#include "GAchievement.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <hpllib/general/HPLString.h>

using namespace std;
using namespace GEnum;

GAchievement::GAchievement(int nType) : HPLShootingObject(nType){
	this->setObjectType( ObjectType::EFFECT);

	// ACR
	this->setSprite( getStaticData()->getSprite( SpriteType::ACHIEVEMENT )->clone() );

	// gqbg͈͂ɂ?(Ӗ͖)
	//this->setHitRect( getStaticData()->getSequence( SpriteType::COMMON,
	//	Sequence::Common::ACHIEVEMENT_FRAME )->getImageInformation(0)->srcRect );

	// TCY
	HPLRect rSrcRect = 
		getStaticData()->
		getSequence(SpriteType::COMMON,Sequence::Common::ACHIEVEMENT_FRAME)->
		getImageInformation(0)->srcRect;
	this->setSize(rSrcRect.getWidth(), rSrcRect.getHeight() );

	// 
	this->setFaceDirection( FaceDirection::LEFT );

	this->m_StayCounter.setWaitFrameNum( ACHIEVEMENT_STAY_FRAME);
}

GAchievement::~GAchievement() {
}

void GAchievement::die( HPLShootingObject* lpDamageSource ) {
	this->setAlive( false );
}

void GAchievement::draw() {

	// center
	HPLVector vCenter = this->getCenter();

//	float fZoom = 1;
//	float fRotateDegree = 0;
	int nAlpha = 255;

	// frame seq
	HPLSequence* lpFrameSeq = getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::ACHIEVEMENT_FRAME );
	HPLRect rFrameSrcRect = lpFrameSeq->getImageInformation(0)->srcRect;

	// frame left
	HPLVector vFrameLeftTop = vCenter;
	vFrameLeftTop.add( - rFrameSrcRect.getWidth() / 2, -rFrameSrcRect.getHeight() / 2  );

	// frame
	getStaticData()->m_Basic.m_Graphics.draw(
		(int)vFrameLeftTop.getX(), (int)vFrameLeftTop.getY(), 
		lpFrameSeq);

	// seq
	HPLSequence* lpSeq = this->getSequence();

	// icon
	getStaticData()->m_Basic.m_Graphics.draw(
		(int)vFrameLeftTop.getX() + ACHIEVEMENT_ICON_DELTA_X,
		(int)vFrameLeftTop.getY() + ACHIEVEMENT_ICON_DELTA_Y,
		lpSeq);

	// 擾
	{
		// master data
		GAchievementData* lpData = 
			&getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementData(this->getType());

		// save data
		GAchievementItem* lpItem =
			getStaticData()->m_AchievementSave.getAchievementItem(this->getType());

		// label
		int x = (int)(vFrameLeftTop.getX() + ACHIEVEMENT_ICON_DELTA_X + 
			ACHIEVEMENT_TEXT_DELTA_X);
		int y = (int)(vFrameLeftTop.getY() + ACHIEVEMENT_LABEL_DELTA_Y);
		DrawString( x, y,
		lpData->m_strLabel.c_str(), GetColor(255,255,0), GetColor(0,0,0) );

		// descriptions
		for( int i = 0; i < (int)lpData->m_vecDescriotions.size(); i ++ ) {
			DrawString(
				x,
				y + ACHIEVEMENT_DESCRIPTION_START_DELTA_Y + i * ACHIEVEMENT_DESCRIPTION_INTERVAL_Y, 
				lpData->m_vecDescriotions[i].c_str(), GetColor(255,255,255),GetColor(0,0,0));
		}

		// comment -> do nothing. IEMOTIONŕ\


		// max num
		if( lpData->m_nMaxNum > 1 ) {
			// ݂̐i
			DrawString(
				x + ACHIEVEMENT_COUNT_DELTA_X,
				y + ACHIEVEMENT_COUNT_DELTA_Y,
				HPLString::chrToStr( "%d/%d", lpItem->getCounter(), lpData->m_nMaxNum).c_str(),
				GetColor(255,255,255) );
		}

		// BȂ}[N\
		if( lpItem->getCounter() >= lpData->m_nMaxNum ) {
			getStaticData()->m_Basic.m_Graphics.draw(
				(int)(vFrameLeftTop.getX() + rFrameSrcRect.getWidth() - 100),
				(int)(vFrameLeftTop.getY() - 10),
				getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::CLEARED ) );
		}
	}
	
	if( getStaticData()->m_Game.isTheWorld() ) {
		lpSeq->step();
	}
}
HPLSequence* GAchievement::getSequence() {
	return this->getSprite()->getSequence( this->getSequenceID(), FaceDirection::LEFT );
}
int GAchievement::getSequenceID() {
	return this->getType();
}

/** S[ƂȂ鍂vZAɐݒ肵܂B
  */
void GAchievement::setGoalCenterY( int nIndexFromBottom ) {
	// t[
	HPLRect rFrameSrcRect = getStaticData()->getSequence(
		SpriteType::COMMON, Sequence::Common::ACHIEVEMENT_FRAME )->getImageInformation(0)->srcRect;

	// ACR
	//HPLRect rIconSrcRect = this->getSequence()->getImageInformation(0)->srcRectl;

	this->m_nGoalCenterY = static_cast<int>(
		getStaticData()->m_Setting.windowHeight -
		( static_cast<float>( nIndexFromBottom ) + 0.5f ) * rFrameSrcRect.getHeight() );
}

