#include "GAchievementSave.h"
#include <hpllib/system/HPLFile.h>
#include <hpllib/system/HPLError.h>
#include <hpllib/general/HPLString.h>
#include <windows.h>

#include "GStaticData.h"

#include <string>

const char* const ACHIEVEMENT_DATA_FILE_PATH = "achievement.evi";
using namespace std;
using namespace GEnum;


GAchievementSave::GAchievementSave() {
	//setAsDefault();

}

GAchievementSave::~GAchievementSave() {
	this->clear();
}

void GAchievementSave::clear() {
	this->m_vecAchievementItems.clear();
	
}


int GAchievementSave::load() {


	return this->load( ACHIEVEMENT_DATA_FILE_PATH );	
}
int GAchievementSave::load(const char* const lpszAchievementSaveFilePath) {
	this->clear();

	if( false == HPLFile::isExists( lpszAchievementSaveFilePath ) ) {
		// ݂Ȃ
		// ۑ
#ifdef _DEBUG
		HPLError::msg( "warning", MB_OK, "уt@C݂Ȃ[%s]", lpszAchievementSaveFilePath);
#endif
		this->save();
		return 1;
	}
	vector<string> vecLines = HPLFile::loadStringLinesFromFile( lpszAchievementSaveFilePath );
	for( int i = 0; i < static_cast<int>( vecLines.size() ); i ++ ) {
		if( HPLFile::isCommentLine( &vecLines[i] ) ) {
			continue;
		}
		// 
		vector<string> vecItems = HPLString::split( vecLines[i], "," );
		for( int j = 0; j < AchievementType::MAX_NUM && j < static_cast<int>( vecItems.size() ); j ++ ) {
			GAchievementData& data = getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementData(j);
			GAchievementItem item ;
			item.m_nMaxNum = data.m_nMaxNum;
			item.m_bIsResetOnStartStage = data.m_bIsResetOnStartStage;
			item.setCounter( atoi(vecItems[j].c_str()));
			this->m_vecAchievementItems.push_back( item );
		}
		break;
	}
	// Ȃꍇ0
	for( int i = (int)this->m_vecAchievementItems.size(); i < AchievementType::MAX_NUM; i ++ ) {
		GAchievementData& data = getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementData(i);
		GAchievementItem item;
		item.m_nMaxNum = data.m_nMaxNum;
		item.m_bIsResetOnStartStage = data.m_bIsResetOnStartStage;
		item.setCounter(0);
		this->m_vecAchievementItems.push_back( item );
	}
	return 0;
}

int GAchievementSave::save() {

	FILE* lpFile = fopen( ACHIEVEMENT_DATA_FILE_PATH, "w" );
	if( lpFile == NULL ) {
		// s
		HPLError::msg( "error", MB_OK, "Open Achievement Save File failure[%s]", ACHIEVEMENT_DATA_FILE_PATH );
		return -1;
	}

	// num Bǂ̓[ĥƂɔ肷
	string str;
	if( 0 < static_cast<int>( this->m_vecAchievementItems.size() ) ) {
		str += HPLString::chrToStr( "%d", this->m_vecAchievementItems[0].getCounter() );
		for( int i = 1; i < static_cast<int>( this->m_vecAchievementItems.size() ); i ++ ) {
			str += HPLString::chrToStr( ",%d", this->m_vecAchievementItems[i].getCounter() );
		}
	}
	fprintf( lpFile, "%s", str.c_str() );
	
	fclose( lpFile );
	return 0;
}

/*int GAchievementSave::setAsDefault() {
	this->clear();
	
	// load default data
	const char* DEFAULT_ACHIEVEMENT_DATA_FILE_PATH = "data/DefaultAchievementData.def";
	
	if( HPLFile::isExists(DEFAULT_ACHIEVEMENT_DATA_FILE_PATH) == false ) {
		// load s
		return -1;
	}
	load( DEFAULT_ACHIEVEMENT_DATA_FILE_PATH );

	return 0;
}*/

