#include "GAchievementScene.h"

#include "GStaticData.h"
#include <hpllib/general/HPLString.h>
#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>

const int ACHIEVEMENT_ITEM_TOP = 100;
const int ACHIEVEMENT_ITEM_INTERVAL_Y = 100;

using namespace GEnum;
GAchievementScene::GAchievementScene() {
	this->m_nY = 0;
	this->m_nMaxY = 100;
	this->m_nVelocityY = 0;
	//this->m_nAccelY = 2;
	//this->
}
GAchievementScene::~GAchievementScene() {
}
void GAchievementScene::init() {
	this->m_nVelocityY = 0;

	// achievement ǂݍ
	getStaticData()->setupEvent();

	this->m_nMaxY = getStaticData()->m_Setting.windowHeight + 
		ACHIEVEMENT_ITEM_TOP + ACHIEVEMENT_ITEM_INTERVAL_Y * getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementDatas().size();

}
void GAchievementScene::quit() {
}
void GAchievementScene::process() {
	// ^Cg
	{
		const int OPTION_TITLE_X = 100;
		const int OPTION_TITLE_Y = 20;
		DrawString( OPTION_TITLE_X, OPTION_TITLE_Y - this->m_nY,
			"Achievements", GetColor(255,255,0) );
	}

	// CxgiCxgGj`FbN
	getStaticData()->isEvent(EventStepType::DEFAULT, true, false);

	// IԂƂȂAchievementIndex
	int nSelectedIndex = 0;

	if( getStaticData()->m_EventImage.isActivated() ){
		// draw image
		HPLSequence* lpSeq = getStaticData()->getSequence( getStaticData()->m_EventImage.spriteID,
			getStaticData()->m_EventImage.seqID );
		getStaticData()->m_Basic.m_Graphics.draw( 
			0,0, lpSeq );
	} else {
		// Achievement\
		int nX = 100;
		int Y_START = 100 - this->m_nY;
		const int Y_INTERVAL = 100;

		bool bIsFirst = true;
		GAchievement achievement(0);

		for( int i = 0; i < AchievementType::MAX_NUM; i ++ ) {
			int nY = Y_START + i * Y_INTERVAL;
			HPLSequence* lpFrameSeq = getStaticData()->getSequence( SpriteType::COMMON, 
				Sequence::Common::ACHIEVEMENT_FRAME);

			HPLRect rFrameSrcRect = lpFrameSeq->getImageInformation(0)->srcRect;
			if( nY <-rFrameSrcRect.getHeight() ||
				nY > getStaticData()->m_Setting.windowHeight + rFrameSrcRect.getHeight() )
			{
				// ʊO
				continue;
			} else if( bIsFirst && nY >= 0 ) {
				nSelectedIndex = i;
				bIsFirst = false;

				// Ig\
				HPLSequence* lpSelectFrameSeq = getStaticData()->getSequence(
					SpriteType::COMMON, Sequence::Common::ACHIEVEMENT_SELECT_FRAME );
				HPLRect rSelectFrameSrcRect = lpSelectFrameSeq->getImageInformation(0)->srcRect;
				int nSelectFrameX = (int)(nX - (rSelectFrameSrcRect.getWidth() - rFrameSrcRect.getWidth() ) / 2);
				int nSelectFrameY = (int)(nY - (rSelectFrameSrcRect.getHeight() - rFrameSrcRect.getHeight() ) / 2);
				getStaticData()->m_Basic.m_Graphics.draw(
					nSelectFrameX, nSelectFrameY, lpSelectFrameSeq );
			}
			// frame
			//getStaticData()->m_Basic.m_Graphics.draw( 
			//	nX, nY, lpFrameSeq );

			GAchievementData* lpData = &getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementData(i);
			//GAchievementItem* lpItem = getStaticData()->m_AchievementSave.getAchievementItem(i);
			// Achievement\
			achievement.setType(i);

			// ʒuC
			HPLRect rArea = achievement.getArea();
			rArea.setX((float)nX);
			rArea.setY((float)nY);
			achievement.setArea( rArea );

			// draw
			achievement.draw();
			//HPLVector vCenter( nX + rFrameSrcRect.getWidth() / 2, nY + rFrameSrcRect.getHeight() ) )
			//HPLSequence* lpIconSeq = getStaticData()->getSequence( 
			//	SpriteType::ACHIEVEMENT, i );
			//getStaticData()->m_Basic.m_Graphics.draw(
			//	nX + 10, nY + 10, lpIconSeq );
		}
	}

	// Cxg̊mFƎsE\
	getStaticData()->checkEvent(false, EventStepType::DEFAULT, true, false);

	if( false == getStaticData()->isFadingOutDX() ) {
		// tF[hAEg͑s
		int nDY = 0;
		
		if( getStaticData()->getInputManager()->isPressed( KeyMap::UP ) ) {
			nDY = -1;
		}
		if( getStaticData()->getInputManager()->isPressed( KeyMap::DOWN ) ) {
			nDY = 1;
		}

		if( nDY != 0 ) {
			this->m_nVelocityY += nDY * ACHIEVEMENT_SCROLL_ACCEL;
			if( abs(this->m_nVelocityY) > ACHIEVEMENT_SCROLL_MAX_SPEED ) {
				this->m_nVelocityY = HPLMath::getSgn<int>( this->m_nVelocityY ) * ACHIEVEMENT_SCROLL_MAX_SPEED;
			}
			this->m_nY += this->m_nVelocityY;
			if( this->m_nY < 0 ){
				this->m_nY = 0;
			} else if( this->m_nY > this->m_nMaxY ) {
				this->m_nY = this->m_nMaxY;
			}
		} else {
			// reduce
			this->m_nVelocityY = (int)
				HPLActionMoveTool::reduceSpeed(
				ACHIEVEMENT_SCROLL_MAX_SPEED / 4.f, (float)this->m_nVelocityY );

		}
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::A ) ) {
			// 

			if( getStaticData()->m_Game.isScenario() == false ) {
				// Rg
				if( nSelectedIndex >= 0 && nSelectedIndex < (int)getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementDatas().size() ) {
					GAchievementData* lpData = &getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementData(nSelectedIndex);
					GAchievementItem* lpItem = getStaticData()->m_AchievementSave.getAchievementItem(nSelectedIndex);

					if( lpItem->getCounter() >= lpData->m_nMaxNum ) {
						int nScenarioIndex = getStaticData()->m_ObjectManager.m_AchievementManager.m_AchievementDataSet.getAchievementData(nSelectedIndex ).m_nCommentScenarioItemID;
						if( nScenarioIndex >= 0 ) {
							// 
							getStaticData()->startEvent( nScenarioIndex, true );
						}
					}
				}
			}
		}
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::B ) ) {
			// L[Ŏ

			// sound
			getStaticData()->m_MixerManager.play( 
				SE::CANCEL,
				false );

			// ^Cg֖߂
			getStaticData()->startFadeOutDX( SceneType::TITLE, -1 );
		}
	}
}
