#include "GArmManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>

using namespace std;
using namespace GEnum;

GArmManager::~GArmManager() {
	for( vector<HPLShootingObject*>::iterator it = this->m_vecArms.begin();
		it != this->m_vecArms.end(); it ++ )
	{
		delete *it;
		*it = NULL;
	}
	this->m_vecArms.clear();
}

bool GArmManager::isEnable() {
	GEnemy* lpEnemy = dynamic_cast<GEnemy*>(this->m_lpParent);
	switch( this->m_lpParent->getType() ) {
	case EnemyType::SLIME_QUEEN:
		if( lpEnemy->getColor() != 2 ) {
			// ΈȊO
			return false;
		}
		if( lpEnemy->getCounter( 
			SlimeQueenCounterType::WAIT_FOR_NEXT )->getState().isFinishAnimation == false)
		{
			// ҂
			// ܂oȂ
			return false;
		}
		if( lpEnemy->isHolding() ) {
			// {̂Œ͂ł鎞
			return false;
		}
	}
	return true;
}
HPLShootingObject* GArmManager::getHead() {
	/*switch( this->m_lpParent->getType() ) {
	}*/

	return this->get( this->getArmNum() - 1 );
}

void GArmManager::algorithm() {
	// 擪ړ
	HPLShootingObject* lpTarget = this->m_lpParent->getTarget();
	
	
	GEnemy* lpArmHead = (GEnemy*)this->getHead();

	// e
	GEnemy* lpParentEnemy = dynamic_cast<GEnemy*>( this->m_lpParent );
	if( false == lpArmHead->isAlive() ) {
		switch( lpParentEnemy->getType() ) {
		case EnemyType::FUUN:
		case EnemyType::RAI:
			// headVłs
			break;
		default:
			// łi{jȂ
			return;
		}
	}

	HPLVector vTargetCenter;

	int nFaceDirection = this->m_lpParent->getFaceDirection();

	float fArmSpeedToTarget = SLIME_QUEEN_ARM_SPEED;

	if( lpParentEnemy->getType() == EnemyType::SLIME_QUEEN &&  lpArmHead->isHolding() ) {
		// ړIn{̂ɌiHׂ邽߁j
		vTargetCenter = this->m_lpParent->getCenter();
	} else {
		switch( lpParentEnemy->getType() ) {	//! e̊炪Č

		case EnemyType::SLIME_QUEEN:	// XCNB[
			switch( lpParentEnemy->getAttackType() ) {
			case 1:
			case 2:
				// {̂̎΂ߑOɌf
				vTargetCenter = this->m_lpParent->getCenter();
				vTargetCenter.add( nFaceDirection * SLIME_QUEEN_GREEN_ARM_UP_X, - SLIME_QUEEN_GREEN_ARM_UP_Y);

				if( lpParentEnemy->getAttackType() == 1 ) {
					// fo
					getStaticData()->m_ShotFactory.shot( lpArmHead, lpParentEnemy->getAttackType(), 0 );
				}
				break;
			default:
				vTargetCenter = lpTarget->getCenter();
				break;
			}
			break;

		case EnemyType::ALRAUNE:	// AEl
			{
				// {̒Sʒu
				vTargetCenter = this->m_lpParent->getCenter();
				// state
				int st = this->getHead()->getState()->getState();
				switch( st ) {
				case StateType::ATTACK:
				case StateType::DAMAGE:
					if( this->getHead()->getSequence()->getState().isFinishAnimation ) {
						// Standɖ߂
						this->getHead()->changeState( StateType::STAND );
					}
					break;
				}
				bool bIsAttack = false;

				switch( this->getHead()->getColor() ) {
				case AlrauneFlowerColorType::RED:	//red flower
					// {̂̎΂ߑOɌf
					vTargetCenter.add(
						nFaceDirection * SLIME_QUEEN_GREEN_ARM_UP_X * 2.f,
						- SLIME_QUEEN_GREEN_ARM_UP_Y);

					// o
					{
						if( lpParentEnemy->getAttackType() == AlrauneAttackType::KAHUN ) {
							bIsAttack = true;
							if( lpArmHead->getCounter(1)->step().isFinishAnimation ) {
								getStaticData()->m_ShotFactory.shot( lpArmHead, lpParentEnemy->getAttackType(), 0 );
								lpArmHead->getCounter(1)->reset();
							}
						}
					}
					break;
				case 1:	//blue flower
					// {̂̐^
					vTargetCenter.add(
						- nFaceDirection * SLIME_QUEEN_GREEN_ARM_UP_X  * 1.f,
						- SLIME_QUEEN_GREEN_ARM_UP_Y * 3.f);

					// o
					{
						if( lpParentEnemy->getAttackType() == AlrauneAttackType::BUG ) {
							bIsAttack = true;

							//getStaticData()->m_ShotFactory.shot( lpArmHead, lpParentEnemy->m_nAttackType, 0 );


							int BUGS[] = {
								EnemyType::BEE,
								EnemyType::ARAKHNE,
							};

							if( lpArmHead->getCounter(1)->step().isFinishAnimation ) {
								HPLVector vCen = lpArmHead->getCenter();
								GEnemy* lpBug = getStaticData()->m_ObjectManager.m_EnemyManager.createWithoutAdd(
									BUGS[ HPLMath::nextInt( 0, SIZEOF( BUGS) ) ],
									vCen, 0 );

								HPLVector v;
								v.setByDegree( HPLMath::nextFloat( 120, 240 ) );
								lpBug->setVelocityAngle( v );

								lpBug->m_vCenterPosition = vCen;

								// ŏCÂ
								lpBug->setRecognized( true );
								getStaticData()->m_ObjectManager.m_EnemyManager.add( lpBug );

								lpArmHead->getCounter(1)->reset();
							}
						}
					}
					break;
				case 2:	//yellow flower
					// {̂̌
					vTargetCenter.add( - nFaceDirection * SLIME_QUEEN_GREEN_ARM_UP_X * 3.f, SLIME_QUEEN_GREEN_ARM_UP_Y / 2);

					// oH
					{
						if( lpParentEnemy->getAttackType() == AlrauneAttackType::LEAF ) {
							bIsAttack = true;

							if( lpArmHead->getCounter(1)->step().isFinishAnimation ) {

								getStaticData()->m_ShotFactory.shot( lpArmHead, lpParentEnemy->getAttackType(), 0 );

								lpArmHead->getCounter(1)->reset();
							}

						}

						HPLVector vPlayerCenter = this->m_lpParent->getTarget()->getCenter();

						// vC[ɉ肱
						if( ( vPlayerCenter.getX() - vTargetCenter.getX()) * this->m_lpParent->getFaceDirection() < 0 ) {
							// vC[̕֌ėtςo
							getStaticData()->m_ShotFactory.shot( lpArmHead, AlrauneAttackType::LEAF_BACK, 0 );
							
						}
						
					}
					break;
				}
				GEnemy* lpHead = (GEnemy*)this->getHead();
				if( bIsAttack && st == StateType::STAND )  {
					lpHead->changeState( StateType::ATTACK );
				}

				// amplitude
				float fDegree = HPLMathConsts::DEGREE_FULL_ROUND *
					lpHead->m_lpAmplitude->getStepCounter() / 
					lpHead->m_lpAmplitude->getWaitFrameNum();
				float fRadian = HPLMath::getRadianFromDegree( fDegree );
				const float FLOWER_AMP_X = 50;
				const float FLOWER_AMP_Y = 100;
				vTargetCenter.add(
					FLOWER_AMP_X * sin( fRadian * 2 ),
					FLOWER_AMP_Y * sin( fRadian / 2 ) );
				//vTargetCenter = lpTarget->getCenter();

				const float FLOWER_ARM_SPEED = 0.5f;
				fArmSpeedToTarget = FLOWER_ARM_SPEED;

				if( lpHead->m_lpAmplitude->step().isFinishAnimation ) {
					lpHead->m_lpAmplitude->reset();
				}
				break;
			}
			break;
		case EnemyType::RAI:		// [C
		case EnemyType::FUUN:		// t[
			{
				int nMapIndex = getStaticData()->getMapIndex();
				switch( nMapIndex ) {
				case SpecialMapIndex::WIND_BOSS_2:
					break;
				default:
					{
						if( lpArmHead->getCounter(0)->step().isFinishAnimation ) {

							
							// 
							for( int i = 0; i < this->getArmNum(); i ++ ) {
								GEnemy* lpArm = (GEnemy*)this->get(i);
								// ëʒuCenterƂĕۑ
								lpArm->m_vCenterPosition = m_lpParent->getCenter();
								getStaticData()->m_ShotFactory.shot( lpArm, 
									0, 0 );
							}
							lpArmHead->getCounter(0)->reset();
						}
					}
					break;
				}
			}

			break;
		}
	}
	// ^[Qbg̕֌
	//HPLVector vDelta = lpArmHead->m_vDelta;


	getStaticData()->collisionObject( lpArmHead );

	HPLVector vHeadCenter = this->getCenter( lpArmHead );
	//lpArmHead->setCenter( vHeadCenter );

	// ^[Qbgւ̌
	int nTargetFace = (lpTarget->getCenter().getX() - vHeadCenter.getX()) > 0 ? FaceDirection::RIGHT : FaceDirection::LEFT;
	lpArmHead->setFaceDirection( nTargetFace );

	//const float ARM_THRESHOLD = 50;
	//ʒu킹
	// [̂ЂƂݒ肵Ă
	// {͒[_mi]jӎ
	// OArm̐[ƎArm̐KԂ悤ɈʒuidȂƃWOUOɂȂԂC[Wj
	// [̎ArḿA[̒SWƁAArm̐[
	// ́AArmWidthƂ

	this->m_fArmLength = this->get(1)->getHitRect().getWidth() + 5;
	switch( this->m_lpParent->getType() ) {
	case EnemyType::ALRAUNE:
		// ԐڐG蓮
		this->moveArmTentacle( vTargetCenter );
		break;

	case EnemyType::SLIME_QUEEN:
	case EnemyType::SLIME:
		// Ȃ񂿂ĐG蓮
		this->moveArm( vTargetCenter );
		break;
	case EnemyType::FUUN:
	case EnemyType::RAI:
		// ~`rbg
		this->moveArmCircle( vTargetCenter );
		break;
	}




}
/** Ԃɍsʏ
	*/
void GArmManager::moveArmCommon( ) {
	// {͌Œ
	GEnemy* lpArm = dynamic_cast<GEnemy*>( this->m_vecArms[0] );
	lpArm->setCenter( this->getCenter( lpArm ) );
	lpArm->setFaceDirection( this->m_lpParent->getFaceDirection() );
}

/** G蕗ɓ
	*/
void GArmManager::moveArmTentacle( HPLVector vTargetCenter ) {
	const float ARM_DEG_SPEED = 1;
	const float ARM_DEG_LIMIT = 60;
	float fCos = cos( HPLMath::getRadianFromDegree( ARM_DEG_LIMIT ) );
	float fSin = sin( HPLMath::getRadianFromDegree( ARM_DEG_LIMIT ) );
	HPLVector vP( this->m_fArmLength, 0 );

	GEnemy* lpArmHead = (GEnemy*)this->getHead();
	HPLVector vHeadCenter = lpArmHead->getCenter();
	HPLVector vTempHeadCenter = vHeadCenter;

	// 擪ȊOɂĊpx
	for( int i = this->getArmNum() - 2; i >= 0; i -- ) {
		GEnemy* lpArm = dynamic_cast<GEnemy*>( this->m_vecArms[i] );

		// g
		HPLVector vCen = this->getCenter( lpArm );

		// Ԑڂ^[Qbgւ̕
		HPLVector vSubToTarget = HPLVector::getVectorAToB( vCen, vTargetCenter );
		// Center^[QbgւXƂAɂĂ
		/*if( this->m_lpParent->getFaceDirection() < 0 ) {
			vSubToTarget.setX( vSubToTarget.getX() * -1 );
		}*/
		// wbhւ̕
		HPLVector vSubToHead = HPLVector::getVectorAToB( vCen, vTempHeadCenter );
		// 
		float fInner = HPLVector::getInner( vSubToHead, vSubToTarget );

		// ExNgvZ
		HPLVector vRight;
		float fRightInner = 0;
		if((int)(lpArm->getRotateDegree() + ARM_DEG_SPEED) %360 <= ARM_DEG_LIMIT ) {
			// ~bg͈͓
			vRight.set(
				fCos * vSubToHead.getX() - fSin * vSubToHead.getY(),
				fSin * vSubToHead.getX() + fCos * vSubToHead.getY() );
			fRightInner = HPLVector::getInner( vRight, vSubToTarget );

		} else {
			// EBȂȂ
			fRightInner = fInner;
		}
		HPLVector vLeft;
		float fLeftInner = 0;
		if(lpArm->getRotateDegree() - ARM_DEG_SPEED >= -ARM_DEG_LIMIT ) {
			// ~bg͈͓
			vLeft.set(
				fCos * vSubToHead.getX() + fSin * vSubToHead.getY(),
				- fSin * vSubToHead.getX() + fCos * vSubToHead.getY() );
			fLeftInner = HPLVector::getInner( vLeft, vSubToTarget );

		} else {
			// EBȂȂ
			fLeftInner = fInner;
		}

		// ]I
		if( fRightInner > fInner && fRightInner > fLeftInner ) {
			lpArm->setRotateDegree( lpArm->getRotateDegree() + ARM_DEG_SPEED );
			vTempHeadCenter = vCen;
			vTempHeadCenter.add( vRight );
		} 
		if( fLeftInner > fInner && fLeftInner > fRightInner ) {
			lpArm->setRotateDegree( lpArm->getRotateDegree() - ARM_DEG_SPEED );
			vTempHeadCenter = vCen;
			vTempHeadCenter.add( vLeft );
		}
	}

	// ʏ
	this->moveArmCommon();

	// Ă
	int nFaceDirection = this->m_lpParent->getFaceDirection();

	// ʒu
	for( int i = 1; i < this->getArmNum(); i ++ ) {
		GEnemy* lpArmPrev = (GEnemy*)this->get(i - 1 );
		GEnemy* lpArm = (GEnemy*)this->get( i );
		float fCos = cos( HPLMath::getRadianFromDegree( lpArmPrev->getRotateDegree() ) );
		float fSin = sin( HPLMath::getRadianFromDegree( lpArmPrev->getRotateDegree() ) );
		
		HPLVector vPlus(
			fCos * vP.getX() - fSin * vP.getY(), 
			fSin * vP.getX() + fCos * vP.getY() );
		HPLVector vNewDelta = lpArmPrev->m_vDelta;
		vNewDelta.setX( vNewDelta.getX() * nFaceDirection );
		vNewDelta.add( vPlus );
		lpArm->m_vDelta.set(
			vNewDelta.getX() * nFaceDirection,
			vNewDelta.getY() );

		vP = vPlus;
		
		lpArm->setCenter( this->getCenter( lpArm ) );
		lpArm->setFaceDirection( this->m_lpParent->getFaceDirection() );

		HPLVector vSubPrevToCur = HPLVector::getVectorAToB( lpArmPrev->m_vDelta, lpArm->m_vDelta );
		vSubPrevToCur.setX( vSubPrevToCur.getX() * this->m_lpParent->getFaceDirection() );
		lpArm->m_fDrawRotate = vSubPrevToCur.getDegree();

	}
}
/** Ȃ񂿂ĐG
	* XCNB[̂
	*/
void GArmManager::moveArm( HPLVector vTargetCenter ) {
	GEnemy* lpArmHead = (GEnemy*)this->getHead();

	// HeadڕWn_ւ̋
	HPLVector vHeadCenter = this->getCenter( lpArmHead );
	HPLVector vSub( vTargetCenter.getX() - vHeadCenter.getX(), vTargetCenter.getY() - vHeadCenter.getY() );
	int nFace = this->m_lpParent->getFaceDirection();
	vSub.setX( vSub.getX() * nFace );

	HPLVector vAim = vSub;
	vAim.normalize();
	vAim.multiple( 0.2f );
		
	if( ((GEnemy*)this->m_lpParent)->getAttackType() == 0 ) {
		// {̒SW̋
		if( lpArmHead->m_vDelta.getLength() > SLIME_QUEEN_ARM_DELTA_MAX_LENGTH ) {
			lpArmHead->m_vDelta.normalize( );
			lpArmHead->m_vDelta.multiple(SLIME_QUEEN_ARM_DELTA_MAX_LENGTH - 1 );
			lpArmHead->setVelocityAngle(0,0);
		}
	}

	//vAim.setX( nFace * vAim.getX() );
	HPLVector vVelocityAngle = lpArmHead->getVelocityAngle();
	vVelocityAngle.add( vAim );
	//vVelocityAngle.setX( fFace * vVelocityAngle.getX() );
	lpArmHead->m_vDelta.add( vVelocityAngle );
	lpArmHead->setVelocityAngle( vVelocityAngle );
	lpArmHead->setCenter( this->getCenter( lpArmHead ) );
	lpArmHead->setFaceDirection( this->m_lpParent->getFaceDirection() );

	for( int i = this->getArmNum() - 2; i >= 1; i -- ) {
		GEnemy* lpArm = dynamic_cast<GEnemy*>( this->m_vecArms[i] );
		GEnemy* lpArmNext = dynamic_cast<GEnemy*>( this->m_vecArms[i + 1] );
		GEnemy* lpArmPrev = dynamic_cast<GEnemy*>( this->m_vecArms[i - 1] );

		// next
		HPLVector vNext;
		HPLVector vPrev = lpArmPrev->m_vDelta;

		HPLVector vLength(
			lpArmNext->getCenter().getX() - lpArm->getCenter().getX(),
			lpArmNext->getCenter().getY() - lpArm->getCenter().getY() );

		const float ARM_THRESHOLD = this->m_fArmLength * 2 / 3;
		if( vLength.getLength() < ARM_THRESHOLD ) {
			// ȏ߂Â
			vNext = lpArmNext->m_vDelta;
		} else {
			if( i == this->getArmNum() - 2 ) {
				// [
				// ŒƉBEAŔ]
				vNext = lpArmNext->m_vDelta;
				vNext.add( lpArmNext->getFaceDirection() * this->m_fArmLength / 2, 0 );
			} else {
				vNext = lpArmNext->m_vDelta;
				HPLVector vAdd;
				vAdd.setByDegree( this->m_lpParent->getFaceDirection() *  lpArmNext->getRotateDegree() );
				vAdd.multiple( this->m_fArmLength / 2 );
				vNext.add( vAdd );
			}
		}

		// ݒ
		HPLVector vSub(
			vNext.getX() - vPrev.getX(),
			vNext.getY() - vPrev.getY() );
		lpArm->setRotateDegree( - vSub.getDegree( ) );

		// ƑO̒ԍWɈړ
		lpArm->m_vDelta.set(
			HPLMath::getInnerPoint( vNext.getX(), vPrev.getX(), 0.5f),
			HPLMath::getInnerPoint( vNext.getY(), vPrev.getY(), 0.5f) );

		lpArm->setCenter( this->getCenter( lpArm ) );
		lpArm->setFaceDirection( this->m_lpParent->getFaceDirection() );
	}

	// ʏ
	this->moveArmCommon();
}


/** {̂̎𓮂rbgƂē
	*/
void GArmManager::moveArmCircle( HPLVector vTargetCenter ) {
	// 1Ƃ̃rbg̊px
	float fDegStep = HPLMathConsts::DEGREE_FULL_ROUND / this->m_vecArms.size();

	const float BIT_CHASE_SPEED = 1.f;

	for( int i = 0; i < (int)this->m_vecArms.size(); i ++ ) {
		// pxݒ
		float fDegree = this->m_fRotateDegree + i * fDegStep;
		HPLVector v;
		v.setByDegree( fDegree );
		v.multiple( this->m_fRadius );

		GEnemy* lpArm = (GEnemy*)this->m_vecArms[i];

		// 擾
		HPLVector vDir = HPLVector::subtract( v, lpArm->m_vDelta );
		vDir.normalize();
		// x
		vDir.multiple( BIT_CHASE_SPEED );
		lpArm->m_vDelta.add( vDir );
		lpArm->setCenter( this->getCenter( lpArm ) );
	}

	if( this->m_fRadius < this->m_fMaxRadius ) {
		// 
		this->m_fRadius += this->m_fRadiusSpeed;
		if( this->m_fRadius > this->m_fMaxRadius ) {
			this->m_fRadius = this->m_fMaxRadius;
		}
	}
	this->m_fRotateDegree += this->m_fRotateSpeed;
	if( this->m_fRotateDegree >= HPLMathConsts::DEGREE_FULL_ROUND ) {
		this->m_fRotateDegree -= HPLMathConsts::DEGREE_FULL_ROUND;
	} 
	if( this->m_fRotateDegree < 0 ) {
		this->m_fRotateDegree += HPLMathConsts::DEGREE_FULL_ROUND;
	}
}

HPLVector GArmManager::getDefaultPosition( ) {
	switch( this->m_lpParent->getType() ) {
	case EnemyType::SLIME_QUEEN:
		{
			// O
			float ERR = 5;
			return HPLVector( 100, 80 + HPLMath::nextFloat(-ERR,ERR));
		}
	case EnemyType::ALRAUNE:
		{
			// 
			return HPLVector( -80, -50);
		}
	case EnemyType::FUUN:
	case EnemyType::RAI:
		return HPLVector(0,0);
	default:
		ASSERT_IT_TYPE( m_lpParent->getType(), "Enemy type");
//		HPLError::assertIt(false);
	}
	return HPLVector();
}
void GArmManager::setup(HPLShootingObject* lpParent) {
	this->m_lpParent = lpParent;

	int n = SLIME_QUEEN_ARM_NUM;
	if( lpParent->getObjectType() == ObjectType::ENEMY ) {
		// change num by enemy type
		switch( lpParent->getType() ) {
		case EnemyType::SLIME_QUEEN:
			break;
		case EnemyType::ALRAUNE:
			n = 8;
			break;
		case EnemyType::RAI:
		case EnemyType::FUUN:
			n = 8;
			this->m_fMaxRadius = 200;
			this->m_fRadiusSpeed = 0.5f;
			this->m_fRotateSpeed = 1.f;
			break;
		}
	}

	
	//HPLVector vCenter = this->getCenter( lpParent );
	HPLVector vCenter = this->m_lpParent->getCenter();
	for( int i = 0; i < n; i ++ ) {
		int nType = EnemyType::ARM;
		switch( lpParent->getType() ) {
		case EnemyType::ALRAUNE:
			nType = EnemyType::KUKI;
			break;
		case EnemyType::FUUN:
			nType = EnemyType::WIND_BIT;
			break;
		case EnemyType::RAI:
			nType = EnemyType::ELEC_BIT;
			break;
		}
		if( i == n - 1 ) {
			// head
			nType = EnemyType::ARM_HEAD;
			switch( lpParent->getType() ) {
			case EnemyType::ALRAUNE:
				nType = EnemyType::FLOWER;
				break;
			case EnemyType::FUUN:
				nType = EnemyType::WIND_BIT;
				break;
			case EnemyType::RAI:
				nType = EnemyType::ELEC_BIT;
				break;
			}
		}
		GEnemy* lpArm = new GEnemy( nType );

		lpArm->m_vDelta = getDefaultPosition();
		//if( i == 0 ) lpArm->setRotateDegree( 270);

		lpArm->setCenter( this->getCenter( lpArm ) );
		lpArm->setTarget( &getStaticData()->m_ObjectManager.m_Player );
		this->m_vecArms.push_back( lpArm );
	}
	// SuperArmor
	((GEnemy*)this->m_vecArms[0])->m_bIsBlowByShot = false;
}
void GArmManager::reset() {
	for( int i = 0; i < this->getArmNum(); i ++ ) {
		GEnemy* lpArm = dynamic_cast<GEnemy*>( this->m_vecArms[i] );
		lpArm->m_vDelta = getDefaultPosition();
		lpArm->setCenter( this->getCenter( lpArm ) );
		lpArm->setVelocityAngle(0,0);
	}
}

/** vC[Ƃ̂蔻
  */ 
HPLShootingObject* GArmManager::checkHitToTarget( ) {
	for( int i = this->getArmNum() - 1; i >= 0; i -- ) {
		GEnemy* lpArm = dynamic_cast<GEnemy*>( this->m_vecArms[i] );
		if( getStaticData()->m_ObjectManager.m_EnemyManager.checkHitToTarget( lpArm, &getStaticData()->m_ObjectManager.m_Player ) ) {
			return lpArm;
		}
	}
	// ǂɂqbgȂ
	return NULL;
}
/** VbgƂ̂蔻
  * 
  */
void GArmManager::checkHitToShot( std::vector<HPLShootingObject*>& vecHitArms ) {
	for( int i = 0; i < this->getArmNum(); i ++ ) {
		GEnemy* lpArm = dynamic_cast<GEnemy*>( this->m_vecArms[i] );
		if( getStaticData()->m_ObjectManager.m_EnemyManager.checkHitToShot( lpArm, this->m_lpParent->getFaceDirection() ) ) {
			vecHitArms.push_back( lpArm );
		}
	}
}

void GArmManager::draw() {
	for( int i = 0 ; i < this->getArmNum(); i ++ ) {
		GEnemy* lpArm = dynamic_cast<GEnemy*>( this->m_vecArms[i] );
		if( lpArm->isAlive() ) {
			lpArm->draw();
		}
	}
}

HPLVector GArmManager::getCenter( HPLShootingObject* lpArm) {
	HPLVector vArmCenter = this->m_lpParent->getCenter();

	HPLVector vDelta = dynamic_cast<GEnemy*>( lpArm ) ->m_vDelta;
	vDelta.setX( vDelta.getX() * HPLMath::getSgn<int>(this->m_lpParent->getFaceDirection()) );

	vArmCenter.add( vDelta );
	return vArmCenter;
}

void GArmManager::createBloodEffect() {
	switch( this->m_lpParent->getType() ) {
	case EnemyType::SLIME_QUEEN:
	case EnemyType::ALRAUNE:
		{
			// ̃GtFNgo
			for( int i = 0; i < this->getArmNum(); i ++ ) {
				GEnemy* lpArm = (GEnemy*)this->m_vecArms[i];
				lpArm->createDeadEffect();
//				getStaticData()->m_ObjectManager.m_EffectManager.createBlood( this->m_vecArms[i]->getCenter() );

			}
		}
		break;
	}
}

void GArmManager::killAllArms(  ) {
	HPLRect mergined = getStaticData()->getMerginedGameRange();

	for( vector<HPLShootingObject*>::iterator it = this->m_vecArms.begin();
		it != this->m_vecArms.end(); it ++
		)
	{
		GEnemy* lpArm = (GEnemy*)*it;
		lpArm->die(NULL );

		HPLRect rHitArea = lpArm->getHitArea();

		if( mergined.isShare( rHitArea ) ) {
			// ʓ
			// ->폜GtFNg
			lpArm->createDeadEffect( );
		}

	}
}
