#include "GContinueScene.h"

#include "GStaticData.h"
#include <hpllib/general/HPLString.h>
#include <hpllib/math/HPLMath.h>

using namespace GEnum;
using namespace std;

GContinueScene::GContinueScene() {
	this->m_StartWaitCounter.setWaitFrameNum( START_WAIT_COUNT );
}
GContinueScene::~GContinueScene() {
}

void GContinueScene::init() {
	m_nColumn = 0;
	this->m_StartWaitCounter.reset();
}
void GContinueScene::quit() {
}
void GContinueScene::process() {

	DrawString( 100,100, "Continue?", GetColor(255,255,255 ) );

	// Yes No
	DrawString( CONTINUE_CURSOR_X, CONTINUE_CURSOR_Y + 12,
		"                  ^Cgɖ߂", GetColor(255,255,255), GetColor(0,0,0) );

	// J[\\
	{
		HPLSequence* lpCursorSeq = getStaticData()->getSequence(
			SpriteType::COMMON, Sequence::Common::CURSOR );

		getStaticData()->m_Basic.m_Graphics.draw(
			(int)(CONTINUE_CURSOR_X + this->m_nColumn * CONTINUE_CURSOR_INTERVAL_X ),
			CONTINUE_CURSOR_Y,
			lpCursorSeq );

		// Aj[V
		lpCursorSeq->step();
	}

	if( this->m_StartWaitCounter.getState().isFinishAnimation == false ) {
		this->m_StartWaitCounter.step();
	} else if( false == getStaticData()->isFadingOutDX() ) {
		// tF[hAEgԂł͂Ȃ

		int nDX = 0;
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::LEFT ) ||
			getStaticData()->getInputManager()->isPressedNow( KeyMap::RIGHT ) )
		{
			nDX = 1;
		}
		if( nDX != 0 ) {
			this->m_nColumn = ( this->m_nColumn + 1 ) % 2;
		}
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::A ) ) {
			// L[Ŏ

			// sound
			getStaticData()->m_MixerManager.play( 
				SE::KETTEI,
				false );

			GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
			lpPlayer->setHP( lpPlayer->getHPMax() );
			lpPlayer->m_nWearState = WearStateType::NORMAL;
			lpPlayer->setAlive( true );
			// c񐔃Zbg
			lpPlayer->setRemainNum( getStaticData()->m_OptionData.getMaxPlayerRemain() );

			switch( this->m_nColumn ) {
			case 0:
				{
					// ̃Xe[W

					getStaticData()->startFadeOutDX( SceneType::GAME, getStaticData()->getMapIndex() );
				}
				break;
			case 1:
				// 
				// ^CgցB
				getStaticData()->startFadeOutDX( SceneType::TITLE, -1 );
				break;
			default:break;
			}

		}
	}
}
