#include "GEnemyManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>

using namespace std;
using namespace GEnum;

/** AElAI
  */
void GEnemyManager::doAlrauneAlgorithm( GEnemy* lpEnemy ) {

	int t = lpEnemy->getType();
	
	HPLShootingObject* lpTarget = lpEnemy->getTarget();
	HPLVector vTargetCenter = lpTarget->getCenter();
	
	HPLVector vSub(
		vTargetCenter.getX() - lpEnemy->getCenter().getX(),
		vTargetCenter.getY() - lpEnemy->getCenter().getY() );


	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	float fLength = vSub.getLength();

	int st = lpEnemy->getState()->getState();
	float RESIST = getStaticData()->m_Setting.resist;
	float GRAVITY = getStaticData()->m_Setting.gravity;

	// Aj[V
	HPLSequence* lpSeq = lpEnemy->getSequence();

	lpEnemy->setBerserkLevel();

	int nNext = -1;
	if( lpEnemy->getCounter( AlrauneCounterType::WAIT_FOR_START )->step().isFinishAnimation ) {
		// ҂

		if( lpEnemy->getCounter(
			AlrauneCounterType::WAIT_FOR_NEXT )->step().isFinishAnimation )
		{
			// U̍Ԃ̑ҋ@
		
			if( st == StateType::ATTACK ) {
				if( lpSeq->getState().isFinishAnimation ) {
					// stand
					lpEnemy->changeState( StateType::STAND );
				}
			}
			switch( lpEnemy->getAttackType() ) {
			case AlrauneAttackType::TENTACLE:	// GU
				{
					bool bIsWaitFinish = lpEnemy->getCounter( AlrauneCounterType::TENTACLE_WAIT_FRAME )->getState().isFinishAnimation;

					if( lpEnemy->getCounter( AlrauneCounterType::TENTACLE_WAIT_FRAME )->step().isFinishAnimation ) {
						// wait I

						if( false == bIsWaitFinish ) {
							// Ƃ
							// ->attackɂȂ
							lpEnemy->changeState( StateType::ATTACK );
						}

						if( lpEnemy->getCounter( AlrauneCounterType::TENTACLE_SHOT_INTERVAL )->step().isFinishAnimation ) {
							// interval I
							// Ă񂽂鐶
							getStaticData()->m_ShotFactory.shot( lpEnemy, lpEnemy->getAttackType(), 0 );

							// interval reset
							lpEnemy->getCounter( AlrauneCounterType::TENTACLE_SHOT_INTERVAL )->reset();

							// JEgi߂
							if( lpEnemy->getCounter( AlrauneCounterType::TENTACLE_COUNT )->step().isFinishAnimation ) {
								// JEgIi1ZbgIj

								// ZbgJEgi߂
								if( lpEnemy->getCounter( AlrauneCounterType::ALL_TENTACLE_COUNT )->step().isFinishAnimation ) {
									// SZbgI

									// ̍Uֈڂ
									nNext = lpEnemy->getAttackType() + 1;

									// ̂߂ɃJE^ZbgĂ
									lpEnemy->getCounter( AlrauneCounterType::ALL_TENTACLE_COUNT )->reset();
								}

								// 1Zbgp̃JE^Zbg
								lpEnemy->getCounter( AlrauneCounterType::TENTACLE_COUNT )->reset();

								// ̃Zbg܂ő҂
								lpEnemy->getCounter( AlrauneCounterType::TENTACLE_WAIT_FRAME )->reset();

							}
						}
					}
				}
				break;
			case AlrauneAttackType::KAHUN:
			case AlrauneAttackType::LEAF:
			case AlrauneAttackType::BUG:
				if( lpEnemy->getCounter(AlrauneCounterType::ATTACK_TERM )->getState().isFinishAnimation ) {
					// attack termI
					nNext = lpEnemy->getAttackType() + 1;
				} else {
					// A^bN
					lpEnemy->getCounter(AlrauneCounterType::ATTACK_TERM )->step();
				}
				break;
			default:
				ASSERT_IT_TYPE( lpEnemy->getAttackType(), "alraune attack type");
//				HPLError::assertIt(false);
			}
		}	// is wait for next
		
	}		// is wait for start

	if( nNext >= 0 ) {
		// ֈȍ~
		if( 0 < lpEnemy->setBerserkLevel() ) {
			// o[T[N[h

			// EGCgZȂ
			HPLCounter* lpCounter = lpEnemy->getCounter( AlrauneCounterType::WAIT_FOR_NEXT );
			lpCounter->setWaitFrameNum( 1);//SLIME_QUEEN_WAIT_FOR_NEXT / 10 );
		}

		lpEnemy->getCounter(AlrauneCounterType::ATTACK_TERM )->reset();
		if( lpEnemy->getAttackType() == AlrauneAttackType::TENTACLE ) {
			lpEnemy->getCounter(AlrauneCounterType::ALL_TENTACLE_COUNT )->reset();
			lpEnemy->getCounter(AlrauneCounterType::TENTACLE_COUNT )->reset();
			lpEnemy->getCounter(AlrauneCounterType::TENTACLE_SHOT_INTERVAL )->end();
			lpEnemy->getCounter(AlrauneCounterType::TENTACLE_WAIT_FRAME )->end();
		}

		// ꏄ
		if( nNext < 0 ) {
			nNext = AlrauneAttackType::MAX_NUM - 1;
		} else if( nNext >= AlrauneAttackType::MAX_NUM - 1 ) {
			nNext = 0;
		}
		lpEnemy->setAttackType( nNext );
	}
}
