#include "GEnemyManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>
#include <hpllib/system/HPLLogger.h>

namespace GEnum {
	namespace PositionType_1 {
		enum PositionType_1_ {
		};
	}
	namespace PositionType {
		enum PositionType_ {
			LEFT,
			CENTER_LEFT,
			CENTER,
			CENTER_RIGHT,
			RIGHT,
			MAX_NUM
		};
	}
}


using namespace std;
using namespace GEnum;

/** Ώۂ̕t߂̈ʒu擾
  * Kʒu̒Ԓn_ڂɂ͈͂ɂāẢEׁA܂͍悤ɂ
  * @param[in]	lpMat		(x,y)=(lpMat->(0,n),lpMat->(1,n))
  * @param[in]	bIsCross	trueFΏۂ܂ʒuړɂ
  * @retval	ړ̃CfbNX
  */
int getIndexNearTarget( HPLVector& vTargetCenter, HPLMatrix<int>* lpMat ,
					   bool bIsCross, HPLVector& vMyCenter, int nAttackType)
{
	int nMapIndex = getStaticData()->getMapIndex();

	if( nMapIndex == SpecialMapIndex::WIND_BOSS_2 ) {
		if( nAttackType == ChaserAttackType::BALL ) {
			// E[
			return lpMat->getRowSize() - 1;
		}
	}
	int nTargetNum = lpMat->getRowSize();

	const int TILE_SIZE = getStaticData()->m_Setting.tileSize;

	// 猩Ăǂɋ邩
	int nTargetSide = vTargetCenter.getX() < vMyCenter.getX() ? 
		FaceDirection::LEFT : FaceDirection::RIGHT;

	// S[̈ʒu
	// 肪ɂȂẢE֍s
	// 肪EɂȂA̍֍s
	int nResultSide = nTargetSide == FaceDirection::LEFT ?
		FaceDirection::RIGHT : FaceDirection::LEFT;

	if( bIsCross ) {	// ܂
		// 肪ɂ΁Aɍɂ
		// 肪EȂAɉEɍs
		nResultSide = nTargetSide;
	}
	int nLeft = 0;
	for( int i = 0; i < nTargetNum; i ++ ) {
		int nMatX = lpMat->get(0,i)* TILE_SIZE;
		//int nIntervalFromLeft = abs(nMatX - nLeft);
		int nX = nMatX;//nLeft + nIntervalFromLeft;
		if( vTargetCenter.getX() < nX ) {
			if( nResultSide == FaceDirection::LEFT ) {	// 葤荶ɍs
				// (i-1)(i)̊Ԃɂ̂ŁA(i-1)̈ʒuɍs
				int nResult = i-1;
				if( nResult < 0 ) {
					nResult = 0;
				}
				return nResult;
			}
		}
	}
	return nTargetNum - 1;
/*	int nTiledWidth = getStaticData()->getBlockManager()->getBlockRange(TILE_SIZE).getWidth();

	int nTileSize = getStaticData()->m_Setting.tileSize;

	int nIntervalWidth = abs(lpMat->get(0,1) - lpMat->get(0,0 ));

	float fIndex = vTargetCenter.getX() / ( lpMat->get(0,0) * nTileSize );

	//int nIndexNearTarget = (int)( HPLMath::getRoundFloat( fIndex, -1 ) );
	int nIndexNearTarget = (int)fIndex;

	int nLeftIndex = lpMap->get(0,0) * TILE_SIZE;


	if( vTargetCenter.getX() < nTiledWidth / 2 ) {	// left from center of game range
		nIndexNearTarget ++;
	} else {	// right from center of game range
		nIndexNearTarget --;
		//nIndexNearTarget
		// do nothing (left)
	}
	if( nIndexNearTarget < 0 ) {
		nIndexNearTarget = 0;
	}
	if( nIndexNearTarget >= PositionType::MAX_NUM ) {
		nIndexNearTarget = PositionType::MAX_NUM - 1;
	}
	return nIndexNearTarget;
	
//	return HPLMath::nextInt(0, nTargetNum );
*/
}

/** ㉺ɗh
  */
void GEnemyManager::amplitudeByVelocity( GEnemy* lpEnemy ) {
	HPLVector v = lpEnemy->getVelocityAngle();

	float fRate = lpEnemy->m_lpAmplitude->getStepCounterRate();
	float fDeg = HPLMathConsts::DEGREE_FULL_ROUND * fRate;
	float fRad = HPLMath::getRadianFromDegree( fDeg );
	const float CHASER_AMPLITUDE_MAX_ACCEL = 2;
	v.add( 0, CHASER_AMPLITUDE_MAX_ACCEL * sin( fRad ));
	
	// ړʂς邾ŁASʒu͎gȂ
	lpEnemy->setVelocityAngle( v );

	if( lpEnemy->m_lpAmplitude->step().isFinishAnimation ) {
		lpEnemy->m_lpAmplitude->reset();
	}
}

/** w肵CfbNXȊÕCfbNXl_Ɏ擾
  * F0`6̂3w肵ꍇA3ȊÔǂꂩ_Ɏ擾
  */
int getRandomAnotherIndex( int nTargetIndex,  int nMaxIndexCount ) {
	vector<int> vecIndexes;
	HPLArrays::getIndexesWithException( nTargetIndex, nMaxIndexCount, vecIndexes );
	return vecIndexes[HPLMath::nextInt(0,vecIndexes.size())];
}

/** G̏ԂɁAAttackType肷
  * @param[in]	nNextAttackType	ʏԂł̎
  */
int getNextAttackType( int nNextAttackType, GEnemy* lpEnemy, int nMapIndex ) {
	// is berserk?
	bool bIsBerserk = lpEnemy->getBerserkLevel() > 0 ;

	// 
	int nNewAttackType = nNextAttackType;

	switch( nMapIndex ) {	// map index check
	case SpecialMapIndex::WIND_BOSS_1:	// before riding
		if( bIsBerserk ) {
			// _ω
			nNewAttackType = getRandomAnotherIndex(nNextAttackType, ChaserAttackType1::MAX_NUM );
		}
		break;
	case SpecialMapIndex::WIND_BOSS_2:	// after
		if( bIsBerserk ) {
			// _ω
			nNewAttackType = getRandomAnotherIndex(nNextAttackType, ChaserAttackType::MAX_NUM );
		}
		break;
	default:
		ASSERT_IT_TYPE(nMapIndex, "nMapIndex");
	}
	return nNewAttackType;
}

void GEnemyManager::doChaser02Move( GEnemy* lpEnemy ) {
	int st = lpEnemy->getState()->getState();
	HPLSequence* lpSeq = lpEnemy->getSequence();

	// chaseeeeeeeeeeeeeeeeeeeeer
	HPLVector vGoal;
	bool bIsChaser = false;
	float fAccel = CHASER_CHASE_ACCEL;//0.2f;
	float fMaxSpeed = CHASER_CHASE_MAX_SPEED;//4;

	HPLVector vTargetCenter = lpEnemy->getTarget()->getCenter();

	// ^[Qbg(vC[)ւ̋E
	HPLVector vSubToTarget = HPLVector::subtract( vTargetCenter, lpEnemy->getCenter() );

	bool bIsFaceToPlayer = true;	// vC[̕iҋ@ȊOftHgj

	// |WV}gNX
	HPLMatrix<int>* lpMat = this->m_mapCoordPositions[EnemyPositionType::CHASER_2];

	// tile size
	int nTileSize = getStaticData()->m_Setting.tileSize;

	// ^[Qbĝ߂POSITION
	int nIndexNearTarget = getIndexNearTarget( vTargetCenter, lpMat,
		true, lpEnemy->getCenter(), lpEnemy->getAttackType());

	// ̍UԐB-1̂܂܂ɂĂΎɂ͈ڂȂ
	int nNextAttackType = -1;

	// ړIʒuɂǂ
	const int THRESHOLD = 100;

	// ㉺ɗh邩H
	bool bIsAmplitude = true;

	// is berserk
	bool bIsBerserk = lpEnemy->getBerserkLevel() > 0;

	int nMapIndex = getStaticData()->getMapIndex();

	// U̍Ԃ̑ҋ@
	switch( lpEnemy->getAttackType() ) {
	case ChaserAttackType::ELEC_SHOT:		//! NWayVbg
		{
			switch( st ) {
			case StateType::ATTACK:	// attack
				{
					if( lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL )->step().isFinishAnimation ) {
						// C^[oEND
						lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL)->reset();

						// shot !
						// 4́AWayWay̔p
						getStaticData()->m_ShotFactory.shot( lpEnemy,
							lpEnemy->getAttackType() ,
							0,
							lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER )->getStepCounter() );

						if( lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER )->step().isFinishAnimation ) {
							// shot counter ended
							// next attack type!
							nNextAttackType = ChaserAttackType::WIND_SHOT;
						}

					} else {
						// ʒu킹
						
						this->getEnemyCoordGoalPos( vGoal, lpMat->get(0,nIndexNearTarget), lpMat->get(1,nIndexNearTarget),
							nTileSize );
						bIsChaser = true;
					}
				}
				break;
			default:
				// change from stand to attack 1
				lpEnemy->changeState( StateType::ATTACK );
				break;
			}
		}
		break;
	case ChaserAttackType::WIND_SHOT:
		{
			switch( st ) {
			case StateType::ATTACK_2:
				
				if( lpSeq->getState().isFinishAnimation ) {
					lpSeq->resetCounter();
				}
				if( lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL)->step().isFinishAnimation ) {
					lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL)->reset();
					// Aj[VI
					// 
					getStaticData()->m_ShotFactory.shot( lpEnemy,
						lpEnemy->getAttackType(),0,
						lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER )->getStepCounter() );
					
					if( lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER )->step().isFinishAnimation ) {
						// I
						// ͓ˌ
						nNextAttackType = ChaserAttackType::ATTACK;
						lpEnemy->changeState( StateType::STAND );
					}
				}
				break;
			default:
				lpEnemy->changeState( StateType::ATTACK_2 );

			}
		}
		break;
	case ChaserAttackType::ATTACK:	// ˌ
		{

			// U^[I
			if( bIsBerserk ) {	// near death
				/*if( lpEnemy->getCounter( ChaserCounterType::ATTACK_TERM)->step().isFinishAnimation ){
					// 
					nNextAttackType = ChaserAttackType::BALL;
				}*/
				const float STOP_THRESHOLD = 3;
				if( lpEnemy->getVelocityAngle().getLength() < STOP_THRESHOLD ) {
					// ~܂
					// 
					nNextAttackType = ChaserAttackType::BALL;
				}
				switch( st ) {
				case StateType::ATTACK_2:
					{
						// ˌȂ̂ŉȂ
						// do nothing
					}
					break;
				default:
					lpEnemy->changeState( StateType::ATTACK_2);
				}
			} else {
				HPLVector vGoalPos = lpEnemy->getTarget()->getCenter();
				// goalƂ̋
				HPLVector vToGoal = HPLVector::subtract( 
					vGoalPos, lpEnemy->getCenter() );

				if( lpEnemy->getCounter( ChaserCounterType::ATTACK_TERM ) ->step().isFinishAnimation ) {
					// stand
					lpEnemy->changeState( StateType::STAND );	// change next
					nNextAttackType =  ChaserAttackType::BALL;
				}
				// goalɓB
				bool bIsNearToGoal = vToGoal.getLength() < THRESHOLD;
				switch( st ) {
				case StateType::ATTACK_2:	// attack2ԁiS[ɌĒǔĂԁj
					{

						vGoal = vGoalPos;//lpEnemy->m_vCenterPosition;
						if( bIsNearToGoal ) {	// reach at goal
//							HPLLogger::HPL_LOGGER.write( "near the goal");
	//						HPLError::msg( "cap",MB_OK,"near the goal");

							// S[ʒSɕύX
//							this->getEnemyCoordGoalPos( vGoal,
//								lpMat->get(0,PositionType::CENTER), lpMat->get(1,PositionType::CENTER),
//								nTileSize );
							bIsChaser = true;
							const float CHASER_ATTACK_ACCEL = 2;
							fAccel = CHASER_ATTACK_ACCEL;
							const float CHASER_ATTACK_MAX_SPEED = 6;
							fMaxSpeed = CHASER_ATTACK_MAX_SPEED;
							// L
//							lpEnemy->m_vCenterPosition = vGoal;
						} else {	// not yet reach the goal
							// chase!
							bIsChaser = true;
						}
					}
					break;
/*				case StateType::STAND:
					{
						if( bIsNearToGoal ) {	// 
							// Sɖ߂
							// ->̍Uֈڂ
							nNextAttackType = ChaserAttackType::BALL;
	//						HPLError::msg( "",MB_OK,"change to ball mode");
						} else {	// BĂȂi
							// ܂BĂȂ
							// ->ATTACK_2[hɂ
//							bIsChaser = true;
//							vGoal = lpEnemy->m_vCenterPosition;

							lpEnemy->changeState( StateType::ATTACK_2);
						}
					}
					break;*/
//				case StateType::ATTACK:
	//				HPLError::msg( "",MB_OK,"change state to attack_2");
//					lpEnemy->changeState( StateType::ATTACK_2);
//					break;
				default:	
					// change state to attack2( chase to goal)
					int nNextState = StateType::ATTACK_2;
	/*				if( bIsNearToGoal ) {	// ɋ߂
						// attacked
						nNextState = StateType::STAND;
					}*/
					lpEnemy->changeState( nNextState );
	//				HPLError::msg( "",MB_OK,"other attack mode:%d", lpEnemy->getAttackType());
				}
			}
		}
		break;
	case ChaserAttackType::BALL:
		{
			// Charge Bolt𓊂B
			// Charge Bolt͒nʂRunner BoltɂȂAvC[֌Đi
			switch( st ) {
			case StateType::ATTACK_2:
				if( lpEnemy->getCounter( ChaserCounterType::ATTACK_TERM )->step().isFinishAnimation ) {	// finish charging
					// ˁI
					getStaticData()->m_ShotFactory.shot( lpEnemy, lpEnemy->getAttackType(), 0 );

					// 
					nNextAttackType = ChaserAttackType::THUNDER_SHOT;
					lpEnemy->changeState( StateType::STAND );
				} else {	// not finished
					
					// `[W͓Ȃ(ƃGtFNgLтĊiDȂ邽߁B)
					bIsChaser = false;
					
					//this->getEnemyCoordGoalPos( vGoal, lpMat->get(0,nIndexNearTarget), lpMat->get(1,nIndexNearTarget),
					//	nTileSize );

					HPLVector vCenter;
					// get hand position (charge)
					this->getChaserHandFrom( vCenter, lpEnemy->getFaceDirection(),
						lpEnemy->getCenter(), lpEnemy->getAttackType() );

					// a = ChargeBolt + alpha
					const int MIN_RADIUS = 30;
					const int RADIUS_PLUS = 50;

					HPLSequence* lpBallSeq = getStaticData()->getSequence(
						SpriteType::SHOT, Sequence::Shot::CHARGE_BOLT );
					// create charge
					getStaticData()->m_ObjectManager.m_EffectManager.createCharge(
						NULL, vCenter, MIN_RADIUS,
						lpBallSeq->getImageInformation()->srcRect.getWidth() / 2 +
						RADIUS_PLUS );
				}
				break;
			default:
				lpEnemy->changeState( StateType::ATTACK_2 );
			}
		}
		break;
	case ChaserAttackType::THUNDER_SHOT:
		{
			// xvC[_ThunderBolt
			// 1񂲂ƂɈʒuςiɏ㏸ĂڕWʒuɕt?j
			switch( st ) {
			case StateType::ATTACK:
				{
					//this->getEnemyCoordGoalPos( vGoal, lpMat->get(0,nIndexNearTarget), lpMat->get(1,nIndexNearTarget),
					//	nTileSize );
					vGoal = vTargetCenter;
					vGoal.add( (vSubToTarget.getX() < 0 ? 1 : -1 ) * CHASER_ATTACK_1_ARM_DELTA_X, -CHASER_THUNDER_SHOT_ABOVE_DISTANCE );
					HPLVector vSub = HPLVector::subtract( vGoal, lpEnemy->getCenter() );
					bIsChaser = true;

					//if( vSub.getLength() <= THRESHOLD ) {	// 
					if( lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL )->step().isFinishAnimation ) {
						lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL )->reset();
						// shot!
						getStaticData()->m_ShotFactory.shot( lpEnemy, lpEnemy->getAttackType(), 0 );
						// interval
						
						if( lpEnemy->getCounter( 
							ChaserCounterType::THUNDER_SHOT_COUNT )->step().isFinishAnimation )
						{
							// owata
							// start next attack mode!
							nNextAttackType = ChaserAttackType::SHABON_SHOT;
						}
					}
//					} else {
						// ړ
						//vGoal.set( lpMat->get(0,nIndexNearTarget), lpMat->get(1,nIndexNearTarget) );
//					}
				}
				break;
			default:
				lpEnemy->changeState( StateType::ATTACK );
				
			
			}
		}
		break;
	case ChaserAttackType::SHABON_SHOT:
		{
			switch( st ) {
			case StateType::ATTACK_2:
				{
					if( lpEnemy->getCounter( ChaserCounterType::ATTACK_TERM )->step().isFinishAnimation ) {
						// UԏI
						// 
						nNextAttackType = ChaserAttackType::ELEC_SHOT;
					} else {
						// UԒ
						// V{VbgI
						const int INTERVAL = 5;
						if( lpEnemy->getCounter( ChaserCounterType::ATTACK_TERM )->getStepCounter() % INTERVAL == 0 ) {
							getStaticData()->m_ShotFactory.shot( lpEnemy, lpEnemy->getAttackType(), 0 );
						}
					}
				}
				break;
			default:
				lpEnemy->changeState( StateType::ATTACK_2 );	// charge'n
			}
		}
		break;

	}
	if( bIsChaser ) {
		this->chase( lpEnemy, vGoal, fAccel, fMaxSpeed );

		amplitudeByVelocity( lpEnemy );
		
	}
	if( lpEnemy->getAttackType() == ChaserAttackType::BALL && 
		st == StateType::ATTACK_2 ) 
	{
		// `[W
		// UȂ
	} else {

		if( bIsFaceToPlayer) {
			this->faceToTarget(lpEnemy );
		} else {
			// is
			HPLActionMoveTool::faceByVelocity( lpEnemy, FACE_CHANGE_THRESHOLD );
		}
	}

	// test
#ifdef _DEBUG
	if( getStaticData()->getInputManager()->isPressedNow( KeyMap::G ) ) {	// QL[
		// IɎ̍UɈڂ点
		nNextAttackType = lpEnemy->getAttackType() + 1;
	}
#endif
	if( nNextAttackType >= 0 ) {	// ̍U֕ύX
		// ȏŕςȂ炩io[TNj
		nNextAttackType = getNextAttackType( nNextAttackType, lpEnemy, nMapIndex );

		// reset counters
		int RESET_COUNTERS[] = {
			ChaserCounterType::ATTACK_TERM,
			ChaserCounterType::SHOT_COUNTER,
			ChaserCounterType::SHOT_INTERVAL,
			ChaserCounterType::WAIT_FOR_NEXT,
			ChaserCounterType::THUNDER_SHOT_COUNT,
		};
		for( int i = 0; i < SIZEOF( RESET_COUNTERS ); i ++ ) {
/*			if( nNextAttackType == ChaserAttackType::ATTACK &&	// next is attack!(ːi)
				i == ChaserCounterType::WAIT_FOR_NEXT )			// no wait between attacks
			{
				continue;
			}*/
			lpEnemy->getCounter( RESET_COUNTERS[i])->reset();
		}

		////////////////////////////////
		// tF[hAEg
		
		// witF[hC/AEg邩ǂ
		int nFadeOutIn = 0;	//1 out, -1 in

		// previous attack type
		int nOld = lpEnemy->getAttackType();
//		bool bIsFadeOutOld = 
//			nOld == ChaserAttackType::BALL ||
//			nOld == ChaserAttackType::THUNDER_SHOT;

		// {[ȂtF[hAEg
		bool bIsFadeOutNext = 
			nNextAttackType == ChaserAttackType::BALL;// ||
			//nNextAttackType == ChaserAttackType::THUNDER_SHOT;

		HPLFadeOut* lpFade = getStaticData()->m_BGManager.getFadeOut();
		// Fade
		switch( nNextAttackType ) {
		case ChaserAttackType::BALL:
		case ChaserAttackType::THUNDER_SHOT:
			if( lpFade->isFading() == false ) {
				// let's fade out
				// darken
				lpFade->setup(
					CHASER_FADE_OUT_FRAME_NUM, 0,0,0,CHASER_FADE_LIGHTEN_ALPHA, CHASER_FADE_DARKEN_ALPHA, DX_BLENDMODE_ALPHA );
				lpFade->start();
			}
			break;
		default:
			if( lpFade->isFading() ) {
				// reverse fade to lighten
				lpFade->setup(
					CHASER_FADE_IN_FRAME_NUM, 0,0,0,CHASER_FADE_DARKEN_ALPHA, CHASER_FADE_LIGHTEN_ALPHA, DX_BLENDMODE_ALPHA );
			}
		}
		
		//////////////////////////////

		// specialization
		switch( nNextAttackType ) {	//Attack
		case ChaserAttackType::ATTACK:
			{
				// ːivC[ɍ킹
				vGoal = vTargetCenter;
				//bIsChaser = false;
				lpEnemy->m_vCenterPosition = vGoal;

				// 񔽑Εɓ
				HPLVector vAim = HPLVector::subtract( vGoal, lpEnemy->getCenter() );
				vAim.normalize();
				const int ATTACK_SPEED = 5;
				vAim.multiple( -1 * ATTACK_SPEED );
				lpEnemy->setVelocityAngle( vAim );

				// stand̏Ԃɂ()
				lpEnemy->changeState( StateType::STAND );
				HPLError::msg( "cap",MB_OK,"change to attack mode");

			}
			break;
		}

		lpEnemy->setAttackType( nNextAttackType );


	}
}
/** Chaser̃ASY
  */
void GEnemyManager::doChaserAlgorithm( GEnemy* lpEnemy ) {
	int t = lpEnemy->getType();
	
	HPLShootingObject* lpTarget = lpEnemy->getTarget();
	HPLVector vTargetCenter = lpTarget->getCenter();
	
	HPLVector vSub(
		vTargetCenter.getX() - lpEnemy->getCenter().getX(),
		vTargetCenter.getY() - lpEnemy->getCenter().getY() );

	HPLVector vGoal;
	bool bIsChaser = false;
	float fAccel = 0.2f;
	float fMaxSpeed = 4;

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	float fLength = vSub.getLength();

	int st = lpEnemy->getState()->getState();
	float RESIST = getStaticData()->m_Setting.resist;
	float GRAVITY = getStaticData()->m_Setting.gravity;

	int nMapIndex = getStaticData()->getMapIndex();

	HPLSequence* lpSeq = lpEnemy->getSequence();

	// tile size
	int nTileSize = getStaticData()->m_Setting.tileSize;

	int nPositionType = EnemyPositionType::CHASER_2;
	switch( nMapIndex ) {
	case SpecialMapIndex::WIND_BOSS_1:
		nPositionType = EnemyPositionType::CHASER_1;
		break;
	}
	// |WV}gNX
	HPLMatrix<int>* lpMat = this->m_mapCoordPositions[nPositionType];

	// ^[Qbĝ߂POSITION
	int nIndexNearTarget = getIndexNearTarget( vTargetCenter, lpMat,
		true, lpEnemy->getCenter(), lpEnemy->getAttackType());

	// U͍sȂ
	if( StateType::READY == st ) {
		if( lpSeq->getState().isFinishAnimation ) {	// I
			// ->̏Ԃɖ߂

			int nNextState = StateType::STAND;	// ̏ԁiftHgStandj
			if( lpEnemy->getPreviousState() >= 0 ) {	// ȑȌԂL^Ă
				// ->ɖ߂
				nNextState = lpEnemy->getPreviousState();
			}
			lpEnemy->changeState( nNextState );
		}
	}

	// Aj[V
//	HPLSequence* lpSeq = lpEnemy->getSequence();

	int nNext = -1;
	bool bIsPrevBerserk = lpEnemy->getBerserkLevel() > 0;
	bool bIsBerserk = lpEnemy->setBerserkLevel() > 0;
	if( bIsPrevBerserk == false && bIsBerserk ) {	// Ȃ
		// wait for next𔼕ɂ
//		HPLCounter* lpCounter = lpEnemy->getCounter( ChaserCounterType::WAIT_FOR_NEXT );
//		lpCounter->setWaitFrameNum( 
//			lpCounter->getWaitFrameNum() / 2 );
	}

	if( lpEnemy->getCounter( AlrauneCounterType::WAIT_FOR_START )->step().isFinishAnimation ) {
		// end of start

		HPLCounter* lpNext = lpEnemy->getCounter( AlrauneCounterType::WAIT_FOR_NEXT );

		if( lpNext->step().isFinishAnimation ) {
			// end of next

			switch( nMapIndex ) {
			case SpecialMapIndex::WIND_BOSS_1:
				{
					this->doChaser01Move( lpEnemy );
				}
				break;
			case SpecialMapIndex::WIND_BOSS_2:
				{
					this->doChaser02Move( lpEnemy );
				}
				break;
			}
		} else {	// waiting for next attack!

			// is chasing now?
			bool bIsChasing = true;

			switch( nMapIndex ) {
			case SpecialMapIndex::WIND_BOSS_1:
				{
					// always chasing
				}
				break;
			case SpecialMapIndex::WIND_BOSS_2:
				{
					switch( lpEnemy->getAttackType() ) {
					case ChaserAttackType::ATTACK:
						{	// not chasing
							bIsChasing = false;

							if( lpNext->getStepCounter() >=
								lpNext->getWaitFrameNum() - 1 )
							{
								// Ō̃t[
								// ːi
								if( bIsBerserk ) {	// berserk!
									float fReduceAccel = 0;
									const int FRAMES_FOR_GOAL = 100;
									HPLVector vVel;
									this->setVelocityByGoal(lpEnemy->getCenter(),
										vVel, vTargetCenter, FRAMES_FOR_GOAL, fReduceAccel );
									lpEnemy->setVelocityAngle( vVel );
									lpEnemy->setReduceAccel( fReduceAccel );
								}
							}
						}
						break;
					}
				}
				break;
			}

			if( bIsChasing ) {
				/////
				// vC[̋߂Ɉړ
				// goal of movement
				HPLVector vGoal;
				// get player near position
				this->getEnemyCoordGoalPos( vGoal, lpMat->get(0,nIndexNearTarget), lpMat->get(1,nIndexNearTarget),
					nTileSize );
				// chase
				this->chase( lpEnemy, vGoal, fAccel, fMaxSpeed );
			}

			if( lpSeq->getState().isFinishAnimation ) {	// end of animation sequence
				// reset
				lpSeq->resetCounter();
			}
		}
	}

	// set global goal position?
	bool bIsSetGlobal = false;	// default:no setting global goal position
	HPLVector vGlobal;
	switch( st ) {
	case StateType::ATTACK_2:	// attack_2
		{
			// charge hand position
			bIsSetGlobal = true;
			// charge hand position
			this->getChaserHandFrom(
				vGlobal, lpEnemy->getFaceDirection(), lpEnemy->getCenter(),
				lpEnemy->getAttackType() );
		}
		break;
	case StateType::BORN:
		{
			bIsSetGlobal = true;
			// enemy center
			vGlobal = lpEnemy->getCenter();
		}
		break;
	}
	if( bIsSetGlobal ) {
		getStaticData()->m_ObjectManager.m_EffectManager.setGlobalMoveTargetCenter( vGlobal );
	}
}

void GEnemyManager::doChaser01Move( GEnemy* lpEnemy ) {
	int st = lpEnemy->getState()->getState();
	HPLSequence* lpSeq = lpEnemy->getSequence();

	// chaseeeeeeeeeeeeeeeeeeeeer
	HPLVector vGoal;
	bool bIsChaser = false;
	float fAccel = 0.2f;
	float fMaxSpeed = 4;

	HPLVector vTargetCenter = lpEnemy->getTarget()->getCenter();

	// ^[Qbg(vC[)ւ̋E
	HPLVector vSubToTarget = HPLVector::subtract( vTargetCenter, lpEnemy->getCenter() );

	bool bIsFaceToPlayer = true;

	// |WV}gNX
	HPLMatrix<int>* lpMat = this->m_mapCoordPositions[EnemyPositionType::CHASER_1];

	// tile size
	int nTileSize = getStaticData()->m_Setting.tileSize;

	// map indx
	int nMapIndex = getStaticData()->getMapIndex();

	// next attack type
	int nNextAttackType = -1;
	
	switch( lpEnemy->getAttackType() ) {
	case ChaserAttackType1::BORN:
		switch( st ) {
		case StateType::BORN:	// UMARERU!
			{
				if( lpEnemy->getCounter( ChaserCounterType::BORN_TERM )->step().isFinishAnimation ) {	// end born
					// exit born
					lpEnemy->changeState(StateType::STAND );
					nNextAttackType = ChaserAttackType1::ELECT_SHOT_1;
				} else {	// borning
					// center
					HPLVector vCenter = lpEnemy->getCenter();
					// radius
					int nRadius = HPLMath::nextInt( 50, lpSeq->getImageInformation()->srcRect.getWidth() / 2 * 1.5f );
					// degree
					int nDeg = HPLMath::nextInt(0,HPLMathConsts::DEGREE_FULL_ROUND );
					HPLVector vRadius;
					vRadius.setByDegree( nDeg );
					vRadius.multiple( nRadius );
					// add to center
					vCenter.add( vRadius );
					// create born-cloud
					GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
						Sequence::Effect::CLOUD, vCenter, true );
					// SWɌĒpiEjɏx
					HPLVector v;
					v.setByDegree( nDeg + 90 );
					const int CLOUD_SPEED = 8;
					v.multiple( CLOUD_SPEED );
					lpEffect->setVelocityAngle( v );

					// set goal position
					lpEffect->setCenterPosition( lpEnemy->getCenter() );

					// create another cloud after death
					lpEffect->setCreateEffectTypeAfterDead( Sequence::Effect::CLOUD );
				}
			}
			break;
		default:
			lpEnemy->changeState( StateType::BORN );
		//default:
	/*		switch( lpEnemy->getAttackType() ) {
			case ChaserAttackType1::??:
				{
					switch( st ) {
					case StateType::??:
						break;
					default:
						lpEnemy->changeState( StateType::?? );
					}
				}
				break;
			}*/
		
		}
		break;
	case ChaserAttackType1::ELECT_SHOT_1:
		{
			bIsChaser = true;
			switch( st ) {
			case StateType::ATTACK:
				{
					bool bIsShot = false;
					bool bIsEnd = false;
					this->commonIntervalShot( lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL ),
						2, lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER ), 
						bIsShot, bIsEnd );
					if( bIsShot ) {
						getStaticData()->m_ShotFactory.shot( lpEnemy,
							lpEnemy->getAttackType(), 0 );
					}
					if( bIsEnd ) {
						nNextAttackType = ChaserAttackType1::WIND_SHOT_1;
					}
				}
				break;
			default:
				lpEnemy->changeState( StateType::ATTACK );
			}
		}
		break;
	case ChaserAttackType1::WIND_SHOT_1:
		{
			switch( st ) {
			case StateType::ATTACK:
				{
					bool bIsShot = false;
					bool bIsEnd = false;
					this->commonIntervalShot( lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL ),
						1, lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER ), 
						bIsShot, bIsEnd );
					if( bIsShot ) {
						getStaticData()->m_ShotFactory.shot( lpEnemy,
							lpEnemy->getAttackType(), 0 );
					}
					if( bIsEnd ) {
						nNextAttackType = ChaserAttackType1::THUNDER_BALL_HOMING;
					}
				}
				break;
			default:
				lpEnemy->changeState( StateType::ATTACK );
			}
			break;
		}
		break;
	case ChaserAttackType1::THUNDER_BALL_HOMING:
		switch( st ) {
		case StateType::ATTACK_2:
			{
				bool bIsShot = false;
				bool bIsEnd = false;
				this->commonIntervalShot( lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL ),
					1, lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER ), 
					bIsShot, bIsEnd );
				if( bIsShot ) {
					getStaticData()->m_ShotFactory.shot( lpEnemy,
						lpEnemy->getAttackType(), 0 );
				}
				if( bIsEnd ) {
					nNextAttackType = ChaserAttackType1::THUNDER_BALL_LINE;
				}
			}
			break;
		default:
			lpEnemy->changeState( StateType::ATTACK_2 );
		}
		break;
	case ChaserAttackType1::THUNDER_BALL_LINE:
		switch( st ) {
		case StateType::ATTACK_2:
			{
				bool bIsShot = false;
				bool bIsEnd = false;
				this->commonIntervalShot( lpEnemy->getCounter( ChaserCounterType::SHOT_INTERVAL ),
					1, lpEnemy->getCounter( ChaserCounterType::SHOT_COUNTER ), 
					bIsShot, bIsEnd );
				if( bIsShot ) {
					getStaticData()->m_ShotFactory.shot( lpEnemy,
						lpEnemy->getAttackType(), 0 );
				}
				if( bIsEnd ) {
					nNextAttackType = ChaserAttackType1::ELECT_SHOT_1;
				}
			}
			break;
		default:
			lpEnemy->changeState( StateType::ATTACK_2 );
		}
		break;
	}
	if( bIsChaser ) {
		// get player near position
		int nIndexNearTarget = getIndexNearTarget( vTargetCenter, lpMat,
			true, lpEnemy->getCenter(), lpEnemy->getAttackType());
		this->getEnemyCoordGoalPos( vGoal, lpMat->get(0,nIndexNearTarget), lpMat->get(1,nIndexNearTarget),
			nTileSize );
		this->chase( lpEnemy, vGoal, fAccel, fMaxSpeed );

		amplitudeByVelocity( lpEnemy );
	}
	
	if( bIsFaceToPlayer) {
		this->faceToTarget(lpEnemy );
	} else {
		// is
		HPLActionMoveTool::faceByVelocity( lpEnemy, FACE_CHANGE_THRESHOLD );
	}

	if( nNextAttackType >= 0 ) {
		nNextAttackType = getNextAttackType( nNextAttackType, lpEnemy, nMapIndex );
		// reset counters
		int RESET_COUNTERS[] = {
			ChaserCounterType::ATTACK_TERM,
			ChaserCounterType::SHOT_COUNTER,
			ChaserCounterType::SHOT_INTERVAL,
			ChaserCounterType::WAIT_FOR_NEXT,
			ChaserCounterType::THUNDER_SHOT_COUNT,
		};
		for(int i = 0; i < SIZEOF( RESET_COUNTERS); i ++ ) {
			lpEnemy->getCounter( RESET_COUNTERS[i] )->reset();
		}
		// change next attack type
		lpEnemy->setAttackType( nNextAttackType );
	}
}
