#include "GEnemyManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>

using namespace std;
using namespace GEnum;

static const float AIKO_CHASE_ACCEL = 0.2f;
static const float AIKO_CHASE_MAX_SPEED = 4;

void GEnemyManager::doEllinAlgorithm( GEnemy* lpEnemy ) {
	int t = lpEnemy->getType();
	HPLShootingObject* lpTarget = lpEnemy->getTarget();
	HPLVector vTargetCenter = lpTarget->getCenter();
	
	HPLVector vSub(
		vTargetCenter.getX() - lpEnemy->getCenter().getX(),
		vTargetCenter.getY() - lpEnemy->getCenter().getY() );


	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	float fLength = vSub.getLength();

	int st = lpEnemy->getState()->getState();
	float RESIST = getStaticData()->m_Setting.resist;
	float GRAVITY = getStaticData()->m_Setting.gravity;

	// chasing
	HPLVector vGoal;
	bool bIsChaser = false;
	float fAccel = AIKO_CHASE_ACCEL;//0.2f;
	float fMaxSpeed = AIKO_CHASE_MAX_SPEED;//4;

	GEnemyAIResult result;

	// Aj[V
	HPLSequence* lpSeq = lpEnemy->getSequence();
	int nNext = -1;
	HPLAttackInformation* lpInfo = lpEnemy->m_lpAttackInformation;

	if( lpInfo->m_WaitForStartCounter.step().isFinishAnimation ) {
		// ҂
		if( lpInfo->m_WaitForNextCounter.step().isFinishAnimation )
		{
			// U̍Ԃ̑ҋ@

			HPLAttackItem* lpItem = lpEnemy->m_lpAttackInformation->getAttackItem( lpEnemy->getAttackType());
			bool bIsShot = false;
			int nAttackType = lpEnemy->getAttackType();
			// ԕω
			switch( nAttackType ) {
			case EllinAttackType::SLASH:
			case EllinAttackType::CHARGE_SLASH:
			case EllinAttackType::HUGE_SURIKEN:
			case EllinAttackType::ROTATION_SWORD:
			case EllinAttackType::SURIKEN:
			case EllinAttackType::SWORD:
				break;
			default:
				ASSERT_IT_TYPE( nAttackType );
			}		
		}
	}
}
