#include "GEnemyManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>

using namespace std;
using namespace GEnum;
// _ړ̈ړ}bv

namespace PointType {
	enum {
		CENTER_TOP,
		LEFT_TOP,
		RIGHT_TOP,
		CENTER_CENTER,
	};
}
namespace RandomType {
	enum {
		NO_MOVE,	//! ړȂ
		ALL,		//! S|Cg_ɑI
		ALL_TOP,		//! gbv݂̂IiEj
	};
}


/** w肵S[ɁAw肵t[œB悤ɑxݒ肷
  * ̊֐ł͒Iȓ̂ŁAȐIɓ΁A聨Chasesŗǂ͂
  * @param[in]	vCenterFrom		on_
  * @param[out]	vVelocityAngle	oꂽx
  * @param[in]	vGoalCenter		ڕWn_
  * @param[in]	nFrameCount		Kvt[
  * @param[out]	fResist			CRɂ錸xivZċ߂j
  */
void GEnemyManager::setVelocityByGoal( HPLVector& vCenterFrom, HPLVector& vVelocityAngle, HPLVector vGoalCenter,
									  int nFrameCount, float& fResist)
 {
	// ړ
	HPLVector vDistance = HPLVector::subtract(
		vGoalCenter, vCenterFrom );
	float fDistance = vDistance.getLength();

	// x(x)
	float fAccel = - 2 * fDistance / (nFrameCount * nFrameCount);
	fResist = -fAccel;

	// 
	float fFirstSpeed = 2 * fDistance / nFrameCount;
	
//	float fSpeed = (float)vVelocityAngle.getLength() / nFrameCount +
//		 fResist * nFrameCount / 2.f;
	vVelocityAngle = vDistance;
	vVelocityAngle.normalize();
	vVelocityAngle.multiple( fFirstSpeed );

}

/** 
  * @param[in]	nCoordX,nCoordY	ڕWW
  */
void GEnemyManager::getEnemyCoordGoalPos( HPLVector& vGoalPos, int nCoordX, int nCoordY,
							   int nTileSize )
{
	vGoalPos.set(	nCoordX * nTileSize + nTileSize / 2, nCoordY * nTileSize + nTileSize / 2 );
}

/** G̎̍sݒ肷
  * @param[in]	nIndex	ꏊCfbNX
  * @param[in,out]	lpEnemy	̈ʒuƈړxݒ肷邽߂ɓn
  * 
  */
void GEnemyManager::setEnemyGoalAndVelocity( int nIndex, HPLMatrix<int>* lpMat, GEnemy* lpEnemy ) {

	int nTileSize = getStaticData()->m_Setting.tileSize;
	// set goal
	getEnemyCoordGoalPos(
		lpEnemy->m_vCenterPosition,
		lpMat->get(0,nIndex), lpMat->get(1,nIndex),
//		RANDOM_MOVE_CELL_LOC[nIndex][0], RANDOM_MOVE_CELL_LOC[nIndex][1],
		nTileSize );

	// set velocity
	const int FRAME_NUM = 100;
	float ENEMY_AIR_RESIST = this->getEnemyAirResist(1);//;
	HPLVector vVel;
	setVelocityByGoal( lpEnemy->getCenter(), vVel, lpEnemy->m_vCenterPosition, FRAME_NUM,
		ENEMY_AIR_RESIST);
	lpEnemy->setVelocityAngle( vVel );
	lpEnemy->setReduceAccel( ENEMY_AIR_RESIST );
}

void GEnemyManager::doMerakoMeet( GEnemy* lpEnemy, GEnemyAIResult& result ) {
}
void GEnemyManager::doMerakoBattle( GEnemy* lpEnemy, GEnemyAIResult& result ) {
	int t = lpEnemy->getType();
	
	HPLShootingObject* lpTarget = lpEnemy->getTarget();
	HPLVector vTargetCenter = lpTarget->getCenter();
	
	HPLVector vSub(
		vTargetCenter.getX() - lpEnemy->getCenter().getX(),
		vTargetCenter.getY() - lpEnemy->getCenter().getY() );


	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	float fLength = vSub.getLength();

	int st = lpEnemy->getState()->getState();
	float RESIST = getStaticData()->m_Setting.resist;
	float GRAVITY = getStaticData()->m_Setting.gravity;

	// tile size
	const int nTileSize = getStaticData()->m_Setting.tileSize;

	// ^Cij
	int nCoordWidth = getStaticData()->m_BlockManager.getBlockMatrix()->getColumnSize();
	int nCoordHeight = getStaticData()->m_BlockManager.getBlockMatrix()->getRowSize();
	
	// vC[
//	bool bIsFaceToPlayer = false;

	// ړ̃Xe[gBꍇɂĂ͐ɓ͖̂B
	int nWalkingState = StateType::WALK;

	// Aj[V
	HPLSequence* lpSeq = lpEnemy->getSequence();
	int nNext = -1;
	bool bIsChangeBySpeed = true;
	//bool bIsChase = false;
	//HPLVector vGoalPosition;
	result.m_fChaseAccel = 0.1f;
	result.m_fChaseMaxSpeed = 3;

	// matrix
	HPLMatrix<int>* lpMat = this->m_mapCoordPositions[EnemyPositionType::SUNNY];

	bool m_bIsChangeBySpeed;

	if( lpEnemy->getCounter( Merako01CounterType::WAIT_FOR_START )->step().isFinishAnimation ) {
		// ҂

		bool bIsFinishNow = lpEnemy->getCounter(
			Merako01CounterType::WAIT_FOR_NEXT )->getState().isFinishAnimation == false;
		if( lpEnemy->getCounter(
			Merako01CounterType::WAIT_FOR_NEXT )->step().isFinishAnimation )
		{
			// U̍Ԃ̑ҋ@
			// ~̓I
			int nWidth = nCoordWidth * nTileSize;
			int nHeight = nCoordHeight * nTileSize;
			HPLVector vScreenCenter(
				nWidth / 2, nHeight / 2 );
			const int MERGINE = 100;
			int nRadius = min( nWidth, nHeight )/ 2 - MERGINE;

			// goalւ̋
			const int NEAR_THRESHOLD = 100;

			// attack termɂĐ؂グmF
			bool bIsCheckAttackTerm = false;
			int nRandomType = RandomType::NO_MOVE;
			const float SLOW_THRESHOLD = 3;
			switch( lpEnemy->getAttackType() ) {
			case Merako01AttackType::MOVE_SHOT:	// ړȂ6Vbg
			{
				if( lpEnemy->getCounter( Merako01CounterType::MOVE_INTERVAL )->step().isFinishAnimation ) {
					// ړJEg

					if( lpEnemy->getCounter( Merako01CounterType::MOVE_COUNT )->step().isFinishAnimation ) {
						// 
						nNext = lpEnemy->getAttackType() + 1;
					}
					lpEnemy->getCounter( Merako01CounterType::MOVE_INTERVAL )->reset();
					// s挈
					nRandomType = RandomType::ALL;

					const int LAVA_BALL_NUM = 6 * fLevel;
					const int START_DEG = -90;
					const int INTERVAL_DEG = 360 / LAVA_BALL_NUM;
					const int LAVA_SPEED = 10;
					// Vbg
					for( int i = 0; i < LAVA_BALL_NUM; i ++ ) {
						float fDeg = START_DEG + i * INTERVAL_DEG;
						HPLVector vVel;
						vVel.setByDegree( fDeg );
						vVel.multiple( LAVA_SPEED );
						GEnemy* lpAdd = this->create( EnemyType::LAVA_BALL, lpEnemy->getCenter(),
							-1 );
						lpAdd->setVelocityAngle( vVel );
						/*
						GShot* lpShot = getStaticData()->m_ObjectManager.m_ShotManager.create(
							Sequence::Shot::LAVA_BALL, lpEnemy->getCenter(),
							lpEnemy->getID(), lpEnemy->getFaceDirection(), false,
							true );
						lpShot->setVelocityAngle( vVel );
						*/
					}
				} else {
					// ړI
				}
			}
			break;
			case Merako01AttackType::LAVA_UP:
			{
				if( lpEnemy->getCounter( Merako01CounterType::LAVA_INTERVAL )->step().isFinishAnimation ) {
					// LAVAJEg

					if( lpEnemy->getCounter( Merako01CounterType::LAVA_COUNT )->step().isFinishAnimation ) {
						// 
						nNext = lpEnemy->getAttackType() + 1;
					}
					lpEnemy->getCounter( Merako01CounterType::LAVA_INTERVAL)->reset();

					// ӂړ
					nRandomType = RandomType::ALL_TOP;

					// n𔭐
					const int MERGINE = 100;
					HPLVector vCenter(
						HPLMath::nextInt( 1 * nTileSize, (nCoordWidth - 1 ) * nTileSize ),
						nCoordHeight * nTileSize - MERGINE );

					GEnemy* lpAdd = this->createWithoutAdd( EnemyType::LAVA_BALL, vCenter,
						-1 );
					this->m_vecAdds.push_back( lpAdd );
					//GShot* lpShot = getStaticData()->m_ObjectManager.m_ShotManager.create(
					//	Sequence::Shot::LAVA_BALL, vCenter, lpEnemy->getID(), lpEnemy->getFaceDirection(),
					//	false, true );

					lpAdd->setVelocityAngle( 0, -LAVA_BALL_SPEED_Y);
				}
			}
			break;
			case Merako01AttackType::CIRCLE:
			{
				switch( st ) {
				case StateType::WALK:
				{
					float fDeg = lpEnemy->getRotateDegree() + lpEnemy->getRotateDegreeSpeed();
					lpEnemy->setRotateDegree( fDeg ) ;


					lpEnemy->m_vCenterPosition.setByDegree( fDeg );
					lpEnemy->m_vCenterPosition.multiple( nRadius );
					lpEnemy->m_vCenterPosition.add( nWidth / 2, nHeight / 2 );

					// vCenterPositionG̃S[ɂȂ
					HPLVector vSub = HPLVector::subtract( lpEnemy->m_vCenterPosition, lpEnemy->getCenter() );
					vSub.normalize();
					const float MERAKO_CIRCLE_SPEED = 3;
					vSub.multiple( MERAKO_CIRCLE_SPEED );
					lpEnemy->setVelocityAngle( vSub );

					// Yːi
					const int Y_THRESHOLD = 50;
					if( abs(lpEnemy->getTarget()->getCenter().getY() - lpEnemy->getCenter().getY() ) < Y_THRESHOLD ) {
						bIsChangeBySpeed = false;
						// DASH!
						lpEnemy->changeState( StateType::DASH );
					}
					
				}
				break;
				case StateType::DASH:
				{
					bIsChangeBySpeed = false;
					// ̂܂܈ړ
					HPLVector vVel = lpEnemy->getVelocityAngle();
					vVel.normalize();
					const float MERAKO_DASH_SPEED = 8;
					vVel.multiple( MERAKO_DASH_SPEED );
					lpEnemy->setVelocityAngle( vVel );

					if( HPLVector::subtract( vScreenCenter, lpEnemy->getCenter() ).getLength() > nRadius ) {
						// ȏ㗣ꂽ
						// ړɕς
						lpEnemy->changeState( StateType::WALK );
					}
				}
				break;
				default:
					lpEnemy->changeState( StateType::WALK );
				break;
				}

				if( lpEnemy->getCounter( Merako01CounterType::ATTACK_TERM )->step().isFinishAnimation ) {
					// ATTACK_TERMŐ؂グ
					nNext = lpEnemy->getAttackType(); // + 1
				}

			}
			break;
			case Merako01AttackType::EXPLOSION:
			{
				// ^񒆂ֈړ
				HPLVector vSub = HPLVector::subtract(
					vScreenCenter, lpEnemy->getCenter() );
				if( vSub.getLength() > NEAR_THRESHOLD ) {
					// ֈړ
					if( StateType::WALK != st ) {
						// ړ
						lpEnemy->changeState( StateType::WALK );
					} else {
						vSub.normalize( );
						const int TO_CENTER_SPEED = 3;
						vSub.multiple( TO_CENTER_SPEED );
						lpEnemy->setVelocityAngle( vSub );
					}
				} else {
					// łɒ
					if( StateType::ATTACK_2 != st ) {
						lpEnemy->changeState( StateType::ATTACK_2 );
					} else {
						// Aj[V
						if( lpSeq->getFrameIndex() == 1 ) {
							float fDeg = lpEnemy->getRotateDegree() + lpEnemy->getRotateDegreeSpeed();
							lpEnemy->setRotateDegree( fDeg );
							const float SHOT_SPEED = 5;
							const int MAX_NUM = 4;
							// I
							// I܂ŔI
							for( int i = 0; i < MAX_NUM; i ++ ) { 
								float fShotDeg = fDeg + i * 360 / MAX_NUM;
								GEnemy* lpAdd = this->createWithoutAdd( EnemyType::LAVA_BALL, lpEnemy->getCenter(),
									-1 );
								this->m_vecAdds.push_back( lpAdd );
//								GShot* lpShot = 
//									getStaticData()->m_ObjectManager.m_ShotManager.create(
//									Sequence::Shot::LAVA_BALL,
//									lpEnemy->getCenter(), lpEnemy->getID(),
//									lpEnemy->getFaceDirection(),
//									false, true);
								HPLVector v;
								v.setByDegree( fShotDeg );
								v.multiple( SHOT_SPEED * fLevel );
								lpAdd->setVelocityAngle( v );
							}
						}
					}
				}
				if( StateType::ATTACK_2 == st && lpSeq->getState().isFinishAnimation ) {
					//
					nNext = lpEnemy->getAttackType() + 1;
				}

			}
			break;
			case Merako01AttackType::FALLOUT:
			{
				const int TOP_THRESHOLD = 100;
				if( TOP_THRESHOLD < lpEnemy->getCenter().getY() ) {
					// ֈړ
					const float SPEED = 5;
					HPLVector vVel(0,-SPEED);
					lpEnemy->setVelocityAngle( vVel );
				} else {
					// _ɍ~点
					if( lpEnemy->getCounter( Merako01CounterType::LAVA_INTERVAL )->step().isFinishAnimation ) {
						lpEnemy->getCounter( Merako01CounterType::LAVA_INTERVAL )->reset();
						HPLVector vCenter( HPLMath::nextInt( 0 + nTileSize, nWidth - nTileSize ),
							50 );
					}
				}
			}
			break;
			case Merako01AttackType::DROP_FLARE:
			{
				// Egbvs藈
				if( lpEnemy->getCounter( Merako01CounterType::MOVE_INTERVAL )->step().isFinishAnimation ) {
					// ړJEg

					if( lpEnemy->getCounter( Merako01CounterType::MOVE_COUNT )->step().isFinishAnimation ) {
						// 
						nNext = lpEnemy->getAttackType() + 1;
					}
					lpEnemy->getCounter( Merako01CounterType::MOVE_INTERVAL )->reset();
					// s挈
					nRandomType = RandomType::ALL_TOP;

//					const int START_DEG = -90;
//					const int INTERVAL_DEG = 360 / LAVA_BALL_NUM;
					//const int LAVA_SPEED = 1;
					// Vbg
					{
						GShot* lpShot = 
							getStaticData()->m_ObjectManager.m_ShotManager.create(
							Sequence::Shot::LAVA_BALL,
							lpEnemy->getCenter(), lpEnemy->getID(),
							lpEnemy->getFaceDirection(), false, true);
						//float fDeg = START_DEG + i * INTERVAL_DEG;
						lpShot->setVelocityAngle( 0, 0 );
					}
				}
			}
			break;
			case Merako01AttackType::DASH:
			{
				// Egbvs藈
				if( lpEnemy->getCounter( Merako01CounterType::MOVE_INTERVAL )->step().isFinishAnimation ) {
					// ړJEg

					if( lpEnemy->getCounter( Merako01CounterType::MOVE_COUNT )->step().isFinishAnimation ) {
						// 
						nNext = lpEnemy->getAttackType() + 1;
					}
					lpEnemy->getCounter( Merako01CounterType::MOVE_INTERVAL )->reset();
				}
				const float SPEED_THRESHOLD = 3;
				if( lpEnemy->getVelocityAngle().getLength() > SPEED_THRESHOLD ) {
					// dash
					if( st != StateType::DASH ) {
						lpEnemy->changeState( StateType::DASH );
					}
				} else {
					// flydown
					if( st != StateType::FLYDOWN ) {
						lpEnemy->changeState( StateType::FLYDOWN );
					}
				}
			}
			break;
			case Merako01AttackType::CHASE:
			{
				result.m_bIsChase = true;
				result.m_vGoalPosition =  vTargetCenter;
				if( lpEnemy->getCounter( Merako01CounterType::ATTACK_TERM )->step().isFinishAnimation ) {
					nNext = lpEnemy->getAttackType() + 1;
				}
			}
			break;
			default:
				ASSERT_IT_TYPE( lpEnemy->getAttackType(), "merako attack type");
//				HPLError::assertIt(false);
			}

			switch( nRandomType ) {
			case RandomType::NO_MOVE:
				break;
			case RandomType::ALL:
				{
					int nIndex = HPLMath::nextInt(0, lpMat->getRowSize() );
					this->setEnemyGoalAndVelocity(nIndex, lpMat, lpEnemy );
				}
				break;
			case RandomType::ALL_TOP:
				{
					int TOPS[] = {
						PointType::CENTER_TOP,
						PointType::LEFT_TOP,
						PointType::RIGHT_TOP,
					};
					int nIndex = TOPS[HPLMath::nextInt(0,SIZEOF(TOPS))];
					this->setEnemyGoalAndVelocity( nIndex, lpMat, lpEnemy );
				}
				break;

			}
		}
	}
	if( bIsChangeBySpeed ) {
		const float SLOW_THRESHOLD = 2;
		if( lpEnemy->getVelocityAngle().getLength() < SLOW_THRESHOLD ) {
			lpEnemy->changeState( StateType::FLYDOWN );
		} else {
			lpEnemy->changeState( nWalkingState );
		}
	}
	// test
#ifdef _DEBUG
	if( getStaticData()->getInputManager()->isPressedNow( KeyMap::G ) ) {
		nNext = lpEnemy->getAttackType() + 1;
	}
#endif
	if( nNext >= 0 ) {
		// ֈȍ~
		int RESET_TARGETS[] = {
			Merako01CounterType::MOVE_INTERVAL,
			Merako01CounterType::MOVE_COUNT,
			Merako01CounterType::LAVA_COUNT,
			Merako01CounterType::LAVA_INTERVAL,
			Merako01CounterType::ATTACK_TERM,
		};
		for( int i = 0; i < SIZEOF( RESET_TARGETS ); i ++ ) {
			lpEnemy->getCounter( RESET_TARGETS[i] )->reset();
		}

		if( nNext >= Merako01AttackType::MAX_NUM ) {
			nNext = 0;
		}
		lpEnemy->setAttackType( nNext );
	}

}

/**************
  * Tj[iqj̃ASY
  */
void GEnemyManager::doMerakoAlgorithm( GEnemy* lpEnemy ) {
	GEnemyAIResult result;
	int nMapIndex = getStaticData()->getMapIndex();

	switch( nMapIndex ) {
	case SpecialMapIndex::SUNNY_MEET:
		break;
	case SpecialMapIndex::MERAKO:
		this->doMerakoBattle( lpEnemy, result );
		break;
	}

	if( result.m_bIsChase ) {//bIsChase ) {
		this->chase( lpEnemy, result.m_vGoalPosition, result.m_fChaseAccel, result.m_fChaseMaxSpeed );
	}
	if( result.m_bIsFaceToPlayer) {
		this->faceToTarget(lpEnemy );
	} else {
		// is
		HPLActionMoveTool::faceByVelocity( lpEnemy, FACE_CHANGE_THRESHOLD );
	}
}
