#include "GEnemyManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>

using namespace std;
using namespace GEnum;


// TODO ʉ
/** 炭AI
  */
void GEnemyManager::doSlimeQueenAlgorithm( GEnemy* lpEnemy ) {
	int t = lpEnemy->getType();
	
	HPLShootingObject* lpTarget = lpEnemy->getTarget();
	HPLVector vTargetCenter = lpTarget->getCenter();
	
	HPLVector vSub(
		vTargetCenter.getX() - lpEnemy->getCenter().getX(),
		vTargetCenter.getY() - lpEnemy->getCenter().getY() );


	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	float fLength = vSub.getLength();

	int st = lpEnemy->getState()->getState();
	float RESIST = getStaticData()->m_Setting.resist;
	float GRAVITY = getStaticData()->m_Setting.gravity;

	// Aj[V
	HPLSequence* lpSeq = lpEnemy->getSequence();

	bool bIsNextColor = false;	//! ̐Fֈڍs邩

	switch( lpEnemy->getColor() ) {
	case 0:		//red
		lpEnemy->getCounter( SlimeQueenCounterType::CREATE_INTERVAL )->step();
		if( false == lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_START )->getState().isFinishAnimation ) {
			HPLVector vVelocityAngle = lpEnemy->getVelocityAngle();
			vVelocityAngle.setX(0);
			lpEnemy->setVelocityAngle( vVelocityAngle );
			// ŏ͂Ƃ܂Ă

			// vC[̕
			lpEnemy->setFaceDirection( HPLMath::getSgn<int>( vSub.getX() ) );

			if( lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_START )->step().isFinishAnimation ) {
				// 
			}
		} else if( false == lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->getState().isFinishAnimation ) {
			if( lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->step().isFinishAnimation ) {
			}
		} else {
			if( st == StateType::STAND ) {

				// 
				lpEnemy->changeState( StateType::WALK );

			} else if( st == StateType::WALK ) {

				// Ԋuŉ
				if( lpEnemy->m_lpCreateEffectIntervalCounter->step().isFinishAnimation ) {
					lpEnemy->m_lpCreateEffectIntervalCounter->reset();

					HPLRect rHitArea = lpEnemy->getHitArea();

					for( int i = 0; i < HPLMath::nextInt( SLIME_QUEEN_SMOKE_MIN, SLIME_QUEEN_SMOKE_MAX); i ++ ) {
						HPLVector vSmokeCenter(
							rHitArea.getX() + rHitArea.getWidth() / 2 + 
							lpEnemy->getFaceDirection() * SLIME_QUEEN_SMOKE_DELTA_X + 
							HPLMath::nextFloat( - SLIME_QUEEN_SMOKE_ERR, SLIME_QUEEN_SMOKE_ERR ) ,
							rHitArea.getBottom() + HPLMath::nextFloat( -SLIME_QUEEN_SMOKE_ERR_Y,SLIME_QUEEN_SMOKE_ERR_Y) );
						GEffect* lpEffect = getStaticData()->createEffect( Sequence::Effect::EXPLOSION_SMOKE ,
							vSmokeCenter, vSmokeCenter, -1, -1 );
						lpEffect->setVelocityAngle( 0, - SMOKE_SPEED_Y );
					}
				}

				// ړ
				HPLVector vVelocityAngle = lpEnemy->getVelocityAngle();
				HPLActionMoveTool::accelWithLimitX(
					&vVelocityAngle, HPLVector( lpEnemy->getFaceDirection() * ( SLIME_QUEEN_RED_ACCEL + RESIST ), 0 ),
//					HPLVector( RESIST,0),
					SLIME_QUEEN_MAX_SPEED + RESIST );
				lpEnemy->setVelocityAngle(vVelocityAngle);

				// ǐڐGŒ~
				if( lpEnemy->getTrigger()->getTrigger( TriggerType::HIT_TO_THE_LEFT ) ||
					lpEnemy->getTrigger()->getTrigger( TriggerType::HIT_TO_THE_RIGHT ) )
				{
					// nk
					getStaticData()->m_ShakeManager.startShake();
					// vC[̕
					lpEnemy->setFaceDirection( HPLMath::getSgn( vSub.getX() ) );

					// ̐F
					bIsNextColor = true;
					lpEnemy->changeState( StateType::STAND );
				}
			}
		}
		break;
	case 1:		//blue
		if( false == lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->getState().isFinishAnimation ) {
			// p
			// ~
			HPLVector vVelocityAngle = lpEnemy->getVelocityAngle();
			vVelocityAngle.setX(0);
			lpEnemy->setVelocityAngle( vVelocityAngle );
			if( lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->step().isFinishAnimation ) {
				lpEnemy->changeState( StateType::READY_TO_JUMP );
				lpEnemy->setFaceDirection( HPLMath::getSgn( vSub.getX() ) );
			}
		} else {
			if( st == StateType::READY_TO_JUMP ) {
				if( lpEnemy->getSequence()->getState().isFinishAnimation ) {
					// change state FLYUP
					lpEnemy->changeState( StateType::FLYUP );

					// jump
					this->jump( lpEnemy,
						HPLMath::getParaboraVelocityX( vSub.getX(), SLIME_QUEEN_JUMP_SPEED_Y, GRAVITY ) / 2, 
						- SLIME_QUEEN_JUMP_SPEED_Y,
						true, false );

					// se
					getStaticData()->m_MixerManager.play( SE::BOSS_JUMP, false );
				}
			} else if( lpEnemy->getState()->isFlyingState() ) {
			} else if( st == StateType::STAND ) {
				// n
				// crouch
				//lpEnemy->changeState( StateType::CROUCH );
				// vC[̕
				lpEnemy->setFaceDirection( HPLMath::getSgn( vSub.getX() ) );
				
				// TODO nɑx0ɂ邩H
				//		邢͈CɌ邩Hix101ɂƂHj

				// nk
				getStaticData()->m_ShakeManager.startShake();

				// Wv񐔊mF
				if( lpEnemy->getCounter( SlimeQueenCounterType::JUMP_COUNT )->step().isFinishAnimation ) {
					// 
					bIsNextColor = true;
					lpEnemy->changeState( StateType::STAND );

					// JE^̓ZbgĂ
					lpEnemy->getCounter( SlimeQueenCounterType::JUMP_COUNT )->reset();
				} else {

					// ܂Wv
					lpEnemy->changeState( StateType::READY_TO_JUMP );
				}
			}/* else if( st == StateType::CROUCH ) {
				if( lpEnemy->getSequence()->getState().isFinishAnimation ) {
					// owata
					
				}
			}*/
			// 
		}
		break;
	case 2:		//green
		if( false == lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->getState().isFinishAnimation ) {
			// waiting
			if( lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->step().isFinishAnimation ) {
				// next]
				lpEnemy->changeState( StateType::ATTACK );
			}
		} else {
			bool bIsNext = false;

			if( st == StateType::ATTACK ) {

				switch( lpEnemy->getAttackType() ) {
//							case 1:	// armŉ
//								break;
				case 2:	//|@
					// G̕֋z񂹂
					HPLVector vDisonAim = lpTarget->getCenter();
					vDisonAim.multiple(-1);
					vDisonAim.add( lpEnemy->getCenter() );
					vDisonAim.normalize();
					vDisonAim.multiple( SLIME_QUEEN_GREEN_DISON_ACCEL );

					HPLVector vTargetVelocityAngle = lpTarget->getVelocityAngle();
					vTargetVelocityAngle.add( vDisonAim );
					lpTarget->setVelocityAngle( vTargetVelocityAngle );

					GEnemy* lpHead = dynamic_cast<GEnemy*>( lpEnemy->m_vecArmManagers[0]->getHead() );
					// z݃GtFNg
					HPLVector vHeadToTarget( vTargetCenter.getX() - lpHead->getCenter().getX(), 
						vTargetCenter.getY() - lpHead->getCenter().getY() );
					float fDegree = vHeadToTarget.getDegree() + HPLMath::nextFloat(-SLIME_QUEEN_VACUUM_DEGREE_ERR,SLIME_QUEEN_VACUUM_DEGREE_ERR);
					float fRadius = HPLMath::nextFloat( SLIME_QUEEN_VACUUM_LENGTH_MIN, SLIME_QUEEN_VACUUM_LENGTH_MAX );
					HPLVector vVacuumCenter;
					vVacuumCenter.setByDegree( fDegree );
					vVacuumCenter.multiple( fRadius );
					HPLVector vVacuumVelocity = vVacuumCenter;
					vVacuumCenter.add( lpHead->getCenter() );

					GEffect* lpVacuumEffect = getStaticData()->createEffect( Sequence::Effect::VACUUM, 
						vVacuumCenter, vVacuumCenter, -1, -1 );
					
					float fSpeed = vVacuumVelocity.getLength() / VACUUM_ALL_FRAMES;
					vVacuumVelocity.normalize();
					vVacuumVelocity.multiple( -1 * fSpeed);

					lpVacuumEffect->setVelocityAngle( vVacuumVelocity );
					break;
				}

				// Go
				if( lpSeq->getState().isFinishAnimation ) {
					// I

					if( lpEnemy->m_vecArmManagers[0]->getHead()->isHolding() ) {
						//擪͂ł
						// p
						lpSeq->resetCounter();
					} else {
						bIsNext = true;
					}
				}
			} else if( st == StateType::HOLD ) {
				// ߂܂Ă
				if( lpSeq->getState().isFinishAnimation ) {
					// I
					// 
					bIsNext = true;
				}
			} else {
				lpEnemy->changeState( StateType::ATTACK );
			}
			if( bIsNext ) {
				lpEnemy->changeState( StateType::STAND );

				// 
				bIsNextColor = true;

				// 
				if( lpEnemy->isHolding() ) {
					this->freeHold( lpTarget, lpEnemy );
				}
				for( vector<GArmManager*>::iterator ait = lpEnemy->m_vecArmManagers.begin();
					ait != lpEnemy->m_vecArmManagers.end();
					ait ++ )
				{
					GArmManager* lpArmManager = *ait;
					// GԂ傠
					lpArmManager->createBloodEffect();

					GEnemy* lpArmHead = dynamic_cast<GEnemy*>( lpArmManager->getHead() );
					if( lpArmHead->isHolding() ) {
						this->freeHold( lpTarget, lpArmHead );
					}
				}
			}
		}
		break;
	case 3:		//yellow
		if( false == lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->getState().isFinishAnimation ) {
			// waiting
			if( lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT )->step().isFinishAnimation ) {
				lpEnemy->changeState( StateType::ATTACK_2 );
				// vC[̕
				lpEnemy->setFaceDirection( HPLMath::getSgn( vSub.getX() ) );
			}
		} else {
			if( st == StateType::ATTACK_2 ) {
				if( lpSeq->getState().isEndLoop ) {
					// FXCA܂͂ЂjЂ΂

					if( getStaticData()->m_OptionData.getLevelIndex() >= LevelType::HARD &&
						HPLMath::nextDouble(0,100) < SLIME_QUEEN_YELLOW_CREATE_PROBABILITY * fLevel )
					{
						// FXCHARDȏ̂݁BȂ^Q[ɂȂ
						// mŏoB

						float fBaseVelX = HPLMath::getParaboraVelocityX( vSub.getX(), SLIME_QUEEN_SHOT_SPEED_Y, GRAVITY ) / 2;
						
						GEnemy* lpNewEnemy = new GEnemy( EnemyType::YELLOW_SLIME );
						lpNewEnemy->setCenter( lpEnemy->getCenter() );
						lpNewEnemy->setVelocityAngle(
							fBaseVelX, -SLIME_QUEEN_SHOT_SPEED_Y);
						this->m_vecAdds.push_back( lpNewEnemy );

						
					} else {
						// Ђj
						getStaticData()->m_ShotFactory.shot(
							lpEnemy, lpEnemy->getColor(), 0);
					}
				}

				if( lpSeq->getState().isFinishAnimation ) {
					// next
					bIsNextColor = true;
					lpEnemy->changeState( StateType::STAND );

				}
			}
		}
		break;
	}


	if( getStaticData()->getInputManager()->isPressedNow( KeyMap::G ) ) {
		// FύX
		bIsNextColor = true;
	}

	if( bIsNextColor ) {
		if( 0 < lpEnemy->setBerserkLevel() ) {
			// o[T[N[h

			// _
			//lpEnemy->setColor( HPLMath::nextInt( 0, lpEnemy->m_vecColors.size() ) );

			// EGCgZȂ
			HPLCounter* lpCounter = lpEnemy->getCounter( SlimeQueenCounterType::WAIT_FOR_NEXT );
			lpCounter->setWaitFrameNum( 4 ) ;//SLIME_QUEEN_WAIT_FOR_NEXT / 10 );
		} else {
		}
		int nColor = lpEnemy->getColor() + 1;

		// X
		if( (int)lpEnemy->m_vecColors.size() <= nColor ) {
			nColor = 0;
		}
		
		lpEnemy->setColor( nColor );

	}

}

