#ifndef _G_EFFECT_
#define _G_EFFECT_

#include <hpllib/object/HPLShootingObject.h>
#include <hpllib/math/HPLMatrix.h>
#include <hpllib/game/block/HPLBlock.h>
#include <hpllib/general/HPLColor.h>

/*****************************************************************
  * GtFNg
  */
class GEffect : public HPLShootingObject {
private:
	float 				m_fScale;			//! TCYύXp
	HPLColor*			m_lpColor;			//! prJ[
	int					m_nNumber;			//! eXgB\p
	std::vector<int>	m_vecNumberList;	//! Ƃ̐lXgiɍĂ܂j
	//int				m_nWindColor;					//! ̐F
//	int		m_nRed;
//	int		m_nGreen;
//	int		m_nBlue;
	
	bool				m_bIsFadeOut;					//! Xɏ^Cv
	int					m_nCreateEffectTypeAfterDead;	//! SɐEffect typeB-1Ȃ琶Ȃ
	HPLVector			m_vCenterPosition;
	HPLCounter*			m_lpIntervalCounter;	//! ړIC^[oJE^
	int					m_nGenerateEffectType;	//! GtFNg^Cv
	// Getter / Setter / public variables
	bool				m_bIsSetColor;	//! J[iintŁjݒ肵ǂ
	HPLVector*			m_lpvTargetDelta;		//! `[WA^[Qbg݂ꍇAꂽʒuɌ悤ɂł
public:
	HPLVector* getTargetDelta() {	return this->m_lpvTargetDelta;}
	void setTargetDelta( HPLVector& v ) {
		if( this->m_lpvTargetDelta == NULL ) {
			this->m_lpvTargetDelta = new HPLVector();
		}
		*this->m_lpvTargetDelta = v;
	}
	// override
	virtual void setColor( int nCol);
	virtual int getColor();
	HPLCounter* getIntervalCounter() {	return this->m_lpIntervalCounter;	}
	void setIntervalCounter( int nFrameNum ) {	
		if( this->m_lpIntervalCounter == NULL ) {
			this->m_lpIntervalCounter = new HPLCounter();
		}
		this->m_lpIntervalCounter->setWaitFrameNum( nFrameNum );
	}
	int getGenerateEffectType(){	return this->m_nGenerateEffectType;	}
	void setGenerateEffectType(int nType) {	this->m_nGenerateEffectType = nType;	}

	void setCenterPosition( HPLVector& v ) {	this->m_vCenterPosition = v;	}
	void getCenterPosition( HPLVector& v ) {	v = this->m_vCenterPosition;	}

	// create effect type
	int getCreateEffectTypeAfterDead() {	return this->m_nCreateEffectTypeAfterDead;	}
	void setCreateEffectTypeAfterDead( int nType ) {	this->m_nCreateEffectTypeAfterDead = nType;	}

	bool 		m_bIsBack;		//! wɕ`
	int			m_nSpriteType;	//! cp
	int			m_nSequenceID;	//! sequence id	cp
	int			m_nFrameIndex;	//! frame index	cp
	int			m_nImageInfo;	//! image info index	cp

//	bool		m_bIsHitToBlock;				//! ubNɃqbg
	// color
	void setColor( int nR, int nG, int nB ) {
		this->checkAndAllocColor();
		this->m_lpColor->set(nR,nG,nB);
	}
	void setColor( HPLColor& col ) {
		this->checkAndAllocColor();
		this->m_lpColor->set(col.r,col.g,col.b);
	}
	/** lݒ肷
	  * @param[in]	bIsZero		]0Ŗ߂邩
	  * @param[in]	nMaxPower	ő包
	  */
	void setNumber( int nNumber, bool bIsZero, int nMaxPower );
	void setScale( float fScale ) {	this->m_fScale = fScale;	}
public:
	GEffect():HPLShootingObject(0){}
	GEffect(int t);
	void setup(int t );
	virtual ~GEffect();

	// operation private
private:
	void checkAndAllocColor() {
		if( this->m_lpColor == NULL ) {
			this->m_lpColor = new HPLColor();
		}
	}
	// Iy[V
public:
	/** */
	void collision(HPLMatrix<int>* matrix,
		std::map<int, HPLBlock*>* blockMap);

	/**
		ASY
	*/
//	void algorithm();

	void draw();

	/////////////////////////////////////////////////////
	/////////////////////////////////////////////////////
	void die(HPLShootingObject* damageSource);

	void damage(float dmg, HPLShootingObject* damageSource);

	HPLSequence* getSequence();

	/** F_ɕύX
	  */
	void setColorAsRandom();

	// 
public:
	void changeState( int nState ) {
		HPLShootingObject::changeStateCommon(this, nState);
	}
	int getSequenceID(){
		return HPLShootingObject::getSequenceIDCommon(this);
	}


};
#endif
