#ifndef _G_EFFECT_MANAGER_
#define _G_EFFECT_MANAGER_

#include <hpllib/cycle/HPLObjectManager.h>

#include "GEffect.h"

using namespace std;

/** Effect manager
  */
class GEffectManager : public HPLObjectManager<GEffect> {
private:
	list<GEffect*> m_vAdds;
//	HPLShootingObject* m_lpGlobalMoveTarget;	//! O[oȈړΏ
	HPLVector	m_vGlobalMoveTargetCenter;	//! O[oȈړڕWn_
public:
//	HPLShootingObject* getGlobalMoveTarget() {	return this->m_lpGlobalMoveTarget;	}
//	void setGlovalMoveTargeT( HPLShootingObject* lpTarget ) {		this->m_lpGlobalMoveTarget = lpTarget;	}
	void getGlobalMoveTargetCenter(HPLVector& v ) {	v = this->m_vGlobalMoveTargetCenter;	}
	void setGlobalMoveTargetCenter( HPLVector& v ) {	this->m_vGlobalMoveTargetCenter = v;	}
	int NUM_WIDTH;	// width for number 
	int NUM_HEIGHT;	// height for number 
public:	// constructor
	GEffectManager();
	virtual ~GEffectManager(){}

public:	// operation public
	void process(bool isMove, bool bIsAI);
	GEffect* create(int t, HPLVector center, bool bIsAddToList );

	void algorithm(GEffect* effect);

	/** vC[wɂGtFNg`悷B`̂݁B
	  */
	void drawBack();

	/** c𐶐
	  * @param[in]	nSpriteType,nSequenceID,nFrameIndex	摜B
	  * @param[in]	lpObject		IuWFNgBȉ̏邽
									E
	  * @param[in]	nRGB			FiGEnum::RGBj
	  * @retval						ݒ聕ǉς݂̃GtFNg
	  */
	GEffect* createZanzo( int nSpriteType, int nSequenceID, int nFrameIndex,
		HPLShootingObject* lpObject, int nR,int nG, int nB  );

	/** GtFNg𕡐쐬܂
	  * @param[in]	nRandomPositionType	ʒũ_ݒ(RandomVectorType::)
	  * @param[in]	fRandomParam0		CIRCLE_RANDOM	:S̍ŏ
	  * @param[in]	fRandomParam1		CIRCLE_RANDOM	:S̍ő勗
	  * @param[in]	fRandomParam2		
	  * @param[in]	fRandomParam3
	  * @param[in]	nRandomSpeedType	ړ̃_ݒ
	  * @param[in]	fRandomSpeedMin
	  * @param[in]	fRandomSpeedMax
	  * @param[in]	fRandomSpeed2Min	RECTANGLE_RANDOM:cx_ŏxȉꍇj
	  * @param[in]	fRandomSpeed2Max	RECTANGLE_RANDOM:cx_ő呬x
	  * @retval		-1		
	  * @retval		0ȏ	쐬GtFNg̐
	  */
	int createEffects( int nType, const HPLVector& vFrom, const HPLVector& vTo,
		int nCreateEnemyType, int nForceID,
		const int nRandomPositionType,
		const float fRandomParams0,
		const float fRandomParams1,
		const float fRandomParams2,
		const float fRandomParams3,
		const int nRandomSpeedType, const float fRandomSpeedMin, const float fRandomSpeedMax,
		const float fRandomSpeed2Min, const float fRandomSpeed2Max,
		const int nNum);

	/** Bloodɓ
	  */
	void createBlood( HPLVector vBloodCenter );

	/** Cureɓ
	  * @param[in]	bIsOne		true	1Ȃ
	  * @retval		ꂽGtFNg
	  */
	int createCure( HPLVector& vCenter, int nID, bool bIsOne );

	/** GtFNg쐬
	  */
	int createWind( HPLVector vCenter, int nWidth, int nHeight, float fDegree, float fSpeedRate );

	/** 
	  */
	int createNumber( HPLVector& vCenter, int nNum, bool bIsZero, int nMaxPower, int nR, int nG, int nB );

	/** `[W𔭐
	  * @param[in]	lpTarget	^[QbgivC[ȊOȂǁA݂ȂꍇNULLj
	  * @param[in]	vCenter		SW
	  * @param[in]	nMinRadius/nMaxRadius
	  */
	int createCharge( HPLShootingObject* lpTarget, HPLVector vCenter, int nMinRadius, int nMaxRadius );

	/** ̌납oGtFNg𔭐
	  */
	int createWeaponBackEffect(int nFaceDirection, const HPLVector& vCenter, int nEffectType );

	/** 
	  */
	bool checkHitToPlayer( GEffect* lpEffect );

	static void drawNumber( int nX, int nY, int nR, int nG, int nB, std::vector<int>& vecNumberList );
};

#endif
