#include "GEnemy.h"

#include "GStaticData.h"

//#include <hpllib/
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/action/HPLCollisionCheckTool.h>
#include <hpllib/math/HPLMath.h>
#include <hpllib/system/HPLLogger.h>
#include <hpllib/general/HPLString.h>

#include <hpllib/general/HPLPointerTool.h>

namespace GEnum {
	const int MERAKO_MOVE_COUNT = 5;			//! SUNNŸړ񐔃ftHg
	const float ENEMY_AIR_RESIST_RATE = 0.05f;	//! G󒆂Ŏ󂯂CRiʏRɂ{j
	const float FACE_CHANGE_THRESHOLD = 0.01f;	//! ]臒l
	const int SHABON_SPEED = 5;

	namespace Sequence {
		namespace Aiko {
			enum Aiko_ {
				STAND,
				ATTACK,
				ATTACK_2,
				FLYDOWN,
			};
		}
	}
}

using namespace std;

using namespace GEnum;

bool GEnemy::getStateFlag( int nIndex ) {
	return HPLMath::getFlagByIndexInt( this->m_nStateFlag, nIndex );
}

void GEnemy::setStateFlag( int nIndex, bool bFlag ) {
	this->m_nStateFlag = HPLMath::setFlagByIndexInt(this->m_nStateFlag, nIndex,
		bFlag );
}

void GEnemy::setWeakness( int nType, bool bIsWeak ) {
	this->m_nWeaknesses = HPLMath::setFlagByIndexInt(this->m_nWeaknesses, nType,
		bIsWeak );
}
bool GEnemy::isWeakness( int nType ) {
	return HPLMath::getFlagByIndexInt( this->m_nWeaknesses, nType );
}
void GEnemy::setImmunity( int nType, bool bIsImmune ) {
	this->m_nImmunities = HPLMath::setFlagByIndexInt(this->m_nImmunities, nType,
		bIsImmune );
}
bool GEnemy::isImmunity( int nType ) {
	return HPLMath::getFlagByIndexInt( this->m_nImmunities, nType );
}
void GEnemy::addCounter( HPLCounter* lpCounter ) {
	HPLError::assertIt( lpCounter != NULL,
		"" );
	this->m_vecCounters.push_back( lpCounter );
}
HPLCounter* GEnemy::getCounter( int nIndex ) {
	return this->m_vecCounters[ nIndex ];
}

/**
  */
//GEnemy::GEnemy( int nType ) : HPLShootingObject(nType){
void GEnemy::setup( int nType ) {
	this->m_lprWeakHitRect = NULL;
	this->clearArmManagers();

	this->resetStateFlag();
	
	setObjectType(ObjectType::ENEMY);
	this->setPreviousState( -1 );

	this->m_nAttackType = 0;

	this->m_fBrustMaxSpeed = 0;
	this->m_nBrustType = BrustType::NONE;
	
	this->m_nWeaknesses = 0;
	this->m_nImmunities = 0;

	this->m_RespawnCounter = NULL;

	this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, true );
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK] = true;

	this->setBerserkLevel(0);

//	this->m_nSolidType = SolidType::NONE;

	// ܂ƂGtFNg
	getStaticData()->m_ObjectManager.resetFireEffect( this );

	// sprite id
//	int nSpriteID = 0;
//	this->setSprite(getStaticData()->getSprite(nSpriteID)->clone());

	this->m_nBitEnemyAttributes = 0;

	// reduce accel
	this->setReduceAccel( getStaticData()->m_ObjectManager.m_EnemyManager.getEnemyAirResist(1) );

//	for( int i = 0; i < EnemyAttribute::MAX_NUM; i ++ ) {
//		this->getEnemyAttributes( i ] = false;
//	}
	GEnemySetting* enemySetting = getStaticData()->m_ObjectManager.m_EnemyManager.getEnemySetting( nType );
	int nSpriteID = enemySetting->m_nSpriteID;

	if( nSpriteID >= 0 ) {
		this->setSprite( getStaticData()->getSprite( nSpriteID )->clone() );
		// TCY
		HPLImageInformation* lpInfo = this->getSprite()->getSequence(0, FaceDirection::LEFT)->getImageInformation(0);
		this->setSize( lpInfo->srcRect.getWidth(), lpInfo->srcRect.getHeight() );
		
	} else {
		this->setSize( 1,1 );
	}

	// ɕ\H
	this->m_bIsDrawBack = false;
	
	// STYPE
	this->m_nHoldType = 0;

	// xO
	float fLevel = getStaticData()->m_Game.getLevel();
	if(fLevel == 0){
		fLevel = 0.001f;
	}

	const float ENEMY_SOLID_RATE = 2.f;
	this->m_SolidData.setup( SolidType::NONE, (int)( SOLID_DEFAULT_FRAME * ENEMY_SOLID_RATE / fLevel ) );

	// target
	this->setTarget( &getStaticData()->m_ObjectManager.m_Player);


//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_ENEMY] = false;
	//setHitToBlock(true);
	this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, true );
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK] = true;


	setRecognized(false);					// CÂȂ
	//this->m_bIsTargetted = false;			// ^[QbeBOĂȂ
	this->m_TargettedRemainCounter.setWaitFrameNum( TARGETTING_REMAIN_COUNT );
	this->m_TargettedRemainCounter.end();


	this->m_nGenerateType = 0;				// G̃^Cv


	HPLAttackInformation* lpInfo = getStaticData()->m_ObjectManager.m_EnemyManager.getAttackInformation(
		nType );
	this->m_lpAttackInformation = lpInfo == NULL ? NULL : lpInfo->clone();

	// set by outter data
	this->setHitRect( enemySetting->m_HitRect );
//	setHitRect(15,50,75,38); // slime default
	// hp
	this->setHPMax( ENEMY_HP_BASE * enemySetting->m_fHPRate * fLevel );
	this->setHP( this->getHPMax() );
	this->setPoint( this->getHP() * ENEMY_POINT_DEFAULT );	//! GHPɔ
	// power
	this->m_fPower = ENEMY_POWER_BASE * enemySetting->m_fPowerRate;
	// blow
	this->m_fBlow = ENEMY_BLOW_BASE * enemySetting->m_fBlowRate;

	// RŃ^[
	this->setEnemyAttribute( EnemyAttribute::RETURN_AT_EDGE, enemySetting->m_aryFlags[EnemyFlagType::RETURN_AT_EDGE ] );
//	this->getEnemyAttributes( EnemyAttribute::RETURN_AT_EDGE ] = 
//		enemySetting->m_aryFlags[EnemyFlagType::RETURN_AT_EDGE];	
	// No Recognize
	this->m_bIsNoRecognize = enemySetting->m_aryFlags[EnemyFlagType::NO_RECOGNIZE];
	// deadp^[
	this->setEnemyAttribute( EnemyAttribute::HAS_DEAD, enemySetting->m_aryFlags[EnemyFlagType::HAS_DEAD ] );
	//this->getEnemyAttributes( EnemyAttribute::HAS_DEAD ] = 
	//	enemySetting->m_aryFlags[EnemyFlagType::HAS_DEAD ];	
	// Hit to Player
	this->setObjectAttribute( ObjectAttribute::HIT_TO_PLAYER, enemySetting->m_aryFlags[EnemyFlagType::HIT_TO_PLAYER ] );
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_PLAYER] = enemySetting->m_aryFlags[EnemyFlagType::HIT_TO_PLAYER ];
	// Hit to Shot
	this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, enemySetting->m_aryFlags[EnemyFlagType::HIT_TO_SHOT ] );
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_SHOT] = enemySetting->m_aryFlags[EnemyFlagType::HIT_TO_SHOT];
	// G
	this->setEnemyAttribute( EnemyAttribute::INVINSIBLE, enemySetting->m_aryFlags[EnemyFlagType::INVINSIBLE ] );
//	this->getEnemyAttributes( EnemyAttribute::INVINSIBLE ] = 
//		enemySetting->m_aryFlags[EnemyFlagType::INVINSIBLE];
	// d͂
	this->setObjectAttribute( ObjectAttribute::GRAVITY, enemySetting->m_aryFlags[EnemyFlagType::GRAVITY ] );
//	this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = enemySetting->m_aryFlags[EnemyFlagType::GRAVITY];
	// eŐ
	this->m_bIsBlowByShot = enemySetting->m_aryFlags[EnemyFlagType::SUPER_ARMOR] == false;	
	// jump over collision
	this->setEnemyAttribute( EnemyAttribute::JUMP_OVER_COLLISION ,
		enemySetting->m_aryFlags[ EnemyFlagType::JUMP_OVER_COLLISION] );
//	this->getEnemyAttributes( EnemyAttribute::JUMP_OVER_COLLISION ] = 
//		enemySetting->m_aryFlags[ EnemyFlagType::JUMP_OVER_COLLISION];

	this->setColor( 0 );
	this->m_nPreviousColor = 0;
	//this->m_bIsHoldingEnemy = false;
	this->setHoldingEnemy( false );
	
	this->m_lpCreateEffectIntervalCounter = NULL;

	this->m_nClassType = EnemyClassType::EVIL_ZAKO;
	
	//this->m_nZanzoColor = -1;	// cȂ
	this->m_lpZanzoColor = NULL;

	this->m_lpAmplitude = NULL;	// UJE^
	
	// TLoX̏㉺hJE^iϓIj
	const int SUCCUBUS_AMPLITUDE_FRAME = 100;

	switch( nType ) {
	case EnemyType::NAMAKO:
		// ^[
//		this->getEnemyAttributes( EnemyAttribute::RETURN_AT_EDGE ] = true;
		// _ȕĂ
		this->setEnemyAttribute( EnemyAttribute::RANDOM_FACE_DIRECTION, true );
//		this->getEnemyAttributes( EnemyAttribute::RANDOM_FACE_DIRECTION ] = true;

		// ތn
		//this->setHoldingEnemy( true );

		break;
	/*case EnemyType::SNAKE:
		// 
		this->setHoldingEnemy( true );
		break;*/
	case EnemyType::BLUE_SLIME_BABY:
	case EnemyType::SLIME_BABY:
	case EnemyType::GREEN_SLIME_BABY:
	case EnemyType::YELLOW_SLIME_BABY:
		{
			this->setSize( this->getWidth()/ 2, this->getHeight() / 2 );
			HPLRect rHitRect = this->getHitRect();
			this->setHitRect(
				rHitRect.getX() / 2,
				rHitRect.getY() / 2,
				rHitRect.getWidth() / 2,
				rHitRect.getHeight() / 2 );
		}
		
	case EnemyType::BLUE_SLIME:
	case EnemyType::SLIME:
	case EnemyType::GREEN_SLIME:
	case EnemyType::YELLOW_SLIME:
		// ^[
//		this->getEnemyAttributes( EnemyAttribute::RETURN_AT_EDGE ] = true;
		// _ȕĂ
		this->setEnemyAttribute( EnemyAttribute::RANDOM_FACE_DIRECTION, true );
//		this->getEnemyAttributes( EnemyAttribute::RANDOM_FACE_DIRECTION ] = true;

		if( nType == EnemyType::YELLOW_SLIME ) {
			// ˌ܂ł̊ԊuBF͑˂̂ŁA~߂Ă
			HPLCounter* lpCounter = new HPLCounter((int)(100.f / fLevel ));
			lpCounter->end();
			this->addCounter( lpCounter );
			
			// ŏCÂ
			this->setRecognized( true );

		} else if( nType == EnemyType::GREEN_SLIME ) {
			this->setHoldingEnemy( true );
			
		}
		break;
	case EnemyType::EVI_HIME:
		this->m_nClassType = EnemyClassType::EVIL_HERO;
//		this->setHitRect(38,35,18,58);
		// G
//		this->getEnemyAttributes( EnemyAttribute::INVINSIBLE ] = true;
		break;
	case EnemyType::MUNIERU:
		this->m_nClassType = EnemyClassType::EVIL_HERO;
//		this->setHitRect(38,35,18,58);
		// G
//		this->getEnemyAttributes( EnemyAttribute::INVINSIBLE ] = true;
		break;
	case EnemyType::TANYA:
//		this->m_bIsBlowByShot = false;
//		this->setHitRect(38,35,18,58);
		//ǂz悤Ƃ
//		this->getEnemyAttributes( EnemyAttribute::JUMP_OVER_COLLISION ] = true;
//		setVelocity( HPLMath::nextDouble( 1.f, 3.f * fLevel ) );
//		break;
	case EnemyType::TANYA_YOUJO:
//		this->m_bIsBlowByShot = false;
//		this->setHitRect(38,35,18,58);
		//ǂz悤Ƃ
//		this->getEnemyAttributes( EnemyAttribute::JUMP_OVER_COLLISION ] = true;

		// o㐔t[͖GvC[ɐڐGȂ
		this->invCounter = new HPLCounter( PLAYER_INVINSIBLE_FRAMES );
		this->startInvinsible();
		// speed
		setVelocity( static_cast<float>( HPLMath::nextDouble( 1.f, 3.f * fLevel ) ) );
		break;
	case EnemyType::HIDE_ENEMY_GENERATOR:
		this->setEnemyGenerateCounterRandom();
//		this->setHitToShot( false );
//		this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_SHOT] = false;
		this->setRecognized( true );
		break;
	case EnemyType::MAZER:
		//this->m_nZanzoColor = RGB::BLUE;
		this->m_lpZanzoColor = new HPLColor();
		*this->m_lpZanzoColor = ZANZO_BLUE;
//		this->setHitToPlayer( false );
//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_PLAYER ] = false;
//		this->setGravity( false );
		this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_BLOCK ] = false;
//		this->setHitRect( 12,19,70,38 );
		break;
	case EnemyType::ARYONA:
		{
			int nMapIndex = getStaticData()->getMapIndex();	// map index
	//		this->setHitToPlayer( false );
	//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_PLAYER ] = false;
	//		this->setHitRect(38,35,18,58);
			// G?
			//this->getEnemyAttributes( EnemyAttribute::INVINSIBLE ] = true;
			// counters
			// wait for start
			this->addCounter( new HPLCounter(10 ) );
			// wait for next
			this->addCounter( new HPLCounter( (int)( 50 / fLevel ) ) );

			int SUMMON_COUNTS[][5] = {
				//	pat									
				//	int1	time1	int2	tim2
				{	//AryonaAttackType::Forest::MAX_NUM,
					5,		50,		5,		50},	// forest
				{	//AryonaAttackType::Wind::MAX_NUM,
					1,		100,		30,		50}	// wind
			};

			int nStar = 0;
			if( nMapIndex == SpecialMapIndex::WIND_ARYONA ) {
				nStar = 1;
			}
			for( int i = 0; i < SIZEOF(SUMMON_COUNTS[0]); i ++ ) {
				this->addCounter( new HPLCounter( SUMMON_COUNTS[ nStar][i] ) );
			}
/*			// all attack patterns
			this->addCounter( new HPLCounter(2 ) );
			// summon interval
			this->addCounter( new HPLCounter(5 ) );
			// summon time
			this->addCounter( new HPLCounter(50 ) );
			// summon interval 2
			this->addCounter( new HPLCounter(5 ) );
			// summon time 2
			this->addCounter( new HPLCounter(50 ) );
			HPLError::assertIt( this->m_vecCounters.size() == AryonaCounterType::MAX_NUM );
			*/

			switch( getStaticData()->m_nSelectedStar ) {
			case StageType::FOREST:
			case StageType::WIND:
				// Gł͂Ȃ
				break;
			default:
				// G
				this->setEnemyAttribute( EnemyAttribute::INVINSIBLE, true );
				
			}
			this->m_nSummonPositionType = -1;
		}
		break;
	case EnemyType::TOZICO:
//		this->setHitToPlayer( false );
//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_PLAYER ] = false;
//		this->setHitRect(38,35,18,58);
		// G?
		//this->getEnemyAttributes( EnemyAttribute::INVINSIBLE ] = true;
		break;
	case EnemyType::ELLIN:
		this->m_lpZanzoColor = new HPLColor();
		*this->m_lpZanzoColor = ZANZO_PURPLE;
		//this->m_nZanzoColor = RGB::RED_AND_BLUE;
		break;
	case EnemyType::SLIME_QUEEN:
		{
			this->m_nClassType = EnemyClassType::EVIL_BOSS;
			// ŏCÂ
			this->setRecognized( true );

			// FǗ
			this->m_vecColors.push_back( HPLColor( 255,0,0 ) );	// 
			this->m_vecColors.push_back( HPLColor( 0,0,255 ) );	// 
			this->m_vecColors.push_back( HPLColor( 0,255,0 ) );	// 
			this->m_vecColors.push_back( HPLColor( 255,255,0 ) );	// 

			// ŏ̐F red
			// TODO
			this->m_CurrentColor = this->m_vecColors[0];
			this->setColor(0);

			bool END_WHEN_STARTS[] = {
				false,
				true,
				false,
				false,
				true,
			};
			int WAIT_FRAMES[] = {
				SLIME_QUEEN_WAIT_FOR_START,
				SLIME_QUEEN_WAIT_FOR_NEXT,
				(int)(SLIME_QUEEN_SHOT_INTERVAL / fLevel),
				SLIME_QUEEN_JUMP_NUM,
				SLIME_QUEEN_RED_CREATE_WAIT
			};

			for( int i = 0; i < SIZEOF( WAIT_FRAMES); i ++ ) {
				HPLCounter* lpCounter = new HPLCounter( WAIT_FRAMES[i]);
				if( END_WHEN_STARTS[i]){
					lpCounter->end();
				}
				this->addCounter( lpCounter );
			}
			// JE^e
			// wait for start
			this->addCounter(new HPLCounter(SLIME_QUEEN_WAIT_FOR_START));

			// wait for next
			// UƍŮԂ̑҂V[PXJE^
/*			HPLCounter* lpNext = new HPLCounter(SLIME_QUEEN_WAIT_FOR_NEXT);
			lpNext->end();
			this->addCounter( lpNext);

			// shot interval
			this->addCounter(new HPLCounter() );

			// Wv
			this->addCounter( new HPLCounter( SLIME_QUEEN_JUMP_NUM ) );

			// ԂŕN܂ł̃N[_Et[
			lpNext = new HPLCounter( SLIME_QUEEN_RED_CREATE_WAIT );
			lpNext->end();
			this->addCounter( lpNext );
*/
			// oԊu
			this->m_lpCreateEffectIntervalCounter = new HPLCounter(SLIME_QUEEN_SMOKE_INTERVAL);

			

			// GiΗpj
			GArmManager* lpArmManager = new GArmManager();
			lpArmManager->setup(this);
			this->m_vecArmManagers.push_back( lpArmManager );

			this->setHoldingEnemy( true );
		}
		break;
	case EnemyType::SHIHAN:
		break;
	case EnemyType::ARM:
	case EnemyType::ARM_HEAD:

		if( this->getType() == EnemyType::ARM_HEAD ) {
			this->setHoldingEnemy( true );
			this->m_nClassType = EnemyClassType::ARM_HEAD;
		} else {
			this->m_nClassType = EnemyClassType::ARM;
		}
		break;
	case EnemyType::ARAKHNE:
		{
			this->setHoldingEnemy( true );
			const int SHOT_INTERVAL = 100;
			this->addCounter( new HPLCounter( (int)( SHOT_INTERVAL / fLevel )) );
		}
		break;
	case EnemyType::IVY:
	case EnemyType::IVY_2:
	case EnemyType::ROPER:
		this->setHoldingEnemy( true );
		break;
	case EnemyType::LAMIA:
		this->setHoldingEnemy( true );
		break;
	case EnemyType::SUCCUBUS:
	case EnemyType::SUCCUBUS_MISAGO:
		{
			this->m_lpAmplitude = new HPLCounter( SUCCUBUS_AMPLITUDE_FRAME );
			this->setHoldingEnemy( true );
		}
		break;
	case EnemyType::ZOMBIE:
		this->setHoldingEnemy( true );
		break;	
	case EnemyType::ROCK:					//!㉺xȉɂȂ_[WȂ?
		{

			this->setRecognized( true );
			this->setObjectAttribute( ObjectAttribute::BOUND, true );
			this->setObjectAttribute( ObjectAttribute::NO_RESIST, true );
	//		this->m_aryObjectAttribute[ObjectAttribute::BOUND] = true;
	//		this->m_aryObjectAttribute[ObjectAttribute::NO_RESIST] = true;
			getStaticData()->m_ObjectManager.setupRandomRotate(this);
/*			this->setRotateDegree( HPLMath::nextFloat(0,HPLMathConsts::DEGREE_FULL_ROUND ) );
			this->setFaceDirection( HPLMath::nextInt(0,2) == 0 ? FaceDirection::LEFT : FaceDirection::RIGHT );
			float fRotateDegreeSpeed = (HPLMath::nextInt(0,2) * 2 - 1 ) * 
				HPLMath::nextFloat( ROCK_ROTATE_DEGREE_SPEED_MIN, ROCK_ROTATE_DEGREE_SPEED_MAX ) ;
			this->setRotateDegreeSpeed( fRotateDegreeSpeed );
			this->setDefaultRotateDegreeSpeed( fRotateDegreeSpeed );
			a*/
		}
		break;
/*	case EnemyType::FIRE_PARTICLE:
		this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
		this->setObjectAttribute( ObjectAttribute::HALF_GRAVITY, true );
		this->setWeakness( DamageType::WATER, true );
		this->setWeakness( DamageType::ICE, true );
		this->m_nClassType = EnemyClassType::SHOT;

		// őՓx̂Ƃ̂ݓ蔻L
		if( getStaticData()->m_OptionData.getLevelIndex() <= LevelType::MAX_NUM - 1 ) {
			this->setObjectAttribute( ObjectAttribute::HIT_TO_PLAYER, false );
		}
		break;*/
	case EnemyType::BEE:
		{
			this->m_vecColors.push_back(HPLColor(255,255,255));
			this->m_vecColors.push_back(HPLColor(255,0,0));
			this->m_CurrentColor = this->m_vecColors[0];
			this->setColor(0);

			const int BEE_AMPLITUDE_FRAME = 300;	// w肵F1T
			this->m_lpAmplitude = new HPLCounter( BEE_AMPLITUDE_FRAME / fLevel );
			this->setRecognized( true );
			this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
	//		this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = false;
			this->setHoldingEnemy( true );
			this->addCounter( new HPLCounter( BEE_SHOOT_INTERVAL / fLevel ) );

			const int BEE_SHOT_INTERVAL = (int)(50/ fLevel);	// ˎ̃C^[o
			const int BEE_SHOT_NUM = (int)(3 * fLevel );	//! ˉ
			HPLCounter* lpCounter = new HPLCounter( BEE_SHOT_INTERVAL );
			lpCounter->setLoopNumMax( BEE_SHOT_NUM );
			this->addCounter( lpCounter );
		}
		break;
	case EnemyType::MINI_BEE:
		{
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
			this->setSize(this->getWidth()/2, this->getHeight() / 2 );
		}
		break;
	case EnemyType::BEE_HIVE:
		{
			const int WAIT_FOR_START = (int)( 100 / fLevel );	//! ˂܂ł̎
			this->addCounter( new HPLCounter( WAIT_FOR_START ) );
			const int BEE_SHOT_INTERVAL = (int)(20/ fLevel);	// ˎ̃C^[o
			HPLCounter* lpCounter = new HPLCounter( BEE_SHOT_INTERVAL );
			lpCounter->end();
			this->addCounter( lpCounter );
		}
		break;
	case EnemyType::QBEE:
		{
			const int QBEE_AMPLITUDE_FRAME = 500;	// w肵F1T
			this->m_lpAmplitude = new HPLCounter( (int)( QBEE_AMPLITUDE_FRAME / fLevel ) );

			this->setRecognized( true );
			this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
//			this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = false;

			const int QBEE_SUMMON_INTERVAL = 100;
			this->addCounter( new HPLCounter( (int)(QBEE_SUMMON_INTERVAL / fLevel ) ) );

			const int QBEE_SHOT_INTERVAL = 10;	// ˎ̃C^[o
			const int QBEE_SHOT_NUM = 2;
			HPLCounter* lpCounter = new HPLCounter( QBEE_SHOT_INTERVAL / fLevel );
			lpCounter->setLoopNumMax( QBEE_SHOT_NUM * fLevel );
			this->addCounter( lpCounter );

//			this->m_nClassType = EnemyClassType::;
		}
		break;
	case EnemyType::FLOWER:
		{
			// F^Cvǉ
			this->m_vecColors.push_back( HPLColor( 255,0,0 ) );	// red
			this->m_vecColors.push_back( HPLColor( 0,0,255 ) );	// blue
			this->m_vecColors.push_back( HPLColor( 255,255,0 ) );	//yellow
			this->setColor(0);
			this->m_nClassType = EnemyClassType::ARM_HEAD;

			const int FLOWER_AMPLITUDE_FRAME = 100;
			// 炷
			this->m_lpAmplitude = new HPLCounter( FLOWER_AMPLITUDE_FRAME );

			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
//			this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK] = false;

			this->addCounter( new HPLCounter((int)(100 / fLevel ) ) );
			// ˊԊu
			this->addCounter( new HPLCounter((int)( 10 / fLevel )) );
		}

		break;
	case EnemyType::KUKI:
		this->m_nClassType = EnemyClassType::ARM;
		this->setObjectAttribute(ObjectAttribute::HIT_TO_SHOT,false );
		break;
	case EnemyType::ALRAUNE:
		{
			// create flowers
			const int NUM_OF_ARMS = 3;
			for( int i = 0; i < NUM_OF_ARMS; i ++ ) {
				GArmManager* lpArmManager = new GArmManager();
				lpArmManager->setup(this);
				GEnemy* lpHead = (GEnemy*)lpArmManager->getHead();
				lpHead->setColor(i);
				lpHead->m_CurrentColor = lpHead->m_vecColors[i];
				this->m_vecArmManagers.push_back( lpArmManager );
			}

			// boss setup
			// ŏCÂ
			this->setRecognized( true );

			// JE^e
			// AlrauneCounterType::WAIT_FOR_START
			this->addCounter(new HPLCounter(100));

			// wait for next
			// UƍŮԂ̑҂V[PXJE^
			// AlrauneCounterType::WAIT_FOR_NEXT
			HPLCounter* lpNext = new HPLCounter(50);
			lpNext->end();
			this->addCounter( lpNext);

			//! TENTACLE_COUNT{TENTACLE_SHOT_INTERVALԊuALL_TENTACLE_COUNT񂾂JԂBJԂ̊ԊuWAIT_FOR_NEXT_TENTACLE
			// tentacle̔ˊԊu
			// AlrauneCounterType::TENTACLE_SHOT_INTERVAL
			HPLCounter* lpShotInterval = new HPLCounter((int)(5 / fLevel));
			lpShotInterval->end();
			this->addCounter( lpShotInterval );

			// AlrauneCounterType::TENTACLE_COUNT
			this->addCounter( new HPLCounter(3));
			// AlrauneCounterType::ALL_TENTACLE_COUNT,
			this->addCounter( new HPLCounter((int)(5)));
			// AlrauneCounterType::ATTACK_TERM
			this->addCounter( new HPLCounter((int)(200 / fLevel )));
			// AlrauneCounterType::TENTACLE_WAIT_FRAME,
			HPLCounter* lpWaitF = new HPLCounter((int)(15/fLevel ));
			//lpWaitF->end();
			this->addCounter( lpWaitF );

			this->m_nClassType = EnemyClassType::EVIL_BOSS;
		}
		break;
	case EnemyType::FUUN:
	case EnemyType::RAI:
		{
			GArmManager* lpArmManager = new GArmManager( );
			lpArmManager->setup( this );
			this->m_vecArmManagers.push_back(lpArmManager);

			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
			// 
			int nInterval = 100 / fLevel;
			this->m_lpAmplitude = new HPLCounter(nInterval );

			// _L
			this->m_lprWeakHitRect = new HPLRect(53,39,14,8);

			// sniper_
			this->setWeakness( DamageType::SNIPER, true );

			int COUNTER_FRAMES[] = {
				100,		//! turn interval
				100,			//! keep moving term
			};
			bool FIRST_STOPS[] = {
				false,
				true		//! stop moving first
			};

			for( int i = 0; i < SIZEOF(COUNTER_FRAMES); i ++ ) {
				HPLCounter* lpCounter = new HPLCounter( COUNTER_FRAMES[i] );
				this->addCounter( lpCounter );
				if( FIRST_STOPS[i] ) {
					lpCounter->end();
				}
			}


		}
		break;
	case EnemyType::WIND_BIT:
	case EnemyType::ELEC_BIT:
		this->m_nClassType = EnemyClassType::ARM;

		this->addCounter( new HPLCounter( 100 / fLevel ) );
		break;
	case EnemyType::EVIL_GATE:
		// ɕ\
		this->m_bIsDrawBack = true;
		break;
	case EnemyType::GHOST:
		{
			this->setRecognized(true);
			const int GHOST_SHOT_INTERVAL = 50;
			HPLCounter* lpCounter = new HPLCounter( GHOST_SHOT_INTERVAL / fLevel );
			this->addCounter( lpCounter );
			this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
			this->setWeakness( DamageType::FIRE, true );
			
		}
		break;
	case EnemyType::MERAKO:
		{
			this->m_nClassType = EnemyClassType::EVIL_BOSS;
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
			this->setRecognized(true);
			// WAIT_FOR_START,
			this->addCounter( new HPLCounter(100 / fLevel ) );
			// WAIT_FOR_NEXT,
			HPLCounter* lpCounter = new HPLCounter( 30 / fLevel );
			lpCounter->end();
			this->addCounter( lpCounter );
			// MOVE_COUNT,		//! ʒuւ
			this->addCounter( new HPLCounter(MERAKO_MOVE_COUNT) );
			// SHOT_INTERVAL,
			this->addCounter( new HPLCounter( 10 / fLevel ) );

			// ATTACK_TERM,		//! U
			int nAttackInterval = 200 / fLevel ;
			this->addCounter( new HPLCounter( nAttackInterval) );
			// MOVE_INTERVAL
			int nInterval = nAttackInterval / MERAKO_MOVE_COUNT;
			this->addCounter( new HPLCounter( nInterval ) );
			// LAVA_COUNT
			int nLavaCount = 10 * fLevel;
			this->addCounter( new HPLCounter( nLavaCount ) );
			// LAVA_INTERVAL
			int nLavaInterval = nAttackInterval / nLavaCount;
			this->addCounter( new HPLCounter( nLavaInterval ) );

			// rotate deg
			this->setRotateDegree( 0 );
			const float MERAKO_ROTATE_DEGREE_SPEED = 5 * fLevel;
			this->setRotateDegreeSpeed( MERAKO_ROTATE_DEGREE_SPEED );
		}
		break;
	case EnemyType::WORM:
		{
			this->setHoldingEnemy( true );

			// uƊۓۂݏԕω
			const int FRAMES_FOR_NEXT_HOLD_TYPE = 100;
			this->addCounter( new HPLCounter( FRAMES_FOR_NEXT_HOLD_TYPE ) );
		}
		
		break;
	case EnemyType::MEDOUSA:
		{
			//this->setHoldingEnemy( false );	̍ÛݍSn
			const int AMPLITUDE_COUNT = 100;
			this->m_lpAmplitude = new HPLCounter(AMPLITUDE_COUNT);

			// SNAKE_COUNT,			//! wro񐔂
			this->addCounter( new HPLCounter( 4 * fLevel ) );
			
			// SNAKE_SHOT_INTERVAL,	//! ւтoԊu
			this->addCounter( new HPLCounter( 50 / fLevel ) );
			
			// WAIT_FOR_NEXT,			//! ܂ł̃EGCg
			this->addCounter( new HPLCounter( 100 / fLevel ) );
			
			// CHARGE,					//! Ή`[W
			this->addCounter( new HPLCounter( 50 / fLevel ) );
		}
		break;
	case EnemyType::FROG:
		break;
	case EnemyType::FIRE_ELEMENTAL:
		{
			// term for wait
			this->addCounter( new HPLCounter( 50 / fLevel ) );
			// term for attacking
			this->addCounter( new HPLCounter( 100 * fLevel ) );
		}
		break;
	case EnemyType::ROBOT:
		{
			//WAIT_FOR_NEXT,
			this->addCounter( new HPLCounter( 100 / fLevel ) );
			//BEAM_SHOT_COUNT,
			this->addCounter( new HPLCounter( 3 * fLevel ) );
			//BEAM_SHOT_INTERVAL,
			//this->addCounter( new HPLCounter( 50 / fLevel ) );
			//MISSILE_SHOT_COUNT,
			this->addCounter( new HPLCounter( 10 * fLevel ) );
			//MISSILE_SHOT_INTERVAL,
			//this->addCounter( new HPLCounter( 25 / fLevel ) );
		}
		break;
	case EnemyType::GOKI:
		// X
		this->addCounter( new HPLCounter(HPLMath::nextInt(50,100) ));
		break;
	case EnemyType::PIRANHA:
		this->setHoldingEnemy(true);
		break;
	case EnemyType::JET_PORT:
		break;
	case EnemyType::CYCLON:
		break;
	case EnemyType::ISO:
		// C\M`N
		// ʂ߂̂
		this->setHolding( true );
		break;
	case EnemyType::SHARK:
		this->setHolding( true );
		break;
	case EnemyType::UNI:
		break;
	case EnemyType::DIRTY_CLOUD:
		{
			int WAIT_FRAME_NUMS[] = {
				50,	// wait for start
				50,	// wait for next
				40,	// drop	interval
				5,	//		count
				50,	// wind	interval
				5,	//		count

			};
			for( int i = 0; i < SIZEOF(WAIT_FRAME_NUMS); i ++ ) {
				// add counter
				this->addCounter( new HPLCounter( (int)(WAIT_FRAME_NUMS[i] / fLevel) ) );
			}
			this->getCounter( DirtyCloudCounterType::WAIT_FOR_NEXT )->end();
		}
		break;
	case EnemyType::FAN_BIRD:
		{
			this->m_fBrustMaxSpeed = MAX_BRUST_ACCEL_X * 1.0f;
			this->m_nBrustType = BrustType::REPULSE_X;
			m_rBrustRect.set(-300,-50,250,this->getHeight() + 50 );
			
			const int FAN_BIRD_AMPLITUDE_FRAME = 400;
			this->m_lpAmplitude = new HPLCounter( FAN_BIRD_AMPLITUDE_FRAME );

			this->m_lprWeakHitRect = new HPLRect(28,56,12,20);
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
		}
		break;
	case EnemyType::JEALOUS_GHOST:
		break;
	case EnemyType::SORROW_CLOUDS:
		{
			const int FAN_BIRD_AMPLITUDE_FRAME = 800;
			this->m_lpAmplitude = new HPLCounter( FAN_BIRD_AMPLITUDE_FRAME );
		}
		break;
	case EnemyType::SHABONER:
		{
			// ubNɃqbgȂ
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );

			// ˊԊu
			HPLCounter* lpWaitCounter = new HPLCounter( 20 / fLevel );
			// ŏ甭
			lpWaitCounter->end();
			this->addCounter( lpWaitCounter );

			// ˎ
			HPLCounter* lpShotCounter = new HPLCounter( 100 * fLevel );
			this->addCounter( lpShotCounter );
			this->setRotateDegreeSpeed( 1 );
			this->setRotateDegree(HPLMath::nextInt(0,(int)HPLMathConsts::DEGREE_FULL_ROUND));

		}
		break;
//	case EnemyType::SHABON:
//		// d1/2
//		this->setObjectAttribute( ObjectAttribute::HALF_GRAVITY, true );
//		this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
//		break;
	case EnemyType::JACKPOT:
		{
			this->setImmunity( DamageType::ICE, true );
		}
		break;
	case EnemyType::CHASER:
		{
			// ŏ~Ă邩ǂ
			bool IS_STOP_ON_STARTS[] = {
				false,
				true,
				false,
				false,
				false,
				false,
				false,
				false,
				false,
				false,
				false,
			};
			// [v邩ǂ
			bool IS_LOOPS[] = {
				false,
				false,
				false,
				false,
				false,
				false,
				false,
				false,
				false,
				false,
				false,
			};
			// JEg
			int WAIT_FRAME_NUMS[] = {
				50,				// wait for start
				100 / fLevel,		// wait for next
				5 * fLevel,			// shot counter
				30 / fLevel,		// shot interval
				100 * fLevel,		// attack term
				300,				// born term
				5,					// born cloud create interval
				8 * fLevel,		// thunder shot counter
				1,					// particle create interval
				2,					// cloud create interval
				100 * fLevel,// chasing timer
			};
			// map index
			int nMapIndex = getStaticData()->getMapIndex();
			if( nMapIndex == SpecialMapIndex::WIND_BOSS_1 ) {	// boss1
				this->changeState( StateType::BORN );
				IS_STOP_ON_STARTS[0] = true;
			}
			for( int i = 0; i < ChaserCounterType::MAX_NUM; i ++ ) {
				// create counter
				HPLCounter* lpCounter = new HPLCounter( WAIT_FRAME_NUMS[i] );
				if( IS_STOP_ON_STARTS[i] ) {	// stop on start
					lpCounter->end();
				}
				lpCounter->setLoop(IS_LOOPS[i]);
				this->addCounter( lpCounter );
			}
			this->m_nClassType = EnemyClassType::EVIL_BOSS;
			this->setRotateDegree( 270);

			const int CHASER_AMPLITUDE_FRAME = 200;
			this->m_lpAmplitude = new HPLCounter( CHASER_AMPLITUDE_FRAME );
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
		}
		break;
	case EnemyType::CONDOR:
		{
			const int CONDOR_AMPLITUDE_FRAME = 100;
			this->m_lpAmplitude = new HPLCounter( CONDOR_AMPLITUDE_FRAME );
		}
		break;
	case EnemyType::LAVA:
	case EnemyType::LAVA_UNDER:
		{
			HPLImageInformation* lpImage = getStaticData()->getSequence( SpriteType::LAVA_UNDER, 0 )->getImageInformation(0);

			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
			this->setObjectAttribute( ObjectAttribute::HIT_TO_NEUTRAL, false );
			//this->setObjectAttribute( ObjectAttribute::HIT_TO_ENEMY, true );

			HPLCounter* lpCounter = new HPLCounter( lpImage->srcRect.getHeight() / LAVA_UP_SPEED );
			this->addCounter( lpCounter );

			this->setRecognized(true);
		}
		break;
	case EnemyType::LAVA_ELEMENTAL_MONSTER:
	case EnemyType::ICE_ELEMENTAL_MONSTER:
		{
			switch( nType ) {
				case EnemyType::LAVA_ELEMENTAL_MONSTER:
				{
					this->m_vecColors.push_back(HPLColor(255,0,0));
				}
				break;
			case EnemyType::ICE_ELEMENTAL_MONSTER:
				{
					this->m_vecColors.push_back(HPLColor(0,0,255));
				}
				break;
			}
			int FRAMES[] = {
				100,	// wait for start
				100,	// wait for next
			};
		}
		break;
	case EnemyType::LAVA_ELEMENCO:
	case EnemyType::ICE_ELEMENCO:
		{
			switch( nType ) {
			case EnemyType::LAVA_ELEMENCO:
				{
					this->m_vecColors.push_back(HPLColor(255,0,0));
				}
				break;
			case EnemyType::ICE_ELEMENCO:
				{
					this->m_vecColors.push_back(HPLColor(0,0,255));
				}
				break;
			}
		}
		break;
	case EnemyType::ICICLE:
		break;
	case EnemyType::GHOST_PAIR:
		{
			// ArmƂēo^

		}
		break;
	case EnemyType::LAVA_BALL:
		{
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );

//			this->m_Weakness.set( DamageType::WATER, true );
//			this->m_Weakness.set( DamageType::ICE, true );
			// 
//			this->m_Immunities.set( DamageType::FIRE, true );	

//			this->m_nContrailObjectType = ObjectType::SHOT;
//			this->m_nContrailType = Sequence::Shot::FIRE_PARTICLE;

			const int LAVA_PARTICLE_INTERVAL = 3;
			this->addCounter( new HPLCounter( LAVA_PARTICLE_INTERVAL ) );
		}
		break;
	case EnemyType::AIKO:
		break;
	default:
		LOG_WARN(HPLString::chrToStr( "Unexpected Enemy[%d]", nType ).c_str());
		break;
	}

	if( this->getEnemyAttribute( EnemyAttribute::RANDOM_FACE_DIRECTION ) ) {	// _ȕĂ
		this->setFaceDirection( HPLMath::nextInt(0,2) == 0 ? FaceDirection::LEFT : FaceDirection::RIGHT );
	}

	if( this->getSprite() != NULL && !this->m_bIsBlowByShot && this->getSprite()->getSequence(this->getSequenceIDByStateType(StateType::DAMAGE), FaceDirection::LEFT)->getLoopNumMax() <= 0 ) {
		// damage stateɂ郋[v0-1̏ꍇ

		// _[WJE^ݒ肷
		this->m_DamageCounter.setWaitFrameNum( 50 );
	}

	// amp^Cv͏l_ɂ
	if( this->m_lpAmplitude != NULL ){
		this->m_lpAmplitude->setStepCounter( HPLMath::nextInt(0,this->m_lpAmplitude->getWaitFrameNum() ) );
	}

	if( this->m_nClassType == EnemyClassType::EVIL_BOSS ) {	// boss
		// force recognize
		this->setRecognized( true );
	}
}
bool GEnemy::isHasDamageState() {
	// SuperArmorAʂɃ_[WԂɂȂ
	return this->m_bIsBlowByShot ||
		this->getType() == EnemyType::FLOWER;
}
void GEnemy::clearArmManagers() {
	for( vector<GArmManager*>::iterator it = m_vecArmManagers.begin();
		it != m_vecArmManagers.end(); it ++ )
	{
		delete *it;
	}
	this->m_vecArmManagers.clear();
}

GEnemy::~GEnemy() {

	// _
	HPLPointerTool::HPLFree<HPLRect>( this->m_lprWeakHitRect );
	HPLPointerTool::HPLFree<HPLCounter>( this->m_lpAmplitude );
	HPLPointerTool::HPLFree<HPLAttackInformation>( this->m_lpAttackInformation );
	HPLPointerTool::HPLFree<HPLColor>( this->m_lpZanzoColor );
	
	
	// arms
	this->clearArmManagers();

	// GtFNg Contrail
	HPLPointerTool::HPLFree<HPLCounter>( this->m_lpCreateEffectIntervalCounter );

	// JE^[폜
	for( vector<HPLCounter*>::iterator it = this->m_vecCounters.begin();
		it != this->m_vecCounters.end();
		it ++ ) 
	{
		delete *it;

	}
	this->m_vecCounters.clear();
}

float GEnemy::getBlow() {
	float fBlowSpeed = this->m_fBlow;
	switch( this->getType() ) {
	case EnemyType::SLIME_QUEEN:
		if( this->getState()->isFlyingState() || 
			this->getState()->getState() == StateType::WALK )
		{
			// ΂Xs[hAbv
			fBlowSpeed *= SLIME_QUEEN_FLYING_DAMAGE_RAGE;
		}
	}
	return fBlowSpeed;
}


HPLSequence* GEnemy::getSequence(){
	if( this->getSprite() ) {
		int seqID = this->getSequenceID();
		HPLSequence* seq = 
			this->getSprite()->getPair(seqID)->left;
		return seq;
	} else {
		
		return NULL;

	}

}

namespace SequenceFlagType {
	enum {
		WALK,
		DEAD,
		FLYDOWN,
		FLYUP,
		READY_TO_JUMP,
		ATTACK,
		ATTACK_2,
		ATTACK_3,
		ATTACK_4,
		HOLD,
		CROUCH,
		MAX_NUM
	};
}
static const int SEQUENCE_ID_MAPPINGS[] = {
	StateType::WALK,
	StateType::DEAD,
	StateType::FLYDOWN,
	StateType::FLYUP,
	StateType::READY_TO_JUMP,
	StateType::ATTACK,
	StateType::ATTACK_2,
	StateType::ATTACK_3,
	StateType::ATTACK_4,
	StateType::HOLD,
	StateType::CROUCH,
	-1
};
int GEnemy::getSequenceIDByStateType( int st ) {
	int id = StateType::STAND;

	int t = this->getType();


	int nIDSets[SequenceFlagType::MAX_NUM];
	memset( nIDSets, 0, sizeof( nIDSets ) );

	switch( t ) {
	case EnemyType::NAMAKO:
	case EnemyType::SLIME:
	case EnemyType::SLIME_BABY:
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::DEAD] = 2;
		break;
	case EnemyType::BLUE_SLIME:
	case EnemyType::BLUE_SLIME_BABY:
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::DEAD] = 2;
		break;
	case EnemyType::GREEN_SLIME:
	case EnemyType::GREEN_SLIME_BABY:
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::DEAD] = 2;
		nIDSets[SequenceFlagType::READY_TO_JUMP] = 3;
		nIDSets[SequenceFlagType::FLYDOWN] = 4;
		nIDSets[SequenceFlagType::HOLD] = 5;
		break;
	case EnemyType::YELLOW_SLIME:
	case EnemyType::YELLOW_SLIME_BABY:
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::DEAD] = 2;
		nIDSets[SequenceFlagType::ATTACK] = 3;
		nIDSets[SequenceFlagType::ATTACK_2] = 4;
		break;
	case EnemyType::TANYA:
	case EnemyType::TANYA_YOUJO:
		id = getStaticData()->getEvigenSequenceID( this );
		break;
	case EnemyType::ARYONA:
		switch( st ) {
		case StateType::WALK:	return 1;
		case StateType::ATTACK:	return 2;
		}
		break;
	case EnemyType::TOZICO:
		nIDSets[SequenceFlagType::FLYDOWN] = 1;
		nIDSets[SequenceFlagType::FLYUP] = 1;
		break;
	case EnemyType::ELLIN:
		id = getStaticData()->getEvigenSequenceID( this );
		break;
	case EnemyType::SLIME_QUEEN:
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::FLYDOWN] = 3;			//
		nIDSets[SequenceFlagType::FLYUP] = 2;			// 
		nIDSets[SequenceFlagType::ATTACK] = 6;			// Ĝ΂
		nIDSets[SequenceFlagType::ATTACK_2] = 5;		// XC΂
		nIDSets[SequenceFlagType::READY_TO_JUMP] = 4;	// Ready to jump
		nIDSets[SequenceFlagType::HOLD] = 7;			// HOLD
		nIDSets[SequenceFlagType::DEAD] = 8;			// DEAD
//		nIDSets[SequenceFlagType::CROUCH] = 4;			// Ready to jump
		break;
	case EnemyType::ARM_HEAD:
	case EnemyType::FLOWER:
		if( st == StateType::ATTACK ) {
			return 2;
		}
		return 1;
	case EnemyType::ARAKHNE:
		switch( st ) {
		case StateType::HOLD_DOWN:
			return 2;
		}
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::HOLD] = 3;
		break;
	case EnemyType::SUCCUBUS:
	case EnemyType::SUCCUBUS_MISAGO:
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::HOLD] = 2;
		break;
	case EnemyType::IVY:
	case EnemyType::ROPER:
		nIDSets[SequenceFlagType::HOLD] = 1;
		break;
	case EnemyType::IVY_2:
		switch( st ) {
		case StateType::HOLD:
			return 2;
			break;
		}
		break;
	case EnemyType::LAMIA:
		nIDSets[SequenceFlagType::WALK] = 1;
		nIDSets[SequenceFlagType::HOLD] = 2;
		nIDSets[SequenceFlagType::DEAD] = 3;
		break;
	case EnemyType::ZOMBIE:
		switch( st ) {
		case StateType::HOLD:
			return 1;
		case StateType::ATTACK:
			return 2;
		case StateType::DASH:
			return 4;
		case StateType::FLYDOWN:
			return 5;
		}
//		nIDSets[SequenceFlagType::WALK] = 1;
//		nIDSets[SequenceFlagType::HOLD] = 2;
//		nIDSets[SequenceFlagType::ATTACK] = 3;
		break;
	case EnemyType::BEE:
		switch( st ) {
		case StateType::HOLD:
			return 1;
		case StateType::HOLD_DOWN:
			return 2;
		case StateType::HOLD_AIR:
			return 3;
		}
		break;
	case EnemyType::QBEE:
		switch( st ) {
		case StateType::ATTACK:
			return 1;
		}

		break;
	case EnemyType::ALRAUNE:
		switch( st ) {
		case StateType::ATTACK:
			if( this->getBerserkLevel() > 0 ) {
				// berserk
				return Sequence::Alraune::ATTACK_DAMAGED_1;
			} else {
				return Sequence::Alraune::ATTACK;
			}
		case StateType::DEAD:
			return Sequence::Alraune::DEAD_1;
		default:
			if( this->getBerserkLevel() > 0 ) {
				// berserk
				return Sequence::Alraune::DAMAGED_1;
			}
		}
		break;
	case EnemyType::WIND_BIT:
	case EnemyType::ELEC_BIT:
		return id;
	case EnemyType::FUUN:
	case EnemyType::RAI:
		if( this->isRecognized() ) {
			switch( st ) {
			case StateType::STAND:
				return 1;
			default:
				return 1;
			}
		} else {
			return 0;
		}
	case EnemyType::MERAKO:
		{
			switch( st ) {
			case StateType::WALK:
				return Sequence::Merako::WALK;
			case StateType::DASH:
				return Sequence::Merako::WALK;
			case StateType::FLYDOWN:
				return Sequence::Merako::FLYDOWN;
			case StateType::ATTACK:
				return Sequence::Merako::ATTACK_SHOT;
			case StateType::ATTACK_2:	// Explosion
				return Sequence::Merako::ATTACK_EXPLOSION;
			default:
#ifdef _DEBUG
				//HPLError::assertIt(false);
#endif
				break;
			}
		}
		break;
	case EnemyType::WORM:
		switch( st ) {
		case StateType::WALK:
			return 1;
		case StateType::HOLD_DOWN:
			switch( this->getHoldType() ) {
			case 0:
				// H
				return 2;
			case 1:
				// ۓۂ
				return 3;
			default:
			//	HPLError::assertIt(false);
				break;
			}
			break;
		default:
			//HPLError::assertIt(false);
			break;
		}
		break;
	case EnemyType::MEDOUSA:
		switch( st ) {
		case StateType::WALK:
			return Sequence::Medousa::WALK;
		case StateType::ATTACK:
			return Sequence::Medousa::ATTACK;
		default:
#ifdef _DEBUG
		//	HPLError::assertIt(false);
#endif
			break;
		}
		break;
	case EnemyType::FIRE_ELEMENTAL:
		break;
	case EnemyType::FROG:
		switch( st ) {
		case StateType::WALK:	return 1;
		case StateType::FLYDOWN:	return 2;
		}
		break;
	case EnemyType::ROBOT:
		switch( st ) {
		case StateType::WALK:	return Sequence::Robot::WALK;
		case StateType::READY_TO_JUMP:	return Sequence::Robot::READY_TO_JUMP;
		case StateType::FLYDOWN:	return Sequence::Robot::FLYDOWN;
		case StateType::READY:	return Sequence::Robot::LAND;
		case StateType::ATTACK_GUN:	return Sequence::Robot::BEAM;
		case StateType::ATTACK_GUN_2:	return Sequence::Robot::MISSILE;
		}
		break;
	case EnemyType::GOKI:
		switch( st ) {
		case StateType::WALK:	return 1;
		case StateType::FLYDOWN:	return 1;
		}
		break;
	case EnemyType::PIRANHA:
		if( StateType::HOLD == st ) {	return 1;	}
		break;
	case EnemyType::JET_PORT:
		if( StateType::ATTACK == st ) {	return 1;	}
		break;
	case EnemyType::CYCLON:
		break;
	case EnemyType::ISO:
		switch( st ) {
		case StateType::ATTACK:		return 1;
		case StateType::HOLD:		return 2;
		}
		break;
	case EnemyType::SHARK:
		switch( st ) {
		case StateType::WALK:
		case StateType::ATTACK:
		case StateType::ATTACK_2:
			return 1;
		}
		break;
	case EnemyType::UNI:
		break;
	case EnemyType::DIRTY_CLOUD:
		switch( st ) {
		case StateType::ATTACK:
			return 1;
		}
		return 0;
		break;
	case EnemyType::FAN_BIRD:
	case EnemyType::JEALOUS_GHOST:
		break;
	case EnemyType::SORROW_CLOUDS:
		switch( st ) {
		case StateType::DYING:
			return 1;
		}
		return 0;
		break;
	case EnemyType::SHABONER:
		break;
	case EnemyType::JACKPOT:
		switch( st ) {
		case StateType::DAMAGE:
			return 1;
		case StateType::DEAD:
			return 2;
		}
		return 0;
	case EnemyType::CHASER:
		switch( st ) {
		case StateType::BORN:
			return Sequence::Chaser::BORN;
		case StateType::ATTACK:
			return Sequence::Chaser::ATTACK_1;
		case StateType::ATTACK_2:
			return Sequence::Chaser::ATTACK_2;
		case StateType::READY:
			return Sequence::Chaser::READY_TO_WALK;
		}
		if( this->getState()->isDeadState() ) {
			return Sequence::Chaser::DEAD;
		}
		return 0;
	case EnemyType::GHOST:
		switch( st ) {
		case StateType::ATTACK:
			return Sequence::GhostPair::ATTACK;
		case StateType::ATTACK_2:
			return Sequence::GhostPair::ATTACK_2;
		}
		return Sequence::GhostPair::STAND;
	case EnemyType::AIKO:
		switch( st ) {
		case StateType::ATTACK:
			return Sequence::Aiko::ATTACK;
		case StateType::ATTACK_2:
			return Sequence::Aiko::ATTACK_2;
		case StateType::FLYDOWN:
			return Sequence::Aiko::FLYDOWN;
		}
		return 0;
	case EnemyType::GHOST_PAIR:
		switch( st ) {
	case StateType::ATTACK:
		return Sequence::GhostPair::ATTACK;
		case State
		}
		return 0;
	case EnemyType::GHOST_PAIR_SHIELD:
		return 0;
	default:
		// id = STANDŒ
		return id;
	//	break;
	}
	
	for( unsigned int i = 0; i < SequenceFlagType::MAX_NUM; i ++ ) {
		if( nIDSets[i] > 0 && st == SEQUENCE_ID_MAPPINGS[i]) {
			// lݒ肳ĂB
			// ԂvB
			id = nIDSets[i];
			break;
		}
	}
	return id;
}

int GEnemy::getSequenceID() {
	return this->getSequenceIDByStateType( this->getState()->getState() );
}

void GEnemy::changeState( int nState ) {
	int nCurrentState = this->getState()->getState();
	
	if( nCurrentState != nState ) { 
		// Aj[VZbg
		this->getSequence()->resetCounter();
	}
	this->setState( nState );

	HPLRect rNewHitRect = this->getHitRect();
	HPLVector vOldSize = HPLVector(this->getWidth(), this->getHeight());
	HPLVector vNewSize = vOldSize;

	switch( this->getType() ) {
	case EnemyType::MERAKO:
		{
			const HPLRect NORMAL_HIT_RECT(40,22,20,74);
			const HPLRect DASH_HIT_RECT(16,12,100,104);
			if( StateType::DASH == nState ) {
				// _bV
				// 蔻ΉƓɂ
				rNewHitRect = ( DASH_HIT_RECT );
			} else {
				// _bVȊO
				// -> 蔻ɖ߂
				rNewHitRect = ( NORMAL_HIT_RECT );
			}
		}
		break;
	case EnemyType::ROBOT:
		{
			switch( nState ) {
			case StateType::STAND:
			case StateType::READY_TO_JUMP:
			case StateType::FLYDOWN:
			case StateType::READY:
				{
					rNewHitRect.set(8,2,48,124);
					vNewSize.set(65,126);
				}
				break;
			case StateType::WALK:
				{
					rNewHitRect.set(12,29,66,94);
					vNewSize.set(88,128);
				}
				break;
			case StateType::ATTACK_GUN:	// beam
				rNewHitRect.set(7,7,38,70);
				vNewSize.set(65,80);
				break;
			case StateType::ATTACK_GUN_2:
				rNewHitRect.set(8,1,154,110);
				vNewSize.set(72,115);
				break;
			}
		}
		break;
	case EnemyType::GOKI:
		switch( nState ) {
		case StateType::STAND:
			rNewHitRect.set(27,1,32,18);
			vNewSize.set(84,21);
		case StateType::FLYDOWN:
			rNewHitRect.set(26,36,38,22);
			vNewSize.set(77,70 );
			break;
		}
		break;
	}

	if( HPLRect::equals( rNewHitRect, this->getHitRect(), true ) == false ||
		HPLVector::equals( vNewSize, vOldSize, true ) == false )
	{
		this->setSize( vNewSize );
		HPLActionMoveTool::changeHitRect( this, rNewHitRect );
	}
}

void GEnemy::draw()
{
	if( this->getSprite() == NULL ) {
		return;
	}

	int t = this->getType();

	// XN[
	HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(0);

	// V[PXɕϊ
	HPLSequence* seq = this->getSequence();
	
	float fScrollX = scroller->getVirtualRect().getX();
	float fScrollY = scroller->getVirtualRect().getY();

	int st = this->getState()->getState();

	float fCenterX = this->getCenter().getX() + fScrollX;
	float fCenterY = this->getCenter().getY() + fScrollY;
	float fZoom = scroller->m_fZoomRate;

	fCenterX *= fZoom;
	fCenterY *= fZoom;
	
	float fRotateDegree = 0;
	switch( this->getType() ) {
	case EnemyType::ROCK:
	case EnemyType::SHABONER:
		fRotateDegree = this->getRotateDegree();
		break;
	}
	int alpha = 255;
	if(this->isInvinsible()  && seq->getStepCounter() % 2 == 0){
		// G͓_ł
		alpha = INVINSIBLE_ALPHA;
	} else if( st == StateType::HOLD ) {
		switch( this->getType() ) {
		case EnemyType::GREEN_SLIME:
		case EnemyType::SLIME_QUEEN:
			alpha = 180;
			break;
		}
	}
	if( alpha < 0 ) {
		alpha = 0;
	} else if( alpha > 255 ) {
		alpha = 255;
	}


	switch( this->getType() ) {
	case EnemyType::SLIME_BABY:
	case EnemyType::BLUE_SLIME_BABY:
	case EnemyType::GREEN_SLIME_BABY:
	case EnemyType::YELLOW_SLIME_BABY:
		fZoom = 0.5f;
		break;
	case EnemyType::MINI_BEE:
		fZoom = 0.5f;
		break;
	}

	// 蔻\
	if( getStaticData()->m_Game.isCheat() && getStaticData()->getInputManager()->isPressed( KeyMap::F ) ){
		float fAreaLeft = this->getArea().getX() + fScrollX;
		float fAreaTop = this->getArea().getY() + fScrollY;

		HPLRect rHitRect = this->getHitRect();
		DrawFillBox(
			static_cast<int>( fAreaLeft + rHitRect.getX() ),
			static_cast<int>( fAreaTop + rHitRect.getY() ),
			static_cast<int>( fAreaLeft + rHitRect.getX() + rHitRect.getWidth() ),
			static_cast<int>( fAreaTop + rHitRect.getY() + rHitRect.getHeight() ),
			GetColor(255,0,0) );

		// brust area
		if( this->getBrustType() != BrustType::NONE ) {
			HPLRect rBrustArea = this->getBrustArea();
			DrawFillBox(
				rBrustArea.getX() + fScrollX,
				rBrustArea.getY() + fScrollY,
				rBrustArea.getRight() + fScrollX,
				rBrustArea.getBottom() + fScrollY,
				GetColor(0,100,100));
		}
	}

	int nFaceDirection = this->getFaceDirection();

	bool bIsColored = false;
	int nR = 255, nG = 255, nB = 255;

	// Aj[V邩ǂ
	bool bIsAnimation = true;
	if( getStaticData()->m_Game.isTheWorld() ||
		this->m_SolidData.getType() != SolidType::NONE )
	{
		// the world 
		// or ł߂Ă
		// ->Aj[VȂ
		bIsAnimation = false;
	}

	// \
	bool bIsSpecialDraw = false;
	
	// ޕʓ\/둤\
	switch( this->getType() ) {
	case EnemyType::SLIME_QUEEN:
		{

			if( this->m_nPreviousColor != this->getColor() ) {
				
				// J[ύX
				float fRate = (float)this->getCounter(SlimeQueenCounterType::WAIT_FOR_NEXT)->getStepCounter() / this->getCounter(SlimeQueenCounterType::WAIT_FOR_NEXT)->getWaitFrameNum();
				this->m_CurrentColor = HPLColor::getInnerPointColor(
					this->m_vecColors[this->m_nPreviousColor], this->m_vecColors[this->getColor()] ,
					fRate);

				if( this->getCounter(SlimeQueenCounterType::WAIT_FOR_NEXT)->getState().isFinishAnimation ) {
					// ~
					// ÕJ[̃J[ɕύX
					this->m_nPreviousColor = this->getColor();
				}
			}
			bIsColored = true;
			nR = this->m_CurrentColor.r;
			nG = this->m_CurrentColor.g;
			nB = this->m_CurrentColor.b;
		}
		break;
	case EnemyType::BEE:
	case EnemyType::FLOWER:
		{
			bIsColored = true;
			nR = this->m_CurrentColor.r;
			nG = this->m_CurrentColor.g;
			nB = this->m_CurrentColor.b;
		}
		break;
	case EnemyType::KUKI:
		{
			// Ԑڕ\
			getStaticData()->m_Basic.m_Graphics.draw(
				fCenterX, fCenterY, 
				getStaticData()->getSequence( SpriteType::FLOWER, 3 ),
				FaceDirection::LEFT, 0, fZoom, 255 );

			fRotateDegree = this->m_fDrawRotate + 180;
				/* this->getFaceDirection() *
				this->getRotateDegree();*/
			/*HPLVector vDeg;
			vDeg.setByDegree( fRotateDegree );
			//vDeg.setX( vDeg.getX() * this->getFaceDirection() );
			vDeg.multiple(-1);
			fRotateDegree = vDeg.getDegree(); */

			HPLVector v;
			v.setByDegree( fRotateDegree );
			v.multiple( this->getHitRect().getWidth() / 2 );
			fCenterX += v.getX() * fZoom;
			fCenterY += v.getY() * fZoom;

			// \͍E]
			//v.setX( v.getX() * this->getFaceDirection() );
			//fRotateDegree = v.getDegree();

			nFaceDirection = FaceDirection::LEFT;
		}
		break;
	case EnemyType::ALRAUNE:
		{
			// ̒ӁEs\

			int SEQS[] = {
				Sequence::Alraune::STAND_3,
				Sequence::Alraune::STAND_2
			};
			if( this->getBerserkLevel() > 0 ) {
				SEQS[0] = Sequence::Alraune::DAMAGED_3;
				SEQS[1] = Sequence::Alraune::DAMAGED_2;
			}
			if( this->getState()->isDeadState() ) {
				SEQS[0] = Sequence::Alraune::DEAD_2;
				SEQS[1] = Sequence::Alraune::DEAD_3;
			}

			for( int i = 0; i < SIZEOF(SEQS); i ++ ) {
				HPLSequence* lpBackSeq = this->getSprite()->getSequence( SEQS[i], FaceDirection::LEFT );
				getStaticData()->m_Basic.m_Graphics.draw(
					(int)fCenterX, (int)fCenterY,
					lpBackSeq,
					this->getFaceDirection(), fRotateDegree, fZoom, alpha, alpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND );

				lpBackSeq->step();
			}

		}
		break;
	case EnemyType::LAVA_BALL:
		{
			fRotateDegree = this->getVelocityAngle().getDegree() + 180;
		}
		break;
/*	case EnemyType::FIRE_PARTICLE:
		{
			alpha = (int)(255.f * (1.f - seq->getLoopNum() /(float)seq->getLoopNumMax() ));
		}
		break;*/
	case EnemyType::SUN:
		{
			this->setObjectAttribute( ObjectAttribute::HIT_TO_ENEMY, true );
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
			const float SUN_ROTATE_DEG_SPEED = -10;
			float fDeg = this->getRotateDegree() + SUN_ROTATE_DEG_SPEED;
			HPLSequence* lpWingSeq = this->getSprite()->getSequence(
				1, FaceDirection::LEFT );
			getStaticData()->m_Basic.m_Graphics.draw(
				fCenterX, fCenterY, lpWingSeq, this->getFaceDirection(),
				fDeg, fZoom );
			this->setRotateDegree(fDeg );
		}
		break;
	case EnemyType::CHASER:
		{
			switch( st ) {
			case StateType::BORN:	// born
				{
					//
					fZoom = this->getCounter( ChaserCounterType::BORN_TERM )->getStepCounterRate();
					const float EPSILON = 0.0001f;
					if( fZoom < EPSILON ) {
						fZoom = EPSILON;
					}
				}
				break;
			case StateType::DEAD:
				{
					float fRate = seq->getStepCounterRate();
					// Xɔ
					alpha = (1.f - fRate ) * 255;

					HPLRect rHitArea = this->getHitArea();
					int top = rHitArea.getY();	// top
					const int DELTA_Y = 50;	// 甭
					int nY = top + rHitArea.getHeight() * fRate + DELTA_Y;	// create height
					const int ERR = 10;
					
					// ~߂ĂĂ
					//if( this->getCounter( ChaserCounterType::DEAD_PARTICLE_INTERVAL )->step().isFinishAnimation )
					{
					//	this->getCounter( ChaserCounterType::DEAD_PARTICLE_INTERVAL )->reset();

						const int MAX_NUM = 10;
						for( int i = 0; i < MAX_NUM; i ++ ) {
							int nParticleCenterX = rHitArea.getX() + HPLMath::nextInt(0,rHitArea.getWidth() );
							int nParticleCenterY = nY + HPLMath::nextInt(-ERR,ERR);
							
							HPLVector vParticleCenter(nParticleCenterX, nParticleCenterY);
							GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
								Sequence::Effect::WIND_RAIL, vParticleCenter, true );
							int nBlack = HPLMath::nextInt(200,255 );
							lpEffect->setColor( nBlack, nBlack, nBlack );
							const float PARTICLE_SPEED_BASE = 5;
							const float PARTICLE_SPEED_ERR = 2;
							float fSpeed = PARTICLE_SPEED_BASE + HPLMath::nextFloat( -PARTICLE_SPEED_ERR, PARTICLE_SPEED_ERR );
							// ֈړ
							lpEffect->setVelocityAngle( 0,-fSpeed);
							lpEffect->setScale(HPLMath::nextInt(2,5));
						}
					}
					if( this->getCounter( ChaserCounterType::DEAD_CLOUD_INTERVAL )->step().isFinishAnimation ) {
						this->getCounter( ChaserCounterType::DEAD_CLOUD_INTERVAL )->reset();
						int nParticleCenterX = rHitArea.getX() + HPLMath::nextInt(0,rHitArea.getWidth() );
						int nParticleCenterY = nY + HPLMath::nextInt(-ERR,ERR);
						
						HPLVector vParticleCenter(nParticleCenterX, nParticleCenterY);
						GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
							Sequence::Effect::FREE_CLOUD, vParticleCenter, true );
						const float PARTICLE_SPEED_BASE = 8;
						const float PARTICLE_SPEED_ERR = 5;
						float fSpeed = PARTICLE_SPEED_BASE + HPLMath::nextFloat( -PARTICLE_SPEED_ERR, PARTICLE_SPEED_ERR );
						// ֈړ
						lpEffect->setVelocityAngle( 0,-fSpeed);
					}

					bIsSpecialDraw = true;

					HPLRect rArea = this->getArea();
					// blend
					SetDrawBlendMode( DX_BLENDMODE_ALPHA, alpha );
					// ͈
					int nMainTop = seq->getImageInformation()->srcRect.getHeight() * fRate;
					int nGraphHandle = getStaticData()->getImageHandle(
						SpriteType::CHASER, this->getSequenceID() );
					// w͈͂̂ݕ`悷
					DrawRectGraph( rArea.getX() + fScrollX, nMainTop + rArea.getY() + fScrollY,
						0,nMainTop, rArea.getWidth(), rArea.getHeight(), nGraphHandle, TRUE,
						this->getFaceDirection() > 0 ? TRUE : FALSE );
					SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );

				}
				break;
			}
		}
		break;
	case EnemyType::LAVA_UNDER:
		{
			if( this->getCounter(0)->isAlive() ) {
				// 犄̕
				HPLRect rArea = this->getArea();
				float fRate = 1 - this->getCounter(0)->getStepCounterRate();
				int nMainTop = seq->getImageInformation()->srcRect.getHeight() * fRate;
				int nGraphHandle = getStaticData()->getImageHandle(
					SpriteType::LAVA_UNDER, this->getSequenceID() );
				DrawRectGraph( rArea.getX() + fScrollX, nMainTop + rArea.getY() + fScrollY,
					0,nMainTop, rArea.getWidth(), rArea.getHeight(), nGraphHandle, TRUE,
					this->getFaceDirection() > 0 ? TRUE : FALSE );
				bIsSpecialDraw = true;
			}
		}
		break;
	}

	if( bIsColored ) {
		SetDrawBright( nR,nG,nB );
	}
	/////////////////////////////////////////////////////////////////////////
	// {̕\
	if( bIsSpecialDraw == false ) {
		getStaticData()->m_Basic.m_Graphics.draw(
			static_cast<int>( fCenterX ),
			static_cast<int>( fCenterY ),
			seq,
			nFaceDirection, fRotateDegree, fZoom, alpha, alpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND);
	}
	////////////////////////////////////////////////////////////////////////
	if( bIsColored ) {
		SetDrawBright( 255, 255, 255 );
	}

	// A[̕\
	for( vector<GArmManager*>::iterator it = m_vecArmManagers.begin();
		it != m_vecArmManagers.end(); it ++ ) 
	{
		GArmManager* lpArmManager = *it;
		bool bIsEnable = true;

		switch( this->getType() ) {
		case EnemyType::SLIME_QUEEN:
			if( this->getColor() != 2 ) {
				bIsEnable = false;
			}
			break;
		}
		if( bIsEnable ) {
			lpArmManager->draw();
		}
	}

	switch( this->getType() ) {
	case EnemyType::ROCK_2:
	case EnemyType::ROCK_2_SMALL:
		if( this->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) {
			// ڒn
			// ->Aj[VȂ
			bIsAnimation = false;
		}
		break;
	}
	
	// extraȕ\
	switch( this->getType() ) {
	case EnemyType::FAN_BIRD:
		{
			int nSeqIndex = 1;

			if( StateType::ATTACK == st ) {
				nSeqIndex = 2;
			}
			HPLSequence* lpPropSeq = this->getSprite()->getSequence(
				nSeqIndex, FaceDirection::LEFT );
			getStaticData()->m_Basic.m_Graphics.draw(
				fCenterX, fCenterY, lpPropSeq, this->getFaceDirection(),
				fRotateDegree, fZoom );
			if( lpPropSeq->step().isFinishAnimation ) {
				lpPropSeq->resetCounter();
			}
/*			// vy\
			switch( st ) {
			case StateType::ATTACK:
				{
				}
				break;
			default:

			}*/
		}
		break;
	case EnemyType::MERAKO:
		{
			switch( st ) {
			case StateType::DASH:
				{
					// Ή\
					float fRotDeg = this->getVelocityAngle().getDegree();
					HPLSequence* lpFireSeq = getStaticData()->getSequence(
						SpriteType::SHOT, Sequence::Shot::LAVA_BALL );
					int nBlendAlpha = HPLMath::nextInt( 180, 230 );
					getStaticData()->m_Basic.m_Graphics.draw(
						fCenterX, fCenterY, lpFireSeq, FaceDirection::LEFT,
						fRotDeg, 2,nBlendAlpha, DX_BLENDMODE_ALPHA ); 
					if( getStaticData()->m_Game.isTheWorld() == false ) {
						lpFireSeq->step();
					}
				}
				break;
			}
		}
		break;
	case EnemyType::CHASER:
		{
			switch( st ) {
			case StateType::ATTACK:
				// Ў\
				{
					float fDeg = nFaceDirection == FaceDirection::LEFT ? 90 : -90;// this->getRotateDegree();
					HPLSequence* lpSeq = this->getSprite()->getSequence(
						Sequence::Chaser::ARM, FaceDirection::LEFT );

					// {̂̒SWAr̒SWvZ
					HPLVector vArmCenter(fCenterX, fCenterY);
					vArmCenter.add( 200 * nFaceDirection, 30 );	// Ïʒu
					if( nFaceDirection < 0 ) {
						vArmCenter.add( 0, -110 );
					}
					HPLVector vArmDir;
					float fArmDeg = fDeg;
					vArmDir.setByDegree( fArmDeg );
					vArmDir.multiple(64);
					vArmCenter.add( vArmDir );

					getStaticData()->m_Basic.m_Graphics.draw(
						static_cast<int>( vArmCenter.getX() ),
						static_cast<int>( vArmCenter.getY() ),
						lpSeq,
						nFaceDirection, fArmDeg, fZoom, alpha, alpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND);
				}
				break;
			case StateType::ATTACK_2:	// `[WA^bN
				
				if( getStaticData()->getMapIndex() == SpecialMapIndex::WIND_BOSS_2 &&	// wind chaser: attack pattern2
					this->m_nAttackType == ChaserAttackType::BALL	// ball attack
					)
				{
					// -> show charging ball
					// V[PX̐i݋
					float fRate = this->getCounter( ChaserCounterType::ATTACK_TERM )->getStepCounterRate();
					float fBallZoom = fZoom * fRate;	// {[̊g嗦iXɊgj
					HPLSequence* lpBallSeq = getStaticData()->getSequence( 
						SpriteType::SHOT, Sequence::Shot::CHARGE_BOLT );
					HPLVector vBallCenter;
					// get hand center
					getStaticData()->m_ObjectManager.m_EnemyManager.getChaserHandFrom(
						vBallCenter, nFaceDirection, HPLVector(fCenterX,fCenterY), this->m_nAttackType );

					// alpha
					int nAlpha = 20;

					// draw ball
					getStaticData()->m_Basic.m_Graphics.draw(
						static_cast<int>( vBallCenter.getX() ),
						static_cast<int>( vBallCenter.getY() ),
						lpBallSeq,
						nFaceDirection, 0, fBallZoom, nAlpha, nAlpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND);

					// BLEND_ADD
					getStaticData()->m_Basic.m_Graphics.draw(
						static_cast<int>( vBallCenter.getX() ),
						static_cast<int>( vBallCenter.getY() ),
						lpBallSeq,
						nFaceDirection, 0, fBallZoom, nAlpha, DX_BLENDMODE_ADD);

					if( bIsAnimation ) {
						if( lpBallSeq->step().isFinishAnimation ) {
							lpBallSeq->resetCounter();
						}
					}
				}
				break;
			}
		}
	}

	// Aj[VXebv
	if( bIsAnimation )
	{
		// the worldł͂Ȃ
		// ł߂ĂȂ

		seq->step();

		if( this->m_lpZanzoColor != NULL ){//this->getType() == EnemyType::MAZER ) {
			// cGtFNg쐬
			getStaticData()->m_ObjectManager.m_EffectManager.createZanzo(
				SpriteType::MAZER,
				this->getSequenceID(),
				seq->getFrameIndex(),
				this,
				this->m_lpZanzoColor->r,this->m_lpZanzoColor->g,this->m_lpZanzoColor->b);
		}
	}

	getStaticData()->m_ObjectManager.drawSolid(
		this->m_SolidData.getType(), fCenterX, fCenterY, seq->getImageInformation(0)->srcRect.getWidth() );

	// HP\
	if( this->m_nClassType != EnemyClassType::EVIL_BOSS &&	// not boss
		this->m_nClassType != EnemyClassType::ARM &&
		this->getType() != EnemyType::LAVA &&
		this->getType() != EnemyType::LAVA_UNDER)	// not arm
	{
		getStaticData()->drawHP( this );
	}

	// 
	

	if( this->m_TargettedRemainCounter.getState().isFinishAnimation == false ) {
		// ^[QbgĂ

		float fRate = m_TargettedRemainCounter.getStepCounter() / (float)m_TargettedRemainCounter.getWaitFrameNum();
		// ^[QbeBO̕\
		getStaticData()->m_Basic.m_Graphics.draw(
			static_cast<int>( fCenterX ),
			static_cast<int>( fCenterY ), getStaticData()->getSequence( SpriteType::EFFECT,
			Sequence::Effect::TARGETTING ),
			FaceDirection::LEFT, 0, 1 - fRate, 200, DX_BLENDMODE_ALPHA );

	}

#ifdef _DEBUG
	// fobO\

	const int STEP = 12;
	HPLRect rHitArea = this->getHitArea();
	int nLeft = rHitArea.getRight() + scroller->getVirtualRect().getX();
	int nTop = rHitArea.getY() + scroller->getVirtualRect().getY();
	// AttackType
	if( this->m_nClassType == EnemyClassType::EVIL_BOSS ) {
		// ׂ\
		{
			string str = HPLString::chrToStr(
				"Act:%d", this->m_nAttackType);
			DrawString( nLeft, nTop, str.c_str(), GetColor(255,255,255) );
		}
	}

	// state
	{
		nTop += STEP;
		// draw state id & label
		getStaticData()->m_ObjectManager.drawState( nLeft, nTop, this->getState()->getState() );
	}
#endif
}

void GEnemy::die(HPLShootingObject* damageSource)
{
	if( damageSource != NULL && getStaticData()->m_ObjectManager.isPlayerShot( damageSource ) )
	{
		// vC[̍UɂĎ

		int ACHIEVEMENTS[] = {
			AchievementType::EVIL_BASTER,
			AchievementType::EVIL_WARRIER,
			AchievementType::EVIL_TERMINATER
		};
		// GjJEg
		for( int i = 0; i < SIZEOF( ACHIEVEMENTS ); i ++ ) {
			getStaticData()->stepAndCheckAchievement( ACHIEVEMENTS[i], 1, true );
		}

		// Q݂PG
		if( damageSource->getID() == getStaticData()->m_Game.m_Reminder.getNoCheck(
			ReminderType::LYING_DAMAGE_ENEMY_ID ) )
		{
			getStaticData()->stepAndCheckAchievement( AchievementType::AWAKEN, 1, true );
		}

		// |CgZ
		getStaticData()->m_Save.setScore( getStaticData()->m_Save.getScore() + this->getPoint());
	}

	if( this->getEnemyAttribute( EnemyAttribute::HAS_DEAD ) && this->m_SolidData.getType() == SolidType::NONE) {
		// dead֕ύX
		this->changeState( StateType::DEAD );
	} else {
		this->setAlive( false );
	}

	if( this->isHolding() ) {
		// 
		getStaticData()->m_ObjectManager.m_EnemyManager.freeHold( this->getTarget(), this );
	}

	// ʏ
	switch( this->getType() ) {
	case EnemyType::TANYA:
	case EnemyType::TANYA_YOUJO:
		{
			// explosion
			GShot* lpShot = getStaticData()->m_ObjectManager.m_ShotManager.create( Sequence::Shot::EXPLOSION, this->getCenter(),
				this->getID(), this->getFaceDirection(), false, true );
			// do nothing more to this shot
		}
		break;
	case EnemyType::ARYONA:
		{
			int nNextMapIndex = -1;
			int nNextSceneIndex = -1;
			int nPlayerPosition = -1;
			HPLVector vCenter = this->getCenter();
			switch( getStaticData()->getMapIndex() ) {
			case SpecialMapIndex::FOREST_ARYONA:
				nNextMapIndex = 29;
				nPlayerPosition = 0;
				break;
			case SpecialMapIndex::WIND_ARYONA:
				nNextMapIndex = 64;
				nPlayerPosition = 0;
				nNextSceneIndex = SceneType::SELECT_PLACE;
				vCenter = this->m_vCenterPosition;
				break;
			}
			if( nNextMapIndex >= 0 ) {
				int TYPES[] = {
					Sequence::Neutral::DOOR_IDLE,
					Sequence::Neutral::TAKARA_BAKO
				};
				int PARAMS[][7] = {
					{nNextMapIndex,nNextSceneIndex,nPlayerPosition,-1,-1,-1,-1},
					{-1,-1,-1,4,1,1,10}
				};
				int VEL_DEGS[][2] = {
					{200,240},
					{300,320}
				};
				int SPEEDS[] = {
					5,
					5 
				};
				for( int i = 0; i < 2; i ++ ) {
					GNeutral* lpNeutral = getStaticData()->m_ObjectManager.m_NeutralManager.create( 
						TYPES[i], vCenter, PARAMS[i][0], PARAMS[i][1] );
					for( int j = 0; j < SIZEOF( PARAMS[i] ); j ++ ) {
						lpNeutral->getPlacerParameters()->push_back( PARAMS[i][j] );
					}
					HPLVector v;
					v.setByDegree( HPLMath::nextFloat(VEL_DEGS[i][0], VEL_DEGS[i][1]));
					v.multiple( SPEEDS[i] );
					lpNeutral->setVelocityAngle( v );
					lpNeutral->setObjectAttribute( ObjectAttribute::GRAVITY, true ) ;
				}
			}


		}

		break;
	case EnemyType::ALRAUNE:
		// SVbg
		getStaticData()->m_ShotFactory.shot( this, AlrauneWeaponType::SCREAM, 0 );
		getStaticData()->m_MixerManager.play( SE::ALRAUNE_SCREAM, false );
		break;
	case EnemyType::BEE_HIVE:
		{
			this->setObjectAttribute( ObjectAttribute::GRAVITY, true );	//! 
			// vC[ɂ̓qbgȂ
			this->setObjectAttribute( ObjectAttribute::HIT_TO_PLAYER, false );
			this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, false );
		}
		break;
	case EnemyType::TOZICO:		//! tozico
		{
			// }bvCfbNX
			int nMapIndex = getStaticData()->getMapIndex();
			int nStar = getStaticData()->m_nSelectedStar;
			int nPlace = getStaticData()->m_nSelectedPlace;

			// ݂̐CfbNX擾
//			getStaticData()->m_Setting.maps.getStarAndPlaceFromMapIndex(
//				nMapIndex, nStar, nPlace );

			// ݂̐ɂSATSUGAIrbg𗧂Ă
			getStaticData()->m_Save.setFlagBit( FlagType::TOZICO_DEATH_NUM, nStar, true );
		}
		break;
	case EnemyType::CHASER:
		{
			// map index
			int nMapIndex = getStaticData()->getMapIndex();

			if( SpecialMapIndex::WIND_BOSS_1 == nMapIndex ) {	// boss

				// check achievement #019 "No vehicle"
				// kill CHASER without car
				getStaticData()->stepAndCheckAchievement( AchievementType::NO_VEHICLE, 1, true );
			}

		}
		break;
	default:
		break;
	}

	if( EnemyClassType::ARM == this->m_nClassType ||
		EnemyClassType::ARM_HEAD == this->m_nClassType )
	{
		// G
		// 𐶐
		getStaticData()->m_ObjectManager.m_EffectManager.createBlood( this->getCenter() );
	}

	// G͑SĔj󂵂Ă
	for( vector<GArmManager*>::iterator ait = this->m_vecArmManagers.begin();
		ait != this->m_vecArmManagers.end();
		ait ++ )
	{
		GArmManager* lpArmManager = *ait;
		// GԂ傠
		// ̃GtFNgo
		// ArmׂĎE
		lpArmManager->killAllArms( );

		//lpArmManager->disable();

		GEnemy* lpArmHead = dynamic_cast<GEnemy*>( lpArmManager->getHead() );
		//lpArmHead->setAlive(false );
		if( lpArmHead->isHolding() ) {
			getStaticData()->m_ObjectManager.m_EnemyManager.freeHold( this->getTarget(), lpArmHead );
		}
	}

}

/** _[W
  */
void GEnemy::damage(float dmg, HPLShootingObject* damageSource)
{
	float fOldHP = this->getHP();
	int nOldBerserkLevel = this->getBerserkLevel();

	// damage \
	getStaticData()->m_ObjectManager.m_EffectManager.createNumber(
		this->getCenter(), (int)dmg, false, NUM_POWER, 
		NUM_RED.r,NUM_RED.g,NUM_RED.b );

	this->setHP( fOldHP - dmg );
	
	if( this->getHP() <= 0 && fOldHP > 0 ) {
		this->die( damageSource );
	}

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	switch( this->getType() ) {
	case EnemyType::JACKPOT:
		{
			const int COINS_PER_HIT = 2 * fLevel;	//! 1qbgŏo鐔
			// uĂ񐔁vɉăRCoB
			// ʂ͌ŒB_[W肠Ă񐔂dvBKgO[U[~TC
			getStaticData()->m_ObjectManager.m_ItemManager.createCoins(
				this->getCenter(), COINS_PER_HIT);
		}
		break;
	case EnemyType::TOZICO:
		{
			if( getStaticData()->m_ObjectManager.isPlayerShot( damageSource ) ) {
				// vC[Vbg
				// Ђ
				int nStar = getStaticData()->m_nSelectedStar;
				int nPlace = getStaticData()->m_nSelectedPlace;
				int nMapIndex = 0;
//				getStaticData()->m_Setting.maps.getStarAndPlaceFromMapIndex(
//					nMapIndex, nStar, nStage );
				getStaticData()->m_Save.setFlagBit(
					FlagType::TOZICO_DEATH_NUM, nStar, true );
			}
		}
		break;
	}
}

bool GEnemy::stepRespawnCounter() {
#ifdef _DEBUG
	ASSERT_IT_NULL( this->m_RespawnCounter );
//	HPLError::assertIt( m_RespawnCounter != NULL );
#endif
	bool bIsFinish = this->m_RespawnCounter->step().isFinishAnimation;
	if( bIsFinish ) {
		this->setEnemyGenerateCounterRandom();
	}
	return bIsFinish;
}

void GEnemy::setEnemyGenerateCounterRandom() {
	if( this->m_nGenerateType == GeneratorType::LAVA_UNDER ) {
		this->m_RespawnCounter->setWaitFrameNum(
			 32);

	} else {
		float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );
		int nFrameNum = ENEMY_GENERATE_INTERVAL_BASE + HPLMath::nextInt( - ENEMY_GENERATE_INTERVAL_ERROR , ENEMY_GENERATE_INTERVAL_ERROR );
		nFrameNum = (int)((float)nFrameNum * (this->m_nGenerateType == GeneratorType::ROCKS ? 0.2f / fLevel : 1.f ) );
		if( m_RespawnCounter == NULL ) {
			m_RespawnCounter = new HPLCounter();
		}
		this->m_RespawnCounter->setWaitFrameNum(
			 nFrameNum);
	}
	this->m_RespawnCounter->reset();
}
void GEnemy::setGenerateType( int nType ) {
	this->m_nGenerateType = nType;
	// ݒ
	this->setEnemyGenerateCounterRandom();

	switch( this->getType() ) {
	case EnemyType::BEE:
		if( nType < 0 ) {
			nType = 0;
		}

		this->m_CurrentColor = this->m_vecColors[nType];
		this->setColor( nType );
		// Ԃ3{
		this->m_fPower *= nType == 0 ? 1: 3;
		break;
	case EnemyType::FLOWER:
//		this->setColor(nType);
		break;
	}
}


/** Fς(I[o[Chj
  */
void GEnemy::setColor(int c) {
	HPLShootingObject::setColor( c );

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	switch( this->getType() ) {
	case EnemyType::SLIME_QUEEN:
		{
			if( c == 2 ) { // green
				// Zbg
				for( vector<GArmManager*>::iterator ait = this->m_vecArmManagers.begin();
					ait != this->m_vecArmManagers.end(); ait ++ )
				{
					(*ait)->reset();
				}
				this->m_nAttackType = HPLMath::nextInt(0,3);	// Up^[
			}
			if( this->m_vecCounters.size() > 0 ) {
				// reset
				this->getCounter(SlimeQueenCounterType::WAIT_FOR_NEXT)->reset();
			}
		}
		break;
	case EnemyType::FLOWER:
		switch(c) {
		case AlrauneFlowerColorType::RED:			// 
			break;
		case AlrauneFlowerColorType::BLUE:			// 
			this->getCounter(0)->setWaitFrameNum( (int)(120 / fLevel ) );
			this->getCounter(1)->setWaitFrameNum( (int)(40 / fLevel ) );
			break;
		case AlrauneFlowerColorType::YELLOW:			// F
			// [t˂܂ł̃C^[o
			this->addCounter( new HPLCounter((int)(100 / fLevel )) );
			// ˊԊu
			this->addCounter( new HPLCounter((int)( 10 / fLevel )) );
			break;
		}
		break;
	}
}


/** [h
	*/
int	GEnemy::setBerserkLevel() {
	switch( this->getType() ) {
	case EnemyType::SLIME_QUEEN:
	case EnemyType::CHASER:
		{
			// ̗͂ʌꍇ
			int nBerserkLevel = this->setBerserkLevel( (this->getHP() / this->getHPMax() <= SLIME_QUEEN_BERSERK_RATE ) ? 1: 0 );
			return nBerserkLevel;
		}

	case EnemyType::ALRAUNE:
		{
			const int TOP_BERSERK_LEVEL = 3;
			if( this->getHP() / this->getHPMax() <= SLIME_QUEEN_BERSERK_RATE ) {
				this->setBerserkLevel( TOP_BERSERK_LEVEL );

				// ԂBerserkɂ
				for( int i = 0; i < (int)this->m_vecArmManagers.size(); i ++ ) {
					((GEnemy*)this->m_vecArmManagers[i]->getHead())->setBerserkLevel( TOP_BERSERK_LEVEL );
				}
				return getBerserkLevel();
			}
			int nCount = 0;
			for( int i = 0; i < (int)this->m_vecArmManagers.size(); i ++ ) {
				GEnemy* lpHead = (GEnemy*)this->m_vecArmManagers[i]->getHead();

				// _[WԂȂo[T[NԂɂ
				lpHead->setBerserkLevel( 
					lpHead->getState()->getState() == StateType::DAMAGE ? 1: 0 );

				if( false == lpHead->isAlive() ) {
					nCount ++;

				}
			}

			if( nCount > 0 ) {
				// Ԃꕔ

				// ԂSo[T[NԂɂ

				for( int i = 0; i < (int)this->m_vecArmManagers.size(); i ++ ) {
					GEnemy* lpHead = (GEnemy*)this->m_vecArmManagers[i]->getHead();	// ԃwbh
					lpHead->setBerserkLevel(nCount);	// o[T[NJEg{̂ɍ킹
				}
			}
			return getBerserkLevel();
		}
	}

	return 0;

}

static void createSlimeDeadEffect( int nCol, GEnemy* lpEnemy ) {
	HPLRect rHitRect = lpEnemy->getHitRect();
	float fRate = 1;
	if( lpEnemy->m_nClassType == EnemyClassType::EVIL_BOSS ) {
		fRate *= 3.f;
	}
	for( int i = 0; i < (int)(fRate * HPLMath::nextInt( CREATE_SLIME_CHIP_MIN, CREATE_SLIME_CHIP_MAX )); i ++ ) {

		// center
		HPLVector vCenter( HPLMath::nextFloat( -rHitRect.getWidth(), rHitRect.getWidth() ),
			HPLMath::nextFloat( -rHitRect.getHeight(), rHitRect.getHeight() ) );
		vCenter.add(lpEnemy->getCenter() );

		GEffect* lpEffect = getStaticData()->createEffect( Sequence::Effect::SLIME_CHIP + HPLMath::nextInt(0,2),
			vCenter, vCenter, -1, -1 );

		lpEffect->setColor( SlimeQueenColors::COLORS[nCol] );
		// velocity
		lpEffect->setVelocityAngle( HPLMath::nextFloat( - SLIME_CHIP_ERR_X, SLIME_CHIP_ERR_X ),
			 - HPLMath::nextFloat( SLIME_CHIP_ERR_Y_MIN, SLIME_CHIP_ERR_Y_MAX ) );
	}
}


/** S̃GtFNg
  */
void GEnemy::createDeadEffect() {

	// ʓł̂ݔ
	switch( this->getType() ) {
	case EnemyType::SLIME:
	case EnemyType::SLIME_BABY:
		createSlimeDeadEffect( SlimeQueenColorType::RED, this );
		break;
	case EnemyType::BLUE_SLIME:
	case EnemyType::BLUE_SLIME_BABY:
		createSlimeDeadEffect( SlimeQueenColorType::BLUE, this );
		break;
	case EnemyType::GREEN_SLIME:
	case EnemyType::GREEN_SLIME_BABY:
		createSlimeDeadEffect( SlimeQueenColorType::GREEN, this );
		break;
	case EnemyType::YELLOW_SLIME_BABY:
	case EnemyType::YELLOW_SLIME:
		createSlimeDeadEffect( SlimeQueenColorType::YELLOW, this );
		break;
	case EnemyType::SLIME_QUEEN:
		createSlimeDeadEffect( this->getColor(), this );
		break;
	case EnemyType::ARM:
	case EnemyType::ARM_HEAD:
	case EnemyType::FLOWER:
	case EnemyType::KUKI:
		// Gn
		getStaticData()->m_ObjectManager.m_EffectManager.createBlood( this->getCenter() );
		break;
	
	}

}

void GEnemy::setFaceDirection( int nFaceDirection ) {
	int st = this->getState()->getState();

	bool bIsChange = nFaceDirection != this->getFaceDirection();

	switch( this->getType() ) {
	case EnemyType::CHASER:
		{
			if( bIsChange ) {
				if( this->getCounter( ChaserCounterType::WAIT_FOR_NEXT)->isAlive()) {
					bool bKochiMinnna = false;
	/*				int nMapIndex = getStaticData()->getMapIndex();
					switch( nMapIndex ) {
					case SpecialMapIndex::WIND_BOSS_2:
						switch( this->getAttackType() ) {
						case ChaserAttackType::ATTACK:
						case ChaserAttackType::THUNDER_SHOT:
							bKochiMinnna = true;
						}
					}*/
					// next͏ɓ悤ɂ̂ŁAԂaȂ͂
					bKochiMinnna = true;
					if( bKochiMinnna && st != StateType::READY ) {	
						this->setPreviousState( st );
						this->changeState( StateType::READY );
					}
				}
			}
		}
		break;
	}
	HPLShootingObject::setFaceDirection( nFaceDirection );

	
}

bool GEnemy::isSlime() {
	switch( this->getType() ) {
	case EnemyType::SLIME:
	case EnemyType::BLUE_SLIME:
	case EnemyType::GREEN_SLIME:
	case EnemyType::YELLOW_SLIME:
	case EnemyType::SLIME_BABY:
	case EnemyType::BLUE_SLIME_BABY:
	case EnemyType::GREEN_SLIME_BABY:
	case EnemyType::YELLOW_SLIME_BABY:
		return true;
	}
	return false;
}

