#ifndef _G_ENEMY_
#define _G_ENEMY_

#include <hpllib/object/HPLShootingobject.h>
#include <hpllib/math/HPLMatrix.h>
#include <hpllib/game/block/HPLBlock.h>
#include <hpllib/image/eg/HPLPaletteManager.h>
#include <hpllib/general/HPLColor.h>
#include <hpllib/math/HPLMath.h>
#include <hpllib/object/HPLSolidData.h>

#include "GEnum.h"
#include "GArmManager.h"

#include <hpllib/game/HPLAttackInformation.h>

namespace GEnum {
	/** A[ĩJE^
	  */
	namespace AryonaCounterType {
		enum {
			WAIT_FOR_START,
			WAIT_FOR_NEXT,
//			ALL_ATTACK_PATTERN,

			SUMMON_INTERVAL,
			SUMMON_TIME,
			SUMMON_INTERVAL_2,
			SUMMON_TIME_2,
			MAX_NUM
		};
	}

	/** AEl̃JE^
	  */
	namespace AlrauneCounterType {
		enum {
			WAIT_FOR_START,
			WAIT_FOR_NEXT,
			TENTACLE_SHOT_INTERVAL,	//! Ă񂽂锭Ԋu

			TENTACLE_COUNT,		//! 
			ALL_TENTACLE_COUNT,	//! TENTACLE_COUNT{TENTACLE_SHOT_INTERVALԊu
								//! ALL_TENTACLE_COUNT񂾂JԂB
								//! JԂ̊ԊuWAIT_FOR_NEXT_TENTACLE
			ATTACK_TERM,		//! U̎
			TENTACLE_WAIT_FRAME,	//! U̍Ԃ̑҂t[
		};
	}

	namespace Merako01CounterType {
		enum {
			WAIT_FOR_START,
			WAIT_FOR_NEXT,
			MOVE_COUNT,		//! ʒuւ
			SHOT_INTERVAL,
			//CHASE_TERM,		//! ǔ
			ATTACK_TERM,	//! U
			MOVE_INTERVAL,	//! ړ̊Ԃ̃EGCg
			LAVA_COUNT,		//! n╬o񐔃JEg
			LAVA_INTERVAL,	//! n╬oԊu
		};
	}
	namespace Merako01AttackType {
		enum Merako01AttackType_ {
			MOVE_SHOT,	//! __ړ{Vbg
			LAVA_UP,	//! n₪オiw`Oj	ɂ߂qEɓAɗn𗎂Ƃ
			CIRCLE,		//! ~̓IYvːi
			EXPLOSION,	//! Ɉړ唚
			FALLOUT,	//! ɏāAn_ɗƂ
			DROP_FLARE,	//! n𗎂Ƃđ唚
			DASH,		//! ːi
			CHASE,		//! CHASE!
			MAX_NUM
		};
	}
	namespace Merako02AttackType {
		enum {
			MAX_NUM
		};
	}
	namespace MedousaCounterType {
		enum {
			SNAKE_COUNT,			//! wro񐔂
			SNAKE_SHOT_INTERVAL,	//! ւтoԊu
			WAIT_FOR_NEXT,			//! ܂ł̃EGCg
			CHARGE,					//! Ή`[W
			
		};
	}
	
	extern const int MERAKO_MOVE_COUNT;			//! SUNNŸړ񐔃ftHg
	extern const float ENEMY_AIR_RESIST_RATE;	//! G󒆂Ŏ󂯂CRiʏRɂ{j
	extern const float FACE_CHANGE_THRESHOLD;	//! ]臒l
	extern const int LAVA_BALL_SPEED_Y;			//! n̏x
	extern const int SHABON_SPEED;

	// robot
	namespace RobotCounterType {
		enum {
			WAIT_FOR_NEXT,
			BEAM_SHOT_COUNT,
			//BEAM_SHOT_INTERVAL,
			MISSILE_SHOT_COUNT,
			//MISSILE_SHOT_INTERVAL,
		};
	}

	// dirty cloud
	namespace DirtyCloudCounterType {
		enum DirtyCloudCounterType_ {
			WAIT_FOR_START,
			WAIT_FOR_NEXT,
			DROP_INTERVAL,
			DROP_COUNT,

			WIND_INTERVAL,
			WIND_COUNT,
		};
	}
	namespace DirtyCloudAttackType {
		enum DirtyCloudAttackType_ {
			DROP,
			WIND,
		};
	}

	// enemy state flag
	namespace StateFlagType {
		enum StateFlagType_ {
			OILED,	//! }l[YȂǂ̃IC
			POISON,	//! 
		};
	}

	// chaser counters
	namespace ChaserCounterType {
		enum ChaserCounterType_ {
			WAIT_FOR_START,
			WAIT_FOR_NEXT,
			SHOT_COUNTER,			//! Vbg
			SHOT_INTERVAL,			//! VbgƃVbg̊
			ATTACK_TERM,			//! UĂ鎞
			BORN_TERM,				//! borno
			BORN_CLOUD_INTERVAL,	//! born_oԊu
			THUNDER_SHOT_COUNT,		//! U͉񐔑ȂƂڂ̂ŕʂŗp
			DEAD_PARTICLE_INTERVAL,	//! S̃p[eBNԊu
			DEAD_CLOUD_INTERVAL,	//! S̉_Ԋu
			MAX_NUM
		};
	}
	// chaser attack type(2)
	namespace ChaserAttackType {
		enum ChaserAttackType_ {
			ELEC_SHOT,		//! װ̂Vbg
			ATTACK,			//! ˂
							//! Berserk͓ːi
			BALL,			//! d̂𓊂inʂ𑖂j
			WIND_SHOT,		//! ̰݂̂Vbg(VbgK)
			THUNDER_SHOT,	//! T_[VbgI
			SHABON_SHOT,	//! ڂ
			MAX_NUM
		};
	}

	// chaser attack type(1)
	namespace ChaserAttackType1 {
		enum ChaserAttackType1_ {
			BORN,
			ELECT_SHOT_1,	// SN()
			WIND_SHOT_1,	// SN(P)
			THUNDER_BALL_HOMING,	// ́(vC[̈ʒuɌ)
			THUNDER_BALL_LINE,		// ꒼ɐBg͏Ɉړ
			MAX_NUM
		};
	}

	// enemy position sets
	namespace EnemyPositionType {
		enum EnemyPositionType_ {
			SUNNY,
			WIND_ARYONA,
			CHASER_1,
			CHASER_2,
			GHOST_PAIR,
			AIKO,
		};
	}

	// bee color
	namespace EnemyBeeColor {
		enum EnemyBeeColor_ {
			YELLOW_V,
			RED_B,	// ԁFɐڋ߂ĕ߂܂ 
		};
	}

	static const int CHASER_FADE_OUT_FRAME_NUM = 30;
	static const int CHASER_FADE_IN_FRAME_NUM = CHASER_FADE_OUT_FRAME_NUM;
	static const int CHASER_FADE_DARKEN_ALPHA = 200;
	static const int CHASER_FADE_LIGHTEN_ALPHA = 0;

	namespace FuuRaiCounterType {
		enum FuuRaiCounterType_ {
			TURN_INTERVAL,		//! vC[̗Ԋu
			KEEP_MOVE_TERM		//! 莞
		};
	}

	namespace FireElementalCounterType {
		enum {
			WAIT_FOR_NEXT,
			ATTACK_TERM,
		};
	}

	namespace AikoAttackType {
		enum AikoAttackType_ {
			ICE_SPIKE,		//! Xi
			ICICLE,			//! 
			TARGET_FROST,	//! 
			CALL_FROST,		//! 肼[
			ICE_SPIKE_TARGET,	//! 
			ICE_SOWRD,		//!
			BLIZZARD,		//! ړ͌
			SNOW,			//! i蔻Lj
		};
	}
/*	namespace AikoCounterType {
		enum {
			WAIT_FOR_START,
			WAIT_FOR_NEXT,
			ICE_SPIKE_INTERVAL,
			ICE_SPIKE_SHOT_NUM,
		};
	}*/

	namespace GhostPairAttackType {
		enum {
			ICE_SPIKE,
			ICICLE,
			PON,			//! ǂŔ˂{[
			HOMING,			//! z[~O[U[
			ICE_SPIKE_WINDER,
			SUMMON_ELEMENT,
			SANDWITCH,		//! Th"EBb`"	cH
			MIRROR,			//! ЕˁAЕ
			ICE,			//! vC[̓ǔAACXNwaySʂɔ
			BOUNCE_PON,		//! ˉe
		};
	}
/*	namespace GhostPairCounterType {
		enum {
			WAIT_FOR_START,
			WAIT_FOR_NEXT,
			ICE_SPIKE_INTERVAL,
			ICE_SPIKE_SHOT_NUM,
			ICICLE_INTERVAL,
			ICICLE_SHOT_NUM,
			PON_INTERVAL,
			PON_SHOT_NUM,
			HOMING_INTERVAL,
			HOMING_SHOT_NUM,
		};
	}*/
	namespace EllinAttackType {
		enum EllinAttackType_ {
			SLASH,
			SURIKEN,
			CHARGE_SLASH,
			HUGE_SURIKEN,
			SWORD,
			ROTATION_SWORD,	//! o]vC[֓̕ˌ
		};
	}
	namespace DragonAttackType {
		enum DragonAttackType_ {
			ROCKS,	//! Ⓤ
			BITES,	//! ݂

		};
	}

	namespace CrazyTankAttackType {
		enum CrazyTankAttackType_ {
		};
	}
	namespace CoreSystemAttackType {
		enum CoreSystemAttackType_ {
		};
	}
	/* 
		KvȂ̃Xg
		- WAIT_FOR_START
		- WAIT_FOR_NEXT
		- Shot:LU@PʂŃZbgŗp
		  - interval
		  - shot num
		
		- ʒu
		- UJڏ(ǂ̍UI玟̂ǂ̍UւȂ邩)
	*/
}



/** GNX
  */
class GEnemy: public HPLShootingObject{
private:
	int				m_nPoint;					//! Q[|Cg
	int				m_nPreviousState;			//! chaserpair-ghostȂǁAȌԂoĂp
	HPLRect*		m_lprWeakHitRect;			//! _|Cg
//	float			m_fAmplitude;				//! ㉺ɂꍇ̐U
	HPLColor*					m_lpZanzoColor;	//! zanzo
	std::vector<HPLCounter*>	m_vecCounters;	//! counters
//	HPLCounter*		m_lpLyingCounter;			//! QĂ鎞ԃJE^
//	int				m_nAttackType;				//! U^Cv
	HPLCounter*		m_RespawnCounter;			//! p
	
	int				m_nBitEnemyAttributes;		//! GBit
//	bool			m_aryEnemyAttributes[ GEnum::EnemyAttribute::MAX_NUM ];

	int				m_nHoldType;				//! ݎ
	float			m_fBlow;					//! ї(level␳)
	int				m_nGenerateType;			//! ^Cv

	int				m_nWeaknesses;				//! _
	int				m_nImmunities;				//! ϐ

	int m_nBerserkLevel;						//! o[T[NxB
												//! 0	:ʏ
												//! 1<=	:o[T[N
	// enemy attribute ( private )
	void setEnemyAttribute( int nIndex, bool bFlag ) {
		this->m_nBitEnemyAttributes = HPLMath::setFlagByIndexInt(
			this->m_nBitEnemyAttributes, nIndex, bFlag );
	}
	float			m_fBrustMaxSpeed;			//! ő呬x
	int 			m_nBrustType;				//! 
	HPLRect			m_rBrustRect;				//! ɂvC[𓮂͈́BArea(0,0)̑΍WBEɂʒuvZ邱

	int				m_nStateFlag;				//! 
	int				m_nAttackType;				//! U^CvBGƂɊǗeقȂB
	
	bool			m_bIsUseReduceAccel;		//! Oŗpӂxp
	float			m_fReduceAccel;				//! iprj

	// Getter/Setter
public:
	HPLAttackInformation* m_lpAttackInformation;	//! Up^[
	int getPoint() { return this->m_nPoint;}
	void setPoint( int nPoint ) {	this->m_nPoint = nPoint;	}
	// check use reduce accel
	bool isUseReduceAccel(){	return this->m_bIsUseReduceAccel;	}
	// get reduce accel
	float getReduceAccel(){		return this->m_fReduceAccel;	}
	// set reduce accel( and enable reduce accel)
	void setReduceAccel(float fReduceAccel){
		this->m_bIsUseReduceAccel = true;
		this->m_fReduceAccel = fReduceAccel;
	}
	// disable reduce accel
	void disableReduceAccel(){	this->m_bIsUseReduceAccel = false;	}
	// attack type
	int getAttackType() {	return this->m_nAttackType;	}
	void setAttackType( int nAttackType ) {	this->m_nAttackType = nAttackType;	}

	// previous state
	int getPreviousState() {	return this->m_nPreviousState;	}
	void setPreviousState( int nState) {	this->m_nPreviousState = nState;	}

	// state flag
	bool getStateFlag( int nIndex );
	void setStateFlag( int nIndex, bool bFlag );
	void resetStateFlag() { this->m_nStateFlag = 0;}
	
	/** _H	  */
	bool isWeakHitRect() {
		return this->isWeakness( GEnum::DamageType::SNIPER ) && 
			this->m_lprWeakHitRect != NULL;
	}
	/** _̈	  */
	HPLRect getWeakHitRect() {
#ifdef _DEBUG
		HPLError::assertIt( this->m_lprWeakHitRect != NULL,
			"%s:this->m_lprWeakHitRect is null", __FUNCTION__);
#endif
		HPLRect rHitRect = *this->m_lprWeakHitRect;
		if( this->getFaceDirection() == FaceDirection::RIGHT ) {
			HPLRect::getReverse( &rHitRect, (int)this->getWidth() );
		}

		return rHitRect;
	}
	HPLRect getWeakHitArea() {
		HPLRect rHitArea = this->getWeakHitRect();
		HPLRect rArea = this->getArea();
		rHitArea.setX( rHitArea.getX() + rArea.getX());
		rHitArea.setY( rHitArea.getY() + rArea.getY());
		return rHitArea;
	}

	// brst max speed
	float getBrustMaxSpeed() {		return this->m_fBrustMaxSpeed;	}
	// brust type
	int getBrustType() {		return this->m_nBrustType;	}
	// brust area
	HPLRect getBrustArea() {
		HPLRect rBrustArea = this->m_rBrustRect;
		if( this->getFaceDirection() == FaceDirection::RIGHT ) {
			// E

			// E̒_A̍㒸_̂傤ǋtɂȂ悤ɂ
			rBrustArea.setX( rBrustArea.getX() * -1 - rBrustArea.getWidth());
		}
		HPLRect rArea = this->getArea();	// area copy
		rBrustArea.setX( rBrustArea.getX() + rArea.getX() );
		rBrustArea.setY( rBrustArea.getY() + rArea.getY() );
		if( this->getFaceDirection() == FaceDirection::RIGHT ) {	// E
			// Area̍㒸_AAreảEE㒸_ɕύX
			rBrustArea.setX( rBrustArea.getX() + rArea.getWidth() );
		}
		return rBrustArea;
	}
	HPLSolidData				m_SolidData;		//! łߏ
	bool						m_bIsDrawBack;		//! ubNɕ\
	HPLCounter					m_FireCounter;		//! Âɂ܂ƂtGtFNgo
	int							m_nFireEffectType;	//! GtFNgID
	HPLCounter					m_DamageCounter;	//! _[WԂ̕A
													//! i_[WԂȂ+[v̓GɌj
	HPLVector					m_vCenterPosition;	//! 菈p̈ʒu
	HPLCounter*					m_lpAmplitude;		//! UJE^B1T360xɑΉ
	HPLVector					m_vAmplitudeCenter;	//! ㉺U̒SW

	HPLVector					m_vDelta;			//! ΍WBTODO prsB
	std::vector<GArmManager*>	m_vecArmManagers;	//! G}l[W
	int 						m_nClassType;		//! NX
	HPLCounter*					m_lpCreateEffectIntervalCounter;	//! GtFNg𔭐Ԋu
	int 						m_nPreviousColor;	//! ÕJ[
	int							m_nEventAfterDead;	//!
//	bool						m_bIsHoldingEnemy;	//! z[h^Cvł
	std::vector<HPLColor>		m_vecColors;			//! J[
	HPLColor					m_CurrentColor;		//! ݂̐F
	bool						m_bIsNoRecognize;		//! vC[FȂ
	float						m_fPower;			//! U(level␳)
	bool							m_bIsBlowByShot;		//! false	X[p[A[}[

//	bool							m_bIsTargetted;			//! ^[QbeBOꂽ
	HPLCounter					m_TargettedRemainCounter;	//! ^[QbeBO̎
	HPLPaletteManager*			m_lpPaletteManager;		//! pbgǗ
	int							m_nSummonPositionType;		//! Generator position type for aryona
	float						m_fDrawRotate;		//! \pRotate

	/** [hx
	  * @retval 0ȉ	ʏ탂[h
	  * @retval 1ȏ	o[T[N[hBlɂĈقȂ鋓Ȃ炳
	  */
	int getBerserkLevel() {
		return this->m_nBerserkLevel;
	}
	/** [hxݒ
	  * ɐݒ肵l
	  */
	int setBerserkLevel();
	int setBerserkLevel( int nLevel ) {
		this->m_nBerserkLevel = nLevel;
		return nLevel;
	}
	// weakness
	void setWeakness( int nType, bool bIsWeak );
	bool isWeakness( int nType );
	// immunities
	void setImmunity( int nType, bool bIsImmune );
	bool isImmunity( int nType );
	int getImmunities() {		return this->m_nImmunities;	}
	int getWeaknesses() {		return this->m_nWeaknesses;	}
	// generate type
	int getGenerateType() {		return this->m_nGenerateType;	}
	void setGenerateType( int nType );
	// blow
	float getBlow();

	/** WFl[gJE^i߂
	  * @retval		true	JE^Ō܂ōs
	  */
	bool stepRespawnCounter();
	void addCounter( HPLCounter* lpCounter );
	HPLCounter* getCounter( int nIndex );
	int getHoldType() {
		return this->m_nHoldType;
	}
	void setHoldType( int nHoldType ) {
		this->m_nHoldType = nHoldType;
	}
	bool getEnemyAttribute( int nIndex ) {
		return HPLMath::getFlagByIndexInt( this->m_nBitEnemyAttributes, nIndex );
	}

	// Constructor
public:
	GEnemy() : HPLShootingObject( 0 ) {}

	GEnemy( int nType ): HPLShootingObject(nType) {
		this->setup( nType );
	}
	void setup( int nType );
	virtual ~GEnemy();

	// Iy[V
private:
	int getSequenceID();

	/** Ԃɑ΂V[PXID擾
	  */
	int getSequenceIDByStateType( int nStateType );

	/** E폜
	  */
	void clearArmManagers();
public:

	/** */
	void collision(HPLMatrix<int>* matrix,
		std::map<int, HPLBlock*>* blockMap);

	/**
		ASY
	*/
	void algorithm();

	void draw();

	void die(HPLShootingObject* damageSource);

	void damage(float dmg, HPLShootingObject* damageSource);

	/**
	  * @retval		NULL		SpriteȂ^CviWFl[^j
	  */ 
	HPLSequence* getSequence();

	// override
	void changeState( int nState );
	
	// override
	void setFaceDirection( int nFaceDirection );

	/** 
	  */
	void setEnemyGenerateCounterRandom();

	/** Fς(I[o[Chj
	  */
	void setColor(int c) ;

	/** _[WԂ
	  * @retval	true	SuperArmorłADamageԂ
	  */
	bool isHasDamageState();

	/** S̃GtFNg
	  */
	void createDeadEffect();


	bool isSlime();
};

#endif
