#ifndef _G_ENEMY_CONSTS_
#define _G_ENEMY_CONSTS_

#include <tchar.h>

namespace GEnum {
	namespace EnemyCommand {
		static const TCHAR* const CMD_SPRITE_ID				= _T("SpriteID");
		static const TCHAR* const CMD_HIT_RECT				= _T("HitRect");
		static const TCHAR* const CMD_HP_RATE				= _T("HPRate");
		static const TCHAR* const CMD_POWER_RATE			= _T("PowerRate");
		static const TCHAR* const CMD_BLOW_RATE				= _T("BlowRate");
		static const TCHAR* const CMD_SOLID_TYPE			= _T("SolidType");
		static const TCHAR* const CMD_SOLID_TYPE_ALL		= _T("ALL");
		static const TCHAR* const CMD_SOLID_TYPE_NONE		= _T("NONE");
		namespace NeedType {
			enum {
				SPRITE_ID,
				HIT_RECT,
				HP_RATE,
				POWER_RATE,
				BLOW_RATE,
				MAX_NUM
			};
		}
		static const TCHAR CMD_FLAGS[][30] = {
			_T("ReturnAtEdge"),
			_T("NoRecognize"),
			_T("HasDead"),
			_T("HitToPlayer"),
			_T("HitToShot"),
			_T("Invinsible"),
			_T("Gravity"),
			_T("SuperArmor"),
			_T("JumpOverCollision"),
		};
	}

	namespace EnemyFlagType {
		enum {
			//  0
			RETURN_AT_EDGE,			//! RɗԂǂ
									//! (default:false)
			NO_RECOGNIZE,			//! ɋCÂȂԂۂH(trueONCÂȂԁj
									//! (default:false)
			HAS_DEAD,
									//! (default:false)
			HIT_TO_PLAYER,
									//! (default:true)
			HIT_TO_SHOT,
									//! (default:true)
			//  5
			INVINSIBLE,				//! uY̓GvGǂ
									//! (default:false)
			GRAVITY,
									//! (default:true)
			SUPER_ARMOR,
									//! (default:false)
			JUMP_OVER_COLLISION,
									//! (default:false)
			// 10
			MAX_NUM
		};
	}
	static bool DEFAULT_ENEMY_FLAGS[] = {
		true,
		false,
		false,
		true,
		true,
		// 5
		false,
		true,
		false,
		false,
		// 10
	};
	static const char* const ENEMY_SETTING_FILE_PATH = _T("data/image/Enemy/EnemySetting.dat");
}

#endif
