#include "GEnemyManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>

using namespace std;
using namespace GEnum;

bool GEnemyManager::checkHitToTarget( GEnemy* lpEnemy, HPLShootingObject* lpTarget ) {
//	HPLShootingObject* lpTarget = lpEnemy->getTarget();

#ifdef _DEBUG
	ASSERT_IT_NULL( lpTarget);
//	HPLError::assertIt( lpTarget != NULL );
#endif
	// ftHgŏ
	bool bIsRidableEnemy =
		lpEnemy->getType() == EnemyType::SORROW_CLOUDS;
	
	// 鏈
	if( lpEnemy->m_SolidData.getType() != SolidType::NONE || // solid or
		bIsRidableEnemy )	// ridable
	{
		CollisionState stateX,stateY;
		lpEnemy->setVelocityAngle(0,0);
		// 鏈
		bool bIsRided = getStaticData()->rideOnObject( lpTarget, lpEnemy, 
			stateX, stateY );

		if( bIsRided ) {	// ꂽ
			switch( lpEnemy->getType() ) {
			case EnemyType::SORROW_CLOUDS:
				// uԂɏn߂
				//lpEnemy->die( lpTarget );
				lpEnemy->changeState( StateType::DYING);
				break;
			}
		}

		// ߂Bqbg͂Ȃ
		return false;
	}

	if( false == this->isHittable( lpTarget, lpEnemy ) ) {	// un hittable
		// do nothing
		return false;
	}

	HPLRect rHitArea = lpEnemy->getHitArea();
	HPLRect rTargetHitArea = lpTarget->getHitArea();

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON ) ;

	if( rHitArea.isShare( rTargetHitArea ) ) {
		// ڐG


		bool bIsSkipGrab = false;	// S^Cvǃqbgɂ
		switch( lpEnemy->getType() ) {
		case EnemyType::SLIME_QUEEN:
			if( lpEnemy->getColor() != 2 ) {
				bIsSkipGrab = true;
			}
			break;
		}



		if( lpEnemy->isHoldingEnemy() && bIsSkipGrab == false  ) {
			// ރ^Cv̓Gł

			if( lpEnemy->isHolding() ) {
				// ł
				return this->grab(lpTarget, lpEnemy );
			} else {
				// łȂ
				if( lpTarget->isHeld() ) {
					// ^[Qbg͂܂Ă
					if( lpTarget->getHeldEnemyID() != lpEnemy->getID() ) {
						// lł

						for( vector<GArmManager*>::iterator ait = lpEnemy->m_vecArmManagers.begin();
							ait != lpEnemy->m_vecArmManagers.end();
							ait ++ )
						{
							GArmManager* lpArmManager = *ait;
							if( lpArmManager->isEnable() ) {
								HPLShootingObject* lpArmHead = lpArmManager->getHead();
								if( lpArmHead->isHolding() && lpTarget->getHeldEnemyID() == lpArmHead->getID() ) {
									// 
									this->freeHold( lpTarget, dynamic_cast<GEnemy*>( lpArmHead ) );

									// ͂ł͎̂̔z
									// D悵Ď͂
									return this->grab(lpTarget, lpEnemy );
								}
							}
								
						}
						// Ȃ
						return false;
					}
				} else {		// **** lpTarget->isHeld()
					// 
					return this->grab(lpTarget, lpEnemy );
				}		// **** lpTarget->isHeld()
			}		// **** lpEnemy->isHolding()
		} else {

			if( lpTarget->isHeld() ) {
				// ʂ̓Gɕ߂܂Ă
				// 
				return false;
			} else {
			
			// qbg
				this->hit( lpTarget, lpEnemy );
			}
		}
	
		return true;
	} else {
		// ڐGȂ
		if( lpEnemy->isHoldingEnemy() ) {
			// ޓG
			// Oꂽ?

			if( lpEnemy->isHolding()) {
				// ꉞ݂ςȂɂ
				return this->grab( lpTarget, lpEnemy );
			}
		} else {
			// ܂ȂG
			// Ȃ
		}
	}

	return false;
}


bool GEnemyManager::isHold(HPLShootingObject* target, GEnemy* enemy){
	return target->isHeld() && enemy->isHolding() && target->getID() == enemy->getHoldTargetID();
}


void GEnemyManager::hit(HPLShootingObject* lpTarget, GEnemy* lpEnemy){
	int nNextState = StateType::DAMAGE;

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );
	// power
	float fDamage = lpEnemy->m_fPower * fLevel;
	// blow
	float fBlowSpeed = lpEnemy->getBlow();

	if( lpTarget->getObjectType() == ObjectType::PLAYER ) {
		GPlayer* lpPlayer = (GPlayer*)lpTarget;
		fDamage *= WEAR_DAMAGE_RAGE[lpPlayer->m_nWearState];
	}
	
	switch( lpEnemy->getType() ) {
	case EnemyType::SLIME_BABY:
	case EnemyType::BLUE_SLIME_BABY:
	case EnemyType::GREEN_SLIME_BABY:
	case EnemyType::YELLOW_SLIME_BABY:
		// ł
		lpEnemy->die( lpTarget );
		return;
	case EnemyType::YELLOW_SLIME:
		nNextState = StateType::DAMAGE_ELEC;
		break;
	case EnemyType::SLIME_QUEEN:
		if( lpEnemy->getState()->isFlyingState() || 
			lpEnemy->getState()->getState() == StateType::WALK )
		{
			// U̓Abv
			fDamage *= SLIME_QUEEN_FLYING_DAMAGE_RAGE;
		}

		if( lpEnemy->getColor() == 3 ) {
			// F
			nNextState = StateType::DAMAGE_ELEC;
		}
		break;
	case EnemyType::LAVA:
	case EnemyType::LAVA_UNDER:
		nNextState = StateType::SWIM;
		break;
	}

	// _[W^
	getStaticData()->damageObject( lpTarget, lpEnemy, fDamage, true, nNextState);

	// TODO 


	// ΂
	switch( lpEnemy->getType() ) {
	case EnemyType::CYCLON:
		{
			// ^ɐ
			const float SPEED = 20;
			HPLVector vVel = lpTarget->getVelocityAngle();
			vVel.setY(-SPEED);
			lpTarget->setVelocityAngle( vVel );
		}
		break;
	default:
		HPLActionMoveTool::blowAway( lpEnemy, lpTarget, fBlowSpeed );
	}


	if( lpTarget->getObjectType() == ObjectType::PLAYER ){
		// ^[Qbg̓vC[ł
		GPlayer* lpPlayer = ((GPlayer*)lpTarget);

		// TODO
		switch( lpEnemy->getType() ) {
		case EnemyType::SLIME:
			break;
		case EnemyType::GREEN_SLIME:
			// 
			lpPlayer->setPoison(true );
			break;
		}
	}

	// G
	if( lpEnemy->getType() == EnemyType::TANYA ||
		lpEnemy->getType() == EnemyType::TANYA_YOUJO )
	{
		// S
		lpEnemy->die( NULL );
	}
}

/** SJE^̃ZbgJn
  */
void GEnemyManager::resetTargetHoldCounter( HPLShootingObject* lpTarget, GEnemy* lpEnemy ) {
	ASSERT_IT_EQUAL( lpTarget->getObjectType(), ObjectType::PLAYER );
//	HPLError::assertIt( lpTarget->getObjectType() == ObjectType::PLAYER);

	GPlayer* lpPlayer = (GPlayer*)lpTarget;
	// HPɑ΂ӂقǂQ[W
	const float HOLD_COUNTER_PER_HP_RATE = 0.1f;

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );
	// Ǧ݂HPɈˑ
	lpPlayer->setHoldCounter( lpEnemy->getHP() * HOLD_COUNTER_PER_HP_RATE * fLevel );

	// ߊlQ[WStart
	lpPlayer->resetHoldCounter();
}

bool GEnemyManager::grab(HPLShootingObject* lpTarget, GEnemy* lpEnemy){

	// ӂقǂ
	if( lpTarget->getObjectType() == ObjectType::PLAYER ) {
		GPlayer* lpPlayer = dynamic_cast<GPlayer*>( lpTarget );

		int nCount = getStaticData()->getScrambleKeyCount( lpPlayer, false );
		// ӂقǂJE^i߂
		if( lpPlayer->stepHoldCounter(nCount).isFinishAnimation ) {
			// ӂقǂJE^I
			// ->Hold 

			// HOLD
			this->freeHold( lpTarget, lpEnemy );

			// ΂
			HPLActionMoveTool::blowAway( lpEnemy, lpTarget, lpEnemy->getBlow() );

			lpPlayer->changeState( StateType::DAMAGE );
			// G
			lpPlayer->startInvinsible();

			// Wv\ɂ
			lpPlayer->getJumpManager()->resetJumpNumMax();

			return false;
		}
/*		for( int i = 0; i < KeyMap::MAX_KEY; i ++ ) {


			if( lpPlayer->isPressedNow( i ) ) {

			}
		}*/
	}

	// TODO PlayerȂꍇ
	GPlayer* lpPlayer = (GPlayer*)lpTarget;
	if( lpPlayer->isHeld() == false ) {
		// ߂܂
		// ->ߊlQ[WX^[gI
		this->resetTargetHoldCounter( lpPlayer, lpEnemy );

	}

	lpEnemy->setHolding( true);
	lpTarget->setHeld( true);
	lpTarget->setHoldEnemyType( lpEnemy->getType() );
	lpTarget->setHeldEnemyID( lpEnemy->getID());
	lpEnemy->setHoldTargetID( lpTarget->getID() );

	int nNextEnemyState = StateType::HOLD;
	switch( lpEnemy->getType() ) {
	case EnemyType::ARAKHNE:
		nNextEnemyState = StateType::HOLD_DOWN;
		break;
	case EnemyType::WORM:
		nNextEnemyState = StateType::HOLD_DOWN;
		if( lpEnemy->getHoldType() < 0 ) {
			lpEnemy->setHoldType(0);
		}
		break;
	}

	lpEnemy->changeState( nNextEnemyState );

	HPLVector vDelta = this->setGrabTargetPosition(lpTarget, lpEnemy );

	// ߂܂̏
	int nNextState = StateType::HOLD_DOWN;
	switch( lpEnemy->getType() ) {
	case EnemyType::IVY_2:
	case EnemyType::IVY:
	case EnemyType::ARAKHNE:
		nNextState = StateType::DAMAGE;
		break;
	case EnemyType::LAMIA:
	case EnemyType::ROPER:
	case EnemyType::SUCCUBUS:
	case EnemyType::SUCCUBUS_MISAGO:
		nNextState = StateType::DISAPPEAR;
		break;
	case EnemyType::WORM:
		switch( lpEnemy->getHoldType() ) {
		case 0:
			nNextState = StateType::HOLD_DOWN;
			break;
		case 1:
			nNextState = StateType::EATENING;
			break;
#ifdef _DEBUG
		default:
			ASSERT_IT_TYPE( lpEnemy->getType(), "Enemy type");
//			HPLError::assertIt(false);
#endif
		}
		break;
	case EnemyType::MEDOUSA:
		nNextState = StateType::EATENING;
		break;
	}

	HPLSequence* lpSeq = lpEnemy->getSequence();

	float fLevel = getStaticData()->m_Game.getLevel(LEVEL_EPSILON );


	if( (lpSeq->getFrameIndex() == 1 && lpSeq->getStepCounter() == 1 ) ) {
		// damage
		float fDamage = lpEnemy->m_fPower * fLevel * HOLD_DAMAGE_RATE;
		lpPlayer->damage( fDamage, lpEnemy, false, nNextState );

		int KUTYA_SES[] = {
			SE::KUTYA_0,
			SE::KUTYA_1,
			SE::KUTYA_2,
		};
		int nSE = KUTYA_SES[ HPLMath::nextInt(0, SIZEOF( KUTYA_SES ) ) ];
		switch( lpEnemy->getType() ) {
		case EnemyType::BEE:
			{
				// color
				switch( lpEnemy->getColor() ) {
				case EnemyBeeColor::YELLOW_V:
					break;
				case EnemyBeeColor::RED_B:	// red
					// sakusaku
					nSE = SE::SAKU;
					break;
				}
			}
			break;
		case EnemyType::IVY:
		case EnemyType::IVY_2:
			nSE = SE::GIRI;
			break;
		}
		// se
		getStaticData()->m_MixerManager.play( nSE, false );
	} else {
		lpPlayer->changeState( nNextState );
	}
	switch( lpEnemy->getType() ) {
	case EnemyType::NAMAKO:
	case EnemyType::SLIME_QUEEN:
	case EnemyType::GREEN_SLIME:
		// XCb`
		// TODO

		//lpPlayer->m_nWearState = WearStateType::NAKED;
		break;
	case EnemyType::WORM:
		break;
	}

	vDelta.add( lpEnemy->getCenter() );
	lpTarget->setCenter( vDelta );

	// 
	this->setGrabTargetFace( lpTarget, lpEnemy );

	// ΍W
//	bool bIsHoldingThisTarget = lpTarget->isHeld();

	return true;
}

/** 񂾑̕mFύX
  * @retval ݒ肵Target̕
  */
int GEnemyManager::setGrabTargetFace( HPLShootingObject* lpTarget, GEnemy* lpEnemy ) {
	int nFaceDirection = lpEnemy->getFaceDirection() * -1;
	lpTarget->setFaceDirection( nFaceDirection );
	return nFaceDirection;//FaceDirection::LEFT;
}

/** 񂾂Ƃ̑Έʒuݒ
  * @retval ݒ肵Έʒu
  */
HPLVector GEnemyManager::setGrabTargetPosition( HPLShootingObject* lpTarget, GEnemy* lpEnemy ) {
	int nDX = 10;
	int nDY = 0;

	switch( lpEnemy->getType() ) {
	case EnemyType::ZOMBIE:
		nDX = 15;
		nDY = 3;
		break;
	case EnemyType::ARAKHNE:
		nDX = 30;
		nDY = 0;
		break;
	case EnemyType::LAMIA:
	case EnemyType::ROPER:
	case EnemyType::SUCCUBUS:
	case EnemyType::SUCCUBUS_MISAGO:
		// use default
		// ̌^Ȃ̂Ŋ֌WȂ
		break;
	case EnemyType::GREEN_SLIME:
		// use default
		break;
	case EnemyType::IVY:
	// case EnemyType::ELEC_IVY:
		nDX = -15;
		nDY = -40;
		break;
	case EnemyType::IVY_2:
		nDX = 130;
		nDY = 0;
		break;
	case EnemyType::BEE:
		nDX = 0;
		nDY = -15;
		break;
	case EnemyType::WORM:
		switch( lpEnemy->getHoldType() ) {
		case 0:
			nDX = 80;
			nDY = 20;
			break;
		case 1:
			break;
		}
		break;


	/*
	case EnemyType::GATE_FLOWER:
		nDX = -20;
		nDY = -46;
		break;
	case EnemyType::EATER:
		nDX = 15;
		nDY = -35;
		break;
	*/
	}

	return HPLVector(nDX,nDY);
}

void GEnemyManager::freeHold( HPLShootingObject* lpTarget, GEnemy* lpEnemy ) {
	this->freeEnemyHold( lpEnemy );
	this->freeTargetHeld( lpTarget );
}
void GEnemyManager::freeEnemyHold( GEnemy* lpEnemy ) {
	lpEnemy->setHoldTargetID( -1 );
	// common:ʏԂɖ߂
/*	if( lpEnemy->getState()->isAttackState() ||
		lpEnemy->getState()->isHoldState() )
	{*/
		// U
		lpEnemy->changeState( StateType::STAND );
//	}
	lpEnemy->setHolding( false );
	lpEnemy->setHoldType(-1);

	switch( lpEnemy->getType() ) {
	case EnemyType::SLIME_QUEEN:
		{
			// slime queen
			// change color
			if( lpEnemy->getColor() == 2 ) {
				lpEnemy->setColor(3);
			}
		}
		break;
	}
}
void GEnemyManager::freeTargetHeld( HPLShootingObject* lpTarget ) {
	// common:ID
	lpTarget->setHeldEnemyID( -1 );


	// common:
	lpTarget->setHeld( false );

	// ^[Qbgɖ߂
	//if( lpTarget->getState()->isHeldState() ) {
	if( lpTarget->getObjectType() == ObjectType::PLAYER ) {
		
		((GPlayer*)lpTarget)->rollBackState();
	} else {
		lpTarget->changeState( StateType::STAND );
	}
	//}
	
	//G
	lpTarget->startInvinsible();
}

/** ڐG/݉\
  */
bool GEnemyManager::isHittable( HPLShootingObject* lpTarget, GEnemy* lpEnemy) {

	// cheatȂ؂Ȃ
	if( getStaticData()->m_Game.isCheat() ) {
		return false;
	}

	if( lpEnemy->isAlive() == false ) {
		// GłƂ
		
		if( lpTarget != NULL ) {
			if( this->isHold( lpTarget, lpEnemy ) ) {
				this->freeTargetHeld( lpTarget );
			}
		}
		// 
		this->freeEnemyHold( lpEnemy );
		// 
		return false;
	}
/*	HPLShootingObject* lpTarget = lpEnemy->getTarget();*/
	if( lpTarget == NULL ) {	// no target
		// null
		return false;
	}

	if( //false == lpEnemy->isHitToPlayer() ||
		false == lpEnemy->getObjectAttribute( ObjectAttribute::HIT_TO_PLAYER ) )	// not hit to player
	{
		// vC[ɐڐGȂ^Cv
		return false;
	}
	if( lpTarget->isInvinsible() ) {	// player is invinsible
		if( lpEnemy->getType() == EnemyType::LAVA ||		// lava
			lpEnemy->getType() == EnemyType::LAVA_UNDER )	// lava under
		{
			if( lpTarget->getObjectType() == ObjectType::PLAYER ) {
				HPLRect rPlayerHitArea = lpTarget->getHitArea();
				HPLRect rHitArea = lpEnemy->getHitArea();
				if( rHitArea.isShare( rPlayerHitArea ) ) {
					GPlayer* lpPlayer = (GPlayer*)lpTarget;
					lpPlayer->changeState( StateType::SWIM );
				}
			}
		}
		// G
		return false;
	}

	if( lpTarget->getState()->isIgnoreAfterDie() ) {	// special (dead) state
		// vC[ڐGȂ
		return false;
	}

	if( lpEnemy->getState()->isDeadState() ) {	// dead
		// SԂȂ牽Ȃ
		return false;
	}

	switch( lpEnemy->getType() ) {
	case EnemyType::TANYA:
	case EnemyType::TANYA_YOUJO:
		if( lpEnemy->isInvinsible() ) {
			// GGԂȂRb`ڐGȂ
			return false;
		}
		break;
	}

	switch( lpTarget->getObjectType() ) {
	case ObjectType::PLAYER:
		{
			GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
			if( lpPlayer->getSuperPowerType() == SuperPowerType::WIND_WIZARD ) {
				// Wizard
				if( lpPlayer->getWeapon()->m_Energy.getRemain() > 0 ) {
					// V[hWJ
					// GƂ̏Փ˂͖B
					return false;
				}
			}
		}
		break;
	}
	return true;
}

void GEnemyManager::fan( GEnemy* lpEnemy, HPLShootingObject* lpTarget, float fBrustRate ) {
	
	// ĂꍇĂ΂B

	if( lpEnemy->getBrustType() == BrustType::NONE ) {
		// ΂\͂Ȃ
		// ->A
		return;
	}

//	HPLShootingObject* lpTarget = lpEnemy->getTarget();
	
	HPLRect rPlayerHitArea = lpTarget->getHitArea();
	HPLRect rBrustArea = lpEnemy->getBrustArea();

	if( rBrustArea.isShare( rPlayerHitArea ) ) {
		// ڐG
		// ->΂s

		// ߂

		HPLVector vBrustVel;

		switch( lpEnemy->getBrustType() ) {
		case BrustType::REPULSE_X:	// ˗
		case BrustType::ATTRACT_X:	// 
			{
				int nFaceDirection = lpEnemy->getFaceDirection();
				float fWidth = nFaceDirection == FaceDirection::RIGHT ? 
					lpTarget->getCenter().getX() - rBrustArea.getX() :
					rBrustArea.getRight() - lpTarget->getCenter().getX()
				;
				if( lpEnemy->getBrustType() == BrustType::ATTRACT ) {
					nFaceDirection *= -1;
				}
				// ɂĈЗ͂ς
				float fRate = fWidth / rBrustArea.getWidth();
				// x
				float fSpeed = lpEnemy->getBrustMaxSpeed() * (1-fRate) * fBrustRate;
				vBrustVel.set(fSpeed * nFaceDirection , 0);
			}
			break;
		case BrustType::REPULSE:
		case BrustType::ATTRACT:
		default:
#ifdef _DEBUG
			ASSERT_IT_TYPE( lpEnemy->getBrustType(), "Brust type");
//			HPLError::assertIt(false);
#endif
			// ۗ
			return;
		}
		HPLVector vTargetVel = lpTarget->getVelocityAngle();
		vTargetVel.add( vBrustVel );
		lpTarget->setVelocityAngle( vTargetVel );
		
	}
}
