#ifndef _G_ENEMY_MANAGER_
#define _G_ENEMY_MANAGER_

#include <hpllib/cycle/HPLObjectManager.h>
#include <hpllib/game/HPLAttackInformation.h>

#include "GPlayer.h"

#include "GEnemy.h"

#include <string>

#include "GEnum.h"

#include "GEnemyConsts.h"

using namespace std;

static const float ENEMY_SPEED_SLOW_X = 2.f;	//TODO


/*
	OɎčs
	sprite id
	HitRect
	Size
	HPRate
	PowerRate
	AllyType	{Ally|Enemy}
*/

class GEnemySetting {

	// Member vriable
public:
	
	int			m_nSpriteID;			//! XvCgID
	HPLRect		m_HitRect;				//! A^̈
	float		m_fHPRate;				//! HP(ftHg1=HP100)
	float		m_fPowerRate;			//! ڐGU͔(ftHg1=Power5)
	float		m_fBlowRate;			//! ӂƂ΂͔(ftHg1=Blow3)
	int			m_nSolidableType;		//! ł߉\AR邩ǂ̔f
										//! true	:L
										//! false	:BRił܂Ȃjidefaultj
										//! ftHgł͑Sfalse
										//! rbgtO(2iF011011)`
	bool		m_aryFlags[GEnum::EnemyFlagType::MAX_NUM];
	
	// Constructor
public:
	GEnemySetting(){
		this->clear();
	}
	void clear() {
		this->m_nSpriteID = GEnum::SpriteType::ENEMY_SPRITE_START;
		this->m_HitRect.set(0,0,2,2);
		this->m_fHPRate = 1;
		this->m_fPowerRate = 1;
		this->m_fBlowRate = 1;
		for( int i = 0; i < GEnum::EnemyFlagType::MAX_NUM; i ++ ) {
			this->m_aryFlags[i] = GEnum::DEFAULT_ENEMY_FLAGS[i];
		}
		this->m_nSolidableType = 0;
	}
	~GEnemySetting(){}
};

/** Cto[\
  */
class BossHPData {
public:
	float m_fRate;
	int m_nBerserkLevel;
	BossHPData(){
		this->m_fRate = 0;
		this->m_nBerserkLevel = 0;
	}
};
/** AIp
  */
class GEnemyAIResult {
public:
	bool m_bIsChase;
	HPLVector m_vGoalPosition;
	float m_fChaseAccel;
	float m_fChaseMaxSpeed;
	bool m_bIsFaceToPlayer;
	GEnemyAIResult() {
		this->m_bIsChase = false;
		this->m_fChaseAccel = 0;
		this->m_fChaseMaxSpeed = 0;
		this->m_bIsFaceToPlayer = false;
	}
};

/** GǗ}l[W
  */
class GEnemyManager: public HPLObjectManager<GEnemy> {
private:
	//! G̍Up^[
	std::map<int,HPLAttackInformation*> m_mapAttackInformations;

	map<int, GEnemySetting>	m_vecEnemySettings;		//! G
	vector<GEnemy*>			m_vecTargettedEnemy;	//! ^[QbeBOꂽGXg
	int						m_nTargettedIndexStep;	//! ^[QbeBO
	vector<GEnemy*>			m_vecAdds;				//! ǉiprocessœGG𐶐ꍇɎgpB
	
	vector<string>			m_vecEnemyNames;		//! U̓G̖O
	vector<BossHPData>			m_vecBossLifeBarRates;	//! {X̗͕\p

	map<int,HPLMatrix<int>* > m_mapCoordPositions;	//! {XȂǂ̋Kʒuwps

public:	// getter setter
	HPLMatrix<int>* getCoordPosition( int nEnemyPositionType );

	HPLAttackInformation* getAttackInformation( int nIndex ) {
		if( this->m_mapAttackInformations.find( nIndex ) == this->m_mapAttackInformations.end() ) {
			return NULL;
		}
		return this->m_mapAttackInformations[nIndex];
	}
	// enemy setting/names
	string getEnemyName( int nIndex );
	GEnemySetting* getEnemySetting( int nIndex ) {
		return &this->m_vecEnemySettings[nIndex];
	}
	/** ^[QbgΏۂ犮S_ɑΏۂI
	  */ 
	GEnemy* getRandomTargettedEnemy();

	/** Ă΂xɁA̓GI
	  */
	GEnemy* getStepTargettedEnemy();

	/** ԋ߂GI
	  */
	GEnemy* getNearestTargettedEnemy( HPLVector vFrom );

public:	// constructor
	GEnemyManager();
	virtual ~GEnemyManager(){
		for( std::map<int,HPLAttackInformation*>::iterator it = this->m_mapAttackInformations.begin();
			it != this->m_mapAttackInformations.end();
			it ++ )
		{
			delete it->second;
			it->second = NULL;
		}
		this->m_mapAttackInformations.clear();
	}

private:	// operation private
	/** vC[̂鏈
	  * @param[in]	fBrustRate		ёx̊iFFAN_BIRD̐ёx͂Ȃ荂j
	  */
	void fan( GEnemy* lpEnemy, HPLShootingObject* lpTarget, float fBrustRate );
	void getEnemyCoordGoalPos( HPLVector& vGoalPos, int nCoordX, int nCoordY,
								   int nTileSize );
	//void setEnemyGoalAndVelocity( int nIndex, int aryCoordMatrix[][2], GEnemy* lpEnemy );
	void setEnemyGoalAndVelocity( int nIndex, HPLMatrix<int>* lpMat, GEnemy* lpEnemy );

	/** KvȂ猸
	  * @retval	true	
	  */
	bool checkAndReduceSpeed( GEnemy* lpEnemy );

public:	// operation public
	void setVelocityByGoal( HPLVector& vCenterFrom, HPLVector& vVelocityAngle, HPLVector vGoalCenter,
		int nFrameCount, float& fResist);
	// override
	void process( bool isMove, bool bIsAI );
	/** create
	  * @param[in]	nGenerateType	Gɂ
									ʏ		FG̎(GenerateType::)
									A[i	Fԍ
	  */
	GEnemy* create(int t, HPLVector center, int nGenerateType);

	/** 쐬邪AXgɂ͒ǉȂ(m_vAddsɂǉȂ)
	  */
	GEnemy* createWithoutAdd( int t, HPLVector center, int nGenerateType );

	/** s 
	  */
	void algorithm(GEnemy* lpEnemy);

	/** ^[QbgƂ̐ڐG
	  */
	bool checkHitToTarget( GEnemy* lpEnemy, HPLShootingObject* lpTarget );

	/** eƂ̐ڐG
	  */
	bool checkHitToShot( GEnemy* lpEnemy, int nParentFaceDirection = 0 );

	/** EnemyƂ̐ڐG
	  */
	bool checkHitToOther( GEnemy* lpEnemy );

	/** ړ
	  * 󒆂ǂŉx𒲐Ĉړ
	  * CRɂ錸͍sȂBreduce*֘A𖾎IɎgp
	  * @param[in,out]	vVelocityAngle		ړʁivZĕύXj
	  * @param[in]		nDirection			ړ
	  * @param[in]		lpTrigger			gKiڒnj
	  * @param[in]		fAccel				x
	  * @param[in]		fMaxSpeed			ő呬x
	  * @param[in]		bIsNoAirMoving		󒆂ł͐ȂB
	  */
	void accelMoveX( HPLVector& vVelocityAngle, int nDirection, HPLTrigger* lpTrigger, float fAccel,
//			float fResist,
			float fMaxSpeed, bool bIsNoAirMoving );

	/** ʏ̃qbg
	  */
	void hit(HPLShootingObject* lpTarget, GEnemy* lpEnemy);

	/** ޏ
	  * @retval		true		͂
	  * @retval		false		ӂقǂꂽ
	  */
	bool grab(HPLShootingObject* lpTarget, GEnemy* lpEnemy);


	/** ł邩ǂ̃`FbN
	  * @retval	true	ł
	  * @retval	false	łȂ
	  */
	bool isHold(HPLShootingObject* lpTarget, GEnemy* lpEnemy);

	/** 񂾑̕mFύX
	  * @retval ݒ肵Target̕
	  */
	int setGrabTargetFace( HPLShootingObject* lpTarget, GEnemy* lpEnemy );
	
	/** 񂾂Ƃ̑Έʒuݒ
	  * @retval ݒ肵Έʒu
	  */
	HPLVector setGrabTargetPosition( HPLShootingObject* lpTarget, GEnemy* lpEnemy );

	/** 
	  */
	void freeHold( HPLShootingObject* lpTarget, GEnemy* lpEnemy);
	void freeEnemyHold( GEnemy* lpEnemy );
	void freeTargetHeld( HPLShootingObject* lpTarget );

	/** ڐG/݉\
	  */
	bool isHittable( HPLShootingObject* lpTarget, GEnemy* lpEnemy);

	/** Wv
	  * @param[in]	vx,vy	Wvx
	  * @param[in]	bIsJumpableInAir	󒆂ŃWv\
	  * @param[in]	bIsAccelType		^WvB
	  *									false	:ڈړxɐݒ肳邽߁A΂ɂȂ
	  */
	void jump( GEnemy* lpEnemy, float vx, float vy, bool bIsJumpableInAir, bool bIsAccelType );

	/** ڕWChaseiVGpj
	  */
	void chase( GEnemy* lpEnemy, HPLVector vGoalPosition, float fAccel, float fMaxSpeed );
	// TODO ʉ
	/** 炭AI
	  */
	void doSlimeQueenAlgorithm( GEnemy* lpEnemy );
	/** AElAI
	  */
	void doAlrauneAlgorithm( GEnemy* lpEnemy );
	void doAryonaAlgorithm( GEnemy* lpEnemy );

	/** neŵāAŒǉĂ炤B
	  * IIIEnemyManager::processĂ΂Ă֐ȊOŌĂ΂ȂB
	  * IIIǉꂸA[N
	  */
	void add( GEnemy* lpEnemy ) {
		this->m_vecAdds.push_back( lpEnemy );
	}

	/** vC[ւ̈ړ
	  */
	void moveToTarget(GEnemy* lpEnemy, float fSpeedRate, bool bIsJumpOverCollision );
	void faceToTarget( GEnemy* lpEnemy );

	/** {XHP\
	  */
	void drawBossHP();

	/** ubNɕ`
	  */
	void drawEnemyBack();

	void doMerakoAlgorithm( GEnemy* lpEnemy );
	void doMerakoMeet( GEnemy* lpEnemy, GEnemyAIResult& result );
	void doMerakoBattle( GEnemy* lpEnemy,GEnemyAIResult& result);

	void doAikoAlgorithm( GEnemy* lpEnemy );
	void doChaserAlgorithm( GEnemy* lpEnemy );
	void doChaser01Move( GEnemy* lpEnemy );
	void doChaser02Move( GEnemy* lpEnemy );
	void doGhostPairAlgorithm( GEnemy* lpEnemy );
	void doEllinAlgorithm( GEnemy* lpEnemy );
	void doDragonAlgorithm( GEnemy* lpEnemy );
	//void do

	/** SJE^̃ZbgJn
	  */
	void resetTargetHoldCounter( HPLShootingObject* lpTarget, GEnemy* lpEnemy );

	/** Chaser˂Vbg̏oʒuvZ
	  */
	void getChaserHandFrom( HPLVector& vFrom, int nFaceDirection, HPLVector& vCenter, int nAttackType );

	/** Ԋuł̔
	  * lpIntervalCounter̃t[xlpShotCounter̃JEg񐔂̐삳B
	  * @param[in,out]	lpIntervalCounter	VbgԊu
	  * @param[in,out]	lpShotCounter		ˉ
	  * @param[out]		bIsShot				˃^C~O
	  * @param[out]		bIsEnd				SVbgI
	  * @param[in]		nIntervalStep		1̃XebvŃJEgXebviʏ1j
	  * 
	  */
	void commonIntervalShot( HPLCounter* lpIntervalCounter, int nIntervalStep, HPLCounter* lpShotCounter,
		bool& bIsShot, bool& bIsEnd );
	/** Gɑ΂CR
	  * @param[in]	fRate	Ɋωꍇ
	  */
	float getEnemyAirResist( float fRate );

	/** amplitude(㉺^)𑬓x݂̂ōsB
	  * ԑƂꂪЂǂȂB{XȂǁAZԂ̂ݗp
	  */
	void amplitudeByVelocity( GEnemy* lpEnemy );

};

#endif
