#include "GEnum.h"

namespace GEnum {
	const float SCROLL_LENGTH_TO_SPEED_RATE = 0.05f;	//! XN[̈ړxɂ銄
	const float UNDER_PLAYER = 50.f;
	const float FOOT_PLAYER = 20.f;
	const float IN_WATER_RESIST_RATE = 5.f;
	const float IN_WATER_GRAVITY_RATE = 0.05f;
	const float JUMP_FIRST_SPEED_RATE = 0.5f;	//! x
	const float SELECT_PLAYER_WALK_SPEED = 6;
	const float SELECT_PLAYER_GOAL_THRESHOLD = 6;
	const float MOVER_SPEED_X = 3;			//! Mover̈ړx(X)
	const float MOVER_SPEED_Y = 3;			//! (Y)
	const int MOVER_WAIT_FRAME = 30;			//! ڐG̃EGCg
	const float LEVEL_EPSILON = 0.0001f;
	const float WIND_SPEED_Y = 3;
	const float WIND_SPEED_DELTA_Y = 2;
	const float WIND_SPEED_X = 3;
	const float WIND_SPEED_DELTA_X = 2;
	const float GATLING_SPD = 20;
	const float GATLING_ERR = 0.1f;
	const float BLOCK_BITE_DAMAGE = 10.f;
	const int BLOOD_RND_MIN = 3;
	const int BLOOD_RND_MAX = 10;
	const float BLOOD_ERR_DEGREE = 60;
	const float BLOOD_SPEED_RND_MIN = 5;
	const float BLOOD_SPEED_RND_MAX = 10;
	const int BLOOD_DELTA_MAX_X = 10;
	const int BLOOD_DELTA_MAX_Y = 15;
	const int BLOOD_DELTA_Y_BASE = 10;
	const int COLLISION_OBJECT_HIT_AREA_DELTA = 0;
	const int COLLISION_OBJECT_HIT_AREA_DELTA_BOTTOM = 5;
	const float MAX_BRUST_ACCEL_Y = 8.f;
	const float MAX_BRUST_ACCEL_X = MAX_BRUST_ACCEL_Y * 1.5f;
	const int FAN_BRUST_LENGTH = 256;

	const float SELECT_STAR_THRESHOLD = 100.f;
	const float SELECT_STAR_MOVE_SPEED = 4.f;
	const float SELECT_STAR_MOVE_ACCEL = 0.1f;
	const int HP_METER_LEFT = 10;
	const int HP_METER_TOP = 10;
	const float PLAYER_LADER_DX = 300;
	const float PLAYER_LADER_DY = 30;
	const int HOMING_LASER_2_DEACCEL_FRAMES = 30;
	const float HOMING_LASER_ACCEL = 5.f;
	const float HOMING_MISSILE_ACCEL = 3.f;
	const int TARGETTING_REMAIN_COUNT = 80;
	const float HOVER_WEAPON_GRAVITY_RATE = 0.05f;
	const float BED_JUMP_VELOCITY_Y = 4.f;
	const float KILLER_FAN_DAMAGE = 1.f;
	const float KILLER_FAN_BRUST_SPEED_RATE = 0.5f;
	const int PLAYER_INVINSIBLE_FRAMES = 90;
	const float ENEMY_NEAR_THRESHOLD = 10.f;
	const int EMOTION_ICON_DELTA_X = 30;
	const int EMOTION_ICON_DELTA_Y = -30;
	const float BOUNCE_DAMAGE_TO_BED = 10;
	const char* const SE_LIST_FILE_PATH = "data/se/SE.txt";
	const char* const MUSIC_LIST_FILE_PATH = "data/music/Music.txt";
	const float ITEM_NEAR_DISAPPEAR_RATE_THRESHOLD = 0.3f;
	const int ITEMS_PER_ROW_IN_MENU = 10;
	const int ITEM_LEFT_IN_MENU = 120;
	const int ITEM_TOP_IN_MENU = 100;
	const int ITEM_WIDTH_IN_MENU = 50;
	const int ITEM_HEIGHT_IN_MENU = 60;
	const int ITEM_INTERVAL_X_IN_MENU = 5;
	const int ITEM_INTERVAL_Y_IN_MENU = 5;
	const int ENEMY_GENERATE_INTERVAL_BASE = 120;	//! G
	const int ENEMY_GENERATE_INTERVAL_ERROR = 50;
	const float KOKEMOMO_CURE = 10.f;
	const float MEAT_CURE = 80.f;
	const float EVIL_DRINK_CURE = 100.f;
	const float EVIL_DRINK_GAGE_ADD = 10.f;			//! т鉻Q[W(test)
	const float EVIL_DRINK_ORB_GET = 1;			//! I[u炦邩
	const int EVIL_BEAM_GAGE_ADD = 5.f;			//! тr[󂯂đ
	const float MAZER_DISTANCE = 100;
	const float MAZER_ACCEL = 1.f;
	const float MAZER_MAX_SPEED = 20;
	const float ENEMY_MOVE_ACCEL = 3.f;
	const float ENEMY_JUMP_SPEED = 8.f;
	const float SCROLL_LENGTH_LIMIT = 300.f;
	const int PLAYER_HP_MAX = 100;//!
	const float PLAYER_HALF_HP_THRESHOLD_RATE = 0.5f;	//! p̃Cxg
	const float PLAYER_QUARTER_HP_THRESHOLD_RATE = 0.25f;	//! p̃Cxg
	const int MAX_EVIL_GAGE = 100;
	const int DEFAULT_MAX_EVIL_ORB_NUM = 3;
	const int MAX_ORB_CARRIABLE_NUM = 12;
	const float CURE_EFFECT_CREATE_RADIUS_MIN = 0;	//! ڐG_ǂꂾ炷
	const float CURE_EFFECT_CREATE_RADIUS_MAX = 60;
	const float CURE_EFFECT_CREATE_VELOCITY_MIN = 2;	//! 
	const float CURE_EFFECT_CREATE_VELOCITY_MAX = 0;
	const int CREATE_CURE_EFFECT_NUM_MIN = 4;		//! 쐬CUREGtFNg̐
	const int CREATE_CURE_EFFECT_NUM_MAX = 5;
	const float CURE_FLOW_UP_SPEED_MIN = 0.1f;		//! ㏸x
	const float CURE_FLOW_UP_SPEED_MAX = 0.3f;
	const float RESIST_IN_THE_AIR_RATE = 0.5f;
	const float SELECT_VTOL_THRESHOLD = 100.f;
	const float SELECT_VTOL_SPEED = 5.f;
	const float LEVELS[LevelType::MAX_NUM] = {
		0.3f,
		0.5f,
		1.f,
		1.5f,
		2.f
	};
	const int DEFAULT_REMAIN_NUM = 3;
	const int MAX_REMAIN_NUM = 8;			//! ݒ\ȍőc@
	const float CURE_STAR_SIZE_RATE_MIN = 0.5f;
	const float CURE_STAR_SIZE_RATE_MAX = 2.f;
	const float CURE_STAR_DEFAULT_SPEED = 4.f;
	const int CURE_STAR_NUM_MIN = 0;
	const int CURE_STAR_NUM_MAX = 2;
	const int CONTINUE_CURSOR_X = 100;
	const int CONTINUE_CURSOR_Y = 200;
	const int PUSH_R_LEFT = 500;
	const int PUSH_R_TOP = 100;
	const float ACHIEVEMENT_FLOW_UP_SPEED = 5;
	const float ACHIEVEMENT_FLOW_DOWN_SPEED = 5;
	const float TAKARABAKO_ENEMY_JUMP_SPEED_Y = 5;
	const float TAKARABAKO_ENEMY_JUMP_SPEED_X = 3;

	const int MISSILE_CONTRAIL_CREATE_INTERVAL = 3;
//	const float EXPLOSION_SMOKE_SPEED_MIN = 1.f;
//	const float EXPLOSION_SMOKE_SPEED_MAX = 2.f;
	const int ACHIEVEMENT_X = 200;
	const int OPTION_OK_CANCEL_INTERVAL_X = 150;
	const int ENEMY_HP_METER_DELTA_Y = 50;
	const char* const ACHIEVEMENT_FILE_PATH = "data/achievements.dat";
	const float ENEMY_POWER_BASE = 5;	//! ڐGU
	const float ENEMY_BLOW_BASE = 3;		//! ёx
	const float ENEMY_HP_BASE = 100;
	const float CONTINUE_CURSOR_INTERVAL_X = 200;	//! ReBj[ʂ̃J[\̈ړ
	const int START_WAIT_COUNT = 30;
	const int ACHIEVEMENT_ICON_DELTA_X = 10;
	const int ACHIEVEMENT_ICON_DELTA_Y = 10;
	const int ACHIEVEMENT_TEXT_DELTA_X = 80;
	const int ACHIEVEMENT_LABEL_DELTA_Y = 10;
	const int ACHIEVEMENT_DESCRIPTION_START_DELTA_Y = 30;
	const int ACHIEVEMENT_DESCRIPTION_INTERVAL_Y = 30;
	const int ACHIEVEMENT_COUNT_DELTA_X = 150;
	const int ACHIEVEMENT_COUNT_DELTA_Y = 60;
	const int ACHIEVEMENT_SCROLL_ACCEL = 2;
	const int ACHIEVEMENT_SCROLL_MAX_SPEED = 20;
	const float FUYU_RIDING_SPEED_Y = 5;
	const float FUYU_AFTER_RIDE_SPEED = 2;
	const float FUYU_AFTER_RIDE_FLOW_UP_SPEED = 0.5f;
	const int PUNCH_HIT_RECT_SIZE = 40;
	const int PUNCH_HIT_RECT_SIZE_Y = 30;
	const float FUYU_MAX_ACCEL = 2;
	const char* const COMMON_EVENET_PACK_FILE_PATH = "data/event/EventPack.txt";
	const float MISSILE_FIRST_SPEED = 0.3f;
	const float MISSILE_ACCEL = 3.f;
	const float MISSILE_MAX_SPEED = 20.f;
	const float BLUE_SLIME_JUMP_SPEED = 10.f;
	const float BLUE_SLIME_JUMP_DISTANCE_THRESHOLD = 10.f;
	const int SLIME_CLIP_DAMAGE_INTERVAL_MIN = 50;			//! `bv^Ԋu
	const int SLIME_CLIP_DAMAGE_INTERVAL_MAX = 100;
	const float SLIME_CLIP_SPEED_X = 10;
	const float SLIME_CLIP_SPEED_Y = 8;
	const float FUYU_MAX_LENGTH = 10;
	const int SLIME_QUEEN_WAIT_FOR_START = 200;
	const int SLIME_QUEEN_WAIT_FOR_NEXT = 100;
	const int SLIME_QUEEN_SHOT_INTERVAL = 1;
	const float SLIME_QUEEN_RED_ACCEL = 0.5f;
	const float SLIME_QUEEN_MAX_SPEED = 8;
//	const float SLIME_QUEEN_JUMP_SPEED_X = 10;
	const float SLIME_QUEEN_JUMP_SPEED_Y = 10;
//	const int SHOT_GUN_BULLET_NUM_MIN = 5;
//	const int SHOT_GUN_BULLET_NUM_MAX = 10;		//! VbgK1x̔ː
	const float SMOKE_SPEED_Y = 5;
	const float SLIME_QUEEN_SMOKE_DELTA_X = 80;
	const float SLIME_QUEEN_GENERATE_VEL_ERR_X = 5;
	const float SLIME_QUEEN_GENERATE_VEL_Y_MIN = 10;	//! 
	const float SLIME_QUEEN_GENERATE_VEL_Y_MAX = 15;
	const int SLIME_QUEEN_SMOKE_INTERVAL = 1;
	const float SLIME_QUEEN_SMOKE_ERR = 80;
	const int SLIME_QUEEN_SMOKE_MIN = 3;	//! 
	const int SLIME_QUEEN_SMOKE_MAX = 5;
	const int INVINSIBLE_ALPHA = 100;		//! GԒAlpha
	const float EFFECT_HIT_ERR = 3;
	const int ACHIEVEMENT_STAY_FRAME = 200;
	const int ENEMY_BOSS_LIFE_BAR_MERGINE = 80;
	const int ENEMY_BOSS_LIFE_BAR_INTERVAL_X = 10;
	const int ENEMY_BOSS_LIFE_BAR_Y_FROM_BOTTOM = 20;
	const int SELECT_CURSOR_LEFT = 20;
	const int SELECT_CURSOR_TOP = 450;
	const float BLUE_SLIME_JUMP_SPEED_X = 8;
//	const int CURSOR_DELTA_Y = 5;	
	const int ZANZO_CREATE_INTERVAL = 60;
	const int PLAYER_POISON_REMAIN = 50;
	const float POISON_DAMAGE = 5;
	const int POISON_DAMAGE_INTERVAL = 10;
	const int DEFAULT_SUPER_POWER_REMAIN = 1000000;		//! SuperPower̍őliŒj
	const int DEFAULT_SUPER_POWER_DECREASE = 5000;
	const int SLIME_QUEEN_JUMP_NUM = 2;
	const float SLIME_QUEEN_SHOT_SPEED_Y = 6;
	const float HOLD_DAMAGE_RATE = 0.3f;
	const int MENU_SUPER_POWER_LEFT = ITEM_LEFT_IN_MENU;
	//const int MENU_SUPER_POWER_TOP = 350;
	const int MENU_SUPER_POWER_INTERVAL_X = 5;
	const float SLIME_QUEEN_YELLOW_CREATE_PROBABILITY = 5;
	const float SLIME_QUEEN_SHOT_ERR = 1;
	const int SLIME_QUEEN_ARM_NUM = 15;
	const float SLIME_QUEEN_FLYING_DAMAGE_RAGE = 1.5;
	const float SLIME_QUEEN_ARM_SPEED = 0.1f;
	const float SLIME_QUEEN_BERSERK_RATE = 0.3f;
	const float SLIME_CLIP_CLEAR_PROBABILITY = 8;		//! Uقǂm
	const int SLIME_QUEEN_RED_CREATE_WAIT = 3;
	const float SLIME_QUEEN_ARM_DELTA_MAX_LENGTH = 700;
	const float SLIME_QUEEN_GREEN_ARM_UP_X = 50;
	const float SLIME_QUEEN_GREEN_ARM_UP_Y = 100;
	const float SLIME_QUEEN_GREEN_DISON_ACCEL = 1.f;
	const int CREATE_SLIME_CHIP_MIN = 3;
	const int CREATE_SLIME_CHIP_MAX = 5;
	const float SLIME_CHIP_ERR_X = 5;
	const float SLIME_CHIP_ERR_Y_MIN = 8;
	const float SLIME_CHIP_ERR_Y_MAX = 10;
	const float GREEN_SLIME_CLIP_DOWN_RATE = 0.98f;
	const float HOLD_CLEAR_PROBABILITY = 5;
	const float SLIME_QUEEN_SMOKE_ERR_Y = 5;
	const float EVIGEN_LIMIT_AREA_UNDER_BOTTOM_MERGINE = 100;	//! [ǂꂾz玀ʂ
	const float VACUUM_ALL_FRAMES = 15;
	const float SLIME_QUEEN_VACUUM_DEGREE_ERR = 30;
	const float SLIME_QUEEN_VACUUM_LENGTH_MIN = 150;
	const float SLIME_QUEEN_VACUUM_LENGTH_MAX = 200;
	const int BUTTON_BRINK_SPEEDUP_NUM = 5;
	const int GAME_SUPER_POWER_LEFT = 150;
	const int GAME_SUPER_POWER_TOP = 10;
	const float PLAYER_SLIME_CLIP_POWER_RATE = 10;
	const float PLAYER_ANOTHER_DOUBLE_JUMP_PROBABILITY = 5;	//! ςWvm
	const float PLAYER_ROLLING_DOUBLE_JUMP_PROBABILITY = 50;	//! ςWv̂Ƃ
	const float ENEMY_AIR_MOVE_ACCEL_RATE = 0.3f;
	const float PLAYER_GRAVITY_DELTA = 0.25;
	const float THROW_VELOCITY_ANGLE_RATE = 1;
	const float SHOT_GUN_ERR = 0.4f;
	const float FUYU_DISAPPEAR_POSITION_Y = -100;
	const float ROCK_NO_HIT_THRESHOLD = 10;
	const float GENERATOR_VEL_X_ERR = 6;
	const float GENERATOR_VEL_Y_MIN = 5;
	const float GENERATOR_VEL_Y_MAX = 8;
	const float GENERATOR_X_ERR = 50;
	const float ROCK_ROTATE_DEGREE_SPEED_MIN = 1;
	const float ROCK_ROTATE_DEGREE_SPEED_MAX = 5;
	const float EXPLOSION_DAMAGE_RAGE = 0.1f;
	const float HOMING_TARGET_LENGTH_THRESHOLD = 300.f;
	const float ITEM_CREATE_ERR_X = 4;
	const float ITEM_CREATE_ERR_Y_MIN = 5;
	const float ITEM_CREATE_ERR_Y_MAX = 8;
	const int COINS_PER_BLUE = 10;
	const float COINS_PER_HP_BASE = 2.5f;
	const float ENEMY_SHOT_DISTANCE_THRESHOLD = 300;
	const float ITEM_DRAW_SCALE_RATE = 0.8f;
	const int BEE_SHOOT_INTERVAL = 100;
	const float IMMUNITIES_DAMAGE_RATE = 0.f;
	const float WEAKNESS_DAMAGE_RATE = 1.8f;
	const int AFTER_BOSS_DEFAULT_WAIT_FRAME_NUM = 500;
	const HPLRect TANK_HIT_RECT = HPLRect(15,14,88,45 );
	const HPLRect VTOL_HIT_RECT = HPLRect(26,12,111,85);
	const HPLRect CAR_HIT_RECT = HPLRect(23,61,87,63);
	const HPLRect ROBOGEN_HIT_RECT = HPLRect(12,8,103,120);
	const int FIRE_EFFECT_CREATE_NUM = 10;	//! GtFNg
	const int FIRE_EFFECT_CREATE_INTERVAL = 10;
	const float ROTATE_STOP_VELOCITY_THRESHOLD = 5;
	const int DARK_BUTTON_BRIGHT = 100;	//! 炢Ԃ̃{^Bright(0`255)
	const int SOLID_DEFAULT_FRAME = 50;
	const int EVIL_BEAM_SPEED = 5;
	const int CHASER_ATTACK_1_ARM_DELTA_X = 210;
	const int CHASER_ATTACK_1_ARM_DELTA_Y = -96;
	const int CHASER_ATTACK_2_DELTA_X = 138;
	const int CHASER_ATTACK_2_DELTA_Y = 84;
	const float SLIDE_CLOUD_SPEED = 10;
	const int FONT_WIDTH = 6;	//! WIȃtHg̕
	const int FONT_HEIGHT = 12;	//! WIȃtHg̍
	const float CHASER_CHASE_ACCEL = 0.2f;
	const float CHASER_CHASE_MAX_SPEED = 4;
	const int LAVA_UP_SPEED = 2;	//! n₪オXs[h
	const int ENEMY_POINT_DEFAULT = 1;
	const int SHOT_POINT_DEFAULT = 1;
	const int CHASER_THUNDER_SHOT_ABOVE_DISTANCE = 200;

};

#include <hpllib/object/HPLSequence.h>
using namespace GEnum;
#include "GStaticData.h"
// wi
/*
void drawUniverseSpace(){
	int nSeq = Sequence::Common::SELECT_UNIVERSE_SPACE;
	switch( getStaticData()->m_nSelectedStar ) {
	case StageType::FOREST:
	case StageType::REST_STAR:
		nSeq = Sequence::Common::FOREST_BACK;
		break;
	}
	int nImageHandle = getStaticData()->getImageHandle(
		SpriteType::COMMON,
		nSeq, 0 );
	// expand
	DrawExtendGraph( 0,0, getStaticData()->m_Setting.windowWidth, getStaticData()->m_Setting.windowHeight,
		nImageHandle, TRUE );
}
*/
