#include "GGameScene.h"

#include "GStaticData.h"
#include <hpllib/general/HPLString.h>
#include "GPlayerManager.h"
#include <hpllib/system/HPLFile.h>

#include <hpllib/action/HPLActionMoveTool.h>

#include "GSpecialDeadScene.h"

#include <hpllib/math/HPLMath.h>

using namespace GEnum;
using namespace HPLMathConsts;
using namespace std;

namespace GEnum {
	static const float SNIPER_MAX_SPEED = 8.f;
	static const float SNIPER_ACCEL = 2.f;
	static const float SNIPER_RESIST = 1.f;
}

bool contains( int nItemType, vector<int>& vecExceptions ) {
	for(int j = 0; j < vecExceptions.size(); j ++ ) {
		if( vecExceptions[j] == nItemType ) {
			return true;
		}
	}
	return false;
}

/////////////////////////////////////////////////////////////////////////////////
GGameScene::GGameScene() {
	this->m_PausePlayer.setup();

	vector<int> vecItems;	// ȊO
	
	vector<int> vecExceptions;	// \ȂACe

	vecExceptions.push_back( Sequence::Item::COIN );
	vecExceptions.push_back( Sequence::Item::BLUE_COIN );
	vecExceptions.push_back( Sequence::Item::COIN_10 );
	vecExceptions.push_back( Sequence::Item::COIN_100 );
	vecExceptions.push_back( Sequence::Item::COIN_1000 );
	vecExceptions.push_back( Sequence::Item::COIN_10000 );
	vecExceptions.push_back( Sequence::Item::COIN_50 );
	vecExceptions.push_back( Sequence::Item::COIN_500 );
	vecExceptions.push_back( Sequence::Item::COIN_5000 );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN_10 );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN_100 );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN_1000 );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN_10000 );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN_50 );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN_500 );
	vecExceptions.push_back( Sequence::Item::FLYING_COIN_5000 );
	vecExceptions.push_back( Sequence::Item::BOSS_ABILITY );
	vecExceptions.push_back( Sequence::Item::QUEEN_AUTHORITY );
	vecExceptions.push_back( Sequence::Item::SEED );
	vecExceptions.push_back( Sequence::Item::WIND_WIZARD );

	// ACe̎ނɂĕя߂
	for( int i = 0; i < Sequence::Item::MAX_NUM; i ++ ) {
		GItem item(i);
//		item.setup(i);
		if( contains( i, vecExceptions ) ) {
			continue;

		}
		// 
		if( getStaticData()->getItemClassType(i) == ItemClassType::WEAPON ) {
			// 
			// ɒǉ
			this->m_vecItemIndexes.push_back(i);
		} else {
			// ȊO
			vecItems.push_back(i);
		}
	}
	// ȊOŌɒǉ
	for( int i = 0; i < (int)vecItems.size(); i ++ ) {
		this->m_vecItemIndexes.push_back( vecItems[i] );
	}


	// xɐݒ肷邽߂̃e[u
	// -1~߂
/*	int MAX_WEAPON_NUM = 5;
	int aryTable[][MAX_WEAPON_NUM] = {
		{WeaponType::PUNCH, WeaponType::PINE_APPLE, WeaponType::CHAIN_SAW, WeaponType::TOMAHAWK,  -1},
		{WeaponType::HOMING_LASER, WeaponType::ELECTRIC_HOMING_LASER, -1},
		{WeaponType::GATLING, -1},
		{WeaponType::MISSILE_LAUNCHER, WeaponType::HOMING_MISSILE_LAUNCHER, -1},
		{WeaponType::FRAME_THROWER, -1},
		{, -1},
	};
	// V[gJbg
	// 0
	//m_aryWeaponShortCut
	for( int i = 0; i < ShortCutType::MAX_NUM; i ++ ) {
		vector<int> vecList;
		for( int j = 0; j < MAX_WEAPON_NUM; i ++ ) {
			int n = aryTables[i][j];
			if( n < 0 ) {
				break;
			} else {
				vecList.push_back( aryTables[i][j] );
			}
		}
		this->m_vecWeaponShortCut.push_back( vecList);
	}*/

	getStaticData()->m_ShortCutPaletteManager.setSelectedIndex(0);

/*	for( int i = 0; i < getStaticData()->m_OptionData.getOptionFlag( OptionFlagType::MAX_SHORTCUT_NUM ); i ++ ) {
		m_aryPrevShortCutKeys.push_back( 0 );
	}*/
	

	const int PALETTE_WAIT_FRAME_NUM = 50;
	this->m_ShowPaletteCounter.setWaitFrameNum( PALETTE_WAIT_FRAME_NUM );

	//const int ENEMY_NAME_WAIT_FRAME_NUM = 80;
	//this->m_ShowEnemyNameCounter.setWaitFrameNum( ENEMY_NAME_WAIT_FRAME_NUM );
	//this->resetEnemyNameCounter();
}
GGameScene::~GGameScene() {
}
void GGameScene::init() {
	// GtFNg
	getStaticData()->m_ObjectManager.m_EffectManager.clear();

	this->m_PausePlayer.setCenter(600,350);

	this->m_nRKeyPressed = 0;
	this->m_nMenuX = 0;
	this->m_nMenuY = 0;

//	this->m_nSuperPowerSelect = 0;

	// Q[V[tO(IɃ^Cg֍sp)
	getStaticData()->m_Game.resetTempFlag();

	getStaticData()->m_ShowEnemyName.reset();
	getStaticData()->m_ShowItemName.reset();

	// check play long
	getStaticData()->stepAndCheckAchievement( AchievementType::PLAY_LONG, 0, false );


}
void GGameScene::quit() {
	// Q[V[tO
	getStaticData()->m_Game.resetTempFlag();

	// {Xj̃JEgLZ
	getStaticData()->stopAfterBossWait();

	// BGMLZ
//	getStaticData()->m_MixerManager.stopMusic();

	// ~
	getStaticData()->m_Game.setTheWorld( false );

	if( bIsNowRespawning ) {
		// respown

		GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;

		// c@炷
		lpPlayer->setRemainNum( lpPlayer->getRemainNum() - 1 );

		// ̗͑S
		lpPlayer->setHP( lpPlayer->getHPMax() );

		// }bvēǂݍ
		getStaticData()->setupMap( getStaticData()->m_MapManager.getSelectedMap(), true);

		// respawn
		getStaticData()->stepAndCheckAchievement(
			AchievementType::RESPAWN_MASTER, 1, true );
	}

}
static GPlayerManager playerManager;	//! Ǘp

/*
void setVectorInt( HPLVector& v ) {
	v.set(
		static_cast<int>(v.getX() ),
		static_cast<int>(v.getY() )
		);
}
*/

int getMapListString( string& strResult, int nStart, int nEnd ) {
	int nMax = getStaticData()->m_MapManager.getMapNum();
	if( nEnd >= nMax ) {
		nEnd = nMax-1;
	}
	if( nStart < 0 || nStart > nEnd )
	{
		return -1;
	}
	for( int i = nStart; i <= nEnd; i ++ ) {
		strResult += HPLString::chrToStr( "[%5d][%s]\r\n",
			i, getStaticData()->m_MapManager.getMapFilePath(i).c_str());
	}
	return 0;
}
void GGameScene::process() {

	// wiG
	//drawUniverseSpace();
	getStaticData()->m_BGManager.drawBG();

	// no scroll adjust
	bool bIsNoScrollAdjust = 
//		getStaticData()->m_Game.isScenario() ||	// scenario -> do scroll
		getStaticData()->m_Game.isTheWorld() ||	// the world
		getStaticData()->m_Game.isMenu() ||		// menu
		//getStaticData()->getAfterBossWaitCounter()->getState().isFinishAnimation == false ||
		getStaticData()->m_lpReadyGoSequence->getState().isFinishAnimation == false ||
		//getStaticData()->m_lpGameSetSequence->getState().isFinishAnimation == false ||
		getStaticData()->isFadingOutDX();
	// darken
	getStaticData()->m_BGManager.drawFadeOut(bIsNoScrollAdjust == false);
	
	// Cxg`FbN
	// ł1GL΃ANeBx[g
	getStaticData()->isEvent( EventStepType::DEFAULT, true, true);

	// ʗpp
	GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
	GPlayer* lpCOMPlayer = &getStaticData()->m_ObjectManager.m_COMPlayer;

	if( getStaticData()->m_EventImage.isActivated() == false ) {

	////////
	// adjust scroll
	// ₩XN[ɂ
	// ȏ㗣ꂽʏXN[
	// ȓł΁AvC[isOS[ƂăXN[ړ
	if( !bIsNoScrollAdjust ){
		// XN[[
		HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(0);

		// shakeʎ擾
		HPLVector shake = getStaticData()->m_ShakeManager.m_vShake;

		// shake isiLȂ΁B)
		getStaticData()->m_ShakeManager.stepShake();

		// XN[
		getStaticData()->adjustScroll( scroller );

		// h炷
		HPLRect rShakedRect = scroller->getVirtualRect();
		//scroller->m_CurrentVirtualCenter.add( shake );
		rShakedRect.setX( rShakedRect.getX() + shake.getX() );
		rShakedRect.setY( rShakedRect.getY() + shake.getY() );

		scroller->setVirtualRect( rShakedRect );

		// shake test
/*		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::G ) ) {
			getStaticData()->m_ShakeManager.startShake();
		}*/
	}

	// draw tiles
	getStaticData()->getBlockManager()->draw(getStaticData()->m_Basic.m_Graphics,
		getStaticData()->getScrollManager()->getScroller(0));

	// draw enemy behind other objects
	getStaticData()->m_ObjectManager.m_EnemyManager.drawEnemyBack();


	// ^[QbeBO摜_
	getStaticData()->getSequence( SpriteType::EFFECT, Sequence::Effect::TARGETTING )->step();

	// ړH
	bool bIsAI = getStaticData()->m_Game.isScenario() == false;

	// ړH
	bool isMove = getStaticData()->m_Game.isTheWorld() == false &&
		getStaticData()->m_Game.isMenu() == false &&
		// &&
		lpPlayer->m_LaderSequence->getState().isFinishAnimation &&
		getStaticData()->isFadingOutDX() == false;

	// ʂɈړȂ
	if( false == getStaticData()->m_lpReadyGoSequence->getState().isFinishAnimation ||
		false == getStaticData()->m_lpGameSetSequence->getState().isFinishAnimation
	)
	{
		isMove = false;
		
	}
	
	// \͈
	HPLRect rMerginedGameRange = getStaticData()->getMerginedGameRange();

	{
		int nWeaponType = lpPlayer->getWeaponType();						// ^Cv
		bool bIsSpecialNoMove = lpPlayer->isSpecialWeaponNoMove() ||
			getStaticData()->m_Game.isTheWorld() || 
			getStaticData()->m_Game.isMenu() ||
			getStaticData()->m_Game.isScenario() ||
			getStaticData()->m_lpReadyGoSequence->getState().isFinishAnimation == false ||
			getStaticData()->m_lpGameSetSequence->getState().isFinishAnimation == false;
		// ̏ꍇ̓vC[͐Î~ĂiȂAʂ̗RœȂƂӖłg
		// -ꕐ
		// -j[
		// -ViI
		// -ReadyGo/GameSet

		// ړʂǂ
/*		lpPlayer->setGetRideSpeed( false );
		if( getStaticData()->isCOMPlayer() ) {
			lpCOMPlayer->setGetRideSpeed( false );
		}
		*/

		// L[Ԃ̍XV
		lpPlayer->updateKeyState( true,
			getStaticData()->getInputManager(),
			KeyMap::MAX_KEY);

		bool bIsSolid = false;
		bool bIsCOMSolid = false;
		if( lpPlayer->m_SolidData.getType() != SolidType::NONE ) {	// ł߂Ă
			bIsSolid = true;

			// oK`
			int nStepSkip = getStaticData()->getScrambleKeyCount( lpPlayer, false );


			// oߏ
			if( lpPlayer->m_SolidData.step(nStepSkip) ) {
				// n
			}
		}
		if( getStaticData()->isCOMPlayer() ) {
			if( lpCOMPlayer->m_SolidData.getType() == SolidType::NONE ) {
			} else {
				bIsCOMSolid = true;
				if( lpCOMPlayer->m_SolidData.step(1) ) {
					// n
				}
			}
		}
		if( (isMove && bIsAI && bIsSpecialNoMove == false) || getStaticData()->m_Game.isScenario()) {
			// isMove, isAI, !isSpecialNoMoveׂĖ
			// 邢̓ViI^CՓˁd͏BTODO肪Ώ

			////////////////////////////////////////////////////////////////////////////
			// collision check
			// fall and hit to collision
			if( false == bIsSolid ) {
				HPLVector velocityAngle = lpPlayer->getVelocityAngle();
				HPLVector center = lpPlayer->getCenter();
				playerManager.collisionCheck(
					lpPlayer,
					&center, &velocityAngle);
			}

			if( false == bIsCOMSolid && getStaticData()->isCOMPlayer() ) {
				// COM Player
				if( lpCOMPlayer->isAlive() ) {
					playerManager.moveAI( lpCOMPlayer );
				}

				// collision check
				HPLVector vComCenter = lpCOMPlayer->getCenter();
				HPLVector vComVelocityAngle = lpCOMPlayer->getVelocityAngle();
				playerManager.collisionCheck(
					lpCOMPlayer,
					&vComCenter, &vComVelocityAngle );
			}
		}

		if( false == bIsSpecialNoMove ) {
			////////////////////////////////////////////////////////////////////////////
			// moving
			if( false == bIsSolid ) {
				HPLVector velocityAngle = lpPlayer->getVelocityAngle();
				playerManager.move(
					lpPlayer, &velocityAngle);
				lpPlayer->setVelocityAngle(velocityAngle);
			}

			if( false == bIsCOMSolid && getStaticData()->isCOMPlayer() ) {
				HPLVector vComVelocityAngle = lpCOMPlayer->getVelocityAngle();
				playerManager.move(
					lpCOMPlayer, &vComVelocityAngle);
				lpCOMPlayer->setVelocityAngle(vComVelocityAngle);
			}
		}

		if( isMove && bIsAI) {
			////////////////////////////////////////////////////////////////////////////
			// attack
			if( false == bIsSolid ) {
				HPLVector velocityAngle = lpPlayer->getVelocityAngle();
				HPLVector center = lpPlayer->getCenter();
				playerManager.attack(
					lpPlayer, &center, &velocityAngle);

				lpPlayer->setVelocityAngle(velocityAngle);
			}

			// UqbgmF
			//playerManager.checkHitToPlayer( lpPlayer );

			if( false == bIsCOMSolid && getStaticData()->isCOMPlayer()  ) {
				// COM 
				HPLVector vComVelocityAngle = lpCOMPlayer->getVelocityAngle();
				HPLVector vComCenter = lpCOMPlayer->getCenter();
				playerManager.attack(
					lpCOMPlayer, &vComCenter, &vComVelocityAngle);

				lpCOMPlayer->setVelocityAngle(vComVelocityAngle);
			}

			// {Xj̑҂
			getStaticData()->processAfterBossWait();
		}
	}

	
	// ɕ\GtFNg
	getStaticData()->m_ObjectManager.m_EffectManager.drawBack(  );

	// ~藧tO
	lpPlayer->m_bIsLandOnObject = false;
	// neutral
	getStaticData()->m_ObjectManager.m_NeutralManager.process( isMove, bIsAI && getStaticData()->m_Game.isScenario() == false );
	lpPlayer->draw();
	if( getStaticData()->isCOMPlayer() ) {
		lpCOMPlayer->draw();
	}

	// enemy
	getStaticData()->m_ObjectManager.m_EnemyManager.process( isMove, bIsAI );
	// item
	getStaticData()->m_ObjectManager.m_ItemManager.process( isMove, bIsAI );

	bool bIsNoTheWorld = getStaticData()->m_Game.isTheWorld() == false &&
		getStaticData()->isFadingOutDX() == false;


	// test

	if( CheckHitKey( KEY_INPUT_U ) ) {
		// TODO eXgFς
		int nIndex = lpPlayer->getPaletteIndex() + 1;
		if( nIndex >= lpPlayer->getPaletteNum() ) {
			nIndex = 0;
		}

		// XvCgύX
		lpPlayer->setPaletteIndex( nIndex );
	}

	// eXg[
	if( getStaticData()->getInputManager()->isPressedNow( KeyMap::G ) ) {	//! DL[
		// eXgF

		// ؂ւ
		lpPlayer->m_nWearState = lpPlayer->m_nWearState == WearStateType::NAKED ?
			WearStateType::NORMAL : WearStateType::NAKED;

		// ɂo
		//getStaticData()->setCOMPlayer( !getStaticData()->isCOMPlayer() );
		//		getStaticData()->m_ObjectManager.m_AchievementManager.create(
//			AchievementType::BED_CRASHER);

	}
	// draw front tiles
	getStaticData()->getBlockManager()->draw(getStaticData()->m_Basic.m_Graphics,
		getStaticData()->getScrollManager()->getScroller(0),
		true);
	// shot
	getStaticData()->m_ObjectManager.m_ShotManager.process( isMove, bIsAI );
	// GtFNg͎~܂Ȃ(The world)
	getStaticData()->m_ObjectManager.m_EffectManager.process( bIsNoTheWorld, bIsNoTheWorld );

	// boss hp drawing
	getStaticData()->m_ObjectManager.m_EnemyManager.drawBossHP();

	// Achievement͎~܂Ȃ
	getStaticData()->m_ObjectManager.m_AchievementManager.process( bIsNoTheWorld, bIsNoTheWorld );


	// draw sniper 
	if( isMove && lpPlayer->getWeapon()->isSniping() &&
		lpPlayer->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) )
	{
		// ړ\ȏ
		// vC[XiCp[Ct
		// nɋ
		
		HPLVector vCenter = lpPlayer->m_vSniperPosition;//lpPlayer->getCenter();
		HPLScroller* lpScroll = getStaticData()->getScrollManager()->getScroller(0);
		vCenter.add( lpScroll->getVirtualRect().getX(), lpScroll->getVirtualRect().getY() );

		HPLRect rSniperSrcRect = getStaticData()->getSequence( SpriteType::COMMON,
			Sequence::Common::SNIPER )->getImageInformation( 0 )->srcRect;

		int nImageHandle = getStaticData()->getImageHandle( 
			SpriteType::COMMON, Sequence::Common::SNIPER );
		// right bottom
		DrawGraph(
			(int)vCenter.getX(), (int)vCenter.getY(), (int)nImageHandle, TRUE );
		// right top ( vertical mirror )
		DrawExtendGraph(
			(int)(vCenter.getX()), (int)(vCenter.getY()),
			(int)(vCenter.getX() + rSniperSrcRect.getWidth()),
			(int)(vCenter.getY() - rSniperSrcRect.getHeight()),
			nImageHandle, TRUE );
		// left bottom ( horizontal mirror )
		DrawTurnGraph(
			(int)(vCenter.getX() - rSniperSrcRect.getWidth() ),   
			(int)vCenter.getY(), nImageHandle, TRUE );
		// left top
		DrawExtendGraph(
			(int)vCenter.getX(),
			(int)vCenter.getY(),
			(int)(vCenter.getX() - rSniperSrcRect.getWidth()),
			(int)(vCenter.getY() - rSniperSrcRect.getHeight()),
			nImageHandle, TRUE );

		// L[œ
		int nDX = 0;
		int nDY = 0;
		if( lpPlayer->isPressed( KeyMap::LEFT ) ) {
			nDX = -1;
		}
		if( lpPlayer->isPressed( KeyMap::RIGHT) ) {
			nDX = 1;
		}
		if( lpPlayer->isPressed( KeyMap::UP) ) {
			nDY = -1;
		}
		if( lpPlayer->isPressed( KeyMap::DOWN) ) {
			nDY = 1;
		}
		if( nDX != 0 || nDY != 0 ) {
			HPLVector vAccel( (float)nDX, (float)nDY );
			vAccel.normalize();
			vAccel.multiple( SNIPER_ACCEL );

			lpPlayer->m_vSniperVelocity.add( vAccel );
			float fSpeed = lpPlayer->m_vSniperVelocity.getLength();
			// 
			fSpeed = HPLActionMoveTool::reduceSpeed( SNIPER_RESIST, fSpeed );
			if( fSpeed > SNIPER_MAX_SPEED ) {
				fSpeed = SNIPER_MAX_SPEED;
			}
			lpPlayer->m_vSniperVelocity.normalize();
			lpPlayer->m_vSniperVelocity.multiple( fSpeed );
			lpPlayer->m_vSniperPosition.add( lpPlayer->m_vSniperVelocity );

		}
		{
			// Q[͈
			HPLRect rGameRange = getStaticData()->getGameRange();

			// AEgWH
			bool bIsOutRange = false;


			if( lpPlayer->m_vSniperPosition.getX() < rGameRange.getX() ) {
				bIsOutRange = true;
				lpPlayer->m_vSniperPosition.setX( rGameRange.getX() );
			} else if( lpPlayer->m_vSniperPosition.getX() > rGameRange.getRight() ) {
				bIsOutRange = true;
				lpPlayer->m_vSniperPosition.setX( rGameRange.getRight() );
			}

			if( lpPlayer->m_vSniperPosition.getY() < rGameRange.getY() ) {
				bIsOutRange = true;
				lpPlayer->m_vSniperPosition.setY( rGameRange.getY() );
			} else if( lpPlayer->m_vSniperPosition.getY() > rGameRange.getBottom() ) {
				bIsOutRange = true;
				lpPlayer->m_vSniperPosition.setY( rGameRange.getBottom() );
			}
			if( bIsOutRange ) {
				// AEgW
				// ->Wɔ[߂
				lpPlayer->m_vSniperVelocity.set(0,0);
			}
		}
	}

	// ACR
	{
		int nState = lpPlayer->m_EmotionData.getState();
		if( lpPlayer->m_EmotionData.m_HoldCounter.step().isFinishAnimation ) {
			nState = lpPlayer->getState()->getState();
			lpPlayer->m_EmotionData.setState( nState );
		}
		int nFaceSequenceID = getStaticData()->getFaceSeqIDFromState( nState,lpPlayer->m_nWearState );
		if( nFaceSequenceID >= 0 ) {
			getStaticData()->drawEmotionIcon(
				10, 150, nFaceSequenceID, 0,
				64,64 );
		}
	}

	if( lpPlayer->getState()->isAttackState() == false ) {
		// UԂłȂ

		// ؂ւH
		bool bIsChenge = false;

		if( lpPlayer->isHeld() == false && getStaticData()->getInputManager()->isPressedNow( KeyMap::C ) ) {
			// vC[͂܂ĂȂ
			// +C{^PUSH
			// ->iV[gJbgj؂ւ
			//lpPlayer->setNextWeapon();
			int nNextIndex = getStaticData()->m_ShortCutPaletteManager.getNextRegisteredIndex(
				getStaticData()->m_ShortCutPaletteManager.getSelectedIndex() );
			if( nNextIndex >= 0 ) {
				// ύX
				getStaticData()->m_ShortCutPaletteManager.setSelectedIndex( nNextIndex );
			}

			bIsChenge = true;

		}
		for( int i = 0; i < (int)this->m_aryPrevShortCutKeys.size(); i ++ ) {
			int nCurrent = CheckHitKey( KEY_INPUT_1 + i );
			if( nCurrent && this->m_aryPrevShortCutKeys[i] == 0 ) {
				// 
				// I
				getStaticData()->m_ShortCutPaletteManager.setSelectedIndex( i );
				bIsChenge = true;
			}
			this->m_aryPrevShortCutKeys[i] = nCurrent;
			if( bIsChenge ) {
				break;
			}
		}
		if( bIsChenge ) {
			int nItemType = getStaticData()->m_ShortCutPaletteManager.getSelectedValue();
			// ύX
			if( getStaticData()->getItemClassType(nItemType) == ItemClassType::WEAPON ) {
				// Ȃ畐ύX
				int nWeaponType = getStaticData()->getWeaponTypeFromItemType(
					nItemType );
				lpPlayer->setWeaponType( nWeaponType );

			}
			// pbg\Jn
			this->m_ShowPaletteCounter.reset();
		}
	}

	// SuperPower
	if( lpPlayer->isSuperPower() ) {
		HPLSequence* lpSeq = getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::SUPER_POWER_BACK );
		HPLRect src = lpSeq->getImageInformation(0)->srcRect;
		int x = GAME_SUPER_POWER_LEFT;
		int y = GAME_SUPER_POWER_TOP;
		// back
		getStaticData()->m_Basic.m_Graphics.draw(
			x, y, lpSeq );
		// icon
		getStaticData()->m_Basic.m_Graphics.draw(
			x, y, getStaticData()->getSequence( SpriteType::COMMON,
			Sequence::Common::SUPER_POWER_00 + lpPlayer->getSuperPowerType() ) );
		// c莞ԂԂŕ\
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, 180 );

		int nDelta = 5;
		int nSize = 38;
		DrawBox(
			(int)(x + nDelta),
			(int)(y + nDelta + nSize * (1.f - lpPlayer->getWeapon()->m_Energy.getRemainRate())),
			(int)(x + nDelta + nSize ),
			(int)(y + nDelta + nSize ), GetColor(255,0,0), TRUE );
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );
		// frame
		getStaticData()->m_Basic.m_Graphics.draw(
			x, y, getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::SUPER_POWER_FRAME ) );
	}

	int nRKeyPressed = CheckHitKey( KEY_INPUT_R );	// R key check

	if( false == getStaticData()->isFadingOutDX() ) {
		// tF[hAEg͑s

		if( false == lpPlayer->isAlive() ) {
			// ł

			int nSceneNumber = -1;
//			int nSpecialMap = -1;

			// special dead
			switch( getStaticData()->getMapIndex() ) {
			case SpecialMapIndex::SLIME_QUEEN:
				nSceneNumber = SpecialDeadEventID::SLIME_QUEEN;
				break;
			case SpecialMapIndex::BEE:
				nSceneNumber = SpecialDeadEventID::BEE;
				break;
			case SpecialMapIndex::ALRAUNE:
				nSceneNumber = SpecialDeadEventID::ALRAUNE;
				break;
			case SpecialMapIndex::WIND_BOSS_1:
			case SpecialMapIndex::WIND_BOSS_2:
				nSceneNumber = SpecialDeadEventID::CHASER_BAD;
//				nSpecialMap = SpecialMapIndex::CHASER_BAD;
				break;
			}

			if( 0 <= nSceneNumber ) {
				// V[ύX
				GSpecialDeadScene* lpScene = (GSpecialDeadScene*) getStaticData()->m_SceneManager.getScene( SceneType::SPECIAL_DEAD );
				lpScene->setScenarioIndex(nSceneNumber);
				// oĂ
				lpScene->setPreviousMap( getStaticData()->getMapIndex() );

				getStaticData()->startFadeOutDX( SceneType::SPECIAL_DEAD, -1 );


				bIsNowRespawning = true;
			} else {
				if( nRKeyPressed && this->m_nRKeyPressed == 0 ) {
					bool bIsRemain = getStaticData()->hitRKey();

					if( bIsRemain ) {

						// IۂRespawn
						bIsNowRespawning = true;
					}

				}
			}

		}

/*		if( CheckHitKey( KEY_INPUT_U ) ) {
			// eXgFCxg
			((GSpecialDeadScene*) getStaticData()->m_SceneManager.getScene( SceneType::SPECIAL_DEAD ))->setScenarioIndex(0);
			getStaticData()->startFadeOutDX( SceneType::SPECIAL_DEAD, -1 );
		}
*/
	}

	this->m_nRKeyPressed = nRKeyPressed;		// R key update

	// S̓KCh\
	if( false == lpPlayer->isAlive() ) {
		// ł

		if( lpPlayer->getRemainNum() > 0 ) {
			// c@

			DrawString( 
				PUSH_R_LEFT, PUSH_R_TOP,
				"RL[őh", GetColor(255,255,255), GetColor(0,0,0) );

		} else {
			DrawString(
				PUSH_R_LEFT,PUSH_R_TOP,
				"Game Over... PUSH R KEY...", 
				GetColor(255,0,0), GetColor(0,0,0 ) );
		}
	}

	static int nPrevCheatKey = 0;					//! `[gL[pBOt[̃`[gL[
	int nCheatKey = CheckHitKey(KEY_INPUT_F5);		//! `[gL[
	static int nPrevMiniCheatKey = 0;			//! lesser
	int nMiniCheatKey = CheckHitKey( KEY_INPUT_F6 );

	if( nPrevCheatKey == 0 && nCheatKey ) {		// F5 G`[g(؂ւ)
		// 
		// `[g[h start
		getStaticData()->m_Game.setCheat(!getStaticData()->m_Game.isCheat());
	}

	if( nPrevMiniCheatKey == 0 && nMiniCheatKey ) {	// F6 `[g(K`[g[hɂ)
		getStaticData()->m_Game.setCheat(true);
		// ǉ
		for( int i = 0; i < WeaponType::MAX_WEAPON_NUM; i ++ ) {
			lpPlayer->getWeapon(i)->m_bIsActivated = true;
			int nItem = getStaticData()->getItemTypeFromWeaponType( i );
			getStaticData()->m_Save.setItemNum( nItem, 1);
		}

		const int MASS_ADD_NUM = 10;		//! ʂɒǉACȇ
		const int BLUE_COIN_ADD_NUM = 100;	//! coin!
		// ǉACeƂ̐
		int ADD_ITEM_TYPES[][2] = {
			{Sequence::Item::MISSILE,MASS_ADD_NUM},
			{Sequence::Item::BATTERY,MASS_ADD_NUM},
			{Sequence::Item::EVIL_DRINK,1},
			{Sequence::Item::BLUE_COIN, BLUE_COIN_ADD_NUM },
			{Sequence::Item::MEAT,1}
		};
		for( int i = 0; i < SIZEOF(ADD_ITEM_TYPES); i ++ ) {
			lpPlayer->getItem( ADD_ITEM_TYPES[i][0],
				ADD_ITEM_TYPES[i][1] );
		}

		// orbMAXɂ
		getStaticData()->m_Save.setFlag( 
			FlagType::EVIL_ORB_NUM, 
			getStaticData()->m_Save.getFlag( FlagType::EVIL_ORB_MAX ) );

		// get all super power
		for( int i = 0; i < SuperPowerType::MAX_NUM; i ++ ) {
			getStaticData()->m_Save.m_arySuperPower[ i ] = 1;
			getStaticData()->m_Save.setFlagBit( FlagType::GET_ABILITY, i, true );
		}
	}
	
	nPrevCheatKey = nCheatKey;
	nPrevMiniCheatKey = nMiniCheatKey;

	if( getStaticData()->m_Game.isCheat() && lpPlayer->isInvinsible() == false ) {
		// cheat mode
		// 
		lpPlayer->startInvinsible();
	}

	{
		HPLScroller* lpScroll = getStaticData()->m_ScrollManager.getScroller(0);
		int nDZ = 0;
		const float ZOOM_DELTA = 0.1f;
		const float ZOOM_MIN = 0.5f;
		const float ZOOM_MAX = 4.f;

		if( CheckHitKey( KEY_INPUT_L ) ) {
			nDZ = 1;
		}
		if( CheckHitKey( KEY_INPUT_P ) ) {
			nDZ = -1;
		}
		
		bool bIsSetDefault = false;

		if( CheckHitKey( KEY_INPUT_O ) ) {
			// 1ɒ
			bIsSetDefault = true;

		} else if( nDZ != 0 ) {

			lpScroll->m_fZoomRate += (float)nDZ * ZOOM_DELTA;
			if( lpScroll->m_fZoomRate < ZOOM_MIN ) {
				lpScroll->m_fZoomRate = ZOOM_MIN;
			}
			if( lpScroll->m_fZoomRate > ZOOM_MAX ) {
				lpScroll->m_fZoomRate = ZOOM_MAX;
			}

			if( lpScroll->m_fZoomRate > (1.f-ZOOM_DELTA) &&
				lpScroll->m_fZoomRate < 1 + ZOOM_DELTA ) {
				// ɃY^
				// ->1ɒ
				bIsSetDefault = true;
			}
		}
		if( bIsSetDefault ) {
			lpScroll->m_fZoomRate = 1;
		}
	}
	
	static int nPrevT = 0;
	int nT = CheckHitKey(KEY_INPUT_T );
	if( nT && nPrevT == 0 ){
		int nNewType = -1;
		// change player type
		switch( lpPlayer->getType() ) {
		case PlayerType::EVIGEN:	nNewType = PlayerType::TANYA;	break;
		case PlayerType::TANYA:		nNewType = PlayerType::EVIGEN;	break;
		}
		if( nNewType >= 0 ) {
			lpPlayer->changeType( nNewType , NULL);
		}
	}

	nPrevT = nT;
	

	} // event image does not activated	//////////////////////////////////////////////////////////

	// draw enemy name
	if( getStaticData()->m_ShowEnemyName.isAlive() ) {
		getStaticData()->m_ObjectManager.drawObjectName( LayoutType::BOTTOM_RIGHT, 
			getStaticData()->m_Game.isTheWorld() == false, ObjectType::ENEMY, 
			getStaticData()->m_ShowEnemyName.getNameType() );
/*		HPLSequence* lpSeq = getStaticData()->m_ShowEnemyName.getSequence();
		HPLRect rSrcRect = lpSeq->getImageInformation( 0 )->srcRect;
		int nLeft = getStaticData()->m_Setting.windowWidth - rSrcRect.getWidth();
		int nTop = getStaticData()->m_Setting.windowHeight - rSrcRect.getHeight();

		// draw frame
		getStaticData()->m_Basic.m_Graphics.draw(
			nLeft, nTop, lpSeq );
		// draw name
		string str = getStaticData()->m_ObjectManager.m_EnemyManager.getEnemyName( getStaticData()->m_ShowEnemyName.getNameType() );
		const int DELTA_X = 5;
		const int DELTA_Y = 5;
		DrawString( nLeft + DELTA_X, nTop + DELTA_Y, str.c_str(), GetColor(255,255,255) );

		if( getStaticData()->m_Game.isTheWorld() == false ) {
			getStaticData()->m_ShowEnemyName.step();
		}*/
	}
	if( getStaticData()->m_ShowItemName.isAlive()) {
		getStaticData()->m_ObjectManager.drawObjectName( LayoutType::BOTTOM_LEFT, 
			getStaticData()->m_Game.isTheWorld() == false, ObjectType::ITEM, 
			getStaticData()->m_ShowItemName.getNameType() );
	}
	// draw item name
	/*if( this->isItemNameCounter() ) {
		// draw frame
		// draw name
		this->stepItemNameCounter();
	}*/
	
	if(getStaticData()->m_EventImage.isActivated()){
		// draw image
		HPLSequence* lpSeq = getStaticData()->getSequence( getStaticData()->m_EventImage.spriteID,
			getStaticData()->m_EventImage.seqID );
		getStaticData()->m_Basic.m_Graphics.draw( 
			0,0, lpSeq );

	}

	// Cxg̊mFƎsE\
	getStaticData()->checkEvent(lpPlayer->isAlive() == false,
		EventStepType::DEFAULT, true, true/* &&
		getStaticData()->getMapIndex() != SpecialMapIndex::PRACTICE*/);
	
	if( getStaticData()->isFadingOutDX() == false ) {
		// tF[hAEg͑łȂ

		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::I ) ) {	// "ESC"L[
			// ESC -> Menu
			getStaticData()->m_Game.setMenu( !getStaticData()->m_Game.isMenu() );
		}

		if( getStaticData()->m_Game.isMenu() && getStaticData()->getInputManager()->isPressedNow( KeyMap::B ) ) {	// "X"L[
			// XMenu
			getStaticData()->m_Game.setMenu( false );
		}

#ifdef _DEBUG
		static int nIKey = 0;
		int nI = CheckHitKey( KEY_INPUT_I );
		if( nI ) {	// "I"L[
			// ->ViI

			const int BUF_SIZE = 10240;
			char lpszBuffer[BUF_SIZE];
			// ViIԍ͂
			try {
				if( 1 == KeyInputString(0,0,
					BUF_SIZE, lpszBuffer, TRUE ) )
				{
					string str(lpszBuffer );
//					str = HPLString::trim( str );
					vector<string> vecItems = HPLString::split( str, " ");
					if( vecItems.size() >= 2 ) {
						for( int i = 0; i < vecItems.size(); i ++ ) {
							vecItems[i] = HPLString::trim( vecItems[i] );
						}
						if( HPLString::equals(vecItems[0], "ev" ) ) {
							if( vecItems.size() < 2 ) {
								HPLError::msg("error",MB_OK,"Event start:ev EVENT_ID");
							} else {
								int nScenarioID = atoi(vecItems[1].c_str());
								// N
								getStaticData()->startEvent(nScenarioID, true);
							}
						} else if( HPLString::equals(vecItems[0], "coc")) {	// change scene/map
							if( vecItems.size() < 2 ) {
								HPLError::msg("error",MB_OK,"Change scene/map:coc MAP_INDEX [SCENE_TYPE]");
							} else {
								int nMapIndex = atoi(vecItems[1].c_str());
								int nSceneType = -1;
								if( vecItems.size() > 2 ) {
									nSceneType = atoi(vecItems[2].c_str());
								}
								getStaticData()->startFadeOutDX( nSceneType, nMapIndex );
							}
						} else if( HPLString::equals( vecItems[0], "map")) {
							if( vecItems.size() < 2 ) {
							/*	string strList;
								// ꗗ\
								int nResult = getMapListString( strList, 0, getStaticData()->m_MapManager.getMapNum() );
								if( nResult == 0 ) {
									HPLError::msg( "msg", MB_OK,
										"%s",strList.c_str());
								}*/
							} else if( vecItems.size() == 2 ) {
								int nMapIndex = 0;
								if( HPLString::equals( vecItems[1], "now") ) {
									nMapIndex = getStaticData()->getMapIndex();
								} else {
									nMapIndex = atoi(vecItems[1].c_str());
								}
								HPLError::msg("message",
									MB_OK, "MapID=%d:FilePath=[%s]",
									nMapIndex, getStaticData()->m_MapManager.getMapFilePath( nMapIndex ).c_str() );
							} else {	// 3ȏw肵Ă
								// arg1`arg2̊Ԃ\
								int nMapIndexStart = atoi( vecItems[1].c_str());
								int nMapIndexEnd = atoi( vecItems[2].c_str());
								string strList;
								int nResult = getMapListString( strList, nMapIndexStart, nMapIndexEnd );
								if( nResult == 0 ) {
									HPLError::msg( "msg", MB_OK,
										"%s", strList.c_str());
								}
							}
						} else if( HPLString::equals( vecItems[0], "chest" ) ) {
							if( vecItems.size() < 2 ) {
							} else {
								// open/close
								if( HPLString::equals( vecItems[1], "reset")) {	// SĂ̕󔠂uxJvԂɂ
									// chest/tansuāASClose
									for( list<GNeutral*>::iterator it = getStaticData()->m_ObjectManager.m_NeutralManager.getList()->begin();
										it != getStaticData()->m_ObjectManager.m_NeutralManager.getList()->end(); 
										it ++ )
									{
										GNeutral* lpNeutral = *it;
										switch( lpNeutral->getType() ) {
										case Sequence::Neutral::TAKARA_BAKO:
										case Sequence::Neutral::TANSU:
											lpNeutral->changeState( StateType::STAND );
											break;
										}
									}
								} else {
									HPLError::msg("error", MB_OK, "Unknown option[%s]", vecItems[1].c_str());
								}
							}
						} else if( HPLString::equals( vecItems[0], "flag") ) {
							bool bIsError = false;
							if( vecItems.size() < 2 ) {
								bIsError = true;
							} else {
								//
								if( HPLString::equals( vecItems[1], "all" ) ) {
									if( vecItems.size() < 3 ) {
										bIsError = true;
									} else {
										int nNum = atoi(vecItems[2].c_str());
										for( int i = 0; i < FlagType::MAX_NUM; i ++ ) {
											getStaticData()->m_Save.setFlag(i, nNum );
										}

										// 
										for( int i = 0; i < OptionFlagType::MAX_NUM; i ++ ) {
										}
										// Z[uȂ悤Ƀ`[g
										getStaticData()->m_Game.setCheat( true );
									}
								} 
							}
							if( bIsError ) {
								HPLError::msg("error", MB_OK,
									"Change flags: flag (all|ID) [FlagNum(10)]");
							}
						}
					}
				}
			} catch( ... ) {
				HPLError::msg("error",MB_OK,"Failed to convert or start event");
			}
		}
		nIKey = nI;

#endif
	}
	
	if( getStaticData()->m_Game.isCheat() ) {
		// `[g

		HPLScroller* lpScroller = getStaticData()->m_ScrollManager.getScroller(0);
		int nMouseInput = GetMouseInput();
		// }EXW
		int nMouseX = 0;
		int nMouseY = 0;
		GetMousePoint( &nMouseX, &nMouseY );
		getStaticData()->m_ObjectManager.checkAndMoveByMouse( nMouseInput,
			MOUSE_INPUT_LEFT, nMouseX, nMouseY,
			lpPlayer, lpScroller );
	}

	// Jn/I̕\
	this->checkAndDraw( getStaticData()->m_lpReadyGoSequence );
	this->checkAndDraw( getStaticData()->m_lpGameSetSequence );

	// HPj[̒ŕ\Ă邩H(ftHg\Ȃ)
	bool bIsDrawInMenu = false;

	// j[\
	if( getStaticData()->m_Game.isMenu() ) {
		this->drawMenu( bIsDrawInMenu);

	}
	if( false == bIsDrawInMenu ) {

		// draw hp meter
		this->drawHP();
	}

	if( this->m_ShowPaletteCounter.getState().isFinishAnimation == false ) {
		// pbg\
		this->drawShortCutPalette();
		this->m_ShowPaletteCounter.step();
	}
	{
		// pbgύX
		/*if( getStaticData()->getInputManager()->isPressedNow( KeyMap::D ) ) {
			int nIndex = lpPlayer->getPaletteIndex() + 1;
			if( nIndex >= lpPlayer->getPaletteNum() ) {
				nIndex = 0;
			}

			// XvCgύX
			lpPlayer->setPaletteIndex( nIndex );

		}*/
	}

}

/** ԂmFāAAj[VcĂ΁Aʂ̒Sɕ\
  */
void GGameScene::checkAndDraw( HPLSequence* lpSeq ) {
	if( false == lpSeq->getState().isFinishAnimation ) {
		HPLRect rSrcRect = lpSeq->getImageInformation(0)->srcRect;

		// TODO Start!̏ꍇ͍[XChC
		// TODO STAGE CLEAR!̏ꍇ́cH
		int nLeft = (int)(getStaticData()->m_Setting.windowWidth / 2 - rSrcRect.getWidth() / 2);
		int nTop = (int)(getStaticData()->m_Setting.windowHeight / 2 - rSrcRect.getHeight() / 2);

		//
		getStaticData()->m_Basic.m_Graphics.draw(
			nLeft, nTop, lpSeq );
		
		lpSeq->step();
	}
}

/** HPQ[W\
  */ 
void GGameScene::drawHP() {
	HPLSequence* lpSeqFrame = getStaticData()->getSequence( 
		SpriteType::COMMON, Sequence::Common::HP_METER_FRAME );
	HPLRect rSrcRect = lpSeqFrame->getImageInformation(0)->srcRect;

	// draw hp meter
	getStaticData()->m_Basic.m_Graphics.draw(
		HP_METER_LEFT, HP_METER_TOP, getStaticData()->getSequence(
		SpriteType::COMMON, Sequence::Common::HP_METER) );

	GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
	float fHPRate = lpPlayer->getHP() / lpPlayer->getHPMax();

	// black
	DrawCircleGauge( 
		static_cast<int>( HP_METER_LEFT + rSrcRect.getWidth() / 2 ),
		static_cast<int>( HP_METER_TOP + rSrcRect.getHeight() / 2 ),
		( 1.f - fHPRate ) * 100.f, 
		getStaticData()->getImageHandle(
		SpriteType::COMMON, Sequence::Common::HP_METER_BLACK ) );

	// set bright as red(evil-gage)
	float fEvilGageRate = lpPlayer->getEvilGage() / MAX_EVIL_GAGE;
	SetDrawBright( 255, (int)(255 * (1.f-fEvilGageRate)), (int)(255 * (1.f - fEvilGageRate )) );

	// draw frame
	getStaticData()->m_Basic.m_Graphics.draw(
		HP_METER_LEFT, HP_METER_TOP, lpSeqFrame );

	// revert bright
	SetDrawBright( 255,255,255);

	// shortcutmF
	int nSelectedItemType = getStaticData()->m_ShortCutPaletteManager.getSelectedValue();//getShortCut(getStaticData()->getShortCutIndex() );
	if( nSelectedItemType >= 0 ) {
		int nItemClassType = getStaticData()->getItemClassType( nSelectedItemType ) ;
		switch( nItemClassType ) {
		case ItemClassType::WEAPON:
			{
				int nWeaponIconSize = (int)getStaticData()->getSequence(
					SpriteType::COMMON, Sequence::Common::WEAPON_ICONS )->getImageInformation(0)->srcRect.getWidth();
				// draw weapon type
				DrawRectGraph(
					(int)( HP_METER_LEFT + rSrcRect.getWidth() /2 - nWeaponIconSize / 2 ),
					(int)( HP_METER_TOP + rSrcRect.getHeight() / 2 - nWeaponIconSize / 2 ),
					(int)( lpPlayer->getWeaponType() * nWeaponIconSize ),
					0,
					nWeaponIconSize, nWeaponIconSize, getStaticData()->getImageHandle( 
					SpriteType::COMMON, Sequence::Common::WEAPON_ICONS ), TRUE, FALSE );
			}
			break;
		default:
			{
				// ACe\
				getStaticData()->m_Basic.m_Graphics.draw(
					HP_METER_LEFT + rSrcRect.getWidth() / 2,
					HP_METER_TOP + rSrcRect.getHeight() / 2,
					getStaticData()->getSequence( SpriteType::ITEM, nSelectedItemType ),
					FaceDirection::LEFT, 0, ITEM_DRAW_SCALE_RATE );
				break;
			}
		}
	}

	/*
	// draw evil-gage
	HPLSequence* lpGageSeq = getStaticData()->getSequence(
		SpriteType::COMMON, Sequence::Common::EVIL_GAGE );
	HPLRect rGageSrcRect = lpGageSeq->getImageInformation(0)->srcRect;
	{
		int nX = 100;
		int nY = HP_METER_TOP + rSrcRect.getHeight() / 2;

		// draw frame
		//HPLSequence* lpSeq = getStaticData()->getSequence(
		//	SpriteType::COMMON, Sequence::Common::EVIL_GAGE_FRAME );
		DrawGraph( nX, nY,
			getStaticData()->getImageHandle( SpriteType::COMMON, Sequence::Common::EVIL_GAGE_FRAME ), TRUE );


		// draw gage

		//float fRate = lpPlayer->getEvilGage() / MAX_EVIL_GAGE;
		// test
		float fRate = 0.7f;

		DrawRectGraph( nX, nY,
			0,0,rGageSrcRect.getWidth() * fRate, rGageSrcRect.getHeight(), 
			getStaticData()->getImageHandle( SpriteType::COMMON, Sequence::Common::EVIL_GAGE ), TRUE, FALSE );
	}*/

	// draw evil-orb
	{
		int nCenterX = (int)(HP_METER_LEFT + rSrcRect.getWidth() / 2);
		int nCenterY = (int)(HP_METER_TOP + rSrcRect.getHeight() / 2);

		int nFrameHandle = getStaticData()->getImageHandle(
			SpriteType::COMMON, Sequence::Common::EVIL_ORB_FRAME );
		int nOrbHandle = getStaticData()->getImageHandle(
			SpriteType::COMMON, Sequence::Common::EVIL_ORB );

		HPLSequence* lpSeq = getStaticData()->getSequence(
			SpriteType::COMMON, Sequence::Common::EVIL_ORB_FRAME );
		HPLRect rOrbSrcRect = lpSeq->getImageInformation(0)->srcRect;

		//const int INTERVAL_X = rOrbSrcRect.getWidth() + 5;

		// I[u\Ԋuixj
		const float DEGREE_INTERVAL = DEGREE_FULL_ROUND / MAX_ORB_CARRIABLE_NUM;

		// HP[^̒SAI[u̒S܂ł̋
		const float RADIUS = rSrcRect.getWidth() / 2 * 0.9f;

		for( int i = 0; i < getStaticData()->m_Save.getFlag( FlagType::EVIL_ORB_MAX ); i ++ ) {
			float fDegree = DEGREE_INTERVAL * i - 90;
			int x = (int)( nCenterX + RADIUS * cos( HPLMath::getRadianFromDegree( fDegree ) ) -
				rOrbSrcRect.getWidth() / 2 );
			int y = (int)( nCenterY + RADIUS * sin( HPLMath::getRadianFromDegree( fDegree ) ) -
				rOrbSrcRect.getHeight() / 2 );

			DrawGraph( x, y, nFrameHandle, TRUE );

			if( i < getStaticData()->m_Save.getFlag( FlagType::EVIL_ORB_NUM ) ) {
				DrawGraph( x, y, nOrbHandle, TRUE );
			}
		}
	}

	// z[~O[U[͓drpbN\
	int nNeedItemType = -1;
	// draw battery/missiles
	switch( lpPlayer->getWeaponType() ) {
	case WeaponType::HOMING_LASER:
	case WeaponType::ELECTRIC_HOMING_LASER:
		{
			nNeedItemType = Sequence::Item::BATTERY;
		}
		break;
	case WeaponType::MISSILE_LAUNCHER:
	case WeaponType::HOMING_MISSILE_LAUNCHER:
	case WeaponType::NIKITA_MISSILE:
		{
			nNeedItemType = Sequence::Item::MISSILE;
		}
		break;
	}
	if( nNeedItemType >= 0 ) {
		// obe[Kvȕ
		
		HPLSequence* lpBatterySeq = getStaticData()->getSequence( 
			SpriteType::ITEM, nNeedItemType );
		int nBatteryWidth = (int)lpBatterySeq->getImageInformation(0)->srcRect.getWidth();

		int nLeft = (int)( HP_METER_LEFT + rSrcRect.getWidth() );
		int nTop = HP_METER_TOP + 50;
		getStaticData()->m_Basic.m_Graphics.draw(
			nLeft, nTop, lpBatterySeq );

		// \
		DrawString(
			nLeft + nBatteryWidth,
			nTop,
			HPLString::chrToStr( "x%d", getStaticData()->m_Save.getItemNum( nNeedItemType ) ).c_str(),
			GetColor( 255,255,255) );
	}

	// score/high-score
	{
		int nLeft = 400;
		int nTop = 50;

		const char SCORE_LABEL[] = "Score:";
		// score
		DrawString( 
			nLeft,
			nTop,
			SCORE_LABEL, GetColor(255,255,255));

		vector<int> vecNumList;
		HPLMath::getNumArrayFromNumber( (int)getStaticData()->m_Save.getScore(),
			false, NUM_POWER, vecNumList);

		getStaticData()->m_ObjectManager.m_EffectManager.drawNumber(
			nLeft + SIZEOF( SCORE_LABEL) * FONT_WIDTH,
			nTop, 255,255,255, vecNumList);

		// high score?
	}

}

