#include "GItem.h"

#include <hpllib/action/HPLActionMoveTool.h>


#include "GStaticData.h"

using namespace std;
using namespace GEnum;

GItem::GItem( int nType ) : HPLShootingObject(nType){
	setObjectType(ObjectType::ITEM);

	//this->setSprite(getStaticData()->getSprite(SpriteType::ITEM)->clone());

//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_ENEMY] = false;
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_SHOT] = false;
	this->setObjectAttribute( ObjectAttribute::GRAVITY, true );
//	this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = true;

	this->setSprite( getStaticData()->getSprite( SpriteType::ITEM )->clone() );

	this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, true );
	this->setObjectAttribute( ObjectAttribute::HIT_TO_PLAYER, true );
	this->setObjectAttribute( ObjectAttribute::BOUND, true );
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK] = true;
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_PLAYER] = true;
//	this->m_aryObjectAttribute[ObjectAttribute::BOUND] = true;
	
	HPLRect rSrcRect = this->getSequence()->getImageInformation(0)->srcRect;
	this->setSize( rSrcRect.getWidth(), rSrcRect.getHeight() );
	this->setHitRect( 0,0,rSrcRect.getWidth(),rSrcRect.getHeight() );

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON);
	this->setHPMax(100);
	this->setHP(this->getHPMax());

	//this->m_bIsWeapon = false;

	// default scale
	this->m_fScale = -1;

	// color
//	this->m_Color = NULL;

	switch( nType ) {
	case Sequence::Item::KOKEMOMO:
		this->setHitRect(8,14,12,14);
		break;
	case Sequence::Item::MEAT:
		this->setHitRect(8,14,30,30);
		break;
	case Sequence::Item::EVIL_DRINK:
		this->setHitRect(14,3,34,54);
		break;
	case Sequence::Item::BATTERY:
		this->setHitRect(2,4,28,28);
		break;
	case Sequence::Item::GATRING_GUN:
		this->setHitRect(4,28,36,18);
//		this->m_bIsWeapon = true;
		break;

	case Sequence::Item::KAPIBARA:
		this->setHitRect(8,3,19,28);
		break;
	case Sequence::Item::ALPACA:
		this->setHitRect(1,2,28,44);
		break;
	case Sequence::Item::DELTA:
		this->setHitRect(1,7,29,21);
		break;
	case Sequence::Item::LAMDA:
		this->setHitRect(4,13,24,33);
		break;
	case Sequence::Item::KAPPA:
		this->setHitRect(3,12,26,34);
		break;

	case Sequence::Item::COIN:
	case Sequence::Item::BLUE_COIN:
	case Sequence::Item::FLYING_COIN:
	case Sequence::Item::FLYING_COIN_10:
	case Sequence::Item::FLYING_COIN_50:
	case Sequence::Item::FLYING_COIN_100:
	case Sequence::Item::FLYING_COIN_500:
	case Sequence::Item::FLYING_COIN_1000:
	case Sequence::Item::FLYING_COIN_5000:
	case Sequence::Item::FLYING_COIN_10000:
	case Sequence::Item::COIN_10:
	case Sequence::Item::COIN_50:
	case Sequence::Item::COIN_100:
	case Sequence::Item::COIN_500:
	case Sequence::Item::COIN_1000:
	case Sequence::Item::COIN_5000:
	case Sequence::Item::COIN_10000:
		{
			int HIT_RECT[] = {
				5,5,15,15
			};

			// scale
			switch( nType ) {
			case Sequence::Item::FLYING_COIN_10:
			case Sequence::Item::FLYING_COIN_50:
			case Sequence::Item::COIN_10:
			case Sequence::Item::COIN_50:
				this->m_fScale = 1.5f;
				break;
			case Sequence::Item::FLYING_COIN_100:
			case Sequence::Item::FLYING_COIN_500:
			case Sequence::Item::COIN_100:
			case Sequence::Item::COIN_500:
				this->m_fScale = 2;
				break;
			case Sequence::Item::FLYING_COIN_1000:
			case Sequence::Item::FLYING_COIN_5000:
			case Sequence::Item::COIN_1000:
			case Sequence::Item::COIN_5000:
				this->m_fScale = 3;
				break;
			case Sequence::Item::FLYING_COIN_10000:
			case Sequence::Item::COIN_10000:
				this->m_fScale = 4;
				break;
			}
			if( this->m_fScale > 0 ) {
				for( int i = 0; i < SIZEOF(HIT_RECT); i ++ ) {
					HIT_RECT[i] *= this->m_fScale;
				}
				this->setSize( this->getWidth() * this->m_fScale,
					this->getHeight() * this->m_fScale );
			}

			// flying
			switch( nType ) {
			case Sequence::Item::FLYING_COIN:
			case Sequence::Item::FLYING_COIN_10:
			case Sequence::Item::FLYING_COIN_100:
			case Sequence::Item::FLYING_COIN_1000:
			case Sequence::Item::FLYING_COIN_10000:
			case Sequence::Item::FLYING_COIN_50:
			case Sequence::Item::FLYING_COIN_500:
			case Sequence::Item::FLYING_COIN_5000:
				this->setObjectAttribute( ObjectAttribute::GRAVITY, false );	// flying
				break;
			}
			//// color
			/*switch( nType ) {
			case Sequence::Item::FLYING_COIN_50:
			case Sequence::Item::FLYING_COIN_500:
			case Sequence::Item::FLYING_COIN_5000:
			case Sequence::Item::COIN_50:
			case Sequence::Item::COIN_500:
			case Sequence::Item::COIN_5000:
				this->setColor( 0,255,0);
				break;
			default:
				this->setColor( 255,0,255);
			}*/
			this->setHitRect(HIT_RECT[0],HIT_RECT[1],HIT_RECT[2],HIT_RECT[3]);
			this->setObjectAttribute( ObjectAttribute::BOUND, true );
	//		this->m_aryObjectAttribute[ObjectAttribute::BOUND] = true;
		}
		break;
	case Sequence::Item::PINE_APPLE:
		this->setHitRect(6,6,20,20);
//		this->m_bIsWeapon = true;
		break;
	case Sequence::Item::SHOT_GUN:
		this->setHitRect(10,6,40,20);
//		this->m_bIsWeapon = true;
		break;
	case Sequence::Item::RAIL_GUN:
		this->setHitRect(10,7,51,17);
//		this->m_bIsWeapon = true;
		break;

	case Sequence::Item::FRAME_THROWER:
		this->setHitRect(8,8,50,20);
	//	this->m_bIsWeapon = true;
		break;
	case Sequence::Item::EVI_FLY:
		this->setHitRect(4,9,18,9);
		break;
	case Sequence::Item::ANTI_POISON:
		this->setHitRect(28,24,6,40);
		break;
	case Sequence::Item::CHAIN_SAW:
		this->setHitRect(6,9,58,14);
//		this->m_bIsWeapon = true;
		break;
	case Sequence::Item::PUNCH:
	case Sequence::Item::DRILL:
	case Sequence::Item::ELECTRIC_HOMING_LASER:
	case Sequence::Item::HOMING_LASER:
	case Sequence::Item::HOMING_MISSILE_LAUNCHER:
	case Sequence::Item::SATELITE_GUN:
	case Sequence::Item::SNIPER_RIFLE:
	case Sequence::Item::TOMAHAWK:
	case Sequence::Item::WATER_GUN:
	case Sequence::Item::MAYO_GUN:
	case Sequence::Item::LASER_GUN:
	case Sequence::Item::HAND_GUN:
	case Sequence::Item::MISSILE:
	case Sequence::Item::MISSILE_LAUNCHER:
	case Sequence::Item::CRYOLATOR:
	case Sequence::Item::PILE_BUNKER:
	case Sequence::Item::NIKITA_MISSILE:
	case Sequence::Item::QUEEN_AUTHORITY:
	case Sequence::Item::SEED:
	case Sequence::Item::WIND_WIZARD:
		this->setHitRect(6,9,58,14);
		break;
	case Sequence::Item::EVI:	// TCY͉摜TCYƓ
		break;
	case Sequence::Item::AJI:	// TCY͉摜TCYƓ
		break;
	case Sequence::Item::STEAK:	// TCY͉摜TCYƓ
		break;
	case Sequence::Item::BOSS_ABILITY:
		this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
		break;
	case Sequence::Item::CAR_BALL_DUMMY:
	case Sequence::Item::SPREAD_MISSILE_LAUNCHER:
	case Sequence::Item::MULTI_MISSILE_LAUNCHER:
		break;

	default:
		ASSERT_IT_TYPE( nType, "Item type");
//		HPLError::assertIt(false );
		break;
	}
}

void GItem::die(HPLShootingObject* damageSource){
	this->setAlive( false );

	switch( this->getType() ) {
	case Sequence::Item::BOSS_ABILITY:	// boss ability
		{
			const int CURE_CHARGE_NUM = 30;
			// cure charge 
			for( int i = 0; i < CURE_CHARGE_NUM; i ++ ) {
				// center
				HPLVector vCenter = this->getCenter();
				// radom radius
				HPLVector vR;
				vR.setByDegree( HPLMath::nextInt(0,(int)HPLMathConsts::DEGREE_FULL_ROUND ) );
				vR.multiple( HPLMath::nextInt(0, this->getWidth() ) );
				vCenter.add( vR );

				// create effect
				GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
					Sequence::Effect::CURE_CHARGE, vCenter, true );
				// homing to player
				lpEffect->setTarget( &getStaticData()->m_ObjectManager.m_Player );
//				lpEffect->setCenterPosition( .getCenter() );

				// random velocity
				HPLVector v;
				v.setByDegree( HPLMath::nextInt( 0, (int)HPLMathConsts::DEGREE_FULL_ROUND ) );
				const float MIN_VEL = 5;
				const float MAX_VEL = 10;
				v.multiple( HPLMath::nextFloat(MIN_VEL, MAX_VEL ) );

				// set vel
				lpEffect->setVelocityAngle( v );
			}
		}
		break;
	}

}

/*void GItem::damage(float dmg, HPLShootingObject* damageSource){
}*/

void GItem::draw() {

	int t = this->getType();

	// XN[
	HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(0);

	// V[PXɕϊ
	HPLSequence* seq = this->getSequence();
	
	float left = this->getArea().getX() + scroller->getVirtualRect().getX();
	float top = this->getArea().getY() + scroller->getVirtualRect().getY();

	
	float fRotateDegree = 0;

	int alpha = 255;

	bool bIsDisappear = seq->getLoopNumMax() > 0;

	int nMapIndex = getStaticData()->getMapIndex();
	if( nMapIndex == SpecialMapIndex::TEST_CHEST ) {
		bIsDisappear = false;
	}

	if( bIsDisappear ) {
		// ^Cv
		float fRate = seq->getCurrentFullStepCountRate();//static_cast<float>( seq->getStepCounter() ) / seq->getImageInformation(0)->waitFrame;
		if( fRate > ITEM_NEAR_DISAPPEAR_RATE_THRESHOLD ) {
			// 芄ȏi
			if( seq->getStepCounter() % 2 == 0 ) {
				// 2F1񔖂
				alpha = 100;
			}
		}
	}
	if( alpha < 0 ) {
		alpha = 0;
	} else if( alpha > 255 ) {
		alpha = 255;
	}

	float fCenterX = this->getCenter().getX() + scroller->getVirtualRect().getX();
	float fCenterY = this->getCenter().getY() + scroller->getVirtualRect().getY();
	float fZoom = scroller->m_fZoomRate;
	fCenterX *= fZoom;
	fCenterY *= fZoom;

	// 蔻\
	if( getStaticData()->getInputManager()->isPressed( KeyMap::F ) ){
		HPLRect rHitRect = this->getHitRect();
		DrawFillBox(
			static_cast<int>( left + rHitRect.getX() ),
			static_cast<int>( top + rHitRect.getY() ),
			static_cast<int>( left + rHitRect.getX() + rHitRect.getWidth() ),
			static_cast<int>( top + rHitRect.getY() + rHitRect.getHeight() ),
			GetColor(255,0,0) );
	}

	// 邳EF
	bool bIsChangedBright = false;
	int nR = 255,nG = 255,nB = 255;
	// F֘A
	switch( this->getType() ) {
	case Sequence::Item::BOSS_ABILITY:
		{
			int c = this->getColor();
			nR = STAR_COLOR[c][0];
			nG = STAR_COLOR[c][1];
			nB = STAR_COLOR[c][2];
			bIsChangedBright = true;
		}
		break;
	case Sequence::Item::COIN_10:
	case Sequence::Item::COIN_100:
	case Sequence::Item::COIN_1000:
	case Sequence::Item::COIN_10000:
	case Sequence::Item::COIN_50:
	case Sequence::Item::COIN_500:
	case Sequence::Item::COIN_5000:
	case Sequence::Item::FLYING_COIN:
	case Sequence::Item::FLYING_COIN_10:
	case Sequence::Item::FLYING_COIN_100:
	case Sequence::Item::FLYING_COIN_1000:
	case Sequence::Item::FLYING_COIN_10000:
	case Sequence::Item::FLYING_COIN_50:
	case Sequence::Item::FLYING_COIN_500:
	case Sequence::Item::FLYING_COIN_5000:
		{
			HPLColor* lpCol = getStaticData()->m_ObjectManager.m_ItemManager.getCoinColor( this->getType()) ;
			nR = lpCol->r;
			nG = lpCol->g;
			nB = lpCol->b;
			bIsChangedBright = true;
			if( this->m_fScale >0 ) {
				fZoom *= this->m_fScale;
			}
		}
		break;
	}
	if( bIsChangedBright ) {
		SetDrawBright(nR,nG,nB);
	}
	getStaticData()->m_Basic.m_Graphics.draw(
		static_cast<int>( fCenterX ), static_cast<int>( fCenterY ), seq,
		this->getFaceDirection(), fRotateDegree, fZoom, alpha, alpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND);

	if( bIsChangedBright ) {
		// 邳EFZbg
		SetDrawBright(255,255,255);
	}
	// Aj[VXebv
	// 
	if(getStaticData()->m_Game.isTheWorld() == false){
		seq->step();
		if( bIsDisappear && seq->getState().isFinishAnimation ) {
			this->die(NULL);
		}
	}

}


HPLSequence* GItem::getSequence(){
	int seqID = getType();
	HPLSequence* seq = 
		this->getSprite()->getPair(seqID)->left;
	return seq;

}


/** Ԍo߂ŏ邩ݒ
  */
void GItem::setDisappear( bool bIsDisappear ) {
	if( bIsDisappear ) {
		//
		HPLSequence* lpSeq = this->getSequence();
		lpSeq->setLoopNumMax(1);
	}
}
