#ifndef _G_ITEM_MANAGER_
#define _G_ITEM_MANAGER_

#include <hpllib/cycle/HPLObjectManager.h>

#include "GEnum.h"

#include "GItem.h"
#include <vector>
#include <string>

using namespace std;

namespace GEnum {
	namespace ItemFlagType {
		enum ItemFlagType_ {
			CURE,
			STOCK,
			UNIQUE,
			USABLE,
			MAX_NUM
		};
	}
}

/** item settings
  */
class GItemSetting {
public:
	string m_strName;	//! name
	int m_nType;		//! type
	int m_nClassType;	//! class
	int m_nEmotionIcon;	//! emotion
	int m_nNextState;	//! next state
	int m_nCure;		//! cure plus
	int m_nPoint;		//! point for score
private:
	bool m_aryFlags[GEnum::ItemFlagType::MAX_NUM];
public:
	bool getFlagBit( int nIndex ) {
//		return HPLMath::getFlagByIndexInt( this->m_nFlags, nIndex );
#ifdef _DEBUG
		ASSERT_IT_INDEX( nIndex, 0, GEnum::ItemFlagType::MAX_NUM );
#endif
		return this->m_aryFlags[nIndex];
	}
	void setFlagBit( int nIndex, bool bFlag ) {
#ifdef _DEBUG
		ASSERT_IT_INDEX( nIndex, 0, GEnum::ItemFlagType::MAX_NUM );
#endif
//		this->m_nFlags = HPLMath::setFlagByIndexInt( this->m_nFlags,
//			nIndex, bFlag );
		this->m_aryFlags[nIndex] = bFlag;
	}
public:
	GItemSetting() {
		this->m_nType = -1;
		this->m_nClassType = -1;
		this->m_nEmotionIcon = -1;
		this->m_nNextState = -1;
		this->m_nCure = 0;
		//this->m_nFlags = 0;
		for( int i = 0; i < GEnum::ItemFlagType::MAX_NUM; i ++ ) {
			m_aryFlags[i] = false;
		}
		this->m_nPoint = 0;
	}

	/**
	  * @
	  */
	int setup( string& str );
};

/*
	ACef[^O
	EnEmotionIcon		EƂɏo邦
						FEI_HEART
						-1ȂoȂ
	EnChangeState		EƂɃXe[gω
						FCHECK
						-1ȂωȂ
*/

/** ACeǗ
  */
class GItemManager: public HPLObjectManager<GItem> {
private:
	std::vector<std::string> m_vecItemDescriptions;	//! 
	std::vector<std::string> m_vecNames;	//! ACẽXg
//	std::vector<int> m_aryPrevShortCutKeys;	//! V[gJbgL[p
	GItemSetting m_arySettings[GEnum::Sequence::Item::MAX_NUM];
	std::map<int,HPLColor> m_mapCoinColor;
public:
	HPLColor* getCoinColor( int nType );
	std::string getDescription( int nIndex );
	std::string getName( int nIndex );
	GItemSetting* getSetting( int nIndex ) {
#ifdef _DEBUG
		ASSERT_IT_INDEX( nIndex, 0, GEnum::Sequence::Item::MAX_NUM );
#endif
		return &this->m_arySettings[nIndex];
	}
public:
	GItemManager();
	virtual ~GItemManager(){ clear(); }

	// Operations
public:
	void process(bool isMove, bool bIsAI);
	GItem* create(int t, HPLVector center);

	void algorithm(GItem* lpItem);

	bool checkHitToPlayer( GItem* lpItem );

	/** w肵ɑΉRC쐬
	  */
	void createCoins( HPLVector& vCreateCenter, int nNum );

	/** ݒȂǂ̓ǂݍ
	  */
	void setup();
private:
	void createCoins( HPLVector& vCreateCenter, int nItemType, int nNum );

};

#endif
