#include "GNeutralManager.h"

#include "GStaticData.h"

#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/math/HPLMath.h>

#include <hpllib/game/map/HPLMapData.h>

#include "GSelectStageScene.h"

using namespace std;
using namespace GEnum;
using namespace HPL::MapData::Item;


bool GNeutralManager::checkHitToPlayer( GNeutral* lpNeutral, GPlayer* lpPlayer ) {

	bool bIsHit = false;

	int st = lpNeutral->getState()->getState();

/*	if( lpNeutral->getType() == Sequence::Neutral::MOVER &&
		( lpNeutral->m_nMoverType == MoverType::ROTATE || lpNeutral->m_nMoverType == MoverType::ROTATE_REVERSE ) )
	{
		HPLVector v;
		v.setByDegree( lpNeutral->getRotateDegree() + HPLMath::getSgn<float>( lpNeutral->m_nMoverType == MoverType::ROTATE ? 1: -1 ) * 90 );
		v.multiple( fabs(MOVER_ROTATE_SPEED ) );
		lpNeutral->setVelocityAngle(v );
	}*/

	// 锻sǂ
	bool bIsCheckCollision = lpNeutral->m_nMountType != MountType::NONE;
	if( lpPlayer->isHeld() ) {	// SĂ
		// 锻͂Ȃ
		bIsCheckCollision = false;
	}
	if( bIsCheckCollision ) {

		// ɏ邱Ƃł
		CollisionState stateX,stateY;

		// 鏈
		getStaticData()->rideOnObject( lpPlayer, lpNeutral, 
			stateX, stateY );

		bIsHit = stateX.isHitX != HitDirectionX::NONE || stateY.isHitY != HitDirectionY::NONE;

	}
	
	if( lpPlayer->getState()->isSpecialState() ) {
		//bIsCheckCollision = false;
		return false;
	}

	if( lpNeutral->getType() == Sequence::Neutral::FAN ||
		lpNeutral->getType() == Sequence::Neutral::KILLER_FAN)						// t@EL[t@
	{
		HPLRect rHitArea = lpPlayer->getHitArea();
		//HPLRect rNeutralHitArea = lpNeutral->getHitArea();
		HPLRect rBrustArea = lpNeutral->getBrustArea();

		if( getStaticData()->m_Game.getTempFlagBit( TempFlagType::SWITCH_LOCK, 0 ) == false &&
			rBrustArea.isShare( rHitArea ) )
		{
			// XCb`ԂON
			// oGAɓ

			float fRate = 0;			// ߂Âivyɋ߂قǋj
			bool bIsAccel = false;		// ANZ邩
			bool bIsX = false;			// X

			if( lpNeutral->getMapNumber() == FanDirectionType::UP ) {
				// TODO SW̍ōs邩mFB
				
				// 
				// xvZ
				float fHeight = rBrustArea.getBottom() - lpPlayer->getCenter().getY();

				if( fHeight > 0 ) {
					//
					// Wv񐔂1ɂ
					lpPlayer->getJumpManager()->setJumpNumMax(1);
					lpPlayer->getJumpManager()->resetJumpNumMax();

					fRate = fHeight / rBrustArea.getHeight();
					if( fRate > 1 ) {
						bIsAccel = false;
					} else {

						// 
						bIsAccel = true;
						bIsX = false;
					}
				}
			} else if( lpNeutral->getMapNumber() == FanDirectionType::RIGHT ) {
				float fWidth = lpPlayer->getCenter().getX() - rBrustArea.getX();
				fRate = fWidth / rBrustArea.getWidth();
				if( fRate >= 0 && fRate <= 1 ) {
					// 
					bIsAccel = true;
					bIsX = true;
				}
			} else if( lpNeutral->getMapNumber() == FanDirectionType::DOWN ) {
				float fHeight = lpPlayer->getCenter().getY() - rBrustArea.getY();
				float fRate = fHeight / rBrustArea.getHeight();
				if( fRate >= 0 && fRate <= 1 ) {
					// 
					bIsAccel = true;
					bIsX = false;
				}
			} else if( lpNeutral->getMapNumber() == FanDirectionType::LEFT ) {
				float fWidth = rBrustArea.getRight() - lpPlayer->getCenter().getX();
				fRate = fWidth / rBrustArea.getWidth();
				if( fRate >= 0 && fRate <= 1 ) {
					// 
					bIsAccel = true;
					bIsX = true;
				}
			}

			if( bIsAccel ) {
				// 

				// ݒ
				float fDegree = ( lpNeutral->getMapNumber() - 1 ) * 90.f;
				HPLVector vAccelDirection;
				vAccelDirection.setByDegree( fDegree );

				// xݒ
				vAccelDirection.multiple( (1.f - fRate ) * (bIsX ? MAX_BRUST_ACCEL_X : MAX_BRUST_ACCEL_Y) );

				if( lpNeutral->getType() == Sequence::Neutral::KILLER_FAN ) {
					// L[t@

					// tɂ
					vAccelDirection.multiple( - KILLER_FAN_BRUST_SPEED_RATE );

					// xF
					// Sɋ߂قǈ񂹂鋭͋̂ŁÂ܂܂OK
				}

				// 
				HPLVector vVelocityAngle = lpPlayer->getVelocityAngle();
				vVelocityAngle.add( vAccelDirection );
				lpPlayer->setVelocityAngle( vVelocityAngle );
			}
		} // is hit


	} else if ( lpNeutral->getType() == Sequence::Neutral::BED ) {	
		if( st == StateType::DEAD ) {
			// Ȃ
		} else {
			// xbh
			if( lpNeutral->m_bIsPlayerMountOn ) {
				// uvɏ

				// Wv񐔂1ɂ
				lpPlayer->getJumpManager()->setJumpNumMax(1);
				lpPlayer->getJumpManager()->resetJumpNumMax();
				// Wv
				// ݒAxݒ
				HPLVector vVelocityAngle( 0, - BED_JUMP_VELOCITY_Y );

				// xݒ
				lpPlayer->setVelocityAngle( vVelocityAngle );
				HPLVector vCenter = lpPlayer->getCenter();
				vCenter.add( vVelocityAngle );
				lpPlayer->setCenter( vCenter ) ;
				lpPlayer->m_bIsLandOnObject = false;
				lpPlayer->changeState(StateType::FLYUP_2 );
				lpPlayer->getTrigger()->setTrigger( TriggerType::ON_THE_GROUND, false );

				lpNeutral->m_bIsPlayerMountOn = false;

				// xbh̓_[W󂯂
				lpNeutral->damage( BOUNCE_DAMAGE_TO_BED, lpPlayer );
			}
		}
	}


	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON);

	HPLRect rPlayerHitArea = lpPlayer->getHitArea();
	HPLRect rHitArea = lpNeutral->getHitArea();

	bool bIsSave = false;			// Z[uH

	if( rPlayerHitArea.isShare( rHitArea ) ) {

		//bool bIsCreateObject = false;	// 𐶐Neutral

		// qbg
		switch( lpNeutral->getType() ) {
		case Sequence::Neutral::KILLER_FAN:
			if( lpPlayer->isInvinsible() == false ) {
				// ܂
				getStaticData()->damageObject( lpPlayer, lpNeutral, KILLER_FAN_DAMAGE * fLevel, true, StateType::DAMAGE ) ;
				bIsHit = true;
			}
			break;
		case Sequence::Neutral::BED:
			if( lpPlayer->isChecking() ) {
				if( st == StateType::DEAD ) {
					// ꂽxbh

					this->m_bIsChecked = true;

					// ŏɉ󂵂ȂCxg
					if( getStaticData()->m_Game.m_Reminder.getNoCheck( ReminderType::BED_DESTRUCTION_COUNT ) == 0 ) {
						getStaticData()->startEvent(2, false);
						getStaticData()->m_Game.m_Reminder.setNoCheck( ReminderType::BED_DESTRUCTION_COUNT, 1 );
					}
					// G[V

					getStaticData()->createPlayerEmotionIcon( Sequence::Effect::EI_HAZUKASHI );
				}
			}
			break;
		case Sequence::Neutral::TANSU:
		case Sequence::Neutral::TAKARA_BAKO:
			{
				if( lpPlayer->isChecking() ) {
					// J(uԂ̂)
					if( st == StateType::STAND ) {

						// ܂JĂȂ
						this->m_bIsChecked = true;

						// "!"}[N
						getStaticData()->createPlayerEmotionIcon( Sequence::Effect::EI_SNAKE );

						if( getStaticData()->getMapIndex() == SpecialMapIndex::TEST_CHEST ) {
							// do nothing
							// xłJ
						} else {
							// 
							lpNeutral->changeState( StateType::ATTACK );
						}


						// ACe
						if( ParameterType::Neutral::OBJECT_TYPE < static_cast<int>( lpNeutral->getPlacerParameters()->size() ) ) {

							// IuWFNg^Cv
							int nObjectType = lpNeutral->getPlacerParameter( ParameterType::Neutral::OBJECT_TYPE );

							// 
							int nType = lpNeutral->getPlacerParameter( ParameterType::Neutral::TYPE );
							if( 0 <= nObjectType && 0 <= nType ) {
								// ACe擾\

								bool bIsEvent = false;

								switch( nObjectType ) {
								case ObjectType::ITEM:
									{
										// JƂL^
										GBoxFlag* lpBox = getStaticData()->m_Save.getBoxFlag( lpNeutral->getType() );
										lpBox->setFlag( nObjectType, nType, lpNeutral->getPlacerParameter( ParameterType::Neutral::FLAG_INDEX), true );
										bIsSave = true;

										// ACeRs[
										getStaticData()->m_TakarabakoInfo.m_nItemType = nType;
										getStaticData()->m_TakarabakoInfo.m_nItemNum = lpNeutral->getPlacerParameter( ParameterType::Neutral::NUM );

										// 擾Cxg̎̃Cxgݒ
										getStaticData()->m_TakarabakoInfo.m_nNextEvent = lpNeutral->getPlacerParameter( ParameterType::Neutral::NEXT_EVENT );

										// ACe擾Cxg
										getStaticData()->startEvent( 7, true );
									}
									break;
								case ObjectType::ENEMY:
									{
										HPLVector vCreateCenter = lpNeutral->getCenter();
										vCreateCenter.add( 0, -50 );
										for( int i = 0; i < lpNeutral->getPlacerParameter( ParameterType::Neutral::NUM ); i ++ ) {

											GEnemy* lpEnemy = getStaticData()->m_ObjectManager.m_EnemyManager.create( 
												nType, vCreateCenter, -1 );
											// ɕグ
											lpEnemy->setVelocityAngle( 
												lpPlayer->getFaceDirection() * TAKARABAKO_ENEMY_JUMP_SPEED_X,
												-TAKARABAKO_ENEMY_JUMP_SPEED_Y );
											// vC[̕
											lpEnemy->setFaceDirection( - lpPlayer->getFaceDirection()  );
										}

										// 
										bIsEvent = true;
									}
									break;
								default:
									bIsEvent = true;
									break;
								}
								if( bIsEvent ) {
									int nEvent = lpNeutral->getPlacerParameter(ParameterType::Neutral::NEXT_EVENT );
									if( nEvent >= 0 ) {
										getStaticData()->startEvent( nEvent, true );
									}
								}
							}

						} // valid parameter setting
						

					} // stand state 
				} // player checking
			}
			break;
		case Sequence::Neutral::KILLER_TANSU:
			if( lpPlayer->isChecking() ) {
				if( st == StateType::STAND ) {

					// J
					lpNeutral->changeState( StateType::ATTACK );

					// ?
					getStaticData()->createPlayerEmotionIcon( Sequence::Effect::EI_HATENA );

					// 񂶂ႤI
					getStaticData()->startEvent( 5, true );
				}
			}
			break;
		case Sequence::Neutral::DOOR_IDLE:
			if( lpPlayer->isChecking() ) {
				// J
				lpNeutral->changeState( StateType::ATTACK );
				this->m_bIsChecked = true;

				getStaticData()->m_nPlayerPlaceIndex = lpNeutral->getPlacerParameter( ParameterType::Neutral::PLAYER_PLACE_INDEX );
				
				int nMapIndex = getStaticData()->getMapIndex();	// current map index

				int nSceneIndex = lpNeutral->getScenarioNumber();
				int nNextMapIndex = lpNeutral->getMapNumber();	// Jڐ̃CfbNX

				bool bIsCheckPoint = false;		// `FbN|Cgł


				switch( nMapIndex ) {
				case SpecialMapIndex::PRACTICE:
					{
						// vNeBX甲
						if( getStaticData()->m_Save.getFlag( FlagType::START ) < StartType::EVIL_HOUSE_BED ) {
							// v
							getStaticData()->m_Save.setItemNum( Sequence::Item::GATRING_GUN, 0 );
							lpPlayer->getWeapon(WeaponType::GATLING )->m_bIsActivated = false;
							// delete from weapon list
							getStaticData()->m_Save.m_aryWeaponState[WeaponType::GATLING] = 0;
							// delete from item list
							getStaticData()->m_Save.setItemNum(Sequence::Item::GATRING_GUN, 0);

							// pbg~jK
							int nMinigunIndex = getStaticData()->m_ShortCutPaletteManager.getIndexByValue(
								Sequence::Item::GATRING_GUN );
							if( nMinigunIndex >= 0 ) {
								getStaticData()->m_ShortCutPaletteManager.setValue(nMinigunIndex, -1 );
							}
							
							// ̂ɋύX
							lpPlayer->setWeaponType(WeaponType::PUNCH);

							// flag ύX
							getStaticData()->m_Save.setFlag( FlagType::START, StartType::EVIL_HOUSE_BED );
							bIsSave = true;
						}
					}
					break;
				case SpecialMapIndex::BEE_HOUSE:
					{
						if( SpecialMapIndex::THREE_WAY == nNextMapIndex && 1 == getStaticData()->m_nPlayerPlaceIndex ) {
							// `FbN|Cgł
							bIsCheckPoint = true;
						}
					}
					break;
				case SpecialMapIndex::WIND_SNIPER:
					{
						if( SpecialMapIndex::WIND_RIDE_CLOUD == nNextMapIndex ) {
							bIsCheckPoint = true;
						}
					}
					break;
				}
				if( nSceneIndex >= 0 ) {
					bIsCheckPoint = true;
				}
				if( bIsCheckPoint ) {
					// `FbN|Cgł
					// ̃V[PlaceIɕς

					bIsSave = getStaticData()->checkPoint(nNextMapIndex );
				} else {

					// tF[hAEgJn
					getStaticData()->startFadeOutDX( nSceneIndex, nNextMapIndex );
				}

			}
			break;
		case Sequence::Neutral::HELP:
			// Ŕ

			if( st == StateType::STAND ) {
				if( lpPlayer->isChecking() ) {
					this->m_bIsChecked = true;

					// w肳ꂽCxg𔭓
					// ǂ߂悤ɂ
					getStaticData()->startEvent( lpNeutral->getPlacerParameter( ParameterType::Neutral::NEXT_EVENT ),
						true);

					lpNeutral->changeState( StateType::DEAD );
				}
			}
			break;
		case Sequence::Neutral::FUYU:
			if( st == StateType::STAND) {
				// ʏԂŐGꂽ

				// DEADɂȂ
				lpNeutral->changeState( StateType::WALK );

				// vC[DisappearɂȂ
				lpPlayer->changeState( StateType::DISAPPEAR );

				HPLVector vVelocity = lpNeutral->getVelocityAngle();
				// ֓
				vVelocity.setY( FUYU_RIDING_SPEED_Y );
				lpPlayer->setVelocityAngle( vVelocity );
			}
			break;
		case Sequence::Neutral::TANK:
		case Sequence::Neutral::VTOL:
		case Sequence::Neutral::CAR:
		case Sequence::Neutral::ROBOGEN:
			{
				if( lpPlayer->getPlayerClassType() == PlayerClassType::HUMAN ) {
					// lԃ^Cvł
					if( lpPlayer->isChecking() ) {
						// ׂ
						if( lpNeutral->getRidePlayerType() >= 0 ) {

							// 
							lpPlayer->changeType( lpNeutral->getRidePlayerType(), lpNeutral );

							// ͏
							lpNeutral->setAlive( false );

						} else {
							// ݒ~X
							HPLError::assertIt( false, "error");
						}
					}
				}
			}
			break;
		}

		// ***** hA⃏[vꍇAvC[̐ݒuʒuStaticDataɓn
	}
	if( bIsSave ) {
		getStaticData()->m_Save.save();
	}

	return bIsHit;
}

bool GNeutralManager::checkHitToShot( GNeutral* lpNeutral ) {

	if( lpNeutral->isAlive() == false ) {
		return false;
	}

	// XCb`H
	bool bIsSwitch = false;
	if( lpNeutral->getType() == Sequence::Neutral::SWITCH_OFF ) {	// XCb`ł
		bIsSwitch = true;
	}
	if( false == bIsSwitch &&	// not switch
		false == lpNeutral->getObjectAttribute( ObjectAttribute::HIT_TO_SHOT )	// neutralshotɓȂݒ
		)
	{
		// do nothing
		return false;
	}
	
	// ΂ɃVbgƂ̓蔻sȂ
/*	if( false == lpNeutral->getObjectAttribute( ObjectAttribute::HIT_TO_SHOT ) ) {
		return false;
	}*/
	
	// player
	GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;

	HPLRect merginedGameRange = getStaticData()->getMerginedGameRange();	// Q[̈(scrolled)

	HPLRect rHitArea = lpNeutral->getHitArea();		// neutral ̓蔻

	bool bIsHit = false;	// hitH
	
	for( list<GShot*>::iterator it = getStaticData()->m_ObjectManager.m_ShotManager.getList()->begin();
		it != getStaticData()->m_ObjectManager.m_ShotManager.getList()->end();
		it ++ )
	{
		GShot* lpShot = *it;

		if( false == lpShot->isAlive() ) {	// shot is dead
			// do nothing
			continue;
		}
		if( lpShot->getParentID() != lpPlayer->getID() ) {	// not player shot
			// do nothing
			continue;
		}
		
		if( bIsSwitch ) {	// neutral is switch
			// no skip
		} else {	// not switch
			if( false == lpShot->getObjectAttribute( ObjectAttribute::HIT_TO_NEUTRAL )// &&		// not hit to neutral
	//			false == lpShot->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK]
			)
			{
				continue;
			}
		}
		if( lpShot->getParentID() == lpNeutral->getID() ) {	// neutral's shot
			continue;
		}

		// ʂ̏
		switch( lpNeutral->getType() ) {
		case Sequence::Neutral::SWITCH_OFF:
			if( lpShot->getType() == Sequence::Shot::EXPLOSION ) {	// 
				// switch cannot be changed by explosion
				continue;
			}
			break;
		}
		/*if( lpShot->isHitToNeutral() == false ) {
			continue;
		}*/
		
		// shot hit area
		HPLRect rShotHitArea = lpShot->getHitArea();

		if( rShotHitArea.isShare( merginedGameRange ) == false ) {
			// ʊO
			continue;
		}

		bool bIsHit = false;

		if( lpShot->getShotClassType() == ShotClassType::LASER ) {
			if( HPLActionMoveTool::isHitObjectToLaser( lpShot, true,
				lpNeutral, lpNeutral->getHitRect().getWidth() / 2 ) )
			{
				// [U[Neutralqbg
				bIsHit = true;
			}
		} else {
			if( rShotHitArea.isShare( rHitArea ) ) {
				bIsHit = true;
			}
		}

		if( bIsHit ) {	// hit!

			// damage
			float fDamage = lpShot->m_fPower;
			if( lpNeutral->m_bIsInvinsible ) {
				// G
				fDamage = 0;
			} else {
				// [

				if( lpShot->getDamageType(DamageType::FIRE )) {
					// fire
					// ->܂ƂGtFNgij𔭐
					getStaticData()->m_ObjectManager.startFireEffect( 
						Sequence::Effect::FIRE, 
						lpNeutral );
				} 
				if( lpShot->getDamageType( DamageType::WATER ) ){
					if( lpNeutral->getType() == Sequence::Neutral::ALLY_FLOWER ) {
						// 
						const int STEP_SPEED_UP = 1;
						lpNeutral->getSequence()->step(STEP_SPEED_UP);
					}
				}

				switch( getStaticData()->m_ObjectManager.getWeakImmuneType( lpShot, lpNeutral ) ) {
				case WeakImmuneType::WEAKNESS:
					fDamage *= WEAKNESS_DAMAGE_RATE;
					break;
				case WeakImmuneType::IMMUNITIES:
					fDamage *= IMMUNITIES_DAMAGE_RATE;
					getStaticData()->m_MixerManager.play( SE::UNBREAKABLE, true );
					break;
				}
				lpNeutral->damage( fDamage, lpShot );
			}
			
			// blow
			float fBlowSpeed = 0;
			//HPLActionMoveTool::blowAway();

			// hit effect
			{
				if( lpShot->getShotClassType() != ShotClassType::LASER ||
					HPLMath::nextInt(0,3 ) == 0 )
				{
					HPLVector vCenter = lpShot->getCenter();
					if( lpShot->getShotClassType() == ShotClassType::LASER ) {
						vCenter = lpNeutral->getCenter();
					}
					vCenter.add( HPLMath::nextFloat(-EFFECT_HIT_ERR, EFFECT_HIT_ERR ),
						HPLMath::nextFloat(-EFFECT_HIT_ERR,EFFECT_HIT_ERR) );
					getStaticData()->createEffect( Sequence::Effect::HIT,
						vCenter, lpNeutral->getCenter(), -1, -1);
				}
			}
			
			// shot kieru
			if( lpShot->getObjectAttribute( ObjectAttribute::HIT_NEUTRAL_TO_DIE ) ||
				lpShot->getObjectAttribute( ObjectAttribute::HIT_BLOCK_TO_DIE ))
			{
				lpShot->die( lpNeutral );
			}
		}
	}

	return bIsHit;
}

