#include "GNeutral.h"

#include "GStaticData.h"
#include "GSelectStageScene.h"

#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/action/HPLCollisionCheckTool.h>
#include <hpllib/math/HPLMath.h>

using namespace std;

using namespace GEnum;

void GNeutral::setWeakness( int nType, bool bIsWeak ) {
	this->m_nWeaknesses = HPLMath::setFlagByIndexInt(this->m_nWeaknesses, nType,
		bIsWeak );
}
bool GNeutral::isWeakness( int nType ) {
	return HPLMath::getFlagByIndexInt( this->m_nWeaknesses, nType );
}
void GNeutral::setImmunity( int nType, bool bIsImmune ) {
	this->m_nImmunities = HPLMath::setFlagByIndexInt(this->m_nImmunities, nType,
		bIsImmune );
}
bool GNeutral::isImmunity( int nType ) {
	return HPLMath::getFlagByIndexInt( this->m_nImmunities, nType );
}


/** ǉ
  * ݃vy
  * Ƃ
  */
GNeutral::GNeutral( int nType, int nMapNumber, int nScenarioNumber ) : HPLShootingObject(nType) {
	setObjectType(ObjectType::NEUTRAL);
	this->m_nMapNumber = nMapNumber;
	this->m_nScenarioNumber = nScenarioNumber;

	this->m_lpAmpCounter = NULL;

	// ftHgݒ
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_PLAYER] = false;
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_ENEMY] = false;
	GNeutralSetting* lpSetting = getStaticData()->m_ObjectManager.m_NeutralManager.getNeutralSetting(nType );
	this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, lpSetting->m_bIsHitToShot );
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_SHOT] = true;
	this->setObjectAttribute( ObjectAttribute::GRAVITY, true );
	//this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = true;

	this->m_nWeaknesses = 0;
	this->m_nImmunities = 0;

	// ܂ƂGtFNg
	getStaticData()->m_ObjectManager.resetFireEffect( this );
	
	// smoke interval
	this->m_lpSmokeIntervalCounter = NULL;

	// invinsible
	this->m_bIsInvinsible = lpSetting->m_bIsInvinsible;//INVINSIBLES[nType];

	this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK , true );
	this->setObjectAttribute( ObjectAttribute::HIT_BLOCK_TO_DIE, false );
//	this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK] = true;
	HPLSprite* lpSprite = new HPLSprite();
	lpSprite->setSequence( nType, getStaticData()->getSprite( SpriteType::NEUTRAL)->getPair( nType )->clone() );

	for( int i = 0; i < (int)lpSetting->m_vecExtraSequenceIDs.size(); i ++ ) {

		int nSeqID = lpSetting->m_vecExtraSequenceIDs[i] + Sequence::Neutral::MAX_NUM;
		lpSprite->setSequence(
			nSeqID,
			//EXTRA_SEQ_ID[i],
			getStaticData()->getSprite( SpriteType::NEUTRAL)->getPair(
			nSeqID )->clone() );
	}
	
	this->setSprite( lpSprite );

	// TCY
	HPLRect rSrcRect = this->getSequence()->getImageInformation(0)->srcRect;
	this->setSize( rSrcRect.getWidth(), rSrcRect.getHeight() );
	// ftHgsize=hitrect
	if( lpSetting->isHitRectEqualsSize() ) {
		this->setHitRect( 0,0,rSrcRect.getWidth(),rSrcRect.getHeight() );
	} else {
		// ݒ肷lL
		this->setHitRect(
			lpSetting->m_aryHitRect[0],
			lpSetting->m_aryHitRect[1],
			lpSetting->m_aryHitRect[2],
			lpSetting->m_aryHitRect[3]);
	}
	
	this->m_bIsPlayerMountOn = false;

	this->m_nMountType = lpSetting->m_nMountType;//MountType::BLOCK;		// {̓ubN
	//this->m_nPlayerPlaceIndex = -1;

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON);

	float fHPRate = 1;

	this->m_nRidePlayerType = -1;	// 悵Ȃ
	
	this->setObjectAttribute( ObjectAttribute::GRAVITY , lpSetting->m_bIsGravity );

	this->m_bIsMover = false;

	// jȂǂɔN
	const int DEFAULT_EXPLOSION_NUM = 10;
	// Ԋu
	const int EXPLOSION_INTERVAL_FRAMES = 21;

	switch( nType ) {
	case Sequence::Neutral::FAN:
		{
			this->m_vecColors.push_back( HPLColor(255,255,255));
			this->m_vecColors.push_back( HPLColor(0,100,255));	// player,wind wizard,chaser boss ability
		}

	case Sequence::Neutral::KILLER_FAN:
		{
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK , false );
//			this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_BLOCK ] = false;
			if( nType == Sequence::Neutral::KILLER_FAN ) {
				this->m_nMountType = MountType::NONE;	// Ȃ
			}
			
			if( this->m_nMapNumber < 0 ) {
				this->m_nMapNumber = 0;
			}
			if( this->m_nMapNumber >= FanDirectionType::MAX_NUM ) {
				this->m_nMapNumber = FanDirectionType::MAX_NUM - 1;
			}
			float SIZES[][2] = {
				{64,32},
				{32,64},
				{64,32},
				{32,64},
			};
			this->setSize(SIZES[this->m_nMapNumber][0], SIZES[this->m_nMapNumber][1]);

			float HIT_RECTS[][4] = {
				{0,0,64,32},
				{0,0,32,64},
				{0,0,64,32},
				{0,0,32,64},
			};
			this->setHitRect(HIT_RECTS[this->m_nMapNumber][0], HIT_RECTS[this->m_nMapNumber][1], HIT_RECTS[this->m_nMapNumber][2], HIT_RECTS[this->m_nMapNumber][3]);
//			this->m_aryObjectAttribute[ObjectAttribute::GRAVITY ] = false;

			// ͈
			float BRUST_RECT_PATTERN[][4] = {
				{ 0,-FAN_BRUST_LENGTH,64,32 + FAN_BRUST_LENGTH},	// up
				{ 0,0,32 + FAN_BRUST_LENGTH,64},	// right
				{ 0,0,64,32 + FAN_BRUST_LENGTH},		// down
				{ -FAN_BRUST_LENGTH,0,32 + FAN_BRUST_LENGTH,64},	// left
			};
			this->m_rBrustRect.set( 
				BRUST_RECT_PATTERN[this->m_nMapNumber][0],
				BRUST_RECT_PATTERN[this->m_nMapNumber][1],
				BRUST_RECT_PATTERN[this->m_nMapNumber][2],
				BRUST_RECT_PATTERN[this->m_nMapNumber][3]
				);
		}
		break;
	case Sequence::Neutral::BURNER:
		{
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK , false );
	//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_BLOCK ] = false;
			if( this->m_nMapNumber < 0 ) {
				this->m_nMapNumber = 0;
			}
			if( this->m_nMapNumber >= FanDirectionType::MAX_NUM ) {
				this->m_nMapNumber = FanDirectionType::MAX_NUM - 1;
			}
	//		this->setSize(32,32);
			const int DELTA = 4;
			this->setHitRect(DELTA,DELTA,32 - DELTA * 2,32 - DELTA * 2);
			this->setObjectAttribute( ObjectAttribute::GRAVITY , false );
	//		this->m_aryObjectAttribute[ObjectAttribute::GRAVITY ] = false;

			// ̓_ɂ
			int nInterval = (int)(HPLMath::nextInt(100,150) / fLevel);//static_cast<int>( 150 / fLevel );
			
			this->m_IntervalCounter.setWaitFrameNum( nInterval );

			this->m_IntervalCounter.end();
		}

		break;
	case Sequence::Neutral::MOVER:
	case Sequence::Neutral::RIDE_CLOUD:
	case Sequence::Neutral::ROUND_TRUNK:
	case Sequence::Neutral::ICE:
	case Sequence::Neutral::SLIDE_CLOUD:
	case Sequence::Neutral::BACK_CLOUD:
		{
			this->m_bIsMover = true;
			if( this->m_nMapNumber < 0 ) {
				this->m_nMapNumber = 0;
			}
			if( this->m_nMapNumber >= MoverType::MAX_NUM ) {
				this->m_nMapNumber = MoverType::MAX_NUM - 1;
			}
			this->m_nMoverType = this->m_nMapNumber;

	//		this->setSize(32,32);
			const int MOVER_HIT_DELTA = 3;
			switch( nType ) {
			case Sequence::Neutral::MOVER:
			case Sequence::Neutral::ICE:
				{
					this->setHitRect(2,2,
						this->getWidth() - MOVER_HIT_DELTA,
						this->getHeight() - MOVER_HIT_DELTA);
				}
				break;
			case Sequence::Neutral::RIDE_CLOUD:
				{
					this->setHitRect( 2,2,
						this->getWidth() - MOVER_HIT_DELTA,
						this->getHeight() - MOVER_HIT_DELTA );
				}
				break;
			case Sequence::Neutral::ROUND_TRUNK:
				{
					this->setHitRect( 2,2,
						this->getWidth() - MOVER_HIT_DELTA,
						this->getHeight() - MOVER_HIT_DELTA );

				}
				break;
			}

			// EGCgJE^(ǂɓۂɎ~܂鎞)
			// Easy=62,Normal=50,Hard=38,NIGHTMARE=26
			int nWaitFrameNum = (int)(74 - fLevel * 24);
			if( nWaitFrameNum < 0 ) {
				nWaitFrameNum = 1;
			}
			this->m_WaitCounter.setWaitFrameNum( nWaitFrameNum );
			this->m_WaitCounter.end();

			// MoveType
			switch( this->m_nMoverType ) {
			case MoverType::LEFT_RIGHT:			// start with right
			case MoverType::UP_DOWN:			// start with down
				this->m_nNextDirection = -1;
				break;
			case MoverType::RIGHT_LEFT:
			case MoverType::DOWN_UP:
				this->m_nNextDirection = 1;
				break;
			case MoverType::ROTATE:
			case MoverType::ROTATE_REVERSE:
				// 
				// ]p
				this->setRotateDegree( this->m_nMoverType == MoverType::ROTATE ? 0.f : 180.f );
				//HPLMath::nextFloat(0,HPLMathConsts::DEGREE_FULL_ROUND ) );
				// ubNɃqbgȂ
				this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK , false );
	//			this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK] = false;

				break;
			case MoverType::FALL:
				this->m_nNextDirection = 0;
				break;
			default:
				// ȉ͓Ȃ
				// none
				// disappear
				this->m_nNextDirection = 0;
				break;
			}
//			this->setObjectAttribute( ObjectAttribute::GRAVITY , false );
//			this->m_aryObjectAttribute[ObjectAttribute::GRAVITY ] = false;

			// Ȃ
			this->setObjectAttribute( ObjectAttribute::NO_RESIST , true );
//			this->m_aryObjectAttribute[ ObjectAttribute::NO_RESIST ] = true;
			
		}
		break;
	case Sequence::Neutral::BED:
		this->setHitRect( 0,20,120,35);
		this->setFaceDirection( 
			this->m_nMapNumber <= 0 ? FaceDirection::LEFT : FaceDirection::RIGHT );

		this->m_nMountType = MountType::THROW;	// ubN
		break;
	case Sequence::Neutral::TANSU:
	case Sequence::Neutral::KILLER_TANSU:
		this->setHitRect( 9,15,112,113);

		this->m_nMountType = MountType::THROW;	// ؂邱Ƃł

		break;
	case Sequence::Neutral::DOOR_IDLE:
		this->setHitRect( 23,22,50,74 );
		this->m_nMountType = MountType::NONE;
	
		break;
	case Sequence::Neutral::TAKARA_BAKO:
		this->setHitRect( 8,31,48,49 );
		//this->m_nMountType = MountType::NONE;
		this->m_nMountType = MountType::NONE;		// Ȃ
		break;
	case Sequence::Neutral::HELP:
		this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
//		this->m_aryObjectAttribute[ObjectAttribute::GRAVITY ] = false;
		this->m_nMountType = MountType::NONE;
		//this->setHitRect( 0,0,32,32 );
		break;
	case Sequence::Neutral::NEXT:
		this->m_nMountType = MountType::NONE;
		break;
	case Sequence::Neutral::FUYU:
		this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
//		this->m_aryObjectAttribute[ObjectAttribute::GRAVITY ] = false;
		this->m_nMountType = MountType::NONE;
		this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_BLOCK ] = false;
		break;
	case Sequence::Neutral::ROCK:
		{
			fHPRate = 5;
			this->setHitRect(20,21,59,64);
			this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
	//		this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = false;
			for(int i = 0; i < DamageType::MAX_NUM; i ++ ) {
				switch( i ) {
				case DamageType::DRILL:
				//case DamageType::EXPLOSION:
					this->setWeakness( i, true );
					break;
				default:
					this->setImmunity( i, true );
				}
			}
		}
			
		break;
	case Sequence::Neutral::TREE:
		{
			fHPRate = 5;
			//this->setHitRect(91,38,62,179);	// old tree(evisen)
			this->setHitRect(44,9,22,192);
//			this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
	//		this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = false;
			for(int i = 0; i < DamageType::MAX_NUM; i ++ ) {
				switch( i ) {
				case DamageType::CHAIN_SAW:
				case DamageType::FIRE:
					this->setWeakness( i, true );
					break;
				default:
					this->setImmunity( i, true );
				}
			}
		}
		break;
	case Sequence::Neutral::EVIGEN_PARTS_ARM:
	case Sequence::Neutral::EVIGEN_PARTS_BODY:
	case Sequence::Neutral::EVIGEN_PARTS_LEG:
	case Sequence::Neutral::EVIGEN_PARTS_HEAD:
		{
			int HIT_RECTS[][5] = {
				{Sequence::Neutral::EVIGEN_PARTS_ARM, 2,2,12,12 },
				{Sequence::Neutral::EVIGEN_PARTS_BODY,6,6,20,34},
				{Sequence::Neutral::EVIGEN_PARTS_LEG,2,2,12,12},
				{Sequence::Neutral::EVIGEN_PARTS_HEAD,2,2,19,21},
			};
			for( int i = 0; i < SIZEOF( HIT_RECTS ); i ++ ) {
				if( HIT_RECTS[i][0] == nType ) {
					this->setHitRect(
						HIT_RECTS[i][1],
						HIT_RECTS[i][2],
						HIT_RECTS[i][3],
						HIT_RECTS[i][4]
						);
					break;
				}
			}
			getStaticData()->m_ObjectManager.setupRandomRotate(this);
			//this->setRotateDegreeSpeed(??? );
		}
		break;
	case Sequence::Neutral::SWITCH_OFF:
		fHPRate = 5;
	case Sequence::Neutral::LOCK_BLOCK:
//		this->setHitRect(0,0,getWidth(), getHeight() );
		this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
//		this->m_aryObjectAttribute[ObjectAttribute::GRAVITY] = false;
		
		break;
	case Sequence::Neutral::CHECK_POINT:
		this->m_nMountType = MountType::NONE;
		this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
//		this->m_aryObjectAttribute[ ObjectAttribute::GRAVITY ] = false;
		break;
	case Sequence::Neutral::GENERATOR:
		this->m_nMountType = MountType::NONE;
		this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
//		this->m_aryObjectAttribute[ ObjectAttribute::GRAVITY ] = false;
		this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
		this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, false );
	//	this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_BLOCK ] = false;
	//	this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_SHOT ] = false;

		// ̂̓IvV(MapIndex,SceneIndex̎)Őݒ肷

		// Ԋu (IvV2ŕύX\)
		this->m_IntervalCounter.setWaitFrameNum(150);
		break;
	case Sequence::Neutral::BARRIER:
		{
			// Ȃ
			this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
	//		this->m_aryObjectAttribute[ ObjectAttribute::GRAVITY ] = false;
			// SN񔚔
			this->m_WaitCounter.setWaitFrameNum( DEFAULT_EXPLOSION_NUM );
			this->m_WaitCounter.reset();

			// Ԋu
			this->m_IntervalCounter.setWaitFrameNum( EXPLOSION_INTERVAL_FRAMES );
			this->m_IntervalCounter.end();
			fHPRate = 15;
		}
		break;
	case Sequence::Neutral::TANK:
		this->m_nMountType = MountType::THROW;
		this->setHitRect((HPLRect&)TANK_HIT_RECT);
		this->m_nRidePlayerType = PlayerType::TANK;
		break;
	case Sequence::Neutral::VTOL:
		this->m_nMountType = MountType::THROW;
		this->setHitRect((HPLRect&)VTOL_HIT_RECT);
		this->m_nRidePlayerType = PlayerType::VTOL_NYA;
		break;
	case Sequence::Neutral::CAR:
		this->m_nMountType = MountType::THROW;
		this->setHitRect((HPLRect&)CAR_HIT_RECT);
		this->m_nRidePlayerType = PlayerType::CAR;
		break;
	case Sequence::Neutral::ROBOGEN:
		this->m_nMountType = MountType::THROW;
		this->setHitRect((HPLRect&)ROBOGEN_HIT_RECT);
		this->m_nRidePlayerType = PlayerType::ROBOGEN;
		break;
	case Sequence::Neutral::WATER_FALL:
		this->m_nMountType = MountType::NONE;
		this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
		this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
		this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, false );
//		this->m_aryObjectAttribute[ ObjectAttribute::GRAVITY ] = false;
//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_BLOCK ] = false;
//		this->m_aryObjectAttribute[ ObjectAttribute::HIT_TO_SHOT ] = false;
		break;
	case Sequence::Neutral::DISPENSER_EVI:
	case Sequence::Neutral::DISPENSER_AKU:
	case Sequence::Neutral::DISPENSER_SIRU:
	case Sequence::Neutral::DISPENSER_BU:
	case Sequence::Neutral::DISPENSER_CA:
		{
			int HIT_RECTS[][4] = {
				{12,117,104,121},
				{0,22,63,104},
				{9,9,62,71},
				{14,7,52,108},
				{7,7,66,94},
			};
			int nHitRectIndex = nType - Sequence::Neutral::DISPENSER_EVI;
			this->setHitRect(
				HIT_RECTS[nHitRectIndex][0],
				HIT_RECTS[nHitRectIndex][1],
				HIT_RECTS[nHitRectIndex][2],
				HIT_RECTS[nHitRectIndex][3] );
			this->m_nMountType = MountType::THROW;

		}
		break;
	case Sequence::Neutral::ALLY_FLOWER:
		{
			this->setHitRect(45,84,32,156);
			this->m_nMountType = MountType::BLOCK;
			this->setObjectAttribute( ObjectAttribute::HIT_TO_ENEMY, true );
			this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, true );
			this->setWeakness( DamageType::FIRE, true );
			this->setImmunity( DamageType::WATER, true );
			fHPRate = 10;
			this->m_IntervalCounter.setWaitFrameNum( 30 );
		}
		break;
	case Sequence::Neutral::MERC:
		{
//			this->setHitRect(5,7,52,52);
//			this->m_nMountType = MountType::NONE;
			this->setObjectAttribute( ObjectAttribute::HIT_TO_ENEMY, false );
//			this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, true );

			this->m_lpAmpCounter = new HPLCounter(360);
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
		}
		break;
	case Sequence::Neutral::JAMMING:
		{
			// hit to shot true
			// hit rect 
			// mount type block
			// invinsible false
			// gravity false
			fHPRate = 20;
			this->m_IntervalCounter.setWaitFrameNum( 100 );

			// 莞ԈԊuŔ
			// SN񔚔
			this->m_WaitCounter.setWaitFrameNum( DEFAULT_EXPLOSION_NUM );
			this->m_WaitCounter.reset();

			// Ԋu
			this->m_IntervalCounter.setWaitFrameNum( EXPLOSION_INTERVAL_FRAMES );
			this->m_IntervalCounter.end();

			const int SMOKE_INTERVAL = 20;
			// 
			this->m_lpSmokeIntervalCounter = new HPLCounter( SMOKE_INTERVAL );
		}
		break;
	case Sequence::Neutral::EFFECT_GENERATOR:
		{
			// create effect
		}
		break;
/*	case Sequence::Neutral::BU_CLOUD:
		{
			// hit to shot false
			// hit rect
			// mount type none
			// invinsible true
			// gravity false

			// 
			int BU_SPEED_X = 5;
			int BU_SPEED_Y = 10;
			this->setVelocityAngle( -BU_SPEED_X, -BU_SPEED_Y );
			this->setObjectAttribute( ObjectAttribute::HIT_TO_BLOCK, false );
		}
		break;*/
	default:
		break;
	}
	this->setHPMax(fHPRate * 100);
	this->setHP(this->getHPMax());


}

/*
void GNeutral::collision(HPLMatrix<int>* matrix,
			   std::map<int, HPLBlock*>* blockMap)
{
	float RESIST = getStaticData()->getSetting()->resist;
	const float GRAVITY = getStaticData()->getSetting()->gravity;
	// Rő呬xiCRƂ̂肠j
	const float FALL_MAX_SPEED = getStaticData()->getSetting()->fallMaxSpeed;

	if( this->isMover() ) {
		RESIST = 0;
	}
	
	int tileSize = getStaticData()->getSetting()->tileSize;
	

	HPLRect hitArea = getHitArea();
	HPLVector velocityAngle = getVelocityAngle();
	HPLVector center = getCenter();

	float dx = center.getX() - hitArea.getX();
	float dy = center.getY() - hitArea.getY();

	{
		CollisionState stateX = HPLCollisionTool::adjustCollisionX(
			hitArea, velocityAngle,
			matrix, tileSize, 
			*blockMap);

		bool isTouch = blockMap->find( stateX.m_nTouchBlockID )->second->isEmpty() == false;
		
		this->getTrigger()->setTrigger(TriggerType::HIT_TO_THE_LEFT,
			isTouch && stateX.isHitX == HitDirectionX::LEFT);
		this->getTrigger()->setTrigger(TriggerType::HIT_TO_THE_RIGHT,
			isTouch && stateX.isHitX == HitDirectionX::RIGHT);

		///////
		// ɂԂ
		if( //this->m_bIsHitToBlock ){
			this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK] )
		{
			if(isTouch){
				center.setX(stateX.fixDeltaX + dx);
				hitArea.setX(stateX.m_nNewX);

				velocityAngle.setX(0);

			}else{
			}
		}
		//
		///////
	}

	if(isAlive()){
		
		CollisionState stateY = HPLCollisionTool::adjustCollisionY(
			hitArea, velocityAngle,
			matrix, tileSize, 
			*blockMap);

		// C
		bool isTouch = blockMap->find( stateY.m_nTouchBlockID )->second->isEmpty() == false;

		this->getTrigger()->setTrigger(TriggerType::ON_THE_GROUND,
			isTouch && stateY.isHitY == HitDirectionY::BOTTOM);
		this->getTrigger()->setTrigger(TriggerType::HIT_TO_THE_CEILING,
			isTouch && stateY.isHitY == HitDirectionY::TOP);

		if(isTouch &&
			this->m_aryObjectAttribute[ObjectAttribute::HIT_TO_BLOCK]
		//	this->m_bIsHitToBlock
		)
		{
			// GĂ
			center.setY( stateY.m_nNewY + dx);
			hitArea.setY( stateY.m_nNewY );


			if(stateY.isHitY == HitDirectionY::BOTTOM){
				//velocityAngle.setY(0);
				////
				// 
				velocityAngle.setX(HPLActionMoveTool::reduceSpeed(
					RESIST,
					velocityAngle.getX()));

				velocityAngle.setY(0);
			}else{
				velocityAngle.setY(0);
			}


		}else{

			if( this->isGravity() ) {
				velocityAngle.setY(velocityAngle.getY() + GRAVITY);
			}
		}
	}

	center.add(velocityAngle);

	setCenter(center);
	setVelocityAngle(velocityAngle);


	//HPLActionMoveTool::checkGroundAtTheFaceDirection((HPLShootingObject*)this,
	//	getStaticData()->getBlockManager(), tileSize);
	
}
*/
void GNeutral::die(HPLShootingObject* damageSource){
	switch( getType() ) {
	case Sequence::Neutral::BED:
		{
			this->changeState( StateType::DEAD );
			// fʂ
			this->m_bIsPlayerMountOn = false;
			this->m_nMountType = MountType::NONE;

			// Z
			getStaticData()->stepAndCheckAchievement( AchievementType::BED_CRASHER, 1, true );
		}
		break;
	case Sequence::Neutral::SWITCH_OFF:
		{
			// ]
			this->changeState( this->getState()->getState() == StateType::STAND ? StateType::DAMAGE : StateType::STAND );

			// game ̏ԕω
			getStaticData()->m_Game.setTempFlagBit( TempFlagType::SWITCH_LOCK, this->getColor(), 
				this->getState()->getState() == StateType::DAMAGE );
			// HPMaxɖ߂
			this->setHP( this->getHPMax() );

			// ʂh炷
			getStaticData()->m_ShakeManager.startShake();
		}
		break;
	case Sequence::Neutral::BARRIER:
		{
			if( this->getHP() <= 0 ) {	// dead
				// ->SelectStarŉo
				GSelectStageScene* lpScene = (GSelectStageScene*)getStaticData()->m_SceneManager.getScene(SceneType::SELECT_STAGE);

				// ->oX^[g
				lpScene->setEffectType(SelectStarSceneEffectType::BARRIER_EXPLOSION );

				// j󂷂
				this->changeState( StateType::DEAD );

				//U
				getStaticData()->m_ShakeManager.startShake();
				// }bvCfbNX
				//int nMapIndex = getStaticData()->getMapIndex();
			
				// Star=StageType
				int nStar = getStaticData()->m_nSelectedStar;
				int nPlace = getStaticData()->m_nSelectedPlace;
				//getStaticData()->m_Setting.maps.getStarAndPlaceFromMapIndex( nMapIndex,
				//	nStar, nPlace );

				// gamȅԕω
				int nFlag = getStaticData()->m_Save.getFlag( FlagType::DESTROY_BARRIER );
				nFlag = HPLMath::setFlagByIndexInt( nFlag, nStar, true );

				getStaticData()->m_Save.setFlag( FlagType::DESTROY_BARRIER, nFlag );
				getStaticData()->m_Save.save();
			}
		}
		break;
	case Sequence::Neutral::ICE:
		this->changeState( StateType::DEAD );
		if( this->getSequence()->getState().isFinishAnimation ) {
			this->setAlive( false );
		}
		break;
	case Sequence::Neutral::JAMMING:
		this->changeState( StateType::DEAD );
		// ܂ɓȂȂ
		this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, false );
		// not ridable
		this->m_nMountType = MountType::NONE;
	default:
		this->setAlive( false );
	}
}

void GNeutral::damage(float dmg, HPLShootingObject* damageSource){
	if( this->m_bIsInvinsible == false ) {//this->getType() == Sequence::Neutral::BED || 
		
		float fOldHP = this->getHP();

		this->setHP( this->getHP() - dmg );

		if( fOldHP > 0 && this->getHP() <= 0 ) {
			this->die( damageSource );
		}
	}
}

void GNeutral::draw() {

	int t = this->getType();

	// XN[
	HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(0);

	// V[PXɕϊ
	HPLSequence* seq = this->getSequence();
	
	float left = this->getArea().getX() + scroller->getVirtualRect().getX();
	float top = this->getArea().getY() + scroller->getVirtualRect().getY();

	// ]
	float fRotateDegree = 0;

	if( this->getType() == Sequence::Neutral::BURNER ||
		this->getType() == Sequence::Neutral::FAN ||
		this->getType() == Sequence::Neutral::KILLER_FAN
		)
	{
		// o[i[
		// t@
		// Elt@
		// ->Tu^Cvɂ]L
		fRotateDegree = this->m_nMapNumber * 90.f;
	}

	// \
	int alpha = 255;
	if( this->isMover() ) {
		if( this->m_nMoverType == MoverType::DISAPPEAR ) {
			// ݂̃Xebv
			int nStepCounter = seq->getStepCounter();
			int nMaxCounter = seq->getImageInformation()->waitFrame;

			alpha = 255 - static_cast<int>( 255.f * static_cast<float>(nStepCounter) / static_cast<float>(nMaxCounter) );
		}
	}
	if( alpha < 0 ) {
		alpha = 0;
	} else if( alpha > 255 ) {
		alpha = 255;
	}

	float fCenterX = this->getCenter().getX() + scroller->getVirtualRect().getX();
	float fCenterY = this->getCenter().getY() + scroller->getVirtualRect().getY();
	float fZoom = scroller->m_fZoomRate;
	fCenterX *= fZoom;
	fCenterY *= fZoom;

	// 蔻\
	if( getStaticData()->getInputManager()->isPressed( KeyMap::F ) ){
		HPLRect rHitRect = this->getHitRect();
		DrawFillBox( 
			static_cast<int>( left + rHitRect.getX() ),
			static_cast<int>( top + rHitRect.getY() ),
			static_cast<int>( left + rHitRect.getX() + rHitRect.getWidth() ),
			static_cast<int>( top + rHitRect.getY() + rHitRect.getHeight() ),
			GetColor(255,0,0) );
	}

	if( this->getSprite() != NULL ) {
		// spriteL
		// ->\

		// uh[h
		// Alphaݒ肪΃At@uhɂ
		int nBlendMode = alpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND;
		// U邩
		// ftHgȂ
		bool bIsBibration = false;
		// U
		HPLVector vShakeDelta;

		// Fς
		bool bIsColored = false;
		int nR = 255;
		int nG = 255;
		int nB = 255;
		bool bIsZoomOut = false;
		float fZoomOutStep = 0.05f;
		bool bIsBlackOut = false;


		switch( this->getType() ) {
		case Sequence::Neutral::FAN:
			{
				if( this->getColor() == 1) {
					bIsColored = true;
					nR = 0;
					nG = 0;
					nB = 255;
				}
			}
			break;
		case Sequence::Neutral::SWITCH_OFF:
		case Sequence::Neutral::LOCK_BLOCK:
			{
				bIsColored = true;
				nR = this->m_vecColors[0].r;
				nG = this->m_vecColors[0].g;
				nB = this->m_vecColors[0].b;
			}
			break;
		case Sequence::Neutral::BARRIER:
			{
				if( false == this->getState()->isDeadState() ) {
					// barrier
					// ->Fւ̏Ǝ
					HPLSequence* lpBeam = getStaticData()->getSequence( SpriteType::COMMON,
						Sequence::Common::SELECT_BARRIER_BEAM );
					const float BEAM_DELTA_Y = 800;
					getStaticData()->m_Basic.m_Graphics.draw(
						fCenterX, fCenterY - BEAM_DELTA_Y, 
						lpBeam, FaceDirection::LEFT, 
						90, 5 );

					lpBeam->step();
				}
			}
			break;
		case Sequence::Neutral::MOVER:
		case Sequence::Neutral::ROUND_TRUNK:
		case Sequence::Neutral::RIDE_CLOUD:
			if( MoverType::FALL == this->m_nMoverType ) {
				// ^Cv
				if( StateType::ATTACK == this->getState()->getState() ) {
					const int MOVER_SHAKE_LENGTH = 2;
					// 
					vShakeDelta.setX( HPLMath::nextFloat( -1,1) * MOVER_SHAKE_LENGTH );
				}
			}
			break;
		case Sequence::Neutral::EVIGEN_PARTS_ARM:
		case Sequence::Neutral::EVIGEN_PARTS_LEG:
		case Sequence::Neutral::EVIGEN_PARTS_BODY:
		case Sequence::Neutral::EVIGEN_PARTS_HEAD:
			fRotateDegree = this->getRotateDegree();
			break;
		case Sequence::Neutral::MERC:
			{
				// IɔZ蔖肷
				alpha = seq->getStepCounter() % 2 == 0 ? 200 : 150;
			}
			break;
		case Sequence::Neutral::BACK_CLOUD:
		case Sequence::Neutral::BU_CLOUD:
			{
				bIsColored = true;
				bIsZoomOut = true;
				bIsBlackOut = true;
			}
			break;
		default:
			if( this->getColor() > 0 ) {
				// 
			}
		}

		float fThreshold = 0.1f;
		float fFrameRate = seq->getStepCounter() / (float)seq->getImageInformation()->waitFrame;
		if( bIsZoomOut) {
			fZoom = 1 - fFrameRate;
		}
		if( bIsBlackOut ) {
			nR = (int)(255 * (1.f-fFrameRate));
			nG = (int)(255.f * (1.f-fFrameRate));
			nB = (int)(100.f * (1.f-fFrameRate))+155;
		}
		if( bIsColored ) {
			SetDrawBright( nR,nG,nB );
		}
		// draw
		getStaticData()->m_Basic.m_Graphics.draw(
			static_cast<int>( fCenterX + vShakeDelta.getX() ),
			static_cast<int>( fCenterY + vShakeDelta.getY() ),
			seq,
			this->getFaceDirection(), fRotateDegree, fZoom, alpha, nBlendMode);
		if( bIsColored ) {
			SetDrawBright( 255,255,255 );
		}
		switch( this->getType() ) {
		case Sequence::Neutral::BARRIER:
			if( this->getState()->getState() == StateType::STAND ) {
				// oAGtFNg
				HPLSequence* lpEffect = getStaticData()->getSequence( SpriteType::NEUTRAL, Sequence::Neutral::BARRIER_EFFECT );
				getStaticData()->m_Basic.m_Graphics.draw(
					left, top, lpEffect );
				lpEffect->step();
			}
			break;
		}
		// Aj[VXebv
		// 
		if(getStaticData()->m_Game.isTheWorld() == false )//&&		// not THE WORLD
			//getStaticData()->m_Game.isScenario() == false)		// not in scenarios
		{
			if( this->isMover() && /*getType() == Sequence::Neutral::MOVER && */	// mover
				this->m_nMoverType == MoverType::DISAPPEAR &&	// and disappear
				this->m_bIsPlayerMountOn == false )	// and player is not on this
			{
				// ĂȂ
				// do nothing
			} else {
				seq->step();

			}

			bool bIsDieAfterAnimation = false;
			if( this->isMover() /*this->getType() == Sequence::Neutral::MOVER*/ ) {
				if( this->m_nMoverType == MoverType::DISAPPEAR ) {
					bIsDieAfterAnimation = true;
				}
/*				if( this->getType() == Sequence::Neutral::BU_CLOUD ||
					this->getType() == Sequence::Neutral::BACK_CLOUD )
				{
					bIsDieAfterAnimation = true;
				}*/
			}
			if( bIsDieAfterAnimation && ( ( seq->getState().isFinishAnimation ) || (bIsZoomOut && fZoom <= fThreshold))) {
				// 
				this->die(NULL );
			}
		} // not the world
	} // sprite not null

	if( false == this->m_bIsInvinsible ) {
		getStaticData()->drawHP( this );

	}

}


HPLSequence* GNeutral::getSequence(){
	int seqID = this->getSequenceID();
	HPLSequence* seq = 
		this->getSprite()->getPair(seqID)->left;
	return seq;

}
int GNeutral::getSequenceID() {
	int nSeqID = getType();

	int st = this->getState()->getState();

	int t = this->getType();

	switch( t ) {
	case Sequence::Neutral::BED:
		if( st == StateType::DEAD ) {
			nSeqID = Sequence::Neutral::BROKEN_BED;
		}
		break;
	case Sequence::Neutral::TANSU:
		if( st == StateType::ATTACK ) {
			nSeqID = Sequence::Neutral::OPEN_TANSU;
		}
		break;
	case Sequence::Neutral::DOOR_IDLE:
		if( st == StateType::ATTACK ) {
			nSeqID = Sequence::Neutral::DOOR_OPEN;
		}
		break;
	case Sequence::Neutral::TAKARA_BAKO:
		if( st == StateType::ATTACK ) {
			nSeqID = Sequence::Neutral::TAKARA_BAKO_OPEN;
		}
		break;
	case Sequence::Neutral::KILLER_TANSU:
		if( st == StateType::ATTACK ) {
			nSeqID = Sequence::Neutral::OPEN_TANSU_MUSHA;
		} else if( st == StateType::ATE_00 ) {
			nSeqID = Sequence::Neutral::TANSU_MUSHAED;
		}
		break;
	case Sequence::Neutral::FUYU:
		if( st == StateType::WALK ) {
			nSeqID = Sequence::Neutral::FUYU_EVI;
		}
	case Sequence::Neutral::SWITCH_OFF:
		if( st == StateType::DAMAGE ) {
			nSeqID = Sequence::Neutral::SWICH_ON;
		}
		break;
	case Sequence::Neutral::BARRIER:
		if( st == StateType::DEAD ) {
			nSeqID = Sequence::Neutral::BARRIER_DEAD;
		}
		break;
	case Sequence::Neutral::ICE:
		if( st == StateType::DEAD ) {
			nSeqID = Sequence::Neutral::ICE_DEAD;
		}
		break;
	case Sequence::Neutral::JAMMING:
		if( st == StateType::DEAD ) {
			nSeqID = Sequence::Neutral::JAMMING_DEAD;
		}
		break;
	}
	return nSeqID;
}


bool GNeutral::isMover() {
	return this->m_bIsMover;
	/*
	int t = this->getType();
	return
		Sequence::Neutral::MOVER == t ||
		Sequence::Neutral::RIDE_CLOUD == t ||
		Sequence::Neutral::ROUND_TRUNK == t ||
		Sequence::Neutral::ICE == t ||
		Sequence::Neutral::;*/
}


void GNeutral::changeState( int nState ) {
	int nOldSt = this->getState()->getState();

	if( nOldSt != nState ) {
		this->getSequence()->resetCounter();
	}
	this->getState()->setState( nState );
}

void GNeutral::setColor(int c ) {
	HPLShootingObject::setColor(c);


}

