#ifndef _G_NEUTRAL_
#define _G_NEUTRAL_


#include <hpllib/object/HPLShootingObject.h>
#include <hpllib/math/HPLMatrix.h>
#include <hpllib/game/block/HPLBlock.h>
#include <hpllib/general/HPLCounter.h>
#include <hpllib/general/HPLColor.h>
#include <hpllib/general/HPLPointerTool.h>

#include <vector>

/** NeutraliuAIuWFA@j
  */
class GNeutral : public HPLShootingObject {
public:
	std::vector<HPLColor>		m_vecColors;
	HPLCounter*		m_lpAmpCounter;			//! 󒆂
	bool			m_bIsInvinsible;
	HPLVector		m_CenterPosition;		//! Uq^ꍇ̒SW
//	bool			m_bIs;					//! tOǗ?
	HPLRect			m_rBrustRect;			//! ̉e󂯂͈́BlHitRectƓ
	int				m_nMoverType;			//! MoverType
	HPLCounter		m_WaitCounter;			//! ǂɐڐGA΂xẽt[JE^
	int				m_nNextDirection;		//! EGCg̈ړ
	bool			m_bIsPlayerMountOn;		//! vC[ɏꂽtO
	bool			isMover();				//! ړłBȉ̓
											//! Eǂ̂ړĂȂ

	HPLCounter	m_IntervalCounter;	//! Iɍsp̃JE^

	// All
	int m_nMountType;			//! 邩ǂ̎(GEnum::MountType)

	// wealmess
	void setWeakness( int nType, bool bIsWeak );
	bool isWeakness( int nType );
	// immunity
	void setImmunity( int nType, bool bIsImmune );
	bool isImmunity( int nType );
	// immunities flags
	int getImmunities() {
		return this->m_nImmunities;
	}
	// weakness flags
	int getWeaknesses() {
		return this->m_nWeaknesses;
	}
	// ride player type
	int getRidePlayerType() {		return this->m_nRidePlayerType;	}

	int 						m_nFireEffectType;	//! ̂ɂ܂ƂtGtFNg^Cv
	HPLCounter					m_FireCounter;	//! Âɂ܂ƂtGtFNgo
	int getFanDirectionType() {
		return this->m_nMapNumber;
	}
	HPLCounter* getSmokeIntervalCounter() {
		ASSERT_IT_NULL( this->m_lpSmokeIntervalCounter );
		return m_lpSmokeIntervalCounter;
	}
	void setSmokeIntervalCounterWaitFrameNum( int nNum ) {
		if( this->m_lpSmokeIntervalCounter == NULL ) {
			this->m_lpSmokeIntervalCounter = new HPLCounter();
		}
		this->m_lpSmokeIntervalCounter->setWaitFrameNum(nNum);
		this->m_lpSmokeIntervalCounter->reset();
	}
private:
	HPLCounter* m_lpSmokeIntervalCounter;	//! oԊu
	bool m_bIsMover;
	int m_nRidePlayerType;		//! ~\BǂPlayerTypeɂȂ邩
							//! -1	~łȂiʂNeutralj
	int	m_nWeaknesses;		//! _
	int 	m_nImmunities;		//! ϐ
	// placer pp[^
	std::vector<int> m_vecPlacerParameters;
	/*
	int m_nPlayerPlaceIndex;	//! vC[ǂ̈ʒuɓoꂳ邩̃CfbNX
								//! Ń_
	// 
	int m_nItemType;			//! ĂACe
	int m_nItemNum;				//! ACe̐

	int m_nNextEvent;			//! Cxg
	*/
public:
	std::vector<int>* getPlacerParameters() {
		return &this->m_vecPlacerParameters;
	}

	/** ݒup[^
	  */
	int getPlacerParameter( int nIndex ) {
		if( (int)this->m_vecPlacerParameters.size() <= nIndex ) {
			return 0;
		}
		return this->m_vecPlacerParameters[nIndex];
	}
	void setPlacerParameter( int nIndex, int nParameter ) {
		this->m_vecPlacerParameters[nIndex] = nParameter;
	}
private:
	int m_nMapNumber;			//! [viFAN,BurnerFj
	int m_nScenarioNumber;		//! ViIID(DoorFScene)
public:
	/**
	  * @param[in] nType				//! 
	  * @param[in] nMapNumber			//! ړ}bv
	  * @param[in] nScenarioNumber		//! ViIԍ
	  */
	GNeutral( int nType, int nMapNumber, int nScenarioNumber );

	virtual ~GNeutral(){
		HPLPointerTool::HPLFree<HPLCounter>( this->m_lpAmpCounter );
		HPLPointerTool::HPLFree<HPLCounter>( this->m_lpSmokeIntervalCounter );
	}

	// Getter/Setter
public:
	int getMapNumber() {
		return this->m_nMapNumber;
	}
	int getScenarioNumber() {
		return this->m_nScenarioNumber;
	}
	HPLRect getBrustArea() {
		HPLRect rHitArea = this->m_rBrustRect;
		rHitArea.setX( rHitArea.getX() + this->getArea().getX() );
		rHitArea.setY( rHitArea.getY() + this->getArea().getY() );
		return rHitArea;
	}

	// override
private:
	
	int getSequenceID();


	// Iy[V
public:
	void setColor(int c );
	/** */
	void collision(HPLMatrix<int>* matrix,
		std::map<int, HPLBlock*>* blockMap);

	/**
		ASY
	*/
//	void algorithm();

	void draw();
	/////////////////////////////////////////////////////
	void die(HPLShootingObject* damageSource);

	void damage(float dmg, HPLShootingObject* damageSource);
	HPLSequence* getSequence();
	void changeState( int nState );
};

#endif
