#ifndef _G_NEUTRAL_MANAGER_
#define _G_NEUTRAL_MANAGER_

#include <hpllib/cycle/HPLObjectManager.h>

#include "GNeutral.h"
#include "GPlayer.h"
#include "GEnum.h"

#include "GNeutralSetting.h"

#include <list>

/** NeutralǗ
  */
class GNeutralManager: public HPLObjectManager<GNeutral> {
private:
	GNeutralSetting m_aryNeutralSettings[ GEnum::Sequence::Neutral::MAX_NUM ];

	bool m_bIsChecked;	//! L[ƂɊŶ
	std::list<GNeutral*> m_vecAdds;	//! ǉۗp
//	string m_aryNames[ GEnum::Sequence::Neutral::MAX_NUM];
public:
//	std::string getName( int nIndex );
	GNeutralManager();
	virtual ~GNeutralManager(){}
	void process(bool isMove, bool bIsAI);
	GNeutral* create(int t, HPLVector center, int nMapNumber, int nScenarioNumber);
	GNeutral* createWithoutAddList( int t, HPLVector center, int nMapNumber, int nScenarioNumber);

	void algorithm(GNeutral* effect);

	// getter/setter
public:
	void addToAdds( GNeutral* lpNeutral ) {
		this->m_vecAdds.push_back( lpNeutral );
	}

	// operations
public:
	bool checkHitToPlayer( GNeutral* lpNeutral, GPlayer* lpPlayer );
	bool checkHitToShot( GNeutral* lpNeutral );

	/** Ƀ_ɔ˂
	  */
	GNeutral* createRandomUpVelocityAngle( int nType, HPLVector vCenter );

	GNeutralSetting* getNeutralSetting( int nIndex ) {
#ifdef _DEBUG
//		HPLError::assertIt( nIndex >= 0 && nIndex < SIZEOF(this->m_aryNeutralSettings ) );
		ASSERT_IT_INDEX( nIndex, 0, SIZEOF( this->m_aryNeutralSettings ) );
#endif
		return &this->m_aryNeutralSettings[nIndex];
	}
private:
	int loadSettings( const char* lpszFilePath );
	/** 񂩂e
	  * @retval	0	I
	  */
	int parseFromLine( GNeutralSetting* lpSetting, std::string& strLine );

/*	/** MoverSpeed
	  *
	float getMoverSpeedX( int nType );
	/** cMoverSpeed
	  *
	float getMoverSpeedY( int nType );*/
};

#endif
