#include "GObjectManager.h"

#include "GStaticData.h"

#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>

using namespace std;
using namespace GEnum;

GObjectManager::GObjectManager(){
	m_vecStateLabels = HPLFile::loadStringLinesFromFile(
		"data/StateLabel.txt", true );

	ASSERT_IT_EQUAL( this->m_vecStateLabels.size(), StateType::MAX_NUM );
//	HPLError::assertIt( this->m_vecStateLabels.size() == StateType::MAX_NUM,
//		"ԃx̐Ǝۂ̏ԐvȂ(labels:%d!=statetypes:%d)",
//	this->m_vecStateLabels.size(), StateType::MAX_NUM);

/*	this->m_nPlayingIndex = 0;

	for( int i = 0; i < PLAYER_MAX_NUM; i ++ ) {
		this->m_aryPlayerList[i].m_nForceID = i;
	}
	char* PLAYER_NAME_LABELS[256] = {
		"т",
		"^[j",
		"g[}",
		"AfZ",
		"^Cc",
		"yZ",
		"K[_",
		"I",
		"^[jicj",
		"̂",
		"",
		"tH{q",
		"",
		"EƁE",
		"",
	};
	for( int i = 0; i < PlayerType::MAX_NUM; i ++ ) {
		// ݒiTODOFt@Cǂݍ݁j
		HPLPlayerSetting setting;
		setting.m_strName = string( PLAYER_NAME_LABELS[i] );
		this->m_vecPlayerSettings.push_back( setting );
	}*/

	// weapon settings
/*
	using namespace WeaponCommand;

	vector<string> vecLines = HPLFile::loadStringLinesFromFile( WEAPON_SETTING_FILE_PATH, true );

	GShotSetting shotSetting;

	// K{ڊmFp
	int NEED_BIT = 0;
	for( int i = 0; i < NeedType::MAX_NUM; i ++ ) {
		NEED_BIT |= 1 << i;
	}

	int nNeedCount = 0;
	int nNum = 0;
	int nIndex = 0;

	// loop
	for( int i = 0; i < (int)vecLines.size(); i ++ ) {

		if( vecLines[i].at(0) == '[' ) {
			// "[#]":Shot ID
			
			if( ( nNeedCount & NEED_BIT ) == NEED_BIT ) {
				// add
				this->m_mapShotSettings[nNum] = shotSetting;
				enemySetting.clear();
				nNeedCount = 0;
			}
			nNum = atoi(vecLines[i].substr(1,vecLines[i].size() - 2).c_str());
		} else {
			vector<string> vecItems = HPLString::split( vecLines[i], "=" );
			if( vecItems.size() < 2 ) {
				HPLError::msg( "Warning", MB_OK, "Error:%s", vecLines[i].c_str());
				continue;
			}

			if( 0 == vecItems[0].compare( CMD_BLOW_RATE ) ) {
				enemySetting.m_fBlowRate = (float)atof(vecItems[1].c_str() );
				nNeedCount |= 1 << NeedType::BLOW_RATE;
			} else {
				// ̑tOƔf
				for( int j = 0; j < ShotFlagType::MAX_NUM; j ++ ) {
					if( 0 == vecItems[0].compare( CMD_FLAGS[j] ) ) {
						enemySetting.m_aryFlags[j] = vecItems[1].compare( "true" ) == 0;
					}
				}
			}
		}
	}*/
	// shot ݒǂݍ
	this->m_ShotManager.loadShotSettings();

	// weapon ݒǂݍ(ItemSetting̓ǂݍ݂O(GItemManagerRXgN^œǂݍł̂OK))
	const char WEAPON_SETTING_FILE_PATH[] = "data/WeaponSettings.txt";
	int nRet = m_WeaponManager.loadWeaponSettings( WEAPON_SETTING_FILE_PATH );

	HPLError::assertIt( nRet >= 0,
		"Failed to load weapon settngs." );
}

void recolor( int nFireSoftHandle, HPLSprite* lpTargetSprite, HPLSprite* lpBaseSprite ) {

	const int MAX_PALETTE_ITEM = 256;
	int nPaletteRed[MAX_PALETTE_ITEM];
	int nPaletteGreen[MAX_PALETTE_ITEM];
	int nPaletteBlue[MAX_PALETTE_ITEM];
	int nPaletteAlpha[MAX_PALETTE_ITEM];

	// pbgǂݍ
	for( int i = 0; i < MAX_PALETTE_ITEM; i ++ ) {
		int r;
		int g;
		int b;
		int a;
		//GetPaletteSoftImage( nFireSoftHandle, i, &nPaletteRed[i], &nPaletteGreen[i], &nPaletteBlue[i] , 0);
		GetPaletteSoftImage( nFireSoftHandle, i,//MAX_PALETTE_ITEM - i - 1,
			&r, &g, &b , &a);
		nPaletteRed[i] = r;
		nPaletteGreen[i] = g;
		nPaletteBlue[i] = b;
		nPaletteAlpha[i] = a;
	}
	SetTransColor(45,0,45);
	for( int nSeq = 0; nSeq < lpTargetSprite->getSequenceNum(); nSeq ++ ) {
		HPLSequence* lpSeq = lpTargetSprite->getSequence( nSeq, FaceDirection::LEFT );
		for( int nImage = 0; nImage < lpSeq->getNumOfInformations(); nImage ++ ) {
			HPLImageInformation* lpImage = lpSeq->getImageInformation(nImage );
			int nImageIndex = lpImage->imageTag;
			int nImageHandle = getStaticData()->m_Basic.m_Graphics.m_ImageManager.get( nImageIndex );

			// SoftImageƂēǂݍ(o^p)
			string str = lpBaseSprite->getSequence(nSeq, FaceDirection::LEFT)->getImageInformation( nImage )->imageTagName;
			int nTargetSoftHandle = LoadSoftImage( str.c_str() );

			// pbgϊ
			for( int i = 0; i < MAX_PALETTE_ITEM; i ++ ) {
				SetPaletteSoftImage( nTargetSoftHandle, i, nPaletteRed[i], nPaletteGreen[i], nPaletteBlue[i] , nPaletteAlpha[i]);
			}

			// Graphɕϊ
			int nGraphHandle = CreateGraphFromSoftImage( nTargetSoftHandle );
			DeleteSoftImage( nTargetSoftHandle );

			// imageɓo^BQƐύX
			lpImage->imageTag = getStaticData()->m_Basic.m_Graphics.m_ImageManager.add(nGraphHandle );

		}
	}
}

void GObjectManager::setup() {
	// G̃J[pbgZbgAbv



//	for( int i = 0; i < PLAYER_MAX_NUM; i ++ ) {
	this->m_Player.setup();
	this->m_Player.changeType( PlayerType::EVIGEN, NULL);


	this->m_COMPlayer.setup();
	this->m_COMPlayer.changeType( PlayerType::TANYA, NULL );

	/*
	static char PALETTE_FILE_PATHS[][MAX_PATH] = {
		"data/image/Player/Evigen/Palette/Fire_Palette.bmp",
		"data/image/Player/Evigen/Palette/Water_Palette.bmp"
	};
	*/
/*	vector<string> vecPaletteFilePaths;
	vector<string> vecLines = HPLFile::loadStringLinesFromFile( "data/image/Player/Evigen/Palette/PaletteList.txt",
		true);

	string strBaseDirectoryPath("data/image/Player/Evigen/Palette/");
	for( int i = 0; i < static_cast<int>( vecLines.size() ); i ++ ) {
		vecPaletteFilePaths.push_back( strBaseDirectoryPath + vecLines[i] );
	}

	for( vector<string>::const_iterator cit = vecPaletteFilePaths.begin();
		cit != vecPaletteFilePaths.end();
		cit ++ )
	{

		// pbgύXXvCg쐬
		HPLSprite* lpFireSprite = getStaticData()->getSprite( SpriteType::EVIGEN )->clone();
		HPLSprite* lpBaseSprite = getStaticData()->getSprite( SpriteType::EVIGEN );	// }X^[f[^(t@CpXp)

		// pbgp
		int nFireSoftHandle = LoadSoftImage( cit->c_str() );
		recolor( nFireSoftHandle, lpFireSprite, lpBaseSprite );

		// vC[ɓo^
		this->m_Player.addPaletteSprite( lpFireSprite );
		this->m_COMPlayer.addPaletteSprite( lpFireSprite->clone() );
	}
*/
}

GObjectManager::~GObjectManager(){

}

/**
	remove all objects except player
*/
void GObjectManager::clear(){
	this->m_EnemyManager.clear();
	this->m_EffectManager.clear();
	this->m_ShotManager.clear();
	this->m_NeutralManager.clear();
	this->m_AchievementManager.clear();
	this->m_ItemManager.clear();
}

void GObjectManager::getEffectInfo( HPLShootingObject* lpObj, 
	int& nEffectType, HPLCounter* lpCounter ) 
{
	switch( lpObj->getObjectType() ) {
	case ObjectType::ENEMY:
		{
			GEnemy* lpEnemy = (GEnemy*)lpObj;
			nEffectType = lpEnemy->m_nFireEffectType;
			lpCounter = &lpEnemy->m_FireCounter;
		}
		break;
	case ObjectType::NEUTRAL:
		{
			GNeutral* lpNeutral = (GNeutral*)lpObj;
			nEffectType = lpNeutral->m_nFireEffectType;
			lpCounter = &lpNeutral->m_FireCounter;
		}
		break;
	default:
		ASSERT_IT_TYPE( lpObj->getObjectType(), "object type");
//		HPLError::assertIt(false);
	}
}
void GObjectManager::startFireEffect( int nEffectType, HPLShootingObject* lpObj )
{
	switch( lpObj->getObjectType() ) {
	case ObjectType::ENEMY:
		{
			GEnemy* lpEnemy = (GEnemy*)lpObj;
			lpEnemy->m_nFireEffectType = nEffectType;
			lpEnemy->m_FireCounter.reset();
		}
		break;
	case ObjectType::NEUTRAL:
		{
			GNeutral* lpNeutral = (GNeutral*)lpObj;
			lpNeutral->m_nFireEffectType = nEffectType;
			lpNeutral->m_FireCounter.reset();
		}
		break;
	default:
		ASSERT_IT_TYPE( lpObj->getObjectType(), "object type");
//		HPLError::assertIt(false);
	}
}
void GObjectManager::createFireEffect( HPLShootingObject* lpObj )
{
	HPLCounter* lpCounter = NULL;
	int nEffectType = -1;
	this->getEffectInfo( lpObj, nEffectType, lpCounter );

	switch( lpObj->getObjectType() ) {
	case ObjectType::ENEMY:
		lpCounter = &((GEnemy*)lpObj)->m_FireCounter;
		break;
	case ObjectType::NEUTRAL:
		lpCounter = &((GNeutral*)lpObj)->m_FireCounter;
		break;
	}
	ASSERT_IT_NULL( lpCounter );
//	HPLError::assertIt( NULL != lpCounter );
	if( nEffectType >= 0 && lpCounter->isAlive() && 
		lpCounter != NULL && lpCounter->step().isEndLoop )
	{
		// ܂ƂGtFNg
		HPLVector vCenter;
		HPLRect rHitArea = lpObj->getHitArea();
		vCenter.add(
			rHitArea.getX() + HPLMath::nextInt( 0, (int)rHitArea.getWidth() ),
			rHitArea.getY() + HPLMath::nextInt( 0, (int)rHitArea.getHeight() ) );

		GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
			Sequence::Effect::FIRE, vCenter, true );
	}
}

void GObjectManager::resetFireEffect( HPLShootingObject* lpObj ) {
	switch( lpObj->getObjectType() ) {
	case ObjectType::ENEMY:
		{
			GEnemy* lpEnemy = (GEnemy*)lpObj;
			lpEnemy->m_FireCounter.setLoopNumMax( FIRE_EFFECT_CREATE_NUM );
			lpEnemy->m_FireCounter.setWaitFrameNum( FIRE_EFFECT_CREATE_INTERVAL );
			lpEnemy->m_FireCounter.end();
		}
		break;
	case ObjectType::NEUTRAL:
		{
			GNeutral* lpNeutral = (GNeutral*)lpObj;
			lpNeutral->m_FireCounter.setLoopNumMax( FIRE_EFFECT_CREATE_NUM );
			lpNeutral->m_FireCounter.setWaitFrameNum( FIRE_EFFECT_CREATE_INTERVAL );
			lpNeutral->m_FireCounter.end();
		}
		break;
	default:
		ASSERT_IT_TYPE( lpObj->getObjectType(), "ObjectType");
//		HPLError::assertIt(false);
	}
}


/** _[W_ϐf
  * @retval	WeakImmuneType::
  */
int GObjectManager::getWeakImmuneType( HPLShootingObject* lpDamageSource, HPLShootingObject* lpTarget ) {
	//int nDamageSourceWeaknessFull = this->getWeaknessFull( lpDamageSource );
	//int nDamageSourceImmunitiesFull = this->getImmunitiesFull( lpDamageSource );

	int nDamageTypeFull = this->getDamageTypeFull( lpDamageSource );

	int nTargetWeaknessFull = this->getWeaknesses( lpTarget );
	int nTargetImmunitiesFull = this->getImmunities( lpTarget );

	if( (nDamageTypeFull & nTargetWeaknessFull ) != 0 ) {
		// _v
		// Ⴆ̑ϐłĂA_łΎ_ɂ
		return WeakImmuneType::WEAKNESS;
	}
	if( (nDamageTypeFull & nTargetImmunitiesFull ) != 0 ) {
		return WeakImmuneType::IMMUNITIES;
	}

	if( nDamageTypeFull == 0 && nTargetImmunitiesFull != 0 ) {
		// ʏełAϐ
		return WeakImmuneType::IMMUNITIES;
	}
	return WeakImmuneType::NONE;
}

int GObjectManager::getDamageTypeFull( HPLShootingObject* lpObj ) {
	HPLError::assertIt( lpObj != NULL && lpObj->getObjectType() == ObjectType::SHOT,
		"%s:%d:%s:lpObj is null or object type is not shot", __FILE__,__LINE__,__FUNCTION__ );

	return ((GShot*)lpObj)->getDamageTypeFull();
}

int GObjectManager::getWeaknesses( HPLShootingObject* lpObj ) {
	switch( lpObj->getObjectType() ) {
	case ObjectType::NEUTRAL:
		return ((GNeutral*)lpObj)->getWeaknesses();
	case ObjectType::ENEMY:
		return ((GEnemy*)lpObj)->getWeaknesses();
	default:
		ASSERT_IT_TYPE( lpObj->getObjectType(), "object type");
//		HPLError::assertIt(false );
	}
	return 0;
}
int GObjectManager::getImmunities( HPLShootingObject* lpObj ) {
	switch( lpObj->getObjectType() ) {
	case ObjectType::NEUTRAL:
		return ((GNeutral*)lpObj)->getImmunities();
	case ObjectType::ENEMY:
		return ((GEnemy*)lpObj)->getImmunities();
	default:
		ASSERT_IT_TYPE( lpObj->getObjectType(), "object type");
//		HPLError::assertIt(false );
	}
	return 0;
}

/** ftHg̉]ݒs
  */
void GObjectManager::setupRandomRotate( HPLShootingObject* lpObj ) {
	lpObj->setRotateDegree( HPLMath::nextFloat(0,HPLMathConsts::DEGREE_FULL_ROUND ) );
	lpObj->setFaceDirection( HPLMath::nextInt(0,2) == 0 ? FaceDirection::LEFT : FaceDirection::RIGHT );
	float fRotateDegreeSpeed = (HPLMath::nextInt(0,2) * 2 - 1 ) * 
		HPLMath::nextFloat( ROCK_ROTATE_DEGREE_SPEED_MIN, ROCK_ROTATE_DEGREE_SPEED_MAX ) ;
	lpObj->setRotateDegreeSpeed( fRotateDegreeSpeed );
	lpObj->setDefaultRotateDegreeSpeed( fRotateDegreeSpeed );
}
/** ԂŗnH
  * @param[in]	nSolidType
  * @param[in]	lpObj
  */ 
bool GObjectManager::isCancellableSolid( int nSolidType, HPLShootingObject* lpObj ) {
	switch( nSolidType ) {
	case SolidType::CRYO:
		// Ⓚ
		switch( lpObj->getObjectType() ) {
		case ObjectType::PLAYER:
		case ObjectType::ENEMY:
			return true;
//		case ObjectType::NEUTRAL:
//			// ł
//			return false;
		default:
#ifdef _DEBUG
			ASSERT_IT_TYPE( nSolidType, "solid type");
	//		HPLError::assertIt(false);
#endif
			break;
		}
		break;
	}
	return true;
}

void GObjectManager::drawSolid( int nSolidType, float fCenterX, float fCenterY, float fSpriteWidth ) {
	switch( nSolidType ) {
	case SolidType::CRYO:
		{
			HPLSequence* lpCryoSeq = getStaticData()->getSequence(
				SpriteType::COMMON, Sequence::Common::CRYO );
			float fWidth = lpCryoSeq->getImageInformation(0)->srcRect.getWidth();
			//float fSpriteWidth = seq->getImageInformation(0)->srcRect.getWidth();
			float fCryoZoom = fSpriteWidth / fWidth * 1.2f;
			const int CRYO_ALPHA = 150;
			getStaticData()->m_Basic.m_Graphics.draw(
				fCenterX, fCenterY, lpCryoSeq, FaceDirection::LEFT,
				0, fCryoZoom, CRYO_ALPHA, DX_BLENDMODE_ALPHA );
		}
		break;
	}
}


int GObjectManager::isEmpty( int nID ) {
	if( nID < 0 ) {
		return BlockType::BLOCK;
	} else if( nID > HPL::Collision::BLOCK_TYPE_MAX ) {
		return BlockType::EMPTY;
	}
	map<int,HPLBlock*>::iterator bit = getStaticData()->getBlockManager()->getBlockMap()->find(nID);
	HPLError::assertIt( bit != getStaticData()->getBlockManager()->getBlockMap()->end(),
		"%s:%s(%d):ID[%d] is not found", __FILE__,__FUNCTION__,__LINE__, nID);
	int nBlockType = bit->second->getBlockType();
	return BlockType::EMPTY == nBlockType ||
		BlockType::EMPTY_DRAW_FRONT == nBlockType;
}
int GObjectManager::getWaterDamage( int nID ) {

	switch( this->getGameTileType( nID ) ) {
	case GameTileType::WATER:
		return 0;
	case GameTileType::LAVA:
		const int YOUGAN_DAMAGE = 30;
		return YOUGAN_DAMAGE;
	}
	return 0;
}
int GObjectManager::getGameTileType( int nID ) {
	switch( nID ) {
	case SpecialBlockID::LAVA:
	case SpecialBlockID::LAVA_SURFACE:
		return GameTileType::LAVA;
	case SpecialBlockID::WATER:
	case SpecialBlockID::WATER_SURFACE:
		return GameTileType::WATER;
	}
	return -1;
}
bool GObjectManager::isSwimTile( int nID ) {
	int nGameTileType = this->getGameTileType(nID);
	// 
	return nGameTileType == GameTileType::WATER ||
		nGameTileType == GameTileType::LAVA;
}

int GObjectManager::getTileType( float fCenterX, float fCenterY, int& nTileType, int& nHeadTileID, int& nFootTileID) {

	HPLVector vHead(fCenterX,fCenterY);
	const int HEAD_Y = -24;
	vHead.add(0, - HEAD_Y );

	nHeadTileID = getStaticData()->getBlockID( vHead );

	const int FOOT_Y = 30;
	HPLVector vFoot(fCenterX,fCenterY);
	vFoot.add(0,static_cast<float>( FOOT_Y) );

	nFootTileID = getStaticData()->getBlockID( vFoot );

	// change to no special(default)
	nTileType = TileType::NOSPECIAL;

	if( nHeadTileID < 0 ) {
		if( nFootTileID  < 0 ) {
			// do nothing
		} else if( this->isSwimTile( nFootTileID ) ) {
			// (V܂Ő)
			// j
			nTileType = TileType::SWIM;
		} else if( isEmpty( nFootTileID ) ) {
			// do nothing
		} else {
			// ubNƂ
			// do nothing
		}
	} else if( this->isSwimTile( nHeadTileID ) ) {
		// ^Cł

		if( nFootTileID  < 0 ) {
			// do nothing
		} else if( isSwimTile( nFootTileID ) ) {
			// ^C
			// 
			nTileType = TileType::SWIM;
		} else if( isEmpty( nFootTileID ) ) {
			// r
			nTileType = TileType::SWIM;
		} 
	} else if( isEmpty( nHeadTileID ) ) {
		// ͋
		if( nFootTileID  < 0 ) {
			// do nothing
		} else if( isSwimTile( nFootTileID ) ) {
			// 𐅂ɂ
			nTileType = TileType::ON_THE_WATER;
		} else if( isEmpty( nFootTileID ) ) {
			// 
			// do nothing
		} 
	}

/*	if( nTileType < 0 ) {
		nTileType = TileType::NOSPECIAL ;
	}*/
	return 0;
}


/** ݂̏Ԃ\(debugpBdebug͓ōs)
  */
void GObjectManager::drawState( int nLeft, int nTop, int nState ) {
#ifndef _DEBUG
	return;
#endif
	const int COLS[] = {255,255,255};

	HPLError::assertIt( nState >= 0 && nState < (int)m_vecStateLabels.size(),
		"out of bounds(index:%d range:[0,%d])", nState, m_vecStateLabels.size());
	string str = HPLString::chrToStr( "%d:%s", nState, m_vecStateLabels[nState].c_str() );

	DrawString( nLeft, nTop, str.c_str(), GetColor(COLS[0],COLS[1],COLS[2]));
		
}
/** }EX̃NbNɉăIuWFNgړ
  * @param[in]	nMouseButtonFilter	{^tB^
  * @param[in]	lpTarget			ړΏ
  * @param[in]	lpScroller			XN[BNULL̎̓XN[sȂ
  * @retval	0	I
  */
int GObjectManager::checkAndMoveByMouse( int nCurrentMouseInput, int nMouseButtonFilter,
										int nMouseX, int nMouseY,
										HPLShootingObject* lpTarget, HPLScroller* lpScroller )
{
	// }EXňړł悤ɂ
	if(( nCurrentMouseInput & nMouseButtonFilter )!= 0  ) {
		// NbN

		int nScrollerX = 0;
		int nScrollerY = 0;
		if( lpScroller != NULL ) {
			nScrollerX = lpScroller->getVirtualRect().getX();
			nScrollerY = lpScroller->getVirtualRect().getY();
		}
		// ړ
		lpTarget->setCenter(
			nMouseX - nScrollerX,
			nMouseY - nScrollerY );
	}
	return 0;
}


/** UvC[VbgH
  */
bool GObjectManager::isPlayerShot( HPLShootingObject* lpObject) {
	return lpObject != NULL && 
		lpObject->getObjectType() == ObjectType::SHOT &&
		((GShot*)lpObject)->getParentID() == this->m_Player.getID();
}


/** IuWFNgړ
  * ǂŔf
  * @retval	
  */
void GObjectManager::moveObjectForce( HPLShootingObject* lpObject ) {
	// map index
	int nMapIndex = getStaticData()->getMapIndex();

	bool bIsWind = false;
	HPLVector vWindAccel;
	const float NEUTRAL_WIND_ACCEL = 0.05f;
	float WIND_ACCEL = NEUTRAL_WIND_ACCEL;
	float RESIST = getStaticData()->m_Setting.resist;

	switch( lpObject->getObjectType() ) {
	case ObjectType::PLAYER:	// player
		{
			GPlayer* lpPlayer = dynamic_cast<GPlayer*>(lpObject);
			// ȗvɂ蓮ς
			switch( nMapIndex ) {
			case SpecialMapIndex::WIND_BOSS_2:	// wind boss(chaser2)
				{
					// ʍɌĕĂ

					// ɂ
					if( lpPlayer->getPlayerClassType() == PlayerClassType::HUMAN ) {	// human
						// lԂ̏ꍇ͉x𑝂₷
						WIND_ACCEL *= 2;
					}
					WIND_ACCEL+= RESIST;
					vWindAccel.set(-WIND_ACCEL,0);
					bIsWind = true;
				}
				break;
			}
		}
		break;
	case ObjectType::NEUTRAL:
		{
			switch( lpObject->getType() ) {
			case Sequence::Neutral::CAR:
				switch( nMapIndex ) {
				case SpecialMapIndex::WIND_BOSS_2:	// wind boss(chaser2)
					{
						vWindAccel.set(-NEUTRAL_WIND_ACCEL,0);
						bIsWind = true;
					}
					break;
				}
			}
		}
		break;
	default:
		HPLError::assertIt( false, "Invalid ");
	}
	if( bIsWind ) {
		if( lpObject->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) {
			float fABS = fabs(vWindAccel.getX());
			vWindAccel.multiple(
				(fABS + RESIST ) / fABS );
		}
		//
		HPLVector vVel = lpObject->getVelocityAngle();
		vVel.add( vWindAccel);
		lpObject->setVelocityAngle( vVel );
		HPLVector vCenter = lpObject->getCenter();
		vCenter.add( vVel );
		lpObject->setCenter( vCenter );
	}
}

void GObjectManager::drawHoldBar( HPLCounter* lpCounter,
								 float fCenterX, float fCenterY
								 )
{
	// ܂Ă
	// ->SQ[W\
	const int HOLD_BAR_DELTA_Y = 80;
	const int BAR_DELTA_X = 1;
	const int BAR_DELTA_Y = 13;

	HPLSequence* lpHoldFrameSeq = getStaticData()->getSequence(
		SpriteType::COMMON, Sequence::Common::HOLD_METER );
	HPLRect rHoldFrameRect = lpHoldFrameSeq->getImageInformation(0)->srcRect;
	int nLeft = fCenterX - rHoldFrameRect.getWidth() / 2;
	int nTop = fCenterY - rHoldFrameRect.getHeight() - HOLD_BAR_DELTA_Y;

	getStaticData()->m_Basic.m_Graphics.draw(
		nLeft,
		nTop,
		lpHoldFrameSeq );

	// bar
	float fRate = lpCounter->getStepCounter() / (float)lpCounter->getWaitFrameNum();
	int nBarImageHandle = getStaticData()->getImageHandle(
		SpriteType::COMMON, Sequence::Common::HOLD_METER_BAR );
	int nSrcWidth = 0;
	int nSrcHeight = 0;
	GetGraphSize( nBarImageHandle, &nSrcWidth, &nSrcHeight );
	DrawRectGraph( nLeft + BAR_DELTA_X, nTop + BAR_DELTA_Y,
		0,0,nSrcWidth * fRate,nSrcHeight,
		nBarImageHandle, TRUE, FALSE );
}

/** IuWFNĝ̖w肵ʒuɏo
  */
void GObjectManager::drawObjectName(int nLayoutType, bool bIsStepAnimation, int nObjectType, int nType) {
	HPLSequence* lpSeq = getStaticData()->m_ShowEnemyName.getSequence();
	switch( nObjectType ) {
	case ObjectType::ITEM:
		lpSeq = getStaticData()->m_ShowItemName.getSequence();
		break;
	}
	HPLRect rSrcRect = lpSeq->getImageInformation( 0 )->srcRect;
	int nLeft = 0;
	int nTop = 0;

	int nRightLeft = getStaticData()->m_Setting.windowWidth - rSrcRect.getWidth();
	int nBottomTop = getStaticData()->m_Setting.windowHeight - rSrcRect.getHeight();

	switch( nLayoutType ) {
	case LayoutType::BOTTOM_RIGHT:	// E
		nLeft = nRightLeft;
		nTop = nBottomTop;
		break;
	case LayoutType::TOP_RIGHT:	// E
		nLeft = nRightLeft;
		break;
	case LayoutType::BOTTOM_LEFT:	// 
		nTop = nBottomTop;
		break;
	}
	// draw frame
	getStaticData()->m_Basic.m_Graphics.draw(
		nLeft, nTop, lpSeq );
	// draw name
	string str;
	switch( nObjectType ) {
	case ObjectType::ENEMY:
		str = getStaticData()->m_ObjectManager.m_EnemyManager.getEnemyName( nType );
		break;
	case ObjectType::ITEM:
		str = getStaticData()->m_ObjectManager.m_ItemManager.getName( nType );
		break;
	case ObjectType::NEUTRAL:
		break;
	}
	const int DELTA_X = 5;
	const int DELTA_Y = 5;
	DrawString( nLeft + DELTA_X, nTop + DELTA_Y, str.c_str(), GetColor(255,255,255) );

	if( bIsStepAnimation ) {
		switch( nObjectType ) {
		case ObjectType::ENEMY:
			getStaticData()->m_ShowEnemyName.step();
			break;
		case ObjectType::ITEM:
			getStaticData()->m_ShowItemName.step();
		}
	}
}

