#ifndef _G_OBJECT_MANAGER_
#define _G_OBJECT_MANAGER_

#include "GEnum.h"

#include "GPlayer.h"
#include "GShotManager.h"
#include "GEffectManager.h"
#include "GEnemyManager.h"
#include "GNeutralManager.h"
#include "GItemManager.h"
#include "GAchievementManager.h"
#include "GWeaponManager.h"

#include "GWeapon.h"

#include <string>
#include <vector>

#include <hpllib/action/HPLScroller.h>

class GObjectManager {
public:

	// \͉Li끄Oj
	// `bv()Effect()NeutralPlayerEnemy`bv(O)ShotEffect
	GPlayer			m_Player;
	GPlayer			m_COMPlayer;
	GShotManager	m_ShotManager;
	GEffectManager	m_BackEffectManager;	//! vC[
	GEffectManager	m_EffectManager;
	GEnemyManager	m_EnemyManager;
	GNeutralManager	m_NeutralManager;
	GItemManager	m_ItemManager;
	GAchievementManager	m_AchievementManager;
	GWeaponManager	m_WeaponManager;
private:
//	std::map<int,GWeaponSetting>	m_mapWeaponSettings;	//! ݒBgĂȂi肩Hj
	std::vector<std::string> m_vecStateLabels;		//! Xe[gɑΉ

public:
	GObjectManager();

	~GObjectManager();

public:
/*	GWeaponSetting* getWeaponSetting( int nIndex ) {
		return &this->m_mapWeaponSettings[nIndex];
	}*/
	/**
	  * setup
	  *  - players
	  */
	void setup();
	/**
		remove all objects except player
	*/
	void clear();

	void startFireEffect( int nEffectType, HPLShootingObject* lpObj );
	void createFireEffect( HPLShootingObject* lpObj );
	void resetFireEffect( HPLShootingObject* lpObj );

	/** _[W_ϐf
	  * @retval	WeakImmuneType::
	  */
	int getWeakImmuneType( HPLShootingObject* lpDamageSource, HPLShootingObject* lpTarget );

	/** ftHg̉]ݒs
	  */
	void setupRandomRotate( HPLShootingObject* lpObj );

	/** XtȂǂ̌ł߃GtFNg\
	  */
	void drawSolid( int nSolidType, float fCenterX, float fCenterY, float fSpriteWidth );

	/** 
	  * IuWFNgGĂ^C̏Ԃ擾
	  * @param[in]	fX,fY	ʒuiXN[΍Wj
	  * @param[out]	nTileType
	  * @param[out]	nHeadTileID
	  * @param[out]	nFootTileID
	  * @retval	0	I
	  */
	int getTileType( float fCenterX, float fCenterY, int& nTileType, int& nHeadTileID, int& nFootTileID);

	/** t̃_[WiGɂ͒ʂȂƂj
	  */
	int getWaterDamage( int nID );

	/** ݂̏Ԃ\(debugpBdebug͓ōs)
	  */
	void drawState( int nLeft, int nTop, int nState );

	/** }EX̃NbNɉăIuWFNgړ
	  * @param[in]	nMouseButtonFilter	{^tB^
	  * @param[in]	lpTarget			ړΏ
	  * @param[in]	lpScroller			XN[BNULL̎̓XN[sȂ
	  * @retval	0	I
	  */
	int checkAndMoveByMouse( int nCurrentMouseInput, int nMouseButtonFilter,
		int nMouseX, int nMouseY,
		HPLShootingObject* lpTarget, HPLScroller* lpScroller );

	/** UvC[VbgH
	  */
	bool isPlayerShot( HPLShootingObject* lpObject);

private:
	/** _[W^Cv擾(œGEShot)
	  */
	int getDamageTypeFull( HPLShootingObject* lpObj );
	/** _ݒ擾iœGENeutralj
	  */
	int getWeaknesses( HPLShootingObject* lpObj );
	int getImmunities( HPLShootingObject* lpObj );

	/** GtFNg̏擾
	  */
	void getEffectInfo( HPLShootingObject* lpObj, 
		int& nEffectType, HPLCounter* lpCounter );

	/** ԂŗnH
	  * @param[in]	nSolidType	ł߃^Cv
	  * @param[in]	lpObj		Ώۂ̃IuWFNg
	  * @param[in]	true		Ԍo߂ŗn
	  */ 
	bool isCancellableSolid( int nSolidType, HPLShootingObject* lpObj);

	/** ^CH
	  */
	int isEmpty( int nID );
	/** j^CH
	  */
	bool isSwimTile( int nID );

public:
	/** Q[Ӗ̂^Cǂ
	  */
	int getGameTileType( int nID );
	/** IuWFNgړ
	  * ǂŔf
	  */
	void moveObjectForce( HPLShootingObject* lpObject );

	/** Holdo[\
	  */
	void drawHoldBar( HPLCounter* lpCounter,
			 float fScrolledCenterX, float fScrolledCenterY);

	/** IuWFNĝ̖w肵ʒuɏo
	  */
	void drawObjectName(int nLayoutType, bool bIsStepAnimation, int nObjectType, int nType);
};

#endif
