#include "GObjectPlacer.h"

#include "GStaticData.h"

//#include "GEnemy.h"
#include "GPlayer.h"

#include <hpllib/math/HPLMath.h>

using namespace std;
using namespace GEnum;
using namespace HPL::MapData::Item;

GObjectPlacer::GObjectPlacer(){
}
GObjectPlacer::~GObjectPlacer(){
}

void GObjectPlacer::placePlayer(){

	// ݒuʒu
	int nCenterIndex = -1;

	int nNum = (int)playerPointList.size();
	nCenterIndex = (getStaticData()->m_nPlayerPlaceIndex >= 0 && getStaticData()->m_nPlayerPlaceIndex < nNum )?
		getStaticData()->m_nPlayerPlaceIndex :
		HPLMath::nextInt(0, nNum);

	HPLVector center = this->playerPointList[ nCenterIndex ];

	center.add( getStaticData()->m_Setting.tileSize / 2.f, getStaticData()->m_Setting.tileSize - 15.f );
	// o^
	//mapDoneCenter[ nCenterIndex] = i;

	GPlayer* player = &getStaticData()->m_ObjectManager.m_Player;

	player->getTrigger()->setTrigger(TriggerType::ON_THE_GROUND, false);

	player->setCenter(center);


	player->setVelocityAngle(0,-1);

	GPlayer* lpCOMPlayer = &getStaticData()->m_ObjectManager.m_COMPlayer;
	lpCOMPlayer->getTrigger()->setTrigger( TriggerType::ON_THE_GROUND, false );
	lpCOMPlayer->setVelocityAngle(0,-1);


	
	int faceDirection = 
		center.getX() > 
		getStaticData()->getBlockManager()->getBlockMatrix()->getColumnSize() * 
		getStaticData()->m_Setting.tileSize / 2 ? FaceDirection::LEFT : FaceDirection::RIGHT;

	////
	// ݒ
	player->setFaceDirection(faceDirection);
	lpCOMPlayer->setFaceDirection( faceDirection );

	const int COM_PLAYER_PLACE_DISTANCE = 100;
	HPLVector vComCenter = center;
	vComCenter.add( (float)(- faceDirection * COM_PLAYER_PLACE_DISTANCE), 0 );
	lpCOMPlayer->setCenter( vComCenter );


}

void GObjectPlacer::placeEnemy(HPLShootingObject* obj, HPLVector center,
							   int nGenerateType)
{
	if( getStaticData()->getMapIndex() == SpecialMapIndex::EVIL_HOUSE_LOBBY ) {	// كr[
		if( getStaticData()->m_Save.getFlag( FlagType::START ) >= StartType::UNTIL_BAVEL ) {
			if( obj->getType() == EnemyType::EVI_HIME ||
				obj->getType() == EnemyType::MUNIERU )	//
			{
				// قoƂȂ̂ɂ܂̂͂
				// skip
				return;
			}
		}
	}
	if( getStaticData()->m_OptionData.getOptionFlag( OptionFlagType::GURO ) == 0 ) {
		// O\OFF

		switch( obj->getType() ) {
		case EnemyType::GOKI:
			// oȂ
			return;
		}
	}

	center.add(
		getStaticData()->m_Setting.tileSize / 2.f,
		getStaticData()->m_Setting.tileSize / 2.f
		);
	GEnemy* enemy = getStaticData()->m_ObjectManager.m_EnemyManager.create(obj->getType(),
		center, nGenerateType);
	enemy->setTarget(&getStaticData()->m_ObjectManager.m_Player);
	enemy->m_vCenterPosition = center;	// center position
	enemy->m_vAmplitudeCenter = center;	// amplitude center
}

void GObjectPlacer::placeNeutral(HPLShootingObject* obj, HPLVector center,
		int scene, int mapIndex,
		vector<int>& vecParameters)
{
	int nStar = getStaticData()->m_nSelectedStar;
	int nPlace = getStaticData()->m_nSelectedPlace;


	// փ^CAɃ^C1ړ
	int nTileSize = getStaticData()->m_Setting.tileSize;
	int nLeft = 0;
	int nTop = nTileSize;
	switch( obj->getType() ) {
	case Sequence::Neutral::MOVER:		// mover
	case Sequence::Neutral::RIDE_CLOUD:	// ride cloud
	case Sequence::Neutral::ROUND_TRUNK:	// round trunk
		nLeft = (int)(getStaticData()->m_Setting.tileSize / 2.f);
		if( Sequence::Neutral::ROUND_TRUNK == obj->getType() ) {
			nTop += nTileSize;
		}
		break;
	}
	center.add(
		nLeft,
		nTop
		);

	GNeutral* neutral = getStaticData()->m_ObjectManager.m_NeutralManager.create(
		obj->getType(), center, mapIndex, scene);
	neutral->setTarget(&getStaticData()->m_ObjectManager.m_Player);

	
	// copy parameters
	for( int i = 0; i < (int)vecParameters.size(); i ++ ) {
		neutral->getPlacerParameters()->push_back( vecParameters[i] );
	}

	switch( neutral->getType() ) {
	case Sequence::Neutral::SWITCH_OFF:
	case Sequence::Neutral::LOCK_BLOCK:
		{
			int c = vecParameters[2];
			neutral->setColor( c );
			const int NUM = 255;
			const int OTHER = 50;
			int cols[][3] = {
				{NUM,OTHER,OTHER},
				{OTHER,OTHER,NUM},
				{OTHER,NUM,OTHER},
				{NUM,NUM,0},
			};

			neutral->m_vecColors.push_back( HPLColor(cols[c][0], cols[c][1], cols[c][2] ) );
		}

		break;
	case Sequence::Neutral::BARRIER:
		{
			//map<int,int> BARRIER_MAP;
			//BARRIER_MAP[SpecialMapIndex::FOREST_POWER] = StageType::FOREST;
			if( HPLMath::getFlagByIndexInt(
				getStaticData()->m_Save.getFlag( FlagType::DESTROY_BARRIER ), 
				getStaticData()->m_nSelectedStar ) )
			{
				// łɔj󂳂Ă
				neutral->getState()->setState( StateType::DEAD );
				// ͂Ȃ
				neutral->m_WaitCounter.end();
				//neutral->changeState( StateType::DEAD );
			}
		}
		break;
	case Sequence::Neutral::JAMMING:
		{
			if( getStaticData()->m_Save.getFlag( FlagType::VTOL_JAMMING ) >= FlagType::JammingFlagType::DESTROYED ) {
				// after destroyed
				neutral->getState()->setState( StateType::STAND );
				neutral->m_WaitCounter.end();
			}
		}
		break;
	case Sequence::Neutral::GENERATOR:
		// set generator interval
		neutral->m_IntervalCounter.setWaitFrameNum( vecParameters[ParameterType::Neutral::GENERATOR_INTERVAL  ]);
		break;
	case Sequence::Neutral::TAKARA_BAKO:
		{
			if( neutral->getPlacerParameter( ParameterType::Neutral::OBJECT_TYPE ) == ObjectType::ITEM ) {

				bool bIsOpen = false;	// ŏJĂǂiftHg͕߂Ăj
				int nItemType = neutral->getPlacerParameter( ParameterType::Neutral::TYPE);
				int nWeaponType = getStaticData()->m_ObjectManager.m_WeaponManager.getWeaponTypeFromItemType( nItemType );

				int nMapIndex = getStaticData()->getMapIndex();

				if( nMapIndex == SpecialMapIndex::TEST_CHEST ) {
				} else {
					if( nWeaponType >= 0 ) {
						// ł
						//vC[Ă邩mF
						GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
						if( getStaticData()->m_Save.m_aryWeaponState[nWeaponType] > 0 ) {
							// Ă
							// 
							bIsOpen = true;
						}
					} else {// items except weapons
						int nObjectType = neutral->getPlacerParameter( ParameterType::Neutral::OBJECT_TYPE );
						int nNeutralOpenParam = neutral->getPlacerParameter( ParameterType::Neutral::FLAG_INDEX);
						
						if( getStaticData()->m_Save.getBoxFlag(neutral->getType())->isFlag(nObjectType, nItemType, nNeutralOpenParam ) )// Y󔠂͊Openς
						{
						//	if( HPLMath::getFlagByIndexInt(
						//		getStaticData()->m_Save.getFlag( FlagType::MISSILE_PICKED ), nStar ) )
							// 󂯂Ă
							bIsOpen = true;
						}
					}
				}

				if( bIsOpen ) {
					neutral->changeState( StateType::ATTACK );
				}
			}
		}
		break;
	}
}	

void GObjectPlacer::placeEffect(HPLShootingObject* obj, HPLVector center){
	HPLError::assertIt( false, "");
}

void GObjectPlacer::placeItem(HPLShootingObject* obj, HPLVector center){
	//HPLError::assertIt( false, "");
	GItem* item = getStaticData()->m_ObjectManager.m_ItemManager.create(
		obj->getType(),
		center);
	//item->setTarget(getSetting()->getObjectManager()->getPlayer());

}
