#include "GPlaceInfo.h"

static const char* const PLACE_INFO_FILE_PATH = "data/maps/PlaceInfo.dat";
static const char* const CMD_PLACE_POSITION = "POSITION";
static const char* const CMD_PLACE_DESCRIPTION = "DESCRIPTION";

#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>
#include <hpllib/math/HPLVectorInt.h>

//#include 
using namespace std;
//using namespace GEnum;

void GPlaceInfo::load() {
	// position
	vector<string> vecList = HPLFile::loadStringLinesFromFile( PLACE_INFO_FILE_PATH, true );
	for( int i = 0; i < (int) vecList.size(); i ++ ) {
		vector<string> vecCmd = HPLString::split( vecList[i], "=");
		ASSERT_IT_EQUAL( vecCmd.size(), 2 );
//		HPLError::assertIt( (int)vecCmd.size() == 2 );
		vector<string> vecItems = HPLString::split( vecCmd[1], "," );
		if( vecCmd[0].substr( 0, strlen( CMD_PLACE_POSITION ) ).compare( CMD_PLACE_POSITION ) == 0 ) {
			// POSITION
			//int nStar = atoi( vecCmd[0].substring( strlen(CMD_PLACE_POSITION ) ).c_str() );
			// add list

			vector<HPLVectorInt> vecInts;

			for( int j = 0; j < (int)vecItems.size() / 2; j ++ ) {
				int nXIndex = j * 2;
				int nYIndex = nXIndex + 1;
				HPLVectorInt v(atoi(vecItems[nXIndex].c_str()), atoi(vecItems[nYIndex].c_str()) );
				vecInts.push_back( v);
			}
			this->m_vecPositions.push_back( vecInts );
		} else if( vecCmd[0].substr( 0, strlen( CMD_PLACE_DESCRIPTION ) ).compare( CMD_PLACE_DESCRIPTION ) == 0 ) {
			// MSG
			vector<string> vecItems = HPLString::split( vecCmd[1], "," );
			this->m_vecDescriptions.push_back(vecItems);
		}
	}

}

