#include "GPlayer.h"

#include "GStaticData.h"

#include <hpllib/math/HPLMath.h>
#include <hpllib/action/HPLActionMoveTool.h>
#include "GSpecialDeadScene.h"
//#include <hpllib/object/HPLDrawInfo.h>	// fCenterXArŒlςĂA܂G肽Ȃ
#include <hpllib/general/HPLString.h>

#include <map>

using namespace std;
using namespace GEnum;

static const float NORMAL_Y = 31;
static const float NORMAL_HEIGHT = 60;	//28+63=91
static const float PESERU_HEIGHT = 51;
static const float SMALL_Y = 71;
static const float SMALL_HEIGHT = 20;	
static const float DEAD_Y = 71;
static const float DEAD_HEIGHT = 20;	

GPlayer::GPlayer(): DXPlayer ( PlayerType::EVIGEN, GEnum::KeyMap::MAX_KEY ) {

	this->m_SolidData.setup( SolidType::NONE, SOLID_DEFAULT_FRAME );
	this->equipWeaponList = new map<int,int>();

	this->m_lpEnemy = NULL;
	setObjectType(ObjectType::PLAYER);

	setFaceDirection(FaceDirection::RIGHT);

	this->setHPMax(100);
	this->setHP(this->getHPMax());
	this->m_nRidingPlayerHP = -1;

	this->m_bIsJumpAccellerable = false;					// Wv

	this->m_nWeaponType = WeaponType::PUNCH;				// 

	this->m_bIsPreviousOnTheGround = false;					// ŏ͋

//	this->m_HoldCounter.setWaitFrameNum( 50 );				// G̍ő̗͂ɍ킹ĕϓ

	// ZbgAbv
	this->getWeapon( WeaponType::GATLING )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::MINIGUN_1;
	this->getWeapon( WeaponType::GATLING )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::MINIGUN_2;
	this->getWeapon( WeaponType::GATLING )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::MINIGUN_3;
	this->getWeapon( WeaponType::CHAIN_SAW )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::CHAIN_SAW;
	this->getWeapon( WeaponType::HOMING_LASER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::SUIT_CASE;
	// TODO G̗pӂ܂
	this->getWeapon( WeaponType::ELECTRIC_HOMING_LASER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::ELECTRIC_SUIT_CASE;

	// missile launcher
	this->getWeapon( WeaponType::MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER;
	this->getWeapon( WeaponType::MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER_FU;
	this->getWeapon( WeaponType::MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER_FD;

	// shot gun
	this->getWeapon( WeaponType::SHOT_GUN )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::SHOT_GUN;
	this->getWeapon( WeaponType::SHOT_GUN )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::SHOT_GUN_FU;
	this->getWeapon( WeaponType::SHOT_GUN )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::SHOT_GUN_FD;

	// frame thrower
	this->getWeapon( WeaponType::FRAME_THROWER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::FRAME_THROWER;
	this->getWeapon( WeaponType::FRAME_THROWER )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::FRAME_THROWER_FU;
	this->getWeapon( WeaponType::FRAME_THROWER )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::FRAME_THROWER_FD;
	
	// rail gun
	this->getWeapon( WeaponType::RAIL_GUN )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::RAIL_GUN;
	this->getWeapon( WeaponType::RAIL_GUN )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::RAIL_GUN_FU;
	this->getWeapon( WeaponType::RAIL_GUN )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::RAIL_GUN_FD;

	// water gun
	this->getWeapon( WeaponType::WATER_GUN )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::WATER_GUN;
	this->getWeapon( WeaponType::WATER_GUN )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::WATER_GUN_FU;
	this->getWeapon( WeaponType::WATER_GUN )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::WATER_GUN_FD;

	// homing missile
	this->getWeapon( WeaponType::HOMING_MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER;
	this->getWeapon( WeaponType::HOMING_MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER_FU;
	this->getWeapon( WeaponType::HOMING_MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER_FD;

	// sniper
	this->getWeapon( WeaponType::SNIPER_RIFLE )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::RAIL_GUN;
	this->getWeapon( WeaponType::SNIPER_RIFLE )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::RAIL_GUN_FU;
	this->getWeapon( WeaponType::SNIPER_RIFLE )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::RAIL_GUN_FD;

	// slime gatling
	this->getWeapon( WeaponType::DRILL )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::DRILL;

	// laser
	this->getWeapon( WeaponType::LASER_GUN )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::RAIL_GUN;
	this->getWeapon( WeaponType::LASER_GUN )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::RAIL_GUN_FU;
	this->getWeapon( WeaponType::LASER_GUN )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::RAIL_GUN_FD;

	// mayo
	this->getWeapon( WeaponType::MAYO_GUN )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::WATER_GUN;
	this->getWeapon( WeaponType::MAYO_GUN )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::WATER_GUN_FU;
	this->getWeapon( WeaponType::MAYO_GUN )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::WATER_GUN_FD;

	// hand gun
	this->getWeapon( WeaponType::HAND_GUN )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::HAND_GUN;
	this->getWeapon( WeaponType::HAND_GUN )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::HAND_GUN_FU;
	this->getWeapon( WeaponType::HAND_GUN )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::HAND_GUN_FD;

	// cryolator
	this->getWeapon( WeaponType::CRYOLATOR )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::CRYOLATOR;
	this->getWeapon( WeaponType::CRYOLATOR )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::CRYOLATOR_FU;
	this->getWeapon( WeaponType::CRYOLATOR )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::CRYOLATOR_FD;

	// slime gun
	this->getWeapon( WeaponType::SLIME_GUN )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::SLIME_GUN;
	this->getWeapon( WeaponType::SLIME_GUN )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::SLIME_GUN_FU;
	this->getWeapon( WeaponType::SLIME_GUN )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::SLIME_GUN_FD;

	// pile bunker
	this->getWeapon( WeaponType::PILE_BUNKER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::PILE_BUNKER;

	// nikita
	this->getWeapon( WeaponType::NIKITA_MISSILE )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER;
	
	// spread missile
	this->getWeapon( WeaponType::SPREAD_MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER;
	this->getWeapon( WeaponType::SPREAD_MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT_UP ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER_FU;
	this->getWeapon( WeaponType::SPREAD_MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT_DOWN ] =
		Sequence::EvigenWeapon::MISSILE_LAUNCHER_FD;

	this->getWeapon( WeaponType::MULTI_MISSILE_LAUNCHER )->m_arySequenceID[ WeaponDirection::FRONT ] =
		Sequence::EvigenWeapon::MULTI_MISSILE_LAUNCHER;

//	this->getWeapon( WeaponType::

	this->m_bIsLandOnObject = false;				// IuWFNg̏ɏĂ

	this->m_nWearState = WearStateType::NORMAL;		// 𒅂

	this->m_BoredCounter.setWaitFrameNum( 500 );	// Q܂ł̎

//	this->setMaxEvilOrbNum( DEFAULT_MAX_EVIL_ORB_NUM );
//	this->setEvilOrbNum( 0 );
	this->setEvilGage(0);
	this->setRemainNum( DEFAULT_REMAIN_NUM);

	
	this->getPoisonCounter()->setWaitFrameNum( PLAYER_POISON_REMAIN );
	this->getPoisonCounter()->end();
	this->getPoisonIntervalCounter()->setWaitFrameNum( POISON_DAMAGE_INTERVAL );
	this->getPoisonIntervalCounter()->end();

	this->m_nSuperPowerType = -1;
//	this->m_nSuperPowerDecrease = DEFAULT_SUPER_POWER_DECREASE;

	// ɂĂ
//	this->m_nSuperPowerRemain = 0;

//	this->setBatteryNum( 0 );

	//this->setStoredDamage( 0 );

	//this->m_bIsNaked = false;

	//this->m_nStockNum = DEFAULT_STOCK_NUM;
	//this->m_nFirstStockNum = DEFAULT_STOCK_NUM;

	//this->m_RespawnWaitCounter.setWaitFrameNum( RESPAWN_WAIT_FRAME_NUM );

	// I点Ă
	//this->m_RespawnWaitCounter.end();

	this->m_nSpecialState = StateType::STAND;	// special state
	this->m_bIsNoSpecialDead = false;	// no special dead
	this->m_ChargeManager.setWaitFrameNum( 20 );	// charge manager
	this->m_DamageWaterInterval.setWaitFrameNum( 20 );	// damage water interval
	this->m_DamageWaterInterval.end();	// stop
	this->m_HoldCounter.setWaitFrameNum( 100 );	// hold counter
//	this->m_bIsGetRideSpeed = false;
	this->m_nStatus = 0;	// Xe[^X
	this->m_ZanzoCounter.setWaitFrameNum( 100 );	// cό`
	this->setEnvType( EnvType::NORMAL );	// environment type
	this->m_IntervalWeaponEffectCounter.setWaitFrameNum( 10 );	// effect interval from weapon
	this->m_nTileType = TileType::NOSPECIAL;
}


GPlayer::~GPlayer(){
	this->clearSprites();
	// delete sprites
	for( int i = 0; i < PlayerType::MAX_NUM; i ++ ) {
		HPLSprite* lpSprite = this->getSpriteIndex( i );
		if( lpSprite ) {
			delete lpSprite;
			this->setSpriteIndex( i, NULL );
		}
	}

	// already delete sprites
	this->setSprite( NULL );

	delete this->m_WeaponSprite;

	delete this->m_LaderSequence;
}
int GPlayer::setStepWeaponCommon( int nWeaponType, int nStep ) {
	int nStartWeaponType = nWeaponType;	// ݂̎ނoĂ
	do {
		// 1T܂Ń[v

		// ֐i߂
		nWeaponType += nStep;

		if( nWeaponType >= WeaponType::MAX_WEAPON_NUM ) {
			// 0 Ɋ߂
			nWeaponType = 0;
		} else if( nWeaponType < 0 ) {
			nWeaponType = WeaponType::MAX_WEAPON_NUM - 1;
		}
		if( this->m_aryWeapons[ nWeaponType ].m_bIsActivated ) {
			break;
		}
	} while( nStartWeaponType != nWeaponType );
	return nWeaponType;
}
/*
int GPlayer::setNextWeapon() {

	this->m_nWeaponType = setStepWeaponCommon( this->m_nWeaponType, 1 );
	return this->getWeaponType();

}

int GPlayer::setPreviousWeapon() {
	this->m_nWeaponType = setStepWeaponCommon( this->m_nWeaponType, -1 );
	return this->getWeaponType();
}
*/

void GPlayer::setWeaponType(int nType ) {
	this->m_nWeaponType = nType;

	// charge
	this->m_ChargeManager.stop();

	// `[WʂύX
	int nChargeFrame = 20;
/*	switch( nType ) {
	case 
	}*/
	this->m_ChargeManager.setWaitFrameNum(nChargeFrame);

	// ŗLݒ
	switch( nType ) {
	case WeaponType::SNIPER_RIFLE:
		{
			//const int SNIPER_RIFLE_DELTA_X = 200;
			//HPLScroller* lpScroller = getStaticData()->getScrollManager()->getScroller(0);

			// ʒu
			// ʂ̐^񒆂ɐݒu
			//HPLRect rVir = lpScroller->getVirtualRect();
			//this->m_vSniperPosition.set(
			//	getStaticData()->m_Setting.windowWidth / 2 + rVir.getX(),
			//	getStaticData()->m_Setting.windowHeight / 2 + rVir.getY() );
				
			//this->m_vSniperPosition.set( (float)(this->getFaceDirection() * SNIPER_RIFLE_DELTA_X), 0 );
			//this->m_vSniperPosition.add( this->getCenter() );
			this->m_vSniperPosition = this->getCenter();

			// x
			this->m_vSniperVelocity.set(0,0);
		}
		break;
	case WeaponType::PILE_BUNKER:
		// V[PXiŌɂĂƂ߂j
		break;
	}

	// SuperPowerݒ
	switch( nType ) {
	case WeaponType::SLIME_GUN:
	case WeaponType::SEED:
	case WeaponType::WIND_WIZARD:
		break;
	default:
		// Super Power disable
		this->stopSuperPower();
	}
}




void GPlayer::setup() {
//	this->setEvilOrbNum( getStaticData()->m_Save.getFlag(FlagType::EVIL_ORB_NUM ) );
	this->setEvilGage( (float)getStaticData()->m_Save.getFlag( FlagType::EVIL_GAGE ));
	this->setRemainNum( getStaticData()->m_OptionData.getMaxPlayerRemain() );

	// G[Vݒ
	this->m_EmotionIcon.setup( Sequence::Effect::EI_HATENA );
	// disable
	this->m_EmotionIcon.setAlive( false );

	//HPLSprite* lpBaseSprite = getStaticData()->m_Basic.m_Graphics.m_SpriteContainer.getSprite(SpriteType::EVIGEN)->clone();

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	this->invCounter = new HPLCounter( static_cast<int>( PLAYER_INVINSIBLE_FRAMES / fLevel ) );

	this->m_nRidingPlayerType = this->getType();						// Ălɐݒ

	// clear sprites
	clearSprites();

	int SPRITES[] = {
		SpriteType::EVIGEN,
		SpriteType::TANYA,
		SpriteType::TANK,
		SpriteType::VTOL_NYA,
		SpriteType::CAR,
		SpriteType::ROBOGEN,
		SpriteType::EVIGEN,
	};
	for( int i = 0; i < PlayerType::MAX_NUM; i ++ ) {
		this->setSpriteIndex( i,  getStaticData()->getSprite(SPRITES[i])->clone() );
	}

	// add palette
	this->addPaletteSprite(this->getSpriteIndex( PlayerType::EVIGEN )->clone() );

	// XvCg
	this->setSprite(this->m_vecPaletteSprites[ PaletteType::DEFAULT]);

	// 
	this->m_WeaponSprite = getStaticData()->getSprite( SpriteType::EVIGEN_WEAPON )->clone();

	// vC[ɕo^
	for( int i = 0; i < WeaponType::MAX_WEAPON_NUM; i ++ ) {
		this->m_aryWeapons[i].setup( i, this );
		this->m_aryWeapons[i].m_bIsActivated = getStaticData()->m_Save.m_aryWeaponState[i] != 0;
	}

	// ԍŏɓo^ĂV[gJbgI
	//getStaticData()->setFirstShortCutIndex( this );
	getStaticData()->selectFirstWeapon( this );

	// [_[
	this->m_LaderSequence = getStaticData()->getSequence( SpriteType::EFFECT,
		Sequence::Effect::LADER )->clone();
	HPLRect rSrcRect = this->m_LaderSequence->getImageInformation(0)->srcRect;
	// srcrectɃ[_[̂蔻쐬
	this->m_rLaderHitRect.set(
		- rSrcRect.getWidth() / 2,
		- rSrcRect.getHeight() / 2,
		rSrcRect.getWidth(),
		rSrcRect.getHeight() );

	this->m_LaderSequence->end();

}
HPLVector GPlayer::getLaderCenter() {
	HPLVector vLaderCenter = this->getCenter();
	vLaderCenter.add( this->getFaceDirection() * PLAYER_LADER_DX,
		PLAYER_LADER_DY );
	return vLaderCenter;
}

HPLRect	GPlayer::getLaderHitArea() {
	HPLVector vCenter = this->getLaderCenter();
	HPLRect rRect = this->m_rLaderHitRect;
	rRect.setX( rRect.getX() + vCenter.getX() );
	rRect.setY( rRect.getY() + vCenter.getY() );
	return rRect;
}


void GPlayer::addPaletteSprite( HPLSprite* lpCopiedSprite ){
	this->m_vecPaletteSprites.push_back( lpCopiedSprite );
}

void GPlayer::clearSprites() {
	for( int i = 0; i < (int)this->m_vecPaletteSprites.size(); i ++)
	{
		delete this->m_vecPaletteSprites[i];
		this->m_vecPaletteSprites[i] = NULL;
	}
	this->m_vecPaletteSprites.clear();
	this->setSprite( NULL );

}
void GPlayer::setPaletteIndex( int nIndex ) {
	switch( this->getType() ) {
	case PlayerType::EVIGEN:
#ifdef _DEBUG
		ASSERT_IT_INDEX( nIndex, 0, this->getPaletteNum() );
#endif
		m_nPaletteIndex = nIndex;
		this->setSprite(this->m_vecPaletteSprites[nIndex] );

		//this->rollBackState();//changeType( StateType::STAND );
		break;
	case PlayerType::TANYA:
	case PlayerType::TANK:
	case PlayerType::VTOL_NYA:
	case PlayerType::CAR:
	case PlayerType::ROBOGEN:
	case PlayerType::ENEMY:
		break;
	}
}


void GPlayer::die(HPLShootingObject* damageSource){
	this->setHP( 0 );

	// G[V
	this->m_EmotionIcon.getSequence()->end();

	if( this->getPlayerClassType() == PlayerClassType::HUMAN ) {
		if( this->isAlive() ) {
			// sound
			getStaticData()->m_MixerManager.play( SE::EVIGEN_DEAD, false );
		}


		if( damageSource != NULL ) {
			// т
			bool bIsChonpa = false;

			// special dead scene!
			int nSpecialDeadEventID = -1;

			// l
			bool bIsExplosion = false;
			switch( this->m_SolidData.getType() ) {				// solid type
			case SolidType::CRYO:								// cryo
				// ΂΂
				bIsExplosion = true ;
				break;
			default:
				{
					switch( damageSource->getObjectType() ) {
					case ObjectType::SHOT:						// shot	---------------------------
						switch( damageSource->getType() ) {
						case Sequence::Shot::EXPLOSION:			// 
							// explosion damage
							bIsExplosion = true;
							break;
						case Sequence::Shot::ONPA:				// g
							this->m_bIsNoSpecialDead = true;
							break;
						}
						break;
					case ObjectType::ENEMY:						// G	---------------------------
						switch( damageSource->getType() ) {
						case EnemyType::SUN:					// sun
							// sun (cutter-chan mk-II)
						case EnemyType::TANYA:					// tanya bomb
						case EnemyType::TANYA_YOUJO:			// tanya youjo bomb
						case EnemyType::FAN_BIRD:				// fan bird
							// lؒf
							bIsExplosion = true;
							break;
						case EnemyType::WORM:
							{
								nSpecialDeadEventID = SpecialDeadEventID::WORM;
							}
							break;
						}
						break;
					case ObjectType::NEUTRAL:					// neutral	----------------------
						{
							GNeutral* lpNeutral = (GNeutral*)damageSource;
							switch( damageSource->getType() ) {
							case Sequence::Neutral::KILLER_FAN:	// killer fan
								{
									if( lpNeutral->getFanDirectionType() == FanDirectionType::DOWN ) {
										// face down direction
										if( HPLMath::nextInt(0,2)==0) {
											// random 50%
											// zanshu
											bIsChonpa = true;
										}
									}
									if( bIsChonpa == false ) {
										// if not set
										// ->explosion (daruma)
										bIsExplosion = true;
									}
								}
								break;
							}
						}
						break;
					}

				}
			}

			if( bIsChonpa ) {
				this->dieChonpa();
			} else if( bIsExplosion ) {
				this->dieExplosion();
			}

			if( nSpecialDeadEventID >= 0 ) {
				((GSpecialDeadScene*) getStaticData()->m_SceneManager.getScene( SceneType::SPECIAL_DEAD ))->setScenarioIndex(nSpecialDeadEventID);

				getStaticData()->startFadeOutDX( SceneType::SPECIAL_DEAD, -1 );
			}
		}
		setAlive(false);
	} else {
		// ~
		this->dropOff();
		// create explosion
		GShot* lpShot = getStaticData()->m_ObjectManager.m_ShotManager.create( Sequence::Shot::EXPLOSION, this->getCenter(),
			this->getID(), this->getFaceDirection(), false, true );
	}

	
}

void GPlayer::damage(float dmg, HPLShootingObject* damageSource,
					 bool isInv, int damageState)
{
	// _[Wʕ\GtFNg
	getStaticData()->m_ObjectManager.m_EffectManager.createNumber(
		this->getCenter(), (int)dmg, false, NUM_POWER,
		NUM_RED.r,NUM_RED.g,NUM_RED.b );
//	if( this->getWeaponType() == WeaponType::SNIPER_RIFLE ) {
//	}
	if( this->getState()->getState() == StateType::BORING ||		// boring (stand)
		this->getState()->getState() == StateType::BORING_CROUCH )	// boring (crouch)
	{
		if( damageSource->getObjectType() == ObjectType::ENEMY ) { // damage is by enemy tuckle
			// set achievement reminder for attacker make player awaken
			getStaticData()->m_Game.m_Reminder.setNoCheck(
				ReminderType::LYING_DAMAGE_ENEMY_ID, damageSource->getID() );
		}
	}
	if( damageSource != NULL ) {	// damaged by something
		switch( damageSource->getObjectType() ) {
		case ObjectType::ENEMY:	// damaged by enemy
			{
				GEnemy* lpEnemy = (GEnemy*)damageSource;
				switch( damageSource->getType() ) {
				case EnemyType::GREEN_SLIME:
					switch( this->getType() ) {
					case PlayerType::EVIGEN:
					case PlayerType::TANYA:
						// player gets poison
						this->startStatus( StatusType::POISON );
						break;
					}
					break;
				case EnemyType::LAMIA:
				case EnemyType::SUCCUBUS:
				case EnemyType::SUCCUBUS_MISAGO:
					switch( this->getType() ) {
					case PlayerType::EVIGEN:
					case PlayerType::TANYA:
						// player get eros
						this->startStatus( StatusType::EROS );
						break;
					}
					break;
				}
			}
			break;
		case ObjectType::SHOT:
			{
				switch( damageSource->getType() ) {
				case Sequence::Shot::EVIL_BEAM:
					{
						// increase evil gage
						this->setEvilGage( this->getEvilGage() + EVIL_BEAM_GAGE_ADD );
					}
					break;
				case Sequence::Shot::DIRTY_DROP:
					{
						// poison
						this->startStatus( StatusType::POISON );
					}
					break;
				}
			}
			break;
		}
	}

	if( this->getState()->isSpecialState() ) {
		// do nothing
	} else {
		this->changeState(damageState);
	}

	// vC[̎ʂɉă_[Wʂ𒲐
/*			EVIGEN,
			TANYA,
			TANK,
			VTOL_NYA,
			CAR,
			ROBOGEN,
			ENEMY,
			MAX_NUM,*/
	// level rate
	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );
	// leveled damage rate
	float fLeveledDamageRate = getStaticData()->m_OptionData.getLevelIndex() > LevelType::NORMAL ? 
		1 / fLevel : 1;
	// _[W{
	float aryDamageRates[] = {
		1,					// evigen
		fLeveledDamageRate,	// tanya
		0.2f,				// tank
		0.3f,				// vtol
		0.6f,				// car
		0.8f,				// robogen
		fLeveledDamageRate,	// enemy
	};
	ASSERT_IT_INDEX( this->getType(), 0, SIZEOF(aryDamageRates) );

	dmg *= aryDamageRates[this->getType()];

	float fOldHP = this->getHP();
	this->setHP( this->getHP() - dmg );

	if( this->getHP() <= 0 && fOldHP > 0) {
		// 
		this->die( damageSource );
	} else {
		// ܂Ă
		if( getStaticData()->m_OptionData.getOptionFlag( OptionFlagType::NO_NEAR_DEAD_SPEAK ) == 0 ) {
			// ׂ

			switch( this->getType() ) {
			case PlayerType::EVIGEN:
				if( this->getHP() <= this->getHPMax() * PLAYER_QUARTER_HP_THRESHOLD_RATE &&
					fOldHP > this->getHPMax() * PLAYER_QUARTER_HP_THRESHOLD_RATE)
				{
					// ʂ
					getStaticData()->startEvent( 12, false );
				} else if( this->getHP() <= this->getHPMax() * PLAYER_HALF_HP_THRESHOLD_RATE &&
					fOldHP > this->getHPMax() * PLAYER_HALF_HP_THRESHOLD_RATE)
				{	// under half hp now
					// _[WI
					getStaticData()->startEvent( 11, false );
				}
			}
		}

		// cancel sniping
		if( this->getWeapon()->isSniping() ) {
			// change weapon to hand
			this->setWeaponType( WeaponType::PUNCH );
		}
	}

	if( this->getHP() > 0 ) {	// yet alive

		switch( this->getType() ) {	// type
		case PlayerType::EVIGEN:	// evigen
			// sound
			getStaticData()->m_MixerManager.play( 
				HPLMath::nextInt( SE::EVIGEN_DAMAGES, SE::MAX_EVIGEN_DAMAGES ),
				false );
		}
	}

	if( isInv ) {	// enable invinsible
		this->startInvinsible( );
	}


	// no elec and no flare
	if( damageState != StateType::DAMAGE_ELEC && damageState != StateType::DAMAGE_FLAME ) {	
		// ǂ΁[
		getStaticData()->m_ObjectManager.m_EffectManager.createBlood( this->getCenter() );
	}
}

/** d˕\̋ʏ
  */
static void drawCommon( float fCenterX, float fCenterY, 
					   HPLSequence* lpSeq, int nFaceDirection, float fRotate,
					   float fZoom, int nAlpha,
					   int nShakeX, int nShakeY )
{
	getStaticData()->m_Basic.m_Graphics.draw(
		(int)fCenterX + nShakeX, (int)fCenterY + nShakeY, lpSeq,
		nFaceDirection, fRotate, fZoom,
		nAlpha, nAlpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND);
}
					   
void GPlayer::draw(){
//	HPLDrawInfo info;
//	info.setup( this);
	HPLRect rArea = this->getArea();	// my area
	HPLVector vCenter = this->getCenter();	// my center
	HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(0);	// scroller
	float left = rArea.getX() + scroller->getVirtualRect().getX();	// left
	float top = rArea.getY() + scroller->getVirtualRect().getY();	// top
	float fCenterX = vCenter.getX() + scroller->getVirtualRect().getX();	// center x
	float fCenterY = vCenter.getY() + scroller->getVirtualRect().getY();	// center y
	float fZoom = scroller->m_fZoomRate;	// zoom
	fCenterX *= fZoom;	// fix center x by zoom
	fCenterY *= fZoom;	// fix center y by zoom

	int t = this->getType();
	int st = this->getState()->getState();
	switch( st ) {
	case StateType::EATENING:
		{
			int nEnemyType = this->getHoldEnemyType();
			GEnemySetting* lpEnSet = getStaticData()->m_ObjectManager.m_EnemyManager.getEnemySetting(
				nEnemyType );
			// \ʒu炷
			fCenterY -= lpEnSet->m_HitRect.getHeight() / 2 * fZoom;
		}
		break;
	}
	if(this->getSprite() != NULL){
		// XvCgꍇ

		int nFaceDirection = FaceDirection::LEFT;
		HPLSequence* seq = this->getSequence();

		float rotate = 0;
		int alpha = 255;

		if( getStaticData()->getInputManager()->isPressed( KeyMap::F ) ){
			HPLRect rHitRect = this->getHitRect();
			DrawFillBox( (int)(left + rHitRect.getX()), (int)(top + rHitRect.getY()),
				(int)(left + rHitRect.getX() + rHitRect.getWidth()),
				(int)(top + rHitRect.getY() + rHitRect.getHeight()), GetColor(255,0,0) );
		}
		if(this->isInvinsible()  && seq->getStepCounter() % 2 == 0){
			// G͓_ł
			alpha = INVINSIBLE_ALPHA;
		}else if(this->getState()->getState() == StateType::REITAI){
			alpha = 80;
		} 
		// \
		//SetDrawBlendMode(DX_BLENDMODE_ALPHA, alpha);

		// Ԉُ̐F
		bool bIsColored = false;
		int nStatus = this->getStatus();
		if( StatusType::NONE != nStatus) {
			bIsColored = true;
		}
		if( bIsColored ) {
			int nR = 255, nG = 255, nB = 255;
			
			switch( nStatus ) {
			case StatusType::POISON:	nR = 100;	nB = 100;	break;
			case StatusType::EROS:		nG = 196;				break;
			}
			SetDrawBright(nR,nG,nB);
		}

		///////////////////////////
		// O
		switch( t ) {
		case PlayerType::CAR:
			if( this->getState()->isFlyingState() ) {
				// GallonC\
				int nGallonSeqID = Sequence::Car::GALLON;
				HPLSequence* lpSeqGallon = this->getSprite()->getSequence( 
					nGallonSeqID, FaceDirection::LEFT );
				drawCommon( fCenterX, fCenterY - 50, lpSeqGallon,
					this->getFaceDirection(), rotate, fZoom,
					alpha, this->getShakeX(), this->getShakeY() );
			}
			break;
		}
		////////////////////////////////
		// {̕`
		drawCommon( fCenterX, fCenterY, seq,
			this->getFaceDirection(), rotate, fZoom,
			alpha, this->getShakeX(), this->getShakeY() );

		////////////////////
		// ㏈
		switch( t ) {
		case PlayerType::CAR:
			if( this->getState()->isFlyingState() == false ) {
				int nGallonSeqID = Sequence::Car::GALLON;
				HPLSequence* lpSeqGallon = this->getSprite()->getSequence( 
					nGallonSeqID, FaceDirection::LEFT );
				drawCommon( fCenterX, fCenterY - 50, lpSeqGallon,
					this->getFaceDirection(), rotate, fZoom,
					alpha, this->getShakeX(), this->getShakeY() );
			}
		}

		if( bIsColored ) {
			// Fɖ߂
			SetDrawBright(255,255,255);
		}
		//SetDrawBlendMode(DX_BLENDMODE_NOBLEND, 255);

		// Aj[V邩ǂ
		bool bIsAnimation = getStaticData()->m_Game.isTheWorld() == false &&	// not the world(nor scenario,nor menu)
			this->m_SolidData.getType() == SolidType::NONE;	// not solided

		// Aj[V
		if( bIsAnimation ) {
			// Aj[V
			seq->step();

			if( this->getSuperPowerType() >= 0 ) {
				// SuperPowerL

				// con
				int SPRITE_TYPE[] = {
					SpriteType::EVIGEN,
					SpriteType::TANYA,
					SpriteType::TANK,
					SpriteType::VTOL_NYA,
					SpriteType::CAR,
					SpriteType::ROBOGEN,
					SpriteType::EVIGEN,
				};
				ASSERT_IT_EQUAL( SIZEOF( SPRITE_TYPE ), PlayerType::MAX_NUM );
//				HPLError::assertIt( SIZEOF( SPRITE_TYPE ) == PlayerType::MAX_NUM );

				float fRate = this->m_ZanzoCounter.getRoundTripRate();//(float)seq->getStepCounter() / (float)seq->getImageInformation()->waitFrame;

				GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.createZanzo(
					SPRITE_TYPE[ this->getType() ],
					this->getSequenceID(),
					seq->getFrameIndex(),
					this,
					ZANZO_RED.r * fRate, ZANZO_RED.g * fRate, ZANZO_RED.b * fRate);

				float fZoomRate = fRate * 0.2f + 1.f;
				int nDefaultLeg = this->getHeightCenterToBottom();	// ʏ푫
				int nZoomedLeg = (int)(nDefaultLeg * fZoomRate);	// Zoom
				int nCenterDiffY = nZoomedLeg - nDefaultLeg;		// 
				HPLVector vCenter = lpEffect->getCenter();
				vCenter.add( 0, -nCenterDiffY / 2 );
				lpEffect->setCenter( vCenter );
				
				lpEffect->setScale( fZoomRate );
				const float ZANZO_FLYUP_SPEED = 1.f;
				lpEffect->setVelocityAngle( 0, -ZANZO_FLYUP_SPEED );

				if( this->m_ZanzoCounter.step().isFinishAnimation ) {
					this->m_ZanzoCounter.reset();
				}
			}

			// shake TODO ̋Lڂłǂ
			switch( t ) {
			case PlayerType::CAR:	// car
				{
					const int ERR = 1;
					// ɏ㉺ɗhĂ
					this->setShakeY( HPLMath::nextInt(-ERR,ERR));
				}
				break;
			}
		}

		if( this->m_LaderSequence->getState().isFinishAnimation == false ) {
			// [_[L

			// \
			HPLVector vLaderCenter = this->getLaderCenter();
			vLaderCenter.add(
				scroller->getVirtualRect().getX(),
				scroller->getVirtualRect().getY() );

			int nAlpha = 200;
			if( this->m_LaderSequence->getStepCounter() % 2 == 1 ) {
				nAlpha = 100;
			}

			getStaticData()->m_Basic.m_Graphics.draw(
				(int)vLaderCenter.getX(), (int)vLaderCenter.getY(),
				this->m_LaderSequence, this->getFaceDirection(),
				0, 1, nAlpha, DX_BLENDMODE_ADD );


			if(getStaticData()->m_Game.isTheWorld() == false){
				this->m_LaderSequence->step();
			}

		}


		if( this->getType() == PlayerType::EVIGEN ) {
			// т񂳂񂾂

			int st = this->getState()->getState();
			int w = this->getWeaponType();
			GWeapon* lpWeapon = this->getWeapon();

			if( this->getState()->isAttackGunState() ) {
				// eU

				int nSeq = -1;
				if( lpWeapon->m_nDirectionType == WeaponDirType::SIX ) {
					if( this->isPressed( KeyMap::UP ) ) {
						nSeq = lpWeapon->m_arySequenceID[WeaponDirection::FRONT_UP];
					} else if( this->isPressed( KeyMap::DOWN ) ) {
						nSeq = lpWeapon->m_arySequenceID[WeaponDirection::FRONT_DOWN];
					} else {
						nSeq = lpWeapon->m_arySequenceID[WeaponDirection::FRONT];
					}


				} else if( lpWeapon->m_nDirectionType == WeaponDirType::STATIC ) {
					nSeq = lpWeapon->m_arySequenceID[ WeaponDirection::FRONT ];

				}

				if( nSeq >= 0 ) {
					HPLSequence* lpSeq = this->m_WeaponSprite->getSequence( nSeq, FaceDirection::LEFT );
					getStaticData()->m_Basic.m_Graphics.draw(
						(int)fCenterX, (int)fCenterY, lpSeq,
						this->getFaceDirection(), rotate, fZoom );

					if(getStaticData()->m_Game.isTheWorld() == false){
						lpSeq->step();

					}
				}
			}

		}

		if( this->m_ChargeManager.isCharging()) {	// `[W
			// \ʒu
			const int CHARGE_DELTA = 30;

			HPLSequence* lpChargeMeterSeq = getStaticData()->getSequence(SpriteType::COMMON, Sequence::Common::CHARGE_METER );
			HPLRect rChargeMeterSrcRect = lpChargeMeterSeq->getImageInformation(0)->srcRect;
			HPLRect rHitArea = this->getHitArea();
			int nLeft = fCenterX - rChargeMeterSrcRect.getWidth() / 2;
			int nTop = rHitArea.getY() - CHARGE_DELTA - rChargeMeterSrcRect.getHeight() + scroller->getVirtualRect().getY();
			

			const int BAR_DELTA_X = 1;
			const int BAR_DELTA_Y = 17;

			int nImageHandle = getStaticData()->getImageHandle(
				SpriteType::COMMON, Sequence::Common::CHARGE_METER_BAR );
			int nSrcWidth = 0;
			int nSrcHeight = 0;

			// o[̔wi
			getStaticData()->m_Basic.m_Graphics.draw(
				nLeft + BAR_DELTA_X, nTop + BAR_DELTA_Y,
				getStaticData()->getSequence( SpriteType::COMMON,
				Sequence::Common::CHARGE_METER_BAR_BACK ) );

			// ̃o[\
			GetGraphSize( nImageHandle, &nSrcWidth, &nSrcHeight );
			float fRate = (float)this->m_ChargeManager.getStepCounter() / 
				(this->m_ChargeManager.getWaitFrameNum()-1);
			DrawRectGraph( nLeft + BAR_DELTA_X, nTop + BAR_DELTA_Y,
				0,0,nSrcWidth * fRate,nSrcHeight,
				nImageHandle, TRUE, FALSE );

			// draw frame
			getStaticData()->m_Basic.m_Graphics.draw(
				nLeft, nTop, lpChargeMeterSeq );

			// TODO create charge effects
			//HPLImageInformation* lpInfo = lpPlayer->getSequence()->getImageInformation(0);
/*			int nWidth = this->getArea().getWidth();	// 96
			// `[WGtFNg
			getStaticData()->m_ObjectManager.m_EffectManager.createCharge(
				this, this->getCenter(), 10, nWidth / 2 );*/

			//HPLImageInformation* lpInfo = lpPlayer->getSequence()->getImageInformation(0);
			int nWidth = this->getArea().getWidth();

			HPLVector vCenter;

			// ̈ʒu擾iKgOœj
			GShotFactory::getPlayerWeaponShotCenter( vCenter, this, WeaponType::GATLING,
				WeaponDirection::FRONT );

			// `[WGtFNg
			getStaticData()->m_ObjectManager.m_EffectManager.createCharge(
				this, vCenter, 10, nWidth / 2 );
		}

		if( this->isHeld() ) {
			getStaticData()->m_ObjectManager.drawHoldBar( &this->m_HoldCounter,
				fCenterX, fCenterY );
		}

		/////// X
		if( this->m_SolidData.getType() == SolidType::CRYO ) {
			getStaticData()->m_ObjectManager.drawSolid(
				this->m_SolidData.getType(), fCenterX, fCenterY, seq->getImageInformation(0)->srcRect.getWidth() );
		}

		if( this->m_SolidData.getType() != SolidType::NONE ) {	// ł܂Ă
			const int SOLID_BAR_DELTA_Y = 20;
			// o[\
			getStaticData()->m_ObjectManager.drawHoldBar( &this->m_SolidData.m_SolidCounter,
				fCenterX, fCenterY - SOLID_BAR_DELTA_Y );
		}

		////// WindWizard
		if( this->getSuperPowerType() == SuperPowerType::WIND_WIZARD ) {
			// Wizard
			Energy* lpEnergy = &this->getWeapon()->m_Energy;
			if( lpEnergy->getRemain() > 0 ) {
				// ܂cĂ
				// iGPlayerAttack.cppŏj
				// V[h\
				HPLSequence* lpShield = getStaticData()->getSequence( SpriteType::COMMON,
					Sequence::Common::WIND_SHIELD );
				int nShieldAlpha = 150;
				drawCommon( fCenterX, fCenterY, lpShield,
					this->getFaceDirection(), rotate, fZoom,
					nShieldAlpha, this->getShakeX(), this->getShakeY() );

				if( bIsAnimation ){
					if( lpShield->step().isFinishAnimation ) {
						lpShield->resetCounter();
					}

					// GlM[
					lpEnergy->step(lpEnergy->m_ConstantDecreaser );
					
				}
			}
		}

		/////// G[VACR
		if( this->m_EmotionIcon.isAlive() ) {
			// \
			this->m_EmotionIcon.setCenter( getStaticData()->getEmotionIconPosition( this ) );
			this->m_EmotionIcon.draw();

			if( this->m_EmotionIcon.getSequence()->getState().isFinishAnimation ){
				// V[PXI

				// 
				this->m_EmotionIcon.setAlive( false );
			}
		}

		////// draw player status (debug)
		if( getStaticData()->m_Game.isCheat() ) {	// cheat
			// start position(y)
			int nY = top;
			// print interval(y)
			const int INTERVAL = FONT_HEIGHT + 2;
			// start position(x)
			int nX = left + rArea.getWidth();

			// status
			DrawString( nX, nY, HPLString::chrToStr( "State:%d", st ).c_str(), GetColor(255,255,255));
			nY += INTERVAL;
			// hp
			DrawString( nX, nY, HPLString::chrToStr( "HP:%.1f", this->getHP()).c_str(), GetColor(255,255,255) );
			nY += INTERVAL;
			// evil gage
			DrawString( nX, nY, HPLString::chrToStr( "EG:%.1f", this->getEvilGage()).c_str(), GetColor(255,255,255));

		}
	}
}

HPLSequence* GPlayer::getSequence(){
	HPLSprite* lpSprite = this->getSprite();

/*	if( this->getType() == PlayerType::PESERU &&
		this->m_bIsNaked )
	{
		lpSprite = this->m_lpNakedPeseruSprite;
	}*/
	HPLSequence* seq = 
		lpSprite->getPair(getSequenceID())->left;

	return seq;
}

int GPlayer::getSequenceID(){
	int id = 0;

	int st = this->getState()->getState();

	int t = this->getType();

	switch( t ) {
	case PlayerType::EVIGEN:
	case PlayerType::TANYA:

		id = getStaticData()->getEvigenSequenceID( this );
		break;
	case PlayerType::TANK:
		id = getStaticData()->getTankSequenceID( this );
		break;
	case PlayerType::VTOL_NYA:
		id = getStaticData()->getVTOLSequenceID( this );
		break;
	case PlayerType::CAR:
		//id = 0;
		if( this->getState()->isFlyingState() ) {
			return Sequence::Car::FLYUP;
		} else {
			return Sequence::Car::STAND;
		}
		break;
	case PlayerType::ROBOGEN:
		switch( st ) {
		case StateType::WALK:
			id = Sequence::Robogen::WALK;
			break;
		case StateType::FLYDOWN:
			id = Sequence::Robogen::FLYDOWN;
			break;
		case StateType::FLYUP:
			id = Sequence::Robogen::FLYUP;
			break;
		case StateType::WALK_READY:
			id = Sequence::Robogen::WALK_READY;
			break;
		case StateType::ATTACK_GUN:
			id = Sequence::Robogen::GATLING;
			break;
		case StateType::ATTACK_GUN_2:
			id = Sequence::Robogen::RAIL;
			break;
		case StateType::ATTACK_GUN_3:
			id = Sequence::Robogen::MISSILE;
			break;
		}
		break;
	}

	return id;
}

void GPlayer::changeState(int st){
	// ʑO
	switch( this->getType() ) {		// type
	case PlayerType::EVIGEN:		// evigen
		{
			if( this->isAlive() ) {
				if( this->getState()->isAttackGunState() ) {	// alive and attack gun state
					if( this->m_ChargeManager.isCharging() ) {	// charging!
						if( this->isPressed( KeyMap::A ) ) {	// press a
							if( this->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) {
								if( this->isPressed(KeyMap::LEFT )|| this->isPressed( KeyMap::RIGHT ) ) {	// press horizontal movement key
									st = StateType::WALK_GUN;
								} else {
									st = StateType::ATTACK_GUN;
								}
							} else {
								st = StateType::JUMP_GUN;
							}
						}
					}
				} else if( this->getState()->getState() == StateType::SWIM ) {	// swim state
					if( HPLState::isDamageState( st ) ) {	// next is damage state
						// no change
						st = StateType::SWIM;
					}
				}
			}
		}
		break;
	case PlayerType::CAR:			// car
		{
			switch( st ) {
			case StateType::STAND:
			case StateType::FLYUP:
				break;
			default:
				st = StateType::STAND;
			}
		}
		break;
	}
	int oldSt = this->getState()->getState();

	if(oldSt != st){
		int nSequenceID = this->getSequenceID();

		this->getSprite()->getPair( nSequenceID )->left->resetCounter();

/*		HPLSequencePair* lpPair = getStaticData()->getWeaponSequencePair(*this);
		if( lpPair != NULL ) {
			lpPair->left->resetCounter();
		}*/

/*		if( this->getType() == PlayerType::PESERU ) {
			this->m_lpNakedPeseruSprite->getPair(nSequenceID )->left->resetCounter();
		}*/

		/*
		if( st == StateType::CROUCH || st == StateType::SWIM ) {
			// 
			this->setHitRect(37,SMALL_Y,25,SMALL_HEIGHT);
		} else if( st == StateType::DEAD ) {
			this->setHitRect(37,DEAD_Y,25,DEAD_HEIGHT);
		} else {
			this->setHitRect(37,NORMAL_Y,25,NORMAL_HEIGHT);
		}*/
	}

	this->getState()->setState(st);
	if( oldSt != st ) {
		// 蔻ς
		this->setHitRectAuto();
	}
}
/** Ԃɖ߂B݂̏ԂɓK؂ȏԂʂ
  * ԕύX܂ōs
  * @retval	̏ԁB
  */
int GPlayer::rollBackState(){
	// is gun state?
	bool bIsAttackGunState = this->getState()->isAttackGunState();

	int nNextState = -1;

	if(this->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND)){	// on the ground

		if( bIsAttackGunState ) {	// attack state
			nNextState = StateType::ATTACK_GUN;

		} else {	// not attack state
			nNextState = StateType::STAND;
		}
		
	}else{	// in the air
		if( bIsAttackGunState ) {	// attack state
			nNextState = StateType::JUMP_GUN;
		} else {	// not attack state

			/////// common animation change with vertical velocity
			if(this->getVelocityAngle().getY() > getStaticData()->m_Setting.flydownSpeedThreshold){
				// fall
				nNextState = StateType::FLYDOWN;
				if( this->getEnvType() == EnvType::SWIM ) {	// swim env
					// no flydown
					nNextState = StateType::FLYUP;
					// WARN!! this will effect not dead states
				}
			}else{	
				// rise up
				nNextState = StateType::FLYUP;
			}
		}
	}
	if( nNextState >= 0 ) {
		this->changeState(nNextState);
	}
	return this->getState()->getState();
}

void GPlayer::jump(){
	
}
void GPlayer::checkJump(){
	
	int st = this->getState()->getState();

	if(st == StateType::STAND ||
		//st == StateType::READY_TO_JUMP ||
		st == StateType::WALK)
	{
		// Wv\ȏ

		if(this->isPressedNow(GEnum::KeyMap::B)){
			// WvL[

			this->getTrigger()->setTrigger(TriggerType::ON_THE_GROUND, false);

			HPLVector v = this->getVelocityAngle();
			float SPD = getStaticData()->m_Setting.player.jumpSpeed;
			v.setY(-SPD);
			this->setVelocityAngle(v);

		}
	}
}

void GPlayer::setHitRectAuto() {
	int st = this->getState()->getState();

	// ʒup
	HPLRect rOldHitArea = this->getHitArea();
	HPLVector vOldCenter = this->getCenter();

	HPLRect rSrcRect = this->getSequence()->getImageInformation(0)->srcRect;
	this->setSize(rSrcRect.getWidth(), rSrcRect.getHeight());

	HPLRect rNewHitRect = this->getHitRect();
	switch( this->getType() ) {
	case PlayerType::EVIGEN:
	case PlayerType::TANYA:
		switch( st ) {
		case StateType::CROUCH:
		case StateType::SWIM:
			rNewHitRect.set(37,SMALL_Y,25,SMALL_HEIGHT);
			break;
		case StateType::DEAD:
			rNewHitRect.set(37,DEAD_Y,25,DEAD_HEIGHT);
			break;
		default:
			rNewHitRect.set(37,NORMAL_Y,25,NORMAL_HEIGHT);
		}
		break;
	case PlayerType::TANK:
		rNewHitRect = (TANK_HIT_RECT);
		break;
	case PlayerType::VTOL_NYA:
		rNewHitRect = (VTOL_HIT_RECT);
		break;
	case PlayerType::CAR:
		rNewHitRect = (CAR_HIT_RECT);
		break;
	case PlayerType::ROBOGEN:
		rNewHitRect = (ROBOGEN_HIT_RECT);
		break;
	default:
		rNewHitRect.set(37,NORMAL_Y,25,NORMAL_HEIGHT);
	}

	if( HPLRect::equals( rNewHitRect, this->getHitRect(), true ) == false ) {
		// 蔻ύXɂ邸C
		HPLActionMoveTool::changeHitRect( this, rNewHitRect );
	}
}

void GPlayer::changeType(int t, HPLShootingObject* lpRidingTarget ) {
	//this->setSprite(this->spriteList[t]);

	int nOldType = this->getType();
	this->setType(t);

	//setSize(96,96);

	this->setShakeX( 0 );
	this->setShakeY( 0 );

	// 蔻Ē
	this->setHitRectAuto();

	// ̏
	switch( t ) {
	case PlayerType::EVIGEN:
	case PlayerType::TANYA:
		// ~肽
		this->m_nRidingPlayerType = -1;
//		if( this->m_nRidingPlayerHP >= 0 ) {	// 蕨ɏĂ
//			this->setHP( this->m_nRidingPlayerHP );	// HPɖ߂
//		}	// lԁlԂȂǁA~ȊOł̕ύX͉Ȃ
		this->m_nRidingPlayerHP = -1;
		break;
	default:
		// ̑i蕨j
		// ҕύX
		this->m_nRidingPlayerType = nOldType;
		this->m_nRidingPlayerHP = this->getHP();
		// ΏۂNeutralHP擾
		if( lpRidingTarget != NULL ) {
			this->setHP( lpRidingTarget->getHP() );
		}
	}
	// set weapon
	switch( t ) {
	case PlayerType::EVIGEN:
		// change weapon
		getStaticData()->selectFirstWeapon( this );
		break;
	default:
		this->setWeaponType(WeaponType::PUNCH );
	}
//	setHitRect(37,NORMAL_Y,25,NORMAL_HEIGHT);

	this->setSprite( this->getSpriteIndex( t ) );

	if( PlayerType::CAR == t && //car 
		getStaticData()->getMapIndex() == SpecialMapIndex::WIND_BOSS_1 &&	// wind boss1
		getStaticData()->m_ObjectManager.m_EnemyManager.getCountTarget( EnemyType::CHASER ) > 0 )
	{
		getStaticData()->m_nPlayerPlaceIndex = 0;
		// ̃}bvֈړ
		getStaticData()->startFadeOutDX( -1, SpecialMapIndex::WIND_BOSS_2 );
	}
}

void GPlayer::resetCommon() {
	// vC[Ԃ
	this->setAlive(true);

	// vC[S
	this->setHeld(false);

	// nɃZbg
	this->getTrigger()->setTrigger( TriggerType::ON_THE_GROUND, true );

	// Ԃɖ߂
	this->rollBackState();

	this->m_bIsNoSpecialDead = false;

	this->m_nTileType = TileType::NOSPECIAL;
}


/** v[Xڍs̃Zbg
  */
void GPlayer::resetPlace() {
	this->resetCommon();

	// vC[HPBCxgŎłꍇ1ɖ߂
	if(this->getHP() <= 0){
		this->setHP(1);
	}


}

/** ړ̃Zbg
  */
void GPlayer::resetStar() {
}

/** S̃Zbg
  */
void GPlayer::resetRespawn() {
	// [ĥŁAʏ͎gpȂ
	//this->resetCommon();

	// hpuSv
	this->setHP( this->getHPMax() );
}
void GPlayer::resetLibrary() {
	this->resetCommon();
	this->setHP(this->getHPMax());
}

bool GPlayer::isChecking() {
	bool bIsUp = this->isPressedNow( KeyMap::UP );
	bool bIsSwim = this->getState()->getState() == StateType::SWIM;
	bool bIsReadyToWalk = this->getState()->isReadyToWalkState();
	bool bIsAttackState = this->getState()->isAttackState();
	return bIsUp && false == bIsAttackState && (bIsSwim || bIsReadyToWalk);
}

void doEmotionWithItem( GPlayer* lpPlayer, int nEmotionIcon, int nChangeState ) {
	if( nEmotionIcon >= 0 ) {	// R\
		getStaticData()->createPlayerEmotionIcon( nEmotionIcon );

		if( nChangeState >= 0 ) {
			lpPlayer->changeState( nChangeState );
		}
	}
}

void selectWeaponItem( GPlayer* lpPlayer, int nItemType, int nAddWeapon  ) {
	// activate it in this game
	lpPlayer->getWeapon( nAddWeapon )->m_bIsActivated = true;
	// status enabled
	getStaticData()->m_Save.m_aryWeaponState[nAddWeapon] = 1;
//		getStaticData()->m_Save.save();

	// current weapon 
	int nOldWeaponType = lpPlayer->getWeaponType();

	// V킪V[gJbgɊ܂܂Ă邩mF
	int nAlreadyExistsIndex = getStaticData()->m_ShortCutPaletteManager.getIndexByValue( nItemType );//getShortCutIndex( nAddWeapon );

	// current selected short cut index
	int nCurrentShortCutIndex = getStaticData()->m_ShortCutPaletteManager.getSelectedIndex();

	// 󂫂邩ǂmF
	int nBlankIndex = getStaticData()->m_ShortCutPaletteManager.getNextBlankIndex( 0 );

	// select that weapon forcely
	lpPlayer->setWeaponType( nAddWeapon );

	// next short cut index selected.
	// -1:no change selection
	int nNextShortCutIndex = -1;

	if( nAlreadyExistsIndex >= 0 ) {	// that weapon is already in palette
		// select palette index
		nNextShortCutIndex = nAlreadyExistsIndex;
		
	} else if( nBlankIndex >= 0 ) {	// a blank in the palette
		// register the weapon at the index of first blank
		getStaticData()->m_ShortCutPaletteManager.setValue( nBlankIndex, nItemType );

		// change selection at the registered index
		nNextShortCutIndex = nBlankIndex;

	} else {	// no blank nor exists in the palette
		ASSERT_IT_INDEX( nCurrentShortCutIndex, 0, getStaticData()->m_ShortCutPaletteManager.getPaletteNum() );
		// register the weapon at current selected index in the palette(replace)
		getStaticData()->m_ShortCutPaletteManager.setValue( nCurrentShortCutIndex, nItemType );
	}

	if( nNextShortCutIndex >= 0 ) {
		// select new weapon short cut index
		getStaticData()->m_ShortCutPaletteManager.setSelectedIndex( nNextShortCutIndex );
	}

	getStaticData()->m_Save.save();
}


/** ACe擾
  * @param[in]	bIsForceStock 
	  * @retval		0					I
  */
int GPlayer::getItem( int nItemType, int nNum) {


	// item setting
	GItemSetting* lpSetting = getStaticData()->m_ObjectManager.m_ItemManager.getSetting(nItemType );
	
	bool bIsStock = lpSetting->getFlagBit( ItemFlagType::STOCK );//true;	// XgbN^CvH
	bool bIsOnlyOne = lpSetting->getFlagBit( ItemFlagType::UNIQUE );//false;	// ЂƂĂȂH
	
	int nAddWeapon = -1;	// ǉ

	int w = getStaticData()->checkItemIsWeapon( nItemType );
	if( w >= 0 ) {	// it is a weapon
		bIsOnlyOne = true;
		nAddWeapon = w;
	} else {	// not weapon

	switch( nItemType ) {
/*	case Sequence::Item::KOKEMOMO:
	case Sequence::Item::EVI_FLY:
	case Sequence::Item::ANTI_POISON:
	case Sequence::Item::EVI:
	case Sequence::Item::AJI:
//		bIsStock = false;
		bIsCure = true;
		fCure = KOKEMOMO_CURE / fLevel;
		break;
	case Sequence::Item::STEAK:
//		bIsStock = false;
		bIsCure = true;
		fCure = 100;
		break;
	case Sequence::Item::MEAT:
		bIsStock = false;
		bIsCure = true;
		fCure = MEAT_CURE / fLevel;
		if( false == bIsForceStock ) {
			getStaticData()->stepAndCheckAchievement( AchievementType::FAT, 1, true );
		}
		break;
	case Sequence::Item::EVIL_DRINK:
		// cure
		bIsStock = false;
		bIsCure = true;
		fCure = EVIL_DRINK_CURE / fLevel;

		if( bIsForceStock == false ) {
			// add evil gage
			if( this->setEvilGage( this->getEvilGage() + EVIL_DRINK_GAGE_ADD * fLevel ) ) {
				// 傤ǂ̃^[MAXɂȂ
				// do nothing
			}
			
			// add evil orb
			getStaticData()->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
				getStaticData()->m_Save.getFlag( FlagType::EVIL_ORB_NUM) + 1 );
			//this->setEvilOrbNum( this->getEvilOrbNum() + static_cast<int>( EVIL_DRINK_ORB_GET / fLevel + 0.5f ) );
			getStaticData()->m_Save.save();
		}
		break;
	case Sequence::Item::BATTERY:
	case Sequence::Item::MISSILE:
		break;
*/
	case Sequence::Item::BLUE_COIN:
		// ʏRCɂ
		// 𑝂₷
		nItemType = Sequence::Item::COIN;
		nNum *= COINS_PER_BLUE;
		break;
	case Sequence::Item::FLYING_COIN:
		nItemType = Sequence::Item::COIN;
		break;
	case Sequence::Item::COIN_10:
	case Sequence::Item::FLYING_COIN_10:
		nItemType = Sequence::Item::COIN;
		nNum *= 10;
		break;
	case Sequence::Item::COIN_50:
	case Sequence::Item::FLYING_COIN_50:
		nItemType = Sequence::Item::COIN;
		nNum *= 50;
		break;
	case Sequence::Item::COIN_100:
	case Sequence::Item::FLYING_COIN_100:
		nItemType = Sequence::Item::COIN;
		nNum *= 100;
		break;
	case Sequence::Item::COIN_500:
	case Sequence::Item::FLYING_COIN_500:
		nItemType = Sequence::Item::COIN;
		nNum *= 500;
		break;
	case Sequence::Item::COIN_1000:
	case Sequence::Item::FLYING_COIN_1000:
		nItemType = Sequence::Item::COIN;
		nNum *= 1000;
		break;
	case Sequence::Item::COIN_5000:
	case Sequence::Item::FLYING_COIN_5000:
		nItemType = Sequence::Item::COIN;
		nNum *= 5000;
		break;
	case Sequence::Item::COIN_10000:
	case Sequence::Item::FLYING_COIN_10000:
		nItemType = Sequence::Item::COIN;
		nNum *= 10000;
		break;
/*	case Sequence::Item::COIN:
	case Sequence::Item::ALPACA:
	case Sequence::Item::DELTA:
	case Sequence::Item::LAMDA:
	case Sequence::Item::KAPIBARA:
	case Sequence::Item::KAPPA:
	case Sequence::Item::QUEEN_AUTHORITY:
	case Sequence::Item::WIND_WIZARD:
	case Sequence::Item::SEED:
	case Sequence::Item::CAR_BALL_DUMMY:
		break;*/
	case Sequence::Item::BOSS_ABILITY:
		{
//			bIsStock = false;	// XgbNȂ
			// map index
			//int nMapIndex = getStaticData()->getMapIndex();
			int nStar = getStaticData()->m_nSelectedStar;
			int nPlace = getStaticData()->m_nSelectedPlace;
			// get star and place ( place is no use )
			//getStaticData()->m_Setting.maps.getStarAndPlaceFromMapIndex( nMapIndex , nStar, nPlace );
			
			int SUPER_POWERS[] = {
				SuperPowerType::QUEEN_AUTHORITY,
				-1,
				-1,
				-1,
				SuperPowerType::SEED,
				SuperPowerType::WIND_WIZARD,
				-1,
			};
			if( SUPER_POWERS[nStar] >= 0 ) {
				getStaticData()->m_Save.m_arySuperPower[SUPER_POWERS[nStar]] = 1;
				// get ability !
				getStaticData()->m_Save.setFlagBit( FlagType::GET_ABILITY, nStar, true );
				getStaticData()->m_Save.save();
			}

			// 
			int WEAPONS[] = {
				WeaponType::SLIME_GUN,
				-1,
				-1,
				-1,
				WeaponType::SEED,	// forest
				WeaponType::WIND_WIZARD,	// wind

			};
			if( 0 <= WEAPONS[nStar] ) {
				// ǉL
				this->addEquipWeapon( WEAPONS[nStar] );
			}

			// ViIX^[g
			int SCENARIOS[] = {
				SpecialScenarioIndex::AFTER_SLIME_QUEEN,
				-1,
				-1,
				-1,
				SpecialScenarioIndex::AFTER_ALRAUNE,	// forest
				SpecialScenarioIndex::AFTER_CHASER,		// wind
				-1,
			};
			// ړ̃vC[ʒu
			int PLAYER_POSITIONS[] = {
				1,
				0,
				0,
				0,
				0,	// forest
				0,	// wind
			};
			#ifdef _DEBUG
			HPLError::assertIt( SCENARIOS[nStar] >= 0,
				"%s:%s(%d):nStar(%d) is not set scenario:%d", __FILE__, __FUNCTION__, __LINE__, nStar, SCENARIOS[nStar]);
			#endif
			// 
			if( SCENARIOS[nStar] >= 0 ) {	// 
				getStaticData()->m_nPlayerPlaceIndex = PLAYER_POSITIONS[nStar];
				getStaticData()->startEvent( SCENARIOS[nStar], true );

			}
			// ǉƂ͂Ȃ
			return 0;
		}
		break;
	}
	}

	if( Sequence::Item::COIN == nItemType ) {
		// check achievement
		getStaticData()->stepAndCheckAchievement(
			AchievementType::GOLD_RUSH, nNum, true );

		// 擾\
		getStaticData()->m_ObjectManager.m_EffectManager.createNumber(
			this->getCenter(), (int)nNum, false, NUM_POWER,
			NUM_YELLOW.r,NUM_YELLOW.g,NUM_YELLOW.b);
	}

	int nSE = SE::GET_ITEM;
	if( bIsStock ) {	// XgbN^Cv

		// ݂̏
		int nCurrentNum = getStaticData()->m_Save.getItemNum( nItemType );

		if( bIsOnlyOne && nCurrentNum == 1 ) {
			// Ȃ
		} else {
			int nNewNum = nCurrentNum + nNum;
			getStaticData()->m_Save.setItemNum( nItemType , nNewNum );
			getStaticData()->m_OptionData.setGetItem( nItemType, 
				getStaticData()->m_OptionData.getGetItem( nItemType) + nNum );
		}

	}

	// play SE
	getStaticData()->m_MixerManager.play(
		nSE, false );


	if( nAddWeapon >= 0 ) {	// ǉ
		selectWeaponItem( this, nItemType, nAddWeapon );
	}

	// |Cgǉ
	getStaticData()->m_Save.addScore( (long)lpSetting->m_nPoint );

	// ACe\
	getStaticData()->m_ShowItemName.start( nItemType, nItemType );


	{

		doEmotionWithItem( this, lpSetting->m_nEmotionIcon, lpSetting->m_nNextState);

	}
	return 0;
}


/** ACegpij
  */
int GPlayer::useOrEquipItem( int nItemType ) {
	// level
	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	// item setting
	GItemSetting* lpSetting = getStaticData()->m_ObjectManager.m_ItemManager.getSetting(nItemType );

	// cure level
	map<int, float> CURE_LEVEL_MAP;
	CURE_LEVEL_MAP[Sequence::Item::KOKEMOMO] = KOKEMOMO_CURE / fLevel;
	CURE_LEVEL_MAP[Sequence::Item::MEAT] = MEAT_CURE / fLevel;

	bool bIsCure = lpSetting->getFlagBit( ItemFlagType::CURE );	// 񕜃ACeH
	float fCure = 0;		// 񕜗

	int nAddWeapon = -1;

	int w = getStaticData()->checkItemIsWeapon( nItemType );
	if( w >= 0 ) {	// it is a weapon
//		bIsOnlyOne = true;
		nAddWeapon = w;
	} else {
		switch( nItemType ) {
			/////////
			// curen
		case Sequence::Item::KOKEMOMO:
		case Sequence::Item::EVI_FLY:
		case Sequence::Item::ANTI_POISON:
		case Sequence::Item::EVI:
		case Sequence::Item::AJI:
			fCure = KOKEMOMO_CURE / fLevel;
			break;
		case Sequence::Item::STEAK:
			fCure = 100;
			break;
		case Sequence::Item::MEAT:
			fCure = MEAT_CURE / fLevel;
			getStaticData()->stepAndCheckAchievement( AchievementType::FAT, 1, true );
			break;
		case Sequence::Item::EVIL_DRINK:
			fCure = EVIL_DRINK_CURE / fLevel;
			if( this->setEvilGage( this->getEvilGage() + EVIL_DRINK_GAGE_ADD * fLevel ) ) {
				// 傤ǂ̃^[MAXɂȂ
				// do nothing
			}
			// add evil orb
			getStaticData()->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
				getStaticData()->m_Save.getFlag( FlagType::EVIL_ORB_NUM) + 1 );
			//this->setEvilOrbNum( this->getEvilOrbNum() + static_cast<int>( EVIL_DRINK_ORB_GET / fLevel + 0.5f ) );
			getStaticData()->m_Save.save();
			break;

		case Sequence::Item::BATTERY:
		case Sequence::Item::MISSILE:
			break;
		}
	}
	int nSE = SE::GET_ITEM;
	if( bIsCure ) {
		nSE = HPLMath::nextInt(0,2) == 0 ? SE::EAT_0 : SE::EAT_1;

		// 񕜃ACe
		this->setHP( this->getHP() + fCure );

		// \
		getStaticData()->m_ObjectManager.m_EffectManager.createNumber(
			this->getCenter(), (int)fCure, false, NUM_POWER,
			NUM_GREEN.r,NUM_GREEN.g,NUM_GREEN.b);

		// create cure effect
		getStaticData()->m_ObjectManager.m_EffectManager.createCure(
			this->getCenter(), this->getID(), false );
	}
	// play SE
	getStaticData()->m_MixerManager.play(
		nSE, false );

	if( nAddWeapon >= 0 ) {	// ǉ
		selectWeaponItem( this, nItemType, nAddWeapon );
	}
	if( lpSetting->getFlagBit( ItemFlagType::USABLE ) ) {	// use it
		// create emotion icon(again)
		doEmotionWithItem( this,  lpSetting->m_nEmotionIcon, lpSetting->m_nNextState);
	}
	return 0;
}


void GPlayer::stopSuperPower( ) {
	this->m_nSuperPowerType = -1;
}

void GPlayer::startSuperPower( int nSuperPowerType ) {
	// Lɂ
//	this->m_nSuperPowerRemain = DEFAULT_SUPER_POWER_REMAIN;

	// SuperPower!
	this->m_nSuperPowerType = nSuperPowerType;

	// Grɍ킹Čϓ
	this->getWeapon()->m_Energy.m_Decreaser.setDecrease( 
		this->getWeapon()->m_Energy.getSuperPowerDecrease( this->m_fEvilGage,
		this->getWeapon()->m_Energy.m_Decreaser) );
	this->getWeapon()->m_Energy.m_ConstantDecreaser.setDecrease(
		this->getWeapon()->m_Energy.getSuperPowerDecrease( this->m_fEvilGage,
		this->getWeapon()->m_Energy.m_ConstantDecreaser) );
//	this->m_nSuperPowerDecrease = 

	// TODO Fς̓oÔł߂Ă
	// Fς
	//int nPaletteType = PaletteType::FIRE;
/*	switch( this->m_nSuperPowerType ) {
	case 
	}*/
	//this->setPaletteIndex( nPaletteType );
}


/*bool GPlayer::stepSuperPower() {
	this->m_nSuperPowerRemain -= this->m_nSuperPowerDecrease;
	if( this->m_nSuperPowerRemain < 0 ) {
		this->m_nSuperPowerRemain = 0;
	}

	bool bIsEnd = this->isSuperPower() == false;
	if( bIsEnd ) {
		this->m_nSuperPowerType = -1;
		this->setPaletteIndex( PaletteType::DEFAULT );
	}
	return bIsEnd;
}*/

bool GPlayer::setEvilGage( float fEvilGage ) {
	float fOld = this->m_fEvilGage;

	if( fOld < fEvilGage ) {	// 
		// SE
		getStaticData()->m_MixerManager.play( SE::EVIL_GAGE_UP, true );

		// GtFNg
		int nNum = (fEvilGage - fOld) / 10;
		if( nNum <= 0 ) {
			nNum = 1;
		}
//		getStaticData()->m_EffectManager.create
		
		getStaticData()->checkAndStartEvent(FlagType::ONE_TALK, OneTalkType::EVILIZE, 
			SpecialScenarioIndex::EVILIZE_CAUTION );
	}

	this->m_fEvilGage = fEvilGage;

	
	if( this->m_fEvilGage < 0 ) {
		// `FbN
		this->m_fEvilGage = 0;
	}
	if( this->m_fEvilGage >= GEnum::MAX_EVIL_GAGE ) {
		// `FbN

		this->m_fEvilGage = static_cast<float>( GEnum::MAX_EVIL_GAGE );

		if( fOld < GEnum::MAX_EVIL_GAGE ) {
			// B
			return true;
		}
	}

	return false;
}


bool GPlayer::isRiding() {
	switch( this->getType() ) {
	case PlayerType::EVIGEN:
	case PlayerType::TANYA:
		return false;
	default:
		// 蕨
		return true;
	}
}

/** 蕨~
  */
void GPlayer::dropOff() {
#ifdef _DEBUG
	HPLError::assertIt( this->m_nRidingPlayerType != this->getType() &&
		this->m_nRidingPlayerType != -1,
		"%s:%s(%d):player is not riding(RidingPlayerType(%d) equals getType()) or RidingPlayerType is not -1",
		__FILE__,__FUNCTION__, __LINE__, m_nRidingPlayerType, getType() );
#endif
	int nNeutralType = -1;
	switch( this->getType() ) {
	case PlayerType::CAR:		nNeutralType = Sequence::Neutral::CAR;		break;
	case PlayerType::TANK:		nNeutralType = Sequence::Neutral::TANK;		break;
	case PlayerType::ROBOGEN:		nNeutralType = Sequence::Neutral::ROBOGEN;		break;
	case PlayerType::VTOL_NYA:		nNeutralType = Sequence::Neutral::VTOL;		break;
	default:
		HPLError::assertIt( false, "sȃvC[^Cv");
	}
	int nHP = this->getHP();
	if( nHP > 0 ) {
		// Neutral蕨
		GNeutral* lpNeutral = getStaticData()->m_ObjectManager.m_NeutralManager.create(
			nNeutralType, this->getCenter(),-1,-1);
		lpNeutral->setHP( nHP );
	}
	// HPA
	this->setHP( this->m_nRidingPlayerHP );
	this->m_nRidingPlayerHP = -1;

	// {lύX
	this->changeType( this->m_nRidingPlayerType, NULL );
}

/*void GPlayer::setPlayableShot( GShot* lpShot ) {
	HPLError::assertIt( lpShot == NULL, "[N" );
	this->m_lpPlayableShot = lpShot;
}
*/

bool GPlayer::isSpecialWeaponNoMove() {
	GWeapon* lpWeapon = this->getWeapon();
	int nWeaponType = this->getWeaponType();
	// ̏ꍇȂ
	// EXiCsO{nɂ
	// ERc{eU
	//return (lpWeapon->isSniping() && this->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) || //WeaponType::SNIPER_RIFLE == nWeaponType||
	//	( nWeaponType == WeaponType::NIKITA_MISSILE && 
	//	this->getState()->isAttackGunState());
	return false;//lpWeapon->isSniping() && this->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND );
}

/** 
  */
void GPlayer::dieExplosion( ) {
	this->changeState( StateType::DISAPPEAR );

	// 葫g̐
	int NEUTRAL_TYPES[] = {
		Sequence::Neutral::EVIGEN_PARTS_ARM,
		Sequence::Neutral::EVIGEN_PARTS_LEG,
		Sequence::Neutral::EVIGEN_PARTS_BODY,
		Sequence::Neutral::EVIGEN_PARTS_HEAD,
	};
	int NEUTRAL_NUMS[] = {
		2,
		2,
		1,
		1,
	};

	HPLVector vCenter = this->getCenter();
	for( int i = 0; i < sizeof(NEUTRAL_TYPES )/sizeof(NEUTRAL_TYPES[0]); i++ ) {
		for( int j = 0; j < NEUTRAL_NUMS[i]; j ++ ) {
			getStaticData()->m_ObjectManager.m_NeutralManager.createRandomUpVelocityAngle(
				NEUTRAL_TYPES[i], vCenter );
		}
	}
}

/** 
  */
void GPlayer::dieNoHead( ) {
	// ȂSiHꂽj
	this->changeState( StateType::CHONPA_STAND );
}

/** т(͐)
  */
void GPlayer::dieChonpa() {
	this->dieNoHead();

	// 񐶐
	getStaticData()->m_ObjectManager.m_NeutralManager.createRandomUpVelocityAngle(
		Sequence::Neutral::EVIGEN_PARTS_HEAD, this->getCenter() );
}

/** start (illegal) status (and its counter)
  */
void GPlayer::startStatus( int nIndex ) {
	this->m_nStatus = nIndex;
	if( nIndex == StatusType::NONE ) {
		this->stopStatus();
	} else {
		this->m_StatusCounter.setWaitFrameNum( STATUS_DATAS[nIndex].m_nFrameNum );
		this->m_StatusCounter.reset();
	}
}
/** stop (illegal) status counter
  */
void GPlayer::stopStatus( ) {
	this->m_nStatus = 0;
	this->m_StatusCounter.stop();
}
/*	bool getStatus( int nIndex ){
	return HPLMath::getFlagByIndexInt( this->m_nStatus, nIndex );
}*/
int GPlayer::getStatus() {
	if( this->m_nStatus == StatusType::NONE ) {
		return this->m_nStatus;
	}
	if( this->m_StatusCounter.getState().isFinishAnimation == false ) {
		this->stopStatus();
	}
	return this->m_nStatus;
}
/**
  * @retval	true	C^[oBBԈُ킩ǂgetStatus()ŊmF
  */
bool GPlayer::stepStatus() {
	if( this->getStatus() == StatusType::NONE ) {
		return true;
	}
	if( this->m_StatusCounter.step().isFinishAnimation ) {
		return true;
	}
	return false;
}

int GPlayer::getPlayerClassType() {
	switch( this->getType() ) {
	case PlayerType::EVIGEN:
	case PlayerType::TANYA:
	case PlayerType::ENEMY:
		return PlayerClassType::HUMAN;
	}
	return PlayerClassType::UNKNOWN;
}
