#ifndef _G_PLAYER_
#define _G_PLAYER_

#include <DXPlayer.h>
#include <hpllib/image/eg/HPLPaletteManager.h>
#include <hpllib/general/HPLChargeManager.h>
#include <hpllib/object/HPLSolidData.h>

#include "GEnum.h"

#include "GWeapon.h"

#include "GShot.h"

#include "GEffect.h"

// ҂ȂHPLShootingObjectł
#include "GEnemy.h"

/** Q[\\ACRi_CAÕAł͂Ȃj̃f[^
  * 
  */
class EmotionData {
public:
	HPLCounter	m_HoldCounter;		//! Ԉێp
private:
	int			m_nState;			//! 
public:
	EmotionData() {
		this->m_nState = StateType::FLYDOWN;
		this->m_HoldCounter.setWaitFrameNum( 50 );
	}
	int getState() {
		return this->m_nState;
	}
	void setState( int nState ) {
		this->m_nState = nState;
		this->m_HoldCounter.reset();
	}
};

/**
  */
class GPlayer : public DXPlayer {

	// public member variables
public:
	int m_nTileType;								//! ݂̃^C^Cv
	HPLSolidData				m_SolidData;
	EmotionData	m_EmotionData;
	HPLCounter	m_DamageWaterInterval;				//! _[Wt̂ɐZĂԂł̃_[WԊu
	HPLVector	m_vSniperPosition;					//! Ȃۂ̃^[QbeBOW
	HPLVector	m_vSniperVelocity;					//! Ȃۂ̈ړ
	int			m_nWearState;							//! 
	bool		m_bIsJumpAccellerable;				//! WvH
	bool		m_bIsPreviousOnTheGround;			//! Ot[ɒnʂɐݒuĂ

	bool		m_bIsLandOnObject;					//! Neutral̂ɍ~藧
	HPLSequence* m_LaderSequence;					//! [_[V[PXimہj
	HPLRect		getLaderHitArea();					//! [_[蔻

	HPLCounter	m_BoredCounter;						//! uԂɂȂ܂ł̃JE^()
	
	GEffect		m_EmotionIcon;						//! ACRp

	HPLCounter 	m_RandomDamageCounter;				//! _[W܂ł̃C^[o
	int			m_nSpecialState;					//! 
	
	bool		m_bIsNoSpecialDead;					//! SĂENDɍsȂ

	HPLChargeManager m_ChargeManager;				//! `[WǗ
	HPLSequenceState stepHoldCounter(int nExtraCount) {
		return this->m_HoldCounter.step(nExtraCount);
	}
	void setHoldCounter( int nWaitFrameNum ) {
		this->m_HoldCounter.setWaitFrameNum( nWaitFrameNum );
	}
	void resetHoldCounter() {
		this->m_HoldCounter.reset();
	}
	/** 蕨ɏĂԂH
	  */
	bool isRiding();
	/** 蕨~
	  */
	void dropOff();

	/*void setGetRideSpeed( bool bIsGet ) {
		this->m_bIsGetRideSpeed = bIsGet;
	}
	bool isGetRideSpeed() {
		return this->m_bIsGetRideSpeed;
	}*/
/*	void setStatus( int nIndex, bool bStatus ) {
		this->m_nStatus = HPLMath::setFlagByIndexInt( this->m_nStatus, nIndex, bStatus );
	}*/
	void startStatus( int nIndex );
	void stopStatus( );
/*	bool getStatus( int nIndex ){
		return HPLMath::getFlagByIndexInt( this->m_nStatus, nIndex );
	}*/
	int getStatus() ;
	/**
	  * @retval	true	C^[oBBԈُ킩ǂgetStatus()ŊmF
	  */
	bool stepStatus();
	int getPlayerClassType();

	// environment type
	int getEnvType() {	return this->m_nEnvType;	}
	void setEnvType( int nType) {	this->m_nEnvType = nType;	}

	int getIntervalEffectType() {	return this->m_nIntervalEffectType;	}
	void setIntervalEffectType( int nEffectType, int nWaitFrameNum ) {
		this->m_nIntervalEffectType = nEffectType;
		this->m_IntervalEffectCounter.setWaitFrameNum( nWaitFrameNum );
	}
	HPLCounter	m_IntervalWeaponEffectCounter;		//! ŕ킩oGtFNg̃JE^
private:
	HPLCounter	m_IntervalEffectCounter;			//! ŉGtFNgô߂̃JE^
	int			m_nIntervalEffectType;				//! ŏoGtFNgB-1Ȃ牽oȂ

	int			m_nEnvType;							//! ubNȂǁAɂĎ󂯂
													//	cf.EnvType::
	HPLCounter	m_ZanzoCounter;						//! zanzõTCYFύXpJE^
	GEnemy* m_lpEnemy;	//! G샂[hp
	
	HPLCounter	m_StatusCounter;					//! Xe[^Xc鎞
	int			m_nStatus;							//! Xe[^XID
	//bool		m_bIsGetRideSpeed;					//! ړNeutralړʂǂ
	int			m_nRidingPlayerType;				//! Ălԃ^Cv
	int			m_nRidingPlayerHP;					//! ĂvC[HP
	HPLCounter	m_HoldCounter;						//! z[hJ܂ł̃JE^
	//HPLCounter	m_SuperPowerRemainCounter;			//! \͎c莞
	int			m_nSuperPowerType;					//! \͎
//	int			m_nSuperPowerRemain;				//! \͎c莞
//	int			m_nSuperPowerDecrease;				//! 鑬x
	HPLSprite*	m_arySprites[GEnum::PlayerType::MAX_NUM];	//! vC[ʂƂ̃XvCg
	int 		m_nRemainNum;						//! c@
	float		m_fEvilGage;						//! т鉻isx
//	int			m_nMaxEvilOrbNum;					//! тI[u
//	int			m_nEvilOrbNum;						//! ݂̃I[u
//	int			m_nRemainBatteryNum;				//! obe[
	HPLVector	getLaderCenter();					//! [_[̒SW
	HPLRect		m_rLaderHitRect;					//! [_[蔻iS̑΍Wj
	// ֘A
	GWeapon		m_aryWeapons[GEnum::WeaponType::MAX_WEAPON_NUM];				//! FL薳ŃXLbv
	int			m_nWeaponType;						//! gp̕
	// pbg֘A
	std::vector<HPLSprite*> m_vecPaletteSprites;	//! pbgϊς݃XvCg GEnum::PaletteTypeQ
	int			m_nPaletteIndex;					//! gp̃pbgID
	HPLPaletteManager m_PaletteManager;				//! pbgǗ
	HPLSprite*	m_WeaponSprite;						//! ̃XvCg
	
	// private operations
private:
	/** ݒ苤ʏ
	  */
	int setStepWeaponCommon( int nWeaponType, int nStep );
	
	/** 
	  */
	void dieExplosion( );//HPLShootingObject* lpDamageSource);
	/** т(͐)
	  */
	void dieChonpa();

	// Constructor
public:
	GPlayer();
	virtual ~GPlayer();

	// Getter/Setter
public:
	/** т(͐Hꂽ)
	  */
	void dieNoHead( );//HPLShotingObject* lpDamageSource );
	/*int getSuperPowerRemain() {
		return this->m_nSuperPowerRemain;
	}*/
//	float getSuperPowerRemainRate() {
//		return (float)this->m_nSuperPowerRemain / GEnum::DEFAULT_SUPER_POWER_REMAIN;
//	}
	void startSuperPower( int nSuperPowerType );
	void stopSuperPower();
	bool isSuperPower() {
		return this->getSuperPowerType() >= 0;
	}


	/*int setSuperPowerDecrease() {
		return this->m_nSuperPowerDecrease;
	}*/

	int getSuperPowerType() {
		return m_nSuperPowerType;
	}
	/** SuperPowerL
	  */
/*	bool isSuperPower() {
		return this->m_nSuperPowerType >= 0 && this->m_nSuperPowerRemain > 0;
	}*/

	/**
	  * @retval	true	I
	  */
//	bool stepSuperPower();

	HPLSprite* getSpriteIndex( int nIndex ) {
		return this->m_arySprites[nIndex];
	}
	void setSpriteIndex( int nIndex, HPLSprite* lpSprite ) {
		this->m_arySprites[nIndex] = lpSprite;
	}
	int getRemainNum() {
		return this->m_nRemainNum;
	}
	int setRemainNum( int nNum ) {
		// mode ɂĂ̓}CiXłOK?
		if( nNum < 0 ) {
			nNum = 0;
		}
		this->m_nRemainNum = nNum;
		return nNum;
	}
/*	int getBatteryNum() {
		return this->m_nRemainBatteryNum;
	}
	int setBatteryNum( int nBatteryNum ) {
		if( nBatteryNum < 0 ) {
			nBatteryNum = 0;
		}
		this->m_nRemainBatteryNum = nBatteryNum;
		return nBatteryNum;
	}
	*/
	/*
	int getMaxEvilOrbNum() {
		return this->m_nMaxEvilOrbNum;
	}
	void setMaxEvilOrbNum( int nNum ) {
		if( nNum < 0 ) {
			nNum = 0;
		}
		this->m_nMaxEvilOrbNum = nNum;
	}

	int getEvilOrbNum() {
		return this->m_nEvilOrbNum;
	}
	void setEvilOrbNum( int nNum ) {
		this->m_nEvilOrbNum = nNum;
	}*/


	float getEvilGage() {
		return this->m_fEvilGage;
	}

	/** @retval	true	őɒB
	  */
	
	bool setEvilGage( float fEvilGage );
	
	HPLSprite* getWeaponSprite() {
		return this->m_WeaponSprite;
	}
	GWeapon* getWeapon( int nWeaponType ) {
#ifdef _DEBUG
		int nMax = GEnum::WeaponType::MAX_WEAPON_NUM;
		HPLError::assertIt( nWeaponType >= 0 && nWeaponType < nMax,
			"%s:invalid weapon type:%d {0,%d}", __FUNCTION__, nWeaponType, nMax);
#endif
		return &this->m_aryWeapons[ nWeaponType ];
	}
	GWeapon* getWeapon() {
		return this->getWeapon( this->m_nWeaponType );
	}
/*	int setNextWeapon();
	int setPreviousWeapon();*/

	/** 
	  * @param[in]	nType	^Cv(ACe^CvV[gJbg^Cvł͂Ȃ)
	  */
	void setWeaponType( int nType );
	/** Iɕ؂ւ܂
		ZbgpH
	  */
	//void setWeaponTypeForce(int nType );

	int getWeaponType() {
		return this->m_nWeaponType;
	}
	/** 
	  * @param[in]	lpCopiedSprite		Rs[ς݂̃XvCgBŎIɏ
	  */
	void addPaletteSprite( HPLSprite* lpCopiedSprite );
	void setPaletteIndex( int nIndex );
	int getPaletteIndex( ) {
		return m_nPaletteIndex;
	}
	int getPaletteNum() {
		return static_cast<int>(this->m_vecPaletteSprites.size() );
	}
	void clearSprites();
	//HPLSprite* 

	// Operations
public:
	/** G[VACR\
	  */
	void startEmotionIcon( int nEffectType );

	/** jump
	  */
	void jump();

	void die(HPLShootingObject* damageSource);

	void damage(float dmg, HPLShootingObject* damageSource,
		bool isInv, int damageState);

	void draw();

	HPLSequence* getSequence();

	int getSequenceID();

	void changeState(int st);

	int rollBackState();


	/**
	*/
	void checkJump();

	/** ݒi[fBO
	  */
	void setup();

	/** ޕύX
	  */
	void changeType(int t, HPLShootingObject* lpRidingTarget);

private:
	void resetCommon();
public:
	/** v[Xڍs̃Zbg
	  */
	void resetPlace();

	/** ړ̃Zbg
	  */
	void resetStar();

	/** S̃Zbg
	  */
	void resetRespawn();

	/** CuV[ł̃Zbg
	  */
	void resetLibrary();

	/** `FbNĂ邩H
	  */
	bool isChecking();

	/** ACe擾
	  * @retval		0					I
	  */
	int getItem( int nItemType, int nNum );

	/** ACegpij
	  */
	int useOrEquipItem( int nItemType );

	/** HitRectĒ
	  */
	void setHitRectAuto();

	/** ȂۂȂǂ̓ꕐgpH
	  * truȅꍇ
	  */
	bool isSpecialWeaponNoMove();
		
};

#endif
