#include "GPlayerManager.h"

#include <hpllib/action/HPLActionMoveTool.h>

#include "GStaticData.h"

using namespace std;
using namespace GEnum;

/** AmmoKvǂAgp
  */
static void getNeedAmmo(int nWeaponType, int& nType, int& nAmmoNum ) {
	nType = -1;
	nAmmoNum = 0;
	switch( nWeaponType ) {
	case WeaponType::HOMING_LASER:
		nType = Sequence::Item::BATTERY;
		nAmmoNum = 1;
		break;
	case WeaponType::ELECTRIC_HOMING_LASER:
		nType = Sequence::Item::BATTERY;
		nAmmoNum = 2;
		break;
	case WeaponType::MISSILE_LAUNCHER:
	case WeaponType::HOMING_MISSILE_LAUNCHER:
	case WeaponType::NIKITA_MISSILE:
	case WeaponType::MULTI_MISSILE_LAUNCHER:
	case WeaponType::SPREAD_MISSILE_LAUNCHER:
		nType = Sequence::Item::MISSILE;
		nAmmoNum = 1;
		break;
	}
}

/** ̃VbgmF
  */
int getWeaponDirection( int nDirectionType, bool up, bool down ) {
	int nWeaponDirection = WeaponDirection::FRONT;

	if( nDirectionType == WeaponDirType::SIX || //lpWeapon->m_nDirectionType == WeaponDirType::SIX ||
		nDirectionType == WeaponDirType::EIGHT) //lpWeapon->m_nDirectionType == WeaponDirType::EIGHT )
	{
		// \
		if( up ) {
			nWeaponDirection = WeaponDirection::FRONT_UP;
		} else if( down ) {
			nWeaponDirection = WeaponDirection::FRONT_DOWN;
		}
	}
	return nWeaponDirection;
}

/** p[܂cĂ邩
  */
static bool isSuperPowerReadyToShot( GPlayer* lpPlayer ) {

	if( lpPlayer->getSuperPowerType() >= 0 ) {
		// SuperPower!
		// GiW[炷
		if( lpPlayer->getWeapon()->m_Energy.step(
			lpPlayer->getWeapon()->m_Energy.m_Decreaser )) {
			// 0 ł
			// ˂Ȃ
			return false;
		}
		return true;
	}
	return true;
}

void checkAndStepCharge( GPlayer* lpPlayer) {
	if( lpPlayer->m_ChargeManager.isCharging() ){
		if( lpPlayer->m_ChargeManager.getState().isFinishAnimation == false &&
			lpPlayer->m_ChargeManager.step() ) 
		{
			// `[W
			// ->炷
			getStaticData()->m_MixerManager.play(
				SE::CHARGE_END, false );
		}

	}
}


/** U
  * 
  */
void GPlayerManager::attack( GPlayer* lpPlayer, HPLVector* lpCenter, HPLVector* lpVelocityAngle) {

	int nState = lpPlayer->getState()->getState();
	HPLSequence* lpSeq = lpPlayer->getSequence();

	// UłȂ
	bool bIsCannotAttack = false;

	if( lpPlayer->isHeld() || lpPlayer->isAlive() == false ) {
		// ߂܂Ă
		// ł

		// UłȂ
		bIsCannotAttack = true;
	} else if( lpPlayer->getState()->isDamageState() ) {
		// _[W
		// UłȂ
		bIsCannotAttack = true ;
	}

	bool aNow = lpPlayer->isPressedNow(KeyMap::A);
	// gpACȅꍇgp
	// get item type from short cut palette
	int nSelectedItemType = getStaticData()->m_ShortCutPaletteManager.getSelectedValue();//( getStaticData()->getShortCutIndex() );

	// ACe̎ʎ擾
	switch( getStaticData()->getItemClassType(nSelectedItemType) ) {	// get item class type from selected item type
	case ItemClassType::USE_ITEM:	// items for using
		if( aNow ) {
			// use it!
			lpPlayer->getItem( nSelectedItemType, 1 );
		}
		break;
	case ItemClassType::STOCK_ITEM:	// stock item
		// do nothing
		bIsCannotAttack = true;
		break;
	default:
		break;
	}

	if( false == bIsCannotAttack &&	// can attack
		!lpPlayer->getState()->isReadyToAttackState() )	// not ready to attack
	{
		// UłȂ
		bIsCannotAttack = true;
	}

	if( bIsCannotAttack ) {
		// cancel charging
		lpPlayer->m_ChargeManager.stop();
		return;
	}
	bool a = lpPlayer->isPressed(KeyMap::A);
	bool e = lpPlayer->isPressed(KeyMap::E);
	bool up = lpPlayer->isPressed( KeyMap::UP );
	bool down = lpPlayer->isPressed( KeyMap::DOWN );

//	HPLRect gameRange = staticData->getGameRange();

	int nWeaponType = lpPlayer->getWeaponType();
/*	if( lpPlayer->m_nWearState == WearStateType::NAKED ) {
		// naked

		// p`ȊOUłȂ
		if( nWeaponType != WeaponType::PUNCH ) {
			return;
		}
	}*/

	GWeapon* lpWeapon = lpPlayer->getWeapon();
	int nWeaponDirection = getWeaponDirection( lpWeapon->m_nDirectionType, up, down );
	
	switch( lpPlayer->getType() ) {
	case PlayerType::EVIGEN:
		{
			// т

			// 1񂾂Vbg
			//bool bIsOneShot = lpWeapon->getClassTypeBit( WeaponClassType::ONE_SHOT );

			// z[~O[U[
			//bool bIsLaserShot = lpWeapon->getClassTypeBit( WeaponClassType::LASER_SHOT );


			// 
			bool bIsThrow = lpWeapon->getClassTypeBit( WeaponClassType::THROW );

			// ߕK{
			bool bIsCharge = lpWeapon->getClassTypeBit( WeaponClassType::CHARGE ) || bIsThrow;

			// LȊO
			//bool bIsOtherShot = !bIsOneShot && !bIsLaserShot && !bIsCharge;

			// ςȂˌp
			//bool bIsConShot = lpWeapon->getClassTypeBit( WeaponClassType::CON_SHOT );


			if( lpPlayer->getState()->isAttackGunState() ) {
				// eł̍U[V
				this->doAttackGun( lpPlayer );

			} else if( lpPlayer->getState()->isAttackState() ) {
				// ̑̍U[V

				if( nWeaponType == WeaponType::PUNCH ) {
					// do nothing

				} else if( bIsThrow ) {
					if( a ) {
						// stop motion
						lpPlayer->getSequence()->resetCounter();

						// step charge
						checkAndStepCharge( lpPlayer );
					} else {
						if( lpPlayer->isReleasedNow( KeyMap::A ) ) {
							// 

							bool bIsShot = isSuperPowerReadyToShot( lpPlayer );
							if( bIsShot ) {
								// create pine apple
								getStaticData()->m_ShotFactory.shot( lpPlayer, nWeaponType, nWeaponDirection );
							} else {
								// TODO
								// ͂ꉹ
							}
							// Zbg
							lpPlayer->m_ChargeManager.stop();
						}
					}
				}
				
				if( lpSeq->getState().isFinishAnimation ) {
					// Aj[VI
					lpPlayer->rollBackState();
				}
			} else {
				// ̑̏ԁiˉ\ȏԁj

				this->doOther( lpPlayer, lpVelocityAngle );

				if( bIsCharge || bIsThrow ) {	// charge type weapons
					if( a ) {
						// step charge
						checkAndStepCharge( lpPlayer );
					}
				}
			}
		}
		break;
	case PlayerType::CAR:
		{
			// CAR_BALL
			if( aNow ) {
				// {[
				int nDirection = getWeaponDirection( WeaponDirType::SIX, up, down );
				getStaticData()->m_ShotFactory.shot( lpPlayer, nWeaponType, nWeaponDirection );
			}
		}
		break;
	}


}

/** eł̍U
  */
void GPlayerManager::doAttackGun( GPlayer* lpPlayer ) {
	bool a = lpPlayer->isPressed(KeyMap::A);
	bool e = lpPlayer->isPressed(KeyMap::E);
	bool up = lpPlayer->isPressed( KeyMap::UP );
	bool down = lpPlayer->isPressed( KeyMap::DOWN );
	bool aNow = lpPlayer->isPressedNow(KeyMap::A);
	bool bIsLeftOrRight = !e && (lpPlayer->isPressed( KeyMap::LEFT ) || lpPlayer->isPressed( KeyMap::RIGHT ));

	GWeapon* lpWeapon = lpPlayer->getWeapon();
	int nWeaponType = lpPlayer->getWeaponType();
	int nWeaponDirection = getWeaponDirection( lpWeapon->m_nDirectionType, up, down );

	// 
	bool bIsThrow = lpWeapon->getClassTypeBit( WeaponClassType::THROW );

	// ߕK{
	bool bIsCharge = lpWeapon->getClassTypeBit( WeaponClassType::CHARGE ) || bIsThrow;

	// 1񂾂Vbg
	bool bIsOneShot = lpWeapon->getClassTypeBit( WeaponClassType::ONE_SHOT );

	// z[~O[U[
	bool bIsLaserShot = lpWeapon->getClassTypeBit( WeaponClassType::LASER_SHOT );

	// LȊO
	bool bIsOtherShot = !bIsOneShot && !bIsLaserShot && !bIsCharge;

	// ςȂˌp
	bool bIsConShot = lpWeapon->getClassTypeBit( WeaponClassType::CON_SHOT );

	HPLSequence* lpSeq = lpPlayer->getSequence();

	if( bIsConShot || bIsLaserShot) {
		// A˃^Cv
		
		bool bIsReady = false;

		if( lpWeapon->m_bIsZeroInterval ) {
			// C^[o
			bIsReady = true;

		} else if( lpWeapon->m_ShotWaitCounter.step().isFinishAnimation ) {
			bIsReady = true;

			lpWeapon->m_ShotWaitCounter.resetCounter();
		}
		if( bIsReady ) {
			// shot

			bool bIsShot = isSuperPowerReadyToShot( lpPlayer );

			if( bIsShot ) {
				//getStaticData()->shotBullet( SHOT_TYPE_MAP[nWeaponType], lpPlayer, nWeaponDirection );
				getStaticData()->m_ShotFactory.shot( lpPlayer, nWeaponType, nWeaponDirection );
			} else {
				// ͂ꉹ
			}


		}
	}
	if( nWeaponType == WeaponType::GATLING && 
		getStaticData()->m_MixerManager.check( SE::MINIGUN_SHOT ) == 0)
		//lpSeq->getFrameIndex() == 2 && 
		//lpSeq->getStepCounter() == 0 )
	{
		// KgO
		// SE~܂Ă
		
		// ->p
		getStaticData()->m_MixerManager.play( 
			SE::MINIGUN_SHOT,
			false );
	}

	if( lpPlayer->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) {
		// ڒnĂ

		//bool bIsStopMotionOnTheGround = true;		// 󒆁ڒnōU߂

		if( bIsLaserShot && lpPlayer->m_bIsPreviousOnTheGround == false )
		{
			// ڒn

			// [U[{n

			// UfBʏ탂[Vɖ߂
			lpPlayer->rollBackState();

			return ;
		} else {

			// n

			if( bIsLeftOrRight ) {
				// Eǂ炩Ă
				lpPlayer->changeState( StateType::WALK_GUN );
			} else {
				// ǂĂȂ
				lpPlayer->changeState( StateType::ATTACK_GUN );
			}
		}
	} else {
		lpPlayer->changeState( StateType::JUMP_GUN );
	}

	if( bIsCharge ) {
		// `[W

		if( a ) {
			// 
			// s
			if( lpPlayer->m_ChargeManager.isCharging() &&
				lpPlayer->m_ChargeManager.getState().isFinishAnimation == false &&
				lpPlayer->m_ChargeManager.step() ) 
			{
				// `[W
				// ->炷
				getStaticData()->m_MixerManager.play(
					SE::CHARGE_END, false );
			}
		} else {
			// 
			if( lpPlayer->m_ChargeManager.isCharging() ) {
				if( lpPlayer->m_ChargeManager.getState().isFinishAnimation ) {
					//->
					//getStaticData()->m_MixerManager.play(
					//	SE::START_CHARGE, false );
					getStaticData()->m_ShotFactory.shot( lpPlayer, nWeaponType, nWeaponDirection );
				} else {
					// ܂`[WO
					// Zbg
					lpPlayer->rollBackState();
				}
				lpPlayer->m_ChargeManager.stop();
			}
		}
	}

	if( lpSeq->getState().isFinishAnimation ) {
		// Aj[VI

		bool bIsContinue = false;	// p

		if( bIsConShot || bIsCharge) {
			// pˉ\ȕ
			// `[W^Cv̕

			if( a ) {
				bIsContinue = true;
			} else {
			}
		}

		if( bIsLaserShot ) {
			// [U[Vbg

			HPLSequence* lpWeaponSeq = 
				lpPlayer->getWeaponSprite()->getSequence(
					lpWeapon->m_arySequenceID[nWeaponDirection],
					FaceDirection::LEFT);
			if( lpWeaponSeq->getState().isFinishAnimation == false) {
				// z[~OVbg
				bIsContinue = true;
			}
		}


		if( bIsContinue ) {
			lpSeq->resetCounter();
		} else {
			lpPlayer->rollBackState();
		}

	}
}

/** ̑́iˑÓj
  */
void GPlayerManager::doOther( GPlayer* lpPlayer, HPLVector* lpVelocityAngle ) {
	///ōU\
	//ōU\
	//WeaponɎ
	
	bool a = lpPlayer->isPressed(KeyMap::A);
	bool e = lpPlayer->isPressed(KeyMap::E);
	bool up = lpPlayer->isPressed( KeyMap::UP );
	bool down = lpPlayer->isPressed( KeyMap::DOWN );
	bool aNow = lpPlayer->isPressedNow(KeyMap::A);

	bool bIsLeftOrRight = !e && (lpPlayer->isPressed( KeyMap::LEFT ) || lpPlayer->isPressed( KeyMap::RIGHT ));


	GWeapon* lpWeapon = lpPlayer->getWeapon();
	int nWeaponType = lpPlayer->getWeaponType();
	int nWeaponDirection = getWeaponDirection( lpWeapon->m_nDirectionType, up, down );
	HPLSequence* lpSeq = lpPlayer->getSequence();

	// 1񂾂Vbg
	bool bIsOneShot = lpWeapon->getClassTypeBit( WeaponClassType::ONE_SHOT );

	// z[~O[U[
	bool bIsLaserShot = lpWeapon->getClassTypeBit( WeaponClassType::LASER_SHOT );

	// 
	bool bIsThrow = lpWeapon->getClassTypeBit( WeaponClassType::THROW );

	// ߕK{
	bool bIsCharge = lpWeapon->getClassTypeBit( WeaponClassType::CHARGE ) || bIsThrow;

	// LȊO
	bool bIsOtherShot = !bIsOneShot && !bIsLaserShot && !bIsCharge;

	// ςȂˌp
	bool bIsConShot = lpWeapon->getClassTypeBit( WeaponClassType::CON_SHOT );

	///////////////////////
	// e򂪕Kvȏe
	int nNeedAmmo = -1;
	int nNeedAmmoNum = 0;
	getNeedAmmo( nWeaponType, nNeedAmmo, nNeedAmmoNum );

	/*
	int nNeedEnergyType = -1;
	int nNeedEnergyNum = 0;
	getNeedEnergy( nWeaponType, nNeedEnergyType, nNeedEnergyNum );
	*/

	bool bIsToShot = 
		( a && bIsOtherShot ) ||
		( aNow && bIsLaserShot && lpPlayer->m_LaderSequence->getState().isFinishAnimation) ||
		( aNow && bIsOneShot ) ||
		( ( aNow ) && bIsCharge );

	int nState = lpPlayer->getState()->getState();

	// ʏ펞
	if( !bIsToShot ) {
		// ĂȂ
		switch( nWeaponType ) {
		case WeaponType::CHAIN_SAW:
			// ҋ@
			getStaticData()->m_MixerManager.play( SE::CHAIN_SAW_KEEP, true );

			// Ԋuŉo
			if( lpPlayer->m_IntervalWeaponEffectCounter.step().isFinishAnimation ) {
				lpPlayer->m_IntervalWeaponEffectCounter.reset();
				// create smoke effect
				getStaticData()->m_ObjectManager.m_EffectManager.createWeaponBackEffect(
					lpPlayer->getFaceDirection(), lpPlayer->getCenter(),
					Sequence::Effect::EXPLOSION_SMOKE );
			}
			break;
		}
	}
	if( bIsToShot && 0 <= nNeedAmmo) {
		// e򂢂n

		// ݂̏
		int nCurrentNum = getStaticData()->m_Save.getItemNum( nNeedAmmo );

		if( nCurrentNum - nNeedAmmoNum >= 0 ) {
			// ܂

			// 
			getStaticData()->m_Save.setItemNum( nNeedAmmo, nCurrentNum - nNeedAmmoNum );
		} else {
			// ȂI
			if( aNow ) {
				// sound
				getStaticData()->m_MixerManager.play( 
					SE::BUZZ,
					false );
			}
			bIsToShot = false;
		}
	}

	// Energy n
	if( bIsToShot && lpWeapon->isSuperPowerWeapon() ) {
		if( lpWeapon->m_Energy.isRemain() == false ) {
			bIsToShot = false;

			// TODO XJXJSE
		}
	}

	if( bIsToShot && lpWeapon->isSniping()) {
		// np
		if( lpPlayer->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) == false ) {
			bIsToShot = false;

			// TODO NG SE
			getStaticData()->m_MixerManager.play( 
				SE::BUZZ,
				false );
		}
	}

	if( bIsToShot ) {	// ready to shot

		if( aNow && nWeaponType == WeaponType::GATLING &&
			getStaticData()->m_MixerManager.check( SE::MINIGUN_STARTUP) == 0 )	// ĐĂȂ
		{
			// (ŏ)
			getStaticData()->m_MixerManager.play( 
				SE::MINIGUN_STARTUP,
				false );
		}
		
		
		switch( lpWeapon->m_nNextPlayerState ) {	// ̏Ԃ߂
		case StateType::ATTACK_GUN:
			{
				if( lpPlayer->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ){//lpPlayer->getState()->isFlyingState() ) {
					// nʂɂ

					if( nState == StateType::WALK || bIsLeftOrRight ) {
						// EL[Ȃ

						lpPlayer->changeState( StateType::WALK_GUN );

					} else {
						// EL[ĂȂ

						lpPlayer->changeState( StateType::ATTACK_GUN );
					}
				} else {
					// Wv
					// ->WvU[V

					lpPlayer->changeState( StateType::JUMP_GUN );
				}
			}
			break;
		case StateType::ATTACK:
			lpPlayer->changeState( StateType::ATTACK_PUNCH );

			break;
		default:
			{
				HPLError::assertIt( false,
					"unexpected state:%d", lpWeapon->m_nNextPlayerState);
			}
			break;
		}

		if( bIsLaserShot ) {
			// 
			lpPlayer->m_LaderSequence->resetCounter();

			// ړʂ0ɂ
			lpVelocityAngle->set(0,0);
			lpPlayer->setVelocityAngle( *lpVelocityAngle );

		} else if( nWeaponType == WeaponType::MISSILE_LAUNCHER ) {
			// 낯
			// vC[X݈̂ړʂ0ɂ
			lpVelocityAngle->setX(0);
			lpPlayer->setVelocityAngle( *lpVelocityAngle );

			// 
			HPLVector vCenter = lpPlayer->getCenter();
			//
			getStaticData()->m_ShotFactory.shot( lpPlayer,
				nWeaponType, nWeaponDirection );


/*				} else if( nWeaponType == WeaponType::PUNCH ) {
			// p`
			// 
			HPLVector vCenter = lpPlayer->getCenter();
			//
			getStaticData()->m_ShotFactory.shot( lpPlayer,
				nWeaponType, nWeaponDirection );*/
		} else if( bIsThrow)
		{
			// 
			// start charge
			lpPlayer->m_ChargeManager.start();

		} else if( bIsCharge ) {
			// charge shot type

			// 
			getStaticData()->m_MixerManager.play(
				SE::START_CHARGE, false );

			// start charge
			lpPlayer->m_ChargeManager.start();
		} else {
			// ̑

			// e𔭎
			getStaticData()->m_ShotFactory.shot( lpPlayer, nWeaponType, nWeaponDirection );
		}


		// Aj[VV[PXZbg
		int SEQS[] = {
			lpWeapon->m_arySequenceID[WeaponDirection::FRONT],
			lpWeapon->m_arySequenceID[WeaponDirection::FRONT_UP],
			lpWeapon->m_arySequenceID[WeaponDirection::FRONT_DOWN],
		};
		int nMax = sizeof( SEQS ) / sizeof( SEQS[0] );
		if( lpWeapon->m_nDirectionType == WeaponDirType::STATIC ) {
			nMax = 1;
		}
		for( int i = 0; i < nMax; i ++ ) {
			HPLSequence* lpWeaponSeq = lpPlayer->getWeaponSprite()->getSequence( SEQS[i], FaceDirection::LEFT );
			lpWeaponSeq->resetCounter();
		}


	} else {	// not ready to shot
		if( bIsCharge ) {	// charging
			// ˂ĂȂ

			if( a == false ) {	// not press shot key
				// charge cancel
				lpPlayer->m_ChargeManager.stop();
			}
		}
	}

}
