#include "GPlayerManager.h"

#include <hpllib/action/HPLActionMoveTool.h>

#include "GStaticData.h"

#include <hpllib/math/HPLMath.h>

using namespace std;
using namespace GEnum;

GSetting* getSetting() {
	return &getStaticData()->m_Setting;
}

float getZoom( GPlayer* player ) {
	float fZoom = 1.f;

	// 炢̈ʒuɂ
	HPLVector vUnder( player->getCenter());
	vUnder.add(0,FOOT_PLAYER );
	int nFootID = getStaticData()->getBlockID(vUnder);

	if( nFootID == 22 ) {
		// x
		fZoom = 0.2f;
	}

	return fZoom;
}


void movePlayer(GPlayer* player, HPLVector* velocityAngle,
				int direction, bool bIsX = true)
{
	float RESIST = getSetting()->resist;

	float SPEED = getSetting()->player.walkMaxSpeed;
	float ACCEL = getSetting()->player.walkAccel;

	float fSpeedZoom = getZoom( player );
	float fAccelZoom = fSpeedZoom;

	if( player->getState()->getState() == StateType::SWIM ) {
		// jł
		// ƍōxɂ
		fSpeedZoom *= 0.5f;
		fAccelZoom *= 0.1f;
	}

	bool bIsIce = false;
	// 炢̈ʒuɂ
	HPLVector vUnder( player->getCenter());
	vUnder.add(0,UNDER_PLAYER );
	int nUnderID = getStaticData()->getBlockID(vUnder);
	if( nUnderID >= 17 && nUnderID <= 20 ) {
		bIsIce = true;
		// X
		// 
		fAccelZoom *= 0.f;
	}


	if( player->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND) ) {
		SPEED *= fSpeedZoom;
		ACCEL *= fAccelZoom;

		SPEED += RESIST;
		ACCEL += RESIST;
		if( bIsIce ) {
			ACCEL *= 0.2f;
		}
	} else {

		SPEED = getSetting()->player.airMaxSpeed;
		ACCEL = getSetting()->player.airAccel;

		SPEED *= fSpeedZoom;
		ACCEL *= fAccelZoom;

		ACCEL += RESIST/2;
	}


	//////
	// /nőxς
	bool bIsAccelMove = true;
	/*if(player->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND)){
	} else if(  ){
	} else {
		bIsAccelMove = true;
	}*/

	if( bIsAccelMove ){


		if( bIsX ) {
			// 󒆂͉ړɂ
			HPLActionMoveTool::accelWithLimitX(
				velocityAngle,
				HPLVector(direction * ACCEL,0),
//				HPLVector(RESIST, 0),
				SPEED);
		} else {
			// 󒆂͉ړɂ
			HPLActionMoveTool::accelWithLimitY(
				velocityAngle,
				HPLVector(0,direction * ACCEL),
//				HPLVector(0, RESIST),
				SPEED);
		}
	} else {

		// nł͑MAXՁ[ɂȂ
		if( direction != 0 ) {
			if( bIsX ) {
				velocityAngle->setX( static_cast<float>( direction ) * SPEED);
			} else {
				velocityAngle->setY( static_cast<float>( direction ) * SPEED);
			}
		}
		
	}
}

void GPlayerManager::standToWalk(GPlayer* player, HPLVector* velocityAngle){
	// 
	int st = player->getState()->getState();


	bool right = player->isPressed(GEnum::KeyMap::RIGHT);
	bool left = player->isPressed(GEnum::KeyMap::LEFT);
	bool up = player->isPressed(GEnum::KeyMap::UP);
	bool down = player->isPressed(GEnum::KeyMap::DOWN);

	bool b = player->isPressed( KeyMap::B );
	bool e = player->isPressed( KeyMap::E );

	bool bIsWalkGun = st == StateType::WALK_GUN || st == StateType::JUMP_GUN;// || st == StateType::ATTACK_PUNCH || st == StateType::ATTACK || st == StateType::ATTACK_PINEAPPLE;

	// L[͂ɂĕς
	int faceDirection = 0;
	/*if( player->getState()->isAttackState() && !bIsWalkGun && !e ) {

		// U͍EUȂ

		// E==SL[ĂԂ͗O
	} else */
		if( (player->getState()->isAttackGunState())&&
		(player->getWeaponType() == WeaponType::HOMING_LASER || player->getWeaponType() == WeaponType::ELECTRIC_HOMING_LASER) )
	{
	} else if( st == StateType::CHECK ) {
		// check͐UԂȂ/ړȂ

	} else {
		if(right){
			faceDirection = FaceDirection::RIGHT;
		}
		if(left){
			faceDirection = FaceDirection::LEFT;
		}

	}

	{
		if(faceDirection != 0 && faceDirection != player->getFaceDirection()){
			/////
			// EL[ĕς
			// Xe[gZbg
			if(player->getState()->isAttackGunState() &&	// eUł
				false == bIsWalkGun &&								// ł͂Ȃ
				false == player->m_ChargeManager.isCharging())	// `[Wł͂Ȃ
			{
				// eU
				// ł͂Ȃ

			}
		}
		if(faceDirection != 0){
			player->setFaceDirection(faceDirection);
		}
	}

	// V[PX
	HPLSequenceState seqState = player->getSequence()->getState();

	// ڒnĂ
	bool isOnTheGround = player->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND);

	bool bIsPunch = st == StateType::ATTACK_PUNCH || st == StateType::ATTACK || st == StateType::ATTACK_PINEAPPLE;

	// Ԃ	
	bool isReadyToWalk = //player->getState()->isAttackState() == false &&
		//!bIsWalkGun &&
		st != StateType::CHECK || bIsPunch;
		//player->getState()->isDeadState();
	


	if(player->getState()->isNoPlayerControllableState(player->isAlive())){// && player->getState()->isDeadState() == false){
		// s\ȏ
		isReadyToWalk = false;
	}

	if( st == StateType::SWIM ) {
		int nUpDown = 0;
		if( up || b ) {
			nUpDown = -1;
		}
		if( down ) {
			nUpDown = 1;
		}
		if( nUpDown != 0 ) {
			movePlayer(player, velocityAngle, nUpDown, false );
		}
	}
	
	// no swim and no crouch 
	// or swim
	bool bIsNoCrouchAndWalkable = (st != StateType::SWIM && !down) || st == StateType::SWIM;

	if( player->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) {
		// nʂɂ
		if( !bIsNoCrouchAndWalkable ) {
			// Ă

			// ړłȂ
			isReadyToWalk = false;
		}

	}

	if( !e &&
		(isReadyToWalk ||
		
		player->getState()->isReadyToWalkState() ||
		st == StateType::BORING ||
		player->getState()->isFlyingState() ||
//		st == StateType::FLYUP ||
//		st == StateType::FLYDOWN ||
		st == StateType::JUMP_GUN ))
	{
		// ړ\ȃXe[g

		// Eړ
		movePlayer(player, velocityAngle, faceDirection);

		if(isOnTheGround){	// ڒn
			if(st != StateType::WALK_GUN &&		// not walking with gun
				st != StateType::WALK &&		// not walking
				(left || right) &&				// push left or right key
				bIsNoCrouchAndWalkable)			// no crouch ( walkable )
			{
				if( st != StateType::SWIM ) {	// not swim
					int nNextState = StateType::WALK;

					if( player->getPlayerClassType() == PlayerClassType::HUMAN ) {	// lԃ^Cvł
						if( st == StateType::WALK_GUN ) {
							nNextState = StateType::WALK_GUN;
						} else if( st == StateType::JUMP_GUN ) {
							nNextState = StateType::WALK_GUN;
						}
					}
					
					player->changeState( nNextState );
				}
			}
		}else{
			////
			// 
			// Ԃ͕ςȂ
			player->changeState( StateType::JUMP_GUN );
		}
	} else if(st == StateType::CROUCH || st == StateType::BORING_CROUCH) {
		// Ⴊݏ

/*		if( down == false && player->isAutoCrouch( AUTO_CROUCH_HP_THRESHOLD, GEnum::KeyMap::A) ) {
			// ĂȂႪݏ

			///////////
			// L[ȊO̍
			//		I
			movePlayer(player, velocityAngle, faceDirection);

			// ɂȂ
			player->changeState(StateType::WALK);

		}else*/
		{
			///////
			// Aj[VI痧
			if(isOnTheGround && seqState.isFinishAnimation && !down){
				player->changeState(StateType::WALK);
			}
		}
	}else if( player->getState()->isFlyingState() ){

		/////
		// łI

		movePlayer(player, velocityAngle, faceDirection);
		

	}else if(st == StateType::ATTACK_PUNCH){

		// p`U
		// ړ\
		movePlayer(player, velocityAngle, faceDirection);

	}else if(st == StateType::ATTACK_PINEAPPLE){

		// U

		if(isOnTheGround){
			/////
			// nړs
		}else{
			/////
			// 󒆈ړ\
			movePlayer(player, velocityAngle, faceDirection);
		}

	} else if( st == StateType::CHECK ) {
		if( seqState.isFinishAnimation ) {
			player->rollBackState();
		}
	} else if( st == StateType::STONE) {	// 
		if( seqState.isFinishAnimation ) {
			player->rollBackState();
		}
	}
	
	bool bIsSpecialNoBoring = player->m_nWearState == WearStateType::NAKED;
	if( !bIsSpecialNoBoring &&
		( st == StateType::STAND || player->getState()->isBoredState() || player->getState()->isAttackState() == false ) )
	{
		//  or
		// bored state or
		// UĂȂ

		// ->boredԂɂ

		// OƂāAȉ̏ꍇBORINGԂɂȂ
		//	E

		if( player->m_BoredCounter.getState().isFinishAnimation == false ) {
			if( player->m_BoredCounter.step().isFinishAnimation ) {
				int nNextState = StateType::BORING;

				if( st == StateType::BORING ) {
					// BORING
					// Q
					nNextState = StateType::BORING_CROUCH;
				} else {
					// xJEgJn
					player->m_BoredCounter.reset();
				}
					
				// get bored
				player->changeState( nNextState );

				if( nNextState == StateType::BORING_CROUCH ) {
					// ˂
					if( 0 == getStaticData()->m_Game.m_Reminder.getNoCheck( ReminderType::REST_COUNT ) ) {
						// Cxg
//						getStaticData()->startEvent(6, false);
						getStaticData()->m_Game.m_Reminder.setNoCheck( ReminderType::REST_COUNT, 1 );
					}
				}
			}
		}
	} else {	// ̑̍s(AԁcȂ)
		//if( player->getState()->isBoredState() == false ){	// bored stateł͂Ȃ
		// 2012/01/23 Ԃɂ炸Zbgie~܂遨ƂĂԂZbgĂȂ̂Cj
		// Zbg
		player->m_BoredCounter.reset();
		//}
	}

	// O
	getStaticData()->m_ObjectManager.moveObjectForce( player );

	// level
	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	// Q]蒆̗͑͂񕜂
	if( st == StateType::BORING_CROUCH ) {	// QĂ
		// /frame
		float fCureAtBoring = 0.5f / fLevel;
		// add cure
		player->setHP( player->getHP() + fCureAtBoring );
	}

	if( player->getSuperPowerType() == SuperPowerType::WIND_WIZARD ) {
		// Ă邾ŏ
		bool bIsZero = player->getWeapon()->m_Energy.step( player->getWeapon()->m_Energy.m_ConstantDecreaser );
	}

	//	if( player->getState()->isReadyToWalkState() && player->getState()->isAttackState() == false  ) {
//		if( player->isPressedNow( KeyMap::UP ) ) {
//			player->changeState( StateType::CHECK ) ;

			// GtFNg
			// TODO eXgőSޔ
/*			HPLVector vEffectCenter = player->getCenter();
			vEffectCenter.add( EMOTION_ICON_DELTA_X, EMOTION_ICON_DELTA_Y );

			int nEIType = Sequence::Effect::EI_HATENA + HPLMath::nextInt(0,4 );
			GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
				nEIType, vEffectCenter );*/

//		}
//	}
	/*else if(player->getState()->isAttackGunState()){
		int wtype = player->getUsingWeaponTypeIndex();*/

/*		if(wtype == WeaponType::SemiAutoColt){
			if(isOnTheGround){
				//////
				// 
				//movePlayer(player, velocityAngle, faceDirection);
				// ?
				if(faceDirection != 0){
					player->changeState(StateType::WALK);
				}
			}else {
				flyMovePlayer(player, velocityAngle, faceDirection);
			}
		}else */
		/*if(true){//player->isUsingHeavyWeapon()){
			if(isOnTheGround){
				/////
				// nړs
			}else{
				/////
				// 󒆈ړ\(ƂĂȂ)
				flyMovePlayer(player, velocityAngle, faceDirection);
			}
		}else{
			if(isOnTheGround){
				/////
				// nړs
			}else{
				/////
				// 󒆈ړ\
				flyMovePlayer(player, velocityAngle, faceDirection);
			}
		}*/
	//}
	/*else if(st == StateType::LYING || st == StateType::BORN){

		////
		// |Ă
		if(player->isBaby()){
			player->setBaby(false);
		}else{
			//  CROUCHԁiŁǍAƁBj
			player->changeState(StateType::CROUCH);
		}

	}*/
}

void GPlayerManager::jump(GPlayer* player, HPLVector* velocityAngle){

	int jumpMaxNum = 2;

	HPLVector vUnder( player->getCenter());
	vUnder.add(0,FOOT_PLAYER );
	int nFootID = getStaticData()->getBlockID(vUnder);

	if( nFootID == 22 ) {
		// Wv1񂾂
		jumpMaxNum = 1;
	}

	/*if(player->getType() == PlayerType::Trellama){
		jumpMaxNum = 3;
	}*/
	player->getJumpManager()->setJumpNumMax(jumpMaxNum);

	int st = player->getState()->getState();

	///////
	// XL[ŃWv
	bool sp = false;

	/*////
	// p`ApCibvA邢́AdΊȊỎΊgp̓Wv\
	*/
	if(st == StateType::ATTACK_PUNCH || st == StateType::ATTACK_PINEAPPLE ||
		st == StateType::WALK_GUN || st == StateType::ATTACK_GUN ||
		st == StateType::JUMP_GUN)
	{
	
		sp = true;
	}

	int wtype = player->getUsingWeaponTypeIndex();

	bool isStateTypeOK = (sp ||
		st == StateType::STAND || 
		st == StateType::BORING ||
		st == StateType::WALK ||
		st == StateType::WALK_READY ||
//		st == StateType::FLYDOWN ||
//		st == StateType::FLYUP ||
//		st == StateType::FLYUP_3 ||
//		st == StateType::FLYUP_2 ||
		player->getState()->isFlyingState() ||
		st == StateType::CROUCH ||
		st == StateType::BORING_CROUCH);

	bool isJumpableOK = (player->getJumpManager()->isJumpable() ||
		getStaticData()->m_Game.isCheat());

	int nJumpKey = KeyMap::B;
	//bool isPressedJumpKey = player->isPressedNow(nJumpKey);

	
	//////
	// never jump when tank
	if( isStateTypeOK && 
		isJumpableOK )
	{
		// Wv\

		bool bIsFirstSpeed = false;
		if( player->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) {
			// n
			
			if( player->isPressedNow( nJumpKey ) ) {
				bIsFirstSpeed = true;
			}
		} else {
			// 󒆂ɂ

			if( player->isPressedNow( nJumpKey ) ) {
				bIsFirstSpeed = true;
			} else {
				if( player->m_bIsJumpAccellerable ) {
					// \
					if( player->isPressed( nJumpKey ) ) {
						HPLVector accel( 0, - getStaticData()->m_Setting.player.jumpAccel );
						velocityAngle->add( accel );

						if( velocityAngle->getY() < - getStaticData()->m_Setting.player.jumpSpeed ) {
							// ōxɓB
							// ->Wvs\ɐ؂ւ
							player->m_bIsJumpAccellerable = false;
						}
					}else{
						// WvL[ĂȂ

						// ->Wvs\ɐ؂ւ
						player->m_bIsJumpAccellerable = false;

					}

				}
			}
			
		}

		if( bIsFirstSpeed ) {
			this->playerJump(player, velocityAngle);

		}
	}

}

void GPlayerManager::playerJump(GPlayer* player, HPLVector* velocityAngle){
	float JUMP_VELOCITY = getSetting()->player.jumpSpeed;

	HPLVector vUnder( player->getCenter());
	vUnder.add(0,FOOT_PLAYER );
	int nFootID = getStaticData()->getBlockID(vUnder);

	if( nFootID == 22 ) {
		// FWv͌
		JUMP_VELOCITY *= 1.f;
	}

	int nNextState = StateType::FLYUP;

	// 󒆃WvH
	bool bIsAirJump = !player->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND );

	// x
	if( player->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND )) {
		// nŃWv
		JUMP_VELOCITY *= JUMP_FIRST_SPEED_RATE;
	} else {
		
		// 
		// 󒆂ƁAɍōxɒBĂ邽߁Aʏ̑xᑫȂ
		//JUMP_VELOCITY *= JUMP_FIRST_SPEED_RATE;
		// do nothing


		if( player->getJumpManager()->getJumpNumMax() < 2 ) {
			// OFWv̂
			JUMP_VELOCITY *= JUMP_FIRST_SPEED_RATE;
		}

		// 2iWv
		//if( HPLMath::nextFloat(0,100) < PLAYER_ANOTHER_DOUBLE_JUMP_PROBABILITY ) {
		//	if( HPLMath::nextFloat(0,100) < PLAYER_ROLLING_DOUBLE_JUMP_PROBABILITY ) {
				nNextState = StateType::FLYUP_3;	// ]
		//	} else {
		//		nNextState = StateType::FLYUP_2;
		//	}
		//}
	}

	if( player->getState()->isAttackGunState() ) {	// gun state
		nNextState = StateType::JUMP_GUN;	// change forcely to jump gun
	}
	//
	
	velocityAngle->setY(-JUMP_VELOCITY);

	if(getStaticData()->m_Game.isCheat() == false){
		// `[gԂł͂Ȃ

		// Wv񐔂炷
		player->getJumpManager()->jump();
	}

	// 󒆏
	player->getTrigger()->setTrigger( TriggerType::ON_THE_GROUND, false );

	// WvAbv
	player->changeState(nNextState);

	// ANZOK
	player->m_bIsJumpAccellerable = true;

	// jump se
	getStaticData()->m_MixerManager.play(
		SE::JUMP, false );
	if( bIsAirJump ) {
		// 󒆃Wv

		HPLRect rHitArea = player->getHitArea();
		
		// GtFNg
		HPLVector vCenter(player->getCenter().getX(), rHitArea.getBottom() );
		getStaticData()->createEffect( 
			Sequence::Effect::JUMP_EFFECT, vCenter,vCenter, -1, -1 );
	}
}

void GPlayerManager::walkToStand(GPlayer* player, HPLVector* velocityAngle){
	//////////////////
	// sړL[bƎ~܂


	bool right = player->isPressed(GEnum::KeyMap::RIGHT);
	bool left = player->isPressed(GEnum::KeyMap::LEFT);

	int st = player->getState()->getState();
	if(
		right == false &&
		left == false)
	{

		/*if(player->isAutoCrouch(AUTO_CROUCH_HP_THRESHOLD, GEnum::KeyMap::A)){
			/////
			// _[WԂƂႪ
			player->changeState(StateType::CROUCH);
		}else
		*/
		int nNextState = -1;
		if( (st == StateType::WALK ||
		st == StateType::WALK_READY ||
		st == StateType::STAND) )
		{
			nNextState = StateType::STAND;
		} else if( st == StateType::WALK_GUN ||
			st == StateType::ATTACK_GUN ) 
		{
			nNextState = StateType::ATTACK_GUN;
		}
		if( nNextState >= 0 ) {
			player->changeState(nNextState);
		}
	}

	//
	////////////

}

void GPlayerManager::crouch(GPlayer* player, HPLVector* velocityAngle){
	int st = player->getState()->getState();

	bool down = player->isPressed(GEnum::KeyMap::DOWN);
	///////////
	// ACtc30%ȉȂ荞
	/*if((st == StateType::STAND || st == StateType::BORING)&& player->isAutoCrouch(AUTO_CROUCH_HP_THRESHOLD, GEnum::KeyMap::A)){
			player->changeState(StateType::CROUCH);
	}else 
	*/
	if((st == StateType::STAND ||
		st == StateType::BORING ||
		st == StateType::WALK) &&

		down)
	{
		////////
		// L[łႪ

		if( player->isRiding() ) {
			// Ă
			// ->~

			// player change
			player->dropOff();
		} else {
			// crouch
			player->changeState(StateType::CROUCH);
		}

	}else{
		HPLSequence* seq = player->getSequence();

		if( //player->isAutoCrouch(AUTO_CROUCH_HP_THRESHOLD, GEnum::KeyMap::A) == false &&
			(st == StateType::CROUCH || st == StateType::BORING_CROUCH) &&
			seq->getState().isFinishAnimation &&
			down == false )
		{
			//////
			// ႪݏԂŉL[𗣂
			// @オ
			player->changeState(StateType::STAND);
		}
	}
}

/*static bool isHittable( GPlayer* lpPlayer, float* lpfSpeed, float* lpfDamage ) {
	if( lpPlayer->getType() == PlayerType::PESERU ) {
		if( lpPlayer->getState()->getState() == StateType::ATTACK_2 ) {
			// XCfBO
			*lpfSpeed = PESERU_SLIDING_BLOW_SPEED;
			*lpfDamage = PESERU_SLIDING_DAMAGE;

			return true;
		}

	} else if( lpPlayer->getType() == PlayerType::DURANDANA ) {

		if( lpPlayer->getState()->getState() == StateType::ATTACK_GUN ) {
			// Oh^Cp[
			*lpfSpeed = DURANDANA_GRAND_TIPER_BLOW_SPEED;
			*lpfDamage = DURANDANA_GRAND_TIPER_DAMAGE;

			return true;

		} else if( lpPlayer->getState()->getState() == StateType::ATTACK_2 ) {
			// KATANA
			*lpfSpeed = DURANDANA_ATTACK_2_BLOW_SPEED;
			*lpfDamage = DURANDANA_ATTACK_2_DAMAGE;

			return true;

		}
	} 
	return false;
}

bool GPlayerManager::checkHitToOnePlayer( GPlayer* lpPlayer, GPlayer* lpTargetPlayer ) {
	if( this->isSkipToSearch( lpPlayer, lpTargetPlayer ) ) {
		return false;
	}

	// qbgΏ
	bool bIsHittable = false;


	float fSpeed = 0;
	float fDamage = 0;
	float fDummy = 0;
	if( isHittable( lpPlayer, &fSpeed, &fDamage ) ) {

		if( getStaticData()->isHit( lpPlayer, lpTargetPlayer ) == false ) {

			// ̈悪ԂĂȂ
			return false;
		}

		// GtFNg
		GEffect* lpEffect = getStaticData()->createEffect(
			Sequence::Effect::HIT,
			lpPlayer->getCenter(),
			lpTargetPlayer->getCenter(), 0, -1 );
		if( isHittable( lpTargetPlayer, &fDummy, &fDummy ) ) {
			// ł
			// ݂ɐ

			// т̑x́A_[WʂɂȂ
			getStaticData()->blowAway( lpPlayer, lpTargetPlayer, TWO_PLAYER_BOTH_BLOW_AWAY_SPEED );
			getStaticData()->blowAway( lpTargetPlayer, lpPlayer, TWO_PLAYER_BOTH_BLOW_AWAY_SPEED );

			// _[W
			getStaticData()->changeState( lpPlayer, StateType::DAMAGE );
			getStaticData()->changeState( lpTargetPlayer, StateType::DAMAGE );


		} else {
			// qbg
			getStaticData()->hitToPlayer( lpPlayer, lpTargetPlayer, fSpeed, fDamage );

		}
		return true;
	}

	return false;
}

void GPlayerManager::checkHitToPlayer( GPlayer* lpPlayer) {

	for( int i = 0; i < PLAYER_MAX_NUM; i ++ ) {
		this->checkHitToOnePlayer( lpPlayer, &getStaticData()->m_ObjectManager.m_aryPlayerList[i] );
	}

	for( list<GPlayer*>::iterator it = getStaticData()->m_ObjectManager.m_EnemyManager.getList()->begin();
		it != getStaticData()->m_ObjectManager.m_EnemyManager.getList()->end();
		it ++ )
	{
		this->checkHitToOnePlayer( lpPlayer, *it );
	}
}

*/