#include "GPlayerManager.h"

#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/action/HPLCollisionCheckTool.h>
#include <hpllib/system/HPLFile.h>
#include <hpllib/general/HPLString.h>
#include <hpllib/math/HPLMath.h>

#include "GStaticData.h"

using namespace std;
using namespace GEnum;

GPlayerManager::GPlayerManager(){
	// ݒǂݍ
/*	vector<string> vList = HPLFile::loadStringLinesFromFile("data/image/Player/SettingList.txt",
		TRUE);
	for( vector<string>::const_iterator cit = vList.begin();
		cit != vList.end();
		cit ++ ) 
	{
		// <ID>;<t@CpX>
		vector<string> vItems = HPLString::split( *cit, ";" );
		HPLError::assertIt( vItems.size() == 2 ,
			"vC[ݒ胊Xg̏G[[%s]", cit->c_str());

		GPlayerSetting playerSetting;
		playerSetting.load( vItems[1].c_str());
		this->m_mapPlayerSettingMap[ atoi(vItems[0].c_str())] = playerSetting;
	}*/
}
GPlayerManager::~GPlayerManager(){
}


/**
	ړ֘Ȁ
	EPlayerInputւ̐U蕪B
	ERIۂ̏
*/
void GPlayerManager::move(GPlayer* player, HPLVector* velocityAngle){
	HPLVector center = player->getCenter();
//	GPlayerState* state = player->getState();

//	xɂړ
//		float ACCEL = 0.07f;

	if(player->getState()->getState() == StateType::DISAPPEAR){
		return;
	}

	bool down = player->isPressed(GEnum::KeyMap::DOWN);
	////////////////
	// ^NԂŉL[ƍ~
/*	if((player->getType() == PlayerType::Tank
			|| player->getType() == PlayerType::Robogen)
		&& down){

		// ~
		player->takeOut();
	}*/


	HPLMatrix<int>* matrix = getStaticData()->getBlockManager()->getBlockMatrix();

	int tileSize = getStaticData()->m_Setting.tileSize;

	// Ë
	HPLRect limitArea(0,0,
		(float)(matrix->getColumnSize() * tileSize),
		(float)(matrix->getRowSize() * tileSize));
		
	////////////
	// E͈͂͒Ȃ悤ɂ
	// 
	/*if(player->getCenter().getX() < limitArea.getX()){
		player->setCenter(limitArea.getX(), player->getCenter().getY());
	}else if(player->getCenter().getX() > limitArea.getRight()){
		player->setCenter(limitArea.getRight(), player->getCenter().getY());
	}*/

	// c
	//if(player->getCenter().getY() < limitArea.getY()){
	//	player->setCenter(player->getCenter().getX(), limitArea.getY());
	//}

	bool bIsDead = false;
	// ʊO֏o
	if( player->getHitArea().getY() > getStaticData()->getLimitUnder()) {//limitArea.getBottom() + EVIGEN_LIMIT_AREA_UNDER_BOTTOM_MERGINE ) {//limitArea.isShare( player->getHitArea() ) == false) {
		// over bottom limit

		// dead!
		bIsDead = true;

		if( player->isAlive() ) {	// alive in previous frame
			// se
			getStaticData()->m_MixerManager.play( SE::FALL_DEATH, false );
		}
	}

	if( getStaticData()->getMapType() == MapType::FORCE_SCROLL_X ||
		getStaticData()->getMapType() == MapType::FORCE_SCROLL_X_FASTER
		)	// scroll map(x)
	{
		// XN[
		//HPLRect rMerginedRange = getStaticData()->getMerginedGameRange();
		HPLRect rGameRange = getStaticData()->getGameRange();

		HPLRect rHitArea = player->getHitArea();

		if( rHitArea.getX() < rGameRange.getX() ) {
			// XN[ōʊOɏo
			// ->Eɉ
			// left~center̋
			HPLVector vCenter = player->getCenter();
			float fLeftToCenterLength = vCenter.getX() - rHitArea.getX();
			vCenter.setX( rGameRange.getX() + fLeftToCenterLength );

			// setting
			player->setCenter( vCenter );

			if( player->isAlive() && player->getTrigger()->getTrigger( TriggerType::HIT_TO_THE_RIGHT ) ) {
				// Ă
				// EԂĂ
				// 
				player->damage( player->getHPMax(), NULL, true, StateType::DEAD );

				// SASE
				getStaticData()->m_MixerManager.play( SE::FALL_DEATH, false );
			}
		}
		/*if( false == rMerginedRange.isShare( player->getHitArea() ) ) {
			bIsDead = true;

		}*/
	} else {	// normal map
		// ʏ펞
		// ->^C̈̍E[ŌvZ
		HPLRect rHitArea = player->getHitArea();

		if( rHitArea.getX() < limitArea.getX() ) {
			// [z
			// ->[ɖ߂
			HPLVector vCenter = player->getCenter();
			float fLeftToCenterLength = vCenter.getX() - rHitArea.getX();
			vCenter.setX( limitArea.getX() + fLeftToCenterLength );

			// setting
			player->setCenter( vCenter );
		}
		if( rHitArea.getRight() > limitArea.getRight() ) {
			// E[z
			// ->E[ɖ߂
			HPLVector vCenter = player->getCenter();
			float fRightToCenterLength = rHitArea.getRight() - vCenter.getX();
			vCenter.setX( limitArea.getRight() - fRightToCenterLength );

			// setting
			player->setCenter( vCenter );
		}
	}
	if( bIsDead ) {	// dead

		//player->setCenter(player->getCenter().getX(), limitArea.getBottom());

		// hp 0
		player->setHP(0);

		// die
		player->die(NULL);//setAlive(false);

		// ړȂ
		// no movement op.
		return ;
	}
	/////////////


	// ԑJ
	int st = player->getState()->getState();

	// Aj[V
	HPLSequenceState seqState = player->getSequence()->getState();

	///////
	// Gԓ
	if(player->isInvinsible()){
		player->invinsibleProcess();
	}

	// is punch state
	bool bIsPunch = st == StateType::ATTACK_PUNCH || st == StateType::ATTACK || st == StateType::ATTACK_PINEAPPLE;

	// is on the ground
	bool bIsOnTheGround = player->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND );

	// is walking or jumping attack state
	bool bIsMovableAttack = st == StateType::WALK_GUN || st == StateType::JUMP_GUN || st == StateType::ATTACK_GUN ||
		(!bIsOnTheGround && bIsPunch );

	if(player->isAlive() == true){	// alive

		if(player->isBind()){	// be bound
			////////////
			// oCh
//			doBind(player);

			// do nothing
		}else{	// not be bound
			if(player->isHeld() == true){	// be hold
				/*********
					z[hĂԂ́A
					EEړ
					EWv
					EႪ
					EU

					oȂBAoK`ł̃_[W͓Gɗ^
				*/
				HPLSequence* seq = player->getSequence();
				HPLSequenceState seqState = seq->getState();

				if(seqState.isFinishAnimation == true){
					// [v
					HPLSequence* seq = player->getSequence();
					seq->resetCounter();
				}
			}else{	// not be hold
				////////////////////////////////////////////////////
				if(getStaticData()->m_Game.isGameOver() ||
					player->getState()->isDamageState() ||
					player->getWeapon()->isSniping() ||
					( player->getState()->isAttackState() && !bIsMovableAttack  ))
				{
					// łȂ
					// EQ[I[o[
					// E_[W
					// EXiCsO
					// EU
				}else{
					//  ̑Jځi΁j
					this->standToWalk(player, velocityAngle);

					//////
					// ߂Ƀq[Ԃ̃AfZ/łԂ̂Ƃ܂ꍇ񕜂
/*					float HEAL_AIBO = 0.3f;
					if(player->isIMAibo() == false &&
						player->isWithAibo() && player->aibo != NULL){
						
						float dx = player->getCenter().getX() - player->aibo->getCenter().getX();
						float dy = player->getCenter().getY() - player->aibo->getCenter().getY();
						HPLVector dir(dx,dy);

						float HEAL_THRESHOLD = 200.f;

						if(dir.getLength() < HEAL_THRESHOLD){
							if(player->aibo->isHeal()){
									/////
									//
								player->setHP(player->getHP() + HEAL_AIBO);

								getStaticData()->getScore()->addFloatScore(
									FloatScore::HEAL_OTHER,
									HEAL_AIBO);
								
							}else if(player->isHeal()){
								player->aibo->setHP(player->getHP() + HEAL_AIBO);
							}
						}
					}*/
				}

				if( player->getState()->isDamageState() ||		// damage 
					( player->getState()->isAttackState() &&	// or attack state
					!bIsMovableAttack ) ||						//		and not movable state
					player->getWeapon()->isSniping() ||			// or sniping
					player->getState()->isNoPlayerControllableState(player->isAlive()) )	// or not controllable
				{
					// 
					// Wv/ړ/Ⴊ݂oȂ

				} else {	// normal state

					//  ̑Jځi΁j
					this->walkToStand(player, velocityAngle);

					if(getStaticData()->m_Game.isGameOver()){	// game over
						// no controllable
					}else{	// not game over

						// jump op.
						jump(player, velocityAngle);

						// crouch op.
						crouch(player, velocityAngle);
					}
				}


				////////
				// ŏu(Af̂)
/*				if(player->getType() == PlayerType::Undelsen){
					player->processMabataki();
				}*/

				// animation sequence
				HPLSequence* seq = player->getSequence();
				// animation seq. state
				HPLSequenceState seqState = seq->getState();

				///////////////////////
				if(player->getState()->isDamageState()){	// _[W[VI
					
					if(seqState.isFinishAnimation == true	// finish damage animation
						//||
	//					player->isErogenDamage()
							)
					{
						if(player->isHeld()){	// ߂܂Ă
							// do nothing

						} /*else if( player->m_DamageRecoveryCounter.getState().isFinishAnimation == false ) {
							// _[W[VJE^܂IĂȂ
							// s
							player->m_DamageRecoveryCounter.step();
							player->getSequence()->resetCounter();

						}*/ else {	// ߂܂ĂȂ

							//player->changeState(StateType::STAND);
							// ʏԂɖ߂
							player->rollBackState();

							//player->setErogenDamage(false);
						}
					}
				}
				if( st == StateType::CAKE ) {	// cake is you
					if( seqState.isFinishAnimation ) {	// finish animation
						// roll back to normal state
						player->rollBackState();
					}
				}
			}
			//////
			// ŏԂ̂Ƃ
			// EŃ}[N\
			// EmŃ_[W󂯂
/*			if(player->isPoison() ) {// || player->isErogen()){
				//doPosion(player, player->isErogen());
				// damage
				if( player->getPoisonIntervalCounter()->step().isFinishAnimation ) {
					player->damage( POISON_DAMAGE, NULL, false, StateType::DAMAGE );
					player->getPoisonIntervalCounter()->reset();
				}
				// step poison
				player->getPoisonCounter()->step();
			}
			*/

			int nStatus = player->getStatus();
			if( StatusType::NONE != nStatus) {
				// Ԃł

				// ->i߂
				if( player->stepStatus() ) {
					// interval}

					player->setHP( player->getHP() );
					if( player->getHP() <= 0 ) {
						// die
						player->die(NULL );
					} else {
						switch( nStatus ) {
						case StatusType::POISON:
							// ɉȂ
							break;
						case StatusType::EROS:
							// DAMAGEԂɂȂ
							player->changeState( StateType::DAMAGE );
							break;
						}
					}
				}
			}

			//
			///////



		}
	}else{// if(player->isAlive() == false)	// player is dead

		///////
		// ^ʂɍ킹āAĂ悤ɂ
		if(player->getVelocityAngle().getX() > 0){
			player->setFaceDirection(FaceDirection::RIGHT);
		}else if(player->getVelocityAngle().getX() < 0){
			
			player->setFaceDirection(FaceDirection::LEFT);
		}	// ړĂȂƂ͕ςȂ

		// 
		if( st == StateType::CHONPA_STAND ) {	// chonpa stand
			if( seqState.isFinishAnimation ) {	// finish animation
				player->changeState( StateType::CHONPA_FALL );	// set next state chonpa-fall
			}
		} else if( st == StateType::CHONPA_FALL ) {	// chonpa fall
			if( seqState.isFinishAnimation ) {		// finish animation
				player->changeState( StateType::CHONPA_DEAD );	// set next state chonpa-dead

				// TODO se:fallen body
			}
		} 
	}
	//
	//////
}

void GPlayerManager::collisionCheck(GPlayer* player, HPLVector* center, HPLVector* velocityAngle){

	if(player->isHeld()){	// be held
		return;
	}
	if( player->getState()->getState() == StateType::DISAPPEAR ||	// disappear
		player->getState()->getState() == StateType::BROKEN )		// broken
	{
		// no collision check needed
		return;
	}

	// level
	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	// player's AREA
	HPLRect area = player->getArea();

	// vC[̓蔻
	HPLRect hitArea = player->getHitArea();
//	BBPlayerState* state = player->getState();

	// O̐ڒn
	// or landing on the object
	player->m_bIsPreviousOnTheGround = player->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ||
		player->m_bIsLandOnObject;

	///////
	// ՓˑȎxL
	HPLVector prevVelocityAngle = *velocityAngle;//HPLVector(velocityAngle->getX(), velocityAngle->getY());

	// default resist
	float fResist = getStaticData()->m_Setting.resist;

	if( player->getState()->isDamageState() ||	// damage state
		player->getState()->isDeadState() )		// dead state
	{
		// less resist
		fResist *= 0.2f;
	}

	////////////////////// X
	if( player->m_bIsPreviousOnTheGround ) {	// previous is on the ground

		//////// vC[̉̕mF
		// under point
		HPLVector vUnder( player->getCenter());
		vUnder.add(0,UNDER_PLAYER );
		// get block id
		int nUnderID = getStaticData()->getBlockID(vUnder);
		if( nUnderID >= 17 && nUnderID <= 20 ) {	// X
			// CRႭ
			fResist *= 0.1f;
			
			if( player->getState()->getState() == StateType::WALK ) {	// walk state
				// Aj[V1F
				// 傱傱ɂ
				player->getSequence()->step();
			}
		}
	}

	// (player's) gravity
	float fGravity = getStaticData()->m_Setting.gravity + PLAYER_GRAVITY_DELTA;

	if( player->getState()->getState() == StateType::SWIM ) {	// swim state
		// jł

		// d͔
		fGravity *= IN_WATER_GRAVITY_RATE;

	} else {	// not swim state

		// ˒͈ꎞIɏd͂ȂȂ
		if( player->getWeapon()->getType() == WeaponType::HOMING_LASER ||		// homing laser
			player->getWeapon()->getType() == WeaponType::ELECTRIC_HOMING_LASER	// electric homing laser
			)
		{
			if( player->getState()->isAttackGunState() ) {	// attack gun state
				// make gravity smaller
				fGravity *= HOVER_WEAPON_GRAVITY_RATE;
			}
		} 
	}

	/////////////
	// common collision check and adjustment

	//CollisionState states[2];

	CollisionState stateX;	// left/right
	CollisionState stateY;	// top/bottom
	
	HPLCollisionTool::commonCollision(
		dynamic_cast<HPLShootingObject*>( player ),//this->getArea(), this->getHitRect(),
//		&center, &vel, width, height,
		getStaticData()->getBlockManager()->getBlockMatrix(), 
		getStaticData()->m_Setting.tileSize,
		getStaticData()->getBlockManager()->getBlockMap(),
//		this->getTrigger(),
		stateX,	stateY,
		fGravity ,
		fResist,
		getStaticData()->m_Setting.fallMaxSpeed,
		true,	// isMove
		true,	// isFall
		player->m_bIsLandOnObject,		// force on the ground
		true
		);

	if( player->m_bIsLandOnObject ) {	// ɏĂ

		// IɒnԂɂ
		player->getTrigger()->setTrigger( TriggerType::ON_THE_GROUND, true ) ;
	}

	if( player->m_bIsLandOnObject &&			// on the object
		stateY.isHitY == HitDirectionY::TOP )	// hit to the celling
	{
		// get damage
		// and get player lying forcely
		getStaticData()->damageObject( player, NULL, BLOCK_BITE_DAMAGE * fLevel, false, StateType::LYING );
	}

	///////////// ubN
	{
		// tile type
//		int nTileType = -1;

		// head tile id
		int nHeadTileID = 0;

		// foot tile id
		int nFootTileID = 0;

		// center position
		HPLVector vCen = player->getCenter();

		// get head and foot tile type
		getStaticData()->m_ObjectManager.getTileType( 
			vCen.getX(), vCen.getY(), player->m_nTileType, nHeadTileID, nFootTileID );


		if( TileType::ON_THE_WATER == player->m_nTileType ||	// on the water
			TileType::SWIM == player->m_nTileType )			// in the water
		{
			// /̏ǂ炩B
			// ->_[Wt̂ȂIɃ_[W^


			// water damage (select bigger damage whether foot or head!)
			int nDamage = max( getStaticData()->m_ObjectManager.getWaterDamage( nFootTileID ),
				getStaticData()->m_ObjectManager.getWaterDamage( nHeadTileID ) );
			bool bIsStopDamageWater = false;

			if( nDamage > 0 ) {	// damage water!
				if( player->m_DamageWaterInterval.isAlive() ) {
					// is
					if( player->m_DamageWaterInterval.step().isFinishAnimation ) {
						// 

						// _[W

						// ̃_[WXe[g
						int nNextDamageState = StateType::DAMAGE;

						// _[W
						player->damage( (float)nDamage, NULL, false, nNextDamageState ) ;
						player->m_DamageWaterInterval.reset();
					}
				} else {
					// JnĂȂ
					// ->Jn

					player->m_DamageWaterInterval.reset();
				}
			} else {
				player->m_DamageWaterInterval.end();
			}
			///////////
			// Ń_[W󂯂ĂAAj[VIƋɑo悤ɖ߂
			if( player->getState()->isDamageState() &&		// damage state
				player->getSequence()->getState().isFinishAnimation )	// end sequence
			{
				// reset 
				player->changeState( StateType::SWIM );
			}
		} else {
			// t̊֘Ał͂Ȃ

			if( player->m_DamageWaterInterval.isAlive() ) {
				// Ă
				// ->Ƃ߂
				player->m_DamageWaterInterval.end();
			}
		}
/*		const int CHECK_BLOCK_STEP = TILE_SIZE;
		int dy = 0;
		while( true ) {
			int nOldY = dy;


			int dx = 0;
			while( true ) {
				int nOldX = dx;

				// mF
				int nTileID = getStaticData()->getBlockManager()->getBlockMatrix()->get(
					(hitArea.getX() + dx) / TILE_SIZE,
					(hitArea.getY() + dy) / TILE_SIZE);
				if( nTileID >= 0 ) {
					if( nTileID == 15 || nTileID == 16 ) {
						if( nTileType == TileType::NOSPECIAL ) {
							// ʏ
							nTileType = TileType::ON_THE_WATER;
						} else {
							nTileType = TileType::SWIM;
						}
						break;
					} else {
						if( getStaticData()->getBlockManager()->getBlockMap()->find(nTileID)->second->getBlockType() == BlockType::EMPTY ||
							getStaticData()->getBlockManager()->getBlockMap()->find(nTileID)->second->getBlockType() == BlockType::EMPTY_DRAW_FRONT)
						{
							// 
							if( nTileType == TileType::SWIM || nTileType == TileType::ON_THE_WATER ){
								// do nothing
							} else {
								nTileType = TileType::NOSPECIAL;
							}

						} else {
							// do nothing
						}
					}
				} else {
					// do nothing
				}

				dx += CHECK_BLOCK_STEP;

				if( nOldX >= hitArea.getWidth() - 1 ) {
					// ɉ߂Ă
					// I
					break;
				} else if( dx >= hitArea.getWidth() ) {
					dx = hitArea.getWidth() - 1;
				}

			}

			if( nTileType >= 0 ) {
				break;
			}
			dy += CHECK_BLOCK_STEP;
			if( nOldY >= hitArea.getHeight() - 1 ) {
				// ɉ߂Ă
				// I
				break;
			} else if( dy >= hitArea.getHeight() ) {
				dy = hitArea.getHeight() - 1;
			}
		}*/

		bool bIsGoSwin = false;

		int nJumpKey = KeyMap::UP;


		if( player->m_nTileType == TileType::ON_THE_WATER ) {
			// 

			// WvŔ
			if( player->isPressed( nJumpKey ) ) {
				float JUMP_VELOCITY = getStaticData()->m_Setting.player.jumpSpeed;

				velocityAngle->setY(-JUMP_VELOCITY * JUMP_FIRST_SPEED_RATE );
				player->setVelocityAngle( *velocityAngle );
				player->changeState( StateType::FLYUP );

				//this->playerJump(player, velocityAngle );
			} else if( player->getState()->getState() != StateType::SWIM ) {
				bIsGoSwin = true;
			}
		} else if( player->m_nTileType == TileType::SWIM) {
			if( player->isAlive() == false ) {
				// ł
				// オ
				const float PLAYER_DIE_FLOW_UP_IN_THE_WATER = 2;
				const float GRAVITY = getStaticData()->m_Setting.gravity;
				velocityAngle->setY( - PLAYER_DIE_FLOW_UP_IN_THE_WATER - GRAVITY );
				player->setVelocityAngle( *velocityAngle );
			} else {
				if( player->getState()->getState() != StateType::SWIM ) {
					// jȊO
					bIsGoSwin = true;
				}
			}
		} else {
			if( player->getState()->getState() == StateType::SWIM ) {
				player->rollBackState();
			}
		}
		// env type
		int nEnvType = -1;
		if( bIsGoSwin ) {	// touch the water

			switch( player->getState()->getState() ) {	// state
			case StateType::STAND:		// stand
			case StateType::WALK:		// walk
			case StateType::FLYDOWN:	// flydown
			case StateType::FLYUP:		// flyup
				player->changeState( StateType::SWIM ) ;
				break;
			}
			HPLVector vel = player->getVelocityAngle();
			vel.setY(vel.getY() / IN_WATER_RESIST_RATE);
			player->setVelocityAngle( vel );

			// env type is "SWIM"
			nEnvType = EnvType::SWIM;

		} else {	// not touch water

			// env type is normal
			nEnvType = EnvType::NORMAL;
		}
		if( nEnvType >= 0 ) {	// env type is set
			// set environment type
			player->setEnvType( nEnvType );
		}
	}

	int st = player->getState()->getState();
	////////
	// _[W[V
	bool isDamageMotion = 
		player->getState()->isDamageState();

	//////
	// gKɂ铮
	HPLTrigger* trigger = player->getTrigger();


	///////
	//
	if(trigger->getTrigger(TriggerType::HIT_TO_THE_LEFT) ||
		trigger->getTrigger(TriggerType::HIT_TO_THE_RIGHT)){
		///////
		// ɃubNɂԂ
		//  _[WF͂˂
		//  ʏ펞FƂ܂(ʏ~܂)

		if(isDamageMotion){
			/////
			// _[W
			float a = -1 * HPLMath::getSgn(prevVelocityAngle.getX());
/*			if(trigger->getTrigger(TriggerType::HIT_TO_THE_LEFT)){
				a = 1;
			}*/
			HPLVector vel = player->getVelocityAngle();
			vel.setX(
				a * 
				getStaticData()->m_Setting.wallBoundRefrection *
				fabs(prevVelocityAngle.getX()));

			/*if(prevVelocityAngle.getX() < getStaticData()->m_Setting.player.airMaxSpeed / 2){
				/////
				// 蓖
				vel.set(0,0);
			}*/
			player->setVelocityAngle(vel);
		}else{
			HPLVector vel = player->getVelocityAngle();
			vel.setX(0);
			player->setVelocityAngle(vel);
		}

	}

	//////
	// c


	float FLYDOWN_SPEED_THRESHOLD = getStaticData()->m_Setting.flydownSpeedThreshold;
/*	if(player->getType() == PlayerType::Robogen){
		FLYDOWN_SPEED_THRESHOLD /= 2.f;
	}*/

	if(player->isHeld()){

	}else{
/*		if(player->getType() == PlayerType::Durandana &&
			player->getSwordType() == SwordType::Katana &&
			st == StateType::ATTACK_4){

				// f_iĂBڒn͖Ȃ
				// ł
				const float KATANA_RESIST_RATE = 4;
				float RESIST = getStaticData()->m_Setting.resist;
				// 
				float x = HPLActionMoveTool::reduceSpeed(RESIST * KATANA_RESIST_RATE, velocityAngle->getX());
				velocityAngle->setX(x);
		}*/
		if(trigger->getTrigger(TriggerType::ON_THE_GROUND)){
			//////
			// ڒn

			if(player->isAlive()){
				/////
				// Ă
				if( st == StateType::SWIM ) {
					// j
					// do nothing
				} else {

					// ̑
					if( player->getState()->isFlyingState() 
						)
					{
						// ł

						if(st != StateType::BORING){
							// ɂĂȂ

							
							// Ԃɂ
							player->changeState(StateType::STAND);

							// ɃZbg
							player->m_BoredCounter.reset();


						}
					}

					if(st == StateType::DAMAGE_FLYDOWN ||
						st == StateType::DAMAGE_FLYDOWN_REVERSE)
					{
						// _[Wnʂɂʏ헧
						//player->changeState(StateType::STAND);

						// ł͂ȂA|ԂɂB
						player->changeState(StateType::LYING);

						if( WearStateType::NAKED == player->m_nWearState ) {
							if( 0 == getStaticData()->m_Game.m_Reminder.getNoCheck( ReminderType::NAKED_COUNT ) ) {
								// ͂߂ĂNAKED
								getStaticData()->startEvent(13, false);
								getStaticData()->m_Game.m_Reminder.setNoCheck( ReminderType::NAKED_COUNT, 1 );
							}
						}
					}


				}
				// Wv񐔂Zbg
				player->getJumpManager()->resetJumpNumMax();

				// WvOFFɂ
				player->m_bIsJumpAccellerable = false;

			}else if( false == player->getState()->isSpecialState() &&
				player->getState()->isDamageState() == false)
			{// && player->isDamageMotion() == false){
				/////
				// ł
				player->changeState(StateType::DEAD);
			}
		}else{
			////////
			// 󒆂ɋ
			//////
			// nʂɂĔэ~肽ƂAWv񐔂񌸂炷
			if(//player->getVelocityAngle().getY() >= 0 &&
				player->m_bIsPreviousOnTheGround 
				//&& 
				//!player->isPressed(GEnum::KeyMap::B)
				)
			{
				if( player->getJumpManager()->isJumpable() ) {
					player->getJumpManager()->jump();
					player->getJumpManager()->setJumpNumMax(1);
				}

			}

			if(player->isAlive() == false &&	// not alive
				false == player->getState()->isSpecialState() &&	// not special state
				player->isHeld() == false &&	// not held
				st != StateType::SWIM )			// not swim
			{
				// S

				//&&player->isDamageMotion() == false){
				////////////
				// łc
				// @x̕ŏԂς

				// xȏɂȂ牺~[VɈڂ
				if(velocityAngle->getY() >= FLYDOWN_SPEED_THRESHOLD && st != StateType::DEAD_FLYDOWN){

					player->changeState(StateType::DEAD_FLYDOWN);

				}else if(velocityAngle->getY() < FLYDOWN_SPEED_THRESHOLD &&

					st != StateType::DEAD_FLYUP)
				{
	//					if(velocityAngle->getY() < 0 && ){
					player->changeState(StateType::DEAD_FLYUP);
				}
			}else{
				// ̑

				if(st != StateType::DAMAGE_ELEC &&
					player->getState()->isDamageState())
				{
					/////
					// dC_[W

						if(player->isHeld() == false)
						{
							/////////
							// _[W󒆂ɂꍇÂƂ
							getStaticData()->setDamageFlyingState(player);
						}

				}else if( st == StateType::SWIM ) {
					// Wv񐔂1ɂ
					player->getJumpManager()->setJumpNumMax(1);
					player->getJumpManager()->resetJumpNumMax();

				} else{
					/////
					// ʏ펞
					if(player->isHeld() == false &&	// not held
						(st == StateType::STAND ||	// stand
						st == StateType::WALK ||	// walk
						st == StateType::CROUCH ||	// crouch
						st == StateType::BORING_CROUCH ||	// boring crouch
						( player->getState()->isFlyingState() && false == player->getState()->isAttackGunState() )
						// flyinf state and not gun state
						) && player->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND) == false 
						)
					{
						// 󒆂Œʏ

						if( st == StateType::FLYUP_2 || st == StateType::FLYUP_3) {
							// Wv͊iDςȂ
						} else {
							if(velocityAngle->getY() >= FLYDOWN_SPEED_THRESHOLD){
								// ~臒lɓB

								if(st != StateType::FLYDOWN){
 									player->changeState(StateType::FLYDOWN);
								}
							}else if(
								st != StateType::FLYUP){
								player->changeState(StateType::FLYUP);
							}
						}
					}


				}
			}
		}
	}

}


