#include "GStaticData.h"

#include <hpllib/general/HPLString.h>

#include "GEnum.h"

#include <vector>
#include <string>
using namespace std;

using namespace GEnum;
using namespace ScenarioItemConsts;

/** TALKnCxg̏
  */
void GStaticData::doTalkEventPack( HPLScenarioItem* item, int nEventStepType, bool bIsEndByPlayerDeath ) {

	if( item->getMessageList()->size() <= 0 ) {	// no messages in talk event
		bool bIsEnd = this->m_lpEventPack->next();
		//HPLError::msg("warning", MB_OK, "no message found in talk event");
		LOG_WARN( HPLString::chrToStr( "no message found in talk event[ID:%d]",
			this->m_lpEventPack->getType()).c_str());
		return;
	}
	/////
	// G\
	{
		/////
		// left
		if(item->getLeftStand()->sequence >= 0){
//					this->drawStand(FaceDirection::LEFT,
//						item->getLeftStand()->sequence);
		}

		if(item->getRightStand()->sequence >= 0){
//					this->drawStand(FaceDirection::RIGHT,
//						item->getRightStand()->sequence);
		}
	}


	// Ӄt[
	this->drawTalkFrame(true, 0);
	
	// 䎌ʒu
	std::map<int,int> left;
	left[ScenarioType::TALK] = 10;
	left[ScenarioType::EMOTION] = 150;
	left[ScenarioType::SELECT] = 50;
	
	// ŏ̈sāAȃR}h܂ނ`FbN
	vector<string> vecList = 
		HPLString::split(item->getMessageList()->at(0), SpecialScenarioType::SPECIAL_SEPARATOR);
	string str = vecList[0];

	// bZ[WXg
	vector<string>* lpVecMessageList = item->getMessageList();

	vector<string> vecReplaceMessages;

	this->m_nSpecialItemType = SpecialScenarioType::NONE;
	for( int i = 0; i < SpecialScenarioType::MAX_NUM; i ++ ) {
		// 
		if( str.compare(SpecialScenarioType::SPECIAL_SCENARIO_TYPE_LABEL[i] ) == 0 ) {
			// XyVȏw񂪗
			bool bIsStartSpecial = false;	// XyVȏs邩H
			switch( i ) {
			case SpecialScenarioType::GET_ITEM:
				if( this->m_TakarabakoInfo.m_nItemType >= 0 ) {
					// 󔠐ݒĂ
					// ->ViIłiݒ肪ꍇ͂ɓȂj
					bIsStartSpecial = true;
				}
				break;
			default:
				bIsStartSpecial = true;
				break;
			}
			if( bIsStartSpecial ) {
				this->m_nSpecialItemType = i;
				break;
			}
		}
	}

	if( this->m_nSpecialItemType != SpecialScenarioType::NONE ) {
		// ꓮ̑O
		this->doSpecialEventBefore( this->m_nSpecialItemType,
			&lpVecMessageList, vecReplaceMessages, item );
	}

	if( item->getType() == ScenarioType::SELECT ) {
		// ZNg^Cv

		// JڐƃbZ[WЂ؂
		this->m_vecSelectScenarioIndex.clear();
		for( int i = 0; i < item->getMessageListSize(); i ++ ) {
			vector<string> vecItems = HPLString::split( item->getMessage(i ), ":" );

			this->m_vecSelectScenarioIndex.push_back( atoi(vecItems[0].c_str() ) );
			vecReplaceMessages.push_back( vecItems[1] );
		}
		lpVecMessageList = &vecReplaceMessages;
	}

	//item->getMessageList()->at[0].find();

	int r = 255, g = 255, b = 255;
	int fontID = 0;
	int stepY = 20;
	int maxLines = 5;
	float fScreenRate = this->m_Setting.windowHeight / 480.f;
	int msgTop = static_cast<int>( 360.f * fScreenRate );
	int maxCharLengthPerLine = static_cast<int>( 70 * fScreenRate );
	/////////////////////////////////////////////////////////////////////////
	// bZ[W\
	this->m_Basic.m_Graphics.drawTalkMessage(
		r, g, b, *lpVecMessageList,
		stepY, left[item->getType()],
		msgTop, maxCharLengthPerLine );
	/////////////////////////////////////////////////////////////////////////

	// ㏈
	this->doSpecialEventAfter( this->m_nSpecialItemType );

	/*this->getSDLKanjiManager()->drawTalkMessage(r, g, b, fontID, item->getMessageList(),
											(float)stepY, maxLines,
											left[item->getType()],
											msgTop,
											maxCharLengthPerLine,
											getGraphics()->getScreen());	*/


	switch( item->getType() ) {
	case ScenarioType::EMOTION:

		// G[V
		this->drawEmotionIcon( 
			(int)(10 * fScreenRate), 
			(int)(msgTop + 5),
			item->getEmotionSequence(), item->getEmotionIndex(),
			128,128 );
		break;
	case ScenarioType::SELECT:
		{
			HPLSequence* lpCursorSeq = getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::CURSOR );
			// J[\\
			this->m_Basic.m_Graphics.draw(
				SELECT_CURSOR_LEFT,
				SELECT_CURSOR_TOP + this->m_nSelectIndex * stepY ,
				lpCursorSeq );
			
			if( false == this->m_Game.isTheWorld() ) {
				lpCursorSeq->step();
			}

			// L[
			{
				int nDY = 0;
				if( this->getInputManager()->isPressedNow( KeyMap::UP ) ) {
					nDY = -1;
				}
				if( this->getInputManager()->isPressedNow( KeyMap::DOWN ) ) {
					nDY = 1;
				}
				if( nDY != 0 ) {
					this->m_nSelectIndex += nDY;
					if( this->m_nSelectIndex < 0 ) {
						this->m_nSelectIndex = (int)this->m_vecSelectScenarioIndex.size() - 1;
					}
					if( this->m_nSelectIndex >= (int)this->m_vecSelectScenarioIndex.size() ) {
						this->m_nSelectIndex = 0;
					}
				}
			}
		}
		break;

	}

	if( false == this->m_lpEventPack->isLast() ) {
		// ܂

		// ̃V[PX
		HPLSequence* lpNextSeq = this->getSequence( SpriteType::COMMON, Sequence::Common::TALK_NEXT);

		// TalkNext(Op`)\
		this->m_Basic.m_Graphics.draw(
			(int)( this->m_Setting.windowWidth - 50.f ),
			(int)( this->m_Setting.windowHeight - 50.f ),
			lpNextSeq );

		if( false == this->m_Game.isTheWorld() ) {
			// the worldł͂Ȃ
			// ->Aj[V
			lpNextSeq->step();
		}
	}

	//
	switch( nEventStepType ) {
	case EventStepType::DEFAULT:
		{
			this->doEventSkip(getStaticData()->getInputManager()->isPressedNow( KeyMap::A ),
				CheckHitKey( KEY_INPUT_LCONTROL ) || CheckHitKey( KEY_INPUT_RCONTROL ),
				bIsEndByPlayerDeath);
			//CheckHitKey( KEY_INPUT_LCONTROL ) ) ||
			//	(bIsSkippable && CheckHitKey( KEY_INPUT_RCONTROL ) ) )
		}
		break;
	
	}



}



/** XLbvi邩Ȃj̏
  * @param[in,out]	item
  * @param[in]		bIsNextKeyPressNow	֐iރL[
  * @retval	true	XLbv
  */
bool GStaticData::doEventSkip( bool bIsNextKeyPressNow, bool bIsSkipKeyPress,
		bool bIsEndByPlayerDeath  )
{
 	HPLScenarioItem* item = this->m_lpEventPack->get();
	if(item == NULL || this->m_lpEventPack->isActive() == false || false == this->m_EventFadeCounter.getState().isFinishAnimation )
	{
		return false;
	}
	if( item->getType() == ScenarioType::SE && item->getSEWaitCounter()->isAlive() ) {
		return false;
	}

	// CtrlL[ŃXLbvł
	bool bIsSkippable = item->getType() != ScenarioType::SELECT;

	bool bIsStep = false;
	
	if(bIsNextKeyPressNow || //getInputManager()->isPressedNow(GEnum::KeyMap::A) || 
		(bIsSkippable && bIsSkipKeyPress ) )
	//CheckHitKey( KEY_INPUT_LCONTROL ) ) ||
	//	(bIsSkippable && CheckHitKey( KEY_INPUT_RCONTROL ) ) )
	{
		// L[or Ctrl
		// ->
		// (CtrlXLbvSelectȊOŗL)

		bIsStep = true;
		
		if(item->getType() == ScenarioItemConsts::ScenarioType::SELECT){
			/////
			// select̂ݓ
			// Cxg
			this->startEvent( this->m_vecSelectScenarioIndex[this->m_nSelectIndex], true );
		}else {
			// ̑bEBhE
			switch( this->m_nSpecialItemType ) {
			case SpecialScenarioType::GET_ITEM:	//! ACe擾
				{
					// ACeǉ
					this->m_ObjectManager.m_Player.getItem( this->m_TakarabakoInfo.m_nItemType,
						this->m_TakarabakoInfo.m_nItemNum );

					// 󔠁uvCxgɋϊ
					if( this->m_TakarabakoInfo.m_nNextEvent >= 0 ) {
						this->startEvent( this->m_TakarabakoInfo.m_nNextEvent, true );
						//bIsEnd = true;
					} else {
						//I
						this->endScenario();
						//bIsEnd = true;
					}

					// 󔠏񃊃Zbg
					//this->m_TakarabakoInfo.reset();

				}
				break;
				
			default:

				// ֐i߂
				bool bIsEnd = this->m_lpEventPack->next();

				if( bIsEnd == false && this->m_TakarabakoInfo.m_nItemNum >= 0 ) {
					// ̃bZ[WŌ

					switch( getStaticData()->getItemClassType( this->m_TakarabakoInfo.m_nItemNum ) ) {
					case ItemClassType::WEAPON:	// E
						{

							this->checkAndStartEvent(FlagType::ONE_TALK, OneTalkType::WEAPON_PALETTE ,
								SpecialScenarioIndex::WEAPON_PALETTE_EXPLAIN );
						}
						break;
					case ItemClassType::STOCK_ITEM:	// XgbNACeE
						{
							// ߂ăQbg炵ׂ邹
							int PATTERNS[][3] = {
								{ Sequence::Item::MISSILE, OneTalkType::MISSILE, SpecialScenarioIndex::MISSILE_EXPLAIN },
								{ Sequence::Item::BATTERY, OneTalkType::BATTERY, SpecialScenarioIndex::BATTERY_EXPLAIN },
							};

							for( int p = 0; p < SIZEOF( PATTERNS ); p ++ ) {
								if( PATTERNS[p][0] == this->m_TakarabakoInfo.m_nItemType ) {
									int nFlag = getStaticData()->m_Save.getFlag(
										GEnum::FlagType::ONE_TALK );
									if( HPLMath::getFlagByIndexInt( nFlag, PATTERNS[p][1] )) {

										this->m_Save.setFlagBit( 
											GEnum::FlagType::ONE_TALK,
											PATTERNS[p][1] , true );

										// Jn
										this->startEvent( PATTERNS[p][2], false );
									}
								}
							}
						}
						break;
					}

				}


				if( bIsEnd == false && this->m_SceneManager.getSceneType() == SceneType::GAME &&
					this->m_EventPackManager.getCurrentEventIndex() == 
					SpecialScenarioIndex::CHONPA_TANSU)
				{
					// σCxg
					
					this->m_ObjectManager.m_Player.die( NULL );
					// 
					//this->m_ObjectManager.m_Player.changeState( StateType::CHONPA_STAND );
					this->m_ObjectManager.m_Player.dieNoHead();

					// vC[ʂ̂ŁACxg~
				}
			} // switch nSpecialScenarioType
		} // if SELECT
	}// now pressed a

	if( bIsEndByPlayerDeath && this->m_ObjectManager.m_Player.isAlive() == false ) {
		// ł遨I
		this->endScenario();
	}
	return bIsStep;
}

