#ifndef _G_SAVE_
#define _G_SAVE_

#include <vector>
#include <string>
#include <map>

#include "GEnum.h"
#include <hpllib/system/HPLError.h>

/* PlaceƓȂ̂ŎgpȂ?
namespace StarStateType {
	enum {
		COMPLETED,
		CLEARED,
		REVEALED,
		SEALED,
	};
}
*/

class GBoxFlag {
private:
	// map<ObjectType,vector<Type>>
	std::map<int,std::vector<int> > m_mapFlags;
//	int m_aryItemFlag[GEnum::Sequence::Item::MAX_NUM];
//	int m_aryEnemyFlag[GEnum::EnemyType::MAX_NUM];
public:
	GBoxFlag();
	/**
	  */
	bool isFlag( int nObjectType, int nType, int nFlagIndex );
	/**
	  */
	void setFlag( int nObjectType, int nType, int nFlagIndex, bool bIsOn );
	
	void fill( int nData );
	void clearAndFill( int nObjectType, int nMaxNum, int nData );
	void clear();
	std::vector<int>& getFlags( int nObjectType );
};

/** o^łZ[uf[^
  */
class GSave {
private:
	long m_lScore;
	std::vector< std::vector<int> > 	m_vecPlaceState;	//! ePlacei
	int m_aryFlags[GEnum::MAX_FLAGS];							//! tOǗ
	int 	m_aryItemNum[ GEnum::Sequence::Item::MAX_NUM ];		//! ACȅ
//	int		m_aryShortCuts[ GEnum::MAX_SHORTCUT_NUM ];		//! V[gJbgB
														//! IDItemԍ

	// map<NeutralType(box type), box*>
	std::map<int, GBoxFlag*> m_mapBoxFlags;

	// rbǵAItemTypeXgŎw肵Ō̃p[^
	
	std::string	m_strFilePath;		//! ۑpX
//	long	m_lPlayTime;			//! vC
public:
	long getScore() {	return this->m_lScore;	}
	/** 
	  */
	bool setScore( long lScore );
	bool addScore( long lScore );

	GBoxFlag* getBoxFlag( int nNeutralType ) {
		HPLError::assertIt( this->m_mapBoxFlags.find(nNeutralType) != this->m_mapBoxFlags.end(),
			"%s:%s(%d):Invalid Neutral Type[%d]", __FILE__,__FUNCTION__,__LINE__,nNeutralType );
		return this->m_mapBoxFlags[nNeutralType];
	}
	int		m_aryStarState[GEnum::StageType::MAX_NUM];					//! ̐i
	int		m_aryWeaponState[ GEnum::WeaponType::MAX_WEAPON_NUM ];		//! 
	int		m_arySuperPower[GEnum::SuperPowerType::MAX_NUM];			//! SuperPower

	std::string m_strComment;								//! Rg
	

	//Constructor
public:
	GSave();
	virtual ~GSave();

private:
	/**
	  * @retval		-1		݂ȂStar
	  * @retval		-2		݂ȂPlace
	  */
	int checkPlaceNum( int nStar, int nPlace );

	// Getter/Setter
public:
/*	int getShortCut( int nIndex ) {
		return this->m_aryShortCuts[nIndex];
	}*/
	/** V[gJbgݒ
	  * @param[in]	nIndex	V[gJbgCfbNX
	  * @param[in]	nItemType	Sequence::ItemBj[pɐ񂵂ł͂Ȃ
	  */
/*	void setShortCut( int nIndex, int nItemType ) {
		this->m_aryShortCuts[nIndex] = nItemType;
	}*/
	/** ICfbNXACeԍ擾
	  */
	int getItemNum( int nIndex ) {
		if( nIndex < 0 || nIndex >= GEnum::Sequence::Item::MAX_NUM ) {
			return -1;
		}
		return this->m_aryItemNum[nIndex];
	}
	/**
	  * @retval		l	ŏIIɐݒ肳ꂽli0艺ɂȂꍇ̏CȂǁj
	  */
	int setItemNum( int nIndex, int nNum );

	/**
	  * @param[in]		nIndex
	  * @param[out]		nFlag
	  * @retval	0					
	  * @retval 0ȊO				ُ
	  */
	//int getFlag( int nIndex, int& nFlag );
	//int setFlag( int nIndex, int nFlag );
	int getFlag( int nIndex ) {
		return this->m_aryFlags[nIndex];
	}
	bool getFlagBit( int nIndex, int nBitIndex );
	void setFlag( int nIndex, int nFlag );
	void setFlagBit( int nIndex, int nBitIndex, bool bFlag );

	/** w肵ɂPlace̐
	  */
	int getStarPlaceNum( int nStar );
	/**
	  * @retval		-1		݂ȂStar
	  * @retval		-2		݂ȂPlace
	  */
	int getPlaceState( int nStar, int nPlace );

	/** }bvCfbNXPlaceToďԂ擾
	  */
	int getPlaceState( int nMapIndex);

	/**
	  */
	void setPlaceState( int nStar, int nPlace, int nState );

	// Operations
public:

	/**
	  * @retval	0		
	  * @retval 1		I[vs
	  */
	int save();
	/**
	  * f[^s͌xoāA
	  * @retval 0		
	  * @retval 1		I[vs
	  */
	int load(const char* lpFilePath);
	void setAsDefault();

	/** V[gJbgpbg̈ԍŏ擾
	  * @retval	-1		V[gJbgpbgɂ͉o^ĂȂ
	  * @retval 0ȏ	݂V[gJbgCfbNX
	  */
//	int getFirstShortCutIndex();

	/** w肵ꏊ̃V[gJbg擾
	  * @param[in]	nIndex	݂̃V[gJbgCfbNXB
	  * 					V[gJbg݂Ȃꍇ́A̔ԍ̂܂܋A
	  * 					-1w肷ƁAԍŏ̃V[gJbgIB݂Ȃꍇ-1Ԃ
	  * @retval		-1		̃V[gJbg񂪑݂ȂiTCY0A܂̓V[gJbgS-1j
	  * @retval		0ȏ	-1ȊO̒lz̃CfbNXiV[gJbgCfbNXj
	  */
//	int getNextShortCutIndex(int nIndex );

};

#endif
