#include "GSelectPlayer.h"

#include "GStaticData.h"

using namespace std;
using namespace GEnum;

GSelectPlayer::GSelectPlayer() : HPLShootingObject(0){
	this->m_bIsStay = true;
	this->m_nGoalIndex = 0;
	this->m_nSequenceID = Sequence::Common::SELECT_MINI_EVIGEN;

}

GSelectPlayer::~GSelectPlayer(){
}

void GSelectPlayer::draw() {
	int nID = Sequence::Common::SELECT_MINI_EVIGEN;	// V[PXID

	int nFaceDirection = FaceDirection::LEFT;

	if( this->m_bIsStay ) {
		// ~
		// do nothing
	} else {
		// ړ

		const float DEGREE_THRESHOLD = 40;
		const float FULL_CIRCLE_DEGREE = 360;
		float fDegree = (float)( (int)(this->getVelocityAngle().getDegree() + FULL_CIRCLE_DEGREE) % (int)FULL_CIRCLE_DEGREE ); 

		bool bIsRight = false;
		if( fDegree <= DEGREE_THRESHOLD ) {
			// right
			bIsRight = true;
		} else if( fDegree <= FULL_CIRCLE_DEGREE / 2 - DEGREE_THRESHOLD ) {
			// down
			// do nothing

		} else if( fDegree <= FULL_CIRCLE_DEGREE / 2 + DEGREE_THRESHOLD ) {
			// left
			nID = Sequence::Common::SELECT_MINI_EVIGEN_LEFT;
		} else if( fDegree <= FULL_CIRCLE_DEGREE - DEGREE_THRESHOLD ) {
			// up
			nID = Sequence::Common::SELECT_MINI_EVIGEN_BACK;
		} else {
			// right
			bIsRight = true;
		}
		if( bIsRight ) {
			nFaceDirection = FaceDirection::RIGHT;
			nID = Sequence::Common::SELECT_MINI_EVIGEN_LEFT;
		}
	}
	HPLSequence* lpSeq = getStaticData()->getSequence(
		SpriteType::COMMON, nID );

	float fHeight = lpSeq->getImageInformation(0)->srcRect.getHeight();

	getStaticData()->m_Basic.m_Graphics.draw(
		(int)this->getCenter().getX(), (int)this->getCenter().getY() - fHeight / 2,
		lpSeq, nFaceDirection, 0, 1 );

	lpSeq->step();
}
