#include "GSetting.h"

#include <hpllib/general/HPLString.h>
#include <hpllib/system/HPLFile.h>

int GMapSetting::getMapIndexFromStarAndPlace( int nStar, int nPlace ) {
#ifdef _DEBUG 
	ASSERT_IT_INDEX(nStar, 0, this->stageList.size() );
	ASSERT_IT_INDEX(nPlace, 0, this->stageList[nStar].size() );
//	HPLError::assertIt( nStar >= 0 && nStar < (int)this->stageList.size() &&
//		nPlace >= 0 && nPlace < (int)this->stageList[nStar].size() );
#endif
	return this->stageList[nStar][nPlace];
}

int GMapSetting::getStarAndPlaceFromMapIndex( int nMapIndex, int& nStar, int& nPlace ) {
	for( int star = 0; star < (int)this->stageList.size(); star ++ ) {
		for( int place = 0; place < (int)this->stageList[star].size(); place ++ ) {
			if( this->stageList[star][place] == nMapIndex ) {
				nStar = star;
				nPlace = place;
				return 0;
			}
		}
	}
	return -1;
}

GSetting::GSetting(){
	HPLProperties* prop = new HPLProperties();
	//////////////////////////////////////////////////
	// {
	prop->loadFromTextFile("data/General.txt");

	setHPLSetting(prop);

	delete prop;

	//////////////////////////////////////////////////
	// vC[ݒ
	prop = new HPLProperties();
	prop->loadFromTextFile("data/PlayerSetting.txt");
	player.walkMaxSpeed = prop->getFloat("WALK_MAX_SPEED");
	player.walkAccel = prop->getFloat("WALK_ACCEL");
	player.airMaxSpeed = prop->getFloat("AIR_MAX_SPEED");
	player.airAccel = prop->getFloat("AIR_ACCEL");
	player.jumpSpeed = prop->getFloat("JUMP_SPEED");
	player.jumpAccel = prop->getFloat("JUMP_ACCEL");
	delete prop;

	///////////////////////////
	// }bv

	prop = new HPLProperties();

	prop->loadFromTextFile("data/maps/MapSetting.txt");

	maps.stageLine = prop->getInt("STAGE_LINE");


	for(int i = 0; i < maps.stageLine; i ++){
		std::vector<int> lst;
		prop->getIntList(
			HPLString::chrToStr("STAGE0%d", i).c_str(),
			&lst, ",");
		maps.addStages(lst);
	}

	delete prop;

	// 
	std::vector<std::string> lines = HPLFile::loadStringLinesFromFile("data/maps/MapDescription.txt");
	for(int i = 0; i < (int)lines.size(); i ++)
	{
		if(HPLFile::isCommentLine(&lines[i]))
		{
			continue;
		}

		this->maps.stageDescriptionList.push_back(lines[i]);
	}

	// b
	this->zHitRange = 25.f;
	this->recognizeThreshold = 200.f;
	this->koguDeltaX = 16.f;

	////
	// \ȃACe
	// ͖
/*	maxItemNum[ItemType::MineralElement] = 50;
	maxItemNum[ItemType::EvilElement] = 10;
	maxItemNum[ItemType::Coin] = -1;
	maxItemNum[ItemType::EviFly] = -1;*/

}

GSetting::~GSetting(){
}
