#ifndef _G_SHOT_
#define _G_SHOT_

#include <hpllib/object/HPLShootingObject.h>
#include <hpllib/game/block/HPLBlock.h>
#include <hpllib/math/HPLMatrix.h>
#include <hpllib/general/HPLDamageTypeManager.h>

namespace GEnum {
	static const int RUNNER_BOLT_SPEED = 12;
}

namespace HomingType {
	enum {
		NONE,
		MISSILE,	//! ~TCiȈՁj
		BEZIE,		//! xWFz[~O
		STOP_MISSILE,	//! ~
	};
}

/** xWFz[~OɕKvȏ(VOg)
  */
class HomingInformation {
public:

	HomingInformation() {

	}
	void getControlPoints( HPLVector vFrom, HPLVector vTo,
		HPLVector* lpvControlUP, HPLVector* lpvControlDW);
	
private:
	HPLVector getControlPoint( HPLVector& vFrom, HPLVector& vTo,
											 float fControlU, 
											 float fControlImageRate );
};


static const int HOMING_TAIL_MAX = 40;

/********************************************
  * 
  */
class HomingData {
public:
	
	bool m_bIsStartExists;	//! 擪݂邩
	float m_fU;
	float m_fR;			//! px
	int m_nCounter;		//! Ȑp
	int m_nDivNum;		//! Ȑp
	int m_nTail;		//! 
	int m_nTailCount;	//! JE^
	HPLCounter m_ForceDeadCounter;	//! 폜JE^

	HPLVector m_aryControl[4];	//! _
	HPLVector m_vErase;
//	int m_aryTime[HOMING_TAIL_MAX];
//	int m_nStopTime;

	float m_fXZ;
	float m_fYZ;

	
	HPLVector m_aryTailCenters[HOMING_TAIL_MAX];		//! ۍW
	float m_aryTailRs[HOMING_TAIL_MAX];					//! ۊpx

	HPLVector m_vRD;
	HPLVector m_vLD;

	HomingData() {
		m_fU = 0;
		m_fR = 0;
		m_nCounter = 0;
		m_nDivNum = 30;
		m_nTailCount = 0;
		this->m_bIsStartExists = true;
		const int HOMING_DEFAULT_DEAD_COUNT = 100;
		m_ForceDeadCounter.setWaitFrameNum( HOMING_DEFAULT_DEAD_COUNT );
	}
	void set( HPLVector& vFrom, HPLVector& vTo,
		HPLVector& vControlUp, HPLVector& vControlDW)
	{
		this->m_aryControl[0] = vFrom;
		this->m_aryControl[1] = vControlDW;
		this->m_aryControl[2] = vControlUp;
		this->m_aryControl[3] = vTo;


		this->m_vLD.set(vFrom.getX() + 12, vFrom.getY() );
		this->m_vRD.set(vFrom.getX() - 12, vFrom.getY() );

		for( int i = 0; i < HOMING_TAIL_MAX; i ++ ) {
			this->m_aryTailCenters[i] = vFrom;
			this->m_aryTailRs[i] = 0;
		}
	}

};


/*** **************************************************************
  *  VbgIuWFNg
  */
class GShot : public HPLShootingObject {
public:
	HPLDamageTypeManager m_DamageType;	//! _[W^Cv
	HPLDamageTypeManager m_Weakness;	//! _
	HPLDamageTypeManager m_Immunities;	//! ϐFĂKvΐݒ肵Ȃ
										//iOFnɂ̓qbg邪AEXӊOł͔jłȂj
private:
	int m_nPoint;	//! Q[|Cg
//	HPLCounter* m_lpIntervalCounter;	//! Ԋuŏ邽߂

	int		m_nHitToSolidType;		//! qbgɑΏۂł܂
	int		m_nDirection;			//! 
	float	m_fRotateSpeed;			//! ]Xs[h(deg)
	int		m_nParentWeaponType;	//! ˌ̕
	//int		m_nDamageType;			//! G/vC[ɗ^_[W^Cv
	int		m_nForceType;			//! 
	HPLCounter* m_lpPuyoPuyoCounter;	//! ՂՂJE^[

	bool	m_bIsClip;				//! Ђ
	HPLCounter* m_lpClipCounter;	//! ӂقǂJE^
	int		m_nShotClassType;		//! NX
	int m_nSolidType;
	float m_fReduceAccel;
	bool m_bIsUseReduceAccel;		//! ʓrݒ肵ReduceAccelgǂ

//	HPLVector	m_vGoal;			//! ߂ꂽS[
	
	// Getter/Setter
public:
	void setReduceAccel(float fAccel ) {
		this->m_bIsUseReduceAccel = true;
		this->m_fReduceAccel = fAccel;
	}
	bool isUseReduceAccel() {
		return this->m_bIsUseReduceAccel;
	}
	float getReduceAccel( ) {
		return this->m_fReduceAccel;
	}
	int getPoint() { return this->m_nPoint;}
	void setPoint( int nPoint ) {	this->m_nPoint = nPoint;	}
//	void getGoal( HPLVector& v ) {	v = this->m_vGoal;	}
//	void setGoal( HPLVector& v ) {	this->m_vGoal = v;	}
	int getSolidType() {
		return this->m_nSolidType;
	}
	void setSolidType( int nSolidType ) {
		this->m_nSolidType = nSolidType;
	}
private:

	void setShotClassType( int nClassType ) {		this->m_nShotClassType = nClassType;	}
public:
	GShot(int nType);
	virtual ~GShot();

public:
	/** NbvJE^X^[g
	  */
	void startClipCounter();
	/** Ԍo߁A܂͂ӂقǂɂJE^i
	  */
	HPLSequenceState& stepClipCounter();
	int getShotClassType() {		return this->m_nShotClassType;	}
	int getHitToSolidType() {		return this->m_nHitToSolidType;	}
	bool isClip() {		return this->m_bIsClip;	}
	int getForceType() {		return this->m_nForceType;	}
	void setForceType( int n ) {		this->m_nForceType = n;	}
	void setDamageType( int nType, bool bIsWeak );
	bool getDamageType( int nType );

	/** _[W^CvŚBrbgZp
	  */
	int getDamageTypeFull() {
		return this->m_DamageType.getFull();//this->m_nDamageType;
	}
	int getParentWeaponType() {
		return m_nParentWeaponType;
	}
	void setParentWeaponType( int nType ) {
		m_nParentWeaponType = nType;
	}

public:
	HPLCounter	m_DamageIntervalCounter;		//! _[W^Ԋu
	HPLVector	m_Delta;						//! ^[QbgƂ̑ΐڐGW
	int 		m_nCreateShotTypeWhenDead;		//! Sɍ쐬Vbg
	HPLCounter* m_lpContrailCreateInterval;	//! KԊu
	int			m_nContrailObjectType;		//! K̃IuWFNg^Cv
	int 		m_nContrailType;	//! K^CvB-1Ȃ琶Ȃ
	HomingData* m_lpHomingData;

	float m_fBlowSpeed;		//! уXs[h
	float m_fPower;			//! U

	std::vector<HPLCounter*> m_vecCounters;		//! JE^
	int		m_nHomingType;
	bool m_bIsDrawRotateByVelocityAngle;		//! VelocityAngle̕ɏ]ĕ\](true)
	bool m_bIsNoMove;							//! Ȃ(VelocityAngle͕\݂̂ɗp)(false)
	int getDirection() {
		return this->m_nDirection;
	}
	void setDirection( int nDirection );
	/** */
	bool collision(HPLMatrix<int>* matrix,
		std::map<int, HPLBlock*>* blockMap);

	/**
		ASY
	*/
	void algorithm();

	void draw();
	/////////////////////////////////////////////////////
	void die(HPLShootingObject* damageSource);

	void damage(float dmg, HPLShootingObject* damageSource);
	HPLSequence* getSequence();
	void changeState( int t );

	/**
		ڐG̍s(U)
		GattackRect(ftHghitRectƓ)
		vC[hitRectڐGꍇ̍s
	*/
	//void attackToPlayer( GPlayer* player);

public:
	int getSequenceID();
	bool isHomingLaser();

	static bool isUnique( int nType );
};

#endif
