#include "GShotFactory.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>
#include <cmath>

using namespace std;
using namespace GEnum;

namespace GEnum {
	static const float ALRAUNE_SCREAM_START_DEG = 160;
	static const float ALRAUNE_SCREAM_END_DEG = 380;

	// Vbg̐ݒ
/*	namespace WayType {
		enum WayType_ {
			NONE,		//! Ώۂ̕Ȃ
			STRAIGHT,	//! (n>1̏ꍇdȂĂ܂)
			NWAY,		//! NWay shot (nIndex/nMaxɂe󂯂
		};
	}
	*/
}


/**
  * @retval	n	˂e̐
  */
int GShotFactory::shot(HPLShootingObject* lpParent, int nWeaponType, int nWeaponDirection,
					   int nShotIndex)
{

	this->m_lpParent = lpParent;
	this->m_nWeaponType = nWeaponType;
	this->m_nWeaponDirection = nWeaponDirection;
	this->m_nShotIndex = nShotIndex;
	this->resetParams();

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );	// level

	this->m_nWayShotNum = 1;

	bool bIsUnique = false;	//! j[NH

	int nColor = 0;	// F
	int n = 1;		// 
	switch( this->m_lpParent->getObjectType() ) {
	case ObjectType::PLAYER:
		n = 1;
		switch( this->m_lpParent->getType() ) {
		case PlayerType::EVIGEN:
			{
				n = ((GPlayer*)this->m_lpParent)->getWeapon()->getNextBulletNum();
				switch( this->m_nWeaponType ) {
				case WeaponType::FRAME_THROWER:
					getStaticData()->m_MixerManager.play( SE::FRAME_THROWER, false );
					break;

				case WeaponType::CHAIN_SAW:
				case WeaponType::DRILL:
					getStaticData()->m_MixerManager.play( SE::CHAIN_SAW, false );
					break;
				case WeaponType::SHOT_GUN:
				case WeaponType::CRYOLATOR:
				case WeaponType::HAND_GUN:
				case WeaponType::HOMING_LASER:
				case WeaponType::ELECTRIC_HOMING_LASER:
				case WeaponType::SNIPER_RIFLE:
				case WeaponType::RAIL_GUN:
					// XiCp[Ct
					getStaticData()->m_MixerManager.play( SE::SNIPER, false );
					if( this->m_nWeaponType == WeaponType::CRYOLATOR ) {
						GPlayer* lpPlayer = (GPlayer*)this->m_lpParent;
						if( lpPlayer->m_nTileType == TileType::SWIM ) {
							// XtɂȂ
							lpPlayer->m_SolidData.setType( SolidType::CRYO );
							lpPlayer->damage( 1, NULL, false, StateType::DAMAGE );
						}
					}
					break;
				case WeaponType::PUNCH:
					break;
				case WeaponType::MISSILE_LAUNCHER:
				case WeaponType::MULTI_MISSILE_LAUNCHER:
				case WeaponType::HOMING_MISSILE_LAUNCHER:
				case WeaponType::SPREAD_MISSILE_LAUNCHER:
					{
						getStaticData()->m_MixerManager.play( SE::MISSILE_LAUNCHER, false );

					}
					break;
				case WeaponType::NIKITA_MISSILE:
					// nikita
					{
						if( getStaticData()->m_ObjectManager.m_ShotManager.isUniqueShotFlag(
							((GPlayer*)this->m_lpParent)->getWeapon()->m_nShotType)) 
						{
							// ɑ݂
							// Buzzer?(Ƃ肠͏oȂ)
							getStaticData()->m_MixerManager.play( SE::BUZZ, false );
							return 0;
						} else {
							// ->unique
							bIsUnique = true;
							getStaticData()->m_MixerManager.play( SE::MISSILE_LAUNCHER, false );
						}
					}
					break;
				case WeaponType::PILE_BUNKER:
					{
						getStaticData()->m_MixerManager.play( SE::MISSILE_LAUNCHER, false );
						getStaticData()->m_ShakeManager.startShake();

						getStaticData()->m_ObjectManager.m_EffectManager.createWeaponBackEffect(
							this->m_lpParent->getFaceDirection(),
							this->m_lpParent->getCenter(),
							Sequence::Effect::EXPLOSION_SMOKE );
					}
					break;
				}
			}
			break;
		case PlayerType::CAR:
			{
				switch( nWeaponType) {
				case WeaponType::CAR_BALL:
					getStaticData()->m_MixerManager.play( SE::SHOT_GUN, false );
					break;
				}
			}
			break;
		}
		break;
	case ObjectType::ENEMY:
		// TODO
		n = 1;
		switch( this->m_lpParent->getType() ) {
		case EnemyType::YELLOW_SLIME:
			// yellow slime
			n = 1 + (int)( fLevel / 2);
			nColor = 3;	//yellow
			break;
		case EnemyType::SLIME_QUEEN:
			n = (int)( 5.f * (1.f + fLevel ) );

			nColor = lpParent->getColor();
			break;
		case EnemyType::ARM_HEAD:
			n = 1;//n = (int)( 5.f * (1.f + fLevel ) );
			nColor = 2;	//green
			break;
		case EnemyType::ARAKHNE:
			n = (int)( 3.f * fLevel );
			break;
		case EnemyType::BEE:
			n = (int)( 3 * fLevel + 1 );
			break;
		case EnemyType::ALRAUNE:
			switch( nWeaponType ) {
			case AlrauneWeaponType::TENTACLE:
				n = 1;
				break;
			case AlrauneWeaponType::SCREAM:
				{
					const float ALRAUNE_SCREAM_SHOT_DEG_INTERVAL = 30;

					n = (int)(((ALRAUNE_SCREAM_END_DEG - ALRAUNE_SCREAM_START_DEG) / ALRAUNE_SCREAM_SHOT_DEG_INTERVAL ) * fLevel);
					this->m_nWayShotNum = n;
				}
				break;
			default:
				// error
				ASSERT_IT_TYPE( nWeaponType, "alraune weapon type");
//				HPLError::assertIt(false );
			}
			break;
		case EnemyType::FLOWER:
			{
				GEnemy* lpEnemy = (GEnemy*)lpParent;
				// AEl̉
				// BUG͂ł͔˂Ȃ̂ŋCɂȂ
			
				// ۂɔ˂e̐
				int nNum = 1;
				this->m_nWayShotNum = (int)(n + 3 / fLevel + 1);	// Ƃ蓾Way
				if( lpEnemy->getBerserkLevel() > 0 ) {
					// berserk
					nNum = m_nWayShotNum;
				} else {
					// not berserk
					nNum = 1 + (int)(fLevel / 2);	// x2ȏ̂Ƃɂ̂ݑ₷
				}
				n = nNum;

			}
			
			break;
		case EnemyType::WIND_BIT:
		case EnemyType::ELEC_BIT:
			break;
		case EnemyType::MERAKO:
			break;
		case EnemyType::ROBOT:
			switch( m_nWeaponType ) {
			case 0:
				n = 1;
				break;
			case 1:
				n = 2;
				break;
			}
			break;
		case EnemyType::SHABONER:
			n = 4;
			break;
		case EnemyType::CHASER:
			{
				int nMapIndex = getStaticData()->getMapIndex();
				switch( nMapIndex ) {
				case SpecialMapIndex::WIND_BOSS_1:
					switch( this->m_nWeaponType ) {
					case ChaserAttackType1::BORN:
						// shotȂ
						return 0;
					case ChaserAttackType1::ELECT_SHOT_1:
						n = (int)(3 * fLevel);
						break;
					case ChaserAttackType1::WIND_SHOT_1:
						n = (int)(12 * fLevel);
						break;
					case ChaserAttackType1::THUNDER_BALL_HOMING:	// n = 1
						n = 1;
						break;
					case ChaserAttackType1::THUNDER_BALL_LINE:	// ɕ΂
						// 
						{
							HPLMatrix<int>* lpMat = 
								getStaticData()->m_ObjectManager.m_EnemyManager.getCoordPosition(
								EnemyPositionType::CHASER_1);
							n = lpMat->getRowSize();
						}
						break;
					}
					break;
				case SpecialMapIndex::WIND_BOSS_2:
					switch( this->m_nWeaponType ) {
					case ChaserAttackType::BALL:
						n = (int)(3 * fLevel);
						break;
					case ChaserAttackType::ELEC_SHOT:
						switch( nShotIndex % 2 ) {
						case 0:
							n = (int)(4 * fLevel);
							break;
						case 1:
							n = (int)(4 * fLevel) + 1;
							break;
						default:
							ASSERT_IT_TYPE( nWeaponType, "chaser 2 elec type");
//							HPLError::assertIt(false);
						}
						break;
					case ChaserAttackType::WIND_SHOT:
						n = (int)(20 * fLevel);
						break;
					case ChaserAttackType::THUNDER_SHOT:
						n= 1;
						break;
					case ChaserAttackType::SHABON_SHOT:
						n = (int)(3 * fLevel);
						break;
					default:
						ASSERT_IT_TYPE( nWeaponType, "chaser 2 weapon type");
//						HPLError::assertIt(false);
					}
					break;
				default:
					ASSERT_IT_TYPE( nMapIndex, "chaser 2 map index");
					//HPLError::assertIt(false);
				}
			}
			break;	// chaser
		case EnemyType::AIKO:
			{
				switch( this->m_nWeaponType ) {
				case AikoAttackType::ICE_SPIKE:
					n = fLevel * 15;
					break;
				case AikoAttackType::ICICLE:
					// ʃTCYQlɌm肷
					break;
				case AikoAttackType::TARGET_FROST:
					// vC[̈ʒuLxǔ
					n = 1;
					break;
				case AikoAttackType::ICE_SOWRD:
					n = 1;
					break;
				case AikoAttackType::ICE_SPIKE_TARGET:
					{
						int m = fLevel * 2;
						n = m % 2 == 0 ? m + 1 : m;
					}
					break;
				case AikoAttackType::CALL_FROST:
					break;
				case AikoAttackType::BLIZZARD:
					n = 1;
					break;
				}
			}
			break;
		case EnemyType::GHOST_PAIR:
			switch( this->m_nWeaponType ) {
			case GhostPairAttackType::HOMING:
			case GhostPairAttackType::ICE_SPIKE:	// 1N
				n = 1;
				break;
			case GhostPairAttackType::ICE_SPIKE_WINDER:
				n = 2 * fLevel;
				break;
			case GhostPairAttackType::ICICLE:
				break;
			case GhostPairAttackType::MIRROR:	// V[hɌĒe(ice spike)𔭎
				n = 2;
				break;
			case GhostPairAttackType::SANDWITCH:
			case GhostPairAttackType::SUMMON_ELEMENT:
				break;
			case GhostPairAttackType::ICE:
				n = 6 * fLevel;
				break;
			case GhostPairAttackType::PON:
				n = 2 * fLevel;
				break;
			}
			break;
		}
		break;
	}
	int nShotType = this->getShotType();
	int nParentID = lpParent->getID();
	int nFaceDirection = lpParent->getFaceDirection();
	for( int i = 0; i < n; i ++ ) {
		HPLVector vShotCenter = this->getCenter(i, n);
		GShot* lpShot = getStaticData()->m_ObjectManager.m_ShotManager.create(
			nShotType,
			vShotCenter,
			nParentID,
			nFaceDirection,
			bIsUnique, true);
		if( lpShot != NULL ) {
			lpShot->setVelocityAngle( this->getVelocityAngle( vShotCenter, i, n ) );
			lpShot->setFaceDirection( lpParent->getFaceDirection() );
			lpShot->setColor(nColor);
			this->setupShot( lpShot );
		} else {
			// 
#ifdef _DEBUG
			HPLError::assertIt(bIsUnique,
				"%s:%s(%d): invalid unique shot is engaged", __FILE__, __FUNCTION__, __LINE__);
#endif
		}
	}

	return n;
}
/**
  * @retval		Vbg^Cv
  */
int GShotFactory::getShotType( ) {
	switch( this->m_lpParent->getObjectType() ) {
	case ObjectType::PLAYER:
		{
			GPlayer* lpPlayer = (GPlayer*)this->m_lpParent;
			switch( lpPlayer->getType() ) {
			case PlayerType::EVIGEN:
				{
					int nType = lpPlayer->getWeapon()->m_nShotType;
					/*if( lpPlayer->getWeaponType() == WeaponType::GATLING ) {
						if( lpPlayer->isSuperPower() && lpPlayer->getSuperPowerType() == SuperPowerType::QUEEN_AUTHORITY ) {
							nType = Sequence::Shot::SLIME_CLIP;
						}
					}*/
					return nType;
				}
			case PlayerType::CAR:
				return Sequence::Shot::CAR_BALL;
			}
			return Sequence::Shot::MISSILE;
		}
		
	case ObjectType::ENEMY:
		switch( this->m_lpParent->getType() ) {
		case EnemyType::YELLOW_SLIME:
		case EnemyType::SLIME_QUEEN:
		case EnemyType::ARM_HEAD:
			return Sequence::Shot::SLIME_CLIP;
		case EnemyType::ARAKHNE:
			{
				int SHOTS[] = {
					Sequence::Shot::KOGUMO_1,
					Sequence::Shot::KOGUMO_2,
					Sequence::Shot::SPIDER_NET,
				};
				return SHOTS[ HPLMath::nextInt(0,3) ];
			}
		case EnemyType::BEE:
			return Sequence::Shot::NEEDLE;
		case EnemyType::ALRAUNE:
			{
				switch( this->m_nWeaponType ) {
				case AlrauneWeaponType::TENTACLE:
					return Sequence::Shot::TENTACLE;
				case AlrauneWeaponType::SCREAM:
					return Sequence::Shot::ONPA;

				}

				ASSERT_IT_TYPE( m_nWeaponType, "alraune shot type");
//				HPLError::assertIt( false, "AElgetShotType" );
			}
		case EnemyType::FLOWER:
			switch( this->m_lpParent->getColor() ) {
			case AlrauneFlowerColorType::RED:
				return Sequence::Shot::KAHUN;
			case AlrauneFlowerColorType::BLUE:
				return Sequence::Shot::LEAF;
			case AlrauneFlowerColorType::YELLOW:
				return Sequence::Shot::LEAF;
			default:
				//HPLError::assertIt(false );
				ASSERT_IT_TYPE( this->m_lpParent->getType(), "Enemy type" ) ;
			}
		case EnemyType::WIND_BIT:
			return Sequence::Shot::WIND;
		case EnemyType::ELEC_BIT:
			return Sequence::Shot::ELEC;
		case EnemyType::GHOST:
			return Sequence::Shot::FALL_ICE;
		case EnemyType::MEDOUSA:
			return Sequence::Shot::SNAKE;
		case EnemyType::ROBOT:
			switch( m_nWeaponType ) {
			case 0: return Sequence::Shot::ROBOT_BEAM;
			case 1:	return Sequence::Shot::ROBOT_MISSILE;
			}
			return Sequence::Shot::ROBOT_BEAM;
		case EnemyType::SHABONER:
			return Sequence::Shot::SHABON;
		case EnemyType::CHASER:
			{
				int nMapIndex = getStaticData()->getMapIndex();
				switch( nMapIndex ) {
				case SpecialMapIndex::WIND_BOSS_1:
					switch( m_nWeaponType ) {
					case ChaserAttackType1::ELECT_SHOT_1:
						return Sequence::Shot::ELEC;
					case ChaserAttackType1::WIND_SHOT_1:
						return Sequence::Shot::WIND;
					case ChaserAttackType1::THUNDER_BALL_HOMING:
					case ChaserAttackType1::THUNDER_BALL_LINE:
						return Sequence::Shot::THUNDER_BALL;
					}
					break;
				case SpecialMapIndex::WIND_BOSS_2:
					switch( m_nWeaponType ) {
					case ChaserAttackType::ELEC_SHOT:
						return Sequence::Shot::ELEC;
					case ChaserAttackType::WIND_SHOT:
						return Sequence::Shot::WIND;
					case ChaserAttackType::BALL:
						return Sequence::Shot::CHARGE_BOLT;
					case ChaserAttackType::THUNDER_SHOT:
						return Sequence::Shot::THUNDER_BOLT;
					case ChaserAttackType::SHABON_SHOT:
						return Sequence::Shot::SHABON;
					}
				}
			}
			break;
		case EnemyType::DIRTY_CLOUD:
			switch( m_nWeaponType ) {
			case 0:
				return Sequence::Shot::DIRTY_DROP;
			case 1:
				return Sequence::Shot::DIRTY_WIND;
			}
			break;
		case EnemyType::AIKO:
			switch( this->m_nWeaponType ) {
			case AikoAttackType::ICE_SPIKE:
			case AikoAttackType::ICE_SPIKE_TARGET:
				return Sequence::Shot::ICE_SPIKE;
			case AikoAttackType::ICE_SOWRD:
				return Sequence::Shot::SOWRD;
			case AikoAttackType::TARGET_FROST:
//				return Sequence::Shot::FROST;
			case AikoAttackType::ICICLE:
			case AikoAttackType::BLIZZARD:
				break;
			}
			break;
		case EnemyType::GHOST_PAIR:
			switch( this->m_nWeaponType ) {
			case GhostPairAttackType::HOMING:
			case GhostPairAttackType::ICE_SPIKE:	// 1N
			case GhostPairAttackType::ICE_SPIKE_WINDER:
			case GhostPairAttackType::MIRROR:	// V[hɌĒe(ice spike)𔭎
			case GhostPairAttackType::SANDWITCH:
				return Sequence::Shot::ICE_SPIKE;
			case GhostPairAttackType::ICICLE:
			case GhostPairAttackType::SUMMON_ELEMENT:
				break;
			}
			break;
		}
	}
	//ASSERT_IT_TYPE( (), "Enemy type" ) ;
	HPLError::assertIt(false, "%s:invalid object:ObjectType=%d, Type=%d",
		__FUNCTION__, m_lpParent->getObjectType(), m_lpParent->getType());
	return 0;
}

/** vC[̕픭ˈʒu
  */
void GShotFactory::getPlayerWeaponShotCenterFromDelta( HPLVector& vResultCenter,
	HPLShootingObject* lpParent, int dx, int dy, int nWeaponType )
{
	GWeaponSetting* lpSetting = getStaticData()->m_ObjectManager.m_WeaponManager.getWeaponSetting(
		nWeaponType );
	int nCenterError = lpSetting->m_nCenterError;
	// ˈʒu
	vResultCenter.set(
		lpParent->getCenter().getX() + 
		lpParent->getFaceDirection() * 10.f +
		(float)HPLMath::nextFloat(-1,1) * nCenterError +//CENTER_RANDOM[m_nWeaponType] +
		dx,

		lpParent->getCenter().getY() +
		dy +
		(float)HPLMath::nextFloat(-1,1) * nCenterError );//CENTER_RANDOM[m_nWeaponType]);
}

/** vC[̕픭ˈʒũYvZ
  */
void GShotFactory::getPlayerWeaponShotCenterDelta( int& dx, int& dy, HPLShootingObject* lpParent, int nWeaponType,
												  int nWeaponDirection)
{
	GWeaponSetting* lpSetting = getStaticData()->m_ObjectManager.m_WeaponManager.getWeaponSetting(
		nWeaponType );
	bool bIsLeftFace = lpParent->getFaceDirection() == FaceDirection::LEFT;
	// 
	dx = bIsLeftFace ? 
		lpSetting->m_nShotDXLeft : lpSetting->m_nShotDXRight;
//				LEFT_FRONT_DELTA_X[this->m_nWeaponType] : RIGHT_FRONT_DELTA_X[this->m_nWeaponType];

	// c
	dy = 22;

	switch( nWeaponType ) {
	case WeaponType::LASER_GUN:	// laser
	case WeaponType::RAIL_GUN:	// rail
		{
			// ΂45x̉=c
			float DX45 = lpSetting->m_nShotDXRight * cos(HPLMath::getRadianFromDegree<float>( 45 ) );
			dy = 27;

			int nDegree = bIsLeftFace ?
				180:0;
			bool bIsSloped = false;	// ΂߂Ă邩H
			switch( nWeaponDirection ) {	// direction
			case WeaponDirection::FRONT_UP:			// front up
				bIsSloped = true;
				dy = (int)(-DX45+5);
				nDegree += ( bIsLeftFace ? 1 : -1 ) * 45;
				break;
			case WeaponDirection::FRONT_DOWN:		// front down
				bIsSloped = true;
				dy = (int)(DX45+50);
				break;
			}

			if( bIsSloped ) {	// ΂߂
				// ʒuC
				dx = bIsLeftFace ? -296 : 296;
			}
		}
		break;
	default:
		{
			switch( nWeaponDirection ) {	// direction
			case WeaponDirection::FRONT_UP:			// front up
				dy = 18;

				dx += lpParent->getFaceDirection() == FaceDirection::LEFT ?
					-3:-2;
				break;
			case WeaponDirection::FRONT_DOWN:		// front down
				dx += lpParent->getFaceDirection() == FaceDirection::LEFT ?
					0:-5;
				break;
			}
		}
	}
}


/** vC[̕픭ˈʒu
  */
void GShotFactory::getPlayerWeaponShotCenter( HPLVector& vResultCenter, HPLShootingObject* lpParent,
											 int nWeaponType, int nWeaponDirection )
{
	int dx = 0;
	int dy = 0;
	// get delta from weapon type and direction
	GShotFactory::getPlayerWeaponShotCenterDelta( dx, dy, lpParent,
		nWeaponType, nWeaponDirection );

	// get center from delta
	GShotFactory::getPlayerWeaponShotCenterFromDelta( vResultCenter, lpParent,
		dx, dy, nWeaponType );
}

/**
  * @retval		Vbg̒SW
  */
HPLVector GShotFactory::getCenter( int nIndex, int nAllNum ) {
	switch( this->m_lpParent->getObjectType() ) {
	case ObjectType::PLAYER:
		{
			GPlayer* lpPlayer = dynamic_cast<GPlayer*>( this->m_lpParent );
			switch( lpPlayer->getType() ) {
			case PlayerType::EVIGEN:
				{
					switch( this->m_nWeaponType ) {
					case WeaponType::SNIPER_RIFLE:
						return lpPlayer->m_vSniperPosition;
					}

					HPLVector c;
					GShotFactory::getPlayerWeaponShotCenter( c, this->m_lpParent, this->m_nWeaponType,
						this->m_nWeaponDirection );


					switch( this->m_nWeaponType ) {
					case WeaponType::LASER_GUN:
					case WeaponType::RAIL_GUN:
						// rail gun p[eBN
						{
							GPlayer* lpPlayer = (GPlayer*)this->m_lpParent;
							int nShotType = lpPlayer->getWeapon()->m_nShotType;
							
							const int RAIL_GUN_PARTICLE_NUM = 50;

							HPLRect r = getStaticData()->getSequence( SpriteType::SHOT,
								 nShotType)->getImageInformation(0)->srcRect;
							// 摜TCY
							int nWidth = (int)r.getWidth();
							int nHeight = (int)r.getHeight();

							float fDelta = this->getShotDegreeDelta();	// shot degree
							
							HPLVector v(this->m_lpParent->getFaceDirection(), 0);	// 
							float fDegree = v.getDegree() + fDelta;
							//float fRad = HPLMath::getRadianFromDegree( fDegree );
							// speed
							const float WIND_RAIL_SPEED = 3;
							// color
							int nR = 255, nG = 255, nB = 255;
							switch( this->m_nWeaponType ) {
							case WeaponType::LASER_GUN:
								nR = 255;	nG = 255;	nB = 100;
								break;
							case WeaponType::RAIL_GUN:
								nR = 200;	nG = 200;	nB = 255;
								break;
							}
							// cosine
							//float fCos = (float)cos(fRad);
							// sine
							//float fSin = (float)sin(fRad);
							// ppx(-ERR~ERŘ덷)
							float fEdgeDeg = fDegree + 90;
							float fEdgeRad = HPLMath::getRadianFromDegree( fEdgeDeg );
							float fEdgeCos = (float)cos( fEdgeRad );
							for( int i = 0; i < RAIL_GUN_PARTICLE_NUM; i ++ ) {
								// ˕
								HPLVector vDelta;
								vDelta.setByDegree( fDegree );
								vDelta.multiple( HPLMath::nextInt(0,nWidth ) );

								// ̒p
								HPLVector vEdge;
								vEdge.setByDegree( fEdgeDeg );
								vEdge.multiple( HPLMath::nextInt(- nHeight / 2, nHeight ) );
								vDelta.add( vEdge );
		/*						int x = HPLMath::nextInt( -1 * nWidth / 2 , nWidth / 2 )* fCos;
								int y = (float)tan(fRad );
								// delta from shot center
								HPLVector vDelta(
									,
									HPLMath::nextInt( -1 * nHei / 2, nWidth / 2) * fSin);
									*/
								vDelta.add( c );
								// create rail wind
								GEffect* lpEffect = getStaticData()->createEffect( Sequence::Effect::WIND_RAIL,
									vDelta, vDelta, -1, -1 );
								// set color
								lpEffect->setColor( nR,nG,nB );
								// velocity
								HPLVector vVel;
								vVel.setByDegree( fDegree + (float)(HPLMath::nextInt(0,2) * 2 - 1) * 20 );
								vVel.multiple( WIND_RAIL_SPEED );
								lpEffect->setVelocityAngle( vVel );
							}
						}
						break;
					}	// switch weapon
					return c;
				}	// switch case evigen
				break;
			case PlayerType::CAR:
				{
					HPLVector c = lpPlayer->getCenter();
					const int CAR_CANNON_DELTA_Y = 100;	// cannon upper delta from car
					c.add( 0, -CAR_CANNON_DELTA_Y );
					return c;
				}
			}	// switch player type
			return lpPlayer->getCenter();
//			break;
		}	// switch case player
		break;
	case ObjectType::ENEMY:
		switch( this->m_lpParent->getType() ) {
		case EnemyType::YELLOW_SLIME:
		case EnemyType::SLIME_QUEEN:
		case EnemyType::ARM_HEAD:
		case EnemyType::ARAKHNE:
		case EnemyType::BEE:
			{
				HPLVector c = this->m_lpParent->getCenter();
				// TODO
				c.add( 0,0 );
				return c;
			}
		case EnemyType::ALRAUNE:
			{
				GEnemy* lpEnemy = (GEnemy*)this->m_lpParent;
				switch( this->m_nWeaponType ) {
				case AlrauneWeaponType::TENTACLE:
					{
						const int TENTACLES_PER_SET = 
							lpEnemy->getCounter( AlrauneCounterType::TENTACLE_COUNT )->getWaitFrameNum();
						const float SHOT_INTERVAL_X = 40;
						const float ONE_SET_INTERVAL_X = SHOT_INTERVAL_X * ( TENTACLES_PER_SET + 1 );
						const float SHOT_DELTA_Y = 80;
				
						float fDeltaX = 
							lpEnemy->getCounter(
								AlrauneCounterType::ALL_TENTACLE_COUNT )->getStepCounter() *
									ONE_SET_INTERVAL_X +
								lpEnemy->getCounter(
									AlrauneCounterType::TENTACLE_COUNT )->getStepCounter() *
										SHOT_INTERVAL_X;

						HPLVector vCen = lpEnemy->getCenter();
						vCen.add( - fDeltaX, SHOT_DELTA_Y );
						return vCen;
					}
				case AlrauneWeaponType::SCREAM:
					return lpEnemy->getCenter();
				}
			}
		case EnemyType::FLOWER:
			return this->m_lpParent->getCenter();
		case EnemyType::ELEC_BIT:
		case EnemyType::WIND_BIT:
		case EnemyType::MEDOUSA:
			return this->m_lpParent->getCenter();
		case EnemyType::GHOST:
			{
				HPLRect rHitArea = this->m_lpParent->getHitArea();
				HPLVector vPos( HPLMath::nextInt(rHitArea.getX(), rHitArea.getRight() ),
					HPLMath::nextInt( rHitArea.getY(), rHitArea.getBottom() ) );
				return vPos;
			}
		case EnemyType::ROBOT:
			{
				HPLVector c = this->m_lpParent->getCenter();
				switch( this->m_nWeaponType ) {
				case 1:
					c.add(nIndex * 10 * this->m_lpParent->getFaceDirection(), 0 );
					return c;
				}
				return c;
			}
		case EnemyType::SHABONER:
			{
				int INTERVAL_DEG = HPLMathConsts::DEGREE_FULL_ROUND / nAllNum;
				const float LENGTH = 35;
				float fDeg = m_lpParent->getRotateDegree() + nIndex * INTERVAL_DEG;
				HPLVector c;
				c.setByDegree(fDeg);
				c.multiple( LENGTH );
				c.add( m_lpParent->getCenter());
				return c;
			}
		case EnemyType::CHASER:
			{
				HPLVector vFrom;
				getStaticData()->m_ObjectManager.m_EnemyManager.getChaserHandFrom(
					vFrom, this->m_lpParent->getFaceDirection(), this->m_lpParent->getCenter(),
					m_nWeaponType );

				bool bIsError = false;
				int MAX_RADIUS = 80;
				
				int nMapIndex = getStaticData()->getMapIndex();
				switch( nMapIndex ) {
				case SpecialMapIndex::WIND_BOSS_1:
					switch( m_nWeaponType ) {
					case ChaserAttackType1::ELECT_SHOT_1:
						bIsError = true;
						break;
					case ChaserAttackType1::WIND_SHOT_1:
						bIsError = true;
						break;
					case ChaserAttackType1::THUNDER_BALL_HOMING:
					case ChaserAttackType1::THUNDER_BALL_LINE:
						break;
					}
					break;
				case SpecialMapIndex::WIND_BOSS_2:
					switch( this->m_nWeaponType ) {
					case ChaserAttackType::BALL:
						break;
					case ChaserAttackType::WIND_SHOT:
						bIsError = true;
						break;
					case ChaserAttackType::ELEC_SHOT:
						break;
					case ChaserAttackType::THUNDER_SHOT:
						vFrom.add( 0, 192 );
						break;
					case ChaserAttackType::SHABON_SHOT:
						bIsError = true;
						MAX_RADIUS /= 2;
						break;
					}
				}
				if( bIsError ) {
					// Ԃ
					float fDeg = HPLMath::nextInt(0,(int)HPLMathConsts::DEGREE_FULL_ROUND );
					int nRadius = HPLMath::nextInt( 0, MAX_RADIUS );
					HPLVector r;
					r.setByDegree( fDeg );
					r.multiple( nRadius );
					vFrom.add( r );
				}
				return vFrom;
			}
		case EnemyType::DIRTY_CLOUD:
			{
				// parent center
			}
			break;
		case EnemyType::AIKO:
			switch( this->m_nWeaponType ) {
			case AikoAttackType::ICE_SPIKE:
			case AikoAttackType::BLIZZARD:
				{
					// 
					HPLVector c = this->m_lpParent->getCenter();
					c.add( 0, - 100 );
					return c;
				}
			case AikoAttackType::ICE_SPIKE_TARGET:
			case AikoAttackType::ICE_SOWRD:
				{
					// ̐
					HPLVector c = this->m_lpParent->getCenter();
					c.add( this->m_lpParent->getFaceDirection() * 80, 0 );
					return c;
				}
			case AikoAttackType::TARGET_FROST:
				{
					// ^[QbeBO
					HPLVector c = this->m_lpParent->getTarget()->getCenter();
					return c;
				}
			case AikoAttackType::ICICLE:
				// ǂH
				// player̓orS
				break;
			}
			break;
		case EnemyType::GHOST_PAIR:
			{
				HPLVector c = this->m_lpParent->getCenter();
				c.add( this->m_lpParent->getFaceDirection() * 80, 0 );
				switch( this->m_nWeaponType ) {
				case GhostPairAttackType::HOMING:
				case GhostPairAttackType::ICE_SPIKE:	// 1N
				case GhostPairAttackType::ICE_SPIKE_WINDER:
					return c;
				case GhostPairAttackType::ICICLE:
					break;
				case GhostPairAttackType::MIRROR:	// V[hɌĒe(ice spike)𔭎
					break;
				case GhostPairAttackType::SANDWITCH:
				case GhostPairAttackType::SUMMON_ELEMENT:
					break;
				case GhostPairAttackType::PON:
					break;
				}
			}
			break;
		}
		break;
	default:
		// 
		HPLError::assertIt( false,
			"ɂ[");
		break;
	}
	return this->m_lpParent->getCenter();
}
/**
  * @retval		Vbg̈ړ
  */
HPLVector GShotFactory::getVelocityAngle( HPLVector vShotCenter, int nIndex, int nMax ) {
	float GRAVITY = getStaticData()->m_Setting.gravity;		// d
	float fRate = (float)nIndex / nMax;

	int nType = this->m_lpParent->getType();

	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );

	switch( this->m_lpParent->getObjectType() ) {
	case ObjectType::PLAYER:
		{
			GPlayer* lpPlayer = dynamic_cast<GPlayer*>( this->m_lpParent );
			
			switch( lpPlayer->getType()) {
			case PlayerType::EVIGEN:
				{
					// ㉺̌덷
		//			float delta = this->getShotDegreeDelta();

					HPLVector v;	// velocity angle
					bool bIsError = false;	// error
					float fError = GATLING_ERR;	// G[
					bool bIsThrow = false;	// 

					switch( this->m_nWeaponType ) {
					case WeaponType::RAIL_GUN:		// rail gun
					case WeaponType::LASER_GUN:		// laser gun
					case WeaponType::PUNCH:			// punch
					case WeaponType::DRILL:			// drill
					case WeaponType::PILE_BUNKER:	// pile bunker
					case WeaponType::SNIPER_RIFLE:	//
						{
							// Ȃ
							return HPLVector();
						}

					case WeaponType::GATLING:			
					case WeaponType::FRAME_THROWER:
					case WeaponType::HOMING_LASER:
					case WeaponType::ELECTRIC_HOMING_LASER:
					case WeaponType::WATER_GUN:
					case WeaponType::MAYO_GUN:
					case WeaponType::SLIME_GUN:
						bIsError = true;
						break;
					case WeaponType::SHOT_GUN:
						bIsError = true;
						fError = SHOT_GUN_ERR;
						break;
						
						// ̑͒i
						
		/*			case WeaponType::HOMING_MISSILE_LAUNCHER:
						v.set(-m_lpParent->getFaceDirection(), -1 );
						v.normalize();
						v.multiple(8);
						return v;
						//break;*/
					}

					// ^
					// left:180,right:0
					v.set( (float)m_lpParent->getFaceDirection(), 0 );
					if( bIsThrow ) {	// 
						// 
						v.setY( - THROW_VELOCITY_ANGLE_RATE );
					}

					if( bIsError ) { // G[L
						// YG[ǉ
						v.setY( v.getY() + HPLMath::nextFloat(-1,1)* fError );
					} else {
					}

					// degree + up/down delta
					v.setByDegree(v.getDegree() + this->getShotDegreeDelta());

					// speed
					float fSpeed = GATLING_SPD;	// default
					switch( m_nWeaponType ) {
					case WeaponType::MISSILE_LAUNCHER:
						fSpeed = MISSILE_FIRST_SPEED;
						break;
					case WeaponType::HOMING_MISSILE_LAUNCHER:
					case WeaponType::SPREAD_MISSILE_LAUNCHER:
					case WeaponType::MULTI_MISSILE_LAUNCHER:
						fSpeed = MISSILE_MAX_SPEED * 3.f / 5.f;
						break;
					case WeaponType::NIKITA_MISSILE:
						{
							const float NIKITA_MISSILE_FIRST_SPEED = 5;
							fSpeed = NIKITA_MISSILE_FIRST_SPEED;
						}
						break;
					case WeaponType::PINE_APPLE:
					case WeaponType::SEED:
					case WeaponType::TOMAHAWK:
					case WeaponType::WIND_WIZARD:
						// throw
						fSpeed *= (float)((GPlayer*)this->m_lpParent)->m_ChargeManager.getStepCounter() / 
							((GPlayer*)this->m_lpParent)->m_ChargeManager.getWaitFrameNum();
						break;
					case WeaponType::WATER_GUN:	// SC
						fSpeed = 16;
						fSpeed += HPLMath::nextFloat(-GATLING_ERR, GATLING_ERR);
						break;
					case WeaponType::MAYO_GUN:
						fSpeed = 5;
						fSpeed += HPLMath::nextFloat(-GATLING_ERR, GATLING_ERR);
						break;
					}
					v.multiple(fSpeed);

					// ㏈
					switch( this->m_nWeaponType ) {
					case WeaponType::NIKITA_MISSILE:
						{
							GPlayer* lpPlayer = dynamic_cast<GPlayer*>(this->m_lpParent);
							lpPlayer->m_vSniperVelocity = v;
						}
						break;
					}
					return v;
				}	// switch case evigen
			case PlayerType::CAR:
				{
					float fSpeed = GATLING_SPD;
					HPLVector v( lpPlayer->getFaceDirection(), 0 );
					v.setByDegree(v.getDegree() + this->getShotDegreeDelta());
					v.multiple( fSpeed );
					return v;
				}
			} // switch player type
			return HPLVector();
			//break;
		}
		break;
	case ObjectType::ENEMY:
		switch( this->m_lpParent->getType() ) {
		case EnemyType::YELLOW_SLIME:
		case EnemyType::SLIME_QUEEN:
		case EnemyType::ARM_HEAD:
			{
				// Ƌ
				float fDirectionLength =
					m_lpParent->getTarget()->getCenter().getX() - 
					vShotCenter.getX();

				HPLVector v(
	//				this->m_lpParent->getFaceDirection() * SLIME_CLIP_SPEED_X,
						HPLMath::getParaboraVelocityX( fDirectionLength, SLIME_CLIP_SPEED_Y, GRAVITY ) * 0.9f,
						- SLIME_CLIP_SPEED_Y);

				switch( this->m_lpParent->getType() ) {
				case EnemyType::SLIME_QUEEN:
					/*float fSpeed = v.getLength();
					float fDegree = v.getDegree();
					v.setByDegree( fDegree + HPLMath::nextDouble( - SLIME_QUEEN_SHOT_ERR, SLIME_QUEEN_SHOT_ERR) );
					v.multiple ( fSpeed );
					*/
					v.add( HPLMath::nextFloat( - SLIME_QUEEN_SHOT_ERR, SLIME_QUEEN_SHOT_ERR),
						HPLMath::nextFloat( - SLIME_QUEEN_SHOT_ERR, SLIME_QUEEN_SHOT_ERR));
					break;
				case EnemyType::ARM_HEAD:
					v.add( HPLMath::nextFloat( - SLIME_QUEEN_SHOT_ERR, SLIME_QUEEN_SHOT_ERR),
						HPLMath::nextFloat( - SLIME_QUEEN_SHOT_ERR, SLIME_QUEEN_SHOT_ERR));
					break;
				}
				return v;
			}
		case EnemyType::ARAKHNE:
		case EnemyType::BEE:
			{
				// Œ
				HPLVector v( (float)this->m_lpParent->getFaceDirection(), -1);

				// ɂĊpxω
				float MAX_DEGREE = 60;
				const float KOGUMO_SPEED = 20;
				float fSpeed = KOGUMO_SPEED;
				switch( nType ) {
				case EnemyType::BEE:
					{
						//MAX_DEGREE = HPLMath::nextFloat( 15,60 );

						HPLVector vTargetCenter = this->m_lpParent->getTarget()->getCenter();
						HPLVector vCenter = this->m_lpParent->getCenter();
						v.set( vTargetCenter.getX() - vCenter.getX(), vTargetCenter.getY() - vCenter.getY() );

						const float BEE_NEEDLE_SPEED = 5;
						fSpeed = BEE_NEEDLE_SPEED;
						break;
					}
				}
				float fDegree = v.getDegree() - MAX_DEGREE + fRate * MAX_DEGREE * 2.f;
				v.setByDegree( fDegree );
				v.multiple( fSpeed );
				// xiŒj
				return v;
			}
		case EnemyType::ALRAUNE:
			// x0
			switch( this->m_nWeaponType ) {
			case AlrauneWeaponType::TENTACLE:
				return HPLVector();
			case AlrauneWeaponType::SCREAM:
				{
					float fStep = (ALRAUNE_SCREAM_END_DEG - ALRAUNE_SCREAM_START_DEG ) / nMax;
					float fDeg = ALRAUNE_SCREAM_START_DEG + nIndex * fStep;
					HPLVector v;
					v.setByDegree( fDeg );
					const float ALRAUNE_SCREAM_SPEED = 10;
					v.multiple( ALRAUNE_SCREAM_SPEED );
					return v;
				}
			}
		case EnemyType::FLOWER:
			{
				HPLVector vParentCenter = this->m_lpParent->getCenter();
				HPLVector vTargetCenter = this->m_lpParent->getTarget()->getCenter();
				
				float fStartDeg = 180;
				float fEndDeg = 240;
				float fSpeed = 10;

				switch( this->m_lpParent->getColor() ) {
				case AlrauneFlowerColorType::RED: // ԕ
					fSpeed = 10;
					fStartDeg = 250;
					fEndDeg = 270;
					break;
				default:
					break;
				}
				// [hH
				if( this->m_lpParent->getColor() == AlrauneFlowerColorType::YELLOW &&
					(vTargetCenter.getX() - vParentCenter.getX() ) * this->m_lpParent->getFaceDirection() < 0 )
				{
					// vC[ɉ肱
					// ->ڗtςł
					HPLVector v = HPLVector::subtract(
						vTargetCenter, vParentCenter );
					v.normalize();
					/*if( this->m_lpParent->getFaceDirection() < 0 ) {
						v.setX( v.getX() * -1 );
					}*/
					v.multiple( fSpeed );
					return v;
				} else {
					HPLVector v;
					// 
					
					float fIntervalDeg = (fEndDeg - fStartDeg ) / this->m_nWayShotNum;

					if( nMax == this->m_nWayShotNum ) {
						v.setByDegree( fStartDeg + fIntervalDeg * nIndex );
					} else {
						v.setByDegree( fStartDeg + fIntervalDeg * HPLMath::nextInt(0,this->m_nWayShotNum) );
					}

					v.multiple( fSpeed );
					return v;
				}
			}
		case EnemyType::ELEC_BIT:
		case EnemyType::WIND_BIT:
			{
				// eCenterPositioneւ̕gp
				HPLVector v = HPLVector::subtract( this->m_lpParent->getCenter(),
					((GEnemy*)this->m_lpParent)->m_vCenterPosition );
				v.normalize();
				//float fDegStep = HPLMathConsts::DEGREE_FULL_ROUND / nMax;
				//HPLVector v;
				//v.setByDegree( fDegStep * nIndex );
				const float WIND_SPEED = 3;
				const float ELEC_SPEED = 1;
				float fSpeed = WIND_SPEED;
				if( this->m_lpParent->getType() == EnemyType::ELEC_BIT ) {
					fSpeed = ELEC_SPEED;

				}
				v.multiple( fSpeed );
				return v;
			}
		case EnemyType::GHOST:
			{
				float ERR = 8;
				HPLVector v( HPLMath::nextFloat(ERR/2,ERR) * (HPLMath::nextInt(0,2) - 1 ), 0 );
				return v;
			}
		case EnemyType::MEDOUSA:
			{
				switch( this->m_nWeaponType ) {
				case 0:
					{
						// Ƌ
						float fDirectionLength =
							m_lpParent->getTarget()->getCenter().getX() - 
							vShotCenter.getX();

						HPLVector v(
			//				this->m_lpParent->getFaceDirection() * SLIME_CLIP_SPEED_X,
								HPLMath::getParaboraVelocityX( fDirectionLength, SLIME_CLIP_SPEED_Y, GRAVITY ) * 0.9f,
								- SLIME_CLIP_SPEED_Y);
						return v;
					}
				case 1:
					{
						// ^
						return HPLVector();
					}
					break;
#ifdef _DEBUG
				default:
					ASSERT_IT_TYPE( this->m_lpParent->getType(), "Enemy type" ) ;

					//HPLError::assertIt(false);
#endif
				}
					
			}
			break;
		case EnemyType::ROBOT:
			{
				switch( m_nWeaponType ) {
				case 0:
					{
						// ^(is)
						HPLVector v(m_lpParent->getFaceDirection(),0);
						const float SPEED = 8;
						v.multiple( SPEED );
						return v;

					}
					break;
				case 1:
					{
						// ^
						const float SPEED = 8;
						return HPLVector(0,-SPEED);
					}
					break;
				}
			}
			break;
		case EnemyType::SHABONER:
			{
				int INTERVAL_DEG = HPLMathConsts::DEGREE_FULL_ROUND / nMax;
				float fDeg = m_lpParent->getRotateDegree() + nIndex * INTERVAL_DEG;
				float ERR = 5 * fLevel;
				fDeg += HPLMath::nextFloat(-ERR,ERR);
				HPLVector v;
				v.setByDegree( fDeg );
				v.multiple( SHABON_SPEED) ;
				return v;
			}
		case EnemyType::CHASER:
			{
				int MAX_DEG = 60 * fLevel;
//				int nWayType = WayType::NWAY;
				float SPEED = 10 * fLevel;
				bool bIsError = false;
				int ERR_DEG = 5;
				float fDeg = 0;		//! ˕
				// Chaser̎̈ʒu
				HPLVector vFrom;
				// Chaser̎̈ʒu擾
				getStaticData()->m_ObjectManager.m_EnemyManager.getChaserHandFrom(
					vFrom, this->m_lpParent->getFaceDirection(),
					this->m_lpParent->getCenter(), this->m_nWeaponType );

				// 肩Ώۂւ̕擾
				HPLVector v = HPLVector::subtract( 
					this->m_lpParent->getTarget()->getCenter(), vFrom );

				GEnemy* lpEnemy = (GEnemy*)this->m_lpParent;
				
				int nMapIndex = getStaticData()->getMapIndex();
				switch( nMapIndex ) {
				case SpecialMapIndex::WIND_BOSS_1:
					switch( this->m_nWeaponType ) {
					case ChaserAttackType1::BORN:
						// do nothing
						break;
					case ChaserAttackType1::ELECT_SHOT_1:
					case ChaserAttackType1::WIND_SHOT_1:
						{
							// S
							fDeg = v.getDegree() + 
								nIndex * HPLMathConsts::DEGREE_FULL_ROUND / nMax;
							v.setByDegree( fDeg);
							v.multiple( SPEED);
							return v;
						}
						break;
					case ChaserAttackType1::THUNDER_BALL_HOMING:
						{
							HPLVector vTargetCenter = this->m_lpParent->getTarget()->getCenter();
							vTargetCenter.add(0,-CHASER_THUNDER_SHOT_ABOVE_DISTANCE);

							// ːi
							float fReduceAccel = 0;
							const int FRAMES_FOR_GOAL = 20;
							HPLVector vVel;
							getStaticData()->m_ObjectManager.m_EnemyManager.setVelocityByGoal(vFrom,
								vVel, vTargetCenter, FRAMES_FOR_GOAL, fReduceAccel );
							this->setReduceAccel( fReduceAccel );
							return vVel;
						}
						break;
					case ChaserAttackType1::THUNDER_BALL_LINE:
						{
							// get matrix for position coord
							HPLMatrix<int>* lpMat = 
								getStaticData()->m_ObjectManager.m_EnemyManager.getCoordPosition(
								EnemyPositionType::CHASER_1);
							// tile size
							int TILE_SIZE = getStaticData()->m_Setting.tileSize;

							// target
							HPLVector vTargetCenter(lpMat->get(0,nIndex) * TILE_SIZE + 
								this->m_nShotIndex * 50 * fLevel,
								lpMat->get(1,nIndex) * TILE_SIZE );
							// ːi
							float fReduceAccel = 0;
							const int FRAMES_FOR_GOAL = 20;
							HPLVector vVel;
							getStaticData()->m_ObjectManager.m_EnemyManager.setVelocityByGoal(vFrom,
								vVel, vTargetCenter, FRAMES_FOR_GOAL, fReduceAccel );
							this->setReduceAccel( fReduceAccel );
							return vVel;
						}
						break;
					}
					break;
				case SpecialMapIndex::WIND_BOSS_2:
					switch( this->m_nWeaponType ) {
					case ChaserAttackType::BALL:
						{
							const int SPEED_X = 10;
							const int SPEED_Y = 10;
							// Ă֓
							v.set( this->m_lpParent->getFaceDirection() * SPEED_X, - SPEED_Y );
							float fDeg = v.getDegree();
							float fSpeed = v.getLength();
							const int DEGREE_STEP = 30;
							fDeg += (nIndex - nMax / 2) * DEGREE_STEP;
							v.setByDegree( fDeg );
							v.multiple(fSpeed);
							return v;
						}
					case ChaserAttackType::ELEC_SHOT:
						{
							fDeg = v.getDegree() + MAX_DEG * (float)( nIndex - nMax / 2 ) / nMax;
						}
						break;
					case ChaserAttackType::WIND_SHOT:
						{
							const int MAX_DEG = 30 * fLevel;
							SPEED = 10 * fLevel;
							bIsError = true;
							fDeg = v.getDegree();
						}
						break;
					case ChaserAttackType::SHABON_SHOT:
						{
							HPLVector v;
							fDeg = 270 + this->m_lpParent->getFaceDirection() * 60;
							SPEED = 8 * fLevel;
							bIsError = true;
							const int MAX_DEG = 60 * fLevel;
							ERR_DEG = MAX_DEG;
						}
						break;
					case ChaserAttackType::THUNDER_SHOT:
						{
							// THUNDER BIRD

							HPLVector v;
							
							return v;
						}
					}
					// ėpIȃVbg
					if( bIsError ) {
						fDeg += HPLMath::nextFloat( -ERR_DEG, ERR_DEG );
					}
					v.setByDegree( fDeg );
					v.multiple( SPEED );
					return v;
				}
			}
			break;
		case EnemyType::DIRTY_CLOUD:
			{
				switch( this->m_nWeaponType ) {
				case 0:
					return HPLVector();
				case 1:
					const float SPEED = 5;
					HPLVector v(this->m_lpParent->getFaceDirection() * SPEED, 0 );
					return v;
				}
			}
			break;
		case EnemyType::AIKO:
			{
				switch( this->m_nWeaponType ) {
				case AikoAttackType::ICE_SPIKE:	// S
					{
						float DEG_STEP = HPLMathConsts::DEGREE_FULL_ROUND / nMax;
						float DEG_SET_STEP = DEG_STEP / 10;
						HPLVector v;
						v.setByDegree( (nIndex)* DEG_STEP + this->m_nShotIndex * DEG_SET_STEP );
						const float SPEED = 7;
						v.multiple( SPEED);
						return v;
					}
				case AikoAttackType::ICE_SPIKE_TARGET:
					{
						HPLVector v( this->m_lpParent->getFaceDirection() , 0 );
						float fDeg = v.getDegree();

						const float ERR = 0 + nIndex * 0.1f;
						fDeg += HPLMath::nextFloat( -ERR,ERR);
						v.setByDegree( fDeg );
						const float SPEED = 8 + nIndex * 0.2f;
						v.multiple( SPEED );
						return v;
					}
				case AikoAttackType::ICE_SOWRD:
					{
						const float SPEED = 7;
						HPLVector v( this->m_lpParent->getFaceDirection() * SPEED, 0 );
						return v;
					}
				case AikoAttackType::ICICLE:
				case AikoAttackType::TARGET_FROST:
				case AikoAttackType::CALL_FROST:
				case AikoAttackType::BLIZZARD:
					break;
				}
			}
			break;
#ifdef _DEBUG
		default:

//			HPLError::assertIt(false);
			ASSERT_IT_TYPE( this->m_lpParent->getType(), "Enemy type" ) ;
#endif
		}
	}
	return HPLVector();
}

/**
  * @retval		l̐ݒ
  */
void GShotFactory::setupShot( GShot* lpShot ) {
	
	switch( this->m_lpParent->getObjectType() ) {
	case ObjectType::PLAYER:
		{
			GPlayer* lpPlayer = dynamic_cast<GPlayer*>( this->m_lpParent );

			lpShot->setParentWeaponType( this->m_nWeaponType );
			switch( lpPlayer->getWeaponType() ) {
			case WeaponType::GATLING:
				break;
			case WeaponType::DRILL:
			case WeaponType::PILE_BUNKER:
				lpShot->setDamageType( DamageType::DRILL, true );
				if( lpPlayer->getWeaponType() == WeaponType::PILE_BUNKER ) {
					lpShot->m_fPower *= 15;
				}
				break;
			case WeaponType::CHAIN_SAW:
				lpShot->setDamageType( DamageType::CHAIN_SAW, true );
				break;
			case WeaponType::RAIL_GUN:
			case WeaponType::LASER_GUN:
				{
					// rotate degree
					int nDegree = this->m_lpParent->getFaceDirection() == FaceDirection::LEFT ?
						180:0;
					// up/down delta
					nDegree += this->getShotDegreeDelta();
					lpShot->setRotateDegree( nDegree);
				}
				break;
			case WeaponType::SNIPER_RIFLE:
				lpShot->m_fPower *= 3;
				break;
			case WeaponType::SLIME_GUN:
				lpShot->setObjectAttribute( ObjectAttribute::HIT_TO_PLAYER ,false );
				lpShot->setObjectAttribute( ObjectAttribute::HIT_TO_ENEMY ,true );
				lpShot->setColor(HPLMath::nextInt(0,SlimeQueenColorType::MAX_NUM ) );
				lpShot->m_fPower *= PLAYER_SLIME_CLIP_POWER_RATE;
				break;
			}
		}
		break;
	case ObjectType::ENEMY:
		if( this->m_bIsReduceAccel ) {
			lpShot->setReduceAccel( this->m_fReduceAccel );
		}
		break;
	}
}

/** ˊpx(W)ɑ΂ď㉺̕ύX
  * W̔ˊpx͈ȉ̒ʂ
  * FaceDirection::LEFT	180
  * FaceDirection::RIGHT0
  */
int GShotFactory::getShotDegreeDelta() {
	int delta = 0;
	if( m_nWeaponDirection == WeaponDirection::FRONT_UP ){
		delta = - (float)m_lpParent->getFaceDirection() * 45;	// Left:180 + 45, Right:0 - 45
	} else if( m_nWeaponDirection == WeaponDirection::FRONT_DOWN ){
		delta =  (float)m_lpParent->getFaceDirection() * 45;	// Left:180 - 45, Right:0 + 45
	}
	return delta;
}
