#include "GShotManager.h"

#include "GStaticData.h"
#include <hpllib/action/HPLActionMoveTool.h>
#include <hpllib/action/HPLShootingMove.h>

#include <hpllib/math/HPLMath.h>
#include <hpllib/general/HPLString.h>
#include <hpllib/system/HPLFile.h>

#include <vector>
#include <string>

using namespace std;
namespace GEnum {
	namespace SettingCommandType {
		enum {
			NAME,
			ID,
			HIT_RECT,
			POWER,
			BLOW_SPEED,
			EXTRA_SEQUENCE_ID,
			FLAGS,
/*			THROW_BLOCK,
			HIT_TO_NEUTRAL,
			HIT_TO_SHOT,
			HIT_OBJECT_TO_DIE,
			GRAVITY,
			ENEMY_SHOT,
			*/
			MAX_NUM
		};
		
	}
	static const char SHOT_SETTING_FILE_PATH[] = _T("data/image/Shot/ShotSetting.txt");
}
using namespace GEnum;
using namespace GShotManagerConsts;


GShotManager::GShotManager(): HPLObjectManager(){

	this->resetUniqueShotFlag();
//	this->loadShotSettings();
	// shot setting
	/*
	using namespace ShotComand;

	vector<string> vecLines = HPLFile::loadStringLinesFromFile( SHOT_SETTING_FILE_PATH, true );

	GShotSetting shotSetting;

	// K{ڊmFp
	int NEED_BIT = 0;
	for( int i = 0; i < NeedType::MAX_NUM; i ++ ) {
		NEED_BIT |= 1 << i;
	}

	int nNeedCount = 0;
	int nNum = 0;
	int nIndex = 0;

	// loop
	for( int i = 0; i < (int)vecLines.size(); i ++ ) {

		if( vecLines[i].at(0) == '[' ) {
			// "[#]":Shot ID
			
			if( ( nNeedCount & NEED_BIT ) == NEED_BIT ) {
				// add
				this->m_mapShotSettings[nNum] = shotSetting;
				enemySetting.clear();
				nNeedCount = 0;
			}
			nNum = atoi(vecLines[i].substr(1,vecLines[i].size() - 2).c_str());
		} else {
			vector<string> vecItems = HPLString::split( vecLines[i], "=" );
			if( vecItems.size() < 2 ) {
				HPLError::msg( "Warning", MB_OK, "Error:%s", vecLines[i].c_str());
				continue;
			}

			if( 0 == vecItems[0].compare( CMD_HIT_RECT ) ) {
				vector<string> vecRects = HPLString::split( vecItems[1], ",") ;
				enemySetting.m_HitRect.set(
					(float)atoi( vecRects[0].c_str() ),
					(float)atoi( vecRects[1].c_str() ),
					(float)atoi( vecRects[2].c_str() ),
					(float)atoi( vecRects[3].c_str() )
					);

				nNeedCount |= 1 << NeedType::HIT_RECT;
			} else if( 0 == vecItems[0].compare( CMD_POWER_RATE ) ) {
				enemySetting.m_fPowerRate = (float)atof(vecItems[1].c_str() );
				nNeedCount |= 1 << NeedType::POWER_RATE;
			} else if( 0 == vecItems[0].compare( CMD_BLOW_RATE ) ) {
				enemySetting.m_fBlowRate = (float)atof(vecItems[1].c_str() );
				nNeedCount |= 1 << NeedType::BLOW_RATE;
			} else {
				// ̑tOƔf
				for( int j = 0; j < ShotFlagType::MAX_NUM; j ++ ) {
					if( 0 == vecItems[0].compare( CMD_FLAGS[j] ) ) {
						enemySetting.m_aryFlags[j] = vecItems[1].compare( "true" ) == 0;
					}
				}
			}
		}
	}
	*/
}

void GShotManager::loadShotSettings() {
	// RgLŃ[h
	vector<string> vecLines = HPLFile::loadStringLinesFromFile( SHOT_SETTING_FILE_PATH, false );

	int nCount = 0;
	int nErrorCount = 0;
	for( int i = 0; i < (int)vecLines.size(); i ++ ) {
		string strLine = vecLines[i];
		if( HPLFile::isCommentLine( &strLine ) ) {
			continue;
		}
		int nRet = this->parseSettingLine( i, strLine, &this->m_aryShotSettings[nCount] );
		nCount ++;
		if( nRet != 0 ) {
			nErrorCount ++;
		}
	}
	if( nErrorCount > 0 ) {
		HPLError::msg( "", MB_OK, "" );
	}
}
int GShotManager::parseSettingLine( int nLineIndex, std::string& strLine, GShotSetting* lpSetting ) {
	if( lpSetting == NULL ) {
		HPLError::msg( "Error", MB_OK, "NULL");
		return -1;
	}
	// 
	vector<string> vecItems = HPLString::split( strLine, ",");

	if( vecItems.size() < SettingCommandType::MAX_NUM ) {
		HPLError::msg( "Error", MB_OK, "vfȂ[%s]vf=[%d]<Kl=[%d]",
			strLine.c_str(), vecItems.size(), SettingCommandType::MAX_NUM );
		return 1;
	}
	for( int j = 0; j < (int)vecItems.size() && j < SettingCommandType::MAX_NUM; j ++ ) {
		string str = vecItems[j]; 
		str = HPLString::trim( str );
		switch( j ) {
		case SettingCommandType::NAME:
			{
				lpSetting->m_strName = str;
			}
			break;
		case SettingCommandType::ID:
			{
				lpSetting->m_nID = atoi(str.c_str());
			}
			break;
		case SettingCommandType::HIT_RECT:
			{
				vector<string> vecFlags = HPLString::split( str, "/");
				if( vecFlags.size() < 4 ) {
					HPLError::msg( "Error", MB_OK, "[%s]:flags(%d) != max_num(%d)",
						strLine.c_str(), vecFlags.size() , ShotSettingFlagType::MAX_NUM );
					continue;
				}
				for( int k = 0; k < SIZEOF(lpSetting->m_aryHitRect) &&
					k < (int)vecFlags.size(); k ++ ) 
				{
					lpSetting->m_aryHitRect[k] = atoi(vecFlags[k].c_str());
				}
			}
			break;
		case SettingCommandType::POWER:
			{
				lpSetting->m_nPower = atoi(str.c_str());
			}
			break;
		case SettingCommandType::BLOW_SPEED:
			{
				lpSetting->m_nBlowSpeed = atoi(str.c_str());
			}
			break;
		case SettingCommandType::EXTRA_SEQUENCE_ID:
			{
				vector<string> vecFlags = HPLString::split( str, "/");
				for( int k = 0; k < (int)vecFlags.size(); k ++ ) {
					int nID = atoi(vecFlags[k].c_str());
					if( nID >= 0 ) {
						lpSetting->m_vecExtraSequenceID.push_back( nID );
					}
				}
			}
			break;
		case SettingCommandType::FLAGS:
			{
				vector<string> vecFlags = HPLString::split( str, "/");
				if( vecFlags.size() < ShotSettingFlagType::MAX_NUM ) {
					HPLError::msg( "Error", MB_OK, "[%s]:flags(%d) != max_num(%d)",
						strLine.c_str(), vecFlags.size() , ShotSettingFlagType::MAX_NUM);
						continue;
				}
				for( int k = 0; k < (int)vecFlags.size(); k ++ ) {
					string s = HPLString::trim( vecFlags[k] );
					bool bFlag = false;
					if( HPLString::equals( s, "TRUE") ) {
						bFlag = true;
					} else if( HPLString::equals( s, "FALSE") ) {
						bFlag = false;
					} else {
						// invalid
						HPLError::msg( "Invalid argument", MB_OK, 
							"(Line:%5d)Not TRUE/FALSE[%s] in [%s]", nLineIndex, s.c_str(), strLine.c_str() );
						return -2;//HPLError::assertIt(HPLString::equals( s, "FALSE") );
					} 

					lpSetting->m_aryFlags[k] = bFlag;
				}
			}
			break;
		default:
			HPLError::assertIt(false,
				"sȖ");
		}
	}
	return 0;
}


/////////////////////////////////////////////////////////////////
// override
void GShotManager::process(bool bIsMove, bool bIsAI) {

	// clear add list
	this->m_vecAdds.clear();
	
	// special stage
	bool bSpecialStage = 
		getStaticData()->getMapType() == MapType::BOSS;

	// mergined game range
	HPLRect merginedGameRange = getStaticData()->getMerginedGameRange();
	// tile size
	int nTileSize = getStaticData()->m_Setting.tileSize;
	// tiled range
	HPLRect tiledRange(0,0,
		(float)nTileSize * getStaticData()->getBlockManager()->getBlockMatrix()->getColumnSize(),
		(float)nTileSize * getStaticData()->getBlockManager()->getBlockMatrix()->getRowSize() );

	for( list<GShot*>::iterator it = this->getList()->begin();
	it != this->getList()->end(); )
	{
		GShot* lpShot = *it;

		bool bIsInGameRange = merginedGameRange.isShare(lpShot->getHitArea());
		bool bIsInTiledRange = tiledRange.isShare( lpShot->getHitArea());

		// Ŏgpp
		bool bIsInGame = bIsInGameRange;

		// ʂɉʊOł
		if( lpShot->getShotClassType() == ShotClassType::LASER || 	// straight laser shots
			lpShot->isHomingLaser() )								// homing laser shots
		{
			// force in game range
			bIsInGameRange = true;
			// force in tiled range
			//bIsInTiledRange = true;
		} else if( Sequence::Shot::SNOW_BALL == lpShot->getType()) {	// snow ball/ rain
			bIsInTiledRange = true;
			if( lpShot->getCenter().getY() > merginedGameRange.getBottom() ) {
				bIsInGameRange = false;
			} else {
				bIsInGameRange = true;
			}
		}

		if( bIsInTiledRange == false) {	// out of tiled range
			// ->
			lpShot->die( NULL );

		} else if( false == bSpecialStage &&	// not special stage
			false == bIsInGameRange )			// not in game range
		{
			// -> die
			lpShot->die( NULL );

		} else if( lpShot->isAlive() ) {	// alive
			
			if( bIsMove ) {	// movable
				CollisionState stateX;
				CollisionState stateY;
				// collision check
				getStaticData()->collisionObject( lpShot, stateX, stateY );
				if( lpShot->getObjectAttribute( ObjectAttribute::HIT_TO_BLOCK ) &&		// hit to block
					lpShot->getObjectAttribute( ObjectAttribute::HIT_BLOCK_TO_DIE ) &&	// die when hit to block
					( stateX.isHitX != 0 || stateY.isHitY != 0 ) )//&&					// hit!
					//lpShot->isAlive() == false )
				{
					HPLVector vCen = lpShot->getCenter();
					HPLVector vBlockCenter = vCen;
					
					if( stateX.isHitX != 0 ) {
						vBlockCenter.set( nTileSize * (stateX.tileCoordX + 0.5f ),
							nTileSize * (stateX.tileCoordY + 0.5f )) ;
					} else if( stateY.isHitY != 0 ) {
						vBlockCenter.set( nTileSize * (stateY.tileCoordX + 0.5f ),
							nTileSize * (stateY.tileCoordY + 0.5f ) );
					}
					vCen.add(vBlockCenter );
					vCen.multiple( 0.5f );

					// create hit effect
					getStaticData()->m_ObjectManager.m_EffectManager.create(
						Sequence::Effect::HIT, vCen, true );
						
				}

				if( lpShot->isAlive() ) {
					// algorithm
					this->algorithm(lpShot);
				}

				if( lpShot->isAlive() && bIsInGameRange  )	// in game range
				{	

					// is hit to player
					bool bIsHit = this->checkHitPlayer( lpShot, &getStaticData()->m_ObjectManager.m_Player );

					if( getStaticData()->isCOMPlayer() ) {
						// there is COM player

						// is hit to COM player
						bIsHit = this->checkHitPlayer( lpShot, &getStaticData()->m_ObjectManager.m_COMPlayer );
					}

					// is hit to other shots
					bIsHit = this->checkHitToShot( lpShot ) != 0;

					// check hit to blocks
					this->checkHitToSpecialTile( lpShot );
				}
			}
		}
		
		
		if( lpShot->isAlive() ) {
			// 
			if( bIsInGame ) {	// ʓ
				lpShot->draw();
			}
			it ++;
		} else {	// dead
			if( this->getUniqueShotFlag( lpShot->getType() ) == lpShot->getID() ) {	// unique shot

				// ->
				this->resetUniqueShotFlag( lpShot->getType() );
			}

			if( bIsInGameRange ) {	// in range
				// -> create another
				if( lpShot->m_nCreateShotTypeWhenDead >= 0 ) {	// this shot has creating after dead
					// create center
					HPLVector vCenter = lpShot->getCenter();

					// special op
					switch( lpShot->getType() ) {	// type
					case Sequence::Shot::THUNDER_BALL:
						{
							HPLImageInformation* lpInfo = getStaticData()->getSequence( SpriteType::SHOT, lpShot->m_nCreateShotTypeWhenDead )->getImageInformation(0);
							int nHeight = (int)lpInfo->srcRect.getHeight();
							vCenter.add(0,nHeight / 2 );
							
						}
						break;
					}
					// create shot
					GShot* lpNewShot = this->create(
						lpShot->m_nCreateShotTypeWhenDead,
						vCenter, lpShot->getParentID(), 
						lpShot->getFaceDirection(), false,
						false ); //new GShot(lpShot->m_nCreateShotTypeWhenDead);

					// blow
					switch( lpNewShot->getType() ){	// type
					case Sequence::Shot::EXPLOSION:	// explosion
						// ї͂́AftHǧ̃Vbg傫ݒ肷
						lpNewShot->m_fBlowSpeed = max( lpNewShot->m_fBlowSpeed, lpShot->m_fBlowSpeed );
						break;
					default:
						lpNewShot->m_fBlowSpeed = lpShot->m_fBlowSpeed;
					}
					// power
					lpNewShot->m_fPower = lpShot->m_fPower;
					// same parent weapon type
					lpNewShot->setParentWeaponType( lpShot->getParentWeaponType() );

					// ꓮ
					switch( lpNewShot->getType() ) {	// type
					case Sequence::Shot::RUNNER_BOLT:	// Runner bolt
						{
							// ɃvC[֑̕悤ɂ
							GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
							// 
							int nFaceDirection = lpPlayer->getCenter().getX() - 
								lpNewShot->getCenter().getX() < 0 ? -1 : 1;
							lpNewShot->setFaceDirection( nFaceDirection );

							// ړʐݒ
							//lpNewShot->setVelocityAngle( (float)nFaceDirection * RUNNER_BOLT_SPEED, 0 );
						}
						break;
						// 
					case Sequence::Shot::CAR_BALL:
						{
							// З͂𗎂Ƃ
							const float POWER_RESIST_FOR_CANNON = 3.f;
							lpNewShot->m_fPower /= POWER_RESIST_FOR_CANNON;
						}
						break;
					}
					this->m_vecAdds.push_back( lpNewShot );

				} else {
					switch( lpShot->getType() ) {
					case Sequence::Shot::WIND_EGG:
						{
							HPLVector vCenter = lpShot->getCenter();

							// generate fan
							GNeutral* lpNeutral = getStaticData()->m_ObjectManager.m_NeutralManager.create(
								Sequence::Neutral::FAN, vCenter, 0,-1);

							// change color
							lpNeutral->setColor(1);

							// create effect
							GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
								Sequence::Effect::WARP, vCenter, true );
						}
						break;
					}
				}
			}
			delete *it;
			it = this->getList()->erase(it);
		}
	}

	for( vector<GShot*>::iterator it = this->m_vecAdds.begin();
	it != this->m_vecAdds.end(); it ++ )
	{
		this->getList()->push_back(*it);
	}

	// 
	int nMapIndex = getStaticData()->getMapIndex();
	switch( nMapIndex ) {
	case SpecialMapIndex::SNOW01:
		{
			HPLVector vCenter(
				HPLMath::nextInt(merginedGameRange.getX() - merginedGameRange.getWidth()/2,
				merginedGameRange.getRight() + merginedGameRange.getWidth()/2 ), 
				merginedGameRange.getY()+10);

//			HPLScroller* lpScroller = getStaticData()->m_ScrollManager.getScroller(0);
//			HPLRect rVir = lpScroller->getVirtualRect();
//			vCenter.add(rVir.getX(), rVir.getY());
			//GShot* lpAdd = this->create( Sequence::Shot::SNOW_BALL,
			//	vCenter, -1, FaceDirection::LEFT, false, true );
			GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
				Sequence::Effect::SNOW_BALL, vCenter, true);
			lpEffect->setVelocityAngle(0,3);
		}
		break;
	}
}

/** e𐶐AXgɉ
  * 
  * @param[in]	t				^Cv
  * @param[in]	center			SW(Global)
  * @param[in]	nParentID		˂IuWFNgID
  * @param[in]	nFaceDirection	ěBړɂĊpxςȅꍇ͈ӖB(LEFTŒ)
  * @param[in]	bIsUnique		j[NesiNULLƂȂ\j
  * @param[in]	bIsAddIntoList	Xgɒǉ邩ǂ
  * @retval		NULL			UniqueŊɐĂꍇ
  */
GShot* GShotManager::create(int nType, HPLVector vCenter, int nParentID,
							int nFaceDirection, bool bIsUnique,
							bool bIsAddIntoList)
{
	// unique 
	if( bIsUnique && this->isUniqueShotFlag( nType ) ) {
		// ɑ݂
		return NULL;
	}
	GShot* lpShot = new GShot( nType );
	lpShot->setCenter( vCenter );
	lpShot->setParentID( nParentID );
	if( false == lpShot->m_bIsDrawRotateByVelocityAngle ) {
		lpShot->setFaceDirection( nFaceDirection );
	}
	if( bIsAddIntoList ) {
		this->getList()->push_back( lpShot );
	}

	if( bIsUnique ) {
		// set unique
		this->setUniqueShotFlag( nType, lpShot->getID() );
	}
	// z[~O
	if( lpShot->m_nHomingType == HomingType::BEZIE ) {
/*		nType == Sequence::Shot::HOMING_LASER ||
		nType == Sequence::Shot::ELECTRIC_HOMING_LASER
		)
	{*/
		// T[`

		GEnemy* lpTargetEnemy = this->getTargettedEnemy();

		HPLVector vTargetCenter;
		if( lpTargetEnemy == NULL ) {
			// Ȃ
			// Ă̕

			HPLRect rGameRange = getStaticData()->getMerginedGameRange();	// Q[g
			//if( HPLMath::nextInt(0,2 ) == 0 ) {
				vTargetCenter.set(
					nFaceDirection == FaceDirection::LEFT ? rGameRange.getX() : rGameRange.getRight(),
					(float)HPLMath::nextInt( static_cast<int>( rGameRange.getY()), static_cast<int>( rGameRange.getBottom()) ) );
			/*} else {
				vTargetCenter.set(
					HPLMath::nextInt( rGameRange.getX(), rGameRange.getRight() ),
					HPLMath::nextInt(0,2) == 0 ? rGameRange.getY() : rGameRange.getBottom() );
			}*/
		} else {
			vTargetCenter = lpTargetEnemy->getCenter();
		}
		HPLVector vUp;
		HPLVector vDown;
		this->m_HomingInformation.getControlPoints(
			vCenter, vTargetCenter, &vUp, &vDown);

		// ZbgAbv
		lpShot->m_lpHomingData->set(
			vCenter, vTargetCenter, vUp, vDown );
	}
	return lpShot;
}


void GShotManager::algorithm(GShot* lpShot) {
	// shot type
	int nType = lpShot->getType();
	
	// ړ (lpShot->collision()Ŏ{ς)
//	HPLVector vCenter = lpShot->getCenter();
//	vCenter.add( lpShot->getVelocityAngle() );
//	lpShot->setCenter( vCenter );

	// level
	float fLevel = getStaticData()->m_Game.getLevel( LEVEL_EPSILON );
	
	float RESIST = getStaticData()->m_Setting.resist;
	float AIR_RESIST = RESIST / 2;
	float GRAVITY = getStaticData()->m_Setting.gravity;

	int st = lpShot->getState()->getState();
	
	if( lpShot->m_nHomingType != HomingType::NONE ) {
		// homing


		// Ώی
		// TODO ASY
		// 1:ŏɌG
		// 2:ԋ߂G
		// 3:t[_		<- r[
		// 4:L			<- 肪ŏꍇǂ邩(idŊoĂH)

		HPLVector vCenter = lpShot->getCenter();
		// x/
		HPLVector vVelocityAngle = lpShot->getVelocityAngle();
		switch( lpShot->m_nHomingType ) {
		case HomingType::BEZIE:
			{
			if( lpShot->m_lpHomingData->m_ForceDeadCounter.step().isFinishAnimation ) {
				// 폜JE^
				// ->
				lpShot->setAlive( false );
			}
#ifdef _DEBUG
				ASSERT_IT_NULL( lpShot->m_lpHomingData );
#endif
				//xWFz[~O(Ώۂ܂Ă^Cv)
				// ^[QbgT[`
				GEnemy* lpTargetEnemy = this->getTargettedEnemy();

				if( lpTargetEnemy != NULL ) {
					// 
					HPLVector vTargetCenter = lpTargetEnemy->getCenter();


					lpShot->m_lpHomingData->m_aryControl[3] = vTargetCenter;
				}
			}
			break;
		case HomingType::MISSILE:
			{
			

				// ݂̊px
				//float fDegree = vVelocityAngle.getDegree();
				//float fLength = vVelocityAngle.getLength();
				// ԋ߂^[Qbg
				HPLShootingObject* lpTarget = this->getNearTarget( lpShot);
				if( lpTarget != NULL) {
					// Ώۂ
					const float MAX_SPEED = 10;
					HPLShootingMove::doMissileHoming( lpShot, lpTarget->getCenter(),
						HOMING_MISSILE_ACCEL, MAX_SPEED);
				} else {
					/*HPLVector vAim = vVelocityAngle;
					vAim.normalize();
					vAim.multiple( HOMING_MISSILE_ACCEL );
					// 
					vVelocityAngle.add( vAim );
					lpShot->setVelocityAngle( vVelocityAngle );*/
				}


				// Ȃ
				// ڕWn_Kȏꏊɂ
				// 
	/*			HPLVector vAdd = vVelocityAngle;
				vAdd.normalize();
				vAdd.multiple*/
			}
			break;
		case HomingType::STOP_MISSILE:
			{
				// 
				// RN{
				const float SHABON_RESIST_RATE = 1.f / fLevel;
				// RlvZ
				float fEnemyResist = 0;//getStaticData()->m_ObjectManager.m_EnemyManager.getEnemyAirResist(1);
				fEnemyResist = RESIST * SHABON_RESIST_RATE;
				// xvZ
				float fSpeed = HPLActionMoveTool::reduceSpeed(
					fEnemyResist, lpShot->getVelocityAngle().getLength() );
				HPLVector v = lpShot->getVelocityAngle();
				v.normalize();
				v.multiple( fSpeed );
				lpShot->setVelocityAngle( v );

				const float EPSILON = 1;
				if( fabs(fSpeed) < EPSILON ) {
					// ~Bʏ̃z[~Os
					lpShot->m_nHomingType = HomingType::MISSILE;
					//lpShot->setVelocityAngle( vel );
				}
			}
			break;
		}
		
	}

	if( 0 <= lpShot->m_nContrailObjectType && 0<= lpShot->m_nContrailType ) {
		// not null?
		HPLError::assertIt(
			NULL != lpShot->m_lpContrailCreateInterval,
			"Contrail counter is null" );
		if( lpShot->m_lpContrailCreateInterval->step().isEndLoop ) {
			switch( lpShot->m_nContrailObjectType ) {
			case ObjectType::EFFECT:
				{
					// create contrail effect
					GEffect* lpEffect = getStaticData()->createEffect( lpShot->m_nContrailType,
						lpShot->getCenter(), lpShot->getCenter(), -1, -1 );
				}
				break;
			case ObjectType::SHOT:
				{
					// 
					GShot* lpNew = getStaticData()->m_ObjectManager.m_ShotManager.create(
						lpShot->m_nContrailType, lpShot->getCenter(), lpShot->getParentID(),
						lpShot->getFaceDirection(), GShot::isUnique( lpShot->m_nContrailType ), 
						false );
					switch( lpShot->getType() ) {
/*					case Sequence::Shot::LAVA_BALL:
						{
							HPLVector c = lpShot->getCenter();
							float fRadius = HPLMath::nextFloat(0, lpShot->getHitRect().getWidth() / 2 );
							float fCreateRad = HPLMath::getRadianFromDegree(HPLMath::nextFloat(0,360) );
							c.add( fRadius * cos(fCreateRad ), fRadius * sin( fCreateRad ) ); 
							//GShot* lpAdd = this->create( Sequence::Shot::FIRE_PARTICLE,
							//	c, lpShot->getID(), lpShot->getFaceDirection(), false, false );
							// n̈ړƋt{_
							lpNew->setCenter( c );
							HPLVector v = lpShot->getVelocityAngle();
							float fDeg = v.getDegree();
							const float ERR = 3;
							v.setByDegree( fDeg + HPLMath::nextFloat( -ERR,ERR));
							const float PARTICLE_SPEED = 3;
							v.multiple( -1 * PARTICLE_SPEED );
							lpNew->setVelocityAngle( v );
						}
						break;*/
					}
					this->addToAdd( lpNew );
				}
				break;
			default:
				ASSERT_IT_TYPE( lpShot->m_nContrailObjectType, "Contrail object type");
			}

		}
	}

	GPlayer* lpPlayer = ((GPlayer*)lpShot->getTarget());

	bool bIsDead = false;	// 񂾁H

	if( lpShot->isClip() ) {
		// Nbv^Cv

		// Uقǂ邩
		bool bIsDeletable = false;
		switch( lpShot->getType() ) {
		case Sequence::Shot::SLIME_CLIP:
		case Sequence::Shot::SNAKE:
			switch( lpShot->getState()->getState() ) {
			case StateType::ATTACK:
				bIsDeletable = true;
				break;
			}
			break;
		}
		if( bIsDeletable ) {
			// vC[̂Ⴊŉ\
			for( int i = 0; i < KeyMap::MAX_KEY; i ++ ) {
				if( lpPlayer->isPressedNow( i ) ){ // && HPLMath::nextFloat(0,100) < SLIME_CLIP_CLEAR_PROBABILITY ) {
					// {^
					if( lpShot->stepClipCounter().isFinishAnimation ) {
						// Uقǂ

						// 
						bIsDead = true;
						lpShot->changeState( StateType::DEAD );
						HPLActionMoveTool::blowAway( lpPlayer, lpShot, 5 );
						lpShot->setObjectAttribute( ObjectAttribute::GRAVITY, true );
						break;
					}
				}
			}
		}
	}

	bool bIsIntervalDamage = false;	//! ȂǁAIɃ_[W^

	bool bIsReduceSpeedVel = false;	//! CRȂǂŌ邩H
	float fReduceResist = 0;	//! Rl
	float fReduceMinimumSpeed = 0;	//! Œᑬx
	
	bool bIsReduceSpeedX = false;	//! ̂݋CRŌ

	switch( nType ) {
	case Sequence::Shot::PINE_APPLE_0:
	case Sequence::Shot::SEED:
		{
			// ]
			HPLActionMoveTool::stepRotate(
				lpShot, ROTATE_STOP_VELOCITY_THRESHOLD );
		}
		break;
	case Sequence::Shot::HOMING_MISSILE:
		// z[~Ô
		break;
	case Sequence::Shot::MISSILE:
		{
			// I

			// ݂̑x
			HPLVector vNewVelocityAngle = lpShot->getVelocityAngle();

			// Newx
			float fNewSpeed = HPLActionMoveTool::accelMove( vNewVelocityAngle.getLength(),
				MISSILE_ACCEL, MISSILE_MAX_SPEED );

			vNewVelocityAngle.normalize();
			vNewVelocityAngle.multiple( fNewSpeed );
			lpShot->setVelocityAngle( vNewVelocityAngle  );
		}
		break;
	case Sequence::Shot::NIKITA_MISSILE:
		{
			GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
			// ړ
			int nDX = 0;
			int nDY = 0;
			if( lpPlayer->isPressed( KeyMap::UP ) ) {
				nDY --;
			}
			if( lpPlayer->isPressed( KeyMap::DOWN ) ) {
				nDY ++;
			}
			if( lpPlayer->isPressed( KeyMap::LEFT ) ) {
				nDX --;
			}
			if( lpPlayer->isPressed( KeyMap::RIGHT ) ) {
				nDX ++;
			}
			if( 0 != nDX || 0 != nDY ) {
				// px쐬
				HPLVector v( nDX, nDY );
				float fDeg = v.getDegree();

				float fCurrentDeg = lpPlayer->m_vSniperVelocity.getDegree();

				float fDeltaDeg = fDeg - fCurrentDeg;

				// 0x܂ł
				if( fDeltaDeg < -180 ) {
					fDeltaDeg += 360;
				}
				const float NIKITA_ROTATE_SPEED = 5;
				fCurrentDeg += HPLMath::getSgn<float>(fDeltaDeg) * NIKITA_ROTATE_SPEED;

				HPLVector vVelocityAngle;
				// Vpxɂ
				vVelocityAngle.setByDegree( fCurrentDeg );
				const float NIKITA_MISSILE_SPEED = 5;	//! Xs[h
				vVelocityAngle.multiple( NIKITA_MISSILE_SPEED );

				// Vbgɔf
				lpShot->setVelocityAngle( vVelocityAngle );
				
				// sniper velocityɔf
				float fLength = lpPlayer->m_vSniperVelocity.getLength();
				lpPlayer->m_vSniperVelocity.setByDegree( fCurrentDeg );
			}
			HPLVector c = lpShot->getCenter();
			c.add( lpShot->getVelocityAngle() );
			lpShot->setCenter( c );
		}
		break;
	case Sequence::Shot::SPIDER_NET:
		{
			if( lpShot->getState()->getState() == StateType::ATTACK ) {
				// vC[ɂ킹
				lpShot->setCenter( lpShot->getTarget()->getCenter() );

				if( false == bIsDead ) {
					// x0ɂ
					lpPlayer->setVelocityAngle(0,0);

					// _[WԂɂiۂ̃_[W͗^Ȃj
					lpPlayer->changeState( StateType::DAMAGE );
				}
			}
		}
		break;
	case Sequence::Shot::SNAKE:
		{
			if( false == bIsDead && lpShot->getState()->getState() == StateType::ATTACK ) {
				// U[h
				// ʒuvC[ɍ킹
				const float SNAKE_SLOW_RATE = 0.3f / fLevel;
				GPlayer* lpPlayer = ((GPlayer*)lpShot->getTarget());
				this->slowDown(lpPlayer, SNAKE_SLOW_RATE );
			}
		}
		break;
	case Sequence::Shot::SLIME_CLIP:
		{
			if( lpShot->getState()->getState() == StateType::ATTACK ) {
				GPlayer* lpPlayer = ((GPlayer*)lpShot->getTarget());

				if( false == bIsDead ) {
					switch( lpShot->getColor()) {
					case 2: //green
						{
							// x
							this->slowDown( lpPlayer, GREEN_SLIME_CLIP_DOWN_RATE );
						}
						break;
					case 3:	//yellow
						{
							// X_[W^
							if( lpShot->m_DamageIntervalCounter.step().isFinishAnimation ) {
								

								// damage player
								// no invinsible bonus
								((GPlayer*)lpShot->getTarget())->damage( lpShot->m_fPower,lpShot,  false, StateType::DAMAGE_ELEC);

								lpShot->m_DamageIntervalCounter.reset();
							}

						}
						break;
					default:
	#ifdef _DEBUG
						ASSERT_IT_TYPE( lpShot->getColor(), "shot color");
//						HPLError::assertIt(false);
	#endif
						// \Ȃ
						break;
					}
				}
			}
		}
		break;
	case Sequence::Shot::MAYO:
		{
			// CR󂯂
//			HPLVector vVelocityAngle = lpShot->getVelocityAngle();
//			const float REDUCE_RATE = 0.1f;
			bIsReduceSpeedX = true;
			fReduceResist = RESIST * 0.5f;
//			vVelocityAngle.multiple( REDUCE_RATE );
//			lpShot->setVelocityAngle(vVelocityAngle );
		}

		break;
	case Sequence::Shot::ELEC:
		{
			const float ELEC_MAX_SPEED = 5;
			const float ELEC_ACCEL = 0.1f;
			HPLVector v = lpShot->getVelocityAngle();
			// 
			float fSpeed = HPLActionMoveTool::accelMove(
				v.getLength(), ELEC_ACCEL, ELEC_MAX_SPEED );
			v.normalize();
			v.multiple( fSpeed );
			lpShot->setVelocityAngle( v );
		}
		break;
	case Sequence::Shot::WIND:
		{
			// 葬x
			// ]
			const float WIND_ROTATE_DEG_SPEED = 0.4f;
			HPLVector v = lpShot->getVelocityAngle();
			float fDegree = v.getDegree() + WIND_ROTATE_DEG_SPEED;
			if( fDegree >= HPLMathConsts::DEGREE_FULL_ROUND ) {
				fDegree -= HPLMathConsts::DEGREE_FULL_ROUND;
			}
			float fSpeed = v.getLength();
			v.setByDegree( fDegree );
			v.multiple( fSpeed );
			lpShot->setVelocityAngle( v );
		}
		break;
	case Sequence::Shot::SKYTHE:
		{
			const float ROTATE_DEG_SPEED = 4.f;

			// ]
			float fDeg = lpShot->getRotateDegree() + ROTATE_DEG_SPEED;
			if( fDeg > HPLMathConsts::DEGREE_FULL_ROUND ) {
				fDeg -= HPLMathConsts::DEGREE_FULL_ROUND;
			}
			lpShot->setRotateDegree( fDeg );
		}
		break;
	case Sequence::Shot::FALL_ICE:
		{

			const float FALL_GRAVITY_RATE = 0.25;
			const float FALL_ICE_MAX_SPEED = 5;
			HPLVector vVel = lpShot->getVelocityAngle();
			vVel.setY( HPLActionMoveTool::accelMove(
				vVel.getY(), GRAVITY * FALL_GRAVITY_RATE, FALL_ICE_MAX_SPEED ) );
			vVel.setX( HPLActionMoveTool::reduceSpeed(
				RESIST * RESIST_IN_THE_AIR_RATE * 0.1f, vVel.getX() ) );
			lpShot->setVelocityAngle( vVel );
		}
		break;
/*	case Sequence::Shot::LAVA_BALL:
		{
//			this->m_vecAdds.push_back( lpAdd );
			//bIsDieAfterFinishAnimation = true;
		}
		break;*/
	case Sequence::Shot::SHABON:
		{
			bIsReduceSpeedX = true;
			// RN{
			const float SHABON_RESIST_RATE = 0.03f;// / fLevel;
			// RlvZ
			fReduceResist = RESIST * SHABON_RESIST_RATE;
		}
		break;
	case Sequence::Shot::RUNNER_BOLT:
		{
			lpShot->setVelocityAngle( (float)lpShot->getFaceDirection() * RUNNER_BOLT_SPEED, 0 );
		}
		break;
	case Sequence::Shot::SPREAD_MISSILE:
		{
			// CR
			bIsReduceSpeedVel = true;
			fReduceResist = RESIST * 0.08f;

		}
		break;
	case Sequence::Shot::THUNDER_BALL:
		{
			// CR
			bIsReduceSpeedVel = true;
			fReduceResist = RESIST * 0.08f;
		}
		break;
	case Sequence::Shot::SPREADED_MISSILE:
		{
			// 
			bIsReduceSpeedVel = true;
			fReduceResist = RESIST * 0.08f;
			const float MINIMUM_SPEED = 4;
			fReduceMinimumSpeed = MINIMUM_SPEED;
			
		}
		break;
	case Sequence::Shot::SNOW_BALL:
		{
			const int SNOW_FALL_SPEED = 3;
			// 葬xŗ
			lpShot->setVelocityAngle( 0, SNOW_FALL_SPEED);
		}
		break;
	case Sequence::Shot::SOWRD:
		{
			bIsReduceSpeedVel = true;
			fReduceResist = RESIST * 0.2f;
			const float MINIMUM_SPEED = 0;
			fReduceMinimumSpeed = MINIMUM_SPEED;
		}
		break;
	default:
		break;
	}

	if( lpShot->isUseReduceAccel() ) {
		HPLVector v = lpShot->getVelocityAngle();
		// xvZ
		float fSpeed = HPLActionMoveTool::reduceSpeed(
			lpShot->getReduceAccel(), v.getLength(), 0 );
		v.normalize();
		v.multiple( fSpeed);
		lpShot->setVelocityAngle( v);

	} else if( bIsReduceSpeedX ) {	// CR on (̂
		// xvZ
		float fSpeed = HPLActionMoveTool::reduceSpeed(
			fReduceResist, lpShot->getVelocityAngle().getX(), fReduceMinimumSpeed );
		HPLVector v = lpShot->getVelocityAngle();
		v.setX( fSpeed );
		lpShot->setVelocityAngle( v );

	} else if( bIsReduceSpeedVel ) {	// CR on (S)
		HPLVector v = lpShot->getVelocityAngle();
		// reduce speed
		float fSpeed = HPLActionMoveTool::reduceSpeed(
			fReduceResist, v.getLength(), fReduceMinimumSpeed );

		v.normalize();
		v.multiple( fSpeed );
		lpShot->setVelocityAngle( v );
	}
	if( lpShot->isClip() && st == StateType::ATTACK ) {
		// ^Cv
		// ->ʒuvC[ɍ킹
		HPLVector vCenter = lpShot->getTarget()->getCenter();
		vCenter.add( lpShot->m_Delta );
		lpShot->setCenter(vCenter );
	}
}

/** Ώۂ
  */
int GShotManager::slowDown( HPLShootingObject* lpTarget, float fRate ) {
	HPLVector vPlayerVelocityAngle = lpTarget->getVelocityAngle();
	vPlayerVelocityAngle.setX( vPlayerVelocityAngle.getX() * fRate );
	lpTarget->setVelocityAngle(vPlayerVelocityAngle);
	return 0;
}


bool GShotManager::checkHitPlayer( GShot* lpShot, GPlayer* lpPlayer ) {
	bool bIsHit = false;

	// cheat
	if( getStaticData()->m_Game.isCheat() ) {
		return false;
	}
	if( getStaticData()->m_Game.isScenario() &&
		getStaticData()->m_SceneManager.getSceneType() != SceneType::LIBRARY)
	{	// in scenario mode(except library)
		return false;
	}
	// XLbv
	if( lpShot->isAlive() == false ) {
		// ł
		return false;
	}
	if( lpPlayer->getState()->isIgnoreAfterDie() ) {
		// ȂXe[^X
		return false;
	}
	if( //lpShot->isHitToPlayer() == false ||
		lpShot->getObjectAttribute( ObjectAttribute::HIT_TO_PLAYER ) == false)
	{
		// Ȃ
		return false;
	}
	if( lpPlayer->isInvinsible() ) {
		// G
		return false;
	}
	if( lpPlayer->isHeld() ) {
		// ܂Ă
		return false;
	}
	if( lpShot->isClip() ) {
		if( lpShot->getState()->getState() != StateType::STAND ) {
			// ʏ펞ȊO͂Ȃ
			return false;
		}
	}
	switch( lpShot->getType() ) {
	case Sequence::Shot::TENTACLE:
		if( lpShot->getSequence()->getFrameIndex() != 1 ) {
			// LтuԈȊO͂Ȃ
			return false;
		}
		break;
	case Sequence::Shot::STONE_CURSE:
		if( lpShot->getFaceDirection() * lpPlayer->getFaceDirection() > 0 ) {
			// VbgƋtĂ
			return false;
		}
		break;
	}

	

	HPLRect rHitArea = lpPlayer->getHitArea();

	HPLRect rShotHitArea = lpShot->getHitArea();

	HPLRect rGameRange = getStaticData()->getMerginedGameRange();
	if( rGameRange.isShare( rShotHitArea ) == false ) {	// SʊOȂ画肷Kv
		return false;
	}
	if( rHitArea.isShare( rShotHitArea ) ) {

		// qbg
		bIsHit = true;

		switch( lpShot->getType() ) {
		case Sequence::Shot::SPIDER_NET:
		case Sequence::Shot::SLIME_CLIP:
		case Sequence::Shot::SNAKE:
			{
				// XCNbv
				// ΍W𓾂
				lpShot->m_Delta.set(
					lpShot->getCenter().getX() - lpPlayer->getCenter().getX(),
					lpShot->getCenter().getY() - lpPlayer->getCenter().getY() );

				// ԕω
				lpShot->changeState( StateType::ATTACK );
				lpShot->setObjectAttribute( ObjectAttribute::GRAVITY, false );	// d͂󂯂Ȃ悤ɂ
				lpShot->setVelocityAngle( 0,0);
			}
			break;
		default:
			{
				// ̏ԁi_[Wԁj
				int nNextDamageState = StateType::DAMAGE;

				if( lpShot->getDamageType( DamageType::FIRE ) ){	// ΂̍UI

					// _[WG
					nNextDamageState = StateType::DAMAGE_FLAME;
				} else if( lpShot->getDamageType( DamageType::ICE ) ) {	// X̍U
					//͈̂ꕔ̓Gɂ
					switch( lpShot->getType() ) {
					case Sequence::Shot::ICE:
						lpPlayer->m_SolidData.setType( SolidType::CRYO );
						break;
					}
				} else {
					if( lpShot->getType() == Sequence::Shot::KAHUN ) {
						// erogen
						nNextDamageState = StateType::HOLD_DOWN;//JII;
					} else if( lpShot->getType( ) == Sequence::Shot::STONE_CURSE ) {
						lpPlayer->m_SolidData.setType( SolidType::STONE );
					}
				}


				// ΂炭Gɂ
				bool bIsInvinsible = true;	

				// _[W
				float fDamage = lpShot->m_fPower;
				
				// ɂă_[WʂقȂ
				fDamage *= WEAR_DAMAGE_RAGE[lpPlayer->m_nWearState];

				if( lpShot->getType() == Sequence::Shot::EXPLOSION &&
					lpShot->getParentID() == lpPlayer->getID()
					)
				{
					// n̔
					// 
					fDamage /= 2;

					const float MAX_SELF_DAMAGE = 0.9f;
					if( fDamage >= lpPlayer->getHPMax() ) {
						fDamage = lpPlayer->getHPMax() * MAX_SELF_DAMAGE;
					}
				}

				// _[W
				lpPlayer->damage( fDamage, lpShot, bIsInvinsible, nNextDamageState );

				// ӂƂ
				HPLActionMoveTool::blowAway( lpShot, lpPlayer, lpShot->m_fBlowSpeed );

				switch( lpShot->getParentWeaponType() ) {
				case WeaponType::PINE_APPLE:
				case WeaponType::TOMAHAWK:
					getStaticData()->stepAndCheckAchievement(
						AchievementType::APPLE_JUMPER, 1, true );
					break;
				case WeaponType::MISSILE_LAUNCHER:
				case WeaponType::HOMING_MISSILE_LAUNCHER:
					getStaticData()->stepAndCheckAchievement(
						AchievementType::MISSILE_JUMPER, 1, true );
					break;
				}
				// 
				if( lpShot->getObjectAttribute(ObjectAttribute::HIT_OBJECT_TO_DIE) ) {
					lpShot->die(NULL);
				}
			}
		}
		
	}

	return bIsHit;
}

GEnemy* GShotManager::getTargettedEnemy() {

/*	for( list<GEnemy*>::iterator it = getStaticData()->m_ObjectManager.m_EnemyManager.getList()->begin();
		it != getStaticData()->m_ObjectManager.m_EnemyManager.getList()->end();
		it ++ )
	{
		GEnemy* lpEnemy = *it;

		if( lpEnemy->m_TargettedRemainCounter.getState().isFinishAnimation ) {
			// ^[QbeBOĂȂ
			continue;
		}
		return lpEnemy;
	}
	return NULL;*/

	return getStaticData()->m_ObjectManager.m_EnemyManager.getStepTargettedEnemy();
}


HPLShootingObject* GShotManager::getNearTarget(GShot* lpShot) {
	if( lpShot->isAlive() == false ) {
		return NULL;
	}
	if( lpShot->getForceType() == ForceType::ENEMY ) {
		return lpShot->getTarget();
	}
	if( false == lpShot->getObjectAttribute(ObjectAttribute::HIT_TO_ENEMY) ) {
		return NULL;
	}

	HPLVector vCenter = lpShot->getCenter();
	HPLRect rMergined = getStaticData()->getMerginedGameRange();
	for( list<GEnemy*>::iterator it = getStaticData()->m_ObjectManager.m_EnemyManager.getList()->begin();
		it != getStaticData()->m_ObjectManager.m_EnemyManager.getList()->end(); it ++ )
	{
		GEnemy* lpEnemy = *it;
		if( false == rMergined.isShare( lpEnemy->getHitArea()) ) {
			continue;
		}
		if( lpEnemy->isAlive() == false ) {
			continue;
		}
		if( false == lpEnemy->getObjectAttribute(ObjectAttribute::HIT_TO_SHOT) ) {
			continue;
		}

		HPLVector vEnemyCenter = lpEnemy->getCenter();
		HPLVector vSub = vEnemyCenter;
		vSub.multiple(-1);
		vSub.add( vCenter);
		if( vSub.getLength() <= HOMING_TARGET_LENGTH_THRESHOLD ) {
			return lpEnemy;
		}
	}
	return NULL;
}

bool isDie( int nType ) {
	switch( nType ) {
	case Sequence::Shot::SEED:
		return false;
	}
	return true;
}
/** ̃Vbgǂ
  * @retval	
  */
int GShotManager::checkHitToShot( GShot* lpShot ) {
	int nHitNum = 0;	// qbgv

	if( lpShot->isAlive() == false ) {
		// ł
		return 0;
	}

	// 
	if( lpShot->getForceType() == ForceType::ENEMY )
	{
		// G̃Vbg͊ĎȂI
		return 0;
	}

	// Vbg̕ӂ蔻̈
	HPLRect rHitArea = lpShot->getHitArea();

	// ʊOȂ炱ɂ͓ĂȂ̂OK
	
	// 鑤
	for( list<GShot*>::iterator it = this->getList()->begin(); it != this->getList()->end();
		it ++ )
	{
		// other shot(鑤̒e)
		GShot* lpOther = *it;
		if( lpOther == lpShot ) {	// 
			continue;
		}
		if( lpOther->isAlive() == false ) {	// Ɏł
			continue;
		}
		if( lpOther->getForceType() == ForceType::ALLY &&	// target is ally shots
			lpOther->getType() != Sequence::Shot::SEED &&	// not seed
			lpOther->getSolidType() != SolidType::CRYO)		// target is not solided
		{
			// skip
			continue;
		}
		// bezier homing lasers
		if( lpOther->m_nHomingType == HomingType::BEZIE ) {
			// skip
			continue;
		}
		/*if( lpOther->getType() != Sequence::Shot::WATER ) {
			continue;
		}*/

		// this shot is weakness type for other shot
		bool bIsWeakness = false;
		{
			bool bIsForceCheck = false;	// force check!
//			switch( lpOther->getType() ) {
//			case Sequence::Shot::SHABON:
//				bIsForceCheck = true;
//				break;
//			}
			if( bIsForceCheck == false ) {
				
				if( ( lpShot->getDamageTypeFull() & lpOther->m_Weakness.getFull() ) != 0 ) {	// has weakness
					bIsWeakness = true;
				} else if( (lpShot->getDamageTypeFull() & lpOther->m_Immunities.getFull() ) != 0 ) {	// has immunities
				} else if( lpOther->getType() != Sequence::Shot::SEED ) {
					continue;
				}
			}
		}

		HPLRect rOtherHitArea = lpOther->getHitArea();	// hit area
		bool bIsHit = false;	// hit!
		if( lpShot->getShotClassType() == ShotClassType::LASER ) {	// straight laser
			
			if( HPLActionMoveTool::isHitObjectToLaser( lpShot, true,
				lpOther, lpOther->getHitRect().getWidth() / 2 ) )	// laser hit check
			{
				bIsHit = true;
			}

		} else {
			if( rOtherHitArea.isShare( rHitArea ) ) {	// object hit check
				bIsHit = true;
			}
		}
		if( bIsHit ) {
			// hit

			bool bIsDieOther = true;	// iG̒ej͎

			if( bIsWeakness &&		// weakness!(ImmunitiesȂωȂ)
				lpShot->getType() == Sequence::Shot::ICE &&				// ICE!
//				lpOther->getType() == Sequence::Shot::LAVA_BALL &&
				lpOther->getSolidType() == SolidType::NONE)				// ł܂ĂȂ
			{
				// 点
				lpOther->setSolidType( SolidType::CRYO);
				// ϐt](_F͂̂܂)
				lpOther->m_Weakness.set( DamageType::FIRE, true);
				lpOther->m_Immunities.set( DamageType::FIRE, false);	// ΂ɎキȂ
				lpOther->m_Immunities.set( DamageType::ICE, false);		// ϐ
				bIsDieOther = false;	// 邾ŎȂȂ
			}

			if( lpShot->m_nHomingType == HomingType::BEZIE ||
				lpShot->getShotClassType() != ShotClassType::LASER &&	// not laser
				isDie( lpShot->getType() ) )		// 玀ʒe
			{
				// 
				//lpShot->setAlive( false );
				lpShot->damage( lpOther->m_fPower, lpOther );
			}
			
			if( bIsWeakness &&
				bIsDieOther &&		// this shot makes other-shot die!
				isDie( lpOther->getType() ) )	// 
			{
				// _[WI
				//lpOther->setAlive( false );
				lpOther->damage( lpShot->m_fPower, lpShot );
			}

			bool bIsHitEffect = true;
			switch( lpOther->getType() ) {
			case Sequence::Shot::FIRE_PARTICLE:
				bIsHitEffect = false;
				break;
			}
			if( bIsHitEffect ) {
				// hit effect
				GEffect* lpEffect = getStaticData()->m_ObjectManager.m_EffectManager.create(
					Sequence::Effect::HIT, lpOther->getCenter(), true );
			}
		}
	}
	return 0;
}


/** ^CɐڐGǂ
  */
bool GShotManager::checkHitToSpecialTile( GShot* lpShot) {

	// hit H
	bool bIsHit = false;

	if( lpShot->getForceType() == ForceType::ENEMY ) { // enemy shot
		return false;
	}
	if( lpShot->getDamageType( DamageType::ICE ) ){	// ice
		// check !
	} else {	// not ice
		return false;
	}

	// unuse
	// ݐڐGĂ^Cꗗp}gNX
//	HPLMatrix<int> mat;

	// hit AREA of shot
	HPLRect rHitArea = lpShot->getHitArea();
	// tile size
	int nTileSize = getStaticData()->m_Setting.tileSize;
	// matrix
	HPLMatrix<int>* lpMat = getStaticData()->m_BlockManager.getBlockMatrix();
	// check coordinates
	for( int y = rHitArea.getY() / nTileSize ; y <= rHitArea.getBottom() / nTileSize; y ++ ) {	// y
		for( int x = rHitArea.getX() / nTileSize ; x <= rHitArea.getRight() / nTileSize; x ++ ) {	// x
			// block id
			int nBlockID = lpMat->get(x,y);
			// game tile type
			int nGameTileType = getStaticData()->m_ObjectManager.getGameTileType( nBlockID );
			switch( nGameTileType ) {	// game tile type
			case GameTileType::LAVA:	// lava
				if( lpShot->getDamageType(DamageType::ICE ) ) {	// ice in lava
					// ɂ
					int nNewBlockID = SpecialBlockID::WATER;
					if( nBlockID == SpecialBlockID::LAVA_SURFACE ) {
						nNewBlockID = SpecialBlockID::WATER_SURFACE;
					}
					// change tile!
					lpMat->set(x,y, nNewBlockID );
				}
			}
		}
	}

	return bIsHit;
}

