#ifndef _G_SHOT_MANAGER_
#define _G_SHOT_MANAGER_

#include <hpllib/cycle/HPLObjectManager.h>
#include "GPlayer.h"
#include "GShot.h"
#include "GEnemy.h"
#include <vector>

#include "GShotSetting.h"
#include "GShotConsts.h"

namespace GEnum {
	namespace GShotManagerConsts {
		static int UNIQUE_SHOT_NONE_ID_NUMBER = -1;	//! j[NVbgǗ
		//!u݂Ȃv킷IDԍ
	}
}
/*
class GShotSetting {

	// Member vriable
public:
	
	HPLRect		m_HitRect;				//! A^̈
	float		m_fPowerRate;			//! ڐGU͔
	float		m_fBlowRate;
	bool		m_aryFlags[GEnum::ShotFlagType::MAX_NUM];
	
	// Constructor
public:
	GShotSetting(){
		this->clear();
	}
	void clear() {
		this->m_HitRect.set(0,0,2,2);
		this->m_fPowerRate = 1;
		this->m_fBlowRate = 1;
		for( int i = 0; i < GEnum::ShotFlagType::MAX_NUM; i ++ ) {
			this->m_aryFlags[i] = GEnum::DEFAULT_SHOT_FLAGS[i];
		}
	}
	~GShotSetting(){}
};
*/
/** VbgǗ
  */
class GShotManager: public HPLObjectManager<GShot> {
private:
//	std::map<int,GShotSetting>	m_mapShotSettings;	//! Vbgݒ
	std::vector<GShot*> m_vecAdds;			//! ǉp
	HomingInformation m_HomingInformation;	//! z[~O
	int m_aryUniqueShotFlag[GEnum::Sequence::Shot::MAX_NUM];	//! Q[ɂ݂ep(ID)
	// eɔB݂ꍇcreateNULLԂB(Iɂ߁BfobOpj
	// eʍۂɔi-1j
	GShotSetting m_aryShotSettings[GEnum::Sequence::Shot::MAX_NUM];
	int parseSettingLine( int nLineIndex, std::string& strLine, GShotSetting* lpSetting );


private:	// Getter/Setter( private )
	void setUniqueShotFlag( int nShotType, int nID ) {
		// Ȓlł邱
//		HPLError::assertIt( nShotType >= 0 && nShotType < GEnum::Sequence::Shot::MAX_NUM );
#ifdef _DEBUG
		ASSERT_IT_INDEX(nShotType, 0, GEnum::Sequence::Shot::MAX_NUM );
#endif

		int nFlag = this->getUniqueShotFlag( nShotType );
		int nTarget = GEnum::GShotManagerConsts::UNIQUE_SHOT_NONE_ID_NUMBER;
		// o^ł邱
		HPLError::assertIt( nFlag == nTarget ,
			"%s:flag is not unique shot:Flat=%d, Target=%d", nFlag, nTarget);
		this->m_aryUniqueShotFlag[nShotType] = nID;
	}
	void resetUniqueShotFlag( int nShotType ) {
		// w肵ShotTypẽj[NID폜
		// Ȓlł邱
#ifdef _DEBUG
		ASSERT_IT_INDEX(nShotType, 0, GEnum::Sequence::Shot::MAX_NUM );
#endif
//		HPLError::assertIt( nShotType >= 0 && nShotType < GEnum::Sequence::Shot::MAX_NUM );
		this->m_aryUniqueShotFlag[nShotType] = GEnum::GShotManagerConsts::UNIQUE_SHOT_NONE_ID_NUMBER;
	}
	/** eׂďɂ͂s
	  */
	void resetUniqueShotFlag( ) {
		for( int i = 0; i < GEnum::Sequence::Shot::MAX_NUM; i ++ ) {
			m_aryUniqueShotFlag[i] = GEnum::GShotManagerConsts::UNIQUE_SHOT_NONE_ID_NUMBER;
		}
	}
	int getUniqueShotFlag( int nShotType ) {
		// Ȓlł邱
#ifdef _DEBUG
		ASSERT_IT_INDEX(nShotType, 0, GEnum::Sequence::Shot::MAX_NUM );
#endif
//		HPLError::assertIt( nShotType >= 0 && nShotType < GEnum::Sequence::Shot::MAX_NUM );
		return this->m_aryUniqueShotFlag[nShotType];
	}
public:		// Getter/Setter
	void addToAdd( GShot* lpShot ) {
		this->m_vecAdds.push_back( lpShot );
	}
	GShotSetting* getShotSetting( int nIndex ) {
#ifdef _DEBUG
		ASSERT_IT_INDEX(nIndex, 0, SIZEOF(this->m_aryShotSettings ) );
#endif
//#ifdef _DEBUG
//		HPLError::assertIt( nIndex >= 0 && nIndex < SIZEOF(this->m_aryShotSettings ) );
//#endif
		return &this->m_aryShotSettings[nIndex];
	}
	/** Unique
	  */
	bool isUniqueShotFlag( int nShotType ) {
		if( this->getUniqueShotFlag( nShotType ) != GEnum::GShotManagerConsts::UNIQUE_SHOT_NONE_ID_NUMBER ) {
			return true;
		} 
		return false;
	}


public:	// constructor
	GShotManager();//
	
	virtual ~GShotManager(){}

private:	// operation (private)

public:	// operation (public)
	void process(bool isMove, bool bIsAI);

	/** e𐶐AXgɉ
	  * 
	  * @param[in]	t				^Cv
	  * @param[in]	center			SW(Global)
	  * @param[in]	nParentID		˂IuWFNgID
	  * @param[in]	nFaceDirection	ěBړɂĊpxςȅꍇ͈ӖB(LEFTŒ)
	  * @param[in]	bIsUnique		j[NesiNULLƂȂ\j
	  * @param[in]	bIsAddIntoList	Xgɒǉ邩ǂ
	  */
	GShot* create(int t, HPLVector center, int nParentID, int nFaceDirection,
		bool bIsUnique , bool bIsAddIntoList );

	/** ʏ
	  */
	void algorithm(GShot* effect);

	/** vC[ւ̃qbg`FbNƁAqbg̏
	  */
	bool checkHitPlayer( GShot* lpShot, GPlayer* lpPlayer );

	/** ̃VbgɃqbg邩
	  */
	int checkHitToShot( GShot* lpShot );

	/** NbveUقǂǂ
	  */
	bool tryRevealClip( GShot* lpShot, GPlayer* lpTarget );

	/** Vbgݒ肽ǂݍ
	  */
	void loadShotSettings();

	/** ^CɐڐGǂ
	  */
	bool checkHitToSpecialTile( GShot* lpShot);
	
private:
	/** ^[QbgꂽGT
	  * ȂꍇNULL
	  */
	GEnemy* getTargettedEnemy();

	/** ԍŏɌA߂̂ɑ΂ăz[~O
	  *
	  */
	HPLShootingObject* getNearTarget(GShot* lpShot);

	void getRidOut( GShot* lpShot );

	/** Ώۂ
	  */
	int slowDown( HPLShootingObject* lpTarget, float fRate );
public:
	// @override
	void clear() {
		HPLObjectManager<GShot>::clear();
		// unique Vbg폜
		this->resetUniqueShotFlag();
	}
};

#endif
