#ifndef _G_SHOT_SETTING_
#define _G_SHOT_SETTING_

#include <string>
#include <vector>
#include <hpllib/math/HPLRect.h>
#include <HPLDXLib.h>

namespace GEnum {
	namespace ShotSettingFlagType {
		enum {
			THROW_BLOCK,
			HIT_TO_NEUTRAL,
			HIT_TO_SHOT,
			HIT_OBJECT_TO_DIE,
			GRAVITY,
			ENEMY_SHOT,
			MAX_NUM
		};
	}
}

class GShotSetting {
public:
	std::string m_strName;
	int m_nID;
	//HPLRect m_rHitRect;
	int m_aryHitRect[4];
	int m_nPower;	// x1
	int m_nBlowSpeed;	// x1
	std::vector<int> m_vecExtraSequenceID;
	bool m_aryFlags[GEnum::ShotSettingFlagType::MAX_NUM];
public:
	GShotSetting() {
		this->m_nID = -1;
		for( int i = 0; i < GEnum::ShotSettingFlagType::MAX_NUM; i ++ ) {
			this->m_aryFlags[i] = false;
		}
		this->m_nPower = 10;
		this->m_nBlowSpeed = 10;
		for( int i = 0; i < SIZEOF(m_aryHitRect ); i ++ ) {
			this->m_aryHitRect[i] = 0;
		}
	}
	~GShotSetting() {
	}
	
};

#endif
