#include "GSpecialDeadScene.h"

#include "GStaticData.h"
#include <hpllib/general/HPLString.h>
#include <hpllib/math/HPLMath.h>
#include "GPlayerManager.h"

using namespace GEnum;
using namespace std;

GSpecialDeadScene::GSpecialDeadScene() :AbstractScene() {
	this->m_nPreviousMap = -1;
}

GSpecialDeadScene::~GSpecialDeadScene() {
}
void GSpecialDeadScene::setScenarioIndex( int nScenarioIndex ) {
	switch( nScenarioIndex ) {
	case SpecialDeadEventID::WORM:	// worm
		// event ͂ȂHTODO 邩
		nScenarioIndex = -1;
		break;
	}
	this->m_nScenarioIndex = nScenarioIndex;
}

static const int INTERVAL_MIN = 50;
static const int INTERVAL_MAX = 100;
void setNextInterval( HPLCounter* lpCounter, int nMin, int nMax ) {
	lpCounter->reset();
	lpCounter->setWaitFrameNum( HPLMath::nextInt( nMin, nMax ));
}
void GSpecialDeadScene::init() {
	// BGMύX
	getStaticData()->m_MixerManager.playMusic(Music::BAD_END, true );
	this->m_nPreviousRKey = 0;

	// ViIǂݍ
	getStaticData()->m_EventPackManager.load(
		"data/event/EventPack-SpecialDead-ThirdPerson.txt");


	// ViIJn
	if( this->m_nScenarioIndex >= 0 ) {
		getStaticData()->startEvent( this->m_nScenarioIndex, true );
	}
	getStaticData()->m_ObjectManager.m_Player.setAlive( true );

	bool bIsAdjust = false;
	// 
	switch( this->m_nScenarioIndex ) {
	case SpecialDeadEventID::CHASER_BAD:
		{
			bIsAdjust = true;
			getStaticData()->setupMap( SpecialMapIndex::CHASER_BAD, false );

			// player
			GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
			lpPlayer->setFaceDirection( FaceDirection::LEFT) ;
			// create chaser
/*			getStaticData()->m_ObjectManager.m_EnemyManager.create(
				EnemyType::CHASER, lpPlayer->getCenter(),
				-1);*/

			setNextInterval( &this->m_IntervalCounter, INTERVAL_MIN,INTERVAL_MAX);

		}
		break;
	}

	if( bIsAdjust ) {
		// XN[[
		HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(0);

		// XN[
		getStaticData()->adjustScroll( scroller );
	}
}
void GSpecialDeadScene::quit() {
	getStaticData()->m_EventImage.deactivate();
	getStaticData()->m_EventPackManager.clear();
	if( this->m_nPreviousMap >= 0 ) {	// have previous map index
		// oĂ}bvCfbNX΂̃}bvǂݍłiReBj[pj
		getStaticData()->setupMap( this->m_nPreviousMap, true );
	}
	this->m_nPreviousMap = -1;
}
void GSpecialDeadScene::process() {
	// test
	// 
/*	getStaticData()->m_Basic.m_Graphics.draw(
		0,0,getStaticData()->getSequence( SpriteType::COMMON,
		Sequence::Common::GAME_OVER_COMMON_01 ) );

	DrawString( 100,100, "Game Over...", GetColor(0,0,0 ) );*/

	// IuWFNg̕`悪L邩
	bool bIsDrawObjects = false;

	GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;

	switch( this->m_nScenarioIndex ) {
	case SpecialDeadEventID::WORM:
		{
			// test worm
			int nRet = PlayMovie( "data/worm_3.wmv", 1, DX_MOVIEPLAYTYPE_BCANCEL );
			if( nRet != 0 ) {
				HPLError::msg( "warning", MB_OK, "error:%d", nRet );
			}
		}
		break;
	case SpecialDeadEventID::CHASER_BAD:
		{
			bIsDrawObjects = true;
			// Ԋu
			if( this->m_IntervalCounter.step().isFinishAnimation ) {
				setNextInterval( &this->m_IntervalCounter, INTERVAL_MIN,INTERVAL_MAX);
				lpPlayer->damage(0,NULL, false, StateType::DAMAGE_ELEC );
			}

			if( lpPlayer->getState()->isDamageState() == false ) {
				lpPlayer->changeState( StateType::DAMAGE_FLYDOWN_REVERSE );
			}
		}
		break;
	}
	getStaticData()->isEvent(EventStepType::DEFAULT, true, false);

	if( bIsDrawObjects ) {
		bool bIsMove = true;
		bool bIsAI = false;
		// draw enemy
		getStaticData()->m_ObjectManager.m_EnemyManager.process( bIsMove, bIsAI );

		GPlayerManager playerManager;

		// draw player
		lpPlayer->draw();

		HPLVector vVel = lpPlayer->getVelocityAngle();
		playerManager.move( lpPlayer, &vVel );
	}

	if(getStaticData()->m_EventImage.isActivated()){
		// draw image
		HPLSequence* lpSeq = getStaticData()->getSequence( getStaticData()->m_EventImage.spriteID,
			getStaticData()->m_EventImage.seqID );
		getStaticData()->m_Basic.m_Graphics.draw( 
			0,0, lpSeq );
		
	}

	if( 0 == CheckHitKey( KEY_INPUT_SPACE ) ) {
		// space key ŃEBhE
		// Cxg̊mFƎsE\
		getStaticData()->checkEvent(false, EventStepType::DEFAULT, true, false);
	}

	if( getStaticData()->m_Game.isScenario() == false && getStaticData()->isFadingOutDX() == false ) {

		bool bANow = getStaticData()->getInputManager()->isPressedNow( KeyMap::A );
		bool bBNow = getStaticData()->getInputManager()->isPressedNow( KeyMap::B );
		bool bR = CheckHitKey( KEY_INPUT_R ) != 0;
		bool bESC = CheckHitKey( KEY_INPUT_ESCAPE ) != 0;
		if( ( m_nPreviousRKey == 0 && ( bANow || bBNow || bR ) ) || bESC ) {
			// escAViIIɎ
			// L[Ŏ

			int nSEIndex = SE::KETTEI;
			if( bBNow || bESC ) {
				nSEIndex = SE::CANCEL;
			}
			// sound
			getStaticData()->m_MixerManager.play( 
				nSEIndex,
				false );

			
			// ReBj[
			//bool bIsRemain = getStaticData()->hitRKey();
			getStaticData()->startFadeOutDX( SceneType::GAME_OVER,
				-1 );

		}
	}
}
