#ifndef _G_STATIC_DATA_
#define _G_STATIC_DATA_

#include <AbstractDXStaticData.h>
#include <hpllib/action/HPLCollisionCheckTool.h>
#include <HPLDXTimeRecorder.h>
#include <hpllib/system/HPLLogger.h>
#include <hpllib/general/HPLShortCutPaletteManager.h>


#include "GEnum.h"

#include "GObjectManager.h"
#include "GObjectPlacer.h"
#include "GGame.h"
#include "GSetting.h"
#include "DXMixerManager.h"

#include "GSave.h"

#include "GAchievementSave.h"
#include "GAchievementManager.h"

#include "GShotFactory.h"
#include "GBGManager.h"
#include "GOptionData.h"
#include "ShowCounter.h"

namespace GEnum {
	namespace EventStepType {
		enum EventStepType_ {
			DEFAULT,			//! 
			MANUAL,				//! ŃXebv邩ǂI
		};
	}
}

/** _^Cv
  */
namespace RandomVectorType {
	enum {
		NO_RANDOM,				//! _Ȃ
		CIRCLE_RANDOM,			//! ~`Ƀ_
		RECTANGLE_RANDOM,		//! `Ƀ_
		ONLY_X,					//! 
		ONLY_Y,					//! 
	};
}

/** 󔠏ioĂpj
  */
class TakarabakoInfo {
public:
	int m_nItemType;								//! ACe^Cv
	int m_nItemNum;									//! ACe
	int m_nNextEvent;								//! ACe擾
public:
	TakarabakoInfo() {
		this->reset();
	}
	~TakarabakoInfo(){}
	void reset() {
		this->m_nItemType = -1;
		this->m_nItemNum = -1;
		this->m_nNextEvent = -1;
	}

	bool isEnable() {
		return 0 <= this->m_nItemType;
	}

};


/*************************************************************
 * Q[Ŝŕێ
 */
class GStaticData : public AbstractDXStaticData {
	// Member variables
public:
	GBGManager			m_BGManager;			//! wiG\Ǘ
	HPLCounter			m_EventFadeCounter;		//! CxgptF[hAEg/CJE^
	HPLColor				m_EventFadeColor;			//! tF[hC/AEgJ[
	int					m_nEventFadeDirection;		//! tF[hCorAEg
	GShotFactory		m_ShotFactory;				//! Vbg쐬S
	GAchievementSave	m_AchievementSave;			//! уZ[u
	GObjectManager		m_ObjectManager;			//! IuWFNgǗ
	HPLSequence*		m_lpReadyGoSequence;			//! Ready Go!
	HPLSequence*		m_lpGameSetSequence;			//! Game Set!
	GGame				m_Game;
	GSetting			m_Setting;
	GObjectPlacer		m_ObjectPlacer;
	DXMixerManager		m_MixerManager;

	int					m_nSelectedStar;			//! I񂾐
	int					m_nSelectedPlace;			//! IPlace

	GSave				m_Save;						//! [UIłZ[uf[^
	GOptionData			m_OptionData;				//! Q[IvV
	// Private member variables
	int					m_nPlayerPlaceIndex;		//! vC[ǂ̏ꏊɓoꂳ邩ݒ
													//! Ń_

	/** EACe 󔠁A^X
	  * Neutral̏ƂĎāA󂯂Ƃɔ
	  */ 
	TakarabakoInfo		m_TakarabakoInfo;
//	int					m_aryPrevShortCutKeyStates[ GEnum::MAX_SHORTCUT_NUM];

	//int m_nEnemyNameType;	//! \G
	//HPLCounter m_ShowEnemyNameCounter;	//! G̖O莞ԕ\
	//HPLCounter m_ShowItemNameCounter;	//! ACe莞ԕ\
	ShowCounter m_ShowEnemyName;	//! ŌɍU𓖂ĂG̖Oԕ\
	ShowCounter m_ShowItemName;		//! ŌɏEACe̖Oԕ\
	HPLDXTimeRecorder m_TimeRecorder;	//! vCԌvp
	HPLShortCutPaletteManager m_ShortCutPaletteManager;
private:
//	std::map<int,int>		m_mapBarrierMapIndex2StageType;		//! MapIndex
//	bool m_bIsForceScrollMap;
	bool	m_bIsCOMPlayer;		//! COMPlayeroꂳ邩
	int					m_nSelectIndex;				//! SCENARIOSELECTݑIʒu
	std::vector<int>	m_vecSelectScenarioIndex;	//! SELECTőI̍s
	//HPLSequence*		m_lpFadeOutSequence;		//! tF[hAEgV[PX
	HPLCounter			m_FadeOutCounter;			//! tF[hAEgBv~eBułB
	bool isFadeOut(){}
	void startFadeOut(int scene, int m){}

	int					m_nAfterBossScenarioID;		//! {XjɎQƂViIID
	HPLCounter			m_AfterBossWaitCounter;		//! {Xj̑҂ԁBꂪ߂Ə̃ViIB

	int					m_nAfterFadeOutDXProcessType;	//! tF[hAEgɍsvZX

//	std::map<int,int>	m_mapItem2WeaponType;	//! <ACe^Cv,^Cv>̃}bv
//	int					m_nShortCutIndex;			//! V[gJbg̎gpIndex

	// Constructors
public:
	GStaticData();
	virtual ~GStaticData();

	// Getter/Setter
public:
	HPLCounter* getAfterBossWaitCounter(){	return &this->m_AfterBossWaitCounter;	}
//	void setShortCutIndex( int nIndex ) {	this->m_nShortCutIndex = nIndex;	}
//	int getShortCutIndex() {	return this->m_nShortCutIndex;	}
	// after fadeout process type
	int getAfterFadeOutDXProcessType() {		return this->m_nAfterFadeOutDXProcessType;	}

	/** {Xj̃EGCg
	  */
	void startAfterBossWait( int nScenarioID, int nWaitFrameNum = -1 );

	/** {Xj̃JEg𒆎~
	  */
	void stopAfterBossWait();

	/** 
	  * @retval true	I
	  */
	bool processAfterBossWait();

	/*
	bool isForceScrollMap() {
		return this->m_bIsForceScrollMap;
	}*/

	bool isCOMPlayer() {
		return this->m_bIsCOMPlayer;
	}
	void setCOMPlayer( bool bIsCOMPlayer ) {
		this->m_bIsCOMPlayer = bIsCOMPlayer;
	}
	/** ݃tF[hAEgmF
	  */
	bool isFadingOutDX() {
		if( this->m_FadeOutCounter.getState().isFinishAnimation ) {
			return false;
		}
		return true;
	}
	void startFadeOutDX(int nNextScene, int nNextMap,
		int nAfterFadeOutDXProcessType = GEnum::AfterFadeOutDXProcessType::NONE);

	/**
	  * @param[in]	bIsLoadEvent	truȅꍇCxgǂݍ
	  * @retval		true	݃tF[hAEg`E
	  */
	bool processFadeOutDX( bool bIsAutoChange);

	void drawFadeOutDX();

	// Override
public:
	void callbackStageChange(){}
	virtual HPLSetting* getSetting();

	// Iy[V
public:
	/** eNX`/C[Wǂݍ݁ZbgAbv
	  */
	void loadTexture();

	void setupMap(int mapIndex, bool bIsLoadEvent );

	/** IuWFNg̎ނɉchangeStateĂяo
	  * 
	  */
	void changeState(HPLShootingObject* obj, int newState);

	/** т̃V[PXID	  */
	int getEvigenSequenceID(HPLShootingObject* obj);
	// damage sequence for evigen
	int getDamageSequenceID(HPLShootingObject* obj );
	// damage flying state for evigen
	void setDamageFlyingState(HPLShootingObject* obj);
	// roll back evigen state
	void rollBack( HPLShootingObject* lpObject );
	/** hit to player */
	void hitToPlayer( HPLShootingObject* lpDamageSource, GPlayer* lpTargetPlayer, float fSpeed, float fDamage );
	// tank sequence
	int getTankSequenceID( HPLShootingObject* obj );
	// vtol sequence
	int getVTOLSequenceID( HPLShootingObject* obj );

	/** GtFNg1쐬܂
	  * TODO effect managerɈڂ
	  */
	GEffect* createEffect(int nType, const HPLVector& vFrom, const HPLVector& vTo,
		int nCreateEnemyType, int nForceID );


	/** xNgWɊYubNID擾 */
	int getBlockID( HPLVector& v );


	/** ubNƓ
	  *
	  */
	CollisionState checkCollisionObjectX( HPLShootingObject* lpObject, 
		HPLShootingObject* lpBlockObject );
	CollisionState checkCollisionObjectY( HPLShootingObject* lpObject, 
		HPLShootingObject* lpBlockObject,
		int nMountType);

	/** vC[ǂʂă_[W^
	  * @param[out]		lpObject		_[W󂯂IuWFNg
	  * @param[out]		lpDamageSource	_[W^IuWFNgBNULL
	  * @param[in]		fDamage			_[WʁBx␳ς
	  * @param[in]		bIsInvinsisble	_[WɖGԂɂȂ邩
	  * @param[in]		nNextState		_[W󂯂IuWFNgɎXe[g
	  */
	void damageObject( HPLShootingObject* lpObject, HPLShootingObject* lpDamageSource, 
		float fDamage, bool bIsInvinsible, int nNextState );

	/**
	  * @param[in]	nType
	  * @param[in]	lpParent			˂sĂe
	  * @param[in]	nWeaponDirection	̕i˕j
	  */
	//void shotBullet( int nType, HPLShootingObject* lpParent,
	//	int nWeaponDirection );

	/////////////////////////////////////////////////////////////////////
	// Cxg
	/**
	  * sׂCxgL邩mF
	  * @param[in]	bIsSkip			CxgsȂ
	  * @param[in]	nEventStepType	L[ɂJڃ`FbN邩ǂBEventStepType
	  * @param[in]	bIsSceneMapChangable	MAPR}hɂJڂsǂ
	  */
	void checkEvent( bool bIsSkip, int nEventStepType, bool bIsSceneMapChangable,
		bool bIsEndByPlayerDeath);

	/**
	  * ݃CxgsmF
	  */
	bool isEvent(int nEventStepType, bool bIsSceneMapChangable, bool bIsEndByPlayerDeath);

private:
	/**
	  * CxgpbN̎s
	  */
	void doEventPack( int nEventStepType, bool bIsSceneMapChangable,
		bool bIsEndByPlayerDeath);

	/** TALKnCxg̏
	  */
	void doTalkEventPack( HPLScenarioItem* item, int nEventStepType, bool bIsEndByPlayerDeath );

	/** ʂ̑/ݒsƂ̕\bZ[Wpӂ
	  * @param[in]	cszPrefix	̂HF"HP"
	  * @param[in]	nOp			Operation
	  * @param[in]	nType		Type
	  * @param[in]	nAmount		w肳ꂽ
	  * @param[in]	nDelta		ۂɑʁw肳ꂽ
	  * @param[in]	cszSuffixSet,Up,Down	ꂼ̃bZ[Wڍ
	  */
	void getAmountTalkString( const char* cszPrefix, int nOp, int nType, int nAmount, int nDelta, 
		const char* cszSuffixSet, const char* cszSuffixUp, const char* cszSuffixDown,
		string& strResult);

	int m_nSpecialItemType;	// special item
public:
	/** XLbvi邩Ȃj̏
	  * @param[in,out]	item
	  * @param[in]		bIsNextKeyPressNow	֐iރL[ij
	  * @param[in]		bIsSkipKeyPress		XLbvL[iftHgCtrljĂ
	  * @param[in]		bIsEndByPlayerDeath	vC[ł狭I
	  * @param[in]		bIsSceneMapChangable	}bv/V[̑J
	  * @retval	true	XLbv
	  */
	bool doEventSkip( bool bIsNextKeyPressNow, bool bIsSkipKeyPress,
		bool bIsEndByPlayerDeath );

	/** ꓮO
	  * @param	nSpecialScenarioType	SpecialScenarioType::
	  * @param	lpVecMessageList		ۂɕ\郁bZ[WXg
	  *									autoϐւ̃|C^Ȃ̂ŁAȂ
	  * @param	vecReplaceMessages		upbZ[W
	  */
	void doSpecialEventBefore( int nSpecialScenarioType,
		std::vector<std::string>** vecMessageList,
		std::vector<std::string>& vecReplaceMessages,
		HPLScenarioItem* lpItem);
	
	/** ꓮ㏈
	  */
	void doSpecialEventAfter( int nSpecialScenarioType );
	
	/**
	  */
	void drawEmotionTalkMessage(int r, int g, int b, int sequenceID,
											 int emotionType, std::vector<std::string> messages);
	/**
	  */
	void drawEmotionIcon(int left, int top, int sequenceID, int emotionType,
		int nWidth, int nHeight);

	void drawStand( int standPos, int seqID );

	/**
	  * @param[in]	bIsAlwaysEnable		ɉ{łBʏ킻̃Xe[Wn܂Ă{ViI͈x}bvēǂݍ݂Kv
	  */
	void startEvent( int nEventIndex, bool bIsAlwaysEnable );

	/** bEChE̘g\
	  * @retval	ۂnTop(default=trueȂftHg
	  */ 
	int drawTalkFrame(bool bIsDefault, int nTop);

	/** ViII㏈
	  */
	void endScenario();

	/////////////////////////////////////////////// scenario operations end
	
	/** G[VACR쐬
	  * @param[in]	lpObject	Ώ
	  * @param[in]	nEffectType	GtFNg^CvŎw肷
	  */
	void createEffectEmotionIcon( HPLShootingObject* lpObject, int nEffectType );
	/** vC[̃G[VJn
	  * @retval	Emotioñ|C^B_Ci~bNϊKv
	  */
	HPLShootingObject* createPlayerEmotionIcon( int nEffectType );
	HPLVector getEmotionIconPosition( HPLShootingObject* lpObject );

	/** ubNn`Փ˔s
	  * @param[in,out]	lpObject	Ώۂ̃IuWFNg
	  * @param[out]		
	  */
	void collisionObject( HPLShootingObject* lpObject ) {
		CollisionState stateX,stateY;	// no use
		this->collisionObject( lpObject, stateX, stateY );
	}
	void collisionObject( HPLShootingObject* lpObject,
		CollisionState& stateX, CollisionState& stateY);


	/** vC[̏Ԃɂăv`\ACRSequenceID擾
	  * @param[in]	st			
	  * @param[in]	nWearState	ߏ
	  * @retval		0ȏ		SequenceID
	  * @retval		-1			\Ȃ
	  */
	int getFaceSeqIDFromState( int st, int nWearState );

	void setStarAndPlace( int nStar, int nPlace );
	int getMapIndexFromStarAndPlace( );

	/** ^CgʂȂǂŋʂ̓
	  */
	void commonBackgroundProcess();
	void commonForegroundProcess();


	/** L҂̏lˈʒu쐬
	  * 
	  */
	HPLVector getShotCenter( HPLShootingObject* lpShooter, int nShotType, int nWeaponType = -1);

	HPLVector getShotVelocityAngle( HPLShootingObject* lpShooter, int nShotType, int nWeaponType = -1);

	/** \
	  */
	void drawDescription( const char* lpczDescription, bool bIsDefault, int nTop );

	/**
	  */
	void setupEvent( const char* lpszEventFilePath = NULL);

	/** {^p̓_Ŗx擾
	  * @param[in]	nCurrentStepCounter	݂̃t[
	  * @param[in]	nMaxStepCounter		őt[
	  */
	int getButtonBright( int nCurrentStepCounter, int nMaxStepCounter );

	/** ΍WȏɂȂ玀
	  * ̃Xe[WiXN[jł͓ꈵɂȂ
	  * @retval	[El
	  */
	float getLimitUnder( );

	/** ̎ނSequenceID𓾂
	  */
	int getStarSequenceID(int nStarType);

	/** ACe̎ނ畐̃^Cv𓾂
	  * @retval	̎
	  * @retval	-1				ȊÕACełꍇ
	  *
	  */
	int getWeaponTypeFromItemType( int nItemType );
	int getItemTypeFromWeaponType( int nWeaponType );
	/** mapɃACeƕ̑΂o^
	  */
//	void registItemAndWeaponSet( int nItemType, int nWeaponType );

	/** ACe̎ނ炻̃ACeǂ̃NX擾
	  * @retval	ItemClassType	WEAPON		
								USE_ITEM	ACe
								STOCK_ITEM	XgbN邾̃ACe
	  */
	int getItemClassType( int nItemType );

	/** RL[Ƃ̏
	  * @retval	true	܂Ă
	  * @retval false	GameOver,man!
	  */
	bool hitRKey();

	/** ݂̃}bvǂȃ^Cv
	  */
	int getMapType();

	/** Z[uǂݍ
	  */
	void loadSave(int nIndex);

	/** HP\
	  */
	void drawHP( HPLShootingObject* lpObject );

	/** XN[
	  * wiłgp
	  * SHAKE͖
	  */
	void adjustScroll( HPLScroller* lpScroller );

	/** уJEgi߂
	  * @param[in]	nStep	i߂
	  * @param[in]	bIsSave	Z[u
	  * @retval	true	̃t[œB
	  */
	bool stepAndCheckAchievement( int nAchievementType, int nStep, bool bIsSave );

	/** SuperPowerɑΉ镐擾
	  * @retval	-1	݂ȂH
	  */
	int getWeaponTypeBySuperPower( int nSuperPowerType );

	/** w肵}bvCfbNXɁAStarPlaceIB
	  * ݂Ȃꍇ͓ɉȂ
	  * Z[u
	  */
	void updateStarAndPlace( int nMapIndex );

	/** ̃}bvRevealedɂāAXe[WIʂɖ߂
	  * @param[in]	nNextMapIndex	ɐiރ}bvCfbNX
	  * @retval	true	߂Ď̃}bvAbN
	  */
	bool checkPoint( int nNextMapIndex );

	/** IuWFNg̃IuWFNgɏƂ̏
	  * @param[in,out]	lpRider	鑤BPlayerȂ
	  * @param[in,out]	lpRided	鑤BGNeutralȂ
	  * @param[out]		stateX,stateY ʁBRider̔ɂȂB
	  * @retval			true	RidedRiderɏɏꂽ
	  */
	bool rideOnObject( HPLShootingObject* lpRider, HPLShootingObject* lpRided,
		CollisionState& stateX, CollisionState& stateY);

	/** 킪pbgɓo^Ă邩mF
	  * ɓo^ς݂Ȃ炻̃CfbNXԂ
	  * 
	  * @param[in]	nWeaponType
	  * @retval		킪݂΁ÃCfbNXԍԂ
	  * @retval		݂Ȃꍇ̓ftHg0Ԃ
	  */
//	int getShortCutIndex( int nWeaponType );

	/** 1Ԗڂ`FbNāAo^Ăŏ̃pbg̕I
	  * o^ĂȂ΃p`o^
	  * @param	ݒ肵pbgCfbNX
	  */
//	int setFirstShortCutIndex( GPlayer* lpPlayer );

	/** 킩ǂmFB
	  * @retval	-1		ȊO
	  * @retval	0ȏ	̎
	  */
	int checkItemIsWeapon( int nItemType );

	/** Eŏ̕I
	  * EȂꍇ̓p`o^
	  * EȊOIiV[gJbgɕςȂ̂
	  */
	void selectFirstWeapon(GPlayer* lpPlayer );

	/** w͈͂őIJ[\\
	  */
	void drawSelectFrame( int nLeft, int nTop, int nWidth, int nHeight );

	/** XN[ʒuscroller::m_CurrentVirtualCenterɂ҂荇킹
	  */
	void adjustScreen( HPLScroller* scroller );

	/** łɎsς݂`FbNAsĂȂ΃Cxgs
	  * @retval	true	sĂȂ̂ŁAs

	  */
	bool checkAndStartEvent( int nFlagType, int nFlagBit, int nEventIndex );

	/**
	  * @param[in]	lpPlayer		L[vC[f[^
	  * @param[in]	bIsOnlyOne		łĂ瑦Ԃ悤ɂ
	  * @retval		ꂽ
	  */
	int getScrambleKeyCount( GPlayer* lpPlayer, bool bIsOnlyOne);
};

extern GStaticData staticData;

static GStaticData* getStaticData() {
	return &staticData;
}

#endif
