#include "GWeapon.h"

#include "GEnum.h"
#include "GStaticData.h"

#include <hpllib/math/HPLMath.h>

using namespace GEnum;

bool HPLDecreaser::step( int& nRemain ) {
	nRemain -= this->getDecrease();
	if( nRemain < 0 ) {
		nRemain = 0;
	}
//	this->setRemain( nRemain );
	if( nRemain <= 0 ) {
		return true;
	}
	return false;
}

Energy::Energy() {
	this->setRemain( DEFAULT_SUPER_POWER_REMAIN );
	this->setMax( DEFAULT_SUPER_POWER_REMAIN );

	this->m_Decreaser.setDecrease(DEFAULT_SUPER_POWER_DECREASE );
	this->m_Decreaser.setDefaultDecrease( DEFAULT_SUPER_POWER_DECREASE );
//	this->setDecrease( DEFAULT_SUPER_POWER_DECREASE );
//	this->setDefaultDecrease( DEFAULT_SUPER_POWER_DECREASE );
//	this->setConstantDecrease(0);
//	this->setDefaultConstantdecrease(0);
}
/** GlM[1
  * @retval	true	GlM[
  */
bool Energy::step( HPLDecreaser& decreaser) {
	int nRemain = this->getRemain();
	bool bIsZero = decreaser.step( nRemain );
	this->setRemain(nRemain );
	return bIsZero;
/*	int nRemain = this->getRemain();
	nRemain -= this->getDecrease();
	if( nRemain < 0 ) {
		nRemain = 0;
	}
	this->setRemain( nRemain );
	if( nRemain <= 0 ) {
		return true;
	}
	return false;*/
}
/** т鉻ɉČʂK
  * т鉻قǌA0ɋ߂ÂB
  * ő厞͌ȂH
  */
int Energy::getSuperPowerDecrease( float fGage, HPLDecreaser& decreaser ) const {
	
	return (int)( ( 1.f - ( fGage / MAX_EVIL_GAGE )) * decreaser.getDefaultDecrease() );
}


void GWeapon::setup( int nType, HPLShootingObject* lpOwner ) {
	this->m_lpOwner = lpOwner;
	this->setType( nType );


	GWeaponSetting* lpSetting = getStaticData()->m_ObjectManager.m_WeaponManager.getWeaponSetting( nType );

	this->m_nDirectionType = lpSetting->m_nDirectionType;//DIRECTION_TYPES[ nType ];

	this->m_ShotWaitCounter.setWaitFrameNum(lpSetting->m_nShotInterval );//SHOT_INTERVALS[nType] );
	this->m_ShotWaitCounter.end();
	if( lpSetting->m_nShotInterval == 0 ) {//SHOT_INTERVALS[nType] == 0 ) {
		this->m_bIsZeroInterval = true;
	} else {
		this->m_bIsZeroInterval = false;
	}


	this->m_nNextPlayerState = lpSetting->m_nNextPlayerState;//NEXT_PLAYER_STATES[ nType ];
	this->setClassType(
		1 << lpSetting->m_nWeaponClassType );
	
	this->m_nShotType = lpSetting->m_nShotType;//SHOT_TYPE_MAP[nType];

	this->m_bIsSniping = false;
	switch( nType ) {
	case WeaponType::SNIPER_RIFLE:
	case WeaponType::SATELITE_GUN:
		this->m_bIsSniping = true;
		break;
	}
	
	this->m_Energy.clear();

	switch( nType ) {
	case WeaponType::SEED:
		{
			// W5xƂ
			this->m_Energy.m_Decreaser.setDecrease( DEFAULT_SUPER_POWER_REMAIN / 5);
			this->m_Energy.m_Decreaser.setDefaultDecrease( DEFAULT_SUPER_POWER_REMAIN / 5);
		}
		break;
	case WeaponType::WIND_WIZARD:
		{
			// 10x
			int nDefaultDecrease = DEFAULT_SUPER_POWER_REMAIN / 5;
			this->m_Energy.m_Decreaser.setDecrease( nDefaultDecrease);
			this->m_Energy.m_Decreaser.setDefaultDecrease( nDefaultDecrease);

			// ɏ
			int nDefaultConstantDecrease = DEFAULT_SUPER_POWER_DECREASE / 50;
			this->m_Energy.m_ConstantDecreaser.setDecrease( nDefaultConstantDecrease );
			this->m_Energy.m_ConstantDecreaser.setDefaultDecrease( nDefaultConstantDecrease );
		}
		break;
	}
}

GWeapon::~GWeapon() {
}


int GWeapon::getNextBulletNum( ) {
	GWeaponSetting* lpSetting = getStaticData()->m_ObjectManager.m_WeaponManager.getWeaponSetting(
		this->getType() );
	if( lpSetting->m_nMinBulletNum < lpSetting->m_nMaxBulletNum ) {//NUMS[this->getType()][0] != NUMS[this->getType()][1] ) {
		return HPLMath::nextInt( lpSetting->m_nMinBulletNum, lpSetting->m_nMaxBulletNum );//NUMS[this->getType()][0], NUMS[this->getType()][1] );
	} else{
		return lpSetting->m_nMaxBulletNum;//NUMS[this->getType()][0];
	}
}



bool GWeapon::getClassTypeBit( int nClassTypeBitIndex ) {
	return HPLMath::getFlagByIndexInt( this->getClassType(), nClassTypeBitIndex );
}

bool GWeapon::isSuperPowerWeapon() {
	switch( this->getType() ) {
	case WeaponType::SLIME_GUN:
	case WeaponType::SEED:
	case WeaponType::WIND_WIZARD:
		return true;
	}
	return false;
}

