#ifndef _G_WEAPON_
#define _G_WEAPON_

#include <hpllib/object/HPLShootingObject.h>
#include <hpllib/general/HPLCounter.h>

#include "GEnum.h"

#include "GWeaponConsts.h"

class HPLDecreaser {
private:
	int m_nDecrease;
	int m_nDefaultDecrease;
public:
	int getDefaultDecrease() { return this->m_nDefaultDecrease;}
	void setDecrease( int nDecrease ) {	this->m_nDecrease = nDecrease; }
	int getDecrease() {	return this->m_nDecrease; }
	void setDefaultDecrease(int nDefaultDecrease) { this->m_nDefaultDecrease = nDefaultDecrease;}
	/** 
	  * @retval	true	0ɂȂ
	  */
	bool step( int& nRemain );
public:
	HPLDecreaser() {
		this->m_nDecrease = 0;
		this->m_nDefaultDecrease = 0;
	}
};


/** GlM[ʊǗ
  */
class Energy {
public:
	HPLDecreaser m_Decreaser;
	HPLDecreaser m_ConstantDecreaser;
private:
	int m_nRemain;	//! c
	int m_nMax;		//! \MAXl

//	int m_nDecrease;	//! 
//	int m_nDefaultDecrease;	//! Wiőj
//	int m_nConstantDecrease;	//! Activate邾Ō
//	int m_nDefaultConstantDecrease;	//! Activate邾Ōʂ̊l
private:
//	int getDefaultDecrease() { return this->m_nDefaultDecrease;}
//	int getDefaultConstantDecreaase(){	return this->m_nDefaultConstantDecrease;}
public:
	Energy();
	~Energy(){}

public:
//	void setDecrease( int nDecrease ) {	this->m_nDecrease = nDecrease; }
//	void setConstantDecrease( int nConstantDecrease){	this->m_nConstantDecrease = nConstantDecrease;}
	int getRemain() {	return this->m_nRemain; }
	void setRemain( int nRemain ) {	this->m_nRemain = nRemain; }
	int getMax()	{	return this->m_nMax; }
	void setMax( int nMax ) {	this->m_nMax = nMax; }
//	int getDecrease() {	return this->m_nDecrease; }
	float getRemainRate() {	return (float)this->getRemain() / (float)getMax() ;	}
//	void setDefaultDecrease(int nDefaultDecrease) { this->m_nDefaultDecrease = nDefaultDecrease;}
//	void setConstantDefaultDecrease(int nDefaultConstantDecrease) {
//		this->m_nDefaultConstantDecrease = nDefaultConstantDecrease;}

	void recharge() { this->setRemain( this->getMax() ); }
	void clear() { this->setRemain(0); }

	/** т鉻ɉČʂK
	  * т鉻ق1ɋ߂ÂB
	  */
	int getSuperPowerDecrease( float fGage, HPLDecreaser& decreaser ) const;
//	int getSuperPowerConstantDecrease( float fGage );

	/**
	  * @retval	true	0ɂȂ
	  */
	bool step( HPLDecreaser& decreaser);
//	bool stepConstant();
	bool isRemain() { return this->getRemain() > 0; }
};


/*************************************************************************************
  ** 
  */
class GWeapon : public HPLShootingObject{
public:
	Energy					m_Energy;			//! GlM[ʊǗ
//	int						m_nSuperPowerType;	//! ΉSuperPower
	bool					m_bIsZeroInterval;	//! t[ˏ
	int						m_nNextPlayerState;	//! vC[͍Uǂ̏ԂɂȂ邩
												//! Ȃ/WvȂPlayerManagerŔf邽
												//! ł́uevup`vŗǂ
//	bool					m_bIsPressNowShot;	//! UL[ςȂł͍UɂȂȂ
	int						m_nDirectionType;	//! ς邩̃^Cv
	bool					m_bIsActivated;		//! Ă邩
	int						m_arySequenceID[GEnum::WeaponDirection::MAX_NUM];

	int 					m_nShotType;		//! oeBshot factoryŎQƂ
	// Member variables
	HPLCounter				m_ShotWaitCounter;	//! A˂̊ԊuJE^
												//! ŏ̈ꔭ͕K
												//! P˂̏ꍇAɔˉ\ɂȂ܂ł̎ԂƂĈ
												//! m_bIsZeroIntervalON̎́ÃJE^[gȂ
	int getClassType() {
		return this->m_nClassType;
	}
	void setClassType( int nClassType ) {
		this->m_nClassType = nClassType;

	}
	bool getClassTypeBit( int nClassTypeBitIndex );
//	void setClassTypeBit( bool bClassTypeBitIndex, bool bBit );
	bool isSniping() {
		return this->m_bIsSniping;
	}

private:
	bool					m_bIsSniping;		//! ʑc̏Əte
	int						m_nClassType;		//! ˕̃^Cvirbgj
	HPLShootingObject*		m_lpOwner;			//! 
//	HPLCounter				m_WaitAfterShotCounter;	//! 㓮悤ɂȂ܂ł̃^C

	// Constructor
public:
	GWeapon() : HPLShootingObject( 0 ){
		this->m_bIsActivated = false;
		this->m_lpOwner = NULL;
		memset( this->m_arySequenceID, 0, sizeof(m_arySequenceID)/sizeof(m_arySequenceID[0]));
		this->m_bIsZeroInterval = false;
	}
	virtual ~GWeapon();

public:

	/**
	  * ݒ
	  * @param[in]	nType	
	  * @param[in]	lpOwner	L
	  */
	void setup( int nType, HPLShootingObject* lpOwner  );

	/** ˂e̐
	  *
	  */
	int getNextBulletNum( );

	// 
public:
	void changeState( int nState ) {
		HPLShootingObject::changeStateCommon(this, nState);
	}
	int getSequenceID(){
		return HPLShootingObject::getSequenceIDCommon(this);
	}
	HPLSequence* getSequence() {
		return HPLShootingObject::getSequenceCommon(this);
	}
	bool isSuperPowerWeapon();
};

#endif
