#ifndef _G_WEAPON_MANAGER_
#define _G_WEAPON_MANAGER_

#include "GEnum.h"
#include "GWeaponConsts.h"
#include <hpllib/object/HPLState.h>
#include <hpllib/system/HPLError.h>

#include <map>
#include <string>

/** ݒ
  */
class GWeaponSetting {
public:
	// Member vriable
public:
	
	std::string m_strName;
	int			m_nID;
	int			m_nDirectionType;		//! ^Cv
	int			m_nShotInterval;		//! ЊԊuB0ŃC^[o
	int			m_nNextPlayerState;		//! vC[̍U[V
	int			m_nWeaponClassType;		//! NX
	int			m_nShotType;			//! VbgType
	int			m_nMaxBulletNum;		//! ő哯ː
	int			m_nMinBulletNum;		//! 
	int			m_nShotDXLeft;			//! ˎ̈ʒu炵
	int			m_nShotDXRight;			//! ˎ̈ʒu炵iEj
	int			m_nCenterError;			//! ˈʒuŜ
	bool		m_aryFlags[GEnum::WeaponFlagType::MAX_NUM];
	int			m_nItemType;			//! ACeΉ(ACexŎw)
	// Constructor
public:
	GWeaponSetting(){
		this->clear();
	}
	void clear() {
		this->m_nID = -1;
		this->m_nDirectionType = GEnum::WeaponDirType::STATIC;
		this->m_nShotInterval = 0;
		this->m_nNextPlayerState = StateType::STAND;
		this->m_nWeaponClassType = GEnum::WeaponClassType::CON_SHOT;
		this->m_nShotType = -1;
		this->m_nMaxBulletNum = 1;
		this->m_nMinBulletNum = 1;
		this->m_nShotDXLeft = 0;
		this->m_nShotDXRight = -10;
		this->m_nCenterError = 0;

		for( int i = 0; i < GEnum::WeaponFlagType::MAX_NUM; i ++ ) {
			this->m_aryFlags[i] = GEnum::DEFAULT_WEAPON_FLAGS[i];
		}
	}
	~GWeaponSetting(){}
};

/** ǗNX
  */
class GWeaponManager {
private:
	GWeaponSetting m_aryWeaponSettings[GEnum::WeaponType::MAX_WEAPON_NUM];
	std::map<int,int>	m_mapItem2WeaponType;	//! <ACe^Cv,^Cv>̃}bv
public:
	int checkItemIsWeapon( int nItemType) {
		std::map<int,int>::iterator it = this->m_mapItem2WeaponType.find(nItemType );
		if( it == this->m_mapItem2WeaponType.end()) {
			return -1;
		}
		return it->second;
	}
	GWeaponSetting* getWeaponSetting( int nIndex );

	/** ACe^Cvw肵āAΉ镐^Cv擾
	  * @retval		-1		ł͂Ȃꍇ
	  */
	int getWeaponTypeFromItemType( int nItemType) {
		//HPLError::assertIt( this->m_mapItem2WeaponType.find( nItemType) != this->m_mapItem2WeaponType.end(),
		//	"%s:%s(%d):Unknown item type:%d",
		//	__FILE__,__FUNCTION__,__LINE__,nItemType);
		if( this->m_mapItem2WeaponType.find( nItemType ) == this->m_mapItem2WeaponType.end() ) {
			return -1;
		}
		return this->m_mapItem2WeaponType[nItemType];
	}
	int getItemTypeFromWeaponType( int nWeaponType, bool bIsStopWhenFailed = true ) {
		for( std::map<int,int>::iterator it = this->m_mapItem2WeaponType.begin();
			it != this->m_mapItem2WeaponType.end(); it ++ )
		{
			if( it->second == nWeaponType ){
				return it->first;
			}
		}
		if( bIsStopWhenFailed ) {
			HPLError::assertIt(false, _T("%s:%s(%d) Unknown weapon type:%d"),
				__FILE__,__FUNCTION__,__LINE__,nWeaponType);
		}
		return -1;
	}
public:
	GWeaponManager();
	~GWeaponManager(){}
	/** ݒǂݍ
	  * @param[in]	lpFilePath	Sݒ肪ꂽt@CpX
	  * @retval		0			I
	  * @retval		-1			I/O error
	  * @retval		-2			G[
	  */
	int loadWeaponSettings( const char* lpFilePath );
private:

	/**
	  * @param[in]	strLine		1̐ݒ肪ꂽs
	  * @param[out]	nIndex		ݒ肵CfbNX
	  * @retval		0			I
	  * @retval		-2			G[
	  */
	int parseSettingStringLine( std::string& strLine, int& nIndex, int nLineIndex );
};

#endif
