#include "ShowCounter.h"

void ShowCounter::setup( int nType, HPLSequence* lpSeq ) {
	this->m_nType = nType;
	this->m_lpSequence = lpSeq;
}
bool ShowCounter::start( int nObjectID, int nNameType ) {
	if( this->m_nObjectID == nObjectID ) {
		return false;
	}
	this->m_nObjectID = nObjectID;
	this->m_nNameType = nNameType;
	//this->m_ShowCounter.reset();
	this->m_lpSequence->resetCounter();
	return true;
}
bool ShowCounter::isAlive() {
#ifdef _DEBUG
	ASSERT_IT_NULL( this->m_lpSequence );
#endif
	return this->m_nObjectID >= 0 && this->m_nNameType >= 0 && this->m_lpSequence->getState().isFinishAnimation == false;
}
bool ShowCounter::step() {
#ifdef _DEBUG
	ASSERT_IT_NULL( this->m_lpSequence );
#endif
	if( this->m_lpSequence->step().isFinishAnimation ) {
		this->m_nNameType = -1;
		return true;
	}
	return false;
}
void ShowCounter::reset() {
	this->m_nObjectID = -1;
	this->m_nNameType = -1;
	this->m_lpSequence->end();
}
